/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_dpg0(Libderiv_t *, prim_data *);

  /* Computes derivatives of (dp|g0) integrals */

void d12hrr_order_dpg0(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[3][4][11] = int_stack + 0;
 Libderiv->deriv_classes[3][4][10] = int_stack + 150;
 Libderiv->deriv_classes[3][4][9] = int_stack + 300;
 Libderiv->deriv_classes[3][4][8] = int_stack + 450;
 Libderiv->deriv_classes[3][4][7] = int_stack + 600;
 Libderiv->deriv_classes[3][4][6] = int_stack + 750;
 Libderiv->deriv_classes[3][4][2] = int_stack + 900;
 Libderiv->deriv_classes[3][4][1] = int_stack + 1050;
 Libderiv->dvrr_classes[2][4] = int_stack + 1200;
 Libderiv->deriv_classes[3][4][0] = int_stack + 1290;
 Libderiv->deriv2_classes[2][4][143] = int_stack + 1440;
 Libderiv->deriv2_classes[3][4][143] = int_stack + 1530;
 Libderiv->deriv2_classes[2][4][131] = int_stack + 1680;
 Libderiv->deriv2_classes[3][4][131] = int_stack + 1770;
 Libderiv->deriv2_classes[2][4][130] = int_stack + 1920;
 Libderiv->deriv2_classes[3][4][130] = int_stack + 2010;
 Libderiv->deriv2_classes[2][4][119] = int_stack + 2160;
 Libderiv->deriv2_classes[3][4][119] = int_stack + 2250;
 Libderiv->deriv2_classes[2][4][118] = int_stack + 2400;
 Libderiv->deriv2_classes[3][4][118] = int_stack + 2490;
 Libderiv->deriv2_classes[2][4][117] = int_stack + 2640;
 Libderiv->deriv2_classes[3][4][117] = int_stack + 2730;
 Libderiv->deriv2_classes[2][4][107] = int_stack + 2880;
 Libderiv->deriv2_classes[3][4][107] = int_stack + 2970;
 Libderiv->deriv2_classes[2][4][106] = int_stack + 3120;
 Libderiv->deriv2_classes[3][4][106] = int_stack + 3210;
 Libderiv->deriv2_classes[2][4][105] = int_stack + 3360;
 Libderiv->deriv2_classes[3][4][105] = int_stack + 3450;
 Libderiv->deriv2_classes[2][4][104] = int_stack + 3600;
 Libderiv->deriv2_classes[3][4][104] = int_stack + 3690;
 Libderiv->deriv2_classes[2][4][95] = int_stack + 3840;
 Libderiv->deriv2_classes[3][4][95] = int_stack + 3930;
 Libderiv->deriv2_classes[2][4][94] = int_stack + 4080;
 Libderiv->deriv2_classes[3][4][94] = int_stack + 4170;
 Libderiv->deriv2_classes[2][4][93] = int_stack + 4320;
 Libderiv->deriv2_classes[3][4][93] = int_stack + 4410;
 Libderiv->deriv2_classes[2][4][92] = int_stack + 4560;
 Libderiv->deriv2_classes[3][4][92] = int_stack + 4650;
 Libderiv->deriv2_classes[2][4][91] = int_stack + 4800;
 Libderiv->deriv2_classes[3][4][91] = int_stack + 4890;
 Libderiv->deriv2_classes[2][4][83] = int_stack + 5040;
 Libderiv->deriv2_classes[3][4][83] = int_stack + 5130;
 Libderiv->deriv2_classes[2][4][82] = int_stack + 5280;
 Libderiv->deriv2_classes[3][4][82] = int_stack + 5370;
 Libderiv->deriv2_classes[2][4][81] = int_stack + 5520;
 Libderiv->deriv2_classes[3][4][81] = int_stack + 5610;
 Libderiv->deriv2_classes[2][4][80] = int_stack + 5760;
 Libderiv->deriv2_classes[3][4][80] = int_stack + 5850;
 Libderiv->deriv2_classes[2][4][79] = int_stack + 6000;
 Libderiv->deriv2_classes[3][4][79] = int_stack + 6090;
 Libderiv->deriv2_classes[2][4][78] = int_stack + 6240;
 Libderiv->deriv2_classes[3][4][78] = int_stack + 6330;
 Libderiv->deriv2_classes[2][4][35] = int_stack + 6480;
 Libderiv->deriv2_classes[3][4][35] = int_stack + 6570;
 Libderiv->deriv2_classes[2][4][34] = int_stack + 6720;
 Libderiv->deriv2_classes[3][4][34] = int_stack + 6810;
 Libderiv->deriv2_classes[2][4][33] = int_stack + 6960;
 Libderiv->deriv2_classes[3][4][33] = int_stack + 7050;
 Libderiv->deriv2_classes[2][4][32] = int_stack + 7200;
 Libderiv->deriv2_classes[3][4][32] = int_stack + 7290;
 Libderiv->deriv2_classes[2][4][31] = int_stack + 7440;
 Libderiv->deriv2_classes[3][4][31] = int_stack + 7530;
 Libderiv->deriv2_classes[2][4][30] = int_stack + 7680;
 Libderiv->deriv2_classes[3][4][30] = int_stack + 7770;
 Libderiv->deriv2_classes[2][4][26] = int_stack + 7920;
 Libderiv->deriv2_classes[3][4][26] = int_stack + 8010;
 Libderiv->deriv2_classes[2][4][23] = int_stack + 8160;
 Libderiv->deriv2_classes[3][4][23] = int_stack + 8250;
 Libderiv->deriv2_classes[2][4][22] = int_stack + 8400;
 Libderiv->deriv2_classes[3][4][22] = int_stack + 8490;
 Libderiv->deriv2_classes[2][4][21] = int_stack + 8640;
 Libderiv->deriv2_classes[3][4][21] = int_stack + 8730;
 Libderiv->deriv2_classes[2][4][20] = int_stack + 8880;
 Libderiv->deriv2_classes[3][4][20] = int_stack + 8970;
 Libderiv->deriv2_classes[2][4][19] = int_stack + 9120;
 Libderiv->deriv2_classes[3][4][19] = int_stack + 9210;
 Libderiv->deriv2_classes[2][4][18] = int_stack + 9360;
 Libderiv->deriv2_classes[3][4][18] = int_stack + 9450;
 Libderiv->deriv2_classes[2][4][14] = int_stack + 9600;
 Libderiv->deriv2_classes[3][4][14] = int_stack + 9690;
 Libderiv->deriv2_classes[2][4][13] = int_stack + 9840;
 Libderiv->deriv2_classes[3][4][13] = int_stack + 9930;
 Libderiv->deriv_classes[2][4][11] = int_stack + 10080;
 Libderiv->deriv2_classes[2][4][11] = int_stack + 10170;
 Libderiv->deriv2_classes[3][4][11] = int_stack + 10260;
 Libderiv->deriv_classes[2][4][10] = int_stack + 10410;
 Libderiv->deriv2_classes[2][4][10] = int_stack + 10500;
 Libderiv->deriv2_classes[3][4][10] = int_stack + 10590;
 Libderiv->deriv_classes[2][4][9] = int_stack + 10740;
 Libderiv->deriv2_classes[2][4][9] = int_stack + 10830;
 Libderiv->deriv2_classes[3][4][9] = int_stack + 10920;
 Libderiv->deriv_classes[2][4][8] = int_stack + 11070;
 Libderiv->deriv2_classes[2][4][8] = int_stack + 11160;
 Libderiv->deriv2_classes[3][4][8] = int_stack + 11250;
 Libderiv->deriv_classes[2][4][7] = int_stack + 11400;
 Libderiv->deriv2_classes[2][4][7] = int_stack + 11490;
 Libderiv->deriv2_classes[3][4][7] = int_stack + 11580;
 Libderiv->deriv_classes[2][4][6] = int_stack + 11730;
 Libderiv->deriv2_classes[2][4][6] = int_stack + 11820;
 Libderiv->deriv2_classes[3][4][6] = int_stack + 11910;
 Libderiv->deriv_classes[2][4][2] = int_stack + 12060;
 Libderiv->deriv2_classes[2][4][2] = int_stack + 12150;
 Libderiv->deriv2_classes[3][4][2] = int_stack + 12240;
 Libderiv->deriv_classes[2][4][1] = int_stack + 12390;
 Libderiv->deriv2_classes[2][4][1] = int_stack + 12480;
 Libderiv->deriv2_classes[3][4][1] = int_stack + 12570;
 Libderiv->deriv_classes[2][4][0] = int_stack + 12720;
 Libderiv->deriv2_classes[2][4][0] = int_stack + 12810;
 Libderiv->deriv2_classes[3][4][0] = int_stack + 12900;
 memset(int_stack,0,104400);

 Libderiv->dvrr_stack = int_stack + 15480;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_dpg0(Libderiv, Data);
   Data++;
 }

 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+13050,int_stack+0,int_stack+10080,15);
     Libderiv->ABCD[11] = int_stack + 13050;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+13320,int_stack+150,int_stack+10410,15);
     Libderiv->ABCD[10] = int_stack + 13320;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+0,int_stack+300,int_stack+10740,15);
     Libderiv->ABCD[9] = int_stack + 0;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+13590,int_stack+450,int_stack+11070,15);
     Libderiv->ABCD[8] = int_stack + 13590;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+270,int_stack+600,int_stack+11400,15);
     Libderiv->ABCD[7] = int_stack + 270;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+13860,int_stack+750,int_stack+11730,15);
     Libderiv->ABCD[6] = int_stack + 13860;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+540,int_stack+900,int_stack+12060, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[2] = int_stack + 540;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+14130,int_stack+1050,int_stack+12390, 0.0, zero_stack, 1.0, int_stack+1200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[1] = int_stack + 14130;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+810,int_stack+1290,int_stack+12720, 1.0, int_stack+1200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[0] = int_stack + 810;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+1080,int_stack+1530,int_stack+1440,15);
     Libderiv->ABCD[155] = int_stack + 1080;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+1350,int_stack+1770,int_stack+1680,15);
     Libderiv->ABCD[143] = int_stack + 1350;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+1620,int_stack+2010,int_stack+1920,15);
     Libderiv->ABCD[142] = int_stack + 1620;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+1890,int_stack+2250,int_stack+2160,15);
     Libderiv->ABCD[131] = int_stack + 1890;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+14400,int_stack+2490,int_stack+2400,15);
     Libderiv->ABCD[130] = int_stack + 14400;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+2160,int_stack+2730,int_stack+2640,15);
     Libderiv->ABCD[129] = int_stack + 2160;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+2430,int_stack+2970,int_stack+2880,15);
     Libderiv->ABCD[119] = int_stack + 2430;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+2700,int_stack+3210,int_stack+3120,15);
     Libderiv->ABCD[118] = int_stack + 2700;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+2970,int_stack+3450,int_stack+3360,15);
     Libderiv->ABCD[117] = int_stack + 2970;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+3240,int_stack+3690,int_stack+3600,15);
     Libderiv->ABCD[116] = int_stack + 3240;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+3510,int_stack+3930,int_stack+3840,15);
     Libderiv->ABCD[107] = int_stack + 3510;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+3780,int_stack+4170,int_stack+4080,15);
     Libderiv->ABCD[106] = int_stack + 3780;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+4050,int_stack+4410,int_stack+4320,15);
     Libderiv->ABCD[105] = int_stack + 4050;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+14670,int_stack+4650,int_stack+4560,15);
     Libderiv->ABCD[104] = int_stack + 14670;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+4320,int_stack+4890,int_stack+4800,15);
     Libderiv->ABCD[103] = int_stack + 4320;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+4590,int_stack+5130,int_stack+5040,15);
     Libderiv->ABCD[95] = int_stack + 4590;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+4860,int_stack+5370,int_stack+5280,15);
     Libderiv->ABCD[94] = int_stack + 4860;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+5130,int_stack+5610,int_stack+5520,15);
     Libderiv->ABCD[93] = int_stack + 5130;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+5400,int_stack+5850,int_stack+5760,15);
     Libderiv->ABCD[92] = int_stack + 5400;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+5670,int_stack+6090,int_stack+6000,15);
     Libderiv->ABCD[91] = int_stack + 5670;
 /*--- compute (dp|g0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+5940,int_stack+6330,int_stack+6240,15);
     Libderiv->ABCD[90] = int_stack + 5940;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+6210,int_stack+6570,int_stack+6480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[47] = int_stack + 6210;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+14940,int_stack+6810,int_stack+6720, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[46] = int_stack + 14940;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+6480,int_stack+7050,int_stack+6960, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[45] = int_stack + 6480;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+6750,int_stack+7290,int_stack+7200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[44] = int_stack + 6750;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+7020,int_stack+7530,int_stack+7440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[43] = int_stack + 7020;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+7290,int_stack+7770,int_stack+7680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[42] = int_stack + 7290;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+7560,int_stack+8010,int_stack+7920, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+12060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[38] = int_stack + 7560;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+7830,int_stack+8250,int_stack+8160, 0.0, zero_stack, 1.0, int_stack+10080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[35] = int_stack + 7830;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+8100,int_stack+8490,int_stack+8400, 0.0, zero_stack, 1.0, int_stack+10410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[34] = int_stack + 8100;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+8370,int_stack+8730,int_stack+8640, 0.0, zero_stack, 1.0, int_stack+10740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[33] = int_stack + 8370;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+15210,int_stack+8970,int_stack+8880, 0.0, zero_stack, 1.0, int_stack+11070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[32] = int_stack + 15210;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+8640,int_stack+9210,int_stack+9120, 0.0, zero_stack, 1.0, int_stack+11400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[31] = int_stack + 8640;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+8910,int_stack+9450,int_stack+9360, 0.0, zero_stack, 1.0, int_stack+11730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[30] = int_stack + 8910;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+9180,int_stack+9690,int_stack+9600, 0.0, zero_stack, 1.0, int_stack+12060, 1.0, int_stack+12390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[26] = int_stack + 9180;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+9450,int_stack+9930,int_stack+9840, 0.0, zero_stack, 2.0, int_stack+12390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[25] = int_stack + 9450;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+9720,int_stack+10260,int_stack+10170, 1.0, int_stack+10080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[23] = int_stack + 9720;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+9990,int_stack+10590,int_stack+10500, 1.0, int_stack+10410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[22] = int_stack + 9990;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+10260,int_stack+10920,int_stack+10830, 1.0, int_stack+10740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[21] = int_stack + 10260;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+10530,int_stack+11250,int_stack+11160, 1.0, int_stack+11070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[20] = int_stack + 10530;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+10800,int_stack+11580,int_stack+11490, 1.0, int_stack+11400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[19] = int_stack + 10800;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+11070,int_stack+11910,int_stack+11820, 1.0, int_stack+11730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[18] = int_stack + 11070;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+11340,int_stack+12240,int_stack+12150, 1.0, int_stack+12060, 0.0, zero_stack, 1.0, int_stack+12720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[14] = int_stack + 11340;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+11610,int_stack+12570,int_stack+12480, 1.0, int_stack+12390, 1.0, int_stack+12720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[13] = int_stack + 11610;
 /*--- compute (dp|g0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+11880,int_stack+12900,int_stack+12810, 2.0, int_stack+12720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[12] = int_stack + 11880;

}
