/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_fdgp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (fd|gp) integrals */

void d12hrr_order_fdgp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][5][11] = int_stack + 0;
 Libderiv->deriv_classes[5][5][10] = int_stack + 441;
 Libderiv->deriv_classes[5][5][9] = int_stack + 882;
 Libderiv->deriv_classes[5][5][8] = int_stack + 1323;
 Libderiv->deriv_classes[5][5][7] = int_stack + 1764;
 Libderiv->dvrr_classes[5][4] = int_stack + 2205;
 Libderiv->deriv_classes[5][5][6] = int_stack + 2520;
 Libderiv->deriv_classes[5][5][2] = int_stack + 2961;
 Libderiv->deriv_classes[5][5][1] = int_stack + 3402;
 Libderiv->dvrr_classes[4][5] = int_stack + 3843;
 Libderiv->deriv_classes[5][5][0] = int_stack + 4158;
 Libderiv->deriv2_classes[3][4][143] = int_stack + 4599;
 Libderiv->deriv2_classes[3][5][143] = int_stack + 4749;
 Libderiv->deriv2_classes[4][4][143] = int_stack + 4959;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 5184;
 Libderiv->deriv2_classes[5][4][143] = int_stack + 5499;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 5814;
 Libderiv->deriv2_classes[3][4][131] = int_stack + 6255;
 Libderiv->deriv2_classes[3][5][131] = int_stack + 6405;
 Libderiv->deriv2_classes[4][4][131] = int_stack + 6615;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 6840;
 Libderiv->deriv2_classes[5][4][131] = int_stack + 7155;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 7470;
 Libderiv->deriv2_classes[3][4][130] = int_stack + 7911;
 Libderiv->deriv2_classes[3][5][130] = int_stack + 8061;
 Libderiv->deriv2_classes[4][4][130] = int_stack + 8271;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 8496;
 Libderiv->deriv2_classes[5][4][130] = int_stack + 8811;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 9126;
 Libderiv->deriv2_classes[3][4][119] = int_stack + 9567;
 Libderiv->deriv2_classes[3][5][119] = int_stack + 9717;
 Libderiv->deriv2_classes[4][4][119] = int_stack + 9927;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 10152;
 Libderiv->deriv2_classes[5][4][119] = int_stack + 10467;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 10782;
 Libderiv->deriv2_classes[3][4][118] = int_stack + 11223;
 Libderiv->deriv2_classes[3][5][118] = int_stack + 11373;
 Libderiv->deriv2_classes[4][4][118] = int_stack + 11583;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 11808;
 Libderiv->deriv2_classes[5][4][118] = int_stack + 12123;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 12438;
 Libderiv->deriv2_classes[3][4][117] = int_stack + 12879;
 Libderiv->deriv2_classes[3][5][117] = int_stack + 13029;
 Libderiv->deriv2_classes[4][4][117] = int_stack + 13239;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 13464;
 Libderiv->deriv2_classes[5][4][117] = int_stack + 13779;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 14094;
 Libderiv->deriv2_classes[3][4][107] = int_stack + 14535;
 Libderiv->deriv2_classes[3][5][107] = int_stack + 14685;
 Libderiv->deriv2_classes[4][4][107] = int_stack + 14895;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 15120;
 Libderiv->deriv2_classes[5][4][107] = int_stack + 15435;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 15750;
 Libderiv->deriv2_classes[3][4][106] = int_stack + 16191;
 Libderiv->deriv2_classes[3][5][106] = int_stack + 16341;
 Libderiv->deriv2_classes[4][4][106] = int_stack + 16551;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 16776;
 Libderiv->deriv2_classes[5][4][106] = int_stack + 17091;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 17406;
 Libderiv->deriv2_classes[3][4][105] = int_stack + 17847;
 Libderiv->deriv2_classes[3][5][105] = int_stack + 17997;
 Libderiv->deriv2_classes[4][4][105] = int_stack + 18207;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 18432;
 Libderiv->deriv2_classes[5][4][105] = int_stack + 18747;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 19062;
 Libderiv->deriv2_classes[3][4][104] = int_stack + 19503;
 Libderiv->deriv2_classes[3][5][104] = int_stack + 19653;
 Libderiv->deriv2_classes[4][4][104] = int_stack + 19863;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 20088;
 Libderiv->deriv2_classes[5][4][104] = int_stack + 20403;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 20718;
 Libderiv->deriv2_classes[3][4][95] = int_stack + 21159;
 Libderiv->deriv2_classes[3][5][95] = int_stack + 21309;
 Libderiv->deriv2_classes[4][4][95] = int_stack + 21519;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 21744;
 Libderiv->deriv2_classes[5][4][95] = int_stack + 22059;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 22374;
 Libderiv->deriv2_classes[3][4][94] = int_stack + 22815;
 Libderiv->deriv2_classes[3][5][94] = int_stack + 22965;
 Libderiv->deriv2_classes[4][4][94] = int_stack + 23175;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 23400;
 Libderiv->deriv2_classes[5][4][94] = int_stack + 23715;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 24030;
 Libderiv->deriv2_classes[3][4][93] = int_stack + 24471;
 Libderiv->deriv2_classes[3][5][93] = int_stack + 24621;
 Libderiv->deriv2_classes[4][4][93] = int_stack + 24831;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 25056;
 Libderiv->deriv2_classes[5][4][93] = int_stack + 25371;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 25686;
 Libderiv->deriv2_classes[3][4][92] = int_stack + 26127;
 Libderiv->deriv2_classes[3][5][92] = int_stack + 26277;
 Libderiv->deriv2_classes[4][4][92] = int_stack + 26487;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 26712;
 Libderiv->deriv2_classes[5][4][92] = int_stack + 27027;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 27342;
 Libderiv->deriv2_classes[3][4][91] = int_stack + 27783;
 Libderiv->deriv2_classes[3][5][91] = int_stack + 27933;
 Libderiv->deriv2_classes[4][4][91] = int_stack + 28143;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 28368;
 Libderiv->deriv2_classes[5][4][91] = int_stack + 28683;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 28998;
 Libderiv->deriv2_classes[3][4][83] = int_stack + 29439;
 Libderiv->deriv2_classes[3][5][83] = int_stack + 29589;
 Libderiv->deriv2_classes[4][4][83] = int_stack + 29799;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 30024;
 Libderiv->deriv_classes[5][4][11] = int_stack + 30339;
 Libderiv->deriv2_classes[5][4][83] = int_stack + 30654;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 30969;
 Libderiv->deriv2_classes[3][4][82] = int_stack + 31410;
 Libderiv->deriv2_classes[3][5][82] = int_stack + 31560;
 Libderiv->deriv2_classes[4][4][82] = int_stack + 31770;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 31995;
 Libderiv->deriv_classes[5][4][10] = int_stack + 32310;
 Libderiv->deriv2_classes[5][4][82] = int_stack + 32625;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 32940;
 Libderiv->deriv2_classes[3][4][81] = int_stack + 33381;
 Libderiv->deriv2_classes[3][5][81] = int_stack + 33531;
 Libderiv->deriv2_classes[4][4][81] = int_stack + 33741;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 33966;
 Libderiv->deriv_classes[5][4][9] = int_stack + 34281;
 Libderiv->deriv2_classes[5][4][81] = int_stack + 34596;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 34911;
 Libderiv->deriv2_classes[3][4][80] = int_stack + 35352;
 Libderiv->deriv2_classes[3][5][80] = int_stack + 35502;
 Libderiv->deriv2_classes[4][4][80] = int_stack + 35712;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 35937;
 Libderiv->deriv_classes[5][4][8] = int_stack + 36252;
 Libderiv->deriv2_classes[5][4][80] = int_stack + 36567;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 36882;
 Libderiv->deriv2_classes[3][4][79] = int_stack + 37323;
 Libderiv->deriv2_classes[3][5][79] = int_stack + 37473;
 Libderiv->deriv2_classes[4][4][79] = int_stack + 37683;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 37908;
 Libderiv->deriv_classes[5][4][7] = int_stack + 38223;
 Libderiv->deriv2_classes[5][4][79] = int_stack + 38538;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 38853;
 Libderiv->deriv2_classes[3][4][78] = int_stack + 39294;
 Libderiv->deriv2_classes[3][5][78] = int_stack + 39444;
 Libderiv->deriv2_classes[4][4][78] = int_stack + 39654;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 39879;
 Libderiv->deriv_classes[5][4][6] = int_stack + 40194;
 Libderiv->deriv2_classes[5][4][78] = int_stack + 40509;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 40824;
 Libderiv->deriv2_classes[3][4][35] = int_stack + 41265;
 Libderiv->deriv2_classes[3][5][35] = int_stack + 41415;
 Libderiv->deriv2_classes[4][4][35] = int_stack + 41625;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 41850;
 Libderiv->deriv2_classes[5][4][35] = int_stack + 42165;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 42480;
 Libderiv->deriv2_classes[3][4][34] = int_stack + 42921;
 Libderiv->deriv2_classes[3][5][34] = int_stack + 43071;
 Libderiv->deriv2_classes[4][4][34] = int_stack + 43281;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 43506;
 Libderiv->deriv2_classes[5][4][34] = int_stack + 43821;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 44136;
 Libderiv->deriv2_classes[3][4][33] = int_stack + 44577;
 Libderiv->deriv2_classes[3][5][33] = int_stack + 44727;
 Libderiv->deriv2_classes[4][4][33] = int_stack + 44937;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 45162;
 Libderiv->deriv2_classes[5][4][33] = int_stack + 45477;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 45792;
 Libderiv->deriv2_classes[3][4][32] = int_stack + 46233;
 Libderiv->deriv2_classes[3][5][32] = int_stack + 46383;
 Libderiv->deriv2_classes[4][4][32] = int_stack + 46593;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 46818;
 Libderiv->deriv2_classes[5][4][32] = int_stack + 47133;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 47448;
 Libderiv->deriv2_classes[3][4][31] = int_stack + 47889;
 Libderiv->deriv2_classes[3][5][31] = int_stack + 48039;
 Libderiv->deriv2_classes[4][4][31] = int_stack + 48249;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 48474;
 Libderiv->deriv2_classes[5][4][31] = int_stack + 48789;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 49104;
 Libderiv->deriv2_classes[3][4][30] = int_stack + 49545;
 Libderiv->deriv2_classes[3][5][30] = int_stack + 49695;
 Libderiv->deriv2_classes[4][4][30] = int_stack + 49905;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 50130;
 Libderiv->deriv_classes[5][4][2] = int_stack + 50445;
 Libderiv->deriv2_classes[5][4][30] = int_stack + 50760;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 51075;
 Libderiv->deriv2_classes[3][4][26] = int_stack + 51516;
 Libderiv->deriv2_classes[3][5][26] = int_stack + 51666;
 Libderiv->deriv2_classes[4][4][26] = int_stack + 51876;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 52101;
 Libderiv->deriv2_classes[5][4][26] = int_stack + 52416;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 52731;
 Libderiv->deriv2_classes[3][4][23] = int_stack + 53172;
 Libderiv->deriv2_classes[3][5][23] = int_stack + 53322;
 Libderiv->deriv2_classes[4][4][23] = int_stack + 53532;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 53757;
 Libderiv->deriv2_classes[5][4][23] = int_stack + 54072;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 54387;
 Libderiv->deriv2_classes[3][4][22] = int_stack + 54828;
 Libderiv->deriv2_classes[3][5][22] = int_stack + 54978;
 Libderiv->deriv2_classes[4][4][22] = int_stack + 55188;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 55413;
 Libderiv->deriv2_classes[5][4][22] = int_stack + 55728;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 56043;
 Libderiv->deriv2_classes[3][4][21] = int_stack + 56484;
 Libderiv->deriv2_classes[3][5][21] = int_stack + 56634;
 Libderiv->deriv2_classes[4][4][21] = int_stack + 56844;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 57069;
 Libderiv->deriv2_classes[5][4][21] = int_stack + 57384;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 57699;
 Libderiv->deriv2_classes[3][4][20] = int_stack + 58140;
 Libderiv->deriv2_classes[3][5][20] = int_stack + 58290;
 Libderiv->deriv2_classes[4][4][20] = int_stack + 58500;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 58725;
 Libderiv->deriv2_classes[5][4][20] = int_stack + 59040;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 59355;
 Libderiv->deriv2_classes[3][4][19] = int_stack + 59796;
 Libderiv->deriv2_classes[3][5][19] = int_stack + 59946;
 Libderiv->deriv2_classes[4][4][19] = int_stack + 60156;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 60381;
 Libderiv->deriv2_classes[5][4][19] = int_stack + 60696;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 61011;
 Libderiv->deriv2_classes[3][4][18] = int_stack + 61452;
 Libderiv->deriv2_classes[3][5][18] = int_stack + 61602;
 Libderiv->deriv2_classes[4][4][18] = int_stack + 61812;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 62037;
 Libderiv->deriv_classes[5][4][1] = int_stack + 62352;
 Libderiv->deriv2_classes[5][4][18] = int_stack + 62667;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 62982;
 Libderiv->deriv2_classes[3][4][14] = int_stack + 63423;
 Libderiv->deriv2_classes[3][5][14] = int_stack + 63573;
 Libderiv->deriv2_classes[4][4][14] = int_stack + 63783;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 64008;
 Libderiv->deriv2_classes[5][4][14] = int_stack + 64323;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 64638;
 Libderiv->deriv2_classes[3][4][13] = int_stack + 65079;
 Libderiv->deriv2_classes[3][5][13] = int_stack + 65229;
 Libderiv->deriv2_classes[4][4][13] = int_stack + 65439;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 65664;
 Libderiv->deriv2_classes[5][4][13] = int_stack + 65979;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 66294;
 Libderiv->deriv_classes[3][4][11] = int_stack + 66735;
 Libderiv->deriv_classes[3][5][11] = int_stack + 66885;
 Libderiv->deriv2_classes[3][4][11] = int_stack + 67095;
 Libderiv->deriv2_classes[3][5][11] = int_stack + 67245;
 Libderiv->deriv_classes[4][4][11] = int_stack + 67455;
 Libderiv->deriv_classes[4][5][11] = int_stack + 67680;
 Libderiv->deriv2_classes[4][4][11] = int_stack + 67995;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 68220;
 Libderiv->deriv2_classes[5][4][11] = int_stack + 68535;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 68850;
 Libderiv->deriv_classes[3][4][10] = int_stack + 69291;
 Libderiv->deriv_classes[3][5][10] = int_stack + 69441;
 Libderiv->deriv2_classes[3][4][10] = int_stack + 69651;
 Libderiv->deriv2_classes[3][5][10] = int_stack + 69801;
 Libderiv->deriv_classes[4][4][10] = int_stack + 70011;
 Libderiv->deriv_classes[4][5][10] = int_stack + 70236;
 Libderiv->deriv2_classes[4][4][10] = int_stack + 70551;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 70776;
 Libderiv->deriv2_classes[5][4][10] = int_stack + 71091;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 71406;
 Libderiv->deriv_classes[3][4][9] = int_stack + 71847;
 Libderiv->deriv_classes[3][5][9] = int_stack + 71997;
 Libderiv->deriv2_classes[3][4][9] = int_stack + 72207;
 Libderiv->deriv2_classes[3][5][9] = int_stack + 72357;
 Libderiv->deriv_classes[4][4][9] = int_stack + 72567;
 Libderiv->deriv_classes[4][5][9] = int_stack + 72792;
 Libderiv->deriv2_classes[4][4][9] = int_stack + 73107;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 73332;
 Libderiv->deriv2_classes[5][4][9] = int_stack + 73647;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 73962;
 Libderiv->deriv_classes[3][4][8] = int_stack + 74403;
 Libderiv->deriv_classes[3][5][8] = int_stack + 74553;
 Libderiv->deriv2_classes[3][4][8] = int_stack + 74763;
 Libderiv->deriv2_classes[3][5][8] = int_stack + 74913;
 Libderiv->deriv_classes[4][4][8] = int_stack + 75123;
 Libderiv->deriv_classes[4][5][8] = int_stack + 75348;
 Libderiv->deriv2_classes[4][4][8] = int_stack + 75663;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 75888;
 Libderiv->deriv2_classes[5][4][8] = int_stack + 76203;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 76518;
 Libderiv->deriv_classes[3][4][7] = int_stack + 76959;
 Libderiv->deriv_classes[3][5][7] = int_stack + 77109;
 Libderiv->deriv2_classes[3][4][7] = int_stack + 77319;
 Libderiv->deriv2_classes[3][5][7] = int_stack + 77469;
 Libderiv->deriv_classes[4][4][7] = int_stack + 77679;
 Libderiv->deriv_classes[4][5][7] = int_stack + 77904;
 Libderiv->deriv2_classes[4][4][7] = int_stack + 78219;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 78444;
 Libderiv->deriv2_classes[5][4][7] = int_stack + 78759;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 79074;
 Libderiv->deriv_classes[3][4][6] = int_stack + 79515;
 Libderiv->deriv_classes[3][5][6] = int_stack + 79665;
 Libderiv->deriv2_classes[3][4][6] = int_stack + 79875;
 Libderiv->deriv2_classes[3][5][6] = int_stack + 80025;
 Libderiv->dvrr_classes[4][4] = int_stack + 80235;
 Libderiv->deriv_classes[4][4][6] = int_stack + 80460;
 Libderiv->deriv_classes[4][5][6] = int_stack + 80685;
 Libderiv->deriv2_classes[4][4][6] = int_stack + 81000;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 81225;
 Libderiv->deriv_classes[5][4][0] = int_stack + 81540;
 Libderiv->deriv2_classes[5][4][6] = int_stack + 81855;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 82170;
 Libderiv->deriv_classes[3][4][2] = int_stack + 82611;
 Libderiv->deriv_classes[3][5][2] = int_stack + 82761;
 Libderiv->deriv2_classes[3][4][2] = int_stack + 82971;
 Libderiv->deriv2_classes[3][5][2] = int_stack + 83121;
 Libderiv->deriv_classes[4][4][2] = int_stack + 83331;
 Libderiv->deriv_classes[4][5][2] = int_stack + 83556;
 Libderiv->deriv2_classes[4][4][2] = int_stack + 83871;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 84096;
 Libderiv->deriv2_classes[5][4][2] = int_stack + 84411;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 84726;
 Libderiv->deriv_classes[3][4][1] = int_stack + 85167;
 Libderiv->deriv_classes[3][5][1] = int_stack + 85317;
 Libderiv->deriv2_classes[3][4][1] = int_stack + 85527;
 Libderiv->deriv2_classes[3][5][1] = int_stack + 85677;
 Libderiv->deriv_classes[4][4][1] = int_stack + 85887;
 Libderiv->deriv_classes[4][5][1] = int_stack + 86112;
 Libderiv->deriv2_classes[4][4][1] = int_stack + 86427;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 86652;
 Libderiv->deriv2_classes[5][4][1] = int_stack + 86967;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 87282;
 Libderiv->dvrr_classes[3][4] = int_stack + 87723;
 Libderiv->dvrr_classes[3][5] = int_stack + 87873;
 Libderiv->deriv_classes[3][4][0] = int_stack + 88083;
 Libderiv->deriv_classes[3][5][0] = int_stack + 88233;
 Libderiv->deriv2_classes[3][4][0] = int_stack + 88443;
 Libderiv->deriv2_classes[3][5][0] = int_stack + 88593;
 Libderiv->deriv_classes[4][4][0] = int_stack + 88803;
 Libderiv->deriv_classes[4][5][0] = int_stack + 89028;
 Libderiv->deriv2_classes[4][4][0] = int_stack + 89343;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 89568;
 Libderiv->deriv2_classes[5][4][0] = int_stack + 89883;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 90198;
 memset(int_stack,0,725112);

 Libderiv->dvrr_stack = int_stack + 199494;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_fdgp(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90639,int_stack+66885,int_stack+66735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87723,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+91089,int_stack+67680,int_stack+67455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80235,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+91764,int_stack+91089,int_stack+90639,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+93114,int_stack+0,int_stack+30339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+94059,int_stack+93114,int_stack+91089,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+93114,int_stack+69441,int_stack+69291, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87723, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+96084,int_stack+70236,int_stack+70011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80235, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+96759,int_stack+96084,int_stack+93114,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+98109,int_stack+441,int_stack+32310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+99054,int_stack+98109,int_stack+96084,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+98109,int_stack+71997,int_stack+71847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87723, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+72792,int_stack+72567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80235, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+101079,int_stack+0,int_stack+98109,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+102429,int_stack+882,int_stack+34281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+103374,int_stack+102429,int_stack+0,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+102429,int_stack+74553,int_stack+74403, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+105399,int_stack+75348,int_stack+75123, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+106074,int_stack+105399,int_stack+102429,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+107424,int_stack+1323,int_stack+36252, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+108369,int_stack+107424,int_stack+105399,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+107424,int_stack+77109,int_stack+76959, 0.0, zero_stack, 1.0, int_stack+87723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+675,int_stack+77904,int_stack+77679, 0.0, zero_stack, 1.0, int_stack+80235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+110394,int_stack+675,int_stack+107424,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+111744,int_stack+1764,int_stack+38223, 0.0, zero_stack, 1.0, int_stack+2205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+112689,int_stack+111744,int_stack+675,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+111744,int_stack+79665,int_stack+79515, 1.0, int_stack+87723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+80685,int_stack+80460, 1.0, int_stack+80235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+114714,int_stack+1350,int_stack+111744,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+2520,int_stack+40194, 1.0, int_stack+2205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+117009,int_stack+116064,int_stack+1350,45);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+87873,int_stack+87723,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+3843,int_stack+80235,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+119034,int_stack+2025,int_stack+116064,45);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+116514,int_stack+82761,int_stack+82611,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+120384,int_stack+83556,int_stack+83331,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+121059,int_stack+120384,int_stack+116514, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+122409,int_stack+2961,int_stack+50445,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+123354,int_stack+122409,int_stack+120384, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+122409,int_stack+85317,int_stack+85167,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+2700,int_stack+86112,int_stack+85887,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+125379,int_stack+2700,int_stack+122409, 0.0, zero_stack, 1.0, int_stack+116064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+126729,int_stack+3402,int_stack+62352,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+127674,int_stack+126729,int_stack+2700, 0.0, zero_stack, 1.0, int_stack+2025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+126729,int_stack+88233,int_stack+88083,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+3375,int_stack+89028,int_stack+88803,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+129699,int_stack+3375,int_stack+126729, 1.0, int_stack+116064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+4158,int_stack+81540,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+131994,int_stack+131049,int_stack+3375, 1.0, int_stack+2025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+4749,int_stack+4599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+66735,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+5184,int_stack+4959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+67455,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+4050,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+5814,int_stack+5499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+30339,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+134019,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+6405,int_stack+6255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66735, 1.0, int_stack+69291,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+6840,int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+67455, 1.0, int_stack+70011,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+5400,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+7470,int_stack+7155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30339, 1.0, int_stack+32310,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+136044,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+8061,int_stack+7911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+69291, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+8496,int_stack+8271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+70011, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+6750,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+9126,int_stack+8811, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+32310, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+138069,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+9717,int_stack+9567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66735, 0.0, zero_stack, 1.0, int_stack+71847,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+10152,int_stack+9927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+67455, 0.0, zero_stack, 1.0, int_stack+72567,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+8100,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+10782,int_stack+10467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30339, 0.0, zero_stack, 1.0, int_stack+34281,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+140094,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+11373,int_stack+11223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69291, 1.0, int_stack+71847, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+11808,int_stack+11583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70011, 1.0, int_stack+72567, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+9450,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+12438,int_stack+12123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32310, 1.0, int_stack+34281, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+10800,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+13029,int_stack+12879, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+71847, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+13464,int_stack+13239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+72567, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+142119,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+14094,int_stack+13779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+34281, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+143469,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+14685,int_stack+14535, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66735, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+74403,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+15120,int_stack+14895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+67455, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75123,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+12825,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+15750,int_stack+15435, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30339, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36252,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+145494,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+16341,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69291, 0.0, zero_stack, 1.0, int_stack+74403, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+16776,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70011, 0.0, zero_stack, 1.0, int_stack+75123, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+14175,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+17406,int_stack+17091, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32310, 0.0, zero_stack, 1.0, int_stack+36252, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+15525,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+17997,int_stack+17847, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71847, 1.0, int_stack+74403, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+18432,int_stack+18207, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72567, 1.0, int_stack+75123, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+147519,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+19062,int_stack+18747, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34281, 1.0, int_stack+36252, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+148869,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+19653,int_stack+19503, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+74403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+20088,int_stack+19863, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+75123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+17550,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+20718,int_stack+20403, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+36252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+18900,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+21309,int_stack+21159, 0.0, zero_stack, 1.0, int_stack+66735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76959,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+21744,int_stack+21519, 0.0, zero_stack, 1.0, int_stack+67455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77679,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+150894,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+22374,int_stack+22059, 0.0, zero_stack, 1.0, int_stack+30339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38223,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+152244,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+22965,int_stack+22815, 0.0, zero_stack, 1.0, int_stack+69291, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76959, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+23400,int_stack+23175, 0.0, zero_stack, 1.0, int_stack+70011, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77679, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+20925,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+24030,int_stack+23715, 0.0, zero_stack, 1.0, int_stack+32310, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38223, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+22275,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+24621,int_stack+24471, 0.0, zero_stack, 1.0, int_stack+71847, 0.0, zero_stack, 1.0, int_stack+76959, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+25056,int_stack+24831, 0.0, zero_stack, 1.0, int_stack+72567, 0.0, zero_stack, 1.0, int_stack+77679, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+154269,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+25686,int_stack+25371, 0.0, zero_stack, 1.0, int_stack+34281, 0.0, zero_stack, 1.0, int_stack+38223, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+155619,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+26277,int_stack+26127, 0.0, zero_stack, 1.0, int_stack+74403, 1.0, int_stack+76959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+26712,int_stack+26487, 0.0, zero_stack, 1.0, int_stack+75123, 1.0, int_stack+77679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+24300,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+27342,int_stack+27027, 0.0, zero_stack, 1.0, int_stack+36252, 1.0, int_stack+38223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+25650,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+27933,int_stack+27783, 0.0, zero_stack, 2.0, int_stack+76959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+28368,int_stack+28143, 0.0, zero_stack, 2.0, int_stack+77679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+157644,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+28998,int_stack+28683, 0.0, zero_stack, 2.0, int_stack+38223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+158994,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+29589,int_stack+29439, 1.0, int_stack+66735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79515,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+30024,int_stack+29799, 1.0, int_stack+67455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80460,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+27675,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+30969,int_stack+30654, 1.0, int_stack+30339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40194,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+29025,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+31560,int_stack+31410, 1.0, int_stack+69291, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79515, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+31995,int_stack+31770, 1.0, int_stack+70011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80460, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+161019,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+32940,int_stack+32625, 1.0, int_stack+32310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40194, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+31050,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+33531,int_stack+33381, 1.0, int_stack+71847, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79515, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+33966,int_stack+33741, 1.0, int_stack+72567, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80460, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+162369,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+34911,int_stack+34596, 1.0, int_stack+34281, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40194, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+33075,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+35502,int_stack+35352, 1.0, int_stack+74403, 0.0, zero_stack, 1.0, int_stack+79515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+35937,int_stack+35712, 1.0, int_stack+75123, 0.0, zero_stack, 1.0, int_stack+80460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+163719,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+36882,int_stack+36567, 1.0, int_stack+36252, 0.0, zero_stack, 1.0, int_stack+40194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+35100,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+37473,int_stack+37323, 1.0, int_stack+76959, 1.0, int_stack+79515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+37908,int_stack+37683, 1.0, int_stack+77679, 1.0, int_stack+80460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+165069,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+38853,int_stack+38538, 1.0, int_stack+38223, 1.0, int_stack+40194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+37125,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+39444,int_stack+39294, 2.0, int_stack+79515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+39879,int_stack+39654, 2.0, int_stack+80460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+166419,int_stack+2025,int_stack+116064,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+40824,int_stack+40509, 2.0, int_stack+40194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+39150,int_stack+131049,int_stack+2025,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+41415,int_stack+41265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82611,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+41850,int_stack+41625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83331,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+167769,int_stack+2025,int_stack+116064, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+42480,int_stack+42165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50445,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+169119,int_stack+131049,int_stack+2025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+43071,int_stack+42921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82611, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+43506,int_stack+43281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83331, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+41175,int_stack+2025,int_stack+116064, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+93114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+44136,int_stack+43821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50445, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+42525,int_stack+131049,int_stack+2025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+44727,int_stack+44577, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82611, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+45162,int_stack+44937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83331, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+171144,int_stack+2025,int_stack+116064, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+45792,int_stack+45477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50445, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+172494,int_stack+131049,int_stack+2025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+46383,int_stack+46233, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+46818,int_stack+46593, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+44550,int_stack+2025,int_stack+116064, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+47448,int_stack+47133, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+174519,int_stack+131049,int_stack+2025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+48039,int_stack+47889, 0.0, zero_stack, 1.0, int_stack+82611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+48474,int_stack+48249, 0.0, zero_stack, 1.0, int_stack+83331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+45900,int_stack+2025,int_stack+116064, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+49104,int_stack+48789, 0.0, zero_stack, 1.0, int_stack+50445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+47250,int_stack+131049,int_stack+2025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+49695,int_stack+49545, 1.0, int_stack+82611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+50130,int_stack+49905, 1.0, int_stack+83331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+176544,int_stack+2025,int_stack+116064, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+111744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+51075,int_stack+50760, 1.0, int_stack+50445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+49275,int_stack+131049,int_stack+2025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+51666,int_stack+51516,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+52101,int_stack+51876,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+177894,int_stack+2025,int_stack+116064, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+116514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+52731,int_stack+52416,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+179244,int_stack+131049,int_stack+2025, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+120384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+53322,int_stack+53172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85167,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+53757,int_stack+53532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85887,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+51300,int_stack+2025,int_stack+116064, 0.0, zero_stack, 1.0, int_stack+90639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+54387,int_stack+54072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62352,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+52650,int_stack+131049,int_stack+2025, 0.0, zero_stack, 1.0, int_stack+91089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+54978,int_stack+54828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85167, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+55413,int_stack+55188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85887, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+181269,int_stack+2025,int_stack+116064, 0.0, zero_stack, 1.0, int_stack+93114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+56043,int_stack+55728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62352, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+182619,int_stack+131049,int_stack+2025, 0.0, zero_stack, 1.0, int_stack+96084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+56634,int_stack+56484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85167, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+57069,int_stack+56844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85887, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+54675,int_stack+2025,int_stack+116064, 0.0, zero_stack, 1.0, int_stack+98109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+57699,int_stack+57384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62352, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+56025,int_stack+131049,int_stack+2025, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+58290,int_stack+58140, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+58725,int_stack+58500, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+184644,int_stack+2025,int_stack+116064, 0.0, zero_stack, 1.0, int_stack+102429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+59355,int_stack+59040, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+185994,int_stack+131049,int_stack+2025, 0.0, zero_stack, 1.0, int_stack+105399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+59946,int_stack+59796, 0.0, zero_stack, 1.0, int_stack+85167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+60381,int_stack+60156, 0.0, zero_stack, 1.0, int_stack+85887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+58050,int_stack+2025,int_stack+116064, 0.0, zero_stack, 1.0, int_stack+107424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+61011,int_stack+60696, 0.0, zero_stack, 1.0, int_stack+62352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+59400,int_stack+131049,int_stack+2025, 0.0, zero_stack, 1.0, int_stack+675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+61602,int_stack+61452, 1.0, int_stack+85167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+62037,int_stack+61812, 1.0, int_stack+85887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+188019,int_stack+2025,int_stack+116064, 0.0, zero_stack, 1.0, int_stack+111744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+62982,int_stack+62667, 1.0, int_stack+62352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+189369,int_stack+131049,int_stack+2025, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+63573,int_stack+63423,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+64008,int_stack+63783,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+61425,int_stack+2025,int_stack+116064, 0.0, zero_stack, 1.0, int_stack+116514, 1.0, int_stack+122409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+64638,int_stack+64323,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+62775,int_stack+131049,int_stack+2025, 0.0, zero_stack, 1.0, int_stack+120384, 1.0, int_stack+2700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+65229,int_stack+65079,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+65664,int_stack+65439,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+191394,int_stack+2025,int_stack+116064, 0.0, zero_stack, 2.0, int_stack+122409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+66294,int_stack+65979,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+64800,int_stack+131049,int_stack+2025, 0.0, zero_stack, 2.0, int_stack+2700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+67245,int_stack+67095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88083,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+68220,int_stack+67995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88803,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+66825,int_stack+2025,int_stack+116064, 1.0, int_stack+90639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+131049,int_stack+68850,int_stack+68535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81540,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+192744,int_stack+131049,int_stack+2025, 1.0, int_stack+91089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+69801,int_stack+69651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88083, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+70776,int_stack+70551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88803, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+68175,int_stack+2025,int_stack+116064, 1.0, int_stack+93114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+93114,int_stack+71406,int_stack+71091, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81540, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+69525,int_stack+93114,int_stack+2025, 1.0, int_stack+96084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+72357,int_stack+72207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88083, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+96084,int_stack+73332,int_stack+73107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88803, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+71550,int_stack+96084,int_stack+116064, 1.0, int_stack+98109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+98109,int_stack+73962,int_stack+73647, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81540, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+194769,int_stack+98109,int_stack+96084, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+74913,int_stack+74763, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+75888,int_stack+75663, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+72900,int_stack+0,int_stack+116064, 1.0, int_stack+102429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+102429,int_stack+76518,int_stack+76203, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+74250,int_stack+102429,int_stack+0, 1.0, int_stack+105399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+77469,int_stack+77319, 0.0, zero_stack, 1.0, int_stack+88083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+105399,int_stack+78444,int_stack+78219, 0.0, zero_stack, 1.0, int_stack+88803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+76275,int_stack+105399,int_stack+116064, 1.0, int_stack+107424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+107424,int_stack+79074,int_stack+78759, 0.0, zero_stack, 1.0, int_stack+81540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+77625,int_stack+107424,int_stack+105399, 1.0, int_stack+675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+80025,int_stack+79875, 1.0, int_stack+88083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+105399,int_stack+81225,int_stack+81000, 1.0, int_stack+88803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+0,int_stack+105399,int_stack+116064, 1.0, int_stack+111744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+111744,int_stack+82170,int_stack+81855, 1.0, int_stack+81540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+79650,int_stack+111744,int_stack+105399, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+83121,int_stack+82971,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+105399,int_stack+84096,int_stack+83871,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1350,int_stack+105399,int_stack+116064, 1.0, int_stack+116514, 0.0, zero_stack, 1.0, int_stack+126729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+116064,int_stack+84726,int_stack+84411,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+81675,int_stack+116064,int_stack+105399, 1.0, int_stack+120384, 0.0, zero_stack, 1.0, int_stack+3375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+120384,int_stack+85677,int_stack+85527,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+105399,int_stack+86652,int_stack+86427,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+83700,int_stack+105399,int_stack+120384, 1.0, int_stack+122409, 1.0, int_stack+126729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+122409,int_stack+87282,int_stack+86967,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+85050,int_stack+122409,int_stack+105399, 1.0, int_stack+2700, 1.0, int_stack+3375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+2700,int_stack+88593,int_stack+88443,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+105399,int_stack+89568,int_stack+89343,15);
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+87075,int_stack+105399,int_stack+2700, 2.0, int_stack+126729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+126729,int_stack+90198,int_stack+89883,21);
 /*--- compute (gp|gp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+88425,int_stack+126729,int_stack+105399, 2.0, int_stack+3375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+196794,int_stack+94059,int_stack+91764,45);
     Libderiv->ABCD[11] = int_stack + 196794;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+93114,int_stack+99054,int_stack+96759,45);
     Libderiv->ABCD[10] = int_stack + 93114;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+98109,int_stack+103374,int_stack+101079,45);
     Libderiv->ABCD[9] = int_stack + 98109;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+102429,int_stack+108369,int_stack+106074,45);
     Libderiv->ABCD[8] = int_stack + 102429;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+107424,int_stack+112689,int_stack+110394,45);
     Libderiv->ABCD[7] = int_stack + 107424;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+111744,int_stack+117009,int_stack+114714,45);
     Libderiv->ABCD[6] = int_stack + 111744;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+116064,int_stack+123354,int_stack+121059, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[2] = int_stack + 116064;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+122409,int_stack+127674,int_stack+125379, 0.0, zero_stack, 1.0, int_stack+119034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[1] = int_stack + 122409;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+126729,int_stack+131994,int_stack+129699, 1.0, int_stack+119034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[0] = int_stack + 126729;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+131049,int_stack+134019,int_stack+4050,45);
     Libderiv->ABCD[155] = int_stack + 131049;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+2700,int_stack+136044,int_stack+5400,45);
     Libderiv->ABCD[143] = int_stack + 2700;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+133749,int_stack+138069,int_stack+6750,45);
     Libderiv->ABCD[142] = int_stack + 133749;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+5400,int_stack+140094,int_stack+8100,45);
     Libderiv->ABCD[131] = int_stack + 5400;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+136449,int_stack+10800,int_stack+9450,45);
     Libderiv->ABCD[130] = int_stack + 136449;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+8100,int_stack+143469,int_stack+142119,45);
     Libderiv->ABCD[129] = int_stack + 8100;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+139149,int_stack+145494,int_stack+12825,45);
     Libderiv->ABCD[119] = int_stack + 139149;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+10800,int_stack+15525,int_stack+14175,45);
     Libderiv->ABCD[118] = int_stack + 10800;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+13500,int_stack+148869,int_stack+147519,45);
     Libderiv->ABCD[117] = int_stack + 13500;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+141849,int_stack+18900,int_stack+17550,45);
     Libderiv->ABCD[116] = int_stack + 141849;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+16200,int_stack+152244,int_stack+150894,45);
     Libderiv->ABCD[107] = int_stack + 16200;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+144549,int_stack+22275,int_stack+20925,45);
     Libderiv->ABCD[106] = int_stack + 144549;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+18900,int_stack+155619,int_stack+154269,45);
     Libderiv->ABCD[105] = int_stack + 18900;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+21600,int_stack+25650,int_stack+24300,45);
     Libderiv->ABCD[104] = int_stack + 21600;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+24300,int_stack+158994,int_stack+157644,45);
     Libderiv->ABCD[103] = int_stack + 24300;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+147249,int_stack+29025,int_stack+27675,45);
     Libderiv->ABCD[95] = int_stack + 147249;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+27000,int_stack+31050,int_stack+161019,45);
     Libderiv->ABCD[94] = int_stack + 27000;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+29700,int_stack+33075,int_stack+162369,45);
     Libderiv->ABCD[93] = int_stack + 29700;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+32400,int_stack+35100,int_stack+163719,45);
     Libderiv->ABCD[92] = int_stack + 32400;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+149949,int_stack+37125,int_stack+165069,45);
     Libderiv->ABCD[91] = int_stack + 149949;
 /*--- compute (fd|gp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+35100,int_stack+39150,int_stack+166419,45);
     Libderiv->ABCD[90] = int_stack + 35100;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+37800,int_stack+169119,int_stack+167769, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[47] = int_stack + 37800;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+152649,int_stack+42525,int_stack+41175, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[46] = int_stack + 152649;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+40500,int_stack+172494,int_stack+171144, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+101079, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[45] = int_stack + 40500;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+155349,int_stack+174519,int_stack+44550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[44] = int_stack + 155349;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+43200,int_stack+47250,int_stack+45900, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[43] = int_stack + 43200;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+45900,int_stack+49275,int_stack+176544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[42] = int_stack + 45900;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+48600,int_stack+179244,int_stack+177894, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+121059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[38] = int_stack + 48600;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+158049,int_stack+52650,int_stack+51300, 0.0, zero_stack, 1.0, int_stack+91764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[35] = int_stack + 158049;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+51300,int_stack+182619,int_stack+181269, 0.0, zero_stack, 1.0, int_stack+96759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[34] = int_stack + 51300;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+160749,int_stack+56025,int_stack+54675, 0.0, zero_stack, 1.0, int_stack+101079, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[33] = int_stack + 160749;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+54000,int_stack+185994,int_stack+184644, 0.0, zero_stack, 1.0, int_stack+106074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[32] = int_stack + 54000;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+163449,int_stack+59400,int_stack+58050, 0.0, zero_stack, 1.0, int_stack+110394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[31] = int_stack + 163449;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+56700,int_stack+189369,int_stack+188019, 0.0, zero_stack, 1.0, int_stack+114714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[30] = int_stack + 56700;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+166149,int_stack+62775,int_stack+61425, 0.0, zero_stack, 1.0, int_stack+121059, 1.0, int_stack+125379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[26] = int_stack + 166149;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+59400,int_stack+64800,int_stack+191394, 0.0, zero_stack, 2.0, int_stack+125379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[25] = int_stack + 59400;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+62100,int_stack+192744,int_stack+66825, 1.0, int_stack+91764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[23] = int_stack + 62100;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+64800,int_stack+69525,int_stack+68175, 1.0, int_stack+96759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[22] = int_stack + 64800;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+67500,int_stack+194769,int_stack+71550, 1.0, int_stack+101079, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[21] = int_stack + 67500;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+70200,int_stack+74250,int_stack+72900, 1.0, int_stack+106074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[20] = int_stack + 70200;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+72900,int_stack+77625,int_stack+76275, 1.0, int_stack+110394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[19] = int_stack + 72900;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+75600,int_stack+79650,int_stack+0, 1.0, int_stack+114714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[18] = int_stack + 75600;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+78300,int_stack+81675,int_stack+1350, 1.0, int_stack+121059, 0.0, zero_stack, 1.0, int_stack+129699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[14] = int_stack + 78300;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+0,int_stack+85050,int_stack+83700, 1.0, int_stack+125379, 1.0, int_stack+129699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[13] = int_stack + 0;
 /*--- compute (fd|gp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+81000,int_stack+88425,int_stack+87075, 2.0, int_stack+129699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[12] = int_stack + 81000;

}
