/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_h0gp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (h0|gp) integrals */

void d12hrr_order_h0gp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][5][11] = int_stack + 0;
 Libderiv->deriv_classes[5][5][10] = int_stack + 441;
 Libderiv->deriv_classes[5][5][9] = int_stack + 882;
 Libderiv->deriv_classes[5][5][8] = int_stack + 1323;
 Libderiv->deriv_classes[5][5][7] = int_stack + 1764;
 Libderiv->dvrr_classes[5][4] = int_stack + 2205;
 Libderiv->deriv_classes[5][5][6] = int_stack + 2520;
 Libderiv->deriv_classes[5][5][2] = int_stack + 2961;
 Libderiv->deriv_classes[5][5][1] = int_stack + 3402;
 Libderiv->deriv_classes[5][5][0] = int_stack + 3843;
 Libderiv->deriv2_classes[5][4][143] = int_stack + 4284;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 4599;
 Libderiv->deriv2_classes[5][4][131] = int_stack + 5040;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 5355;
 Libderiv->deriv2_classes[5][4][130] = int_stack + 5796;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 6111;
 Libderiv->deriv2_classes[5][4][119] = int_stack + 6552;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 6867;
 Libderiv->deriv2_classes[5][4][118] = int_stack + 7308;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 7623;
 Libderiv->deriv2_classes[5][4][117] = int_stack + 8064;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 8379;
 Libderiv->deriv2_classes[5][4][107] = int_stack + 8820;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 9135;
 Libderiv->deriv2_classes[5][4][106] = int_stack + 9576;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 9891;
 Libderiv->deriv2_classes[5][4][105] = int_stack + 10332;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 10647;
 Libderiv->deriv2_classes[5][4][104] = int_stack + 11088;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 11403;
 Libderiv->deriv2_classes[5][4][95] = int_stack + 11844;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 12159;
 Libderiv->deriv2_classes[5][4][94] = int_stack + 12600;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 12915;
 Libderiv->deriv2_classes[5][4][93] = int_stack + 13356;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 13671;
 Libderiv->deriv2_classes[5][4][92] = int_stack + 14112;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 14427;
 Libderiv->deriv2_classes[5][4][91] = int_stack + 14868;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 15183;
 Libderiv->deriv_classes[5][4][11] = int_stack + 15624;
 Libderiv->deriv2_classes[5][4][83] = int_stack + 15939;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 16254;
 Libderiv->deriv_classes[5][4][10] = int_stack + 16695;
 Libderiv->deriv2_classes[5][4][82] = int_stack + 17010;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 17325;
 Libderiv->deriv_classes[5][4][9] = int_stack + 17766;
 Libderiv->deriv2_classes[5][4][81] = int_stack + 18081;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 18396;
 Libderiv->deriv_classes[5][4][8] = int_stack + 18837;
 Libderiv->deriv2_classes[5][4][80] = int_stack + 19152;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 19467;
 Libderiv->deriv_classes[5][4][7] = int_stack + 19908;
 Libderiv->deriv2_classes[5][4][79] = int_stack + 20223;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 20538;
 Libderiv->deriv_classes[5][4][6] = int_stack + 20979;
 Libderiv->deriv2_classes[5][4][78] = int_stack + 21294;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 21609;
 Libderiv->deriv2_classes[5][4][35] = int_stack + 22050;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 22365;
 Libderiv->deriv2_classes[5][4][34] = int_stack + 22806;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 23121;
 Libderiv->deriv2_classes[5][4][33] = int_stack + 23562;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 23877;
 Libderiv->deriv2_classes[5][4][32] = int_stack + 24318;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 24633;
 Libderiv->deriv2_classes[5][4][31] = int_stack + 25074;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 25389;
 Libderiv->deriv_classes[5][4][2] = int_stack + 25830;
 Libderiv->deriv2_classes[5][4][30] = int_stack + 26145;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 26460;
 Libderiv->deriv2_classes[5][4][26] = int_stack + 26901;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 27216;
 Libderiv->deriv2_classes[5][4][23] = int_stack + 27657;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 27972;
 Libderiv->deriv2_classes[5][4][22] = int_stack + 28413;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 28728;
 Libderiv->deriv2_classes[5][4][21] = int_stack + 29169;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 29484;
 Libderiv->deriv2_classes[5][4][20] = int_stack + 29925;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 30240;
 Libderiv->deriv2_classes[5][4][19] = int_stack + 30681;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 30996;
 Libderiv->deriv_classes[5][4][1] = int_stack + 31437;
 Libderiv->deriv2_classes[5][4][18] = int_stack + 31752;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 32067;
 Libderiv->deriv2_classes[5][4][14] = int_stack + 32508;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 32823;
 Libderiv->deriv2_classes[5][4][13] = int_stack + 33264;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 33579;
 Libderiv->deriv2_classes[5][4][11] = int_stack + 34020;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 34335;
 Libderiv->deriv2_classes[5][4][10] = int_stack + 34776;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 35091;
 Libderiv->deriv2_classes[5][4][9] = int_stack + 35532;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 35847;
 Libderiv->deriv2_classes[5][4][8] = int_stack + 36288;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 36603;
 Libderiv->deriv2_classes[5][4][7] = int_stack + 37044;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 37359;
 Libderiv->deriv_classes[5][4][0] = int_stack + 37800;
 Libderiv->deriv2_classes[5][4][6] = int_stack + 38115;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 38430;
 Libderiv->deriv2_classes[5][4][2] = int_stack + 38871;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 39186;
 Libderiv->deriv2_classes[5][4][1] = int_stack + 39627;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 39942;
 Libderiv->deriv2_classes[5][4][0] = int_stack + 40383;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 40698;
 memset(int_stack,0,329112);

 Libderiv->dvrr_stack = int_stack + 52479;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_h0gp(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41139,int_stack+0,int_stack+15624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205,21);
     Libderiv->ABCD[11] = int_stack + 41139;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42084,int_stack+441,int_stack+16695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205, 0.0, zero_stack,21);
     Libderiv->ABCD[10] = int_stack + 42084;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+43029,int_stack+882,int_stack+17766, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[9] = int_stack + 43029;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+1323,int_stack+18837, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+43974,int_stack+1764,int_stack+19908, 0.0, zero_stack, 1.0, int_stack+2205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[7] = int_stack + 43974;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+945,int_stack+2520,int_stack+20979, 1.0, int_stack+2205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[6] = int_stack + 945;
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1890,int_stack+2961,int_stack+25830,21);
     Libderiv->ABCD[2] = int_stack + 1890;
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+44919,int_stack+3402,int_stack+31437,21);
     Libderiv->ABCD[1] = int_stack + 44919;
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+2835,int_stack+3843,int_stack+37800,21);
     Libderiv->ABCD[0] = int_stack + 2835;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+45864,int_stack+4599,int_stack+4284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+15624,21);
     Libderiv->ABCD[155] = int_stack + 45864;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3780,int_stack+5355,int_stack+5040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15624, 1.0, int_stack+16695,21);
     Libderiv->ABCD[143] = int_stack + 3780;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4725,int_stack+6111,int_stack+5796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+16695, 0.0, zero_stack,21);
     Libderiv->ABCD[142] = int_stack + 4725;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+46809,int_stack+6867,int_stack+6552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15624, 0.0, zero_stack, 1.0, int_stack+17766,21);
     Libderiv->ABCD[131] = int_stack + 46809;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5670,int_stack+7623,int_stack+7308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16695, 1.0, int_stack+17766, 0.0, zero_stack,21);
     Libderiv->ABCD[130] = int_stack + 5670;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6615,int_stack+8379,int_stack+8064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17766, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[129] = int_stack + 6615;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7560,int_stack+9135,int_stack+8820, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15624, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18837,21);
     Libderiv->ABCD[119] = int_stack + 7560;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8505,int_stack+9891,int_stack+9576, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16695, 0.0, zero_stack, 1.0, int_stack+18837, 0.0, zero_stack,21);
     Libderiv->ABCD[118] = int_stack + 8505;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+47754,int_stack+10647,int_stack+10332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17766, 1.0, int_stack+18837, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[117] = int_stack + 47754;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9450,int_stack+11403,int_stack+11088, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+18837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[116] = int_stack + 9450;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+10395,int_stack+12159,int_stack+11844, 0.0, zero_stack, 1.0, int_stack+15624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19908,21);
     Libderiv->ABCD[107] = int_stack + 10395;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+11340,int_stack+12915,int_stack+12600, 0.0, zero_stack, 1.0, int_stack+16695, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19908, 0.0, zero_stack,21);
     Libderiv->ABCD[106] = int_stack + 11340;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12285,int_stack+13671,int_stack+13356, 0.0, zero_stack, 1.0, int_stack+17766, 0.0, zero_stack, 1.0, int_stack+19908, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[105] = int_stack + 12285;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+48699,int_stack+14427,int_stack+14112, 0.0, zero_stack, 1.0, int_stack+18837, 1.0, int_stack+19908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[104] = int_stack + 48699;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13230,int_stack+15183,int_stack+14868, 0.0, zero_stack, 2.0, int_stack+19908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[103] = int_stack + 13230;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14175,int_stack+16254,int_stack+15939, 1.0, int_stack+15624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20979,21);
     Libderiv->ABCD[95] = int_stack + 14175;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15120,int_stack+17325,int_stack+17010, 1.0, int_stack+16695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20979, 0.0, zero_stack,21);
     Libderiv->ABCD[94] = int_stack + 15120;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+16065,int_stack+18396,int_stack+18081, 1.0, int_stack+17766, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20979, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[93] = int_stack + 16065;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+17010,int_stack+19467,int_stack+19152, 1.0, int_stack+18837, 0.0, zero_stack, 1.0, int_stack+20979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[92] = int_stack + 17010;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+17955,int_stack+20538,int_stack+20223, 1.0, int_stack+19908, 1.0, int_stack+20979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[91] = int_stack + 17955;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+18900,int_stack+21609,int_stack+21294, 2.0, int_stack+20979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[90] = int_stack + 18900;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+19845,int_stack+22365,int_stack+22050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25830,21);
     Libderiv->ABCD[47] = int_stack + 19845;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+20790,int_stack+23121,int_stack+22806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25830, 0.0, zero_stack,21);
     Libderiv->ABCD[46] = int_stack + 20790;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21735,int_stack+23877,int_stack+23562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25830, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[45] = int_stack + 21735;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+22680,int_stack+24633,int_stack+24318, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[44] = int_stack + 22680;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+23625,int_stack+25389,int_stack+25074, 0.0, zero_stack, 1.0, int_stack+25830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[43] = int_stack + 23625;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+24570,int_stack+26460,int_stack+26145, 1.0, int_stack+25830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[42] = int_stack + 24570;
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+25515,int_stack+27216,int_stack+26901,21);
     Libderiv->ABCD[38] = int_stack + 25515;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26460,int_stack+27972,int_stack+27657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31437,21);
     Libderiv->ABCD[35] = int_stack + 26460;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+27405,int_stack+28728,int_stack+28413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31437, 0.0, zero_stack,21);
     Libderiv->ABCD[34] = int_stack + 27405;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+49644,int_stack+29484,int_stack+29169, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31437, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[33] = int_stack + 49644;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+28350,int_stack+30240,int_stack+29925, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[32] = int_stack + 28350;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+29295,int_stack+30996,int_stack+30681, 0.0, zero_stack, 1.0, int_stack+31437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[31] = int_stack + 29295;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+30240,int_stack+32067,int_stack+31752, 1.0, int_stack+31437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[30] = int_stack + 30240;
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+31185,int_stack+32823,int_stack+32508,21);
     Libderiv->ABCD[26] = int_stack + 31185;
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+32130,int_stack+33579,int_stack+33264,21);
     Libderiv->ABCD[25] = int_stack + 32130;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+33075,int_stack+34335,int_stack+34020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37800,21);
     Libderiv->ABCD[23] = int_stack + 33075;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+50589,int_stack+35091,int_stack+34776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37800, 0.0, zero_stack,21);
     Libderiv->ABCD[22] = int_stack + 50589;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+34020,int_stack+35847,int_stack+35532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37800, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[21] = int_stack + 34020;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+34965,int_stack+36603,int_stack+36288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[20] = int_stack + 34965;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+35910,int_stack+37359,int_stack+37044, 0.0, zero_stack, 1.0, int_stack+37800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[19] = int_stack + 35910;
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+36855,int_stack+38430,int_stack+38115, 1.0, int_stack+37800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[18] = int_stack + 36855;
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+37800,int_stack+39186,int_stack+38871,21);
     Libderiv->ABCD[14] = int_stack + 37800;
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+51534,int_stack+39942,int_stack+39627,21);
     Libderiv->ABCD[13] = int_stack + 51534;
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+38745,int_stack+40698,int_stack+40383,21);
     Libderiv->ABCD[12] = int_stack + 38745;

}
