/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_ffi0(Libderiv_t *, prim_data *);

  /* Computes derivatives of (ff|i0) integrals */

void d1hrr_order_ffi0(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[3][6][11] = int_stack + 0;
 Libderiv->deriv_classes[4][6][11] = int_stack + 280;
 Libderiv->deriv_classes[5][6][11] = int_stack + 700;
 Libderiv->deriv_classes[6][6][11] = int_stack + 1288;
 Libderiv->deriv_classes[3][6][10] = int_stack + 2072;
 Libderiv->deriv_classes[4][6][10] = int_stack + 2352;
 Libderiv->deriv_classes[5][6][10] = int_stack + 2772;
 Libderiv->deriv_classes[6][6][10] = int_stack + 3360;
 Libderiv->deriv_classes[3][6][9] = int_stack + 4144;
 Libderiv->deriv_classes[4][6][9] = int_stack + 4424;
 Libderiv->deriv_classes[5][6][9] = int_stack + 4844;
 Libderiv->deriv_classes[6][6][9] = int_stack + 5432;
 Libderiv->deriv_classes[3][6][8] = int_stack + 6216;
 Libderiv->deriv_classes[4][6][8] = int_stack + 6496;
 Libderiv->deriv_classes[5][6][8] = int_stack + 6916;
 Libderiv->deriv_classes[6][6][8] = int_stack + 7504;
 Libderiv->deriv_classes[3][6][7] = int_stack + 8288;
 Libderiv->deriv_classes[4][6][7] = int_stack + 8568;
 Libderiv->deriv_classes[5][6][7] = int_stack + 8988;
 Libderiv->deriv_classes[6][6][7] = int_stack + 9576;
 Libderiv->deriv_classes[3][6][6] = int_stack + 10360;
 Libderiv->deriv_classes[4][6][6] = int_stack + 10640;
 Libderiv->deriv_classes[5][6][6] = int_stack + 11060;
 Libderiv->deriv_classes[6][6][6] = int_stack + 11648;
 Libderiv->deriv_classes[3][6][2] = int_stack + 12432;
 Libderiv->deriv_classes[4][6][2] = int_stack + 12712;
 Libderiv->deriv_classes[5][6][2] = int_stack + 13132;
 Libderiv->deriv_classes[6][6][2] = int_stack + 13720;
 Libderiv->deriv_classes[3][6][1] = int_stack + 14504;
 Libderiv->deriv_classes[4][6][1] = int_stack + 14784;
 Libderiv->deriv_classes[5][6][1] = int_stack + 15204;
 Libderiv->deriv_classes[6][6][1] = int_stack + 15792;
 Libderiv->dvrr_classes[3][6] = int_stack + 16576;
 Libderiv->deriv_classes[3][6][0] = int_stack + 16856;
 Libderiv->dvrr_classes[4][6] = int_stack + 17136;
 Libderiv->deriv_classes[4][6][0] = int_stack + 17556;
 Libderiv->dvrr_classes[5][6] = int_stack + 17976;
 Libderiv->deriv_classes[5][6][0] = int_stack + 18564;
 Libderiv->deriv_classes[6][6][0] = int_stack + 19152;
 memset(int_stack,0,159488);

 Libderiv->dvrr_stack = int_stack + 50484;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_ffi0(Libderiv, Data);
   Data++;
 }

 /*--- compute (fp|i0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+19936,int_stack+280,int_stack+0,28);
 /*--- compute (gp|i0) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+20776,int_stack+700,int_stack+280,28);
 /*--- compute (fd|i0) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+22036,int_stack+20776,int_stack+19936,28);
 /*--- compute (hp|i0) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+23716,int_stack+1288,int_stack+700,28);
 /*--- compute (gd|i0) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+25480,int_stack+23716,int_stack+20776,28);
 /*--- compute (fp|i0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+23716,int_stack+2352,int_stack+2072,28);
 /*--- compute (gp|i0) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+19936,int_stack+2772,int_stack+2352,28);
 /*--- compute (fd|i0) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+0,int_stack+19936,int_stack+23716,28);
 /*--- compute (hp|i0) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+23716,int_stack+3360,int_stack+2772,28);
 /*--- compute (gd|i0) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+28000,int_stack+23716,int_stack+19936,28);
 /*--- compute (fp|i0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+19936,int_stack+4424,int_stack+4144,28);
 /*--- compute (gp|i0) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+20776,int_stack+4844,int_stack+4424,28);
 /*--- compute (fd|i0) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+23716,int_stack+20776,int_stack+19936,28);
 /*--- compute (hp|i0) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1680,int_stack+5432,int_stack+4844,28);
 /*--- compute (gd|i0) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+3444,int_stack+1680,int_stack+20776,28);
 /*--- compute (fp|i0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1680,int_stack+6496,int_stack+6216,28);
 /*--- compute (gp|i0) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+19936,int_stack+6916,int_stack+6496,28);
 /*--- compute (fd|i0) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+30520,int_stack+19936,int_stack+1680,28);
 /*--- compute (hp|i0) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1680,int_stack+7504,int_stack+6916,28);
 /*--- compute (gd|i0) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+32200,int_stack+1680,int_stack+19936,28);
 /*--- compute (fp|i0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+19936,int_stack+8568,int_stack+8288,28);
 /*--- compute (gp|i0) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+20776,int_stack+8988,int_stack+8568,28);
 /*--- compute (fd|i0) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1680,int_stack+20776,int_stack+19936,28);
 /*--- compute (hp|i0) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+5964,int_stack+9576,int_stack+8988,28);
 /*--- compute (gd|i0) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+7728,int_stack+5964,int_stack+20776,28);
 /*--- compute (fp|i0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+5964,int_stack+10640,int_stack+10360,28);
 /*--- compute (gp|i0) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+19936,int_stack+11060,int_stack+10640,28);
 /*--- compute (fd|i0) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+34720,int_stack+19936,int_stack+5964,28);
 /*--- compute (hp|i0) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+5964,int_stack+11648,int_stack+11060,28);
 /*--- compute (gd|i0) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+36400,int_stack+5964,int_stack+19936,28);
 /*--- compute (fp|i0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+19936,int_stack+17136,int_stack+16576,28);
 /*--- compute (gp|i0) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+20776,int_stack+17976,int_stack+17136,28);
 /*--- compute (fd|i0) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+5964,int_stack+20776,int_stack+19936,28);
 /*--- compute (fp|i0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+10248,int_stack+12712,int_stack+12432, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (gp|i0) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+11088,int_stack+13132,int_stack+12712, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (fd|i0) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+38920,int_stack+11088,int_stack+10248, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|i0) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+40600,int_stack+13720,int_stack+13132, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (gd|i0) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+42364,int_stack+40600,int_stack+11088, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (fp|i0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+40600,int_stack+14784,int_stack+14504, 0.0, zero_stack, 1.0, int_stack+16576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (gp|i0) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+10248,int_stack+15204,int_stack+14784, 0.0, zero_stack, 1.0, int_stack+17136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (fd|i0) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+11508,int_stack+10248,int_stack+40600, 0.0, zero_stack, 1.0, int_stack+19936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|i0) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+40600,int_stack+15792,int_stack+15204, 0.0, zero_stack, 1.0, int_stack+17976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (gd|i0) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+13188,int_stack+40600,int_stack+10248, 0.0, zero_stack, 1.0, int_stack+20776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (fp|i0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+10248,int_stack+17556,int_stack+16856, 1.0, int_stack+16576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (gp|i0) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+40600,int_stack+18564,int_stack+17556, 1.0, int_stack+17136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (fd|i0) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+15708,int_stack+40600,int_stack+10248, 1.0, int_stack+19936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|i0) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+44884,int_stack+19152,int_stack+18564, 1.0, int_stack+17976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (gd|i0) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+17388,int_stack+44884,int_stack+40600, 1.0, int_stack+20776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (ff|i0) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+44884,int_stack+25480,int_stack+22036,28);
     Libderiv->ABCD[11] = int_stack + 44884;
 /*--- compute (ff|i0) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+19908,int_stack+28000,int_stack+0,28);
     Libderiv->ABCD[10] = int_stack + 19908;
 /*--- compute (ff|i0) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+25396,int_stack+3444,int_stack+23716,28);
     Libderiv->ABCD[9] = int_stack + 25396;
 /*--- compute (ff|i0) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+47684,int_stack+32200,int_stack+30520,28);
     Libderiv->ABCD[8] = int_stack + 47684;
 /*--- compute (ff|i0) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+28196,int_stack+7728,int_stack+1680,28);
     Libderiv->ABCD[7] = int_stack + 28196;
 /*--- compute (ff|i0) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+0,int_stack+36400,int_stack+34720,28);
     Libderiv->ABCD[6] = int_stack + 0;
 /*--- compute (ff|i0) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+2800,int_stack+42364,int_stack+38920, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[2] = int_stack + 2800;
 /*--- compute (ff|i0) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+7644,int_stack+13188,int_stack+11508, 0.0, zero_stack, 1.0, int_stack+5964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[1] = int_stack + 7644;
 /*--- compute (ff|i0) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+10444,int_stack+17388,int_stack+15708, 1.0, int_stack+5964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[0] = int_stack + 10444;

}
