/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_h0gg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (h0|gg) integrals */

void d1hrr_order_h0gg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][4][11] = int_stack + 0;
 Libderiv->deriv_classes[5][5][11] = int_stack + 315;
 Libderiv->deriv_classes[5][6][11] = int_stack + 756;
 Libderiv->deriv_classes[5][7][11] = int_stack + 1344;
 Libderiv->deriv_classes[5][8][11] = int_stack + 2100;
 Libderiv->deriv_classes[5][4][10] = int_stack + 3045;
 Libderiv->deriv_classes[5][5][10] = int_stack + 3360;
 Libderiv->deriv_classes[5][6][10] = int_stack + 3801;
 Libderiv->deriv_classes[5][7][10] = int_stack + 4389;
 Libderiv->deriv_classes[5][8][10] = int_stack + 5145;
 Libderiv->deriv_classes[5][4][9] = int_stack + 6090;
 Libderiv->deriv_classes[5][5][9] = int_stack + 6405;
 Libderiv->deriv_classes[5][6][9] = int_stack + 6846;
 Libderiv->deriv_classes[5][7][9] = int_stack + 7434;
 Libderiv->deriv_classes[5][8][9] = int_stack + 8190;
 Libderiv->deriv_classes[5][4][8] = int_stack + 9135;
 Libderiv->deriv_classes[5][5][8] = int_stack + 9450;
 Libderiv->deriv_classes[5][6][8] = int_stack + 9891;
 Libderiv->deriv_classes[5][7][8] = int_stack + 10479;
 Libderiv->deriv_classes[5][8][8] = int_stack + 11235;
 Libderiv->deriv_classes[5][4][7] = int_stack + 12180;
 Libderiv->deriv_classes[5][5][7] = int_stack + 12495;
 Libderiv->deriv_classes[5][6][7] = int_stack + 12936;
 Libderiv->deriv_classes[5][7][7] = int_stack + 13524;
 Libderiv->deriv_classes[5][8][7] = int_stack + 14280;
 Libderiv->dvrr_classes[5][4] = int_stack + 15225;
 Libderiv->deriv_classes[5][4][6] = int_stack + 15540;
 Libderiv->dvrr_classes[5][5] = int_stack + 15855;
 Libderiv->deriv_classes[5][5][6] = int_stack + 16296;
 Libderiv->dvrr_classes[5][6] = int_stack + 16737;
 Libderiv->deriv_classes[5][6][6] = int_stack + 17325;
 Libderiv->dvrr_classes[5][7] = int_stack + 17913;
 Libderiv->deriv_classes[5][7][6] = int_stack + 18669;
 Libderiv->deriv_classes[5][8][6] = int_stack + 19425;
 Libderiv->deriv_classes[5][4][2] = int_stack + 20370;
 Libderiv->deriv_classes[5][5][2] = int_stack + 20685;
 Libderiv->deriv_classes[5][6][2] = int_stack + 21126;
 Libderiv->deriv_classes[5][7][2] = int_stack + 21714;
 Libderiv->deriv_classes[5][8][2] = int_stack + 22470;
 Libderiv->deriv_classes[5][4][1] = int_stack + 23415;
 Libderiv->deriv_classes[5][5][1] = int_stack + 23730;
 Libderiv->deriv_classes[5][6][1] = int_stack + 24171;
 Libderiv->deriv_classes[5][7][1] = int_stack + 24759;
 Libderiv->deriv_classes[5][8][1] = int_stack + 25515;
 Libderiv->deriv_classes[5][4][0] = int_stack + 26460;
 Libderiv->deriv_classes[5][5][0] = int_stack + 26775;
 Libderiv->deriv_classes[5][6][0] = int_stack + 27216;
 Libderiv->deriv_classes[5][7][0] = int_stack + 27804;
 Libderiv->deriv_classes[5][8][0] = int_stack + 28560;
 memset(int_stack,0,236040);

 Libderiv->dvrr_stack = int_stack + 92694;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_h0gg(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+29505,int_stack+15855,int_stack+15225,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+30450,int_stack+16737,int_stack+15855,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+31773,int_stack+30450,int_stack+29505,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+33663,int_stack+17913,int_stack+16737,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+35427,int_stack+33663,int_stack+30450,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+38073,int_stack+35427,int_stack+31773,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41223,int_stack+315,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15225,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+42168,int_stack+756,int_stack+315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15855,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+43491,int_stack+42168,int_stack+41223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29505,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+45381,int_stack+1344,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16737,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+47145,int_stack+45381,int_stack+42168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30450,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+49791,int_stack+47145,int_stack+43491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31773,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+41223,int_stack+2100,int_stack+1344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17913,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+52941,int_stack+41223,int_stack+45381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33663,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+41223,int_stack+52941,int_stack+47145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35427,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+52941,int_stack+3360,int_stack+3045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15225, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+53886,int_stack+3801,int_stack+3360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15855, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+45633,int_stack+53886,int_stack+52941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29505, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+55209,int_stack+4389,int_stack+3801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16737, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+55209,int_stack+53886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30450, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+56973,int_stack+0,int_stack+45633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31773, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+52941,int_stack+5145,int_stack+4389, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17913, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+45633,int_stack+52941,int_stack+55209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33663, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+60123,int_stack+45633,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35427, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+6405,int_stack+6090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15225, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+945,int_stack+6846,int_stack+6405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15855, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2268,int_stack+945,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29505, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4158,int_stack+7434,int_stack+6846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16737, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+45633,int_stack+4158,int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30450, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+52941,int_stack+45633,int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31773, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+8190,int_stack+7434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17913, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+64533,int_stack+0,int_stack+4158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33663, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+64533,int_stack+45633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35427, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+45633,int_stack+9450,int_stack+9135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+46578,int_stack+9891,int_stack+9450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+47901,int_stack+46578,int_stack+45633, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+64533,int_stack+10479,int_stack+9891, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+66297,int_stack+64533,int_stack+46578, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+4410,int_stack+66297,int_stack+47901, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+45633,int_stack+11235,int_stack+10479, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7560,int_stack+45633,int_stack+64533, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+68943,int_stack+7560,int_stack+66297, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7560,int_stack+12495,int_stack+12180, 0.0, zero_stack, 1.0, int_stack+15225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8505,int_stack+12936,int_stack+12495, 0.0, zero_stack, 1.0, int_stack+15855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+9828,int_stack+8505,int_stack+7560, 0.0, zero_stack, 1.0, int_stack+29505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+64533,int_stack+13524,int_stack+12936, 0.0, zero_stack, 1.0, int_stack+16737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+66297,int_stack+64533,int_stack+8505, 0.0, zero_stack, 1.0, int_stack+30450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+45633,int_stack+66297,int_stack+9828, 0.0, zero_stack, 1.0, int_stack+31773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7560,int_stack+14280,int_stack+13524, 0.0, zero_stack, 1.0, int_stack+17913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9828,int_stack+7560,int_stack+64533, 0.0, zero_stack, 1.0, int_stack+33663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+73353,int_stack+9828,int_stack+66297, 0.0, zero_stack, 1.0, int_stack+35427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+64533,int_stack+16296,int_stack+15540, 1.0, int_stack+15225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+65478,int_stack+17325,int_stack+16296, 1.0, int_stack+15855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+66801,int_stack+65478,int_stack+64533, 1.0, int_stack+29505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7560,int_stack+18669,int_stack+17325, 1.0, int_stack+16737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9324,int_stack+7560,int_stack+65478, 1.0, int_stack+30450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+11970,int_stack+9324,int_stack+66801, 1.0, int_stack+31773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+29505,int_stack+19425,int_stack+18669, 1.0, int_stack+17913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+64533,int_stack+29505,int_stack+7560, 1.0, int_stack+33663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+29505,int_stack+64533,int_stack+9324, 1.0, int_stack+35427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+64533,int_stack+20685,int_stack+20370,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+65478,int_stack+21126,int_stack+20685,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+66801,int_stack+65478,int_stack+64533,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7560,int_stack+21714,int_stack+21126,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+9324,int_stack+7560,int_stack+65478,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+33915,int_stack+9324,int_stack+66801,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+64533,int_stack+22470,int_stack+21714,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+15120,int_stack+64533,int_stack+7560,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+64533,int_stack+15120,int_stack+9324,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+15120,int_stack+23730,int_stack+23415,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+16065,int_stack+24171,int_stack+23730,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+17388,int_stack+16065,int_stack+15120,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+19278,int_stack+24759,int_stack+24171,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+21042,int_stack+19278,int_stack+16065,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+7560,int_stack+21042,int_stack+17388,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+15120,int_stack+25515,int_stack+24759,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+77763,int_stack+15120,int_stack+19278,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+15120,int_stack+77763,int_stack+21042,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+77763,int_stack+26775,int_stack+26460,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+78708,int_stack+27216,int_stack+26775,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+80031,int_stack+78708,int_stack+77763,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+19530,int_stack+27804,int_stack+27216,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+21294,int_stack+19530,int_stack+78708,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+23940,int_stack+21294,int_stack+80031,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+77763,int_stack+28560,int_stack+27804,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+80031,int_stack+77763,int_stack+19530,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+83559,int_stack+80031,int_stack+21294,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+77763,int_stack+41223,int_stack+49791, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38073,21);
     Libderiv->ABCD[11] = int_stack + 77763;
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+87969,int_stack+60123,int_stack+56973, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38073, 0.0, zero_stack,21);
     Libderiv->ABCD[10] = int_stack + 87969;
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+56091,int_stack+0,int_stack+52941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38073, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[9] = int_stack + 56091;
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+48783,int_stack+68943,int_stack+4410, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[8] = int_stack + 48783;
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+73353,int_stack+45633, 0.0, zero_stack, 1.0, int_stack+38073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[7] = int_stack + 0;
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+68943,int_stack+29505,int_stack+11970, 1.0, int_stack+38073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[6] = int_stack + 68943;
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+27090,int_stack+64533,int_stack+33915,21);
     Libderiv->ABCD[2] = int_stack + 27090;
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+31815,int_stack+15120,int_stack+7560,21);
     Libderiv->ABCD[1] = int_stack + 31815;
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+4725,int_stack+83559,int_stack+23940,21);
     Libderiv->ABCD[0] = int_stack + 4725;

}
