/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_p0hg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (p0|hg) integrals */

void d1hrr_order_p0hg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[1][5][11] = int_stack + 0;
 Libderiv->deriv_classes[1][6][11] = int_stack + 63;
 Libderiv->deriv_classes[1][7][11] = int_stack + 147;
 Libderiv->deriv_classes[1][8][11] = int_stack + 255;
 Libderiv->deriv_classes[1][9][11] = int_stack + 390;
 Libderiv->deriv_classes[1][5][10] = int_stack + 555;
 Libderiv->deriv_classes[1][6][10] = int_stack + 618;
 Libderiv->deriv_classes[1][7][10] = int_stack + 702;
 Libderiv->deriv_classes[1][8][10] = int_stack + 810;
 Libderiv->deriv_classes[1][9][10] = int_stack + 945;
 Libderiv->deriv_classes[1][5][9] = int_stack + 1110;
 Libderiv->deriv_classes[1][6][9] = int_stack + 1173;
 Libderiv->deriv_classes[1][7][9] = int_stack + 1257;
 Libderiv->deriv_classes[1][8][9] = int_stack + 1365;
 Libderiv->deriv_classes[1][9][9] = int_stack + 1500;
 Libderiv->deriv_classes[1][5][8] = int_stack + 1665;
 Libderiv->deriv_classes[1][6][8] = int_stack + 1728;
 Libderiv->deriv_classes[1][7][8] = int_stack + 1812;
 Libderiv->deriv_classes[1][8][8] = int_stack + 1920;
 Libderiv->deriv_classes[1][9][8] = int_stack + 2055;
 Libderiv->deriv_classes[1][5][7] = int_stack + 2220;
 Libderiv->deriv_classes[1][6][7] = int_stack + 2283;
 Libderiv->deriv_classes[1][7][7] = int_stack + 2367;
 Libderiv->deriv_classes[1][8][7] = int_stack + 2475;
 Libderiv->deriv_classes[1][9][7] = int_stack + 2610;
 Libderiv->dvrr_classes[1][5] = int_stack + 2775;
 Libderiv->deriv_classes[1][5][6] = int_stack + 2838;
 Libderiv->dvrr_classes[1][6] = int_stack + 2901;
 Libderiv->deriv_classes[1][6][6] = int_stack + 2985;
 Libderiv->dvrr_classes[1][7] = int_stack + 3069;
 Libderiv->deriv_classes[1][7][6] = int_stack + 3177;
 Libderiv->dvrr_classes[1][8] = int_stack + 3285;
 Libderiv->deriv_classes[1][8][6] = int_stack + 3420;
 Libderiv->deriv_classes[1][9][6] = int_stack + 3555;
 Libderiv->deriv_classes[1][5][2] = int_stack + 3720;
 Libderiv->deriv_classes[1][6][2] = int_stack + 3783;
 Libderiv->deriv_classes[1][7][2] = int_stack + 3867;
 Libderiv->deriv_classes[1][8][2] = int_stack + 3975;
 Libderiv->deriv_classes[1][9][2] = int_stack + 4110;
 Libderiv->deriv_classes[1][5][1] = int_stack + 4275;
 Libderiv->deriv_classes[1][6][1] = int_stack + 4338;
 Libderiv->deriv_classes[1][7][1] = int_stack + 4422;
 Libderiv->deriv_classes[1][8][1] = int_stack + 4530;
 Libderiv->deriv_classes[1][9][1] = int_stack + 4665;
 Libderiv->deriv_classes[1][5][0] = int_stack + 4830;
 Libderiv->deriv_classes[1][6][0] = int_stack + 4893;
 Libderiv->deriv_classes[1][7][0] = int_stack + 4977;
 Libderiv->deriv_classes[1][8][0] = int_stack + 5085;
 Libderiv->deriv_classes[1][9][0] = int_stack + 5220;
 memset(int_stack,0,43080);

 Libderiv->dvrr_stack = int_stack + 18321;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_p0hg(Libderiv, Data);
   Data++;
 }

 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5385,int_stack+2901,int_stack+2775,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5574,int_stack+3069,int_stack+2901,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5826,int_stack+5574,int_stack+5385,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6204,int_stack+3285,int_stack+3069,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6528,int_stack+6204,int_stack+5574,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+7032,int_stack+6528,int_stack+5826,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7662,int_stack+63,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2775,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7851,int_stack+147,int_stack+63, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2901,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8103,int_stack+7851,int_stack+7662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5385,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8481,int_stack+255,int_stack+147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3069,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8805,int_stack+8481,int_stack+7851, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5574,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9309,int_stack+8805,int_stack+8103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5826,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7662,int_stack+390,int_stack+255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3285,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+9939,int_stack+7662,int_stack+8481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6204,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7662,int_stack+9939,int_stack+8805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6528,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9939,int_stack+618,int_stack+555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2775, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10128,int_stack+702,int_stack+618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2901, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10380,int_stack+10128,int_stack+9939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5385, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8502,int_stack+810,int_stack+702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3069, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+8502,int_stack+10128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5574, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+10758,int_stack+0,int_stack+10380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5826, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9939,int_stack+945,int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3285, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+11388,int_stack+9939,int_stack+8502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6204, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+12036,int_stack+11388,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6528, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+1173,int_stack+1110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2775, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+189,int_stack+1257,int_stack+1173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2901, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+441,int_stack+189,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5385, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+819,int_stack+1365,int_stack+1257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3069, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+11388,int_stack+819,int_stack+189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5574, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+8502,int_stack+11388,int_stack+441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5826, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+1500,int_stack+1365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3285, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+9939,int_stack+0,int_stack+819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6204, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+9939,int_stack+11388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6528, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11388,int_stack+1728,int_stack+1665, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+11577,int_stack+1812,int_stack+1728, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9939,int_stack+11577,int_stack+11388, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10317,int_stack+1920,int_stack+1812, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+840,int_stack+10317,int_stack+11577, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+11388,int_stack+840,int_stack+9939, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1344,int_stack+2055,int_stack+1920, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+12876,int_stack+1344,int_stack+10317, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1344,int_stack+12876,int_stack+840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+840,int_stack+2283,int_stack+2220, 0.0, zero_stack, 1.0, int_stack+2775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1029,int_stack+2367,int_stack+2283, 0.0, zero_stack, 1.0, int_stack+2901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12876,int_stack+1029,int_stack+840, 0.0, zero_stack, 1.0, int_stack+5385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+13254,int_stack+2475,int_stack+2367, 0.0, zero_stack, 1.0, int_stack+3069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9939,int_stack+13254,int_stack+1029, 0.0, zero_stack, 1.0, int_stack+5574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13578,int_stack+9939,int_stack+12876, 0.0, zero_stack, 1.0, int_stack+5826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+840,int_stack+2610,int_stack+2475, 0.0, zero_stack, 1.0, int_stack+3285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+14208,int_stack+840,int_stack+13254, 0.0, zero_stack, 1.0, int_stack+6204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+14856,int_stack+14208,int_stack+9939, 0.0, zero_stack, 1.0, int_stack+6528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9939,int_stack+2985,int_stack+2838, 1.0, int_stack+2775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10128,int_stack+3177,int_stack+2985, 1.0, int_stack+2901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10380,int_stack+10128,int_stack+9939, 1.0, int_stack+5385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+14208,int_stack+3420,int_stack+3177, 1.0, int_stack+3069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+840,int_stack+14208,int_stack+10128, 1.0, int_stack+5574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12876,int_stack+840,int_stack+10380, 1.0, int_stack+5826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5385,int_stack+3555,int_stack+3420, 1.0, int_stack+3285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+9939,int_stack+5385,int_stack+14208, 1.0, int_stack+6204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+5385,int_stack+9939,int_stack+840, 1.0, int_stack+6528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+840,int_stack+3783,int_stack+3720,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1029,int_stack+3867,int_stack+3783,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+9939,int_stack+1029,int_stack+840,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+10317,int_stack+3975,int_stack+3867,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14208,int_stack+10317,int_stack+1029,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6225,int_stack+14208,int_stack+9939,3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+840,int_stack+4110,int_stack+3975,3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2184,int_stack+840,int_stack+10317,3);
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2832,int_stack+2184,int_stack+14208,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+14208,int_stack+4338,int_stack+4275,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+14397,int_stack+4422,int_stack+4338,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2184,int_stack+14397,int_stack+14208,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+840,int_stack+4530,int_stack+4422,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+9939,int_stack+840,int_stack+14397,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+14208,int_stack+9939,int_stack+2184,3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2184,int_stack+4665,int_stack+4530,3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3672,int_stack+2184,int_stack+840,3);
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+15696,int_stack+3672,int_stack+9939,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+9939,int_stack+4893,int_stack+4830,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+10128,int_stack+4977,int_stack+4893,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+10380,int_stack+10128,int_stack+9939,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3672,int_stack+5085,int_stack+4977,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+840,int_stack+3672,int_stack+10128,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+3996,int_stack+840,int_stack+10380,3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+9939,int_stack+5220,int_stack+5085,3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2184,int_stack+9939,int_stack+3672,3);
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+16536,int_stack+2184,int_stack+840,3);
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+17376,int_stack+7662,int_stack+9309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7032,3);
     Libderiv->ABCD[11] = int_stack + 17376;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+9132,int_stack+12036,int_stack+10758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7032, 0.0, zero_stack,3);
     Libderiv->ABCD[10] = int_stack + 9132;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+10077,int_stack+0,int_stack+8502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7032, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[9] = int_stack + 10077;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+0,int_stack+1344,int_stack+11388, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+945,int_stack+14856,int_stack+13578, 0.0, zero_stack, 1.0, int_stack+7032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[7] = int_stack + 945;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+7662,int_stack+5385,int_stack+12876, 1.0, int_stack+7032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[6] = int_stack + 7662;
 /*--- compute (p0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+4626,int_stack+2832,int_stack+6225,3);
     Libderiv->ABCD[2] = int_stack + 4626;
 /*--- compute (p0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1890,int_stack+15696,int_stack+14208,3);
     Libderiv->ABCD[1] = int_stack + 1890;
 /*--- compute (p0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2835,int_stack+16536,int_stack+3996,3);
     Libderiv->ABCD[0] = int_stack + 2835;

}
