/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_p0hp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (p0|hp) integrals */

void d1hrr_order_p0hp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[1][5][11] = int_stack + 0;
 Libderiv->deriv_classes[1][6][11] = int_stack + 63;
 Libderiv->deriv_classes[1][5][10] = int_stack + 147;
 Libderiv->deriv_classes[1][6][10] = int_stack + 210;
 Libderiv->deriv_classes[1][5][9] = int_stack + 294;
 Libderiv->deriv_classes[1][6][9] = int_stack + 357;
 Libderiv->deriv_classes[1][5][8] = int_stack + 441;
 Libderiv->deriv_classes[1][6][8] = int_stack + 504;
 Libderiv->deriv_classes[1][5][7] = int_stack + 588;
 Libderiv->deriv_classes[1][6][7] = int_stack + 651;
 Libderiv->dvrr_classes[1][5] = int_stack + 735;
 Libderiv->deriv_classes[1][5][6] = int_stack + 798;
 Libderiv->deriv_classes[1][6][6] = int_stack + 861;
 Libderiv->deriv_classes[1][5][2] = int_stack + 945;
 Libderiv->deriv_classes[1][6][2] = int_stack + 1008;
 Libderiv->deriv_classes[1][5][1] = int_stack + 1092;
 Libderiv->deriv_classes[1][6][1] = int_stack + 1155;
 Libderiv->deriv_classes[1][5][0] = int_stack + 1239;
 Libderiv->deriv_classes[1][6][0] = int_stack + 1302;
 memset(int_stack,0,11088);

 Libderiv->dvrr_stack = int_stack + 1953;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_p0hp(Libderiv, Data);
   Data++;
 }

 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1386,int_stack+63,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+735,3);
     Libderiv->ABCD[11] = int_stack + 1386;
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1575,int_stack+210,int_stack+147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+735, 0.0, zero_stack,3);
     Libderiv->ABCD[10] = int_stack + 1575;
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+357,int_stack+294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+735, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[9] = int_stack + 0;
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+189,int_stack+504,int_stack+441, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[8] = int_stack + 189;
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378,int_stack+651,int_stack+588, 0.0, zero_stack, 1.0, int_stack+735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[7] = int_stack + 378;
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1764,int_stack+861,int_stack+798, 1.0, int_stack+735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[6] = int_stack + 1764;
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+567,int_stack+1008,int_stack+945,3);
     Libderiv->ABCD[2] = int_stack + 567;
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+1155,int_stack+1092,3);
     Libderiv->ABCD[1] = int_stack + 756;
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+945,int_stack+1302,int_stack+1239,3);
     Libderiv->ABCD[0] = int_stack + 945;

}
