/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (0s|os) integrals */

#include "libint.h"

void _build_00o0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2n;
  REALTYPE twoo2n;
  REALTYPE threeo2n;
  REALTYPE fouro2n;
  REALTYPE fiveo2n;
  REALTYPE sixo2n;
  REALTYPE seveno2n;
  REALTYPE eighto2n;
  REALTYPE nineo2n;
  REALTYPE teno2n;
  oneo2n = 1.0*Data->oo2n;
  twoo2n = 2.0*Data->oo2n;
  threeo2n = 3.0*Data->oo2n;
  fouro2n = 4.0*Data->oo2n;
  fiveo2n = 5.0*Data->oo2n;
  sixo2n = 6.0*Data->oo2n;
  seveno2n = 7.0*Data->oo2n;
  eighto2n = 8.0*Data->oo2n;
  nineo2n = 9.0*Data->oo2n;
  teno2n = 10.0*Data->oo2n;
  U20 = Data->U[2][0];
  U21 = Data->U[2][1];
  U22 = Data->U[2][2];
  U50 = Data->U[5][0];
  U51 = Data->U[5][1];
  U52 = Data->U[5][2];


*(vp++) = U20*I0[0] + U50*I1[0]
           + (teno2n)*(I2[0] - (lpon)*I3[0]);
*(vp++) = U20*I0[1] + U50*I1[1]
           + (nineo2n)*(I2[1] - (lpon)*I3[1]);
*(vp++) = U20*I0[2] + U50*I1[2]
           + (nineo2n)*(I2[2] - (lpon)*I3[2]);
*(vp++) = U20*I0[3] + U50*I1[3]
           + (eighto2n)*(I2[3] - (lpon)*I3[3]);
*(vp++) = U20*I0[4] + U50*I1[4]
           + (eighto2n)*(I2[4] - (lpon)*I3[4]);
*(vp++) = U20*I0[5] + U50*I1[5]
           + (eighto2n)*(I2[5] - (lpon)*I3[5]);
*(vp++) = U20*I0[6] + U50*I1[6]
           + (seveno2n)*(I2[6] - (lpon)*I3[6]);
*(vp++) = U20*I0[7] + U50*I1[7]
           + (seveno2n)*(I2[7] - (lpon)*I3[7]);
*(vp++) = U20*I0[8] + U50*I1[8]
           + (seveno2n)*(I2[8] - (lpon)*I3[8]);
*(vp++) = U20*I0[9] + U50*I1[9]
           + (seveno2n)*(I2[9] - (lpon)*I3[9]);
*(vp++) = U20*I0[10] + U50*I1[10]
           + (sixo2n)*(I2[10] - (lpon)*I3[10]);
*(vp++) = U20*I0[11] + U50*I1[11]
           + (sixo2n)*(I2[11] - (lpon)*I3[11]);
*(vp++) = U20*I0[12] + U50*I1[12]
           + (sixo2n)*(I2[12] - (lpon)*I3[12]);
*(vp++) = U20*I0[13] + U50*I1[13]
           + (sixo2n)*(I2[13] - (lpon)*I3[13]);
*(vp++) = U20*I0[14] + U50*I1[14]
           + (sixo2n)*(I2[14] - (lpon)*I3[14]);
*(vp++) = U20*I0[15] + U50*I1[15]
           + (fiveo2n)*(I2[15] - (lpon)*I3[15]);
*(vp++) = U20*I0[16] + U50*I1[16]
           + (fiveo2n)*(I2[16] - (lpon)*I3[16]);
*(vp++) = U20*I0[17] + U50*I1[17]
           + (fiveo2n)*(I2[17] - (lpon)*I3[17]);
*(vp++) = U20*I0[18] + U50*I1[18]
           + (fiveo2n)*(I2[18] - (lpon)*I3[18]);
*(vp++) = U20*I0[19] + U50*I1[19]
           + (fiveo2n)*(I2[19] - (lpon)*I3[19]);
*(vp++) = U20*I0[20] + U50*I1[20]
           + (fiveo2n)*(I2[20] - (lpon)*I3[20]);
*(vp++) = U20*I0[21] + U50*I1[21]
           + (fouro2n)*(I2[21] - (lpon)*I3[21]);
*(vp++) = U20*I0[22] + U50*I1[22]
           + (fouro2n)*(I2[22] - (lpon)*I3[22]);
*(vp++) = U20*I0[23] + U50*I1[23]
           + (fouro2n)*(I2[23] - (lpon)*I3[23]);
*(vp++) = U20*I0[24] + U50*I1[24]
           + (fouro2n)*(I2[24] - (lpon)*I3[24]);
*(vp++) = U20*I0[25] + U50*I1[25]
           + (fouro2n)*(I2[25] - (lpon)*I3[25]);
*(vp++) = U20*I0[26] + U50*I1[26]
           + (fouro2n)*(I2[26] - (lpon)*I3[26]);
*(vp++) = U20*I0[27] + U50*I1[27]
           + (fouro2n)*(I2[27] - (lpon)*I3[27]);
*(vp++) = U20*I0[28] + U50*I1[28]
           + (threeo2n)*(I2[28] - (lpon)*I3[28]);
*(vp++) = U20*I0[29] + U50*I1[29]
           + (threeo2n)*(I2[29] - (lpon)*I3[29]);
*(vp++) = U20*I0[30] + U50*I1[30]
           + (threeo2n)*(I2[30] - (lpon)*I3[30]);
*(vp++) = U20*I0[31] + U50*I1[31]
           + (threeo2n)*(I2[31] - (lpon)*I3[31]);
*(vp++) = U20*I0[32] + U50*I1[32]
           + (threeo2n)*(I2[32] - (lpon)*I3[32]);
*(vp++) = U20*I0[33] + U50*I1[33]
           + (threeo2n)*(I2[33] - (lpon)*I3[33]);
*(vp++) = U20*I0[34] + U50*I1[34]
           + (threeo2n)*(I2[34] - (lpon)*I3[34]);
*(vp++) = U20*I0[35] + U50*I1[35]
           + (threeo2n)*(I2[35] - (lpon)*I3[35]);
*(vp++) = U20*I0[36] + U50*I1[36]
           + (twoo2n)*(I2[36] - (lpon)*I3[36]);
*(vp++) = U20*I0[37] + U50*I1[37]
           + (twoo2n)*(I2[37] - (lpon)*I3[37]);
*(vp++) = U20*I0[38] + U50*I1[38]
           + (twoo2n)*(I2[38] - (lpon)*I3[38]);
*(vp++) = U20*I0[39] + U50*I1[39]
           + (twoo2n)*(I2[39] - (lpon)*I3[39]);
*(vp++) = U20*I0[40] + U50*I1[40]
           + (twoo2n)*(I2[40] - (lpon)*I3[40]);
*(vp++) = U20*I0[41] + U50*I1[41]
           + (twoo2n)*(I2[41] - (lpon)*I3[41]);
*(vp++) = U20*I0[42] + U50*I1[42]
           + (twoo2n)*(I2[42] - (lpon)*I3[42]);
*(vp++) = U20*I0[43] + U50*I1[43]
           + (twoo2n)*(I2[43] - (lpon)*I3[43]);
*(vp++) = U20*I0[44] + U50*I1[44]
           + (twoo2n)*(I2[44] - (lpon)*I3[44]);
*(vp++) = U20*I0[45] + U50*I1[45]
           + (oneo2n)*(I2[45] - (lpon)*I3[45]);
*(vp++) = U20*I0[46] + U50*I1[46]
           + (oneo2n)*(I2[46] - (lpon)*I3[46]);
*(vp++) = U20*I0[47] + U50*I1[47]
           + (oneo2n)*(I2[47] - (lpon)*I3[47]);
*(vp++) = U20*I0[48] + U50*I1[48]
           + (oneo2n)*(I2[48] - (lpon)*I3[48]);
*(vp++) = U20*I0[49] + U50*I1[49]
           + (oneo2n)*(I2[49] - (lpon)*I3[49]);
*(vp++) = U20*I0[50] + U50*I1[50]
           + (oneo2n)*(I2[50] - (lpon)*I3[50]);
*(vp++) = U20*I0[51] + U50*I1[51]
           + (oneo2n)*(I2[51] - (lpon)*I3[51]);
*(vp++) = U20*I0[52] + U50*I1[52]
           + (oneo2n)*(I2[52] - (lpon)*I3[52]);
*(vp++) = U20*I0[53] + U50*I1[53]
           + (oneo2n)*(I2[53] - (lpon)*I3[53]);
*(vp++) = U20*I0[54] + U50*I1[54]
           + (oneo2n)*(I2[54] - (lpon)*I3[54]);
*(vp++) = U20*I0[55] + U50*I1[55];
*(vp++) = U20*I0[56] + U50*I1[56];
*(vp++) = U20*I0[57] + U50*I1[57];
*(vp++) = U20*I0[58] + U50*I1[58];
*(vp++) = U20*I0[59] + U50*I1[59];
*(vp++) = U20*I0[60] + U50*I1[60];
*(vp++) = U20*I0[61] + U50*I1[61];
*(vp++) = U20*I0[62] + U50*I1[62];
*(vp++) = U20*I0[63] + U50*I1[63];
*(vp++) = U20*I0[64] + U50*I1[64];
*(vp++) = U20*I0[65] + U50*I1[65];
*(vp++) = U21*I0[55] + U51*I1[55]
           + (teno2n)*(I2[45] - (lpon)*I3[45]);
*(vp++) = U21*I0[56] + U51*I1[56]
           + (nineo2n)*(I2[46] - (lpon)*I3[46]);
*(vp++) = U21*I0[57] + U51*I1[57]
           + (eighto2n)*(I2[47] - (lpon)*I3[47]);
*(vp++) = U21*I0[58] + U51*I1[58]
           + (seveno2n)*(I2[48] - (lpon)*I3[48]);
*(vp++) = U21*I0[59] + U51*I1[59]
           + (sixo2n)*(I2[49] - (lpon)*I3[49]);
*(vp++) = U21*I0[60] + U51*I1[60]
           + (fiveo2n)*(I2[50] - (lpon)*I3[50]);
*(vp++) = U21*I0[61] + U51*I1[61]
           + (fouro2n)*(I2[51] - (lpon)*I3[51]);
*(vp++) = U21*I0[62] + U51*I1[62]
           + (threeo2n)*(I2[52] - (lpon)*I3[52]);
*(vp++) = U21*I0[63] + U51*I1[63]
           + (twoo2n)*(I2[53] - (lpon)*I3[53]);
*(vp++) = U21*I0[64] + U51*I1[64]
           + (oneo2n)*(I2[54] - (lpon)*I3[54]);
*(vp++) = U21*I0[65] + U51*I1[65];
*(vp++) = U22*I0[65] + U52*I1[65]
           + (teno2n)*(I2[54] - (lpon)*I3[54]);

}
/* Total number of FLOPs = 498 */
