/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_00lk(Libint_t*, prim_data*);

  /* Computes quartets of (00|lk) integrals */

REALTYPE *hrr_order_00lk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[0][8] = int_stack + 0;
 Libint->vrr_classes[0][9] = int_stack + 45;
 Libint->vrr_classes[0][10] = int_stack + 100;
 Libint->vrr_classes[0][11] = int_stack + 166;
 Libint->vrr_classes[0][12] = int_stack + 244;
 Libint->vrr_classes[0][13] = int_stack + 335;
 Libint->vrr_classes[0][14] = int_stack + 440;
 Libint->vrr_classes[0][15] = int_stack + 560;
 memset(int_stack,0,696*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 696;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_00lk(Libint, Data);
   Data++;
 }
 /*--- compute (00|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+696,int_stack+45,int_stack+0,1);
 /*--- compute (00|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+831,int_stack+100,int_stack+45,1);
 /*--- compute (00|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+996,int_stack+831,int_stack+696,1);
 /*--- compute (00|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1266,int_stack+166,int_stack+100,1);
 /*--- compute (00|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1464,int_stack+1266,int_stack+831,1);
 /*--- compute (00|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+1794,int_stack+1464,int_stack+996,1);
 /*--- compute (00|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+696,int_stack+244,int_stack+166,1);
 /*--- compute (00|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2244,int_stack+696,int_stack+1266,1);
 /*--- compute (00|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2640,int_stack+2244,int_stack+1464,1);
 /*--- compute (00|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+930,int_stack+2640,int_stack+1794,1);
 /*--- compute (00|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1605,int_stack+335,int_stack+244,1);
 /*--- compute (00|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3190,int_stack+1605,int_stack+696,1);
 /*--- compute (00|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3658,int_stack+3190,int_stack+2244,1);
 /*--- compute (00|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+4318,int_stack+3658,int_stack+2640,1);
 /*--- compute (00|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1878,int_stack+4318,int_stack+930,1);
 /*--- compute (00|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+696,int_stack+440,int_stack+335,1);
 /*--- compute (00|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1011,int_stack+696,int_stack+1605,1);
 /*--- compute (00|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+5143,int_stack+1011,int_stack+3190,1);
 /*--- compute (00|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+5923,int_stack+5143,int_stack+3658,1);
 /*--- compute (00|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2823,int_stack+5923,int_stack+4318,1);
 /*--- compute (00|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+6913,int_stack+2823,int_stack+1878,1);
 /*--- compute (00|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1557,int_stack+560,int_stack+440,1);
 /*--- compute (00|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1917,int_stack+1557,int_stack+696,1);
 /*--- compute (00|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3978,int_stack+1917,int_stack+1011,1);
 /*--- compute (00|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+3978,int_stack+5143,1);
 /*--- compute (00|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3978,int_stack+0,int_stack+5923,1);
 /*--- compute (00|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+3978,int_stack+2823,1);
 /*--- compute (00|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1540,int_stack+0,int_stack+6913,1);
 return int_stack+1540;}
