/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddkh(Libint_t*, prim_data*);

  /* Computes quartets of (dd|kh) integrals */

REALTYPE *hrr_order_ddkh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][7] = int_stack + 0;
 Libint->vrr_classes[2][8] = int_stack + 216;
 Libint->vrr_classes[2][9] = int_stack + 486;
 Libint->vrr_classes[2][10] = int_stack + 816;
 Libint->vrr_classes[2][11] = int_stack + 1212;
 Libint->vrr_classes[2][12] = int_stack + 1680;
 Libint->vrr_classes[3][7] = int_stack + 2226;
 Libint->vrr_classes[3][8] = int_stack + 2586;
 Libint->vrr_classes[3][9] = int_stack + 3036;
 Libint->vrr_classes[3][10] = int_stack + 3586;
 Libint->vrr_classes[3][11] = int_stack + 4246;
 Libint->vrr_classes[3][12] = int_stack + 5026;
 Libint->vrr_classes[4][7] = int_stack + 5936;
 Libint->vrr_classes[4][8] = int_stack + 6476;
 Libint->vrr_classes[4][9] = int_stack + 7151;
 Libint->vrr_classes[4][10] = int_stack + 7976;
 Libint->vrr_classes[4][11] = int_stack + 8966;
 Libint->vrr_classes[4][12] = int_stack + 10136;
 memset(int_stack,0,11501*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 11501;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddkh(Libint, Data);
   Data++;
 }
 /*--- compute (d0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+11501,int_stack+216,int_stack+0,6);
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+12149,int_stack+486,int_stack+216,6);
 /*--- compute (d0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+12959,int_stack+12149,int_stack+11501,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14255,int_stack+816,int_stack+486,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+15245,int_stack+14255,int_stack+12149,6);
 /*--- compute (d0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+16865,int_stack+15245,int_stack+12959,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+11501,int_stack+1212,int_stack+816,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19025,int_stack+11501,int_stack+14255,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+21005,int_stack+19025,int_stack+15245,6);
 /*--- compute (d0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+12689,int_stack+21005,int_stack+16865,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15929,int_stack+1680,int_stack+1212,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23705,int_stack+15929,int_stack+11501,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+26081,int_stack+23705,int_stack+19025,6);
 /*--- compute (d0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+15929,int_stack+26081,int_stack+21005,6);
 /*--- compute (d0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+19979,int_stack+15929,int_stack+12689,6);
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+11501,int_stack+2586,int_stack+2226,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+12581,int_stack+3036,int_stack+2586,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13931,int_stack+12581,int_stack+11501,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+16091,int_stack+3586,int_stack+3036,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+24515,int_stack+16091,int_stack+12581,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+27215,int_stack+24515,int_stack+13931,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+11501,int_stack+4246,int_stack+3586,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+11501,int_stack+16091,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+13481,int_stack+0,int_stack+24515,10);
 /*--- compute (f0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+30815,int_stack+13481,int_stack+27215,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+24515,int_stack+5026,int_stack+4246,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+26855,int_stack+24515,int_stack+11501,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+36215,int_stack+26855,int_stack+0,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+41715,int_stack+36215,int_stack+13481,10);
 /*--- compute (f0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+11501,int_stack+41715,int_stack+30815,10);
 /*--- compute (dp|kh) ---*/
 hrr1_build_dp(Libint->AB,int_stack+24515,int_stack+11501,int_stack+19979,756);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+6476,int_stack+5936,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+1620,int_stack+7151,int_stack+6476,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+3645,int_stack+1620,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+19061,int_stack+7976,int_stack+7151,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+38123,int_stack+19061,int_stack+1620,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+42173,int_stack+38123,int_stack+3645,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+8966,int_stack+7976,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2970,int_stack+0,int_stack+19061,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+47573,int_stack+2970,int_stack+38123,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+54323,int_stack+47573,int_stack+42173,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+38123,int_stack+10136,int_stack+8966,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+41633,int_stack+38123,int_stack+0,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+62423,int_stack+41633,int_stack+2970,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+62423,int_stack+47573,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+38123,int_stack+0,int_stack+54323,15);
 /*--- compute (fp|kh) ---*/
 hrr1_build_fp(Libint->AB,int_stack+49463,int_stack+38123,int_stack+11501,756);
 /*--- compute (dd|kh) ---*/
 hrr1_build_dd(Libint->AB,int_stack+72143,int_stack+49463,int_stack+24515,756);
 return int_stack+72143;}
