/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddlp(Libint_t*, prim_data*);

  /* Computes quartets of (dd|lp) integrals */

REALTYPE *hrr_order_ddlp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][8] = int_stack + 0;
 Libint->vrr_classes[2][9] = int_stack + 270;
 Libint->vrr_classes[3][8] = int_stack + 600;
 Libint->vrr_classes[3][9] = int_stack + 1050;
 Libint->vrr_classes[4][8] = int_stack + 1600;
 Libint->vrr_classes[4][9] = int_stack + 2275;
 memset(int_stack,0,3100*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 3100;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddlp(Libint, Data);
   Data++;
 }
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3100,int_stack+270,int_stack+0,6);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3910,int_stack+1050,int_stack+600,10);
 /*--- compute (dp|lp) ---*/
 hrr1_build_dp(Libint->AB,int_stack+5260,int_stack+3910,int_stack+3100,135);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+7690,int_stack+2275,int_stack+1600,15);
 /*--- compute (fp|lp) ---*/
 hrr1_build_fp(Libint->AB,int_stack+9715,int_stack+7690,int_stack+3910,135);
 /*--- compute (dd|lp) ---*/
 hrr1_build_dd(Libint->AB,int_stack+0,int_stack+9715,int_stack+5260,135);
 return int_stack+0;}
