/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddmi(Libint_t*, prim_data*);

  /* Computes quartets of (dd|mi) integrals */

REALTYPE *hrr_order_ddmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][9] = int_stack + 0;
 Libint->vrr_classes[2][10] = int_stack + 330;
 Libint->vrr_classes[2][11] = int_stack + 726;
 Libint->vrr_classes[2][12] = int_stack + 1194;
 Libint->vrr_classes[2][13] = int_stack + 1740;
 Libint->vrr_classes[2][14] = int_stack + 2370;
 Libint->vrr_classes[2][15] = int_stack + 3090;
 Libint->vrr_classes[3][9] = int_stack + 3906;
 Libint->vrr_classes[3][10] = int_stack + 4456;
 Libint->vrr_classes[3][11] = int_stack + 5116;
 Libint->vrr_classes[3][12] = int_stack + 5896;
 Libint->vrr_classes[3][13] = int_stack + 6806;
 Libint->vrr_classes[3][14] = int_stack + 7856;
 Libint->vrr_classes[3][15] = int_stack + 9056;
 Libint->vrr_classes[4][9] = int_stack + 10416;
 Libint->vrr_classes[4][10] = int_stack + 11241;
 Libint->vrr_classes[4][11] = int_stack + 12231;
 Libint->vrr_classes[4][12] = int_stack + 13401;
 Libint->vrr_classes[4][13] = int_stack + 14766;
 Libint->vrr_classes[4][14] = int_stack + 16341;
 Libint->vrr_classes[4][15] = int_stack + 18141;
 memset(int_stack,0,20181*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 20181;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddmi(Libint, Data);
   Data++;
 }
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+20181,int_stack+330,int_stack+0,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21171,int_stack+726,int_stack+330,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+22359,int_stack+21171,int_stack+20181,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+24339,int_stack+1194,int_stack+726,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+25743,int_stack+24339,int_stack+21171,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+28119,int_stack+25743,int_stack+22359,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+20181,int_stack+1740,int_stack+1194,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+31419,int_stack+20181,int_stack+24339,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+34227,int_stack+31419,int_stack+25743,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+21819,int_stack+34227,int_stack+28119,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+26769,int_stack+2370,int_stack+1740,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+38187,int_stack+26769,int_stack+20181,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+41463,int_stack+38187,int_stack+31419,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+46143,int_stack+41463,int_stack+34227,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+28659,int_stack+46143,int_stack+21819,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+20181,int_stack+3090,int_stack+2370,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+22341,int_stack+20181,int_stack+26769,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+52083,int_stack+22341,int_stack+38187,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+20181,int_stack+52083,int_stack+41463,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+35589,int_stack+20181,int_stack+46143,6);
 /*--- compute (d0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+43905,int_stack+35589,int_stack+28659,6);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+20181,int_stack+4456,int_stack+3906,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21831,int_stack+5116,int_stack+4456,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23811,int_stack+21831,int_stack+20181,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+27111,int_stack+5896,int_stack+5116,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+29451,int_stack+27111,int_stack+21831,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+33411,int_stack+29451,int_stack+23811,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+20181,int_stack+6806,int_stack+5896,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+38911,int_stack+20181,int_stack+27111,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+38911,int_stack+29451,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+22911,int_stack+0,int_stack+33411,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+31161,int_stack+7856,int_stack+6806,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+53145,int_stack+31161,int_stack+20181,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+58605,int_stack+53145,int_stack+38911,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+66405,int_stack+58605,int_stack+0,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+76305,int_stack+66405,int_stack+22911,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+9056,int_stack+7856,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3600,int_stack+0,int_stack+31161,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+20181,int_stack+3600,int_stack+53145,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+29281,int_stack+20181,int_stack+58605,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+87855,int_stack+29281,int_stack+66405,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+20181,int_stack+87855,int_stack+76305,10);
 /*--- compute (dp|mi) ---*/
 hrr1_build_dp(Libint->AB,int_stack+53145,int_stack+20181,int_stack+43905,1540);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+35581,int_stack+11241,int_stack+10416,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+38056,int_stack+12231,int_stack+11241,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+41026,int_stack+38056,int_stack+35581,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45976,int_stack+13401,int_stack+12231,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+80865,int_stack+45976,int_stack+38056,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+86805,int_stack+80865,int_stack+41026,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+35581,int_stack+14766,int_stack+13401,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+35581,int_stack+45976,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+39676,int_stack+0,int_stack+80865,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+95055,int_stack+39676,int_stack+86805,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+80865,int_stack+16341,int_stack+14766,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+85590,int_stack+80865,int_stack+35581,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+107430,int_stack+85590,int_stack+0,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+107430,int_stack+39676,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+35581,int_stack+0,int_stack+95055,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+93780,int_stack+18141,int_stack+16341,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+119130,int_stack+93780,int_stack+80865,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+93780,int_stack+119130,int_stack+85590,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+119130,int_stack+93780,int_stack+107430,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+80865,int_stack+119130,int_stack+0,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+101655,int_stack+80865,int_stack+35581,15);
 /*--- compute (fp|mi) ---*/
 hrr1_build_fp(Libint->AB,int_stack+124755,int_stack+101655,int_stack+20181,1540);
 /*--- compute (dd|mi) ---*/
 hrr1_build_dd(Libint->AB,int_stack+170955,int_stack+124755,int_stack+53145,1540);
 return int_stack+170955;}
