/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddnn(Libint_t*, prim_data*);

  /* Computes quartets of (dd|nn) integrals */

REALTYPE *hrr_order_ddnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][10] = int_stack + 0;
 Libint->vrr_classes[2][11] = int_stack + 396;
 Libint->vrr_classes[2][12] = int_stack + 864;
 Libint->vrr_classes[2][13] = int_stack + 1410;
 Libint->vrr_classes[2][14] = int_stack + 2040;
 Libint->vrr_classes[2][15] = int_stack + 2760;
 Libint->vrr_classes[2][16] = int_stack + 3576;
 Libint->vrr_classes[2][17] = int_stack + 4494;
 Libint->vrr_classes[2][18] = int_stack + 5520;
 Libint->vrr_classes[2][19] = int_stack + 6660;
 Libint->vrr_classes[2][20] = int_stack + 7920;
 Libint->vrr_classes[3][10] = int_stack + 9306;
 Libint->vrr_classes[3][11] = int_stack + 9966;
 Libint->vrr_classes[3][12] = int_stack + 10746;
 Libint->vrr_classes[3][13] = int_stack + 11656;
 Libint->vrr_classes[3][14] = int_stack + 12706;
 Libint->vrr_classes[3][15] = int_stack + 13906;
 Libint->vrr_classes[3][16] = int_stack + 15266;
 Libint->vrr_classes[3][17] = int_stack + 16796;
 Libint->vrr_classes[3][18] = int_stack + 18506;
 Libint->vrr_classes[3][19] = int_stack + 20406;
 Libint->vrr_classes[3][20] = int_stack + 22506;
 Libint->vrr_classes[4][10] = int_stack + 24816;
 Libint->vrr_classes[4][11] = int_stack + 25806;
 Libint->vrr_classes[4][12] = int_stack + 26976;
 Libint->vrr_classes[4][13] = int_stack + 28341;
 Libint->vrr_classes[4][14] = int_stack + 29916;
 Libint->vrr_classes[4][15] = int_stack + 31716;
 Libint->vrr_classes[4][16] = int_stack + 33756;
 Libint->vrr_classes[4][17] = int_stack + 36051;
 Libint->vrr_classes[4][18] = int_stack + 38616;
 Libint->vrr_classes[4][19] = int_stack + 41466;
 Libint->vrr_classes[4][20] = int_stack + 44616;
 memset(int_stack,0,48081*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 48081;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddnn(Libint, Data);
   Data++;
 }
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+48081,int_stack+396,int_stack+0,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+49269,int_stack+864,int_stack+396,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+50673,int_stack+49269,int_stack+48081,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+53049,int_stack+1410,int_stack+864,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+54687,int_stack+53049,int_stack+49269,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+57495,int_stack+54687,int_stack+50673,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+48081,int_stack+2040,int_stack+1410,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+61455,int_stack+48081,int_stack+53049,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+49971,int_stack+61455,int_stack+54687,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+64731,int_stack+49971,int_stack+57495,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+54651,int_stack+2760,int_stack+2040,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+56811,int_stack+54651,int_stack+48081,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+70671,int_stack+56811,int_stack+61455,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+76131,int_stack+70671,int_stack+49971,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+83151,int_stack+76131,int_stack+64731,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+48081,int_stack+3576,int_stack+2760,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+60591,int_stack+48081,int_stack+54651,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+91467,int_stack+60591,int_stack+56811,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+50529,int_stack+91467,int_stack+70671,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+64911,int_stack+50529,int_stack+76131,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+97767,int_stack+64911,int_stack+83151,6);
 /*--- compute (d0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+74739,int_stack+4494,int_stack+3576,6);
 /*--- compute (d0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+77493,int_stack+74739,int_stack+48081,6);
 /*--- compute (d0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+82389,int_stack+77493,int_stack+60591,6);
 /*--- compute (d0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+108855,int_stack+82389,int_stack+91467,6);
 /*--- compute (d0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+118305,int_stack+108855,int_stack+50529,6);
 /*--- compute (d0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+48081,int_stack+118305,int_stack+64911,6);
 /*--- compute (d0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+129771,int_stack+48081,int_stack+97767,6);
 /*--- compute (d0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+61185,int_stack+5520,int_stack+4494,6);
 /*--- compute (d0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+64263,int_stack+61185,int_stack+74739,6);
 /*--- compute (d0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+89589,int_stack+64263,int_stack+77493,6);
 /*--- compute (d0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+69771,int_stack+89589,int_stack+82389,6);
 /*--- compute (d0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+144027,int_stack+69771,int_stack+108855,6);
 /*--- compute (d0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+97749,int_stack+144027,int_stack+118305,6);
 /*--- compute (d0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+157257,int_stack+97749,int_stack+48081,6);
 /*--- compute (d0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+174105,int_stack+157257,int_stack+129771,6);
 /*--- compute (d0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+48081,int_stack+6660,int_stack+5520,6);
 /*--- compute (d0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+51501,int_stack+48081,int_stack+61185,6);
 /*--- compute (d0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+113037,int_stack+51501,int_stack+64263,6);
 /*--- compute (d0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+122217,int_stack+113037,int_stack+89589,6);
 /*--- compute (d0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+80571,int_stack+122217,int_stack+69771,6);
 /*--- compute (d0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+57657,int_stack+80571,int_stack+144027,6);
 /*--- compute (d0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+134457,int_stack+57657,int_stack+97749,6);
 /*--- compute (d0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+191925,int_stack+134457,int_stack+157257,6);
 /*--- compute (d0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+212985,int_stack+191925,int_stack+174105,6);
 /*--- compute (d0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+75297,int_stack+7920,int_stack+6660,6);
 /*--- compute (d0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+95691,int_stack+75297,int_stack+48081,6);
 /*--- compute (d0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+102531,int_stack+95691,int_stack+51501,6);
 /*--- compute (d0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+154113,int_stack+102531,int_stack+113037,6);
 /*--- compute (d0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+95691,int_stack+154113,int_stack+122217,6);
 /*--- compute (d0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+154113,int_stack+95691,int_stack+80571,6);
 /*--- compute (d0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+75297,int_stack+154113,int_stack+57657,6);
 /*--- compute (d0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+154113,int_stack+75297,int_stack+134457,6);
 /*--- compute (d0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+48081,int_stack+154113,int_stack+191925,6);
 /*--- compute (d0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+73821,int_stack+48081,int_stack+212985,6);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+48081,int_stack+9966,int_stack+9306,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+50061,int_stack+10746,int_stack+9966,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+52401,int_stack+50061,int_stack+48081,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+56361,int_stack+11656,int_stack+10746,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+59091,int_stack+56361,int_stack+50061,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+63771,int_stack+59091,int_stack+52401,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+48081,int_stack+12706,int_stack+11656,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+99957,int_stack+48081,int_stack+56361,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+51231,int_stack+99957,int_stack+59091,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+105417,int_stack+51231,int_stack+63771,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+59031,int_stack+13906,int_stack+12706,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+62631,int_stack+59031,int_stack+48081,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+115317,int_stack+62631,int_stack+99957,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+124417,int_stack+115317,int_stack+51231,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+136117,int_stack+124417,int_stack+105417,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+99957,int_stack+15266,int_stack+13906,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+104037,int_stack+99957,int_stack+59031,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+48081,int_stack+104037,int_stack+62631,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+58581,int_stack+48081,int_stack+115317,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+149977,int_stack+58581,int_stack+124417,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+111237,int_stack+149977,int_stack+136117,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+129717,int_stack+16796,int_stack+15266,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+134307,int_stack+129717,int_stack+99957,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+166357,int_stack+134307,int_stack+104037,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+178357,int_stack+166357,int_stack+48081,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+194107,int_stack+178357,int_stack+58581,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+48081,int_stack+194107,int_stack+149977,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+142467,int_stack+48081,int_stack+111237,10);
 /*--- compute (f0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+99957,int_stack+18506,int_stack+16796,10);
 /*--- compute (f0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+105087,int_stack+99957,int_stack+129717,10);
 /*--- compute (f0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+114267,int_stack+105087,int_stack+134307,10);
 /*--- compute (f0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+213217,int_stack+114267,int_stack+166357,10);
 /*--- compute (f0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+231217,int_stack+213217,int_stack+178357,10);
 /*--- compute (f0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+166227,int_stack+231217,int_stack+194107,10);
 /*--- compute (f0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+253267,int_stack+166227,int_stack+48081,10);
 /*--- compute (f0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+281347,int_stack+253267,int_stack+142467,10);
 /*--- compute (f0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+48081,int_stack+20406,int_stack+18506,10);
 /*--- compute (f0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+53781,int_stack+48081,int_stack+99957,10);
 /*--- compute (f0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+127867,int_stack+53781,int_stack+105087,10);
 /*--- compute (f0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+143167,int_stack+127867,int_stack+114267,10);
 /*--- compute (f0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+99957,int_stack+143167,int_stack+213217,10);
 /*--- compute (f0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+191707,int_stack+99957,int_stack+231217,10);
 /*--- compute (f0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+311047,int_stack+191707,int_stack+166227,10);
 /*--- compute (f0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+343807,int_stack+311047,int_stack+253267,10);
 /*--- compute (f0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+221107,int_stack+343807,int_stack+281347,10);
 /*--- compute (f0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+64041,int_stack+22506,int_stack+20406,10);
 /*--- compute (f0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+163567,int_stack+64041,int_stack+48081,10);
 /*--- compute (f0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+257407,int_stack+163567,int_stack+53781,10);
 /*--- compute (f0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+163567,int_stack+257407,int_stack+127867,10);
 /*--- compute (f0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+257407,int_stack+163567,int_stack+143167,10);
 /*--- compute (f0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+125157,int_stack+257407,int_stack+99957,10);
 /*--- compute (f0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+257407,int_stack+125157,int_stack+191707,10);
 /*--- compute (f0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+99957,int_stack+257407,int_stack+311047,10);
 /*--- compute (f0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+257407,int_stack+99957,int_stack+343807,10);
 /*--- compute (f0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+99957,int_stack+257407,int_stack+221107,10);
 /*--- compute (dp|nn) ---*/
 hrr1_build_dp(Libint->AB,int_stack+143517,int_stack+99957,int_stack+73821,4356);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+221925,int_stack+25806,int_stack+24816,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+224895,int_stack+26976,int_stack+25806,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+228405,int_stack+224895,int_stack+221925,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+234345,int_stack+28341,int_stack+26976,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+238440,int_stack+234345,int_stack+224895,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+245460,int_stack+238440,int_stack+228405,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+221925,int_stack+29916,int_stack+28341,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+255360,int_stack+221925,int_stack+234345,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+226650,int_stack+255360,int_stack+238440,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+263550,int_stack+226650,int_stack+245460,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+238350,int_stack+31716,int_stack+29916,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+243750,int_stack+238350,int_stack+221925,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+278400,int_stack+243750,int_stack+255360,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+292050,int_stack+278400,int_stack+226650,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+309600,int_stack+292050,int_stack+263550,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+221925,int_stack+33756,int_stack+31716,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+253200,int_stack+221925,int_stack+238350,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+330390,int_stack+253200,int_stack+243750,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+228045,int_stack+330390,int_stack+278400,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+264000,int_stack+228045,int_stack+292050,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+346140,int_stack+264000,int_stack+309600,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+288570,int_stack+36051,int_stack+33756,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+295455,int_stack+288570,int_stack+221925,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+307695,int_stack+295455,int_stack+253200,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+48081,int_stack+307695,int_stack+330390,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+48081,int_stack+228045,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+221925,int_stack+0,int_stack+264000,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+373860,int_stack+221925,int_stack+346140,15);
 /*--- compute (g0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+254685,int_stack+38616,int_stack+36051,15);
 /*--- compute (g0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+262380,int_stack+254685,int_stack+288570,15);
 /*--- compute (g0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+325695,int_stack+262380,int_stack+295455,15);
 /*--- compute (g0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+276150,int_stack+325695,int_stack+307695,15);
 /*--- compute (g0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+409500,int_stack+276150,int_stack+48081,15);
 /*--- compute (g0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+48081,int_stack+409500,int_stack+0,15);
 /*--- compute (g0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+442575,int_stack+48081,int_stack+221925,15);
 /*--- compute (g0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+484695,int_stack+442575,int_stack+373860,15);
 /*--- compute (g0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+221925,int_stack+41466,int_stack+38616,15);
 /*--- compute (g0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+230475,int_stack+221925,int_stack+254685,15);
 /*--- compute (g0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+0,int_stack+230475,int_stack+262380,15);
 /*--- compute (g0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+346095,int_stack+0,int_stack+325695,15);
 /*--- compute (g0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+303150,int_stack+346095,int_stack+276150,15);
 /*--- compute (g0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+245865,int_stack+303150,int_stack+409500,15);
 /*--- compute (g0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+376695,int_stack+245865,int_stack+48081,15);
 /*--- compute (g0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+529245,int_stack+376695,int_stack+442575,15);
 /*--- compute (g0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+425835,int_stack+529245,int_stack+484695,15);
 /*--- compute (g0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+48081,int_stack+44616,int_stack+41466,15);
 /*--- compute (g0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+57531,int_stack+48081,int_stack+221925,15);
 /*--- compute (g0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+22950,int_stack+57531,int_stack+230475,15);
 /*--- compute (g0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+48600,int_stack+22950,int_stack+0,15);
 /*--- compute (g0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+48600,int_stack+346095,15);
 /*--- compute (g0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+42840,int_stack+0,int_stack+303150,15);
 /*--- compute (g0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+289965,int_stack+42840,int_stack+245865,15);
 /*--- compute (g0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+0,int_stack+289965,int_stack+376695,15);
 /*--- compute (g0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+221925,int_stack+0,int_stack+529245,15);
 /*--- compute (g0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+0,int_stack+221925,int_stack+425835,15);
 /*--- compute (fp|nn) ---*/
 hrr1_build_fp(Libint->AB,int_stack+221925,int_stack+0,int_stack+99957,4356);
 /*--- compute (dd|nn) ---*/
 hrr1_build_dd(Libint->AB,int_stack+352605,int_stack+221925,int_stack+143517,4356);
 return int_stack+352605;}
