/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_dpmh(Libint_t*, prim_data*);

  /* Computes quartets of (dp|mh) integrals */

REALTYPE *hrr_order_dpmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][9] = int_stack + 0;
 Libint->vrr_classes[2][10] = int_stack + 330;
 Libint->vrr_classes[2][11] = int_stack + 726;
 Libint->vrr_classes[2][12] = int_stack + 1194;
 Libint->vrr_classes[2][13] = int_stack + 1740;
 Libint->vrr_classes[2][14] = int_stack + 2370;
 Libint->vrr_classes[3][9] = int_stack + 3090;
 Libint->vrr_classes[3][10] = int_stack + 3640;
 Libint->vrr_classes[3][11] = int_stack + 4300;
 Libint->vrr_classes[3][12] = int_stack + 5080;
 Libint->vrr_classes[3][13] = int_stack + 5990;
 Libint->vrr_classes[3][14] = int_stack + 7040;
 memset(int_stack,0,8240*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 8240;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_dpmh(Libint, Data);
   Data++;
 }
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8240,int_stack+330,int_stack+0,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9230,int_stack+726,int_stack+330,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+10418,int_stack+9230,int_stack+8240,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+12398,int_stack+1194,int_stack+726,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+13802,int_stack+12398,int_stack+9230,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+16178,int_stack+13802,int_stack+10418,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+8240,int_stack+1740,int_stack+1194,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+19478,int_stack+8240,int_stack+12398,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+22286,int_stack+19478,int_stack+13802,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+9878,int_stack+22286,int_stack+16178,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+14828,int_stack+2370,int_stack+1740,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+26246,int_stack+14828,int_stack+8240,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+29522,int_stack+26246,int_stack+19478,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+14828,int_stack+29522,int_stack+22286,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+20768,int_stack+14828,int_stack+9878,6);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8240,int_stack+3640,int_stack+3090,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9890,int_stack+4300,int_stack+3640,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+11870,int_stack+9890,int_stack+8240,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15170,int_stack+5080,int_stack+4300,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+27698,int_stack+15170,int_stack+9890,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+31658,int_stack+27698,int_stack+11870,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+8240,int_stack+5990,int_stack+5080,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+8240,int_stack+15170,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+10970,int_stack+0,int_stack+27698,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+37158,int_stack+10970,int_stack+31658,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+27698,int_stack+7040,int_stack+5990,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+30848,int_stack+27698,int_stack+8240,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+45408,int_stack+30848,int_stack+0,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+45408,int_stack+10970,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+45408,int_stack+0,int_stack+37158,10);
 /*--- compute (dp|mh) ---*/
 hrr1_build_dp(Libint->AB,int_stack+56958,int_stack+45408,int_stack+20768,1155);
 return int_stack+56958;}
