/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_dpnk(Libint_t*, prim_data*);

  /* Computes quartets of (dp|nk) integrals */

REALTYPE *hrr_order_dpnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][10] = int_stack + 0;
 Libint->vrr_classes[2][11] = int_stack + 396;
 Libint->vrr_classes[2][12] = int_stack + 864;
 Libint->vrr_classes[2][13] = int_stack + 1410;
 Libint->vrr_classes[2][14] = int_stack + 2040;
 Libint->vrr_classes[2][15] = int_stack + 2760;
 Libint->vrr_classes[2][16] = int_stack + 3576;
 Libint->vrr_classes[2][17] = int_stack + 4494;
 Libint->vrr_classes[3][10] = int_stack + 5520;
 Libint->vrr_classes[3][11] = int_stack + 6180;
 Libint->vrr_classes[3][12] = int_stack + 6960;
 Libint->vrr_classes[3][13] = int_stack + 7870;
 Libint->vrr_classes[3][14] = int_stack + 8920;
 Libint->vrr_classes[3][15] = int_stack + 10120;
 Libint->vrr_classes[3][16] = int_stack + 11480;
 Libint->vrr_classes[3][17] = int_stack + 13010;
 memset(int_stack,0,14720*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 14720;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_dpnk(Libint, Data);
   Data++;
 }
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+14720,int_stack+396,int_stack+0,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15908,int_stack+864,int_stack+396,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+17312,int_stack+15908,int_stack+14720,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+19688,int_stack+1410,int_stack+864,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+21326,int_stack+19688,int_stack+15908,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+24134,int_stack+21326,int_stack+17312,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+14720,int_stack+2040,int_stack+1410,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+28094,int_stack+14720,int_stack+19688,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+16610,int_stack+28094,int_stack+21326,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+31370,int_stack+16610,int_stack+24134,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+21290,int_stack+2760,int_stack+2040,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+23450,int_stack+21290,int_stack+14720,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+37310,int_stack+23450,int_stack+28094,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+42770,int_stack+37310,int_stack+16610,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+49790,int_stack+42770,int_stack+31370,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+14720,int_stack+3576,int_stack+2760,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+27230,int_stack+14720,int_stack+21290,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+58106,int_stack+27230,int_stack+23450,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+17168,int_stack+58106,int_stack+37310,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+31550,int_stack+17168,int_stack+42770,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+64406,int_stack+31550,int_stack+49790,6);
 /*--- compute (d0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+41378,int_stack+4494,int_stack+3576,6);
 /*--- compute (d0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+44132,int_stack+41378,int_stack+14720,6);
 /*--- compute (d0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+49028,int_stack+44132,int_stack+27230,6);
 /*--- compute (d0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+75494,int_stack+49028,int_stack+58106,6);
 /*--- compute (d0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+41378,int_stack+75494,int_stack+17168,6);
 /*--- compute (d0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+14720,int_stack+41378,int_stack+31550,6);
 /*--- compute (d0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+27824,int_stack+14720,int_stack+64406,6);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+14720,int_stack+6180,int_stack+5520,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+16700,int_stack+6960,int_stack+6180,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+19040,int_stack+16700,int_stack+14720,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+23000,int_stack+7870,int_stack+6960,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+42080,int_stack+23000,int_stack+16700,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+46760,int_stack+42080,int_stack+19040,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+14720,int_stack+8920,int_stack+7870,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+53360,int_stack+14720,int_stack+23000,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+17870,int_stack+53360,int_stack+42080,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+58820,int_stack+17870,int_stack+46760,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+42080,int_stack+10120,int_stack+8920,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+45680,int_stack+42080,int_stack+14720,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+68720,int_stack+45680,int_stack+53360,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+77820,int_stack+68720,int_stack+17870,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+89520,int_stack+77820,int_stack+58820,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+14720,int_stack+11480,int_stack+10120,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+18800,int_stack+14720,int_stack+42080,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+51980,int_stack+18800,int_stack+45680,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+103380,int_stack+51980,int_stack+68720,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+117030,int_stack+103380,int_stack+77820,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+62480,int_stack+117030,int_stack+89520,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+42080,int_stack+13010,int_stack+11480,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+80960,int_stack+42080,int_stack+14720,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+89120,int_stack+80960,int_stack+18800,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+89120,int_stack+51980,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+80960,int_stack+0,int_stack+103380,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+80960,int_stack+117030,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+80960,int_stack+0,int_stack+62480,10);
 /*--- compute (dp|nk) ---*/
 hrr1_build_dp(Libint->AB,int_stack+104720,int_stack+80960,int_stack+27824,2376);
 return int_stack+104720;}
