/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdid(Libint_t*, prim_data*);

  /* Computes quartets of (fd|id) integrals */

REALTYPE *hrr_order_fdid(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][6] = int_stack + 0;
 Libint->vrr_classes[3][7] = int_stack + 280;
 Libint->vrr_classes[3][8] = int_stack + 640;
 Libint->vrr_classes[4][6] = int_stack + 1090;
 Libint->vrr_classes[4][7] = int_stack + 1510;
 Libint->vrr_classes[4][8] = int_stack + 2050;
 Libint->vrr_classes[5][6] = int_stack + 2725;
 Libint->vrr_classes[5][7] = int_stack + 3313;
 Libint->vrr_classes[5][8] = int_stack + 4069;
 memset(int_stack,0,5014*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 5014;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdid(Libint, Data);
   Data++;
 }
 /*--- compute (f0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+5014,int_stack+280,int_stack+0,10);
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+5854,int_stack+640,int_stack+280,10);
 /*--- compute (f0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+6934,int_stack+5854,int_stack+5014,10);
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+5014,int_stack+1510,int_stack+1090,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+8614,int_stack+2050,int_stack+1510,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+0,int_stack+8614,int_stack+5014,15);
 /*--- compute (fp|id) ---*/
 hrr1_build_fp(Libint->AB,int_stack+8614,int_stack+0,int_stack+6934,168);
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+5014,int_stack+3313,int_stack+2725,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+13654,int_stack+4069,int_stack+3313,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+15922,int_stack+13654,int_stack+5014,21);
 /*--- compute (gp|id) ---*/
 hrr1_build_gp(Libint->AB,int_stack+19450,int_stack+15922,int_stack+0,168);
 /*--- compute (fd|id) ---*/
 hrr1_build_fd(Libint->AB,int_stack+27010,int_stack+19450,int_stack+8614,168);
 return int_stack+27010;}
