/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdlg(Libint_t*, prim_data*);

  /* Computes quartets of (fd|lg) integrals */

REALTYPE *hrr_order_fdlg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][8] = int_stack + 0;
 Libint->vrr_classes[3][9] = int_stack + 450;
 Libint->vrr_classes[3][10] = int_stack + 1000;
 Libint->vrr_classes[3][11] = int_stack + 1660;
 Libint->vrr_classes[3][12] = int_stack + 2440;
 Libint->vrr_classes[4][8] = int_stack + 3350;
 Libint->vrr_classes[4][9] = int_stack + 4025;
 Libint->vrr_classes[4][10] = int_stack + 4850;
 Libint->vrr_classes[4][11] = int_stack + 5840;
 Libint->vrr_classes[4][12] = int_stack + 7010;
 Libint->vrr_classes[5][8] = int_stack + 8375;
 Libint->vrr_classes[5][9] = int_stack + 9320;
 Libint->vrr_classes[5][10] = int_stack + 10475;
 Libint->vrr_classes[5][11] = int_stack + 11861;
 Libint->vrr_classes[5][12] = int_stack + 13499;
 memset(int_stack,0,15410*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 15410;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdlg(Libint, Data);
   Data++;
 }
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15410,int_stack+450,int_stack+0,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+16760,int_stack+1000,int_stack+450,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+18410,int_stack+16760,int_stack+15410,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21110,int_stack+1660,int_stack+1000,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23090,int_stack+21110,int_stack+16760,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+26390,int_stack+23090,int_stack+18410,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15410,int_stack+2440,int_stack+1660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+30890,int_stack+15410,int_stack+21110,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+15410,int_stack+30890,int_stack+23090,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+30890,int_stack+15410,int_stack+26390,10);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15410,int_stack+4025,int_stack+3350,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+17435,int_stack+4850,int_stack+4025,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19910,int_stack+17435,int_stack+15410,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+23960,int_stack+5840,int_stack+4850,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+23960,int_stack+17435,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+37640,int_stack+0,int_stack+19910,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15410,int_stack+7010,int_stack+5840,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+44390,int_stack+15410,int_stack+23960,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+15410,int_stack+44390,int_stack+0,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+44390,int_stack+15410,int_stack+37640,15);
 /*--- compute (fp|lg) ---*/
 hrr1_build_fp(Libint->AB,int_stack+54515,int_stack+44390,int_stack+30890,675);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15410,int_stack+9320,int_stack+8375,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+18245,int_stack+10475,int_stack+9320,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+21710,int_stack+18245,int_stack+15410,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+27380,int_stack+11861,int_stack+10475,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+31538,int_stack+27380,int_stack+18245,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+31538,int_stack+21710,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15410,int_stack+13499,int_stack+11861,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+74765,int_stack+15410,int_stack+27380,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+9450,int_stack+74765,int_stack+31538,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+21000,int_stack+9450,int_stack+0,21);
 /*--- compute (gp|lg) ---*/
 hrr1_build_gp(Libint->AB,int_stack+74765,int_stack+21000,int_stack+44390,675);
 /*--- compute (fd|lg) ---*/
 hrr1_build_fd(Libint->AB,int_stack+0,int_stack+74765,int_stack+54515,675);
 return int_stack+0;}
