/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdnm(Libint_t*, prim_data*);

  /* Computes quartets of (fd|nm) integrals */

REALTYPE *hrr_order_fdnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][10] = int_stack + 0;
 Libint->vrr_classes[3][11] = int_stack + 660;
 Libint->vrr_classes[3][12] = int_stack + 1440;
 Libint->vrr_classes[3][13] = int_stack + 2350;
 Libint->vrr_classes[3][14] = int_stack + 3400;
 Libint->vrr_classes[3][15] = int_stack + 4600;
 Libint->vrr_classes[3][16] = int_stack + 5960;
 Libint->vrr_classes[3][17] = int_stack + 7490;
 Libint->vrr_classes[3][18] = int_stack + 9200;
 Libint->vrr_classes[3][19] = int_stack + 11100;
 Libint->vrr_classes[4][10] = int_stack + 13200;
 Libint->vrr_classes[4][11] = int_stack + 14190;
 Libint->vrr_classes[4][12] = int_stack + 15360;
 Libint->vrr_classes[4][13] = int_stack + 16725;
 Libint->vrr_classes[4][14] = int_stack + 18300;
 Libint->vrr_classes[4][15] = int_stack + 20100;
 Libint->vrr_classes[4][16] = int_stack + 22140;
 Libint->vrr_classes[4][17] = int_stack + 24435;
 Libint->vrr_classes[4][18] = int_stack + 27000;
 Libint->vrr_classes[4][19] = int_stack + 29850;
 Libint->vrr_classes[5][10] = int_stack + 33000;
 Libint->vrr_classes[5][11] = int_stack + 34386;
 Libint->vrr_classes[5][12] = int_stack + 36024;
 Libint->vrr_classes[5][13] = int_stack + 37935;
 Libint->vrr_classes[5][14] = int_stack + 40140;
 Libint->vrr_classes[5][15] = int_stack + 42660;
 Libint->vrr_classes[5][16] = int_stack + 45516;
 Libint->vrr_classes[5][17] = int_stack + 48729;
 Libint->vrr_classes[5][18] = int_stack + 52320;
 Libint->vrr_classes[5][19] = int_stack + 56310;
 memset(int_stack,0,60720*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 60720;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdnm(Libint, Data);
   Data++;
 }
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+60720,int_stack+660,int_stack+0,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+62700,int_stack+1440,int_stack+660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+65040,int_stack+62700,int_stack+60720,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+69000,int_stack+2350,int_stack+1440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+71730,int_stack+69000,int_stack+62700,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+76410,int_stack+71730,int_stack+65040,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+60720,int_stack+3400,int_stack+2350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+83010,int_stack+60720,int_stack+69000,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+63870,int_stack+83010,int_stack+71730,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+88470,int_stack+63870,int_stack+76410,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+71670,int_stack+4600,int_stack+3400,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+75270,int_stack+71670,int_stack+60720,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+98370,int_stack+75270,int_stack+83010,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+107470,int_stack+98370,int_stack+63870,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+119170,int_stack+107470,int_stack+88470,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+60720,int_stack+5960,int_stack+4600,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+81570,int_stack+60720,int_stack+71670,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+133030,int_stack+81570,int_stack+75270,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+64800,int_stack+133030,int_stack+98370,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+88770,int_stack+64800,int_stack+107470,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+143530,int_stack+88770,int_stack+119170,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+105150,int_stack+7490,int_stack+5960,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+109740,int_stack+105150,int_stack+60720,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+117900,int_stack+109740,int_stack+81570,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+162010,int_stack+117900,int_stack+133030,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+177760,int_stack+162010,int_stack+64800,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+60720,int_stack+177760,int_stack+88770,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+196870,int_stack+60720,int_stack+143530,10);
 /*--- compute (f0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+82560,int_stack+9200,int_stack+7490,10);
 /*--- compute (f0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+87690,int_stack+82560,int_stack+105150,10);
 /*--- compute (f0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+129900,int_stack+87690,int_stack+109740,10);
 /*--- compute (f0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+96870,int_stack+129900,int_stack+117900,10);
 /*--- compute (f0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+220630,int_stack+96870,int_stack+162010,10);
 /*--- compute (f0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+143500,int_stack+220630,int_stack+177760,10);
 /*--- compute (f0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+242680,int_stack+143500,int_stack+60720,10);
 /*--- compute (f0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+270760,int_stack+242680,int_stack+196870,10);
 /*--- compute (f0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+60720,int_stack+11100,int_stack+9200,10);
 /*--- compute (f0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+66420,int_stack+60720,int_stack+82560,10);
 /*--- compute (f0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+168980,int_stack+66420,int_stack+87690,10);
 /*--- compute (f0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+60720,int_stack+168980,int_stack+129900,10);
 /*--- compute (f0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+168980,int_stack+60720,int_stack+96870,10);
 /*--- compute (f0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+60720,int_stack+168980,int_stack+220630,10);
 /*--- compute (f0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+168980,int_stack+60720,int_stack+143500,10);
 /*--- compute (f0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+60720,int_stack+168980,int_stack+242680,10);
 /*--- compute (f0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+95820,int_stack+60720,int_stack+270760,10);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+60720,int_stack+14190,int_stack+13200,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63690,int_stack+15360,int_stack+14190,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+67200,int_stack+63690,int_stack+60720,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+73140,int_stack+16725,int_stack+15360,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+77235,int_stack+73140,int_stack+63690,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+84255,int_stack+77235,int_stack+67200,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+60720,int_stack+18300,int_stack+16725,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+132120,int_stack+60720,int_stack+73140,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+65445,int_stack+132120,int_stack+77235,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+140310,int_stack+65445,int_stack+84255,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+77145,int_stack+20100,int_stack+18300,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+82545,int_stack+77145,int_stack+60720,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+155160,int_stack+82545,int_stack+132120,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+168810,int_stack+155160,int_stack+65445,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+186360,int_stack+168810,int_stack+140310,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+132120,int_stack+22140,int_stack+20100,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+138240,int_stack+132120,int_stack+77145,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+60720,int_stack+138240,int_stack+82545,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+207150,int_stack+60720,int_stack+155160,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+227625,int_stack+207150,int_stack+168810,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+149040,int_stack+227625,int_stack+186360,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+176760,int_stack+24435,int_stack+22140,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+183645,int_stack+176760,int_stack+132120,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+76470,int_stack+183645,int_stack+138240,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+252195,int_stack+76470,int_stack+60720,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+275820,int_stack+252195,int_stack+207150,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+304485,int_stack+275820,int_stack+227625,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+195885,int_stack+304485,int_stack+149040,15);
 /*--- compute (g0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+60720,int_stack+27000,int_stack+24435,15);
 /*--- compute (g0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+132120,int_stack+60720,int_stack+176760,15);
 /*--- compute (g0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+145890,int_stack+132120,int_stack+183645,15);
 /*--- compute (g0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+145890,int_stack+76470,15);
 /*--- compute (g0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+337245,int_stack+0,int_stack+252195,15);
 /*--- compute (g0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+231525,int_stack+337245,int_stack+275820,15);
 /*--- compute (g0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+370320,int_stack+231525,int_stack+304485,15);
 /*--- compute (g0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+269745,int_stack+370320,int_stack+195885,15);
 /*--- compute (g0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+68415,int_stack+29850,int_stack+27000,15);
 /*--- compute (g0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+76965,int_stack+68415,int_stack+60720,15);
 /*--- compute (g0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+314295,int_stack+76965,int_stack+132120,15);
 /*--- compute (g0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+60720,int_stack+314295,int_stack+145890,15);
 /*--- compute (g0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+132120,int_stack+60720,int_stack+0,15);
 /*--- compute (g0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+169920,int_stack+132120,int_stack+337245,15);
 /*--- compute (g0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+314295,int_stack+169920,int_stack+231525,15);
 /*--- compute (g0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+132120,int_stack+314295,int_stack+370320,15);
 /*--- compute (g0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+314295,int_stack+132120,int_stack+269745,15);
 /*--- compute (fp|nm) ---*/
 hrr1_build_fp(Libint->AB,int_stack+132120,int_stack+314295,int_stack+95820,3630);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+241020,int_stack+34386,int_stack+33000,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+245178,int_stack+36024,int_stack+34386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+250092,int_stack+245178,int_stack+241020,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+258408,int_stack+37935,int_stack+36024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+264141,int_stack+258408,int_stack+245178,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+273969,int_stack+264141,int_stack+250092,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+241020,int_stack+40140,int_stack+37935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+287829,int_stack+241020,int_stack+258408,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+247635,int_stack+287829,int_stack+264141,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+368745,int_stack+247635,int_stack+273969,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+264015,int_stack+42660,int_stack+40140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+271575,int_stack+264015,int_stack+241020,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+389535,int_stack+271575,int_stack+287829,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+284805,int_stack+389535,int_stack+247635,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+284805,int_stack+368745,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+368745,int_stack+45516,int_stack+42660,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+241020,int_stack+368745,int_stack+264015,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+60720,int_stack+241020,int_stack+271575,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+256140,int_stack+60720,int_stack+389535,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+377313,int_stack+256140,int_stack+284805,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+82770,int_stack+377313,int_stack+0,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+48729,int_stack+45516,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+9639,int_stack+0,int_stack+368745,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+284805,int_stack+9639,int_stack+241020,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+411711,int_stack+284805,int_stack+60720,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+444786,int_stack+411711,int_stack+256140,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+484917,int_stack+444786,int_stack+377313,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+530781,int_stack+484917,int_stack+82770,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+60720,int_stack+52320,int_stack+48729,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+71493,int_stack+60720,int_stack+0,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+90771,int_stack+71493,int_stack+9639,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+90771,int_stack+284805,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+241020,int_stack+0,int_stack+411711,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+368745,int_stack+241020,int_stack+444786,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+422253,int_stack+368745,int_stack+484917,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+580677,int_stack+422253,int_stack+530781,21);
 /*--- compute (h0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+37800,int_stack+56310,int_stack+52320,21);
 /*--- compute (h0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+287325,int_stack+37800,int_stack+60720,21);
 /*--- compute (h0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+37800,int_stack+287325,int_stack+71493,21);
 /*--- compute (h0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+481221,int_stack+37800,int_stack+90771,21);
 /*--- compute (h0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+37800,int_stack+481221,int_stack+0,21);
 /*--- compute (h0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+481221,int_stack+37800,int_stack+241020,21);
 /*--- compute (h0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+241020,int_stack+481221,int_stack+368745,21);
 /*--- compute (h0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+481221,int_stack+241020,int_stack+422253,21);
 /*--- compute (h0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+368745,int_stack+481221,int_stack+580677,21);
 /*--- compute (gp|nm) ---*/
 hrr1_build_gp(Libint->AB,int_stack+444975,int_stack+368745,int_stack+314295,3630);
 /*--- compute (fd|nm) ---*/
 hrr1_build_fd(Libint->AB,int_stack+608325,int_stack+444975,int_stack+132120,3630);
 return int_stack+608325;}
