/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fpkg(Libint_t*, prim_data*);

  /* Computes quartets of (fp|kg) integrals */

REALTYPE *hrr_order_fpkg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][7] = int_stack + 0;
 Libint->vrr_classes[3][8] = int_stack + 360;
 Libint->vrr_classes[3][9] = int_stack + 810;
 Libint->vrr_classes[3][10] = int_stack + 1360;
 Libint->vrr_classes[3][11] = int_stack + 2020;
 Libint->vrr_classes[4][7] = int_stack + 2800;
 Libint->vrr_classes[4][8] = int_stack + 3340;
 Libint->vrr_classes[4][9] = int_stack + 4015;
 Libint->vrr_classes[4][10] = int_stack + 4840;
 Libint->vrr_classes[4][11] = int_stack + 5830;
 memset(int_stack,0,7000*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 7000;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fpkg(Libint, Data);
   Data++;
 }
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+7000,int_stack+360,int_stack+0,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8080,int_stack+810,int_stack+360,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+9430,int_stack+8080,int_stack+7000,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+11590,int_stack+1360,int_stack+810,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+13240,int_stack+11590,int_stack+8080,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+15940,int_stack+13240,int_stack+9430,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7000,int_stack+2020,int_stack+1360,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19540,int_stack+7000,int_stack+11590,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+7000,int_stack+19540,int_stack+13240,10);
 /*--- compute (f0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+19540,int_stack+7000,int_stack+15940,10);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+7000,int_stack+3340,int_stack+2800,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8620,int_stack+4015,int_stack+3340,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+10645,int_stack+8620,int_stack+7000,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+13885,int_stack+4840,int_stack+4015,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+13885,int_stack+8620,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+24940,int_stack+0,int_stack+10645,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7000,int_stack+5830,int_stack+4840,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+30340,int_stack+7000,int_stack+13885,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+4050,int_stack+30340,int_stack+0,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+10800,int_stack+4050,int_stack+24940,15);
 /*--- compute (fp|kg) ---*/
 hrr1_build_fp(Libint->AB,int_stack+24940,int_stack+10800,int_stack+19540,540);
 return int_stack+24940;}
