/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fpnl(Libint_t*, prim_data*);

  /* Computes quartets of (fp|nl) integrals */

REALTYPE *hrr_order_fpnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][10] = int_stack + 0;
 Libint->vrr_classes[3][11] = int_stack + 660;
 Libint->vrr_classes[3][12] = int_stack + 1440;
 Libint->vrr_classes[3][13] = int_stack + 2350;
 Libint->vrr_classes[3][14] = int_stack + 3400;
 Libint->vrr_classes[3][15] = int_stack + 4600;
 Libint->vrr_classes[3][16] = int_stack + 5960;
 Libint->vrr_classes[3][17] = int_stack + 7490;
 Libint->vrr_classes[3][18] = int_stack + 9200;
 Libint->vrr_classes[4][10] = int_stack + 11100;
 Libint->vrr_classes[4][11] = int_stack + 12090;
 Libint->vrr_classes[4][12] = int_stack + 13260;
 Libint->vrr_classes[4][13] = int_stack + 14625;
 Libint->vrr_classes[4][14] = int_stack + 16200;
 Libint->vrr_classes[4][15] = int_stack + 18000;
 Libint->vrr_classes[4][16] = int_stack + 20040;
 Libint->vrr_classes[4][17] = int_stack + 22335;
 Libint->vrr_classes[4][18] = int_stack + 24900;
 memset(int_stack,0,27750*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 27750;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fpnl(Libint, Data);
   Data++;
 }
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+27750,int_stack+660,int_stack+0,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+29730,int_stack+1440,int_stack+660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+32070,int_stack+29730,int_stack+27750,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+36030,int_stack+2350,int_stack+1440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+38760,int_stack+36030,int_stack+29730,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+43440,int_stack+38760,int_stack+32070,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+27750,int_stack+3400,int_stack+2350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+50040,int_stack+27750,int_stack+36030,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+30900,int_stack+50040,int_stack+38760,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+55500,int_stack+30900,int_stack+43440,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+38700,int_stack+4600,int_stack+3400,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+42300,int_stack+38700,int_stack+27750,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+65400,int_stack+42300,int_stack+50040,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+74500,int_stack+65400,int_stack+30900,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+86200,int_stack+74500,int_stack+55500,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+27750,int_stack+5960,int_stack+4600,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+48600,int_stack+27750,int_stack+38700,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+100060,int_stack+48600,int_stack+42300,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+31830,int_stack+100060,int_stack+65400,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+55800,int_stack+31830,int_stack+74500,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+110560,int_stack+55800,int_stack+86200,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+72180,int_stack+7490,int_stack+5960,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+76770,int_stack+72180,int_stack+27750,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+84930,int_stack+76770,int_stack+48600,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+129040,int_stack+84930,int_stack+100060,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+144790,int_stack+129040,int_stack+31830,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+27750,int_stack+144790,int_stack+55800,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+163900,int_stack+27750,int_stack+110560,10);
 /*--- compute (f0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+49590,int_stack+9200,int_stack+7490,10);
 /*--- compute (f0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+54720,int_stack+49590,int_stack+72180,10);
 /*--- compute (f0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+96930,int_stack+54720,int_stack+76770,10);
 /*--- compute (f0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+49590,int_stack+96930,int_stack+84930,10);
 /*--- compute (f0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+67590,int_stack+49590,int_stack+129040,10);
 /*--- compute (f0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+89640,int_stack+67590,int_stack+144790,10);
 /*--- compute (f0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+49590,int_stack+89640,int_stack+27750,10);
 /*--- compute (f0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+77670,int_stack+49590,int_stack+163900,10);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+27750,int_stack+12090,int_stack+11100,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+30720,int_stack+13260,int_stack+12090,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+34230,int_stack+30720,int_stack+27750,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+40170,int_stack+14625,int_stack+13260,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+44265,int_stack+40170,int_stack+30720,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+51285,int_stack+44265,int_stack+34230,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+27750,int_stack+16200,int_stack+14625,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+61185,int_stack+27750,int_stack+40170,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+32475,int_stack+61185,int_stack+44265,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+107370,int_stack+32475,int_stack+51285,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+44175,int_stack+18000,int_stack+16200,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+49575,int_stack+44175,int_stack+27750,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+122220,int_stack+49575,int_stack+61185,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+59025,int_stack+122220,int_stack+32475,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+135870,int_stack+59025,int_stack+107370,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+107370,int_stack+20040,int_stack+18000,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+27750,int_stack+107370,int_stack+44175,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+156660,int_stack+27750,int_stack+49575,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+38550,int_stack+156660,int_stack+122220,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+172410,int_stack+38550,int_stack+59025,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+196980,int_stack+172410,int_stack+135870,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+59025,int_stack+22335,int_stack+20040,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+113490,int_stack+59025,int_stack+107370,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+125730,int_stack+113490,int_stack+27750,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+224700,int_stack+125730,int_stack+156660,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+143730,int_stack+224700,int_stack+38550,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+248325,int_stack+143730,int_stack+172410,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+281085,int_stack+248325,int_stack+196980,15);
 /*--- compute (g0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+27750,int_stack+24900,int_stack+22335,15);
 /*--- compute (g0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+35445,int_stack+27750,int_stack+59025,15);
 /*--- compute (g0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+49215,int_stack+35445,int_stack+113490,15);
 /*--- compute (g0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+172395,int_stack+49215,int_stack+125730,15);
 /*--- compute (g0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+107370,int_stack+172395,int_stack+224700,15);
 /*--- compute (g0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+172395,int_stack+107370,int_stack+143730,15);
 /*--- compute (g0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+107370,int_stack+172395,int_stack+248325,15);
 /*--- compute (g0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+149490,int_stack+107370,int_stack+281085,15);
 /*--- compute (fp|nl) ---*/
 hrr1_build_fp(Libint->AB,int_stack+194040,int_stack+149490,int_stack+77670,2970);
 return int_stack+194040;}
