/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdkd(Libint_t*, prim_data*);

  /* Computes quartets of (gd|kd) integrals */

REALTYPE *hrr_order_gdkd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][7] = int_stack + 0;
 Libint->vrr_classes[4][8] = int_stack + 540;
 Libint->vrr_classes[4][9] = int_stack + 1215;
 Libint->vrr_classes[5][7] = int_stack + 2040;
 Libint->vrr_classes[5][8] = int_stack + 2796;
 Libint->vrr_classes[5][9] = int_stack + 3741;
 Libint->vrr_classes[6][7] = int_stack + 4896;
 Libint->vrr_classes[6][8] = int_stack + 5904;
 Libint->vrr_classes[6][9] = int_stack + 7164;
 memset(int_stack,0,8704*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 8704;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdkd(Libint, Data);
   Data++;
 }
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+8704,int_stack+540,int_stack+0,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+10324,int_stack+1215,int_stack+540,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+12349,int_stack+10324,int_stack+8704,15);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+8704,int_stack+2796,int_stack+2040,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15589,int_stack+3741,int_stack+2796,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+0,int_stack+15589,int_stack+8704,21);
 /*--- compute (gp|kd) ---*/
 hrr1_build_gp(Libint->AB,int_stack+15589,int_stack+0,int_stack+12349,216);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+8704,int_stack+5904,int_stack+4896,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+11728,int_stack+7164,int_stack+5904,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+25309,int_stack+11728,int_stack+8704,28);
 /*--- compute (hp|kd) ---*/
 hrr1_build_hp(Libint->AB,int_stack+31357,int_stack+25309,int_stack+0,216);
 /*--- compute (gd|kd) ---*/
 hrr1_build_gd(Libint->AB,int_stack+44965,int_stack+31357,int_stack+15589,216);
 return int_stack+44965;}
