/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdlh(Libint_t*, prim_data*);

  /* Computes quartets of (gd|lh) integrals */

REALTYPE *hrr_order_gdlh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][8] = int_stack + 0;
 Libint->vrr_classes[4][9] = int_stack + 675;
 Libint->vrr_classes[4][10] = int_stack + 1500;
 Libint->vrr_classes[4][11] = int_stack + 2490;
 Libint->vrr_classes[4][12] = int_stack + 3660;
 Libint->vrr_classes[4][13] = int_stack + 5025;
 Libint->vrr_classes[5][8] = int_stack + 6600;
 Libint->vrr_classes[5][9] = int_stack + 7545;
 Libint->vrr_classes[5][10] = int_stack + 8700;
 Libint->vrr_classes[5][11] = int_stack + 10086;
 Libint->vrr_classes[5][12] = int_stack + 11724;
 Libint->vrr_classes[5][13] = int_stack + 13635;
 Libint->vrr_classes[6][8] = int_stack + 15840;
 Libint->vrr_classes[6][9] = int_stack + 17100;
 Libint->vrr_classes[6][10] = int_stack + 18640;
 Libint->vrr_classes[6][11] = int_stack + 20488;
 Libint->vrr_classes[6][12] = int_stack + 22672;
 Libint->vrr_classes[6][13] = int_stack + 25220;
 memset(int_stack,0,28160*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 28160;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdlh(Libint, Data);
   Data++;
 }
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+28160,int_stack+675,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+30185,int_stack+1500,int_stack+675,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+32660,int_stack+30185,int_stack+28160,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+36710,int_stack+2490,int_stack+1500,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+39680,int_stack+36710,int_stack+30185,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+44630,int_stack+39680,int_stack+32660,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+28160,int_stack+3660,int_stack+2490,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51380,int_stack+28160,int_stack+36710,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+57320,int_stack+51380,int_stack+39680,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+31670,int_stack+57320,int_stack+44630,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+41795,int_stack+5025,int_stack+3660,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+65570,int_stack+41795,int_stack+28160,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+72590,int_stack+65570,int_stack+51380,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+41795,int_stack+72590,int_stack+57320,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+54170,int_stack+41795,int_stack+31670,15);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+28160,int_stack+7545,int_stack+6600,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+30995,int_stack+8700,int_stack+7545,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+34460,int_stack+30995,int_stack+28160,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+40130,int_stack+10086,int_stack+8700,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+44288,int_stack+40130,int_stack+30995,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+68345,int_stack+44288,int_stack+34460,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+28160,int_stack+11724,int_stack+10086,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+28160,int_stack+40130,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+77795,int_stack+0,int_stack+44288,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+33074,int_stack+77795,int_stack+68345,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+68345,int_stack+13635,int_stack+11724,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+89345,int_stack+68345,int_stack+28160,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+99173,int_stack+89345,int_stack+0,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+113033,int_stack+99173,int_stack+77795,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+68345,int_stack+113033,int_stack+33074,21);
 /*--- compute (gp|lh) ---*/
 hrr1_build_gp(Libint->AB,int_stack+88190,int_stack+68345,int_stack+54170,945);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+17100,int_stack+15840,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3780,int_stack+18640,int_stack+17100,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+8400,int_stack+3780,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+28160,int_stack+20488,int_stack+18640,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33704,int_stack+28160,int_stack+3780,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+42944,int_stack+33704,int_stack+8400,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+22672,int_stack+20488,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+6552,int_stack+0,int_stack+28160,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+130715,int_stack+6552,int_stack+33704,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+146115,int_stack+130715,int_stack+42944,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+28160,int_stack+25220,int_stack+22672,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+35804,int_stack+28160,int_stack+0,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+48908,int_stack+35804,int_stack+6552,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+48908,int_stack+130715,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+23100,int_stack+0,int_stack+146115,28);
 /*--- compute (hp|lh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+130715,int_stack+23100,int_stack+68345,945);
 /*--- compute (gd|lh) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+130715,int_stack+88190,945);
 return int_stack+0;}
