/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdnf(Libint_t*, prim_data*);

  /* Computes quartets of (gd|nf) integrals */

REALTYPE *hrr_order_gdnf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[5][10] = int_stack + 5100;
 Libint->vrr_classes[5][11] = int_stack + 6486;
 Libint->vrr_classes[5][12] = int_stack + 8124;
 Libint->vrr_classes[5][13] = int_stack + 10035;
 Libint->vrr_classes[6][10] = int_stack + 12240;
 Libint->vrr_classes[6][11] = int_stack + 14088;
 Libint->vrr_classes[6][12] = int_stack + 16272;
 Libint->vrr_classes[6][13] = int_stack + 18820;
 memset(int_stack,0,21760*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 21760;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdnf(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21760,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+24730,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28240,int_stack+24730,int_stack+21760,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+34180,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+38275,int_stack+34180,int_stack+24730,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+45295,int_stack+38275,int_stack+28240,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21760,int_stack+6486,int_stack+5100,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+25918,int_stack+8124,int_stack+6486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+30832,int_stack+25918,int_stack+21760,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+39148,int_stack+10035,int_stack+8124,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+39148,int_stack+25918,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+55195,int_stack+0,int_stack+30832,21);
 /*--- compute (gp|nf) ---*/
 hrr1_build_gp(Libint->AB,int_stack+69055,int_stack+55195,int_stack+45295,660);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+14088,int_stack+12240,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5544,int_stack+16272,int_stack+14088,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+21760,int_stack+5544,int_stack+0,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+32848,int_stack+18820,int_stack+16272,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+40492,int_stack+32848,int_stack+5544,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+40492,int_stack+21760,28);
 /*--- compute (hp|nf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+98755,int_stack+0,int_stack+55195,660);
 /*--- compute (gd|nf) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+98755,int_stack+69055,660);
 return int_stack+0;}
