/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdng(Libint_t*, prim_data*);

  /* Computes quartets of (gd|ng) integrals */

REALTYPE *hrr_order_gdng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[5][10] = int_stack + 6900;
 Libint->vrr_classes[5][11] = int_stack + 8286;
 Libint->vrr_classes[5][12] = int_stack + 9924;
 Libint->vrr_classes[5][13] = int_stack + 11835;
 Libint->vrr_classes[5][14] = int_stack + 14040;
 Libint->vrr_classes[6][10] = int_stack + 16560;
 Libint->vrr_classes[6][11] = int_stack + 18408;
 Libint->vrr_classes[6][12] = int_stack + 20592;
 Libint->vrr_classes[6][13] = int_stack + 23140;
 Libint->vrr_classes[6][14] = int_stack + 26080;
 memset(int_stack,0,29440*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 29440;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdng(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+29440,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+32410,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+35920,int_stack+32410,int_stack+29440,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+41860,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+45955,int_stack+41860,int_stack+32410,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+52975,int_stack+45955,int_stack+35920,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+29440,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+62875,int_stack+29440,int_stack+41860,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+29440,int_stack+62875,int_stack+45955,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+62875,int_stack+29440,int_stack+52975,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+29440,int_stack+8286,int_stack+6900,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33598,int_stack+9924,int_stack+8286,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+38512,int_stack+33598,int_stack+29440,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+46828,int_stack+11835,int_stack+9924,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+52561,int_stack+46828,int_stack+33598,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+77725,int_stack+52561,int_stack+38512,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+29440,int_stack+14040,int_stack+11835,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+29440,int_stack+46828,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+29440,int_stack+0,int_stack+52561,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+91585,int_stack+29440,int_stack+77725,21);
 /*--- compute (gp|ng) ---*/
 hrr1_build_gp(Libint->AB,int_stack+112375,int_stack+91585,int_stack+62875,990);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+29440,int_stack+18408,int_stack+16560,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+34984,int_stack+20592,int_stack+18408,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+41536,int_stack+34984,int_stack+29440,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+52624,int_stack+23140,int_stack+20592,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+60268,int_stack+52624,int_stack+34984,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+60268,int_stack+41536,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+29440,int_stack+26080,int_stack+23140,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+73372,int_stack+29440,int_stack+52624,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+18480,int_stack+73372,int_stack+60268,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+40320,int_stack+18480,int_stack+0,28);
 /*--- compute (hp|ng) ---*/
 hrr1_build_hp(Libint->AB,int_stack+156925,int_stack+40320,int_stack+91585,990);
 /*--- compute (gd|ng) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+156925,int_stack+112375,990);
 return int_stack+0;}
