/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdnp(Libint_t*, prim_data*);

  /* Computes quartets of (gd|np) integrals */

REALTYPE *hrr_order_gdnp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[5][10] = int_stack + 2160;
 Libint->vrr_classes[5][11] = int_stack + 3546;
 Libint->vrr_classes[6][10] = int_stack + 5184;
 Libint->vrr_classes[6][11] = int_stack + 7032;
 memset(int_stack,0,9216*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 9216;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdnp(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9216,int_stack+990,int_stack+0,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12186,int_stack+3546,int_stack+2160,21);
 /*--- compute (gp|np) ---*/
 hrr1_build_gp(Libint->AB,int_stack+16344,int_stack+12186,int_stack+9216,198);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+25254,int_stack+7032,int_stack+5184,28);
 /*--- compute (hp|np) ---*/
 hrr1_build_hp(Libint->AB,int_stack+30798,int_stack+25254,int_stack+12186,198);
 /*--- compute (gd|np) ---*/
 hrr1_build_gd(Libint->AB,int_stack+43272,int_stack+30798,int_stack+16344,198);
 return int_stack+43272;}
