/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gfip(Libint_t*, prim_data*);

  /* Computes quartets of (gf|ip) integrals */

REALTYPE *hrr_order_gfip(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][6] = int_stack + 0;
 Libint->vrr_classes[4][7] = int_stack + 420;
 Libint->vrr_classes[5][6] = int_stack + 960;
 Libint->vrr_classes[5][7] = int_stack + 1548;
 Libint->vrr_classes[6][6] = int_stack + 2304;
 Libint->vrr_classes[6][7] = int_stack + 3088;
 Libint->vrr_classes[7][6] = int_stack + 4096;
 Libint->vrr_classes[7][7] = int_stack + 5104;
 memset(int_stack,0,6400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 6400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gfip(Libint, Data);
   Data++;
 }
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+6400,int_stack+420,int_stack+0,15);
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+7660,int_stack+1548,int_stack+960,21);
 /*--- compute (gp|ip) ---*/
 hrr1_build_gp(Libint->AB,int_stack+9424,int_stack+7660,int_stack+6400,84);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+13204,int_stack+3088,int_stack+2304,28);
 /*--- compute (hp|ip) ---*/
 hrr1_build_hp(Libint->AB,int_stack+15556,int_stack+13204,int_stack+7660,84);
 /*--- compute (gd|ip) ---*/
 hrr1_build_gd(Libint->AB,int_stack+20848,int_stack+15556,int_stack+9424,84);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+6400,int_stack+5104,int_stack+4096,36);
 /*--- compute (ip|ip) ---*/
 hrr1_build_ip(Libint->AB,int_stack+28408,int_stack+6400,int_stack+13204,84);
 /*--- compute (hd|ip) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+28408,int_stack+15556,84);
 /*--- compute (gf|ip) ---*/
 hrr1_build_gf(Libint->AB,int_stack+28408,int_stack+0,int_stack+20848,84);
 return int_stack+28408;}
