/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggnh(Libint_t*, prim_data*);

  /* Computes quartets of (gg|nh) integrals */

REALTYPE *hrr_order_ggnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[4][15] = int_stack + 6900;
 Libint->vrr_classes[5][10] = int_stack + 8940;
 Libint->vrr_classes[5][11] = int_stack + 10326;
 Libint->vrr_classes[5][12] = int_stack + 11964;
 Libint->vrr_classes[5][13] = int_stack + 13875;
 Libint->vrr_classes[5][14] = int_stack + 16080;
 Libint->vrr_classes[5][15] = int_stack + 18600;
 Libint->vrr_classes[6][10] = int_stack + 21456;
 Libint->vrr_classes[6][11] = int_stack + 23304;
 Libint->vrr_classes[6][12] = int_stack + 25488;
 Libint->vrr_classes[6][13] = int_stack + 28036;
 Libint->vrr_classes[6][14] = int_stack + 30976;
 Libint->vrr_classes[6][15] = int_stack + 34336;
 Libint->vrr_classes[7][10] = int_stack + 38144;
 Libint->vrr_classes[7][11] = int_stack + 40520;
 Libint->vrr_classes[7][12] = int_stack + 43328;
 Libint->vrr_classes[7][13] = int_stack + 46604;
 Libint->vrr_classes[7][14] = int_stack + 50384;
 Libint->vrr_classes[7][15] = int_stack + 54704;
 Libint->vrr_classes[8][10] = int_stack + 59600;
 Libint->vrr_classes[8][11] = int_stack + 62570;
 Libint->vrr_classes[8][12] = int_stack + 66080;
 Libint->vrr_classes[8][13] = int_stack + 70175;
 Libint->vrr_classes[8][14] = int_stack + 74900;
 Libint->vrr_classes[8][15] = int_stack + 80300;
 memset(int_stack,0,86420*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 86420;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggnh(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+86420,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+89390,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+92900,int_stack+89390,int_stack+86420,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+98840,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+102935,int_stack+98840,int_stack+89390,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+109955,int_stack+102935,int_stack+92900,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+86420,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+119855,int_stack+86420,int_stack+98840,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+91145,int_stack+119855,int_stack+102935,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+128045,int_stack+91145,int_stack+109955,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+102845,int_stack+6900,int_stack+5100,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+108245,int_stack+102845,int_stack+86420,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+142895,int_stack+108245,int_stack+119855,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+102845,int_stack+142895,int_stack+91145,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+142895,int_stack+102845,int_stack+128045,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+86420,int_stack+10326,int_stack+8940,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+90578,int_stack+11964,int_stack+10326,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+95492,int_stack+90578,int_stack+86420,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+103808,int_stack+13875,int_stack+11964,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+109541,int_stack+103808,int_stack+90578,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+119369,int_stack+109541,int_stack+95492,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+86420,int_stack+16080,int_stack+13875,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+86420,int_stack+103808,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+93035,int_stack+0,int_stack+109541,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+163685,int_stack+93035,int_stack+119369,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+109415,int_stack+18600,int_stack+16080,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+116975,int_stack+109415,int_stack+86420,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+184475,int_stack+116975,int_stack+0,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+109415,int_stack+184475,int_stack+93035,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+184475,int_stack+109415,int_stack+163685,21);
 /*--- compute (gp|nh) ---*/
 hrr1_build_gp(Libint->AB,int_stack+213581,int_stack+184475,int_stack+142895,1386);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+23304,int_stack+21456,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5544,int_stack+25488,int_stack+23304,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+12096,int_stack+5544,int_stack+0,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86420,int_stack+28036,int_stack+25488,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+94064,int_stack+86420,int_stack+5544,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+107168,int_stack+94064,int_stack+12096,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+30976,int_stack+28036,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+8820,int_stack+0,int_stack+86420,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+125648,int_stack+8820,int_stack+94064,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+147488,int_stack+125648,int_stack+107168,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+86420,int_stack+34336,int_stack+30976,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+96500,int_stack+86420,int_stack+0,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+275951,int_stack+96500,int_stack+8820,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+275951,int_stack+125648,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+86420,int_stack+0,int_stack+147488,28);
 /*--- compute (hp|nh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+275951,int_stack+86420,int_stack+184475,1386);
 /*--- compute (gd|nh) ---*/
 hrr1_build_gd(Libint->AB,int_stack+363269,int_stack+275951,int_stack+213581,1386);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+40520,int_stack+38144,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+7128,int_stack+43328,int_stack+40520,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15552,int_stack+7128,int_stack+0,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+29808,int_stack+46604,int_stack+43328,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+125228,int_stack+29808,int_stack+7128,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142076,int_stack+125228,int_stack+15552,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+50384,int_stack+46604,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+165836,int_stack+0,int_stack+29808,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+11340,int_stack+165836,int_stack+125228,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+185492,int_stack+11340,int_stack+142076,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+125228,int_stack+54704,int_stack+50384,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+138188,int_stack+125228,int_stack+0,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+221132,int_stack+138188,int_stack+165836,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+125228,int_stack+221132,int_stack+11340,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+221132,int_stack+125228,int_stack+185492,36);
 /*--- compute (ip|nh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+488009,int_stack+221132,int_stack+86420,1386);
 /*--- compute (hd|nh) ---*/
 hrr1_build_hd(Libint->AB,int_stack+604433,int_stack+488009,int_stack+275951,1386);
 /*--- compute (gf|nh) ---*/
 hrr1_build_gf(Libint->AB,int_stack+779069,int_stack+604433,int_stack+363269,1386);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+86420,int_stack+62570,int_stack+59600,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+95330,int_stack+66080,int_stack+62570,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+105860,int_stack+95330,int_stack+86420,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+123680,int_stack+70175,int_stack+66080,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+135965,int_stack+123680,int_stack+95330,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+157025,int_stack+135965,int_stack+105860,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+86420,int_stack+74900,int_stack+70175,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+186725,int_stack+86420,int_stack+123680,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+100595,int_stack+186725,int_stack+135965,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+271028,int_stack+100595,int_stack+157025,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+135695,int_stack+80300,int_stack+74900,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+151895,int_stack+135695,int_stack+86420,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+315578,int_stack+151895,int_stack+186725,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+135695,int_stack+315578,int_stack+100595,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+315578,int_stack+135695,int_stack+271028,45);
 /*--- compute (kp|nh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+0,int_stack+315578,int_stack+221132,1386);
 /*--- compute (id|nh) ---*/
 hrr1_build_id(Libint->AB,int_stack+149688,int_stack+0,int_stack+488009,1386);
 /*--- compute (hf|nh) ---*/
 hrr1_build_hf(Libint->AB,int_stack+986969,int_stack+149688,int_stack+604433,1386);
 /*--- compute (gg|nh) ---*/
 hrr1_build_gg(Libint->AB,int_stack+0,int_stack+986969,int_stack+779069,1386);
 return int_stack+0;}
