/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpnn(Libint_t*, prim_data*);

  /* Computes quartets of (gp|nn) integrals */

REALTYPE *hrr_order_gpnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[4][15] = int_stack + 6900;
 Libint->vrr_classes[4][16] = int_stack + 8940;
 Libint->vrr_classes[4][17] = int_stack + 11235;
 Libint->vrr_classes[4][18] = int_stack + 13800;
 Libint->vrr_classes[4][19] = int_stack + 16650;
 Libint->vrr_classes[4][20] = int_stack + 19800;
 Libint->vrr_classes[5][10] = int_stack + 23265;
 Libint->vrr_classes[5][11] = int_stack + 24651;
 Libint->vrr_classes[5][12] = int_stack + 26289;
 Libint->vrr_classes[5][13] = int_stack + 28200;
 Libint->vrr_classes[5][14] = int_stack + 30405;
 Libint->vrr_classes[5][15] = int_stack + 32925;
 Libint->vrr_classes[5][16] = int_stack + 35781;
 Libint->vrr_classes[5][17] = int_stack + 38994;
 Libint->vrr_classes[5][18] = int_stack + 42585;
 Libint->vrr_classes[5][19] = int_stack + 46575;
 Libint->vrr_classes[5][20] = int_stack + 50985;
 memset(int_stack,0,55836*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 55836;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpnn(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+55836,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+58806,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+62316,int_stack+58806,int_stack+55836,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+68256,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72351,int_stack+68256,int_stack+58806,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+79371,int_stack+72351,int_stack+62316,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+55836,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+89271,int_stack+55836,int_stack+68256,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+60561,int_stack+89271,int_stack+72351,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+97461,int_stack+60561,int_stack+79371,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+72261,int_stack+6900,int_stack+5100,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+77661,int_stack+72261,int_stack+55836,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+112311,int_stack+77661,int_stack+89271,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+125961,int_stack+112311,int_stack+60561,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+143511,int_stack+125961,int_stack+97461,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+55836,int_stack+8940,int_stack+6900,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+87111,int_stack+55836,int_stack+72261,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+164301,int_stack+87111,int_stack+77661,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+61956,int_stack+164301,int_stack+112311,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+97911,int_stack+61956,int_stack+125961,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+180051,int_stack+97911,int_stack+143511,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+122481,int_stack+11235,int_stack+8940,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+129366,int_stack+122481,int_stack+55836,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+141606,int_stack+129366,int_stack+87111,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+207771,int_stack+141606,int_stack+164301,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+231396,int_stack+207771,int_stack+61956,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+55836,int_stack+231396,int_stack+97911,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+260061,int_stack+55836,int_stack+180051,15);
 /*--- compute (g0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+88596,int_stack+13800,int_stack+11235,15);
 /*--- compute (g0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+96291,int_stack+88596,int_stack+122481,15);
 /*--- compute (g0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+159606,int_stack+96291,int_stack+129366,15);
 /*--- compute (g0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+110061,int_stack+159606,int_stack+141606,15);
 /*--- compute (g0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+295701,int_stack+110061,int_stack+207771,15);
 /*--- compute (g0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+180006,int_stack+295701,int_stack+231396,15);
 /*--- compute (g0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+328776,int_stack+180006,int_stack+55836,15);
 /*--- compute (g0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+370896,int_stack+328776,int_stack+260061,15);
 /*--- compute (g0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+55836,int_stack+16650,int_stack+13800,15);
 /*--- compute (g0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+64386,int_stack+55836,int_stack+88596,15);
 /*--- compute (g0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+218226,int_stack+64386,int_stack+96291,15);
 /*--- compute (g0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+241176,int_stack+218226,int_stack+159606,15);
 /*--- compute (g0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+137061,int_stack+241176,int_stack+110061,15);
 /*--- compute (g0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+79776,int_stack+137061,int_stack+295701,15);
 /*--- compute (g0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+271776,int_stack+79776,int_stack+180006,15);
 /*--- compute (g0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+415446,int_stack+271776,int_stack+328776,15);
 /*--- compute (g0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+468096,int_stack+415446,int_stack+370896,15);
 /*--- compute (g0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+123876,int_stack+19800,int_stack+16650,15);
 /*--- compute (g0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+174861,int_stack+123876,int_stack+55836,15);
 /*--- compute (g0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+191961,int_stack+174861,int_stack+64386,15);
 /*--- compute (g0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+320916,int_stack+191961,int_stack+218226,15);
 /*--- compute (g0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+174861,int_stack+320916,int_stack+241176,15);
 /*--- compute (g0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+320916,int_stack+174861,int_stack+137061,15);
 /*--- compute (g0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+123876,int_stack+320916,int_stack+79776,15);
 /*--- compute (g0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+320916,int_stack+123876,int_stack+271776,15);
 /*--- compute (g0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+55836,int_stack+320916,int_stack+415446,15);
 /*--- compute (g0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+120186,int_stack+55836,int_stack+468096,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+55836,int_stack+24651,int_stack+23265,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+59994,int_stack+26289,int_stack+24651,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+64908,int_stack+59994,int_stack+55836,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+73224,int_stack+28200,int_stack+26289,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+78957,int_stack+73224,int_stack+59994,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+88785,int_stack+78957,int_stack+64908,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+55836,int_stack+30405,int_stack+28200,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+102645,int_stack+55836,int_stack+73224,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+62451,int_stack+102645,int_stack+78957,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+185526,int_stack+62451,int_stack+88785,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+78831,int_stack+32925,int_stack+30405,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+86391,int_stack+78831,int_stack+55836,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+206316,int_stack+86391,int_stack+102645,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+225426,int_stack+206316,int_stack+62451,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+249996,int_stack+225426,int_stack+185526,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+185526,int_stack+35781,int_stack+32925,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+55836,int_stack+185526,int_stack+78831,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+279102,int_stack+55836,int_stack+86391,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+70956,int_stack+279102,int_stack+206316,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+301152,int_stack+70956,int_stack+225426,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+194094,int_stack+301152,int_stack+249996,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+232902,int_stack+38994,int_stack+35781,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+242541,int_stack+232902,int_stack+185526,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+335550,int_stack+242541,int_stack+55836,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+360750,int_stack+335550,int_stack+279102,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+259677,int_stack+360750,int_stack+70956,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+55836,int_stack+259677,int_stack+301152,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+393825,int_stack+55836,int_stack+194094,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+101700,int_stack+42585,int_stack+38994,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+185526,int_stack+101700,int_stack+232902,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+204804,int_stack+185526,int_stack+242541,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+443721,int_stack+204804,int_stack+335550,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+299808,int_stack+443721,int_stack+360750,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+481521,int_stack+299808,int_stack+259677,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+233364,int_stack+481521,int_stack+55836,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+535029,int_stack+233364,int_stack+393825,21);
 /*--- compute (h0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+55836,int_stack+46575,int_stack+42585,21);
 /*--- compute (h0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+67806,int_stack+55836,int_stack+101700,21);
 /*--- compute (h0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+346113,int_stack+67806,int_stack+185526,21);
 /*--- compute (h0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+378243,int_stack+346113,int_stack+204804,21);
 /*--- compute (h0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+597399,int_stack+378243,int_stack+443721,21);
 /*--- compute (h0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+650319,int_stack+597399,int_stack+299808,21);
 /*--- compute (h0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+712059,int_stack+650319,int_stack+481521,21);
 /*--- compute (h0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+421083,int_stack+712059,int_stack+233364,21);
 /*--- compute (h0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+185526,int_stack+421083,int_stack+535029,21);
 /*--- compute (h0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+261756,int_stack+50985,int_stack+46575,21);
 /*--- compute (h0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+274986,int_stack+261756,int_stack+55836,21);
 /*--- compute (h0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+298926,int_stack+274986,int_stack+67806,21);
 /*--- compute (h0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+494793,int_stack+298926,int_stack+346113,21);
 /*--- compute (h0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+261756,int_stack+494793,int_stack+378243,21);
 /*--- compute (h0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+494793,int_stack+261756,int_stack+597399,21);
 /*--- compute (h0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+261756,int_stack+494793,int_stack+650319,21);
 /*--- compute (h0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+494793,int_stack+261756,int_stack+712059,21);
 /*--- compute (h0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+261756,int_stack+494793,int_stack+421083,21);
 /*--- compute (h0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+351846,int_stack+261756,int_stack+185526,21);
 /*--- compute (gp|nn) ---*/
 hrr1_build_gp(Libint->AB,int_stack+443322,int_stack+351846,int_stack+120186,4356);
 return int_stack+443322;}
