/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdig(Libint_t*, prim_data*);

  /* Computes quartets of (hd|ig) integrals */

REALTYPE *hrr_order_hdig(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][6] = int_stack + 0;
 Libint->vrr_classes[5][7] = int_stack + 588;
 Libint->vrr_classes[5][8] = int_stack + 1344;
 Libint->vrr_classes[5][9] = int_stack + 2289;
 Libint->vrr_classes[5][10] = int_stack + 3444;
 Libint->vrr_classes[6][6] = int_stack + 4830;
 Libint->vrr_classes[6][7] = int_stack + 5614;
 Libint->vrr_classes[6][8] = int_stack + 6622;
 Libint->vrr_classes[6][9] = int_stack + 7882;
 Libint->vrr_classes[6][10] = int_stack + 9422;
 Libint->vrr_classes[7][6] = int_stack + 11270;
 Libint->vrr_classes[7][7] = int_stack + 12278;
 Libint->vrr_classes[7][8] = int_stack + 13574;
 Libint->vrr_classes[7][9] = int_stack + 15194;
 Libint->vrr_classes[7][10] = int_stack + 17174;
 memset(int_stack,0,19550*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 19550;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdig(Libint, Data);
   Data++;
 }
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+19550,int_stack+588,int_stack+0,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+21314,int_stack+1344,int_stack+588,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+23582,int_stack+21314,int_stack+19550,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+27110,int_stack+2289,int_stack+1344,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+29945,int_stack+27110,int_stack+21314,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+34481,int_stack+29945,int_stack+23582,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+19550,int_stack+3444,int_stack+2289,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+40361,int_stack+19550,int_stack+27110,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+19550,int_stack+40361,int_stack+29945,21);
 /*--- compute (h0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+40361,int_stack+19550,int_stack+34481,21);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+19550,int_stack+5614,int_stack+4830,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+21902,int_stack+6622,int_stack+5614,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+24926,int_stack+21902,int_stack+19550,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+29630,int_stack+7882,int_stack+6622,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+33410,int_stack+29630,int_stack+21902,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+33410,int_stack+24926,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+19550,int_stack+9422,int_stack+7882,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+49181,int_stack+19550,int_stack+29630,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+19550,int_stack+49181,int_stack+33410,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+49181,int_stack+19550,int_stack+0,28);
 /*--- compute (hp|ig) ---*/
 hrr1_build_hp(Libint->AB,int_stack+60941,int_stack+49181,int_stack+40361,420);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+12278,int_stack+11270,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3024,int_stack+13574,int_stack+12278,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+6912,int_stack+3024,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+19550,int_stack+15194,int_stack+13574,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+24410,int_stack+19550,int_stack+3024,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+32186,int_stack+24410,int_stack+6912,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+17174,int_stack+15194,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+5940,int_stack+0,int_stack+19550,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+87401,int_stack+5940,int_stack+24410,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+0,int_stack+87401,int_stack+32186,36);
 /*--- compute (ip|ig) ---*/
 hrr1_build_ip(Libint->AB,int_stack+87401,int_stack+0,int_stack+49181,420);
 /*--- compute (hd|ig) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+87401,int_stack+60941,420);
 return int_stack+0;}
