/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdlk(Libint_t*, prim_data*);

  /* Computes quartets of (hd|lk) integrals */

REALTYPE *hrr_order_hdlk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[5][12] = int_stack + 5124;
 Libint->vrr_classes[5][13] = int_stack + 7035;
 Libint->vrr_classes[5][14] = int_stack + 9240;
 Libint->vrr_classes[5][15] = int_stack + 11760;
 Libint->vrr_classes[6][8] = int_stack + 14616;
 Libint->vrr_classes[6][9] = int_stack + 15876;
 Libint->vrr_classes[6][10] = int_stack + 17416;
 Libint->vrr_classes[6][11] = int_stack + 19264;
 Libint->vrr_classes[6][12] = int_stack + 21448;
 Libint->vrr_classes[6][13] = int_stack + 23996;
 Libint->vrr_classes[6][14] = int_stack + 26936;
 Libint->vrr_classes[6][15] = int_stack + 30296;
 Libint->vrr_classes[7][8] = int_stack + 34104;
 Libint->vrr_classes[7][9] = int_stack + 35724;
 Libint->vrr_classes[7][10] = int_stack + 37704;
 Libint->vrr_classes[7][11] = int_stack + 40080;
 Libint->vrr_classes[7][12] = int_stack + 42888;
 Libint->vrr_classes[7][13] = int_stack + 46164;
 Libint->vrr_classes[7][14] = int_stack + 49944;
 Libint->vrr_classes[7][15] = int_stack + 54264;
 memset(int_stack,0,59160*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 59160;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdlk(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+59160,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+61995,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+65460,int_stack+61995,int_stack+59160,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+71130,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+75288,int_stack+71130,int_stack+61995,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+82218,int_stack+75288,int_stack+65460,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+59160,int_stack+5124,int_stack+3486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+91668,int_stack+59160,int_stack+71130,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+99984,int_stack+91668,int_stack+75288,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+64074,int_stack+99984,int_stack+82218,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+78249,int_stack+7035,int_stack+5124,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+111534,int_stack+78249,int_stack+59160,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+121362,int_stack+111534,int_stack+91668,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+135222,int_stack+121362,int_stack+99984,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+83982,int_stack+135222,int_stack+64074,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+59160,int_stack+9240,int_stack+7035,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+65775,int_stack+59160,int_stack+78249,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+152547,int_stack+65775,int_stack+111534,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+168927,int_stack+152547,int_stack+121362,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+103827,int_stack+168927,int_stack+135222,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+189717,int_stack+103827,int_stack+83982,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+77241,int_stack+11760,int_stack+9240,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+84801,int_stack+77241,int_stack+59160,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+128082,int_stack+84801,int_stack+65775,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+59160,int_stack+128082,int_stack+152547,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+128082,int_stack+59160,int_stack+168927,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+59160,int_stack+128082,int_stack+103827,21);
 /*--- compute (h0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+91500,int_stack+59160,int_stack+189717,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+59160,int_stack+15876,int_stack+14616,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+62940,int_stack+17416,int_stack+15876,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+67560,int_stack+62940,int_stack+59160,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+75120,int_stack+19264,int_stack+17416,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+80664,int_stack+75120,int_stack+62940,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+125520,int_stack+80664,int_stack+67560,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+59160,int_stack+21448,int_stack+19264,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+138120,int_stack+59160,int_stack+75120,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+149208,int_stack+138120,int_stack+80664,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+65712,int_stack+149208,int_stack+125520,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+125520,int_stack+23996,int_stack+21448,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+164608,int_stack+125520,int_stack+59160,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+177712,int_stack+164608,int_stack+138120,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+177712,int_stack+149208,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+133164,int_stack+0,int_stack+65712,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+59160,int_stack+26936,int_stack+23996,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+67980,int_stack+59160,int_stack+125520,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+196192,int_stack+67980,int_stack+164608,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+218032,int_stack+196192,int_stack+177712,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+159624,int_stack+218032,int_stack+0,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+245752,int_stack+159624,int_stack+133164,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+30296,int_stack+26936,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+10080,int_stack+0,int_stack+59160,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+125520,int_stack+10080,int_stack+67980,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+125520,int_stack+196192,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+281032,int_stack+0,int_stack+218032,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+191964,int_stack+281032,int_stack+159624,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+125520,int_stack+191964,int_stack+245752,28);
 /*--- compute (hp|lk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+170880,int_stack+125520,int_stack+91500,1620);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+35724,int_stack+34104,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+4860,int_stack+37704,int_stack+35724,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+10800,int_stack+4860,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+20520,int_stack+40080,int_stack+37704,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+27648,int_stack+20520,int_stack+4860,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+272940,int_stack+27648,int_stack+10800,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+42888,int_stack+40080,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+289140,int_stack+0,int_stack+20520,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+59160,int_stack+289140,int_stack+27648,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+8424,int_stack+59160,int_stack+272940,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+272940,int_stack+46164,int_stack+42888,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+78960,int_stack+272940,int_stack+0,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+95808,int_stack+78960,int_stack+289140,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+282768,int_stack+95808,int_stack+59160,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+312468,int_stack+282768,int_stack+8424,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+59160,int_stack+49944,int_stack+46164,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+59160,int_stack+272940,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+19656,int_stack+0,int_stack+78960,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+346488,int_stack+19656,int_stack+95808,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+70500,int_stack+346488,int_stack+282768,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+382128,int_stack+70500,int_stack+312468,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+272940,int_stack+54264,int_stack+49944,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+285900,int_stack+272940,int_stack+59160,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+308580,int_stack+285900,int_stack+0,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+427488,int_stack+308580,int_stack+19656,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+427488,int_stack+346488,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+272940,int_stack+0,int_stack+70500,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+0,int_stack+272940,int_stack+382128,36);
 /*--- compute (ip|lk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+272940,int_stack+0,int_stack+125520,1620);
 /*--- compute (hd|lk) ---*/
 hrr1_build_hd(Libint->AB,int_stack+409020,int_stack+272940,int_stack+170880,1620);
 return int_stack+409020;}
