/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdmg(Libint_t*, prim_data*);

  /* Computes quartets of (hd|mg) integrals */

REALTYPE *hrr_order_hdmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[6][9] = int_stack + 8295;
 Libint->vrr_classes[6][10] = int_stack + 9835;
 Libint->vrr_classes[6][11] = int_stack + 11683;
 Libint->vrr_classes[6][12] = int_stack + 13867;
 Libint->vrr_classes[6][13] = int_stack + 16415;
 Libint->vrr_classes[7][9] = int_stack + 19355;
 Libint->vrr_classes[7][10] = int_stack + 21335;
 Libint->vrr_classes[7][11] = int_stack + 23711;
 Libint->vrr_classes[7][12] = int_stack + 26519;
 Libint->vrr_classes[7][13] = int_stack + 29795;
 memset(int_stack,0,33575*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 33575;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdmg(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33575,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37040,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+41198,int_stack+37040,int_stack+33575,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+48128,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+53042,int_stack+48128,int_stack+37040,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+61358,int_stack+53042,int_stack+41198,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+33575,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72908,int_stack+33575,int_stack+48128,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+33575,int_stack+72908,int_stack+53042,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+72908,int_stack+33575,int_stack+61358,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33575,int_stack+9835,int_stack+8295,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+38195,int_stack+11683,int_stack+9835,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+43739,int_stack+38195,int_stack+33575,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+52979,int_stack+13867,int_stack+11683,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+59531,int_stack+52979,int_stack+38195,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+90233,int_stack+59531,int_stack+43739,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+33575,int_stack+16415,int_stack+13867,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+33575,int_stack+52979,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+33575,int_stack+0,int_stack+59531,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+105633,int_stack+33575,int_stack+90233,28);
 /*--- compute (hp|mg) ---*/
 hrr1_build_hp(Libint->AB,int_stack+128733,int_stack+105633,int_stack+72908,825);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33575,int_stack+21335,int_stack+19355,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+39515,int_stack+23711,int_stack+21335,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+46643,int_stack+39515,int_stack+33575,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+58523,int_stack+26519,int_stack+23711,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+66947,int_stack+58523,int_stack+39515,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+81203,int_stack+66947,int_stack+46643,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+33575,int_stack+29795,int_stack+26519,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+33575,int_stack+58523,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+16848,int_stack+0,int_stack+66947,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+40608,int_stack+16848,int_stack+81203,36);
 /*--- compute (ip|mg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+180708,int_stack+40608,int_stack+105633,825);
 /*--- compute (hd|mg) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+180708,int_stack+128733,825);
 return int_stack+0;}
