/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdmh(Libint_t*, prim_data*);

  /* Computes quartets of (hd|mh) integrals */

REALTYPE *hrr_order_hdmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[5][14] = int_stack + 8295;
 Libint->vrr_classes[6][9] = int_stack + 10815;
 Libint->vrr_classes[6][10] = int_stack + 12355;
 Libint->vrr_classes[6][11] = int_stack + 14203;
 Libint->vrr_classes[6][12] = int_stack + 16387;
 Libint->vrr_classes[6][13] = int_stack + 18935;
 Libint->vrr_classes[6][14] = int_stack + 21875;
 Libint->vrr_classes[7][9] = int_stack + 25235;
 Libint->vrr_classes[7][10] = int_stack + 27215;
 Libint->vrr_classes[7][11] = int_stack + 29591;
 Libint->vrr_classes[7][12] = int_stack + 32399;
 Libint->vrr_classes[7][13] = int_stack + 35675;
 Libint->vrr_classes[7][14] = int_stack + 39455;
 memset(int_stack,0,43775*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 43775;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdmh(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+43775,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47240,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+51398,int_stack+47240,int_stack+43775,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+58328,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+63242,int_stack+58328,int_stack+47240,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+71558,int_stack+63242,int_stack+51398,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+43775,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+83108,int_stack+43775,int_stack+58328,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+92936,int_stack+83108,int_stack+63242,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+49508,int_stack+92936,int_stack+71558,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+66833,int_stack+8295,int_stack+6090,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+106796,int_stack+66833,int_stack+43775,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+118262,int_stack+106796,int_stack+83108,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+66833,int_stack+118262,int_stack+92936,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+87623,int_stack+66833,int_stack+49508,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+43775,int_stack+12355,int_stack+10815,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+48395,int_stack+14203,int_stack+12355,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+53939,int_stack+48395,int_stack+43775,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63179,int_stack+16387,int_stack+14203,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+69731,int_stack+63179,int_stack+48395,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+111878,int_stack+69731,int_stack+53939,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+43775,int_stack+18935,int_stack+16387,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+43775,int_stack+63179,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+127278,int_stack+0,int_stack+69731,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+51419,int_stack+127278,int_stack+111878,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+111878,int_stack+21875,int_stack+18935,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+145758,int_stack+111878,int_stack+43775,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+161046,int_stack+145758,int_stack+0,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+182886,int_stack+161046,int_stack+127278,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+111878,int_stack+182886,int_stack+51419,28);
 /*--- compute (hp|mh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+144218,int_stack+111878,int_stack+87623,1155);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+27215,int_stack+25235,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+5940,int_stack+29591,int_stack+27215,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+13068,int_stack+5940,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+43775,int_stack+32399,int_stack+29591,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+52199,int_stack+43775,int_stack+5940,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+66455,int_stack+52199,int_stack+13068,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+35675,int_stack+32399,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+9828,int_stack+0,int_stack+43775,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+86255,int_stack+9828,int_stack+52199,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+216983,int_stack+86255,int_stack+66455,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+43775,int_stack+39455,int_stack+35675,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+55115,int_stack+43775,int_stack+0,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+26676,int_stack+55115,int_stack+9828,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+246683,int_stack+26676,int_stack+86255,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+246683,int_stack+216983,36);
 /*--- compute (ip|mh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+216983,int_stack+0,int_stack+111878,1155);
 /*--- compute (hd|mh) ---*/
 hrr1_build_hd(Libint->AB,int_stack+314003,int_stack+216983,int_stack+144218,1155);
 return int_stack+314003;}
