/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdmm(Libint_t*, prim_data*);

  /* Computes quartets of (hd|mm) integrals */

REALTYPE *hrr_order_hdmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[5][14] = int_stack + 8295;
 Libint->vrr_classes[5][15] = int_stack + 10815;
 Libint->vrr_classes[5][16] = int_stack + 13671;
 Libint->vrr_classes[5][17] = int_stack + 16884;
 Libint->vrr_classes[5][18] = int_stack + 20475;
 Libint->vrr_classes[6][9] = int_stack + 24465;
 Libint->vrr_classes[6][10] = int_stack + 26005;
 Libint->vrr_classes[6][11] = int_stack + 27853;
 Libint->vrr_classes[6][12] = int_stack + 30037;
 Libint->vrr_classes[6][13] = int_stack + 32585;
 Libint->vrr_classes[6][14] = int_stack + 35525;
 Libint->vrr_classes[6][15] = int_stack + 38885;
 Libint->vrr_classes[6][16] = int_stack + 42693;
 Libint->vrr_classes[6][17] = int_stack + 46977;
 Libint->vrr_classes[6][18] = int_stack + 51765;
 Libint->vrr_classes[7][9] = int_stack + 57085;
 Libint->vrr_classes[7][10] = int_stack + 59065;
 Libint->vrr_classes[7][11] = int_stack + 61441;
 Libint->vrr_classes[7][12] = int_stack + 64249;
 Libint->vrr_classes[7][13] = int_stack + 67525;
 Libint->vrr_classes[7][14] = int_stack + 71305;
 Libint->vrr_classes[7][15] = int_stack + 75625;
 Libint->vrr_classes[7][16] = int_stack + 80521;
 Libint->vrr_classes[7][17] = int_stack + 86029;
 Libint->vrr_classes[7][18] = int_stack + 92185;
 memset(int_stack,0,99025*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 99025;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdmm(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+99025,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+102490,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+106648,int_stack+102490,int_stack+99025,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+113578,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+118492,int_stack+113578,int_stack+102490,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+126808,int_stack+118492,int_stack+106648,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+99025,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+138358,int_stack+99025,int_stack+113578,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+148186,int_stack+138358,int_stack+118492,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+104758,int_stack+148186,int_stack+126808,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+122083,int_stack+8295,int_stack+6090,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+162046,int_stack+122083,int_stack+99025,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+173512,int_stack+162046,int_stack+138358,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+189892,int_stack+173512,int_stack+148186,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+128698,int_stack+189892,int_stack+104758,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99025,int_stack+10815,int_stack+8295,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+106585,int_stack+99025,int_stack+122083,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+210682,int_stack+106585,int_stack+162046,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+229792,int_stack+210682,int_stack+173512,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+152953,int_stack+229792,int_stack+189892,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+254362,int_stack+152953,int_stack+128698,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+119815,int_stack+13671,int_stack+10815,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+128383,int_stack+119815,int_stack+99025,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+182059,int_stack+128383,int_stack+106585,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+286702,int_stack+182059,int_stack+210682,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+315367,int_stack+286702,int_stack+229792,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+204109,int_stack+315367,int_stack+152953,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+349765,int_stack+204109,int_stack+254362,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+99025,int_stack+16884,int_stack+13671,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+143503,int_stack+99025,int_stack+119815,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+242917,int_stack+143503,int_stack+128383,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+108664,int_stack+242917,int_stack+182059,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+160639,int_stack+108664,int_stack+286702,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+268117,int_stack+160639,int_stack+315367,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+391345,int_stack+268117,int_stack+204109,21);
 /*--- compute (h0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+441241,int_stack+391345,int_stack+349765,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+200770,int_stack+20475,int_stack+16884,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+211543,int_stack+200770,int_stack+99025,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+313981,int_stack+211543,int_stack+143503,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+200770,int_stack+313981,int_stack+242917,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+313981,int_stack+200770,int_stack+108664,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+200770,int_stack+313981,int_stack+160639,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+313981,int_stack+200770,int_stack+268117,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+99025,int_stack+313981,int_stack+391345,21);
 /*--- compute (h0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+161395,int_stack+99025,int_stack+441241,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+99025,int_stack+26005,int_stack+24465,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+103645,int_stack+27853,int_stack+26005,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+109189,int_stack+103645,int_stack+99025,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+118429,int_stack+30037,int_stack+27853,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+124981,int_stack+118429,int_stack+103645,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+136069,int_stack+124981,int_stack+109189,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+99025,int_stack+32585,int_stack+30037,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+224920,int_stack+99025,int_stack+118429,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+238024,int_stack+224920,int_stack+124981,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+106669,int_stack+238024,int_stack+136069,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+129769,int_stack+35525,int_stack+32585,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+138589,int_stack+129769,int_stack+99025,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+256504,int_stack+138589,int_stack+224920,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+278344,int_stack+256504,int_stack+238024,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+306064,int_stack+278344,int_stack+106669,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+224920,int_stack+38885,int_stack+35525,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+235000,int_stack+224920,int_stack+129769,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+99025,int_stack+235000,int_stack+138589,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+124505,int_stack+99025,int_stack+256504,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+338404,int_stack+124505,int_stack+278344,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+252640,int_stack+338404,int_stack+306064,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+295760,int_stack+42693,int_stack+38885,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+307184,int_stack+295760,int_stack+224920,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+377212,int_stack+307184,int_stack+235000,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+406612,int_stack+377212,int_stack+99025,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+444832,int_stack+406612,int_stack+124505,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+99025,int_stack+444832,int_stack+338404,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+490696,int_stack+99025,int_stack+252640,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+224920,int_stack+46977,int_stack+42693,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+237772,int_stack+224920,int_stack+295760,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+260620,int_stack+237772,int_stack+307184,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+294220,int_stack+260620,int_stack+377212,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+338320,int_stack+294220,int_stack+406612,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+546136,int_stack+338320,int_stack+444832,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+391828,int_stack+546136,int_stack+99025,28);
 /*--- compute (i0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+607288,int_stack+391828,int_stack+490696,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+99025,int_stack+51765,int_stack+46977,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+113389,int_stack+99025,int_stack+224920,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+458356,int_stack+113389,int_stack+237772,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+99025,int_stack+458356,int_stack+260620,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+458356,int_stack+99025,int_stack+294220,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+224920,int_stack+458356,int_stack+338320,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+458356,int_stack+224920,int_stack+546136,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+224920,int_stack+458356,int_stack+391828,28);
 /*--- compute (i0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+308080,int_stack+224920,int_stack+607288,28);
 /*--- compute (hp|mm) ---*/
 hrr1_build_hp(Libint->AB,int_stack+392780,int_stack+308080,int_stack+161395,3025);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+583355,int_stack+59065,int_stack+57085,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+589295,int_stack+61441,int_stack+59065,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+596423,int_stack+589295,int_stack+583355,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+608303,int_stack+64249,int_stack+61441,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+616727,int_stack+608303,int_stack+589295,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+630983,int_stack+616727,int_stack+596423,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+583355,int_stack+67525,int_stack+64249,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+650783,int_stack+583355,int_stack+608303,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+99025,int_stack+650783,int_stack+616727,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+593183,int_stack+99025,int_stack+630983,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+622883,int_stack+71305,int_stack+67525,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+122785,int_stack+622883,int_stack+583355,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+142441,int_stack+122785,int_stack+650783,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+634223,int_stack+142441,int_stack+99025,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+170521,int_stack+634223,int_stack+593183,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99025,int_stack+75625,int_stack+71305,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+583355,int_stack+99025,int_stack+622883,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+212101,int_stack+583355,int_stack+122785,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+244861,int_stack+212101,int_stack+142441,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+111985,int_stack+244861,int_stack+634223,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+606035,int_stack+111985,int_stack+170521,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+161881,int_stack+80521,int_stack+75625,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+176569,int_stack+161881,int_stack+99025,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+176569,int_stack+583355,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+661475,int_stack+0,int_stack+212101,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+710615,int_stack+661475,int_stack+244861,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+202489,int_stack+710615,int_stack+111985,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+769583,int_stack+202489,int_stack+606035,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+583355,int_stack+86029,int_stack+80521,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+599879,int_stack+583355,int_stack+161881,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+99025,int_stack+599879,int_stack+176569,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+142225,int_stack+99025,int_stack+0,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+142225,int_stack+661475,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+629255,int_stack+0,int_stack+710615,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+840863,int_stack+629255,int_stack+202489,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+198925,int_stack+840863,int_stack+769583,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+707879,int_stack+92185,int_stack+86029,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+726347,int_stack+707879,int_stack+583355,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+759395,int_stack+726347,int_stack+599879,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+926399,int_stack+759395,int_stack+99025,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+707879,int_stack+926399,int_stack+142225,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+68796,int_stack+707879,int_stack+0,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+707879,int_stack+68796,int_stack+629255,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+707879,int_stack+840863,36);
 /*--- compute (k0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+583355,int_stack+0,int_stack+198925,36);
 /*--- compute (ip|mm) ---*/
 hrr1_build_ip(Libint->AB,int_stack+0,int_stack+583355,int_stack+308080,3025);
 /*--- compute (hd|mm) ---*/
 hrr1_build_hd(Libint->AB,int_stack+583355,int_stack+0,int_stack+392780,3025);
 return int_stack+583355;}
