/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdnn(Libint_t*, prim_data*);

  /* Computes quartets of (hd|nn) integrals */

REALTYPE *hrr_order_hdnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[5][15] = int_stack + 9660;
 Libint->vrr_classes[5][16] = int_stack + 12516;
 Libint->vrr_classes[5][17] = int_stack + 15729;
 Libint->vrr_classes[5][18] = int_stack + 19320;
 Libint->vrr_classes[5][19] = int_stack + 23310;
 Libint->vrr_classes[5][20] = int_stack + 27720;
 Libint->vrr_classes[6][10] = int_stack + 32571;
 Libint->vrr_classes[6][11] = int_stack + 34419;
 Libint->vrr_classes[6][12] = int_stack + 36603;
 Libint->vrr_classes[6][13] = int_stack + 39151;
 Libint->vrr_classes[6][14] = int_stack + 42091;
 Libint->vrr_classes[6][15] = int_stack + 45451;
 Libint->vrr_classes[6][16] = int_stack + 49259;
 Libint->vrr_classes[6][17] = int_stack + 53543;
 Libint->vrr_classes[6][18] = int_stack + 58331;
 Libint->vrr_classes[6][19] = int_stack + 63651;
 Libint->vrr_classes[6][20] = int_stack + 69531;
 Libint->vrr_classes[7][10] = int_stack + 75999;
 Libint->vrr_classes[7][11] = int_stack + 78375;
 Libint->vrr_classes[7][12] = int_stack + 81183;
 Libint->vrr_classes[7][13] = int_stack + 84459;
 Libint->vrr_classes[7][14] = int_stack + 88239;
 Libint->vrr_classes[7][15] = int_stack + 92559;
 Libint->vrr_classes[7][16] = int_stack + 97455;
 Libint->vrr_classes[7][17] = int_stack + 102963;
 Libint->vrr_classes[7][18] = int_stack + 109119;
 Libint->vrr_classes[7][19] = int_stack + 115959;
 Libint->vrr_classes[7][20] = int_stack + 123519;
 memset(int_stack,0,131835*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 131835;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdnn(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+131835,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+135993,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+140907,int_stack+135993,int_stack+131835,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+149223,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+154956,int_stack+149223,int_stack+135993,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+164784,int_stack+154956,int_stack+140907,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+131835,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+178644,int_stack+131835,int_stack+149223,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+138450,int_stack+178644,int_stack+154956,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+190110,int_stack+138450,int_stack+164784,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+154830,int_stack+9660,int_stack+7140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+162390,int_stack+154830,int_stack+131835,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+210900,int_stack+162390,int_stack+178644,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+230010,int_stack+210900,int_stack+138450,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+254580,int_stack+230010,int_stack+190110,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+131835,int_stack+12516,int_stack+9660,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+175620,int_stack+131835,int_stack+154830,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+283686,int_stack+175620,int_stack+162390,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+140403,int_stack+283686,int_stack+210900,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+190740,int_stack+140403,int_stack+230010,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+305736,int_stack+190740,int_stack+254580,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+225138,int_stack+15729,int_stack+12516,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+234777,int_stack+225138,int_stack+131835,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+251913,int_stack+234777,int_stack+175620,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+344544,int_stack+251913,int_stack+283686,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+377619,int_stack+344544,int_stack+140403,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+131835,int_stack+377619,int_stack+190740,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+417750,int_stack+131835,int_stack+305736,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+177699,int_stack+19320,int_stack+15729,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+188472,int_stack+177699,int_stack+225138,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+277113,int_stack+188472,int_stack+234777,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+207750,int_stack+277113,int_stack+251913,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+467646,int_stack+207750,int_stack+344544,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+305673,int_stack+467646,int_stack+377619,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+513951,int_stack+305673,int_stack+131835,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+572919,int_stack+513951,int_stack+417750,21);
 /*--- compute (h0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+131835,int_stack+23310,int_stack+19320,21);
 /*--- compute (h0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+143805,int_stack+131835,int_stack+177699,21);
 /*--- compute (h0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+359181,int_stack+143805,int_stack+188472,21);
 /*--- compute (h0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+391311,int_stack+359181,int_stack+277113,21);
 /*--- compute (h0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+245550,int_stack+391311,int_stack+207750,21);
 /*--- compute (h0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+165351,int_stack+245550,int_stack+467646,21);
 /*--- compute (h0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+434151,int_stack+165351,int_stack+305673,21);
 /*--- compute (h0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+635289,int_stack+434151,int_stack+513951,21);
 /*--- compute (h0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+708999,int_stack+635289,int_stack+572919,21);
 /*--- compute (h0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+227091,int_stack+27720,int_stack+23310,21);
 /*--- compute (h0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+298470,int_stack+227091,int_stack+131835,21);
 /*--- compute (h0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+322410,int_stack+298470,int_stack+143805,21);
 /*--- compute (h0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+502947,int_stack+322410,int_stack+359181,21);
 /*--- compute (h0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+298470,int_stack+502947,int_stack+391311,21);
 /*--- compute (h0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+502947,int_stack+298470,int_stack+245550,21);
 /*--- compute (h0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+227091,int_stack+502947,int_stack+165351,21);
 /*--- compute (h0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+502947,int_stack+227091,int_stack+434151,21);
 /*--- compute (h0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+131835,int_stack+502947,int_stack+635289,21);
 /*--- compute (h0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+221925,int_stack+131835,int_stack+708999,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+131835,int_stack+34419,int_stack+32571,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+137379,int_stack+36603,int_stack+34419,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+143931,int_stack+137379,int_stack+131835,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+155019,int_stack+39151,int_stack+36603,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+162663,int_stack+155019,int_stack+137379,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+175767,int_stack+162663,int_stack+143931,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+131835,int_stack+42091,int_stack+39151,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+194247,int_stack+131835,int_stack+155019,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+140655,int_stack+194247,int_stack+162663,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+313401,int_stack+140655,int_stack+175767,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+162495,int_stack+45451,int_stack+42091,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+172575,int_stack+162495,int_stack+131835,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+341121,int_stack+172575,int_stack+194247,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+366601,int_stack+341121,int_stack+140655,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+399361,int_stack+366601,int_stack+313401,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+313401,int_stack+49259,int_stack+45451,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+131835,int_stack+313401,int_stack+162495,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+190215,int_stack+131835,int_stack+172575,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+151995,int_stack+190215,int_stack+341121,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+438169,int_stack+151995,int_stack+366601,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+324825,int_stack+438169,int_stack+399361,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+376569,int_stack+53543,int_stack+49259,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+389421,int_stack+376569,int_stack+313401,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+484033,int_stack+389421,int_stack+131835,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+517633,int_stack+484033,int_stack+190215,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+561733,int_stack+517633,int_stack+151995,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+131835,int_stack+561733,int_stack+438169,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+412269,int_stack+131835,int_stack+324825,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+192987,int_stack+58331,int_stack+53543,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+313401,int_stack+192987,int_stack+376569,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+339105,int_stack+313401,int_stack+389421,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+615241,int_stack+339105,int_stack+484033,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+665641,int_stack+615241,int_stack+517633,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+478797,int_stack+665641,int_stack+561733,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+727381,int_stack+478797,int_stack+131835,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+806005,int_stack+727381,int_stack+412269,28);
 /*--- compute (i0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+131835,int_stack+63651,int_stack+58331,28);
 /*--- compute (i0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+147795,int_stack+131835,int_stack+192987,28);
 /*--- compute (i0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+176523,int_stack+147795,int_stack+313401,28);
 /*--- compute (i0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+377185,int_stack+176523,int_stack+339105,28);
 /*--- compute (i0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+889165,int_stack+377185,int_stack+615241,28);
 /*--- compute (i0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+550141,int_stack+889165,int_stack+665641,28);
 /*--- compute (i0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+632461,int_stack+550141,int_stack+478797,28);
 /*--- compute (i0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+434305,int_stack+632461,int_stack+727381,28);
 /*--- compute (i0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+959725,int_stack+434305,int_stack+806005,28);
 /*--- compute (i0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+313401,int_stack+69531,int_stack+63651,28);
 /*--- compute (i0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+331041,int_stack+313401,int_stack+131835,28);
 /*--- compute (i0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+724189,int_stack+331041,int_stack+147795,28);
 /*--- compute (i0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+772069,int_stack+724189,int_stack+176523,28);
 /*--- compute (i0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+131835,int_stack+772069,int_stack+377185,28);
 /*--- compute (i0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+724189,int_stack+131835,int_stack+889165,28);
 /*--- compute (i0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+818269,int_stack+724189,int_stack+550141,28);
 /*--- compute (i0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+313401,int_stack+818269,int_stack+632461,28);
 /*--- compute (i0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+532585,int_stack+313401,int_stack+434305,28);
 /*--- compute (i0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+313401,int_stack+532585,int_stack+959725,28);
 /*--- compute (hp|nn) ---*/
 hrr1_build_hp(Libint->AB,int_stack+435369,int_stack+313401,int_stack+221925,4356);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+709797,int_stack+78375,int_stack+75999,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+716925,int_stack+81183,int_stack+78375,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+725349,int_stack+716925,int_stack+709797,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+739605,int_stack+84459,int_stack+81183,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+749433,int_stack+739605,int_stack+716925,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+766281,int_stack+749433,int_stack+725349,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+709797,int_stack+88239,int_stack+84459,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+790041,int_stack+709797,int_stack+739605,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+721137,int_stack+790041,int_stack+749433,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+809697,int_stack+721137,int_stack+766281,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+749217,int_stack+92559,int_stack+88239,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+762177,int_stack+749217,int_stack+709797,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+845337,int_stack+762177,int_stack+790041,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+878097,int_stack+845337,int_stack+721137,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+920217,int_stack+878097,int_stack+809697,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+709797,int_stack+97455,int_stack+92559,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+784857,int_stack+709797,int_stack+749217,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+970113,int_stack+784857,int_stack+762177,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+724485,int_stack+970113,int_stack+845337,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+810777,int_stack+724485,int_stack+878097,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+131835,int_stack+810777,int_stack+920217,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+869745,int_stack+102963,int_stack+97455,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+886269,int_stack+869745,int_stack+709797,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+915645,int_stack+886269,int_stack+784857,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+198363,int_stack+915645,int_stack+970113,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+958845,int_stack+198363,int_stack+724485,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+709797,int_stack+958845,int_stack+810777,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+709797,int_stack+131835,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+131835,int_stack+109119,int_stack+102963,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+150303,int_stack+131835,int_stack+869745,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+788421,int_stack+150303,int_stack+886269,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+837381,int_stack+788421,int_stack+915645,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1027641,int_stack+837381,int_stack+198363,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+183351,int_stack+1027641,int_stack+958845,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+902181,int_stack+183351,int_stack+709797,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1107021,int_stack+902181,int_stack+0,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+115959,int_stack+109119,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+20520,int_stack+0,int_stack+131835,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+57456,int_stack+20520,int_stack+150303,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+709797,int_stack+57456,int_stack+788421,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1213941,int_stack+709797,int_stack+837381,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+783237,int_stack+1213941,int_stack+1027641,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1304661,int_stack+783237,int_stack+183351,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+131835,int_stack+1304661,int_stack+902181,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+889077,int_stack+131835,int_stack+1107021,36);
 /*--- compute (k0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+258195,int_stack+123519,int_stack+115959,36);
 /*--- compute (k0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1019757,int_stack+258195,int_stack+0,36);
 /*--- compute (k0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1060797,int_stack+1019757,int_stack+20520,36);
 /*--- compute (k0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1122357,int_stack+1060797,int_stack+57456,36);
 /*--- compute (k0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+1122357,int_stack+709797,36);
 /*--- compute (k0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1019757,int_stack+0,int_stack+1213941,36);
 /*--- compute (k0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1140717,int_stack+1019757,int_stack+783237,36);
 /*--- compute (k0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+709797,int_stack+1140717,int_stack+1304661,36);
 /*--- compute (k0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1019757,int_stack+709797,int_stack+131835,36);
 /*--- compute (k0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+709797,int_stack+1019757,int_stack+889077,36);
 /*--- compute (ip|nn) ---*/
 hrr1_build_ip(Libint->AB,int_stack+866613,int_stack+709797,int_stack+313401,4356);
 /*--- compute (hd|nn) ---*/
 hrr1_build_hd(Libint->AB,int_stack+1232517,int_stack+866613,int_stack+435369,4356);
 return int_stack+1232517;}
