/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgkf(Libint_t*, prim_data*);

  /* Computes quartets of (hg|kf) integrals */

REALTYPE *hrr_order_hgkf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[6][7] = int_stack + 4242;
 Libint->vrr_classes[6][8] = int_stack + 5250;
 Libint->vrr_classes[6][9] = int_stack + 6510;
 Libint->vrr_classes[6][10] = int_stack + 8050;
 Libint->vrr_classes[7][7] = int_stack + 9898;
 Libint->vrr_classes[7][8] = int_stack + 11194;
 Libint->vrr_classes[7][9] = int_stack + 12814;
 Libint->vrr_classes[7][10] = int_stack + 14794;
 Libint->vrr_classes[8][7] = int_stack + 17170;
 Libint->vrr_classes[8][8] = int_stack + 18790;
 Libint->vrr_classes[8][9] = int_stack + 20815;
 Libint->vrr_classes[8][10] = int_stack + 23290;
 Libint->vrr_classes[9][7] = int_stack + 26260;
 Libint->vrr_classes[9][8] = int_stack + 28240;
 Libint->vrr_classes[9][9] = int_stack + 30715;
 Libint->vrr_classes[9][10] = int_stack + 33740;
 memset(int_stack,0,37370*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 37370;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgkf(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+37370,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+39638,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+42473,int_stack+39638,int_stack+37370,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47009,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+50474,int_stack+47009,int_stack+39638,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+56144,int_stack+50474,int_stack+42473,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+37370,int_stack+5250,int_stack+4242,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+40394,int_stack+6510,int_stack+5250,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+44174,int_stack+40394,int_stack+37370,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+50222,int_stack+8050,int_stack+6510,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+50222,int_stack+40394,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+63704,int_stack+0,int_stack+44174,28);
 /*--- compute (hp|kf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+73784,int_stack+63704,int_stack+56144,360);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+11194,int_stack+9898,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3888,int_stack+12814,int_stack+11194,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+37370,int_stack+3888,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+45146,int_stack+14794,int_stack+12814,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+51086,int_stack+45146,int_stack+3888,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+51086,int_stack+37370,36);
 /*--- compute (ip|kf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+96464,int_stack+0,int_stack+63704,360);
 /*--- compute (hd|kf) ---*/
 hrr1_build_hd(Libint->AB,int_stack+126704,int_stack+96464,int_stack+73784,360);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+37370,int_stack+18790,int_stack+17170,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+42230,int_stack+20815,int_stack+18790,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+48305,int_stack+42230,int_stack+37370,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+58025,int_stack+23290,int_stack+20815,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+65450,int_stack+58025,int_stack+42230,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+77600,int_stack+65450,int_stack+48305,45);
 /*--- compute (kp|kf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+37370,int_stack+77600,int_stack+0,360);
 /*--- compute (id|kf) ---*/
 hrr1_build_id(Libint->AB,int_stack+172064,int_stack+37370,int_stack+96464,360);
 /*--- compute (hf|kf) ---*/
 hrr1_build_hf(Libint->AB,int_stack+232544,int_stack+172064,int_stack+126704,360);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+28240,int_stack+26260,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5940,int_stack+30715,int_stack+28240,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13365,int_stack+5940,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+93800,int_stack+33740,int_stack+30715,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+102875,int_stack+93800,int_stack+5940,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+117725,int_stack+102875,int_stack+13365,55);
 /*--- compute (lp|kf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+308144,int_stack+117725,int_stack+77600,360);
 /*--- compute (kd|kf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+76250,int_stack+308144,int_stack+37370,360);
 /*--- compute (if|kf) ---*/
 hrr1_build_if(Libint->AB,int_stack+308144,int_stack+76250,int_stack+172064,360);
 /*--- compute (hg|kf) ---*/
 hrr1_build_hg(Libint->AB,int_stack+0,int_stack+308144,int_stack+232544,360);
 return int_stack+0;}
