/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgld(Libint_t*, prim_data*);

  /* Computes quartets of (hg|ld) integrals */

REALTYPE *hrr_order_hgld(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[6][8] = int_stack + 3486;
 Libint->vrr_classes[6][9] = int_stack + 4746;
 Libint->vrr_classes[6][10] = int_stack + 6286;
 Libint->vrr_classes[7][8] = int_stack + 8134;
 Libint->vrr_classes[7][9] = int_stack + 9754;
 Libint->vrr_classes[7][10] = int_stack + 11734;
 Libint->vrr_classes[8][8] = int_stack + 14110;
 Libint->vrr_classes[8][9] = int_stack + 16135;
 Libint->vrr_classes[8][10] = int_stack + 18610;
 Libint->vrr_classes[9][8] = int_stack + 21580;
 Libint->vrr_classes[9][9] = int_stack + 24055;
 Libint->vrr_classes[9][10] = int_stack + 27080;
 memset(int_stack,0,30710*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 30710;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgld(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+30710,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33545,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+37010,int_stack+33545,int_stack+30710,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+30710,int_stack+4746,int_stack+3486,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+6286,int_stack+4746,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+42680,int_stack+0,int_stack+30710,28);
 /*--- compute (hp|ld) ---*/
 hrr1_build_hp(Libint->AB,int_stack+50240,int_stack+42680,int_stack+37010,270);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+30710,int_stack+9754,int_stack+8134,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+35570,int_stack+11734,int_stack+9754,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+35570,int_stack+30710,36);
 /*--- compute (ip|ld) ---*/
 hrr1_build_ip(Libint->AB,int_stack+67250,int_stack+0,int_stack+42680,270);
 /*--- compute (hd|ld) ---*/
 hrr1_build_hd(Libint->AB,int_stack+89930,int_stack+67250,int_stack+50240,270);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+30710,int_stack+16135,int_stack+14110,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+36785,int_stack+18610,int_stack+16135,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+44210,int_stack+36785,int_stack+30710,45);
 /*--- compute (kp|ld) ---*/
 hrr1_build_kp(Libint->AB,int_stack+123950,int_stack+44210,int_stack+0,270);
 /*--- compute (id|ld) ---*/
 hrr1_build_id(Libint->AB,int_stack+153110,int_stack+123950,int_stack+67250,270);
 /*--- compute (hf|ld) ---*/
 hrr1_build_hf(Libint->AB,int_stack+198470,int_stack+153110,int_stack+89930,270);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+24055,int_stack+21580,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7425,int_stack+27080,int_stack+24055,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+16500,int_stack+7425,int_stack+0,55);
 /*--- compute (lp|ld) ---*/
 hrr1_build_lp(Libint->AB,int_stack+56360,int_stack+16500,int_stack+44210,270);
 /*--- compute (kd|ld) ---*/
 hrr1_build_kd(Libint->AB,int_stack+255170,int_stack+56360,int_stack+123950,270);
 /*--- compute (if|ld) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+255170,int_stack+153110,270);
 /*--- compute (hg|ld) ---*/
 hrr1_build_hg(Libint->AB,int_stack+75600,int_stack+0,int_stack+198470,270);
 return int_stack+75600;}
