/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hplh(Libint_t*, prim_data*);

  /* Computes quartets of (hp|lh) integrals */

REALTYPE *hrr_order_hplh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[5][12] = int_stack + 5124;
 Libint->vrr_classes[5][13] = int_stack + 7035;
 Libint->vrr_classes[6][8] = int_stack + 9240;
 Libint->vrr_classes[6][9] = int_stack + 10500;
 Libint->vrr_classes[6][10] = int_stack + 12040;
 Libint->vrr_classes[6][11] = int_stack + 13888;
 Libint->vrr_classes[6][12] = int_stack + 16072;
 Libint->vrr_classes[6][13] = int_stack + 18620;
 memset(int_stack,0,21560*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 21560;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hplh(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+21560,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+24395,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+27860,int_stack+24395,int_stack+21560,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+33530,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+37688,int_stack+33530,int_stack+24395,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+44618,int_stack+37688,int_stack+27860,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+21560,int_stack+5124,int_stack+3486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+54068,int_stack+21560,int_stack+33530,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+62384,int_stack+54068,int_stack+37688,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+26474,int_stack+62384,int_stack+44618,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+40649,int_stack+7035,int_stack+5124,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+73934,int_stack+40649,int_stack+21560,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+83762,int_stack+73934,int_stack+54068,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+40649,int_stack+83762,int_stack+62384,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+57974,int_stack+40649,int_stack+26474,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+21560,int_stack+10500,int_stack+9240,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25340,int_stack+12040,int_stack+10500,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+29960,int_stack+25340,int_stack+21560,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37520,int_stack+13888,int_stack+12040,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+43064,int_stack+37520,int_stack+25340,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+77819,int_stack+43064,int_stack+29960,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+21560,int_stack+16072,int_stack+13888,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+21560,int_stack+37520,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+90419,int_stack+0,int_stack+43064,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+28112,int_stack+90419,int_stack+77819,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+77819,int_stack+18620,int_stack+16072,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+105819,int_stack+77819,int_stack+21560,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+118923,int_stack+105819,int_stack+0,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+118923,int_stack+90419,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+77819,int_stack+0,int_stack+28112,28);
 /*--- compute (hp|lh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+104279,int_stack+77819,int_stack+57974,945);
 return int_stack+104279;}
