/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hpli(Libint_t*, prim_data*);

  /* Computes quartets of (hp|li) integrals */

REALTYPE *hrr_order_hpli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[5][12] = int_stack + 5124;
 Libint->vrr_classes[5][13] = int_stack + 7035;
 Libint->vrr_classes[5][14] = int_stack + 9240;
 Libint->vrr_classes[6][8] = int_stack + 11760;
 Libint->vrr_classes[6][9] = int_stack + 13020;
 Libint->vrr_classes[6][10] = int_stack + 14560;
 Libint->vrr_classes[6][11] = int_stack + 16408;
 Libint->vrr_classes[6][12] = int_stack + 18592;
 Libint->vrr_classes[6][13] = int_stack + 21140;
 Libint->vrr_classes[6][14] = int_stack + 24080;
 memset(int_stack,0,27440*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 27440;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hpli(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+27440,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+30275,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+33740,int_stack+30275,int_stack+27440,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+39410,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+43568,int_stack+39410,int_stack+30275,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+50498,int_stack+43568,int_stack+33740,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+27440,int_stack+5124,int_stack+3486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+59948,int_stack+27440,int_stack+39410,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+68264,int_stack+59948,int_stack+43568,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+32354,int_stack+68264,int_stack+50498,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+46529,int_stack+7035,int_stack+5124,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+79814,int_stack+46529,int_stack+27440,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+89642,int_stack+79814,int_stack+59948,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+103502,int_stack+89642,int_stack+68264,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+52262,int_stack+103502,int_stack+32354,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+27440,int_stack+9240,int_stack+7035,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+34055,int_stack+27440,int_stack+46529,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+120827,int_stack+34055,int_stack+79814,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+27440,int_stack+120827,int_stack+89642,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+72107,int_stack+27440,int_stack+103502,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+96362,int_stack+72107,int_stack+52262,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+27440,int_stack+13020,int_stack+11760,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+31220,int_stack+14560,int_stack+13020,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+35840,int_stack+31220,int_stack+27440,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+43400,int_stack+16408,int_stack+14560,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+48944,int_stack+43400,int_stack+31220,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+58184,int_stack+48944,int_stack+35840,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+27440,int_stack+18592,int_stack+16408,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+70784,int_stack+27440,int_stack+43400,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+70784,int_stack+48944,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+33992,int_stack+0,int_stack+58184,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+52892,int_stack+21140,int_stack+18592,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+81872,int_stack+52892,int_stack+27440,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+122822,int_stack+81872,int_stack+70784,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+141302,int_stack+122822,int_stack+0,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+164402,int_stack+141302,int_stack+33992,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+24080,int_stack+21140,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+8820,int_stack+0,int_stack+52892,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24108,int_stack+8820,int_stack+81872,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+45948,int_stack+24108,int_stack+122822,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+45948,int_stack+141302,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+122822,int_stack+0,int_stack+164402,28);
 /*--- compute (hp|li) ---*/
 hrr1_build_hp(Libint->AB,int_stack+0,int_stack+122822,int_stack+96362,1260);
 return int_stack+0;}
