/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_i0lk(Libint_t*, prim_data*);

  /* Computes quartets of (i0|lk) integrals */

REALTYPE *hrr_order_i0lk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[6][13] = int_stack + 9380;
 Libint->vrr_classes[6][14] = int_stack + 12320;
 Libint->vrr_classes[6][15] = int_stack + 15680;
 memset(int_stack,0,19488*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 19488;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_i0lk(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+19488,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+23268,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+27888,int_stack+23268,int_stack+19488,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+35448,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+40992,int_stack+35448,int_stack+23268,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+50232,int_stack+40992,int_stack+27888,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+19488,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+62832,int_stack+19488,int_stack+35448,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+73920,int_stack+62832,int_stack+40992,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+26040,int_stack+73920,int_stack+50232,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+44940,int_stack+9380,int_stack+6832,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+89320,int_stack+44940,int_stack+19488,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+102424,int_stack+89320,int_stack+62832,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+120904,int_stack+102424,int_stack+73920,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+52584,int_stack+120904,int_stack+26040,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+19488,int_stack+12320,int_stack+9380,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+28308,int_stack+19488,int_stack+44940,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+144004,int_stack+28308,int_stack+89320,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+165844,int_stack+144004,int_stack+102424,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+79044,int_stack+165844,int_stack+120904,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+193564,int_stack+79044,int_stack+52584,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+43596,int_stack+15680,int_stack+12320,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+53676,int_stack+43596,int_stack+19488,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+111384,int_stack+53676,int_stack+28308,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+111384,int_stack+144004,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+111384,int_stack+0,int_stack+165844,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+111384,int_stack+79044,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+43120,int_stack+0,int_stack+193564,28);
 return int_stack+43120;}
