/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_idii(Libint_t*, prim_data*);

  /* Computes quartets of (id|ii) integrals */

REALTYPE *hrr_order_idii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][6] = int_stack + 0;
 Libint->vrr_classes[6][7] = int_stack + 784;
 Libint->vrr_classes[6][8] = int_stack + 1792;
 Libint->vrr_classes[6][9] = int_stack + 3052;
 Libint->vrr_classes[6][10] = int_stack + 4592;
 Libint->vrr_classes[6][11] = int_stack + 6440;
 Libint->vrr_classes[6][12] = int_stack + 8624;
 Libint->vrr_classes[7][6] = int_stack + 11172;
 Libint->vrr_classes[7][7] = int_stack + 12180;
 Libint->vrr_classes[7][8] = int_stack + 13476;
 Libint->vrr_classes[7][9] = int_stack + 15096;
 Libint->vrr_classes[7][10] = int_stack + 17076;
 Libint->vrr_classes[7][11] = int_stack + 19452;
 Libint->vrr_classes[7][12] = int_stack + 22260;
 Libint->vrr_classes[8][6] = int_stack + 25536;
 Libint->vrr_classes[8][7] = int_stack + 26796;
 Libint->vrr_classes[8][8] = int_stack + 28416;
 Libint->vrr_classes[8][9] = int_stack + 30441;
 Libint->vrr_classes[8][10] = int_stack + 32916;
 Libint->vrr_classes[8][11] = int_stack + 35886;
 Libint->vrr_classes[8][12] = int_stack + 39396;
 memset(int_stack,0,43491*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 43491;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_idii(Libint, Data);
   Data++;
 }
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+43491,int_stack+784,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+45843,int_stack+1792,int_stack+784,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+48867,int_stack+45843,int_stack+43491,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+53571,int_stack+3052,int_stack+1792,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+57351,int_stack+53571,int_stack+45843,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+63399,int_stack+57351,int_stack+48867,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+43491,int_stack+4592,int_stack+3052,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+71239,int_stack+43491,int_stack+53571,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+78799,int_stack+71239,int_stack+57351,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+48111,int_stack+78799,int_stack+63399,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59871,int_stack+6440,int_stack+4592,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+88879,int_stack+59871,int_stack+43491,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+98119,int_stack+88879,int_stack+71239,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+110719,int_stack+98119,int_stack+78799,28);
 /*--- compute (i0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+65415,int_stack+110719,int_stack+48111,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+43491,int_stack+8624,int_stack+6440,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+43491,int_stack+59871,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+43491,int_stack+0,int_stack+88879,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+125839,int_stack+43491,int_stack+98119,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+43491,int_stack+125839,int_stack+110719,28);
 /*--- compute (i0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+81879,int_stack+43491,int_stack+65415,28);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+43491,int_stack+12180,int_stack+11172,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+46515,int_stack+13476,int_stack+12180,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+50403,int_stack+46515,int_stack+43491,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+56451,int_stack+15096,int_stack+13476,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+61311,int_stack+56451,int_stack+46515,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+69087,int_stack+61311,int_stack+50403,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+43491,int_stack+17076,int_stack+15096,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+43491,int_stack+56451,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+103831,int_stack+0,int_stack+61311,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+49431,int_stack+103831,int_stack+69087,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+64551,int_stack+19452,int_stack+17076,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+116791,int_stack+64551,int_stack+43491,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+128671,int_stack+116791,int_stack+0,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+128671,int_stack+103831,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+144871,int_stack+0,int_stack+49431,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+103831,int_stack+22260,int_stack+19452,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+43491,int_stack+103831,int_stack+64551,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+57747,int_stack+43491,int_stack+116791,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+103831,int_stack+57747,int_stack+128671,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+43491,int_stack+103831,int_stack+0,36);
 /*--- compute (k0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+103831,int_stack+43491,int_stack+144871,36);
 /*--- compute (ip|ii) ---*/
 hrr1_build_ip(Libint->AB,int_stack+132055,int_stack+103831,int_stack+81879,784);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+43491,int_stack+26796,int_stack+25536,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+47271,int_stack+28416,int_stack+26796,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+52131,int_stack+47271,int_stack+43491,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+59691,int_stack+30441,int_stack+28416,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+65766,int_stack+59691,int_stack+47271,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+75486,int_stack+65766,int_stack+52131,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+43491,int_stack+32916,int_stack+30441,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+88086,int_stack+43491,int_stack+59691,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+88086,int_stack+65766,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+50916,int_stack+0,int_stack+75486,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+69816,int_stack+35886,int_stack+32916,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16200,int_stack+69816,int_stack+43491,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+197911,int_stack+16200,int_stack+88086,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+78726,int_stack+197911,int_stack+0,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+218161,int_stack+78726,int_stack+50916,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+39396,int_stack+35886,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+31050,int_stack+0,int_stack+69816,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+48870,int_stack+31050,int_stack+16200,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+48870,int_stack+197911,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+30375,int_stack+0,int_stack+78726,45);
 /*--- compute (l0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+64395,int_stack+30375,int_stack+218161,45);
 /*--- compute (kp|ii) ---*/
 hrr1_build_kp(Libint->AB,int_stack+197911,int_stack+64395,int_stack+103831,784);
 /*--- compute (id|ii) ---*/
 hrr1_build_id(Libint->AB,int_stack+0,int_stack+197911,int_stack+132055,784);
 return int_stack+0;}
