/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ihih(Libint_t*, prim_data*);

  /* Computes quartets of (ih|ih) integrals */

REALTYPE *hrr_order_ihih(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][6] = int_stack + 0;
 Libint->vrr_classes[6][7] = int_stack + 784;
 Libint->vrr_classes[6][8] = int_stack + 1792;
 Libint->vrr_classes[6][9] = int_stack + 3052;
 Libint->vrr_classes[6][10] = int_stack + 4592;
 Libint->vrr_classes[6][11] = int_stack + 6440;
 Libint->vrr_classes[7][6] = int_stack + 8624;
 Libint->vrr_classes[7][7] = int_stack + 9632;
 Libint->vrr_classes[7][8] = int_stack + 10928;
 Libint->vrr_classes[7][9] = int_stack + 12548;
 Libint->vrr_classes[7][10] = int_stack + 14528;
 Libint->vrr_classes[7][11] = int_stack + 16904;
 Libint->vrr_classes[8][6] = int_stack + 19712;
 Libint->vrr_classes[8][7] = int_stack + 20972;
 Libint->vrr_classes[8][8] = int_stack + 22592;
 Libint->vrr_classes[8][9] = int_stack + 24617;
 Libint->vrr_classes[8][10] = int_stack + 27092;
 Libint->vrr_classes[8][11] = int_stack + 30062;
 Libint->vrr_classes[9][6] = int_stack + 33572;
 Libint->vrr_classes[9][7] = int_stack + 35112;
 Libint->vrr_classes[9][8] = int_stack + 37092;
 Libint->vrr_classes[9][9] = int_stack + 39567;
 Libint->vrr_classes[9][10] = int_stack + 42592;
 Libint->vrr_classes[9][11] = int_stack + 46222;
 Libint->vrr_classes[10][6] = int_stack + 50512;
 Libint->vrr_classes[10][7] = int_stack + 52360;
 Libint->vrr_classes[10][8] = int_stack + 54736;
 Libint->vrr_classes[10][9] = int_stack + 57706;
 Libint->vrr_classes[10][10] = int_stack + 61336;
 Libint->vrr_classes[10][11] = int_stack + 65692;
 Libint->vrr_classes[11][6] = int_stack + 70840;
 Libint->vrr_classes[11][7] = int_stack + 73024;
 Libint->vrr_classes[11][8] = int_stack + 75832;
 Libint->vrr_classes[11][9] = int_stack + 79342;
 Libint->vrr_classes[11][10] = int_stack + 83632;
 Libint->vrr_classes[11][11] = int_stack + 88780;
 memset(int_stack,0,94864*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 94864;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ihih(Libint, Data);
   Data++;
 }
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+94864,int_stack+784,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+97216,int_stack+1792,int_stack+784,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+100240,int_stack+97216,int_stack+94864,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+104944,int_stack+3052,int_stack+1792,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+108724,int_stack+104944,int_stack+97216,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+114772,int_stack+108724,int_stack+100240,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+94864,int_stack+4592,int_stack+3052,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+122612,int_stack+94864,int_stack+104944,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+130172,int_stack+122612,int_stack+108724,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+99484,int_stack+130172,int_stack+114772,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+111244,int_stack+6440,int_stack+4592,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+140252,int_stack+111244,int_stack+94864,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+149492,int_stack+140252,int_stack+122612,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+111244,int_stack+149492,int_stack+130172,28);
 /*--- compute (i0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+126364,int_stack+111244,int_stack+99484,28);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+94864,int_stack+9632,int_stack+8624,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+97888,int_stack+10928,int_stack+9632,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+101776,int_stack+97888,int_stack+94864,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+107824,int_stack+12548,int_stack+10928,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+112684,int_stack+107824,int_stack+97888,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+142828,int_stack+112684,int_stack+101776,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+94864,int_stack+14528,int_stack+12548,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+152908,int_stack+94864,int_stack+107824,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+152908,int_stack+112684,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+100804,int_stack+0,int_stack+142828,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+142828,int_stack+16904,int_stack+14528,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+162628,int_stack+142828,int_stack+94864,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+174508,int_stack+162628,int_stack+152908,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+142828,int_stack+174508,int_stack+0,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+162268,int_stack+142828,int_stack+100804,36);
 /*--- compute (ip|ih) ---*/
 hrr1_build_ip(Libint->AB,int_stack+183436,int_stack+162268,int_stack+126364,588);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+20972,int_stack+19712,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3780,int_stack+22592,int_stack+20972,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+8640,int_stack+3780,int_stack+0,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+16200,int_stack+24617,int_stack+22592,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+94864,int_stack+16200,int_stack+3780,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+104584,int_stack+94864,int_stack+8640,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+27092,int_stack+24617,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+117184,int_stack+0,int_stack+16200,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+7425,int_stack+117184,int_stack+94864,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+129334,int_stack+7425,int_stack+104584,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+94864,int_stack+30062,int_stack+27092,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+232828,int_stack+94864,int_stack+0,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+94864,int_stack+232828,int_stack+117184,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+232828,int_stack+94864,int_stack+7425,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+94864,int_stack+232828,int_stack+129334,45);
 /*--- compute (kp|ih) ---*/
 hrr1_build_kp(Libint->AB,int_stack+232828,int_stack+94864,int_stack+162268,588);
 /*--- compute (id|ih) ---*/
 hrr1_build_id(Libint->AB,int_stack+296332,int_stack+232828,int_stack+183436,588);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+121324,int_stack+35112,int_stack+33572,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+125944,int_stack+37092,int_stack+35112,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+131884,int_stack+125944,int_stack+121324,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+141124,int_stack+39567,int_stack+37092,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+148549,int_stack+141124,int_stack+125944,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+160429,int_stack+148549,int_stack+131884,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+121324,int_stack+42592,int_stack+39567,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+175829,int_stack+121324,int_stack+141124,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+190679,int_stack+175829,int_stack+148549,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+130399,int_stack+190679,int_stack+160429,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+153499,int_stack+46222,int_stack+42592,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+210479,int_stack+153499,int_stack+121324,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+210479,int_stack+175829,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+153499,int_stack+0,int_stack+190679,55);
 /*--- compute (m0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+0,int_stack+153499,int_stack+130399,55);
 /*--- compute (lp|ih) ---*/
 hrr1_build_lp(Libint->AB,int_stack+121324,int_stack+0,int_stack+94864,588);
 /*--- compute (kd|ih) ---*/
 hrr1_build_kd(Libint->AB,int_stack+395116,int_stack+121324,int_stack+232828,588);
 /*--- compute (if|ih) ---*/
 hrr1_build_if(Libint->AB,int_stack+522124,int_stack+395116,int_stack+296332,588);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+94864,int_stack+52360,int_stack+50512,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+100408,int_stack+54736,int_stack+52360,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+107536,int_stack+100408,int_stack+94864,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+32340,int_stack+57706,int_stack+54736,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+41250,int_stack+32340,int_stack+100408,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+200704,int_stack+41250,int_stack+107536,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+94864,int_stack+61336,int_stack+57706,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+219184,int_stack+94864,int_stack+32340,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+237004,int_stack+219184,int_stack+41250,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+32340,int_stack+237004,int_stack+200704,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+200704,int_stack+65692,int_stack+61336,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+260764,int_stack+200704,int_stack+94864,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+282544,int_stack+260764,int_stack+219184,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+200704,int_stack+282544,int_stack+237004,66);
 /*--- compute (n0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+236344,int_stack+200704,int_stack+32340,66);
 /*--- compute (mp|ih) ---*/
 hrr1_build_mp(Libint->AB,int_stack+275152,int_stack+236344,int_stack+0,588);
 /*--- compute (ld|ih) ---*/
 hrr1_build_ld(Libint->AB,int_stack+686764,int_stack+275152,int_stack+121324,588);
 /*--- compute (kf|ih) ---*/
 hrr1_build_kf(Libint->AB,int_stack+845524,int_stack+686764,int_stack+395116,588);
 /*--- compute (ig|ih) ---*/
 hrr1_build_ig(Libint->AB,int_stack+1057204,int_stack+845524,int_stack+522124,588);
 /*--- compute (o0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+73024,int_stack+70840,78);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+6552,int_stack+75832,int_stack+73024,78);
 /*--- compute (o0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+14976,int_stack+6552,int_stack+0,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+28080,int_stack+79342,int_stack+75832,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+38610,int_stack+28080,int_stack+6552,78);
 /*--- compute (o0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+55458,int_stack+38610,int_stack+14976,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+83632,int_stack+79342,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+94864,int_stack+0,int_stack+28080,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+115924,int_stack+94864,int_stack+38610,78);
 /*--- compute (o0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+12870,int_stack+115924,int_stack+55458,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+45630,int_stack+88780,int_stack+83632,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+61074,int_stack+45630,int_stack+0,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+144004,int_stack+61074,int_stack+94864,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+45630,int_stack+144004,int_stack+115924,78);
 /*--- compute (o0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+87750,int_stack+45630,int_stack+12870,78);
 /*--- compute (np|ih) ---*/
 hrr1_build_np(Libint->AB,int_stack+372172,int_stack+87750,int_stack+236344,588);
 /*--- compute (md|ih) ---*/
 hrr1_build_md(Libint->AB,int_stack+0,int_stack+372172,int_stack+275152,588);
 /*--- compute (lf|ih) ---*/
 hrr1_build_lf(Libint->AB,int_stack+194040,int_stack+0,int_stack+686764,588);
 /*--- compute (kg|ih) ---*/
 hrr1_build_kg(Libint->AB,int_stack+458640,int_stack+194040,int_stack+845524,588);
 /*--- compute (ih|ih) ---*/
 hrr1_build_ih(Libint->AB,int_stack+0,int_stack+458640,int_stack+1057204,588);
 return int_stack+0;}
