/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iiki(Libint_t*, prim_data*);

  /* Computes quartets of (ii|ki) integrals */

REALTYPE *hrr_order_iiki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][7] = int_stack + 0;
 Libint->vrr_classes[6][8] = int_stack + 1008;
 Libint->vrr_classes[6][9] = int_stack + 2268;
 Libint->vrr_classes[6][10] = int_stack + 3808;
 Libint->vrr_classes[6][11] = int_stack + 5656;
 Libint->vrr_classes[6][12] = int_stack + 7840;
 Libint->vrr_classes[6][13] = int_stack + 10388;
 Libint->vrr_classes[7][7] = int_stack + 13328;
 Libint->vrr_classes[7][8] = int_stack + 14624;
 Libint->vrr_classes[7][9] = int_stack + 16244;
 Libint->vrr_classes[7][10] = int_stack + 18224;
 Libint->vrr_classes[7][11] = int_stack + 20600;
 Libint->vrr_classes[7][12] = int_stack + 23408;
 Libint->vrr_classes[7][13] = int_stack + 26684;
 Libint->vrr_classes[8][7] = int_stack + 30464;
 Libint->vrr_classes[8][8] = int_stack + 32084;
 Libint->vrr_classes[8][9] = int_stack + 34109;
 Libint->vrr_classes[8][10] = int_stack + 36584;
 Libint->vrr_classes[8][11] = int_stack + 39554;
 Libint->vrr_classes[8][12] = int_stack + 43064;
 Libint->vrr_classes[8][13] = int_stack + 47159;
 Libint->vrr_classes[9][7] = int_stack + 51884;
 Libint->vrr_classes[9][8] = int_stack + 53864;
 Libint->vrr_classes[9][9] = int_stack + 56339;
 Libint->vrr_classes[9][10] = int_stack + 59364;
 Libint->vrr_classes[9][11] = int_stack + 62994;
 Libint->vrr_classes[9][12] = int_stack + 67284;
 Libint->vrr_classes[9][13] = int_stack + 72289;
 Libint->vrr_classes[10][7] = int_stack + 78064;
 Libint->vrr_classes[10][8] = int_stack + 80440;
 Libint->vrr_classes[10][9] = int_stack + 83410;
 Libint->vrr_classes[10][10] = int_stack + 87040;
 Libint->vrr_classes[10][11] = int_stack + 91396;
 Libint->vrr_classes[10][12] = int_stack + 96544;
 Libint->vrr_classes[10][13] = int_stack + 102550;
 Libint->vrr_classes[11][7] = int_stack + 109480;
 Libint->vrr_classes[11][8] = int_stack + 112288;
 Libint->vrr_classes[11][9] = int_stack + 115798;
 Libint->vrr_classes[11][10] = int_stack + 120088;
 Libint->vrr_classes[11][11] = int_stack + 125236;
 Libint->vrr_classes[11][12] = int_stack + 131320;
 Libint->vrr_classes[11][13] = int_stack + 138418;
 Libint->vrr_classes[12][7] = int_stack + 146608;
 Libint->vrr_classes[12][8] = int_stack + 149884;
 Libint->vrr_classes[12][9] = int_stack + 153979;
 Libint->vrr_classes[12][10] = int_stack + 158984;
 Libint->vrr_classes[12][11] = int_stack + 164990;
 Libint->vrr_classes[12][12] = int_stack + 172088;
 Libint->vrr_classes[12][13] = int_stack + 180369;
 memset(int_stack,0,189924*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 189924;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iiki(Libint, Data);
   Data++;
 }
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+189924,int_stack+1008,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+192948,int_stack+2268,int_stack+1008,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+196728,int_stack+192948,int_stack+189924,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+202776,int_stack+3808,int_stack+2268,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+207396,int_stack+202776,int_stack+192948,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+214956,int_stack+207396,int_stack+196728,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+189924,int_stack+5656,int_stack+3808,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+225036,int_stack+189924,int_stack+202776,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+234276,int_stack+225036,int_stack+207396,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+195468,int_stack+234276,int_stack+214956,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+210588,int_stack+7840,int_stack+5656,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+246876,int_stack+210588,int_stack+189924,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+257964,int_stack+246876,int_stack+225036,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+273364,int_stack+257964,int_stack+234276,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+217140,int_stack+273364,int_stack+195468,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+189924,int_stack+10388,int_stack+7840,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+189924,int_stack+210588,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+189924,int_stack+0,int_stack+246876,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+292264,int_stack+189924,int_stack+257964,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+189924,int_stack+292264,int_stack+273364,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+238308,int_stack+189924,int_stack+217140,28);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+189924,int_stack+14624,int_stack+13328,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+193812,int_stack+16244,int_stack+14624,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+198672,int_stack+193812,int_stack+189924,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+206448,int_stack+18224,int_stack+16244,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+212388,int_stack+206448,int_stack+193812,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+222108,int_stack+212388,int_stack+198672,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+189924,int_stack+20600,int_stack+18224,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+189924,int_stack+206448,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+266532,int_stack+0,int_stack+212388,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+197052,int_stack+266532,int_stack+222108,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+216492,int_stack+23408,int_stack+20600,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+282732,int_stack+216492,int_stack+189924,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+296988,int_stack+282732,int_stack+0,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+316788,int_stack+296988,int_stack+266532,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+341088,int_stack+316788,int_stack+197052,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+266532,int_stack+26684,int_stack+23408,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+266532,int_stack+216492,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+189924,int_stack+0,int_stack+282732,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+189924,int_stack+296988,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+189924,int_stack+0,int_stack+316788,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+266532,int_stack+189924,int_stack+341088,36);
 /*--- compute (ip|ki) ---*/
 hrr1_build_ip(Libint->AB,int_stack+302820,int_stack+266532,int_stack+238308,1008);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+189924,int_stack+32084,int_stack+30464,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+194784,int_stack+34109,int_stack+32084,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+200859,int_stack+194784,int_stack+189924,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+210579,int_stack+36584,int_stack+34109,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+218004,int_stack+210579,int_stack+194784,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+230154,int_stack+218004,int_stack+200859,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+189924,int_stack+39554,int_stack+36584,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+246354,int_stack+189924,int_stack+210579,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+246354,int_stack+218004,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+198834,int_stack+0,int_stack+230154,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+223134,int_stack+43064,int_stack+39554,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+20250,int_stack+223134,int_stack+189924,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+387492,int_stack+20250,int_stack+246354,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+233664,int_stack+387492,int_stack+0,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+412242,int_stack+233664,int_stack+198834,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+47159,int_stack+43064,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+189924,int_stack+0,int_stack+223134,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+446262,int_stack+189924,int_stack+20250,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+189924,int_stack+446262,int_stack+387492,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+189924,int_stack+233664,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+189924,int_stack+0,int_stack+412242,45);
 /*--- compute (kp|ki) ---*/
 hrr1_build_kp(Libint->AB,int_stack+387492,int_stack+189924,int_stack+266532,1008);
 /*--- compute (id|ki) ---*/
 hrr1_build_id(Libint->AB,int_stack+496356,int_stack+387492,int_stack+302820,1008);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+53864,int_stack+51884,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5940,int_stack+56339,int_stack+53864,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13365,int_stack+5940,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25245,int_stack+59364,int_stack+56339,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+34320,int_stack+25245,int_stack+5940,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+235284,int_stack+34320,int_stack+13365,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+62994,int_stack+59364,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+255084,int_stack+0,int_stack+25245,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+273234,int_stack+255084,int_stack+34320,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+10890,int_stack+273234,int_stack+235284,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+235284,int_stack+67284,int_stack+62994,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+40590,int_stack+235284,int_stack+0,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+297984,int_stack+40590,int_stack+255084,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+328234,int_stack+297984,int_stack+273234,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+248154,int_stack+328234,int_stack+10890,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+72289,int_stack+67284,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+665700,int_stack+0,int_stack+235284,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+665700,int_stack+40590,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+665700,int_stack+0,int_stack+297984,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+665700,int_stack+328234,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+289734,int_stack+0,int_stack+248154,55);
 /*--- compute (lp|ki) ---*/
 hrr1_build_lp(Libint->AB,int_stack+665700,int_stack+289734,int_stack+189924,1008);
 /*--- compute (kd|ki) ---*/
 hrr1_build_kd(Libint->AB,int_stack+801780,int_stack+665700,int_stack+387492,1008);
 /*--- compute (if|ki) ---*/
 hrr1_build_if(Libint->AB,int_stack+1019508,int_stack+801780,int_stack+496356,1008);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+189924,int_stack+80440,int_stack+78064,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+197052,int_stack+83410,int_stack+80440,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+205962,int_stack+197052,int_stack+189924,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+220218,int_stack+87040,int_stack+83410,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+231108,int_stack+220218,int_stack+197052,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+248928,int_stack+231108,int_stack+205962,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+189924,int_stack+91396,int_stack+87040,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+189924,int_stack+220218,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+21780,int_stack+0,int_stack+231108,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+202992,int_stack+21780,int_stack+248928,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+238632,int_stack+96544,int_stack+91396,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+254076,int_stack+238632,int_stack+189924,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+51480,int_stack+254076,int_stack+0,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+345174,int_stack+51480,int_stack+21780,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+345174,int_stack+202992,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+189924,int_stack+102550,int_stack+96544,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+389724,int_stack+189924,int_stack+238632,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+189924,int_stack+389724,int_stack+254076,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+389724,int_stack+189924,int_stack+51480,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+189924,int_stack+389724,int_stack+345174,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+345174,int_stack+189924,int_stack+0,66);
 /*--- compute (mp|ki) ---*/
 hrr1_build_mp(Libint->AB,int_stack+411702,int_stack+345174,int_stack+289734,1008);
 /*--- compute (ld|ki) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1301748,int_stack+411702,int_stack+665700,1008);
 /*--- compute (kf|ki) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1573908,int_stack+1301748,int_stack+801780,1008);
 /*--- compute (ig|ki) ---*/
 hrr1_build_ig(Libint->AB,int_stack+578022,int_stack+1573908,int_stack+1019508,1008);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+112288,int_stack+109480,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8424,int_stack+115798,int_stack+112288,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+18954,int_stack+8424,int_stack+0,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+35802,int_stack+120088,int_stack+115798,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+48672,int_stack+35802,int_stack+8424,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+69732,int_stack+48672,int_stack+18954,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+125236,int_stack+120088,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+97812,int_stack+0,int_stack+35802,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+189924,int_stack+97812,int_stack+48672,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+15444,int_stack+189924,int_stack+69732,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+57564,int_stack+131320,int_stack+125236,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+225024,int_stack+57564,int_stack+0,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+255912,int_stack+225024,int_stack+97812,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+75816,int_stack+255912,int_stack+189924,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+1001382,int_stack+75816,int_stack+15444,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+189924,int_stack+138418,int_stack+131320,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+189924,int_stack+57564,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1060350,int_stack+0,int_stack+225024,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+1060350,int_stack+255912,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1060350,int_stack+0,int_stack+75816,78);
 /*--- compute (o0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+0,int_stack+1060350,int_stack+1001382,78);
 /*--- compute (np|ki) ---*/
 hrr1_build_np(Libint->AB,int_stack+1001382,int_stack+0,int_stack+345174,1008);
 /*--- compute (md|ki) ---*/
 hrr1_build_md(Libint->AB,int_stack+1936788,int_stack+1001382,int_stack+411702,1008);
 /*--- compute (lf|ki) ---*/
 hrr1_build_lf(Libint->AB,int_stack+2269428,int_stack+1936788,int_stack+1301748,1008);
 /*--- compute (kg|ki) ---*/
 hrr1_build_kg(Libint->AB,int_stack+2723028,int_stack+2269428,int_stack+1573908,1008);
 /*--- compute (ih|ki) ---*/
 hrr1_build_ih(Libint->AB,int_stack+1200966,int_stack+2723028,int_stack+578022,1008);
 /*--- compute (q0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+1793670,int_stack+149884,int_stack+146608,91);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+1803498,int_stack+153979,int_stack+149884,91);
 /*--- compute (q0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+1815783,int_stack+1803498,int_stack+1793670,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1835439,int_stack+158984,int_stack+153979,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+1850454,int_stack+1835439,int_stack+1803498,91);
 /*--- compute (q0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+1875024,int_stack+1850454,int_stack+1815783,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1793670,int_stack+164990,int_stack+158984,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+78624,int_stack+1793670,int_stack+1835439,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+108654,int_stack+78624,int_stack+1850454,91);
 /*--- compute (q0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+1811688,int_stack+108654,int_stack+1875024,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1860828,int_stack+172088,int_stack+164990,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1882122,int_stack+1860828,int_stack+1793670,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+189924,int_stack+1882122,int_stack+78624,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+239974,int_stack+189924,int_stack+108654,91);
 /*--- compute (q0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+78624,int_stack+239974,int_stack+1811688,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1793670,int_stack+180369,int_stack+172088,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+301399,int_stack+1793670,int_stack+1860828,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1793670,int_stack+301399,int_stack+1882122,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+301399,int_stack+1793670,int_stack+189924,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1793670,int_stack+301399,int_stack+239974,91);
 /*--- compute (q0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+147420,int_stack+1793670,int_stack+78624,91);
 /*--- compute (op|ki) ---*/
 hrr1_build_op(Libint->AB,int_stack+239148,int_stack+147420,int_stack+0,1008);
 /*--- compute (nd|ki) ---*/
 hrr1_build_nd(Libint->AB,int_stack+475020,int_stack+239148,int_stack+1001382,1008);
 /*--- compute (mf|ki) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3267348,int_stack+475020,int_stack+1936788,1008);
 /*--- compute (lg|ki) ---*/
 hrr1_build_lg(Libint->AB,int_stack+0,int_stack+3267348,int_stack+2269428,1008);
 /*--- compute (kh|ki) ---*/
 hrr1_build_kh(Libint->AB,int_stack+1793670,int_stack+0,int_stack+2723028,1008);
 /*--- compute (ii|ki) ---*/
 hrr1_build_ii(Libint->AB,int_stack+0,int_stack+1793670,int_stack+1200966,1008);
 return int_stack+0;}
