/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iimh(Libint_t*, prim_data*);

  /* Computes quartets of (ii|mh) integrals */

REALTYPE *hrr_order_iimh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[6][13] = int_stack + 8120;
 Libint->vrr_classes[6][14] = int_stack + 11060;
 Libint->vrr_classes[7][9] = int_stack + 14420;
 Libint->vrr_classes[7][10] = int_stack + 16400;
 Libint->vrr_classes[7][11] = int_stack + 18776;
 Libint->vrr_classes[7][12] = int_stack + 21584;
 Libint->vrr_classes[7][13] = int_stack + 24860;
 Libint->vrr_classes[7][14] = int_stack + 28640;
 Libint->vrr_classes[8][9] = int_stack + 32960;
 Libint->vrr_classes[8][10] = int_stack + 35435;
 Libint->vrr_classes[8][11] = int_stack + 38405;
 Libint->vrr_classes[8][12] = int_stack + 41915;
 Libint->vrr_classes[8][13] = int_stack + 46010;
 Libint->vrr_classes[8][14] = int_stack + 50735;
 Libint->vrr_classes[9][9] = int_stack + 56135;
 Libint->vrr_classes[9][10] = int_stack + 59160;
 Libint->vrr_classes[9][11] = int_stack + 62790;
 Libint->vrr_classes[9][12] = int_stack + 67080;
 Libint->vrr_classes[9][13] = int_stack + 72085;
 Libint->vrr_classes[9][14] = int_stack + 77860;
 Libint->vrr_classes[10][9] = int_stack + 84460;
 Libint->vrr_classes[10][10] = int_stack + 88090;
 Libint->vrr_classes[10][11] = int_stack + 92446;
 Libint->vrr_classes[10][12] = int_stack + 97594;
 Libint->vrr_classes[10][13] = int_stack + 103600;
 Libint->vrr_classes[10][14] = int_stack + 110530;
 Libint->vrr_classes[11][9] = int_stack + 118450;
 Libint->vrr_classes[11][10] = int_stack + 122740;
 Libint->vrr_classes[11][11] = int_stack + 127888;
 Libint->vrr_classes[11][12] = int_stack + 133972;
 Libint->vrr_classes[11][13] = int_stack + 141070;
 Libint->vrr_classes[11][14] = int_stack + 149260;
 Libint->vrr_classes[12][9] = int_stack + 158620;
 Libint->vrr_classes[12][10] = int_stack + 163625;
 Libint->vrr_classes[12][11] = int_stack + 169631;
 Libint->vrr_classes[12][12] = int_stack + 176729;
 Libint->vrr_classes[12][13] = int_stack + 185010;
 Libint->vrr_classes[12][14] = int_stack + 194565;
 memset(int_stack,0,205485*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 205485;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iimh(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+205485,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+210105,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+215649,int_stack+210105,int_stack+205485,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+224889,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+231441,int_stack+224889,int_stack+210105,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+242529,int_stack+231441,int_stack+215649,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+205485,int_stack+8120,int_stack+5572,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+257929,int_stack+205485,int_stack+224889,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+271033,int_stack+257929,int_stack+231441,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+213129,int_stack+271033,int_stack+242529,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+236229,int_stack+11060,int_stack+8120,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+289513,int_stack+236229,int_stack+205485,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+304801,int_stack+289513,int_stack+257929,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+236229,int_stack+304801,int_stack+271033,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+263949,int_stack+236229,int_stack+213129,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+205485,int_stack+16400,int_stack+14420,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+211425,int_stack+18776,int_stack+16400,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+218553,int_stack+211425,int_stack+205485,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+230433,int_stack+21584,int_stack+18776,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+238857,int_stack+230433,int_stack+211425,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+296289,int_stack+238857,int_stack+218553,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+205485,int_stack+24860,int_stack+21584,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+205485,int_stack+230433,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+316089,int_stack+0,int_stack+238857,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+215313,int_stack+316089,int_stack+296289,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+296289,int_stack+28640,int_stack+24860,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+339849,int_stack+296289,int_stack+205485,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+359505,int_stack+339849,int_stack+0,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+387585,int_stack+359505,int_stack+316089,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+296289,int_stack+387585,int_stack+215313,36);
 /*--- compute (ip|mh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+337869,int_stack+296289,int_stack+263949,1155);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+35435,int_stack+32960,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7425,int_stack+38405,int_stack+35435,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16335,int_stack+7425,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+205485,int_stack+41915,int_stack+38405,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+216015,int_stack+205485,int_stack+7425,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+233835,int_stack+216015,int_stack+16335,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+46010,int_stack+41915,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+12285,int_stack+0,int_stack+205485,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+258585,int_stack+12285,int_stack+216015,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+434889,int_stack+258585,int_stack+233835,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+205485,int_stack+50735,int_stack+46010,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+219660,int_stack+205485,int_stack+0,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+472014,int_stack+219660,int_stack+12285,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+472014,int_stack+258585,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+205485,int_stack+0,int_stack+434889,45);
 /*--- compute (kp|mh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+434889,int_stack+205485,int_stack+296289,1155);
 /*--- compute (id|mh) ---*/
 hrr1_build_id(Libint->AB,int_stack+559629,int_stack+434889,int_stack+337869,1155);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+59160,int_stack+56135,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9075,int_stack+62790,int_stack+59160,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19965,int_stack+9075,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+38115,int_stack+67080,int_stack+62790,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+257460,int_stack+38115,int_stack+9075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+279240,int_stack+257460,int_stack+19965,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+72085,int_stack+67080,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+309490,int_stack+0,int_stack+38115,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+15015,int_stack+309490,int_stack+257460,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+335230,int_stack+15015,int_stack+279240,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+257460,int_stack+77860,int_stack+72085,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+274785,int_stack+257460,int_stack+0,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+380605,int_stack+274785,int_stack+309490,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+257460,int_stack+380605,int_stack+15015,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+257460,int_stack+335230,55);
 /*--- compute (lp|mh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+257460,int_stack+0,int_stack+205485,1155);
 /*--- compute (kd|mh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+753669,int_stack+257460,int_stack+434889,1155);
 /*--- compute (if|mh) ---*/
 hrr1_build_if(Libint->AB,int_stack+1003149,int_stack+753669,int_stack+559629,1155);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+205485,int_stack+88090,int_stack+84460,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+216375,int_stack+92446,int_stack+88090,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+229443,int_stack+216375,int_stack+205485,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+413385,int_stack+97594,int_stack+92446,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+428829,int_stack+413385,int_stack+216375,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+454965,int_stack+428829,int_stack+229443,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+205485,int_stack+103600,int_stack+97594,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+223503,int_stack+205485,int_stack+413385,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+491265,int_stack+223503,int_stack+428829,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+534825,int_stack+491265,int_stack+454965,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+413385,int_stack+110530,int_stack+103600,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+434175,int_stack+413385,int_stack+205485,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+589275,int_stack+434175,int_stack+223503,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+413385,int_stack+589275,int_stack+491265,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+589275,int_stack+413385,int_stack+534825,66);
 /*--- compute (mp|mh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1326549,int_stack+589275,int_stack+0,1155);
 /*--- compute (ld|mh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1517124,int_stack+1326549,int_stack+257460,1155);
 /*--- compute (kf|mh) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1828974,int_stack+1517124,int_stack+753669,1155);
 /*--- compute (ig|mh) ---*/
 hrr1_build_ig(Libint->AB,int_stack+2244774,int_stack+1828974,int_stack+1003149,1155);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+122740,int_stack+118450,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+127888,int_stack+122740,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54054,int_stack+133972,int_stack+127888,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+72306,int_stack+54054,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+665505,int_stack+72306,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+141070,int_stack+133972,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+103194,int_stack+0,int_stack+54054,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+708405,int_stack+103194,int_stack+72306,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+21294,int_stack+708405,int_stack+665505,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+665505,int_stack+149260,int_stack+141070,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+759885,int_stack+665505,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+802473,int_stack+759885,int_stack+103194,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+863313,int_stack+802473,int_stack+708405,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+665505,int_stack+863313,int_stack+21294,78);
 /*--- compute (np|mh) ---*/
 hrr1_build_np(Libint->AB,int_stack+755595,int_stack+665505,int_stack+589275,1155);
 /*--- compute (md|mh) ---*/
 hrr1_build_md(Libint->AB,int_stack+205485,int_stack+755595,int_stack+1326549,1155);
 /*--- compute (lf|mh) ---*/
 hrr1_build_lf(Libint->AB,int_stack+984285,int_stack+205485,int_stack+1517124,1155);
 /*--- compute (kg|mh) ---*/
 hrr1_build_kg(Libint->AB,int_stack+2729874,int_stack+984285,int_stack+1828974,1155);
 /*--- compute (ih|mh) ---*/
 hrr1_build_ih(Libint->AB,int_stack+1504035,int_stack+2729874,int_stack+2244774,1155);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+163625,int_stack+158620,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+169631,int_stack+163625,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+176729,int_stack+169631,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+120393,int_stack+84357,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+185010,int_stack+176729,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2183175,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2225763,int_stack+2183175,int_stack+84357,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+24843,int_stack+2225763,int_stack+120393,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+99918,int_stack+194565,int_stack+185010,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+128583,int_stack+99918,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2285823,int_stack+128583,int_stack+2183175,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+99918,int_stack+2285823,int_stack+2225763,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2183175,int_stack+99918,int_stack+24843,91);
 /*--- compute (op|mh) ---*/
 hrr1_build_op(Libint->AB,int_stack+2288280,int_stack+2183175,int_stack+665505,1155);
 /*--- compute (nd|mh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3353574,int_stack+2288280,int_stack+755595,1155);
 /*--- compute (mf|mh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3810954,int_stack+3353574,int_stack+205485,1155);
 /*--- compute (lg|mh) ---*/
 hrr1_build_lg(Libint->AB,int_stack+0,int_stack+3810954,int_stack+984285,1155);
 /*--- compute (kh|mh) ---*/
 hrr1_build_kh(Libint->AB,int_stack+3353574,int_stack+0,int_stack+2729874,1155);
 /*--- compute (ii|mh) ---*/
 hrr1_build_ii(Libint->AB,int_stack+0,int_stack+3353574,int_stack+1504035,1155);
 return int_stack+0;}
