/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iinm(Libint_t*, prim_data*);

  /* Computes quartets of (ii|nm) integrals */

REALTYPE *hrr_order_iinm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[6][14] = int_stack + 9520;
 Libint->vrr_classes[6][15] = int_stack + 12880;
 Libint->vrr_classes[6][16] = int_stack + 16688;
 Libint->vrr_classes[6][17] = int_stack + 20972;
 Libint->vrr_classes[6][18] = int_stack + 25760;
 Libint->vrr_classes[6][19] = int_stack + 31080;
 Libint->vrr_classes[7][10] = int_stack + 36960;
 Libint->vrr_classes[7][11] = int_stack + 39336;
 Libint->vrr_classes[7][12] = int_stack + 42144;
 Libint->vrr_classes[7][13] = int_stack + 45420;
 Libint->vrr_classes[7][14] = int_stack + 49200;
 Libint->vrr_classes[7][15] = int_stack + 53520;
 Libint->vrr_classes[7][16] = int_stack + 58416;
 Libint->vrr_classes[7][17] = int_stack + 63924;
 Libint->vrr_classes[7][18] = int_stack + 70080;
 Libint->vrr_classes[7][19] = int_stack + 76920;
 Libint->vrr_classes[8][10] = int_stack + 84480;
 Libint->vrr_classes[8][11] = int_stack + 87450;
 Libint->vrr_classes[8][12] = int_stack + 90960;
 Libint->vrr_classes[8][13] = int_stack + 95055;
 Libint->vrr_classes[8][14] = int_stack + 99780;
 Libint->vrr_classes[8][15] = int_stack + 105180;
 Libint->vrr_classes[8][16] = int_stack + 111300;
 Libint->vrr_classes[8][17] = int_stack + 118185;
 Libint->vrr_classes[8][18] = int_stack + 125880;
 Libint->vrr_classes[8][19] = int_stack + 134430;
 Libint->vrr_classes[9][10] = int_stack + 143880;
 Libint->vrr_classes[9][11] = int_stack + 147510;
 Libint->vrr_classes[9][12] = int_stack + 151800;
 Libint->vrr_classes[9][13] = int_stack + 156805;
 Libint->vrr_classes[9][14] = int_stack + 162580;
 Libint->vrr_classes[9][15] = int_stack + 169180;
 Libint->vrr_classes[9][16] = int_stack + 176660;
 Libint->vrr_classes[9][17] = int_stack + 185075;
 Libint->vrr_classes[9][18] = int_stack + 194480;
 Libint->vrr_classes[9][19] = int_stack + 204930;
 Libint->vrr_classes[10][10] = int_stack + 216480;
 Libint->vrr_classes[10][11] = int_stack + 220836;
 Libint->vrr_classes[10][12] = int_stack + 225984;
 Libint->vrr_classes[10][13] = int_stack + 231990;
 Libint->vrr_classes[10][14] = int_stack + 238920;
 Libint->vrr_classes[10][15] = int_stack + 246840;
 Libint->vrr_classes[10][16] = int_stack + 255816;
 Libint->vrr_classes[10][17] = int_stack + 265914;
 Libint->vrr_classes[10][18] = int_stack + 277200;
 Libint->vrr_classes[10][19] = int_stack + 289740;
 Libint->vrr_classes[11][10] = int_stack + 303600;
 Libint->vrr_classes[11][11] = int_stack + 308748;
 Libint->vrr_classes[11][12] = int_stack + 314832;
 Libint->vrr_classes[11][13] = int_stack + 321930;
 Libint->vrr_classes[11][14] = int_stack + 330120;
 Libint->vrr_classes[11][15] = int_stack + 339480;
 Libint->vrr_classes[11][16] = int_stack + 350088;
 Libint->vrr_classes[11][17] = int_stack + 362022;
 Libint->vrr_classes[11][18] = int_stack + 375360;
 Libint->vrr_classes[11][19] = int_stack + 390180;
 Libint->vrr_classes[12][10] = int_stack + 406560;
 Libint->vrr_classes[12][11] = int_stack + 412566;
 Libint->vrr_classes[12][12] = int_stack + 419664;
 Libint->vrr_classes[12][13] = int_stack + 427945;
 Libint->vrr_classes[12][14] = int_stack + 437500;
 Libint->vrr_classes[12][15] = int_stack + 448420;
 Libint->vrr_classes[12][16] = int_stack + 460796;
 Libint->vrr_classes[12][17] = int_stack + 474719;
 Libint->vrr_classes[12][18] = int_stack + 490280;
 Libint->vrr_classes[12][19] = int_stack + 507570;
 memset(int_stack,0,526680*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 526680;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iinm(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+526680,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+532224,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+538776,int_stack+532224,int_stack+526680,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+549864,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+557508,int_stack+549864,int_stack+532224,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+570612,int_stack+557508,int_stack+538776,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+526680,int_stack+9520,int_stack+6580,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+589092,int_stack+526680,int_stack+549864,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+535500,int_stack+589092,int_stack+557508,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+604380,int_stack+535500,int_stack+570612,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+557340,int_stack+12880,int_stack+9520,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+567420,int_stack+557340,int_stack+526680,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+632100,int_stack+567420,int_stack+589092,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+657580,int_stack+632100,int_stack+535500,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+690340,int_stack+657580,int_stack+604380,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+526680,int_stack+16688,int_stack+12880,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+585060,int_stack+526680,int_stack+557340,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+729148,int_stack+585060,int_stack+567420,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+538104,int_stack+729148,int_stack+632100,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+605220,int_stack+538104,int_stack+657580,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+758548,int_stack+605220,int_stack+690340,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+651084,int_stack+20972,int_stack+16688,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+663936,int_stack+651084,int_stack+526680,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+686784,int_stack+663936,int_stack+585060,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+810292,int_stack+686784,int_stack+729148,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+854392,int_stack+810292,int_stack+538104,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+526680,int_stack+854392,int_stack+605220,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+907900,int_stack+526680,int_stack+758548,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+587832,int_stack+25760,int_stack+20972,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+602196,int_stack+587832,int_stack+651084,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+720384,int_stack+602196,int_stack+663936,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+627900,int_stack+720384,int_stack+686784,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+974428,int_stack+627900,int_stack+810292,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+758464,int_stack+974428,int_stack+854392,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1036168,int_stack+758464,int_stack+526680,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1114792,int_stack+1036168,int_stack+907900,28);
 /*--- compute (i0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+526680,int_stack+31080,int_stack+25760,28);
 /*--- compute (i0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+542640,int_stack+526680,int_stack+587832,28);
 /*--- compute (i0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+829808,int_stack+542640,int_stack+602196,28);
 /*--- compute (i0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+526680,int_stack+829808,int_stack+720384,28);
 /*--- compute (i0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+829808,int_stack+526680,int_stack+627900,28);
 /*--- compute (i0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+526680,int_stack+829808,int_stack+974428,28);
 /*--- compute (i0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+829808,int_stack+526680,int_stack+758464,28);
 /*--- compute (i0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+526680,int_stack+829808,int_stack+1036168,28);
 /*--- compute (i0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+624960,int_stack+526680,int_stack+1114792,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+526680,int_stack+39336,int_stack+36960,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+533808,int_stack+42144,int_stack+39336,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+542232,int_stack+533808,int_stack+526680,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+556488,int_stack+45420,int_stack+42144,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+566316,int_stack+556488,int_stack+533808,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+583164,int_stack+566316,int_stack+542232,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+526680,int_stack+49200,int_stack+45420,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+726600,int_stack+526680,int_stack+556488,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+538020,int_stack+726600,int_stack+566316,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+746256,int_stack+538020,int_stack+583164,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+566100,int_stack+53520,int_stack+49200,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+579060,int_stack+566100,int_stack+526680,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+781896,int_stack+579060,int_stack+726600,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+814656,int_stack+781896,int_stack+538020,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+856776,int_stack+814656,int_stack+746256,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+726600,int_stack+58416,int_stack+53520,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+741288,int_stack+726600,int_stack+566100,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+526680,int_stack+741288,int_stack+579060,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+564480,int_stack+526680,int_stack+781896,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+906672,int_stack+564480,int_stack+814656,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+767208,int_stack+906672,int_stack+856776,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+833736,int_stack+63924,int_stack+58416,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+850260,int_stack+833736,int_stack+726600,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+965640,int_stack+850260,int_stack+741288,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1008840,int_stack+965640,int_stack+526680,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1065540,int_stack+1008840,int_stack+564480,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+526680,int_stack+1065540,int_stack+906672,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+879636,int_stack+526680,int_stack+767208,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+605304,int_stack+70080,int_stack+63924,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+726600,int_stack+605304,int_stack+833736,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+759648,int_stack+726600,int_stack+850260,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+808608,int_stack+759648,int_stack+965640,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1134336,int_stack+808608,int_stack+1008840,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+965172,int_stack+1134336,int_stack+1065540,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1213716,int_stack+965172,int_stack+526680,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1314804,int_stack+1213716,int_stack+879636,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+526680,int_stack+76920,int_stack+70080,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+547200,int_stack+526680,int_stack+605304,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+873408,int_stack+547200,int_stack+726600,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+526680,int_stack+873408,int_stack+759648,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+873408,int_stack+526680,int_stack+808608,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+726600,int_stack+873408,int_stack+1134336,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+832440,int_stack+726600,int_stack+965172,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+950376,int_stack+832440,int_stack+1213716,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+726600,int_stack+950376,int_stack+1314804,36);
 /*--- compute (ip|nm) ---*/
 hrr1_build_ip(Libint->AB,int_stack+857280,int_stack+726600,int_stack+624960,3630);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1162200,int_stack+87450,int_stack+84480,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1171110,int_stack+90960,int_stack+87450,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1181640,int_stack+1171110,int_stack+1162200,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1199460,int_stack+95055,int_stack+90960,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1211745,int_stack+1199460,int_stack+1171110,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1232805,int_stack+1211745,int_stack+1181640,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1162200,int_stack+99780,int_stack+95055,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1262505,int_stack+1162200,int_stack+1199460,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1176375,int_stack+1262505,int_stack+1211745,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1287075,int_stack+1176375,int_stack+1232805,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1211475,int_stack+105180,int_stack+99780,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1227675,int_stack+1211475,int_stack+1162200,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1331625,int_stack+1227675,int_stack+1262505,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+526680,int_stack+1331625,int_stack+1176375,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+579330,int_stack+526680,int_stack+1287075,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1162200,int_stack+111300,int_stack+105180,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1256025,int_stack+1162200,int_stack+1211475,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1372575,int_stack+1256025,int_stack+1227675,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1180560,int_stack+1372575,int_stack+1331625,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1288425,int_stack+1180560,int_stack+526680,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+641700,int_stack+1288425,int_stack+579330,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+526680,int_stack+118185,int_stack+111300,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+547335,int_stack+526680,int_stack+1162200,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+584055,int_stack+547335,int_stack+1256025,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+584055,int_stack+1372575,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1362135,int_stack+0,int_stack+1180560,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1162200,int_stack+1362135,int_stack+1288425,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1448130,int_stack+1162200,int_stack+641700,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1260480,int_stack+125880,int_stack+118185,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1283565,int_stack+1260480,int_stack+526680,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+638055,int_stack+1283565,int_stack+547335,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1555050,int_stack+638055,int_stack+584055,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+526680,int_stack+1555050,int_stack+0,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+526680,int_stack+1362135,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1636050,int_stack+0,int_stack+1162200,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1762410,int_stack+1636050,int_stack+1448130,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1162200,int_stack+134430,int_stack+125880,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1187850,int_stack+1162200,int_stack+1260480,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1324875,int_stack+1187850,int_stack+1283565,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1162200,int_stack+1324875,int_stack+638055,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1254000,int_stack+1162200,int_stack+1555050,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1367400,int_stack+1254000,int_stack+526680,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+526680,int_stack+1367400,int_stack+0,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1162200,int_stack+526680,int_stack+1636050,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+526680,int_stack+1162200,int_stack+1762410,45);
 /*--- compute (kp|nm) ---*/
 hrr1_build_kp(Libint->AB,int_stack+1162200,int_stack+526680,int_stack+726600,3630);
 /*--- compute (id|nm) ---*/
 hrr1_build_id(Libint->AB,int_stack+1554240,int_stack+1162200,int_stack+857280,3630);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+690030,int_stack+147510,int_stack+143880,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+700920,int_stack+151800,int_stack+147510,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+713790,int_stack+700920,int_stack+690030,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+735570,int_stack+156805,int_stack+151800,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+750585,int_stack+735570,int_stack+700920,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+776325,int_stack+750585,int_stack+713790,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+690030,int_stack+162580,int_stack+156805,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+812625,int_stack+690030,int_stack+735570,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+707355,int_stack+812625,int_stack+750585,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+842655,int_stack+707355,int_stack+776325,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+750255,int_stack+169180,int_stack+162580,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+770055,int_stack+750255,int_stack+690030,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+897105,int_stack+770055,int_stack+812625,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+947155,int_stack+897105,int_stack+707355,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1011505,int_stack+947155,int_stack+842655,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+690030,int_stack+176660,int_stack+169180,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+804705,int_stack+690030,int_stack+750255,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1087735,int_stack+804705,int_stack+770055,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+712470,int_stack+1087735,int_stack+897105,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+844305,int_stack+712470,int_stack+947155,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+844305,int_stack+1011505,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+934395,int_stack+185075,int_stack+176660,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+959640,int_stack+934395,int_stack+690030,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1004520,int_stack+959640,int_stack+804705,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2164080,int_stack+1004520,int_stack+1087735,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2250705,int_stack+2164080,int_stack+712470,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+690030,int_stack+2250705,int_stack+844305,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2355810,int_stack+690030,int_stack+0,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+194480,int_stack+185075,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+28215,int_stack+0,int_stack+934395,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+78705,int_stack+28215,int_stack+959640,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+810150,int_stack+78705,int_stack+1004520,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+909150,int_stack+810150,int_stack+2164080,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2486490,int_stack+909150,int_stack+2250705,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2164080,int_stack+2486490,int_stack+690030,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2626630,int_stack+2164080,int_stack+2355810,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+690030,int_stack+204930,int_stack+194480,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+721380,int_stack+690030,int_stack+0,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2318520,int_stack+721380,int_stack+28215,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+690030,int_stack+2318520,int_stack+78705,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2318520,int_stack+690030,int_stack+810150,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+690030,int_stack+2318520,int_stack+909150,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+851730,int_stack+690030,int_stack+2486490,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2318520,int_stack+851730,int_stack+2164080,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+690030,int_stack+2318520,int_stack+2626630,55);
 /*--- compute (lp|nm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+2164080,int_stack+690030,int_stack+526680,3630);
 /*--- compute (kd|nm) ---*/
 hrr1_build_kd(Libint->AB,int_stack+2654130,int_stack+2164080,int_stack+1162200,3630);
 /*--- compute (if|nm) ---*/
 hrr1_build_if(Libint->AB,int_stack+3438210,int_stack+2654130,int_stack+1554240,3630);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+526680,int_stack+220836,int_stack+216480,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+539748,int_stack+225984,int_stack+220836,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+555192,int_stack+539748,int_stack+526680,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+581328,int_stack+231990,int_stack+225984,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+599346,int_stack+581328,int_stack+539748,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+630234,int_stack+599346,int_stack+555192,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+526680,int_stack+238920,int_stack+231990,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+889680,int_stack+526680,int_stack+581328,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+547470,int_stack+889680,int_stack+599346,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+925716,int_stack+547470,int_stack+630234,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+598950,int_stack+246840,int_stack+238920,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+622710,int_stack+598950,int_stack+526680,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+991056,int_stack+622710,int_stack+889680,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1051116,int_stack+991056,int_stack+547470,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1128336,int_stack+1051116,int_stack+925716,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+889680,int_stack+255816,int_stack+246840,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+916608,int_stack+889680,int_stack+598950,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+526680,int_stack+916608,int_stack+622710,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+595980,int_stack+526680,int_stack+991056,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1219812,int_stack+595980,int_stack+1051116,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+964128,int_stack+1219812,int_stack+1128336,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1086096,int_stack+265914,int_stack+255816,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1116390,int_stack+1086096,int_stack+889680,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1327920,int_stack+1116390,int_stack+916608,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1407120,int_stack+1327920,int_stack+526680,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1511070,int_stack+1407120,int_stack+595980,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+526680,int_stack+1511070,int_stack+1219812,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1170246,int_stack+526680,int_stack+964128,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+889680,int_stack+277200,int_stack+265914,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+923538,int_stack+889680,int_stack+1086096,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+984126,int_stack+923538,int_stack+1116390,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1637196,int_stack+984126,int_stack+1327920,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1755996,int_stack+1637196,int_stack+1407120,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1327062,int_stack+1755996,int_stack+1511070,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1901526,int_stack+1327062,int_stack+526680,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1901526,int_stack+1170246,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+526680,int_stack+289740,int_stack+277200,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+564300,int_stack+526680,int_stack+889680,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1073886,int_stack+564300,int_stack+923538,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+526680,int_stack+1073886,int_stack+984126,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+889680,int_stack+526680,int_stack+1637196,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1056000,int_stack+889680,int_stack+1755996,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1495230,int_stack+1056000,int_stack+1327062,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+889680,int_stack+1495230,int_stack+1901526,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1121340,int_stack+889680,int_stack+0,66);
 /*--- compute (mp|nm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1360920,int_stack+1121340,int_stack+690030,3630);
 /*--- compute (ld|nm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+4454610,int_stack+1360920,int_stack+2164080,3630);
 /*--- compute (kf|nm) ---*/
 hrr1_build_kf(Libint->AB,int_stack+5434710,int_stack+4454610,int_stack+2654130,3630);
 /*--- compute (ig|nm) ---*/
 hrr1_build_ig(Libint->AB,int_stack+6741510,int_stack+5434710,int_stack+3438210,3630);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+308748,int_stack+303600,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+314832,int_stack+308748,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+321930,int_stack+314832,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+122382,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+330120,int_stack+321930,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+173862,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+173862,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+216450,int_stack+24570,int_stack+122382,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+85410,int_stack+339480,int_stack+330120,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113490,int_stack+85410,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1959870,int_stack+113490,int_stack+173862,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2030850,int_stack+1959870,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2122110,int_stack+2030850,int_stack+216450,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+350088,int_stack+339480,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+162630,int_stack+0,int_stack+85410,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+218790,int_stack+162630,int_stack+113490,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+31824,int_stack+218790,int_stack+1959870,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2230218,int_stack+31824,int_stack+2030850,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1959870,int_stack+2230218,int_stack+2122110,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2104014,int_stack+362022,int_stack+350088,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2139816,int_stack+2104014,int_stack+0,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2357982,int_stack+2139816,int_stack+162630,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2451582,int_stack+2357982,int_stack+218790,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+138294,int_stack+2451582,int_stack+31824,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2574432,int_stack+138294,int_stack+2230218,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2744784,int_stack+2574432,int_stack+1959870,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1959870,int_stack+375360,int_stack+362022,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1999884,int_stack+1959870,int_stack+2104014,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+1999884,int_stack+2139816,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2071488,int_stack+0,int_stack+2357982,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2211888,int_stack+2071488,int_stack+2451582,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2930112,int_stack+2211888,int_stack+138294,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+106080,int_stack+2930112,int_stack+2574432,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2383878,int_stack+106080,int_stack+2744784,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+2615538,int_stack+390180,int_stack+375360,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+2659998,int_stack+2615538,int_stack+1959870,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2740026,int_stack+2659998,int_stack+1999884,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+3128856,int_stack+2740026,int_stack+0,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2615538,int_stack+3128856,int_stack+2071488,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+3128856,int_stack+2615538,int_stack+2211888,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2615538,int_stack+3128856,int_stack+2930112,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2871066,int_stack+2615538,int_stack+106080,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+3144846,int_stack+2871066,int_stack+2383878,78);
 /*--- compute (np|nm) ---*/
 hrr1_build_np(Libint->AB,int_stack+3427986,int_stack+3144846,int_stack+1121340,3630);
 /*--- compute (md|nm) ---*/
 hrr1_build_md(Libint->AB,int_stack+8266110,int_stack+3427986,int_stack+1360920,3630);
 /*--- compute (lf|nm) ---*/
 hrr1_build_lf(Libint->AB,int_stack+526680,int_stack+8266110,int_stack+4454610,3630);
 /*--- compute (kg|nm) ---*/
 hrr1_build_kg(Libint->AB,int_stack+9464010,int_stack+526680,int_stack+5434710,3630);
 /*--- compute (ih|nm) ---*/
 hrr1_build_ih(Libint->AB,int_stack+4146726,int_stack+9464010,int_stack+6741510,3630);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+6281166,int_stack+412566,int_stack+406560,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+6299184,int_stack+419664,int_stack+412566,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+6320478,int_stack+6299184,int_stack+6281166,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+6356514,int_stack+427945,int_stack+419664,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+6381357,int_stack+6356514,int_stack+6299184,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+6423945,int_stack+6381357,int_stack+6320478,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+6281166,int_stack+437500,int_stack+427945,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+6484005,int_stack+6281166,int_stack+6356514,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+6309831,int_stack+6484005,int_stack+6381357,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+6533691,int_stack+6309831,int_stack+6423945,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+6380811,int_stack+448420,int_stack+437500,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+6413571,int_stack+6380811,int_stack+6281166,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+6623781,int_stack+6413571,int_stack+6484005,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+6706591,int_stack+6623781,int_stack+6309831,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+6813061,int_stack+6706591,int_stack+6533691,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+6281166,int_stack+460796,int_stack+448420,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+6470901,int_stack+6281166,int_stack+6380811,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+6939187,int_stack+6470901,int_stack+6413571,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+6318294,int_stack+6939187,int_stack+6623781,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+6536421,int_stack+6318294,int_stack+6706591,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+7034737,int_stack+6536421,int_stack+6813061,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+6685479,int_stack+474719,int_stack+460796,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+6727248,int_stack+6685479,int_stack+6281166,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+6801504,int_stack+6727248,int_stack+6470901,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+7202905,int_stack+6801504,int_stack+6939187,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+7346230,int_stack+7202905,int_stack+6318294,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+6281166,int_stack+7346230,int_stack+6536421,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+7520131,int_stack+6281166,int_stack+7034737,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+6479910,int_stack+490280,int_stack+474719,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+6526593,int_stack+6479910,int_stack+6685479,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+6910704,int_stack+6526593,int_stack+6727248,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+6610131,int_stack+6910704,int_stack+6801504,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+7736347,int_stack+6610131,int_stack+7202905,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+7034464,int_stack+7736347,int_stack+7346230,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+7937002,int_stack+7034464,int_stack+6281166,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+7937002,int_stack+7520131,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+6281166,int_stack+507570,int_stack+490280,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+6333036,int_stack+6281166,int_stack+6479910,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+7266332,int_stack+6333036,int_stack+6526593,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+6281166,int_stack+7266332,int_stack+6910704,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+7266332,int_stack+6281166,int_stack+6610131,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+6281166,int_stack+7266332,int_stack+7736347,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+7266332,int_stack+6281166,int_stack+7034464,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+6281166,int_stack+7266332,int_stack+7937002,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+6600576,int_stack+6281166,int_stack+0,91);
 /*--- compute (op|nm) ---*/
 hrr1_build_op(Libint->AB,int_stack+6930906,int_stack+6600576,int_stack+3144846,3630);
 /*--- compute (nd|nm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+11424210,int_stack+6930906,int_stack+3427986,3630);
 /*--- compute (mf|nm) ---*/
 hrr1_build_mf(Libint->AB,int_stack+12861690,int_stack+11424210,int_stack+8266110,3630);
 /*--- compute (lg|nm) ---*/
 hrr1_build_lg(Libint->AB,int_stack+6281166,int_stack+12861690,int_stack+526680,3630);
 /*--- compute (kh|nm) ---*/
 hrr1_build_kh(Libint->AB,int_stack+11424210,int_stack+6281166,int_stack+9464010,3630);
 /*--- compute (ii|nm) ---*/
 hrr1_build_ii(Libint->AB,int_stack+6281166,int_stack+11424210,int_stack+4146726,3630);
 return int_stack+6281166;}
