/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iplg(Libint_t*, prim_data*);

  /* Computes quartets of (ip|lg) integrals */

REALTYPE *hrr_order_iplg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[7][8] = int_stack + 9380;
 Libint->vrr_classes[7][9] = int_stack + 11000;
 Libint->vrr_classes[7][10] = int_stack + 12980;
 Libint->vrr_classes[7][11] = int_stack + 15356;
 Libint->vrr_classes[7][12] = int_stack + 18164;
 memset(int_stack,0,21440*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 21440;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iplg(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+21440,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25220,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+29840,int_stack+25220,int_stack+21440,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37400,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+42944,int_stack+37400,int_stack+25220,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+52184,int_stack+42944,int_stack+29840,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+21440,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+64784,int_stack+21440,int_stack+37400,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+21440,int_stack+64784,int_stack+42944,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+64784,int_stack+21440,int_stack+52184,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+21440,int_stack+11000,int_stack+9380,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+26300,int_stack+12980,int_stack+11000,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+32240,int_stack+26300,int_stack+21440,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+41960,int_stack+15356,int_stack+12980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+49088,int_stack+41960,int_stack+26300,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+83684,int_stack+49088,int_stack+32240,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+21440,int_stack+18164,int_stack+15356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+21440,int_stack+41960,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+14256,int_stack+0,int_stack+49088,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+34056,int_stack+14256,int_stack+83684,36);
 /*--- compute (ip|lg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+83684,int_stack+34056,int_stack+64784,675);
 return int_stack+83684;}
