/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_k0hg(Libint_t*, prim_data*);

  /* Computes quartets of (k0|hg) integrals */

REALTYPE *hrr_order_k0hg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][5] = int_stack + 0;
 Libint->vrr_classes[7][6] = int_stack + 756;
 Libint->vrr_classes[7][7] = int_stack + 1764;
 Libint->vrr_classes[7][8] = int_stack + 3060;
 Libint->vrr_classes[7][9] = int_stack + 4680;
 memset(int_stack,0,6660*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 6660;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_k0hg(Libint, Data);
   Data++;
 }
 /*--- compute (k0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+6660,int_stack+756,int_stack+0,36);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+8928,int_stack+1764,int_stack+756,36);
 /*--- compute (k0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+11952,int_stack+8928,int_stack+6660,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+16488,int_stack+3060,int_stack+1764,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+20376,int_stack+16488,int_stack+8928,36);
 /*--- compute (k0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+26424,int_stack+20376,int_stack+11952,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+6660,int_stack+4680,int_stack+3060,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+33984,int_stack+6660,int_stack+16488,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+33984,int_stack+20376,36);
 /*--- compute (k0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+10080,int_stack+0,int_stack+26424,36);
 return int_stack+10080;}
