/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_k0nk(Libint_t*, prim_data*);

  /* Computes quartets of (k0|nk) integrals */

REALTYPE *hrr_order_k0nk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[7][17] = int_stack + 26964;
 memset(int_stack,0,33120*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 33120;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_k0nk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+33120,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+40248,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+48672,int_stack+40248,int_stack+33120,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+62928,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72756,int_stack+62928,int_stack+40248,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+89604,int_stack+72756,int_stack+48672,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+33120,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+113364,int_stack+33120,int_stack+62928,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+44460,int_stack+113364,int_stack+72756,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+133020,int_stack+44460,int_stack+89604,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+72540,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+85500,int_stack+72540,int_stack+33120,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+168660,int_stack+85500,int_stack+113364,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+201420,int_stack+168660,int_stack+44460,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+243540,int_stack+201420,int_stack+133020,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+33120,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+108180,int_stack+33120,int_stack+72540,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+293436,int_stack+108180,int_stack+85500,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+47808,int_stack+293436,int_stack+168660,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+134100,int_stack+47808,int_stack+201420,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+331236,int_stack+134100,int_stack+243540,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+193068,int_stack+26964,int_stack+21456,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+209592,int_stack+193068,int_stack+33120,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+238968,int_stack+209592,int_stack+108180,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+397764,int_stack+238968,int_stack+293436,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+193068,int_stack+397764,int_stack+47808,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+193068,int_stack+134100,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+78624,int_stack+0,int_stack+331236,36);
 return int_stack+78624;}
