/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdif(Libint_t*, prim_data*);

  /* Computes quartets of (kd|if) integrals */

REALTYPE *hrr_order_kdif(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][6] = int_stack + 0;
 Libint->vrr_classes[7][7] = int_stack + 1008;
 Libint->vrr_classes[7][8] = int_stack + 2304;
 Libint->vrr_classes[7][9] = int_stack + 3924;
 Libint->vrr_classes[8][6] = int_stack + 5904;
 Libint->vrr_classes[8][7] = int_stack + 7164;
 Libint->vrr_classes[8][8] = int_stack + 8784;
 Libint->vrr_classes[8][9] = int_stack + 10809;
 Libint->vrr_classes[9][6] = int_stack + 13284;
 Libint->vrr_classes[9][7] = int_stack + 14824;
 Libint->vrr_classes[9][8] = int_stack + 16804;
 Libint->vrr_classes[9][9] = int_stack + 19279;
 memset(int_stack,0,22304*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 22304;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdif(Libint, Data);
   Data++;
 }
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+22304,int_stack+1008,int_stack+0,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+25328,int_stack+2304,int_stack+1008,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+29216,int_stack+25328,int_stack+22304,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+35264,int_stack+3924,int_stack+2304,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+40124,int_stack+35264,int_stack+25328,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+47900,int_stack+40124,int_stack+29216,36);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+22304,int_stack+7164,int_stack+5904,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+26084,int_stack+8784,int_stack+7164,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+30944,int_stack+26084,int_stack+22304,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+38504,int_stack+10809,int_stack+8784,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+0,int_stack+38504,int_stack+26084,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+57980,int_stack+0,int_stack+30944,45);
 /*--- compute (kp|if) ---*/
 hrr1_build_kp(Libint->AB,int_stack+70580,int_stack+57980,int_stack+47900,280);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+14824,int_stack+13284,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+4620,int_stack+16804,int_stack+14824,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+22304,int_stack+4620,int_stack+0,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+31544,int_stack+19279,int_stack+16804,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+38969,int_stack+31544,int_stack+4620,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+38969,int_stack+22304,55);
 /*--- compute (lp|if) ---*/
 hrr1_build_lp(Libint->AB,int_stack+15400,int_stack+0,int_stack+57980,280);
 /*--- compute (kd|if) ---*/
 hrr1_build_kd(Libint->AB,int_stack+100820,int_stack+15400,int_stack+70580,280);
 return int_stack+100820;}
