/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdlf(Libint_t*, prim_data*);

  /* Computes quartets of (kd|lf) integrals */

REALTYPE *hrr_order_kdlf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[8][8] = int_stack + 8784;
 Libint->vrr_classes[8][9] = int_stack + 10809;
 Libint->vrr_classes[8][10] = int_stack + 13284;
 Libint->vrr_classes[8][11] = int_stack + 16254;
 Libint->vrr_classes[9][8] = int_stack + 19764;
 Libint->vrr_classes[9][9] = int_stack + 22239;
 Libint->vrr_classes[9][10] = int_stack + 25264;
 Libint->vrr_classes[9][11] = int_stack + 28894;
 memset(int_stack,0,33184*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 33184;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdlf(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+33184,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+38044,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+43984,int_stack+38044,int_stack+33184,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+53704,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+60832,int_stack+53704,int_stack+38044,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+72712,int_stack+60832,int_stack+43984,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+33184,int_stack+10809,int_stack+8784,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+39259,int_stack+13284,int_stack+10809,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+46684,int_stack+39259,int_stack+33184,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+58834,int_stack+16254,int_stack+13284,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+58834,int_stack+39259,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+88912,int_stack+0,int_stack+46684,45);
 /*--- compute (kp|lf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+109162,int_stack+88912,int_stack+72712,450);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+22239,int_stack+19764,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7425,int_stack+25264,int_stack+22239,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+33184,int_stack+7425,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+48034,int_stack+28894,int_stack+25264,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+58924,int_stack+48034,int_stack+7425,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+58924,int_stack+33184,55);
 /*--- compute (lp|lf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+24750,int_stack+0,int_stack+88912,450);
 /*--- compute (kd|lf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+157762,int_stack+24750,int_stack+109162,450);
 return int_stack+157762;}
