/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdlh(Libint_t*, prim_data*);

  /* Computes quartets of (kd|lh) integrals */

REALTYPE *hrr_order_kdlh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[7][13] = int_stack + 12060;
 Libint->vrr_classes[8][8] = int_stack + 15840;
 Libint->vrr_classes[8][9] = int_stack + 17865;
 Libint->vrr_classes[8][10] = int_stack + 20340;
 Libint->vrr_classes[8][11] = int_stack + 23310;
 Libint->vrr_classes[8][12] = int_stack + 26820;
 Libint->vrr_classes[8][13] = int_stack + 30915;
 Libint->vrr_classes[9][8] = int_stack + 35640;
 Libint->vrr_classes[9][9] = int_stack + 38115;
 Libint->vrr_classes[9][10] = int_stack + 41140;
 Libint->vrr_classes[9][11] = int_stack + 44770;
 Libint->vrr_classes[9][12] = int_stack + 49060;
 Libint->vrr_classes[9][13] = int_stack + 54065;
 memset(int_stack,0,59840*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 59840;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdlh(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+59840,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+64700,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+70640,int_stack+64700,int_stack+59840,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+80360,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+87488,int_stack+80360,int_stack+64700,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+99368,int_stack+87488,int_stack+70640,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+59840,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+115568,int_stack+59840,int_stack+80360,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+129824,int_stack+115568,int_stack+87488,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+68264,int_stack+129824,int_stack+99368,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+92564,int_stack+12060,int_stack+8784,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+149624,int_stack+92564,int_stack+59840,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+166472,int_stack+149624,int_stack+115568,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+92564,int_stack+166472,int_stack+129824,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+122264,int_stack+92564,int_stack+68264,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+59840,int_stack+17865,int_stack+15840,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+65915,int_stack+20340,int_stack+17865,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+73340,int_stack+65915,int_stack+59840,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85490,int_stack+23310,int_stack+20340,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+94400,int_stack+85490,int_stack+65915,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+156284,int_stack+94400,int_stack+73340,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+59840,int_stack+26820,int_stack+23310,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+59840,int_stack+85490,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+176534,int_stack+0,int_stack+94400,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+70370,int_stack+176534,int_stack+156284,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+156284,int_stack+30915,int_stack+26820,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100745,int_stack+156284,int_stack+59840,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+201284,int_stack+100745,int_stack+0,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+230984,int_stack+201284,int_stack+176534,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+156284,int_stack+230984,int_stack+70370,45);
 /*--- compute (kp|lh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+198809,int_stack+156284,int_stack+122264,945);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+38115,int_stack+35640,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7425,int_stack+41140,int_stack+38115,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+16500,int_stack+7425,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59840,int_stack+44770,int_stack+41140,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+70730,int_stack+59840,int_stack+7425,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+88880,int_stack+70730,int_stack+16500,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+49060,int_stack+44770,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+12870,int_stack+0,int_stack+59840,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+113630,int_stack+12870,int_stack+70730,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+300869,int_stack+113630,int_stack+88880,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+59840,int_stack+54065,int_stack+49060,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+74855,int_stack+59840,int_stack+0,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+34650,int_stack+74855,int_stack+12870,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+337994,int_stack+34650,int_stack+113630,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+337994,int_stack+300869,55);
 /*--- compute (lp|lh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+300869,int_stack+0,int_stack+156284,945);
 /*--- compute (kd|lh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+428444,int_stack+300869,int_stack+198809,945);
 return int_stack+428444;}
