/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdmi(Libint_t*, prim_data*);

  /* Computes quartets of (kd|mi) integrals */

REALTYPE *hrr_order_kdmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[7][14] = int_stack + 14220;
 Libint->vrr_classes[7][15] = int_stack + 18540;
 Libint->vrr_classes[8][9] = int_stack + 23436;
 Libint->vrr_classes[8][10] = int_stack + 25911;
 Libint->vrr_classes[8][11] = int_stack + 28881;
 Libint->vrr_classes[8][12] = int_stack + 32391;
 Libint->vrr_classes[8][13] = int_stack + 36486;
 Libint->vrr_classes[8][14] = int_stack + 41211;
 Libint->vrr_classes[8][15] = int_stack + 46611;
 Libint->vrr_classes[9][9] = int_stack + 52731;
 Libint->vrr_classes[9][10] = int_stack + 55756;
 Libint->vrr_classes[9][11] = int_stack + 59386;
 Libint->vrr_classes[9][12] = int_stack + 63676;
 Libint->vrr_classes[9][13] = int_stack + 68681;
 Libint->vrr_classes[9][14] = int_stack + 74456;
 Libint->vrr_classes[9][15] = int_stack + 81056;
 memset(int_stack,0,88536*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 88536;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdmi(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+88536,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+94476,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+101604,int_stack+94476,int_stack+88536,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+113484,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+121908,int_stack+113484,int_stack+94476,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+136164,int_stack+121908,int_stack+101604,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+88536,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+155964,int_stack+88536,int_stack+113484,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+172812,int_stack+155964,int_stack+121908,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+98364,int_stack+172812,int_stack+136164,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+128064,int_stack+14220,int_stack+10440,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+196572,int_stack+128064,int_stack+88536,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+216228,int_stack+196572,int_stack+155964,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+244308,int_stack+216228,int_stack+172812,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+139404,int_stack+244308,int_stack+98364,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+88536,int_stack+18540,int_stack+14220,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+101496,int_stack+88536,int_stack+128064,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+279948,int_stack+101496,int_stack+196572,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+88536,int_stack+279948,int_stack+216228,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+180984,int_stack+88536,int_stack+244308,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+230880,int_stack+180984,int_stack+139404,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+88536,int_stack+25911,int_stack+23436,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+95961,int_stack+28881,int_stack+25911,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+104871,int_stack+95961,int_stack+88536,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+119721,int_stack+32391,int_stack+28881,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+130251,int_stack+119721,int_stack+95961,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+148071,int_stack+130251,int_stack+104871,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+88536,int_stack+36486,int_stack+32391,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+172821,int_stack+88536,int_stack+119721,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+193881,int_stack+172821,int_stack+130251,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+100821,int_stack+193881,int_stack+148071,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+137946,int_stack+41211,int_stack+36486,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+286320,int_stack+137946,int_stack+88536,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+286320,int_stack+172821,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+310890,int_stack+0,int_stack+193881,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+152121,int_stack+310890,int_stack+100821,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+88536,int_stack+46611,int_stack+41211,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+104736,int_stack+88536,int_stack+137946,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+355440,int_stack+104736,int_stack+286320,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+88536,int_stack+355440,int_stack+0,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+355440,int_stack+88536,int_stack+310890,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+417810,int_stack+355440,int_stack+152121,45);
 /*--- compute (kp|mi) ---*/
 hrr1_build_kp(Libint->AB,int_stack+487110,int_stack+417810,int_stack+230880,1540);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+88536,int_stack+55756,int_stack+52731,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+97611,int_stack+59386,int_stack+55756,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+108501,int_stack+97611,int_stack+88536,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+126651,int_stack+63676,int_stack+59386,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+139521,int_stack+126651,int_stack+97611,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+161301,int_stack+139521,int_stack+108501,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+88536,int_stack+68681,int_stack+63676,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+191551,int_stack+88536,int_stack+126651,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+217291,int_stack+191551,int_stack+139521,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+103551,int_stack+217291,int_stack+161301,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+148926,int_stack+74456,int_stack+68681,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+253591,int_stack+148926,int_stack+88536,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+283621,int_stack+253591,int_stack+191551,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+326521,int_stack+283621,int_stack+217291,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+166251,int_stack+326521,int_stack+103551,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+88536,int_stack+81056,int_stack+74456,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+108336,int_stack+88536,int_stack+148926,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+108336,int_stack+253591,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+50050,int_stack+0,int_stack+283621,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+229776,int_stack+50050,int_stack+326521,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+229776,int_stack+166251,55);
 /*--- compute (lp|mi) ---*/
 hrr1_build_lp(Libint->AB,int_stack+84700,int_stack+0,int_stack+417810,1540);
 /*--- compute (kd|mi) ---*/
 hrr1_build_kd(Libint->AB,int_stack+653430,int_stack+84700,int_stack+487110,1540);
 return int_stack+653430;}
