/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdmk(Libint_t*, prim_data*);

  /* Computes quartets of (kd|mk) integrals */

REALTYPE *hrr_order_kdmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[7][14] = int_stack + 14220;
 Libint->vrr_classes[7][15] = int_stack + 18540;
 Libint->vrr_classes[7][16] = int_stack + 23436;
 Libint->vrr_classes[8][9] = int_stack + 28944;
 Libint->vrr_classes[8][10] = int_stack + 31419;
 Libint->vrr_classes[8][11] = int_stack + 34389;
 Libint->vrr_classes[8][12] = int_stack + 37899;
 Libint->vrr_classes[8][13] = int_stack + 41994;
 Libint->vrr_classes[8][14] = int_stack + 46719;
 Libint->vrr_classes[8][15] = int_stack + 52119;
 Libint->vrr_classes[8][16] = int_stack + 58239;
 Libint->vrr_classes[9][9] = int_stack + 65124;
 Libint->vrr_classes[9][10] = int_stack + 68149;
 Libint->vrr_classes[9][11] = int_stack + 71779;
 Libint->vrr_classes[9][12] = int_stack + 76069;
 Libint->vrr_classes[9][13] = int_stack + 81074;
 Libint->vrr_classes[9][14] = int_stack + 86849;
 Libint->vrr_classes[9][15] = int_stack + 93449;
 Libint->vrr_classes[9][16] = int_stack + 100929;
 memset(int_stack,0,109344*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 109344;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdmk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+109344,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+115284,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+122412,int_stack+115284,int_stack+109344,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+134292,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+142716,int_stack+134292,int_stack+115284,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+156972,int_stack+142716,int_stack+122412,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+109344,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+176772,int_stack+109344,int_stack+134292,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+193620,int_stack+176772,int_stack+142716,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+119172,int_stack+193620,int_stack+156972,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+148872,int_stack+14220,int_stack+10440,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+217380,int_stack+148872,int_stack+109344,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+237036,int_stack+217380,int_stack+176772,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+265116,int_stack+237036,int_stack+193620,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+160212,int_stack+265116,int_stack+119172,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+109344,int_stack+18540,int_stack+14220,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+122304,int_stack+109344,int_stack+148872,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+300756,int_stack+122304,int_stack+217380,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+333516,int_stack+300756,int_stack+237036,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+201792,int_stack+333516,int_stack+265116,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+375636,int_stack+201792,int_stack+160212,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+144984,int_stack+23436,int_stack+18540,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+159672,int_stack+144984,int_stack+109344,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+251688,int_stack+159672,int_stack+122304,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+109344,int_stack+251688,int_stack+300756,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+251688,int_stack+109344,int_stack+333516,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+109344,int_stack+251688,int_stack+201792,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+175872,int_stack+109344,int_stack+375636,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+109344,int_stack+31419,int_stack+28944,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+116769,int_stack+34389,int_stack+31419,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+125679,int_stack+116769,int_stack+109344,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+140529,int_stack+37899,int_stack+34389,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+151059,int_stack+140529,int_stack+116769,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+247152,int_stack+151059,int_stack+125679,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+109344,int_stack+41994,int_stack+37899,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+271902,int_stack+109344,int_stack+140529,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+292962,int_stack+271902,int_stack+151059,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+121629,int_stack+292962,int_stack+247152,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+247152,int_stack+46719,int_stack+41994,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+322662,int_stack+247152,int_stack+109344,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+347232,int_stack+322662,int_stack+271902,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+382332,int_stack+347232,int_stack+292962,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+261327,int_stack+382332,int_stack+121629,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+109344,int_stack+52119,int_stack+46719,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+125544,int_stack+109344,int_stack+247152,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+125544,int_stack+322662,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+426882,int_stack+0,int_stack+347232,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+313302,int_stack+426882,int_stack+382332,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+479532,int_stack+313302,int_stack+261327,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+247152,int_stack+58239,int_stack+52119,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+265512,int_stack+247152,int_stack+109344,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+375672,int_stack+265512,int_stack+125544,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+109344,int_stack+375672,int_stack+0,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+548832,int_stack+109344,int_stack+426882,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+375672,int_stack+548832,int_stack+313302,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+247152,int_stack+375672,int_stack+479532,45);
 /*--- compute (kp|mk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+336252,int_stack+247152,int_stack+175872,1980);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+109344,int_stack+68149,int_stack+65124,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+118419,int_stack+71779,int_stack+68149,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+129309,int_stack+118419,int_stack+109344,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+147459,int_stack+76069,int_stack+71779,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+160329,int_stack+147459,int_stack+118419,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+182109,int_stack+160329,int_stack+129309,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+109344,int_stack+81074,int_stack+76069,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+212359,int_stack+109344,int_stack+147459,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+212359,int_stack+160329,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+124359,int_stack+0,int_stack+182109,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+169734,int_stack+86849,int_stack+81074,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+36300,int_stack+169734,int_stack+109344,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+550092,int_stack+36300,int_stack+212359,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+187059,int_stack+550092,int_stack+0,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+592992,int_stack+187059,int_stack+124359,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+93449,int_stack+86849,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+109344,int_stack+0,int_stack+169734,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+656517,int_stack+109344,int_stack+36300,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+19800,int_stack+656517,int_stack+550092,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+706567,int_stack+19800,int_stack+187059,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+143994,int_stack+706567,int_stack+592992,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+550092,int_stack+100929,int_stack+93449,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+572532,int_stack+550092,int_stack+0,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+782797,int_stack+572532,int_stack+109344,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+550092,int_stack+782797,int_stack+656517,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+782797,int_stack+550092,int_stack+19800,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+550092,int_stack+782797,int_stack+706567,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+651732,int_stack+550092,int_stack+143994,55);
 /*--- compute (lp|mk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+760632,int_stack+651732,int_stack+247152,1980);
 /*--- compute (kd|mk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1027932,int_stack+760632,int_stack+336252,1980);
 return int_stack+1027932;}
