/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kfig(Libint_t*, prim_data*);

  /* Computes quartets of (kf|ig) integrals */

REALTYPE *hrr_order_kfig(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][6] = int_stack + 0;
 Libint->vrr_classes[7][7] = int_stack + 1008;
 Libint->vrr_classes[7][8] = int_stack + 2304;
 Libint->vrr_classes[7][9] = int_stack + 3924;
 Libint->vrr_classes[7][10] = int_stack + 5904;
 Libint->vrr_classes[8][6] = int_stack + 8280;
 Libint->vrr_classes[8][7] = int_stack + 9540;
 Libint->vrr_classes[8][8] = int_stack + 11160;
 Libint->vrr_classes[8][9] = int_stack + 13185;
 Libint->vrr_classes[8][10] = int_stack + 15660;
 Libint->vrr_classes[9][6] = int_stack + 18630;
 Libint->vrr_classes[9][7] = int_stack + 20170;
 Libint->vrr_classes[9][8] = int_stack + 22150;
 Libint->vrr_classes[9][9] = int_stack + 24625;
 Libint->vrr_classes[9][10] = int_stack + 27650;
 Libint->vrr_classes[10][6] = int_stack + 31280;
 Libint->vrr_classes[10][7] = int_stack + 33128;
 Libint->vrr_classes[10][8] = int_stack + 35504;
 Libint->vrr_classes[10][9] = int_stack + 38474;
 Libint->vrr_classes[10][10] = int_stack + 42104;
 memset(int_stack,0,46460*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 46460;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kfig(Libint, Data);
   Data++;
 }
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+46460,int_stack+1008,int_stack+0,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+49484,int_stack+2304,int_stack+1008,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+53372,int_stack+49484,int_stack+46460,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+59420,int_stack+3924,int_stack+2304,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+64280,int_stack+59420,int_stack+49484,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+72056,int_stack+64280,int_stack+53372,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+46460,int_stack+5904,int_stack+3924,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+82136,int_stack+46460,int_stack+59420,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+46460,int_stack+82136,int_stack+64280,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+82136,int_stack+46460,int_stack+72056,36);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+46460,int_stack+9540,int_stack+8280,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+50240,int_stack+11160,int_stack+9540,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+55100,int_stack+50240,int_stack+46460,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+62660,int_stack+13185,int_stack+11160,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+68735,int_stack+62660,int_stack+50240,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+68735,int_stack+55100,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+46460,int_stack+15660,int_stack+13185,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+97256,int_stack+46460,int_stack+62660,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+46460,int_stack+97256,int_stack+68735,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+62660,int_stack+46460,int_stack+0,45);
 /*--- compute (kp|ig) ---*/
 hrr1_build_kp(Libint->AB,int_stack+97256,int_stack+62660,int_stack+82136,420);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+20170,int_stack+18630,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+4620,int_stack+22150,int_stack+20170,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+10560,int_stack+4620,int_stack+0,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+46460,int_stack+24625,int_stack+22150,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+81560,int_stack+46460,int_stack+4620,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+142616,int_stack+81560,int_stack+10560,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+27650,int_stack+24625,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+9075,int_stack+0,int_stack+46460,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+158016,int_stack+9075,int_stack+81560,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+0,int_stack+158016,int_stack+142616,55);
 /*--- compute (lp|ig) ---*/
 hrr1_build_lp(Libint->AB,int_stack+142616,int_stack+0,int_stack+62660,420);
 /*--- compute (kd|ig) ---*/
 hrr1_build_kd(Libint->AB,int_stack+199316,int_stack+142616,int_stack+97256,420);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+46460,int_stack+33128,int_stack+31280,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+52004,int_stack+35504,int_stack+33128,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+59132,int_stack+52004,int_stack+46460,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+70220,int_stack+38474,int_stack+35504,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+79130,int_stack+70220,int_stack+52004,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+93386,int_stack+79130,int_stack+59132,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+46460,int_stack+42104,int_stack+38474,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+111866,int_stack+46460,int_stack+70220,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+23100,int_stack+111866,int_stack+79130,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+111866,int_stack+23100,int_stack+93386,66);
 /*--- compute (mp|ig) ---*/
 hrr1_build_mp(Libint->AB,int_stack+23100,int_stack+111866,int_stack+0,420);
 /*--- compute (ld|ig) ---*/
 hrr1_build_ld(Libint->AB,int_stack+290036,int_stack+23100,int_stack+142616,420);
 /*--- compute (kf|ig) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+290036,int_stack+199316,420);
 return int_stack+0;}
