/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kfih(Libint_t*, prim_data*);

  /* Computes quartets of (kf|ih) integrals */

REALTYPE *hrr_order_kfih(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][6] = int_stack + 0;
 Libint->vrr_classes[7][7] = int_stack + 1008;
 Libint->vrr_classes[7][8] = int_stack + 2304;
 Libint->vrr_classes[7][9] = int_stack + 3924;
 Libint->vrr_classes[7][10] = int_stack + 5904;
 Libint->vrr_classes[7][11] = int_stack + 8280;
 Libint->vrr_classes[8][6] = int_stack + 11088;
 Libint->vrr_classes[8][7] = int_stack + 12348;
 Libint->vrr_classes[8][8] = int_stack + 13968;
 Libint->vrr_classes[8][9] = int_stack + 15993;
 Libint->vrr_classes[8][10] = int_stack + 18468;
 Libint->vrr_classes[8][11] = int_stack + 21438;
 Libint->vrr_classes[9][6] = int_stack + 24948;
 Libint->vrr_classes[9][7] = int_stack + 26488;
 Libint->vrr_classes[9][8] = int_stack + 28468;
 Libint->vrr_classes[9][9] = int_stack + 30943;
 Libint->vrr_classes[9][10] = int_stack + 33968;
 Libint->vrr_classes[9][11] = int_stack + 37598;
 Libint->vrr_classes[10][6] = int_stack + 41888;
 Libint->vrr_classes[10][7] = int_stack + 43736;
 Libint->vrr_classes[10][8] = int_stack + 46112;
 Libint->vrr_classes[10][9] = int_stack + 49082;
 Libint->vrr_classes[10][10] = int_stack + 52712;
 Libint->vrr_classes[10][11] = int_stack + 57068;
 memset(int_stack,0,62216*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 62216;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kfih(Libint, Data);
   Data++;
 }
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+62216,int_stack+1008,int_stack+0,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+65240,int_stack+2304,int_stack+1008,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+69128,int_stack+65240,int_stack+62216,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+75176,int_stack+3924,int_stack+2304,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+80036,int_stack+75176,int_stack+65240,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+87812,int_stack+80036,int_stack+69128,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+62216,int_stack+5904,int_stack+3924,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+97892,int_stack+62216,int_stack+75176,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+107612,int_stack+97892,int_stack+80036,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+68156,int_stack+107612,int_stack+87812,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+83276,int_stack+8280,int_stack+5904,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+120572,int_stack+83276,int_stack+62216,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+132452,int_stack+120572,int_stack+97892,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+83276,int_stack+132452,int_stack+107612,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+102716,int_stack+83276,int_stack+68156,36);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+62216,int_stack+12348,int_stack+11088,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+65996,int_stack+13968,int_stack+12348,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+70856,int_stack+65996,int_stack+62216,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+78416,int_stack+15993,int_stack+13968,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+84491,int_stack+78416,int_stack+65996,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+123884,int_stack+84491,int_stack+70856,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+62216,int_stack+18468,int_stack+15993,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+136484,int_stack+62216,int_stack+78416,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+136484,int_stack+84491,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+69641,int_stack+0,int_stack+123884,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+123884,int_stack+21438,int_stack+18468,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+148634,int_stack+123884,int_stack+62216,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+163484,int_stack+148634,int_stack+136484,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+123884,int_stack+163484,int_stack+0,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+148184,int_stack+123884,int_stack+69641,45);
 /*--- compute (kp|ih) ---*/
 hrr1_build_kp(Libint->AB,int_stack+174644,int_stack+148184,int_stack+102716,588);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+26488,int_stack+24948,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+4620,int_stack+28468,int_stack+26488,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+10560,int_stack+4620,int_stack+0,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+19800,int_stack+30943,int_stack+28468,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+62216,int_stack+19800,int_stack+4620,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+74096,int_stack+62216,int_stack+10560,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+33968,int_stack+30943,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+89496,int_stack+0,int_stack+19800,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+9075,int_stack+89496,int_stack+62216,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+104346,int_stack+9075,int_stack+74096,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+62216,int_stack+37598,int_stack+33968,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+127446,int_stack+62216,int_stack+0,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+62216,int_stack+127446,int_stack+89496,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+238148,int_stack+62216,int_stack+9075,55);
 /*--- compute (m0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+62216,int_stack+238148,int_stack+104346,55);
 /*--- compute (lp|ih) ---*/
 hrr1_build_lp(Libint->AB,int_stack+238148,int_stack+62216,int_stack+148184,588);
 /*--- compute (kd|ih) ---*/
 hrr1_build_kd(Libint->AB,int_stack+317528,int_stack+238148,int_stack+174644,588);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+94556,int_stack+43736,int_stack+41888,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+100100,int_stack+46112,int_stack+43736,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+107228,int_stack+100100,int_stack+94556,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+118316,int_stack+49082,int_stack+46112,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+127226,int_stack+118316,int_stack+100100,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+141482,int_stack+127226,int_stack+107228,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+94556,int_stack+52712,int_stack+49082,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+159962,int_stack+94556,int_stack+118316,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+177782,int_stack+159962,int_stack+127226,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+105446,int_stack+177782,int_stack+141482,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+133166,int_stack+57068,int_stack+52712,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+201542,int_stack+133166,int_stack+94556,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+201542,int_stack+159962,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+201542,int_stack+0,int_stack+177782,66);
 /*--- compute (n0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+0,int_stack+201542,int_stack+105446,66);
 /*--- compute (mp|ih) ---*/
 hrr1_build_mp(Libint->AB,int_stack+94556,int_stack+0,int_stack+62216,588);
 /*--- compute (ld|ih) ---*/
 hrr1_build_ld(Libint->AB,int_stack+444536,int_stack+94556,int_stack+238148,588);
 /*--- compute (kf|ih) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+444536,int_stack+317528,588);
 return int_stack+0;}
