/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kfnh(Libint_t*, prim_data*);

  /* Computes quartets of (kf|nh) integrals */

REALTYPE *hrr_order_kfnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[8][10] = int_stack + 21456;
 Libint->vrr_classes[8][11] = int_stack + 24426;
 Libint->vrr_classes[8][12] = int_stack + 27936;
 Libint->vrr_classes[8][13] = int_stack + 32031;
 Libint->vrr_classes[8][14] = int_stack + 36756;
 Libint->vrr_classes[8][15] = int_stack + 42156;
 Libint->vrr_classes[9][10] = int_stack + 48276;
 Libint->vrr_classes[9][11] = int_stack + 51906;
 Libint->vrr_classes[9][12] = int_stack + 56196;
 Libint->vrr_classes[9][13] = int_stack + 61201;
 Libint->vrr_classes[9][14] = int_stack + 66976;
 Libint->vrr_classes[9][15] = int_stack + 73576;
 Libint->vrr_classes[10][10] = int_stack + 81056;
 Libint->vrr_classes[10][11] = int_stack + 85412;
 Libint->vrr_classes[10][12] = int_stack + 90560;
 Libint->vrr_classes[10][13] = int_stack + 96566;
 Libint->vrr_classes[10][14] = int_stack + 103496;
 Libint->vrr_classes[10][15] = int_stack + 111416;
 memset(int_stack,0,120392*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 120392;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kfnh(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+120392,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+127520,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+135944,int_stack+127520,int_stack+120392,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+150200,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+160028,int_stack+150200,int_stack+127520,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+176876,int_stack+160028,int_stack+135944,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+120392,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+200636,int_stack+120392,int_stack+150200,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+131732,int_stack+200636,int_stack+160028,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+220292,int_stack+131732,int_stack+176876,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+159812,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+172772,int_stack+159812,int_stack+120392,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+255932,int_stack+172772,int_stack+200636,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+159812,int_stack+255932,int_stack+131732,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+255932,int_stack+159812,int_stack+220292,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+120392,int_stack+24426,int_stack+21456,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+129302,int_stack+27936,int_stack+24426,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+139832,int_stack+129302,int_stack+120392,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+157652,int_stack+32031,int_stack+27936,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+169937,int_stack+157652,int_stack+129302,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+190997,int_stack+169937,int_stack+139832,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+120392,int_stack+36756,int_stack+32031,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+220697,int_stack+120392,int_stack+157652,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+134567,int_stack+220697,int_stack+169937,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+305828,int_stack+134567,int_stack+190997,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+169667,int_stack+42156,int_stack+36756,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+185867,int_stack+169667,int_stack+120392,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+185867,int_stack+220697,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+169667,int_stack+0,int_stack+134567,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+350378,int_stack+169667,int_stack+305828,45);
 /*--- compute (kp|nh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+412748,int_stack+350378,int_stack+255932,1386);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+51906,int_stack+48276,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+56196,int_stack+51906,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23760,int_stack+10890,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+120392,int_stack+61201,int_stack+56196,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+135407,int_stack+120392,int_stack+10890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+161147,int_stack+135407,int_stack+23760,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+66976,int_stack+61201,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+17325,int_stack+0,int_stack+120392,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+197447,int_stack+17325,int_stack+135407,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+240347,int_stack+197447,int_stack+161147,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+120392,int_stack+73576,int_stack+66976,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+140192,int_stack+120392,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+294797,int_stack+140192,int_stack+17325,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+294797,int_stack+197447,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+120392,int_stack+0,int_stack+240347,55);
 /*--- compute (lp|nh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+562436,int_stack+120392,int_stack+350378,1386);
 /*--- compute (kd|nh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+749546,int_stack+562436,int_stack+412748,1386);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+85412,int_stack+81056,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+90560,int_stack+85412,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+54648,int_stack+96566,int_stack+90560,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+196622,int_stack+54648,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+227510,int_stack+196622,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+103496,int_stack+96566,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+271070,int_stack+0,int_stack+54648,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+20790,int_stack+271070,int_stack+196622,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+307106,int_stack+20790,int_stack+227510,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+196622,int_stack+111416,int_stack+103496,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+220382,int_stack+196622,int_stack+0,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+372446,int_stack+220382,int_stack+271070,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+196622,int_stack+372446,int_stack+20790,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+372446,int_stack+196622,int_stack+307106,66);
 /*--- compute (mp|nh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1048922,int_stack+372446,int_stack+120392,1386);
 /*--- compute (ld|nh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+0,int_stack+1048922,int_stack+562436,1386);
 /*--- compute (kf|nh) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1048922,int_stack+0,int_stack+749546,1386);
 return int_stack+1048922;}
