/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kgmg(Libint_t*, prim_data*);

  /* Computes quartets of (kg|mg) integrals */

REALTYPE *hrr_order_kgmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[8][9] = int_stack + 14220;
 Libint->vrr_classes[8][10] = int_stack + 16695;
 Libint->vrr_classes[8][11] = int_stack + 19665;
 Libint->vrr_classes[8][12] = int_stack + 23175;
 Libint->vrr_classes[8][13] = int_stack + 27270;
 Libint->vrr_classes[9][9] = int_stack + 31995;
 Libint->vrr_classes[9][10] = int_stack + 35020;
 Libint->vrr_classes[9][11] = int_stack + 38650;
 Libint->vrr_classes[9][12] = int_stack + 42940;
 Libint->vrr_classes[9][13] = int_stack + 47945;
 Libint->vrr_classes[10][9] = int_stack + 53720;
 Libint->vrr_classes[10][10] = int_stack + 57350;
 Libint->vrr_classes[10][11] = int_stack + 61706;
 Libint->vrr_classes[10][12] = int_stack + 66854;
 Libint->vrr_classes[10][13] = int_stack + 72860;
 Libint->vrr_classes[11][9] = int_stack + 79790;
 Libint->vrr_classes[11][10] = int_stack + 84080;
 Libint->vrr_classes[11][11] = int_stack + 89228;
 Libint->vrr_classes[11][12] = int_stack + 95312;
 Libint->vrr_classes[11][13] = int_stack + 102410;
 memset(int_stack,0,110600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 110600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kgmg(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+110600,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+116540,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+123668,int_stack+116540,int_stack+110600,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+135548,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+143972,int_stack+135548,int_stack+116540,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+158228,int_stack+143972,int_stack+123668,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+110600,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+178028,int_stack+110600,int_stack+135548,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+110600,int_stack+178028,int_stack+143972,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+178028,int_stack+110600,int_stack+158228,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+110600,int_stack+16695,int_stack+14220,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+118025,int_stack+19665,int_stack+16695,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+126935,int_stack+118025,int_stack+110600,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+141785,int_stack+23175,int_stack+19665,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+152315,int_stack+141785,int_stack+118025,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+207728,int_stack+152315,int_stack+126935,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+110600,int_stack+27270,int_stack+23175,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+110600,int_stack+141785,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+110600,int_stack+0,int_stack+152315,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+140300,int_stack+110600,int_stack+207728,45);
 /*--- compute (kp|mg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+207728,int_stack+140300,int_stack+178028,825);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+110600,int_stack+35020,int_stack+31995,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+119675,int_stack+38650,int_stack+35020,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+119675,int_stack+110600,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18150,int_stack+42940,int_stack+38650,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+177425,int_stack+18150,int_stack+119675,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+296828,int_stack+177425,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+47945,int_stack+42940,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+110600,int_stack+0,int_stack+18150,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+110600,int_stack+177425,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+327078,int_stack+0,int_stack+296828,55);
 /*--- compute (lp|mg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+372453,int_stack+327078,int_stack+140300,825);
 /*--- compute (kd|mg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+483828,int_stack+372453,int_stack+207728,825);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+57350,int_stack+53720,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10890,int_stack+61706,int_stack+57350,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23958,int_stack+10890,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45738,int_stack+66854,int_stack+61706,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+110600,int_stack+45738,int_stack+10890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+136736,int_stack+110600,int_stack+23958,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+72860,int_stack+66854,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+173036,int_stack+0,int_stack+45738,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+173036,int_stack+110600,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+173036,int_stack+0,int_stack+136736,66);
 /*--- compute (mp|mg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+662028,int_stack+173036,int_stack+327078,825);
 /*--- compute (ld|mg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+798153,int_stack+662028,int_stack+372453,825);
 /*--- compute (kf|mg) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1020903,int_stack+798153,int_stack+483828,825);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+84080,int_stack+79790,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+89228,int_stack+84080,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54054,int_stack+95312,int_stack+89228,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+110600,int_stack+54054,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+227486,int_stack+110600,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+102410,int_stack+95312,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72306,int_stack+0,int_stack+54054,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+72306,int_stack+110600,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+51480,int_stack+0,int_stack+227486,78);
 /*--- compute (np|mg) ---*/
 hrr1_build_np(Libint->AB,int_stack+227486,int_stack+51480,int_stack+173036,825);
 /*--- compute (md|mg) ---*/
 hrr1_build_md(Libint->AB,int_stack+1317903,int_stack+227486,int_stack+662028,825);
 /*--- compute (lf|mg) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+1317903,int_stack+798153,825);
 /*--- compute (kg|mg) ---*/
 hrr1_build_kg(Libint->AB,int_stack+371250,int_stack+0,int_stack+1020903,825);
 return int_stack+371250;}
