/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kinn(Libint_t*, prim_data*);

  /* Computes quartets of (ki|nn) integrals */

REALTYPE *hrr_order_kinn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[7][17] = int_stack + 26964;
 Libint->vrr_classes[7][18] = int_stack + 33120;
 Libint->vrr_classes[7][19] = int_stack + 39960;
 Libint->vrr_classes[7][20] = int_stack + 47520;
 Libint->vrr_classes[8][10] = int_stack + 55836;
 Libint->vrr_classes[8][11] = int_stack + 58806;
 Libint->vrr_classes[8][12] = int_stack + 62316;
 Libint->vrr_classes[8][13] = int_stack + 66411;
 Libint->vrr_classes[8][14] = int_stack + 71136;
 Libint->vrr_classes[8][15] = int_stack + 76536;
 Libint->vrr_classes[8][16] = int_stack + 82656;
 Libint->vrr_classes[8][17] = int_stack + 89541;
 Libint->vrr_classes[8][18] = int_stack + 97236;
 Libint->vrr_classes[8][19] = int_stack + 105786;
 Libint->vrr_classes[8][20] = int_stack + 115236;
 Libint->vrr_classes[9][10] = int_stack + 125631;
 Libint->vrr_classes[9][11] = int_stack + 129261;
 Libint->vrr_classes[9][12] = int_stack + 133551;
 Libint->vrr_classes[9][13] = int_stack + 138556;
 Libint->vrr_classes[9][14] = int_stack + 144331;
 Libint->vrr_classes[9][15] = int_stack + 150931;
 Libint->vrr_classes[9][16] = int_stack + 158411;
 Libint->vrr_classes[9][17] = int_stack + 166826;
 Libint->vrr_classes[9][18] = int_stack + 176231;
 Libint->vrr_classes[9][19] = int_stack + 186681;
 Libint->vrr_classes[9][20] = int_stack + 198231;
 Libint->vrr_classes[10][10] = int_stack + 210936;
 Libint->vrr_classes[10][11] = int_stack + 215292;
 Libint->vrr_classes[10][12] = int_stack + 220440;
 Libint->vrr_classes[10][13] = int_stack + 226446;
 Libint->vrr_classes[10][14] = int_stack + 233376;
 Libint->vrr_classes[10][15] = int_stack + 241296;
 Libint->vrr_classes[10][16] = int_stack + 250272;
 Libint->vrr_classes[10][17] = int_stack + 260370;
 Libint->vrr_classes[10][18] = int_stack + 271656;
 Libint->vrr_classes[10][19] = int_stack + 284196;
 Libint->vrr_classes[10][20] = int_stack + 298056;
 Libint->vrr_classes[11][10] = int_stack + 313302;
 Libint->vrr_classes[11][11] = int_stack + 318450;
 Libint->vrr_classes[11][12] = int_stack + 324534;
 Libint->vrr_classes[11][13] = int_stack + 331632;
 Libint->vrr_classes[11][14] = int_stack + 339822;
 Libint->vrr_classes[11][15] = int_stack + 349182;
 Libint->vrr_classes[11][16] = int_stack + 359790;
 Libint->vrr_classes[11][17] = int_stack + 371724;
 Libint->vrr_classes[11][18] = int_stack + 385062;
 Libint->vrr_classes[11][19] = int_stack + 399882;
 Libint->vrr_classes[11][20] = int_stack + 416262;
 Libint->vrr_classes[12][10] = int_stack + 434280;
 Libint->vrr_classes[12][11] = int_stack + 440286;
 Libint->vrr_classes[12][12] = int_stack + 447384;
 Libint->vrr_classes[12][13] = int_stack + 455665;
 Libint->vrr_classes[12][14] = int_stack + 465220;
 Libint->vrr_classes[12][15] = int_stack + 476140;
 Libint->vrr_classes[12][16] = int_stack + 488516;
 Libint->vrr_classes[12][17] = int_stack + 502439;
 Libint->vrr_classes[12][18] = int_stack + 518000;
 Libint->vrr_classes[12][19] = int_stack + 535290;
 Libint->vrr_classes[12][20] = int_stack + 554400;
 Libint->vrr_classes[13][10] = int_stack + 575421;
 Libint->vrr_classes[13][11] = int_stack + 582351;
 Libint->vrr_classes[13][12] = int_stack + 590541;
 Libint->vrr_classes[13][13] = int_stack + 600096;
 Libint->vrr_classes[13][14] = int_stack + 611121;
 Libint->vrr_classes[13][15] = int_stack + 623721;
 Libint->vrr_classes[13][16] = int_stack + 638001;
 Libint->vrr_classes[13][17] = int_stack + 654066;
 Libint->vrr_classes[13][18] = int_stack + 672021;
 Libint->vrr_classes[13][19] = int_stack + 691971;
 Libint->vrr_classes[13][20] = int_stack + 714021;
 memset(int_stack,0,738276*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 738276;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kinn(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+738276,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+745404,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+753828,int_stack+745404,int_stack+738276,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+768084,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+777912,int_stack+768084,int_stack+745404,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+794760,int_stack+777912,int_stack+753828,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+738276,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+818520,int_stack+738276,int_stack+768084,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+749616,int_stack+818520,int_stack+777912,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+838176,int_stack+749616,int_stack+794760,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+777696,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+790656,int_stack+777696,int_stack+738276,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+873816,int_stack+790656,int_stack+818520,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+906576,int_stack+873816,int_stack+749616,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+948696,int_stack+906576,int_stack+838176,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+738276,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+813336,int_stack+738276,int_stack+777696,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+998592,int_stack+813336,int_stack+790656,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+752964,int_stack+998592,int_stack+873816,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+839256,int_stack+752964,int_stack+906576,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1036392,int_stack+839256,int_stack+948696,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+898224,int_stack+26964,int_stack+21456,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+914748,int_stack+898224,int_stack+738276,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+944124,int_stack+914748,int_stack+813336,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1102920,int_stack+944124,int_stack+998592,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1159620,int_stack+1102920,int_stack+752964,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+738276,int_stack+1159620,int_stack+839256,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1228416,int_stack+738276,int_stack+1036392,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+816900,int_stack+33120,int_stack+26964,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+835368,int_stack+816900,int_stack+898224,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+987324,int_stack+835368,int_stack+914748,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+868416,int_stack+987324,int_stack+944124,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1313952,int_stack+868416,int_stack+1102920,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1036284,int_stack+1313952,int_stack+1159620,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1393332,int_stack+1036284,int_stack+738276,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1494420,int_stack+1393332,int_stack+1228416,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+738276,int_stack+39960,int_stack+33120,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+758796,int_stack+738276,int_stack+816900,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1128012,int_stack+758796,int_stack+835368,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1183092,int_stack+1128012,int_stack+987324,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+933216,int_stack+1183092,int_stack+868416,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+795732,int_stack+933216,int_stack+1313952,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1256532,int_stack+795732,int_stack+1036284,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1601340,int_stack+1256532,int_stack+1393332,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1727700,int_stack+1601340,int_stack+1494420,36);
 /*--- compute (k0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+901572,int_stack+47520,int_stack+39960,36);
 /*--- compute (k0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1023936,int_stack+901572,int_stack+738276,36);
 /*--- compute (k0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1064976,int_stack+1023936,int_stack+758796,36);
 /*--- compute (k0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1374468,int_stack+1064976,int_stack+1128012,36);
 /*--- compute (k0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1023936,int_stack+1374468,int_stack+1183092,36);
 /*--- compute (k0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1374468,int_stack+1023936,int_stack+933216,36);
 /*--- compute (k0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+901572,int_stack+1374468,int_stack+795732,36);
 /*--- compute (k0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1374468,int_stack+901572,int_stack+1256532,36);
 /*--- compute (k0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+738276,int_stack+1374468,int_stack+1601340,36);
 /*--- compute (k0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+892716,int_stack+738276,int_stack+1727700,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+738276,int_stack+58806,int_stack+55836,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+747186,int_stack+62316,int_stack+58806,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+757716,int_stack+747186,int_stack+738276,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+775536,int_stack+66411,int_stack+62316,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+787821,int_stack+775536,int_stack+747186,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+808881,int_stack+787821,int_stack+757716,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+738276,int_stack+71136,int_stack+66411,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+838581,int_stack+738276,int_stack+775536,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+752451,int_stack+838581,int_stack+787821,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1049532,int_stack+752451,int_stack+808881,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+787551,int_stack+76536,int_stack+71136,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+803751,int_stack+787551,int_stack+738276,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1094082,int_stack+803751,int_stack+838581,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+832101,int_stack+1094082,int_stack+752451,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1135032,int_stack+832101,int_stack+1049532,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1049532,int_stack+82656,int_stack+76536,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+738276,int_stack+1049532,int_stack+787551,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1197402,int_stack+738276,int_stack+803751,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+770676,int_stack+1197402,int_stack+1094082,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1244652,int_stack+770676,int_stack+832101,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1318362,int_stack+1244652,int_stack+1135032,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+832101,int_stack+89541,int_stack+82656,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+852756,int_stack+832101,int_stack+1049532,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1049532,int_stack+852756,int_stack+738276,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1103532,int_stack+1049532,int_stack+1197402,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1401522,int_stack+1103532,int_stack+770676,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1487517,int_stack+1401522,int_stack+1244652,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1174407,int_stack+1487517,int_stack+1318362,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+738276,int_stack+97236,int_stack+89541,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+761361,int_stack+738276,int_stack+832101,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1281327,int_stack+761361,int_stack+852756,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+802671,int_stack+1281327,int_stack+1049532,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1585797,int_stack+802671,int_stack+1103532,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1049532,int_stack+1585797,int_stack+1401522,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1342527,int_stack+1049532,int_stack+1487517,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1685022,int_stack+1342527,int_stack+1174407,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1164192,int_stack+105786,int_stack+97236,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1189842,int_stack+1164192,int_stack+738276,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1468887,int_stack+1189842,int_stack+761361,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+1468887,int_stack+1281327,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1818672,int_stack+0,int_stack+802671,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+738276,int_stack+1818672,int_stack+1585797,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1932072,int_stack+738276,int_stack+1049532,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2079492,int_stack+1932072,int_stack+1342527,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1236012,int_stack+2079492,int_stack+1685022,45);
 /*--- compute (l0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1049532,int_stack+115236,int_stack+105786,45);
 /*--- compute (l0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1077882,int_stack+1049532,int_stack+1164192,45);
 /*--- compute (l0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1537737,int_stack+1077882,int_stack+1189842,45);
 /*--- compute (l0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1049532,int_stack+1537737,int_stack+1468887,45);
 /*--- compute (l0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1399362,int_stack+1049532,int_stack+0,45);
 /*--- compute (l0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1049532,int_stack+1399362,int_stack+1818672,45);
 /*--- compute (l0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1399362,int_stack+1049532,int_stack+738276,45);
 /*--- compute (l0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1049532,int_stack+1399362,int_stack+1932072,45);
 /*--- compute (l0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1399362,int_stack+1049532,int_stack+2079492,45);
 /*--- compute (l0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1592412,int_stack+1399362,int_stack+1236012,45);
 /*--- compute (kp|nn) ---*/
 hrr1_build_kp(Libint->AB,int_stack+1049532,int_stack+1592412,int_stack+892716,4356);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1519980,int_stack+129261,int_stack+125631,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1530870,int_stack+133551,int_stack+129261,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1543740,int_stack+1530870,int_stack+1519980,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1565520,int_stack+138556,int_stack+133551,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1788432,int_stack+1565520,int_stack+1530870,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1814172,int_stack+1788432,int_stack+1543740,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1519980,int_stack+144331,int_stack+138556,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1850472,int_stack+1519980,int_stack+1565520,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1537305,int_stack+1850472,int_stack+1788432,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1880502,int_stack+1537305,int_stack+1814172,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1788432,int_stack+150931,int_stack+144331,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1808232,int_stack+1788432,int_stack+1519980,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1934952,int_stack+1808232,int_stack+1850472,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1985002,int_stack+1934952,int_stack+1537305,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2049352,int_stack+1985002,int_stack+1880502,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1519980,int_stack+158411,int_stack+150931,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1542420,int_stack+1519980,int_stack+1788432,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1842882,int_stack+1542420,int_stack+1808232,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2125582,int_stack+1842882,int_stack+1934952,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+738276,int_stack+2125582,int_stack+1985002,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1900632,int_stack+738276,int_stack+2049352,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1788432,int_stack+166826,int_stack+158411,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2002272,int_stack+1788432,int_stack+1519980,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2047152,int_stack+2002272,int_stack+1542420,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+828366,int_stack+2047152,int_stack+1842882,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+914991,int_stack+828366,int_stack+2125582,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2113152,int_stack+914991,int_stack+738276,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2113152,int_stack+1900632,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+738276,int_stack+176231,int_stack+166826,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+766491,int_stack+738276,int_stack+1788432,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1788432,int_stack+766491,int_stack+2002272,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1863232,int_stack+1788432,int_stack+2047152,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1962232,int_stack+1863232,int_stack+828366,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2233272,int_stack+1962232,int_stack+914991,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+816981,int_stack+2233272,int_stack+2113152,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2373412,int_stack+816981,int_stack+0,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+186681,int_stack+176231,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+31350,int_stack+0,int_stack+738276,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+87780,int_stack+31350,int_stack+766491,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2083507,int_stack+87780,int_stack+1788432,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2536762,int_stack+2083507,int_stack+1863232,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1788432,int_stack+2536762,int_stack+1962232,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2675362,int_stack+1788432,int_stack+2233272,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2855542,int_stack+2675362,int_stack+816981,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+738276,int_stack+2855542,int_stack+2373412,55);
 /*--- compute (m0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1950132,int_stack+198231,int_stack+186681,55);
 /*--- compute (m0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1984782,int_stack+1950132,int_stack+0,55);
 /*--- compute (m0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+937926,int_stack+1984782,int_stack+31350,55);
 /*--- compute (m0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1950132,int_stack+937926,int_stack+87780,55);
 /*--- compute (m0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+1950132,int_stack+2083507,55);
 /*--- compute (m0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1950132,int_stack+0,int_stack+2536762,55);
 /*--- compute (m0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+1950132,int_stack+1788432,55);
 /*--- compute (m0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1788432,int_stack+0,int_stack+2675362,55);
 /*--- compute (m0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2013657,int_stack+1788432,int_stack+2855542,55);
 /*--- compute (m0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2249607,int_stack+2013657,int_stack+738276,55);
 /*--- compute (lp|nn) ---*/
 hrr1_build_lp(Libint->AB,int_stack+2489187,int_stack+2249607,int_stack+1592412,4356);
 /*--- compute (kd|nn) ---*/
 hrr1_build_kd(Libint->AB,int_stack+3077247,int_stack+2489187,int_stack+1049532,4356);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+738276,int_stack+215292,int_stack+210936,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+751344,int_stack+220440,int_stack+215292,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+766788,int_stack+751344,int_stack+738276,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+792924,int_stack+226446,int_stack+220440,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+810942,int_stack+792924,int_stack+751344,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+841830,int_stack+810942,int_stack+766788,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+738276,int_stack+233376,int_stack+226446,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+885390,int_stack+738276,int_stack+792924,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+759066,int_stack+885390,int_stack+810942,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+921426,int_stack+759066,int_stack+841830,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+810546,int_stack+241296,int_stack+233376,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+834306,int_stack+810546,int_stack+738276,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+986766,int_stack+834306,int_stack+885390,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1046826,int_stack+986766,int_stack+759066,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1124046,int_stack+1046826,int_stack+921426,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+738276,int_stack+250272,int_stack+241296,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+875886,int_stack+738276,int_stack+810546,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1215522,int_stack+875886,int_stack+834306,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+765204,int_stack+1215522,int_stack+986766,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+923406,int_stack+765204,int_stack+1046826,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1284822,int_stack+923406,int_stack+1124046,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1031514,int_stack+260370,int_stack+250272,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1061808,int_stack+1031514,int_stack+738276,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1115664,int_stack+1061808,int_stack+875886,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1406790,int_stack+1115664,int_stack+1215522,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1510740,int_stack+1406790,int_stack+765204,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+738276,int_stack+1510740,int_stack+923406,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1636866,int_stack+738276,int_stack+1284822,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+882420,int_stack+271656,int_stack+260370,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+916278,int_stack+882420,int_stack+1031514,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1194864,int_stack+916278,int_stack+1061808,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+976866,int_stack+1194864,int_stack+1115664,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1793682,int_stack+976866,int_stack+1406790,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1284624,int_stack+1793682,int_stack+1510740,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1939212,int_stack+1284624,int_stack+738276,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1939212,int_stack+1636866,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+738276,int_stack+284196,int_stack+271656,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+775896,int_stack+738276,int_stack+882420,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1452792,int_stack+775896,int_stack+916278,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1553772,int_stack+1452792,int_stack+1194864,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1095666,int_stack+1553772,int_stack+976866,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+843612,int_stack+1095666,int_stack+1793682,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1688412,int_stack+843612,int_stack+1284624,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+4018143,int_stack+1688412,int_stack+1939212,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1904628,int_stack+4018143,int_stack+0,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+298056,int_stack+284196,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+41580,int_stack+0,int_stack+738276,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+116820,int_stack+41580,int_stack+775896,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1261986,int_stack+116820,int_stack+1452792,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+1261986,int_stack+1553772,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1261986,int_stack+0,int_stack+1095666,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+1261986,int_stack+843612,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+738276,int_stack+0,int_stack+1688412,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+738276,int_stack+4018143,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+738276,int_stack+0,int_stack+1904628,66);
 /*--- compute (mp|nn) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1025772,int_stack+738276,int_stack+2249607,4356);
 /*--- compute (ld|nn) ---*/
 hrr1_build_ld(Libint->AB,int_stack+4018143,int_stack+1025772,int_stack+2489187,4356);
 /*--- compute (kf|nn) ---*/
 hrr1_build_kf(Libint->AB,int_stack+5194263,int_stack+4018143,int_stack+3077247,4356);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+318450,int_stack+313302,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+324534,int_stack+318450,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+331632,int_stack+324534,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+122382,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+339822,int_stack+331632,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+173862,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+173862,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+216450,int_stack+24570,int_stack+122382,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+85410,int_stack+349182,int_stack+339822,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113490,int_stack+85410,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1744512,int_stack+113490,int_stack+173862,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1815492,int_stack+1744512,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1906752,int_stack+1815492,int_stack+216450,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+359790,int_stack+349182,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+162630,int_stack+0,int_stack+85410,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+218790,int_stack+162630,int_stack+113490,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+31824,int_stack+218790,int_stack+1744512,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2014860,int_stack+31824,int_stack+1815492,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1744512,int_stack+2014860,int_stack+1906752,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1888656,int_stack+371724,int_stack+359790,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1924458,int_stack+1888656,int_stack+0,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2142624,int_stack+1924458,int_stack+162630,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2236224,int_stack+2142624,int_stack+218790,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+138294,int_stack+2236224,int_stack+31824,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2359074,int_stack+138294,int_stack+2014860,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2529426,int_stack+2359074,int_stack+1744512,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1744512,int_stack+385062,int_stack+371724,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1784526,int_stack+1744512,int_stack+1888656,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+1784526,int_stack+1924458,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1856130,int_stack+0,int_stack+2142624,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1996530,int_stack+1856130,int_stack+2236224,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2714754,int_stack+1996530,int_stack+138294,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+106080,int_stack+2714754,int_stack+2359074,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2168520,int_stack+106080,int_stack+2529426,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+2400180,int_stack+399882,int_stack+385062,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+2444640,int_stack+2400180,int_stack+1744512,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2524668,int_stack+2444640,int_stack+1784526,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2913498,int_stack+2524668,int_stack+0,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3072618,int_stack+2913498,int_stack+1856130,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1744512,int_stack+3072618,int_stack+1996530,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3269178,int_stack+1744512,int_stack+2714754,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3524706,int_stack+3269178,int_stack+106080,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+3524706,int_stack+2168520,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+283140,int_stack+416262,int_stack+399882,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+332280,int_stack+283140,int_stack+2400180,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1973832,int_stack+332280,int_stack+2444640,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2107212,int_stack+1973832,int_stack+2524668,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+2286222,int_stack+2107212,int_stack+2913498,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1973832,int_stack+2286222,int_stack+3072618,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+2235912,int_stack+1973832,int_stack+1744512,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1744512,int_stack+2235912,int_stack+3269178,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2063922,int_stack+1744512,int_stack+3524706,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2398542,int_stack+2063922,int_stack+0,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+2738310,int_stack+2398542,int_stack+738276,4356);
 /*--- compute (md|nn) ---*/
 hrr1_build_md(Libint->AB,int_stack+6762423,int_stack+2738310,int_stack+1025772,4356);
 /*--- compute (lf|nn) ---*/
 hrr1_build_lf(Libint->AB,int_stack+8199903,int_stack+6762423,int_stack+4018143,4356);
 /*--- compute (kg|nn) ---*/
 hrr1_build_kg(Libint->AB,int_stack+10160103,int_stack+8199903,int_stack+5194263,4356);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+738276,int_stack+440286,int_stack+434280,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+756294,int_stack+447384,int_stack+440286,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+777588,int_stack+756294,int_stack+738276,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+813624,int_stack+455665,int_stack+447384,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+838467,int_stack+813624,int_stack+756294,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+881055,int_stack+838467,int_stack+777588,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+738276,int_stack+465220,int_stack+455665,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+941115,int_stack+738276,int_stack+813624,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+766941,int_stack+941115,int_stack+838467,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+990801,int_stack+766941,int_stack+881055,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+837921,int_stack+476140,int_stack+465220,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+870681,int_stack+837921,int_stack+738276,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1080891,int_stack+870681,int_stack+941115,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1163701,int_stack+1080891,int_stack+766941,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1270171,int_stack+1163701,int_stack+990801,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+738276,int_stack+488516,int_stack+476140,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+928011,int_stack+738276,int_stack+837921,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1396297,int_stack+928011,int_stack+870681,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+775404,int_stack+1396297,int_stack+1080891,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+993531,int_stack+775404,int_stack+1163701,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1491847,int_stack+993531,int_stack+1270171,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1142589,int_stack+502439,int_stack+488516,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1184358,int_stack+1142589,int_stack+738276,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1258614,int_stack+1184358,int_stack+928011,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1660015,int_stack+1258614,int_stack+1396297,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1803340,int_stack+1660015,int_stack+775404,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+738276,int_stack+1803340,int_stack+993531,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1977241,int_stack+738276,int_stack+1491847,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+937020,int_stack+518000,int_stack+502439,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+983703,int_stack+937020,int_stack+1142589,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1367814,int_stack+983703,int_stack+1184358,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1067241,int_stack+1367814,int_stack+1258614,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2193457,int_stack+1067241,int_stack+1660015,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1491574,int_stack+2193457,int_stack+1803340,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+1491574,int_stack+738276,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3600798,int_stack+0,int_stack+1977241,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+738276,int_stack+535290,int_stack+518000,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+790146,int_stack+738276,int_stack+937020,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1723442,int_stack+790146,int_stack+983703,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1862672,int_stack+1723442,int_stack+1367814,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1231041,int_stack+1862672,int_stack+1067241,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+883512,int_stack+1231041,int_stack+2193457,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2048312,int_stack+883512,int_stack+1491574,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3871068,int_stack+2048312,int_stack+0,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+3871068,int_stack+3600798,91);
 /*--- compute (q0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+3600798,int_stack+554400,int_stack+535290,91);
 /*--- compute (q0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+3658128,int_stack+3600798,int_stack+738276,91);
 /*--- compute (q0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+330330,int_stack+3658128,int_stack+790146,91);
 /*--- compute (q0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+3600798,int_stack+330330,int_stack+1723442,91);
 /*--- compute (q0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1460361,int_stack+3600798,int_stack+1862672,91);
 /*--- compute (q0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1720257,int_stack+1460361,int_stack+1231041,91);
 /*--- compute (q0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1151052,int_stack+1720257,int_stack+883512,91);
 /*--- compute (q0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+738276,int_stack+1151052,int_stack+2048312,91);
 /*--- compute (q0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1110921,int_stack+738276,int_stack+3871068,91);
 /*--- compute (q0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+3600798,int_stack+1110921,int_stack+0,91);
 /*--- compute (op|nn) ---*/
 hrr1_build_op(Libint->AB,int_stack+738276,int_stack+3600798,int_stack+2398542,4356);
 /*--- compute (nd|nn) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3997194,int_stack+738276,int_stack+2738310,4356);
 /*--- compute (mf|nn) ---*/
 hrr1_build_mf(Libint->AB,int_stack+12512343,int_stack+3997194,int_stack+6762423,4356);
 /*--- compute (lg|nn) ---*/
 hrr1_build_lg(Libint->AB,int_stack+14908143,int_stack+12512343,int_stack+8199903,4356);
 /*--- compute (kh|nn) ---*/
 hrr1_build_kh(Libint->AB,int_stack+5722170,int_stack+14908143,int_stack+10160103,4356);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+582351,int_stack+575421,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20790,int_stack+590541,int_stack+582351,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45360,int_stack+20790,int_stack+0,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86940,int_stack+600096,int_stack+590541,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115605,int_stack+86940,int_stack+20790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+164745,int_stack+115605,int_stack+45360,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+611121,int_stack+600096,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+234045,int_stack+0,int_stack+86940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+33075,int_stack+234045,int_stack+115605,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+291375,int_stack+33075,int_stack+164745,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+114975,int_stack+623721,int_stack+611121,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+152775,int_stack+114975,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+395325,int_stack+152775,int_stack+234045,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+490875,int_stack+395325,int_stack+33075,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1757580,int_stack+490875,int_stack+291375,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+638001,int_stack+623721,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+218925,int_stack+0,int_stack+114975,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1903110,int_stack+218925,int_stack+152775,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+42840,int_stack+1903110,int_stack+395325,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+294525,int_stack+42840,int_stack+490875,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2013360,int_stack+294525,int_stack+1757580,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1757580,int_stack+654066,int_stack+638001,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1805775,int_stack+1757580,int_stack+0,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+466515,int_stack+1805775,int_stack+218925,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2207400,int_stack+466515,int_stack+1903110,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2372775,int_stack+2207400,int_stack+42840,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+2372775,int_stack+294525,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2573430,int_stack+0,int_stack+2013360,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+229320,int_stack+672021,int_stack+654066,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+283185,int_stack+229320,int_stack+1757580,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1891455,int_stack+283185,int_stack+1805775,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2822910,int_stack+1891455,int_stack+466515,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+379575,int_stack+2822910,int_stack+2207400,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2034255,int_stack+379575,int_stack+2372775,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3011910,int_stack+2034255,int_stack+0,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+9015306,int_stack+3011910,int_stack+2573430,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+691971,int_stack+672021,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+59850,int_stack+0,int_stack+229320,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2301795,int_stack+59850,int_stack+283185,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2462445,int_stack+2301795,int_stack+1891455,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1757580,int_stack+2462445,int_stack+2822910,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2676645,int_stack+1757580,int_stack+379575,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+167580,int_stack+2676645,int_stack+2034255,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+9327156,int_stack+167580,int_stack+3011910,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2985345,int_stack+9327156,int_stack+9015306,105);
 /*--- compute (r0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+9015306,int_stack+714021,int_stack+691971,105);
 /*--- compute (r0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+9081456,int_stack+9015306,int_stack+0,105);
 /*--- compute (r0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+511560,int_stack+9081456,int_stack+59850,105);
 /*--- compute (r0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+9015306,int_stack+511560,int_stack+2301795,105);
 /*--- compute (r0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+2022180,int_stack+9015306,int_stack+2462445,105);
 /*--- compute (r0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2322060,int_stack+2022180,int_stack+1757580,105);
 /*--- compute (r0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1757580,int_stack+2322060,int_stack+2676645,105);
 /*--- compute (r0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2154480,int_stack+1757580,int_stack+167580,105);
 /*--- compute (r0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+2154480,int_stack+9327156,105);
 /*--- compute (r0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1757580,int_stack+0,int_stack+2985345,105);
 /*--- compute (qp|nn) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2214960,int_stack+1757580,int_stack+3600798,4356);
 /*--- compute (od|nn) ---*/
 hrr1_build_od(Libint->AB,int_stack+9015306,int_stack+2214960,int_stack+738276,4356);
 /*--- compute (nf|nn) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+9015306,int_stack+3997194,4356);
 /*--- compute (mg|nn) ---*/
 hrr1_build_mg(Libint->AB,int_stack+17848443,int_stack+0,int_stack+12512343,4356);
 /*--- compute (lh|nn) ---*/
 hrr1_build_lh(Libint->AB,int_stack+0,int_stack+17848443,int_stack+14908143,4356);
 /*--- compute (ki|nn) ---*/
 hrr1_build_ki(Libint->AB,int_stack+9015306,int_stack+0,int_stack+5722170,4356);
 return int_stack+9015306;}
