/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lfng(Libint_t*, prim_data*);

  /* Computes quartets of (lf|ng) integrals */

REALTYPE *hrr_order_lfng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[9][10] = int_stack + 20700;
 Libint->vrr_classes[9][11] = int_stack + 24330;
 Libint->vrr_classes[9][12] = int_stack + 28620;
 Libint->vrr_classes[9][13] = int_stack + 33625;
 Libint->vrr_classes[9][14] = int_stack + 39400;
 Libint->vrr_classes[10][10] = int_stack + 46000;
 Libint->vrr_classes[10][11] = int_stack + 50356;
 Libint->vrr_classes[10][12] = int_stack + 55504;
 Libint->vrr_classes[10][13] = int_stack + 61510;
 Libint->vrr_classes[10][14] = int_stack + 68440;
 Libint->vrr_classes[11][10] = int_stack + 76360;
 Libint->vrr_classes[11][11] = int_stack + 81508;
 Libint->vrr_classes[11][12] = int_stack + 87592;
 Libint->vrr_classes[11][13] = int_stack + 94690;
 Libint->vrr_classes[11][14] = int_stack + 102880;
 memset(int_stack,0,112240*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 112240;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lfng(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+112240,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+121150,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+131680,int_stack+121150,int_stack+112240,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+149500,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+161785,int_stack+149500,int_stack+121150,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+182845,int_stack+161785,int_stack+131680,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+112240,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+212545,int_stack+112240,int_stack+149500,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+112240,int_stack+212545,int_stack+161785,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+212545,int_stack+112240,int_stack+182845,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+112240,int_stack+24330,int_stack+20700,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+123130,int_stack+28620,int_stack+24330,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+136000,int_stack+123130,int_stack+112240,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+157780,int_stack+33625,int_stack+28620,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+172795,int_stack+157780,int_stack+123130,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+257095,int_stack+172795,int_stack+136000,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+112240,int_stack+39400,int_stack+33625,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+112240,int_stack+157780,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+112240,int_stack+0,int_stack+172795,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+155140,int_stack+112240,int_stack+257095,55);
 /*--- compute (lp|ng) ---*/
 hrr1_build_lp(Libint->AB,int_stack+257095,int_stack+155140,int_stack+212545,990);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+112240,int_stack+50356,int_stack+46000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+125308,int_stack+55504,int_stack+50356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+125308,int_stack+112240,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+26136,int_stack+61510,int_stack+55504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+209590,int_stack+26136,int_stack+125308,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+390745,int_stack+209590,int_stack+0,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+68440,int_stack+61510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+112240,int_stack+0,int_stack+26136,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+112240,int_stack+209590,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+434305,int_stack+0,int_stack+390745,66);
 /*--- compute (mp|ng) ---*/
 hrr1_build_mp(Libint->AB,int_stack+499645,int_stack+434305,int_stack+155140,990);
 /*--- compute (ld|ng) ---*/
 hrr1_build_ld(Libint->AB,int_stack+662995,int_stack+499645,int_stack+257095,990);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+81508,int_stack+76360,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+87592,int_stack+81508,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+94690,int_stack+87592,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+112240,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+148744,int_stack+112240,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+102880,int_stack+94690,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+200224,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+200224,int_stack+112240,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+200224,int_stack+0,int_stack+148744,78);
 /*--- compute (np|ng) ---*/
 hrr1_build_np(Libint->AB,int_stack+0,int_stack+200224,int_stack+434305,990);
 /*--- compute (md|ng) ---*/
 hrr1_build_md(Libint->AB,int_stack+930295,int_stack+0,int_stack+499645,990);
 /*--- compute (lf|ng) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+930295,int_stack+662995,990);
 return int_stack+0;}
