/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lglk(Libint_t*, prim_data*);

  /* Computes quartets of (lg|lk) integrals */

REALTYPE *hrr_order_lglk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][8] = int_stack + 0;
 Libint->vrr_classes[8][9] = int_stack + 2025;
 Libint->vrr_classes[8][10] = int_stack + 4500;
 Libint->vrr_classes[8][11] = int_stack + 7470;
 Libint->vrr_classes[8][12] = int_stack + 10980;
 Libint->vrr_classes[8][13] = int_stack + 15075;
 Libint->vrr_classes[8][14] = int_stack + 19800;
 Libint->vrr_classes[8][15] = int_stack + 25200;
 Libint->vrr_classes[9][8] = int_stack + 31320;
 Libint->vrr_classes[9][9] = int_stack + 33795;
 Libint->vrr_classes[9][10] = int_stack + 36820;
 Libint->vrr_classes[9][11] = int_stack + 40450;
 Libint->vrr_classes[9][12] = int_stack + 44740;
 Libint->vrr_classes[9][13] = int_stack + 49745;
 Libint->vrr_classes[9][14] = int_stack + 55520;
 Libint->vrr_classes[9][15] = int_stack + 62120;
 Libint->vrr_classes[10][8] = int_stack + 69600;
 Libint->vrr_classes[10][9] = int_stack + 72570;
 Libint->vrr_classes[10][10] = int_stack + 76200;
 Libint->vrr_classes[10][11] = int_stack + 80556;
 Libint->vrr_classes[10][12] = int_stack + 85704;
 Libint->vrr_classes[10][13] = int_stack + 91710;
 Libint->vrr_classes[10][14] = int_stack + 98640;
 Libint->vrr_classes[10][15] = int_stack + 106560;
 Libint->vrr_classes[11][8] = int_stack + 115536;
 Libint->vrr_classes[11][9] = int_stack + 119046;
 Libint->vrr_classes[11][10] = int_stack + 123336;
 Libint->vrr_classes[11][11] = int_stack + 128484;
 Libint->vrr_classes[11][12] = int_stack + 134568;
 Libint->vrr_classes[11][13] = int_stack + 141666;
 Libint->vrr_classes[11][14] = int_stack + 149856;
 Libint->vrr_classes[11][15] = int_stack + 159216;
 Libint->vrr_classes[12][8] = int_stack + 169824;
 Libint->vrr_classes[12][9] = int_stack + 173919;
 Libint->vrr_classes[12][10] = int_stack + 178924;
 Libint->vrr_classes[12][11] = int_stack + 184930;
 Libint->vrr_classes[12][12] = int_stack + 192028;
 Libint->vrr_classes[12][13] = int_stack + 200309;
 Libint->vrr_classes[12][14] = int_stack + 209864;
 Libint->vrr_classes[12][15] = int_stack + 220784;
 memset(int_stack,0,233160*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 233160;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lglk(Libint, Data);
   Data++;
 }
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+233160,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+239235,int_stack+4500,int_stack+2025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+246660,int_stack+239235,int_stack+233160,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+258810,int_stack+7470,int_stack+4500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+267720,int_stack+258810,int_stack+239235,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+282570,int_stack+267720,int_stack+246660,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+233160,int_stack+10980,int_stack+7470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+302820,int_stack+233160,int_stack+258810,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+320640,int_stack+302820,int_stack+267720,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+243690,int_stack+320640,int_stack+282570,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+274065,int_stack+15075,int_stack+10980,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+345390,int_stack+274065,int_stack+233160,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+366450,int_stack+345390,int_stack+302820,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+396150,int_stack+366450,int_stack+320640,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+286350,int_stack+396150,int_stack+243690,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+233160,int_stack+19800,int_stack+15075,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+247335,int_stack+233160,int_stack+274065,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+433275,int_stack+247335,int_stack+345390,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+468375,int_stack+433275,int_stack+366450,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+328875,int_stack+468375,int_stack+396150,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+512925,int_stack+328875,int_stack+286350,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+271905,int_stack+25200,int_stack+19800,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+288105,int_stack+271905,int_stack+233160,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+380850,int_stack+288105,int_stack+247335,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+233160,int_stack+380850,int_stack+433275,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+380850,int_stack+233160,int_stack+468375,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+233160,int_stack+380850,int_stack+328875,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+302460,int_stack+233160,int_stack+512925,45);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+233160,int_stack+33795,int_stack+31320,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+240585,int_stack+36820,int_stack+33795,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+249660,int_stack+240585,int_stack+233160,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+264510,int_stack+40450,int_stack+36820,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+275400,int_stack+264510,int_stack+240585,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+375360,int_stack+275400,int_stack+249660,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+233160,int_stack+44740,int_stack+40450,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+400110,int_stack+233160,int_stack+264510,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+421890,int_stack+400110,int_stack+275400,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+246030,int_stack+421890,int_stack+375360,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+375360,int_stack+49745,int_stack+44740,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+452140,int_stack+375360,int_stack+233160,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+477880,int_stack+452140,int_stack+400110,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+514180,int_stack+477880,int_stack+421890,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+390375,int_stack+514180,int_stack+246030,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+233160,int_stack+55520,int_stack+49745,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+250485,int_stack+233160,int_stack+375360,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+250485,int_stack+452140,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+559555,int_stack+0,int_stack+477880,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+442350,int_stack+559555,int_stack+514180,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+614005,int_stack+442350,int_stack+390375,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+375360,int_stack+62120,int_stack+55520,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+395160,int_stack+375360,int_stack+233160,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+505875,int_stack+395160,int_stack+250485,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+233160,int_stack+505875,int_stack+0,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+683305,int_stack+233160,int_stack+559555,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+505875,int_stack+683305,int_stack+442350,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+375360,int_stack+505875,int_stack+614005,55);
 /*--- compute (lp|lk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+464460,int_stack+375360,int_stack+302460,1620);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+233160,int_stack+72570,int_stack+69600,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+242070,int_stack+76200,int_stack+72570,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+252960,int_stack+242070,int_stack+233160,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+270780,int_stack+80556,int_stack+76200,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+283848,int_stack+270780,int_stack+242070,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+305628,int_stack+283848,int_stack+252960,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+233160,int_stack+85704,int_stack+80556,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+335328,int_stack+233160,int_stack+270780,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+335328,int_stack+283848,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+248604,int_stack+0,int_stack+305628,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+293154,int_stack+91710,int_stack+85704,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+36300,int_stack+293154,int_stack+233160,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+683160,int_stack+36300,int_stack+335328,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+311172,int_stack+683160,int_stack+0,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+726720,int_stack+311172,int_stack+248604,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+98640,int_stack+91710,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+233160,int_stack+0,int_stack+293154,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+789090,int_stack+233160,int_stack+36300,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+20790,int_stack+789090,int_stack+683160,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+840570,int_stack+20790,int_stack+311172,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+269196,int_stack+840570,int_stack+726720,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+683160,int_stack+106560,int_stack+98640,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+706920,int_stack+683160,int_stack+0,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+916800,int_stack+706920,int_stack+233160,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+683160,int_stack+916800,int_stack+789090,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+916800,int_stack+683160,int_stack+20790,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+683160,int_stack+916800,int_stack+840570,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+784800,int_stack+683160,int_stack+269196,66);
 /*--- compute (mp|lk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+891720,int_stack+784800,int_stack+375360,1620);
 /*--- compute (ld|lk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1159020,int_stack+891720,int_stack+464460,1620);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+233160,int_stack+119046,int_stack+115536,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+243690,int_stack+123336,int_stack+119046,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+256560,int_stack+243690,int_stack+233160,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+277620,int_stack+128484,int_stack+123336,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+293064,int_stack+277620,int_stack+243690,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+318804,int_stack+293064,int_stack+256560,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+233160,int_stack+134568,int_stack+128484,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+353904,int_stack+233160,int_stack+277620,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+384792,int_stack+353904,int_stack+293064,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+251412,int_stack+384792,int_stack+318804,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+304062,int_stack+141666,int_stack+134568,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+427692,int_stack+304062,int_stack+233160,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+464196,int_stack+427692,int_stack+353904,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+515676,int_stack+464196,int_stack+384792,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+325356,int_stack+515676,int_stack+251412,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+233160,int_stack+149856,int_stack+141666,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+257730,int_stack+233160,int_stack+304062,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+580026,int_stack+257730,int_stack+427692,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+640866,int_stack+580026,int_stack+464196,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+399066,int_stack+640866,int_stack+515676,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+399066,int_stack+325356,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+300318,int_stack+159216,int_stack+149856,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+328398,int_stack+300318,int_stack+233160,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+489156,int_stack+328398,int_stack+257730,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+233160,int_stack+489156,int_stack+580026,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+489156,int_stack+233160,int_stack+640866,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+233160,int_stack+489156,int_stack+399066,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+353280,int_stack+233160,int_stack+0,78);
 /*--- compute (np|lk) ---*/
 hrr1_build_np(Libint->AB,int_stack+1596420,int_stack+353280,int_stack+784800,1620);
 /*--- compute (md|lk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1917180,int_stack+1596420,int_stack+891720,1620);
 /*--- compute (lf|lk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+2451780,int_stack+1917180,int_stack+1159020,1620);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+173919,int_stack+169824,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12285,int_stack+178924,int_stack+173919,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+27300,int_stack+12285,int_stack+0,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51870,int_stack+184930,int_stack+178924,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+69888,int_stack+51870,int_stack+12285,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+99918,int_stack+69888,int_stack+27300,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+192028,int_stack+184930,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+140868,int_stack+0,int_stack+51870,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+233160,int_stack+140868,int_stack+69888,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+21294,int_stack+233160,int_stack+99918,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+82719,int_stack+200309,int_stack+192028,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+283210,int_stack+82719,int_stack+0,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+479640,int_stack+283210,int_stack+140868,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+107562,int_stack+479640,int_stack+233160,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+539700,int_stack+107562,int_stack+21294,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+233160,int_stack+209864,int_stack+200309,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+233160,int_stack+82719,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+625695,int_stack+0,int_stack+283210,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+261825,int_stack+625695,int_stack+479640,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+696675,int_stack+261825,int_stack+107562,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+49686,int_stack+696675,int_stack+539700,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+479640,int_stack+220784,int_stack+209864,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+512400,int_stack+479640,int_stack+233160,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+164346,int_stack+512400,int_stack+0,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+479640,int_stack+164346,int_stack+625695,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+801780,int_stack+479640,int_stack+261825,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+479640,int_stack+801780,int_stack+696675,91);
 /*--- compute (q0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+619780,int_stack+479640,int_stack+49686,91);
 /*--- compute (op|lk) ---*/
 hrr1_build_op(Libint->AB,int_stack+767200,int_stack+619780,int_stack+353280,1620);
 /*--- compute (nd|lk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+0,int_stack+767200,int_stack+1596420,1620);
 /*--- compute (mf|lk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+641520,int_stack+0,int_stack+1917180,1620);
 /*--- compute (lg|lk) ---*/
 hrr1_build_lg(Libint->AB,int_stack+3180780,int_stack+641520,int_stack+2451780,1620);
 return int_stack+3180780;}
