/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_likk(Libint_t*, prim_data*);

  /* Computes quartets of (li|kk) integrals */

REALTYPE *hrr_order_likk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][7] = int_stack + 0;
 Libint->vrr_classes[8][8] = int_stack + 1620;
 Libint->vrr_classes[8][9] = int_stack + 3645;
 Libint->vrr_classes[8][10] = int_stack + 6120;
 Libint->vrr_classes[8][11] = int_stack + 9090;
 Libint->vrr_classes[8][12] = int_stack + 12600;
 Libint->vrr_classes[8][13] = int_stack + 16695;
 Libint->vrr_classes[8][14] = int_stack + 21420;
 Libint->vrr_classes[9][7] = int_stack + 26820;
 Libint->vrr_classes[9][8] = int_stack + 28800;
 Libint->vrr_classes[9][9] = int_stack + 31275;
 Libint->vrr_classes[9][10] = int_stack + 34300;
 Libint->vrr_classes[9][11] = int_stack + 37930;
 Libint->vrr_classes[9][12] = int_stack + 42220;
 Libint->vrr_classes[9][13] = int_stack + 47225;
 Libint->vrr_classes[9][14] = int_stack + 53000;
 Libint->vrr_classes[10][7] = int_stack + 59600;
 Libint->vrr_classes[10][8] = int_stack + 61976;
 Libint->vrr_classes[10][9] = int_stack + 64946;
 Libint->vrr_classes[10][10] = int_stack + 68576;
 Libint->vrr_classes[10][11] = int_stack + 72932;
 Libint->vrr_classes[10][12] = int_stack + 78080;
 Libint->vrr_classes[10][13] = int_stack + 84086;
 Libint->vrr_classes[10][14] = int_stack + 91016;
 Libint->vrr_classes[11][7] = int_stack + 98936;
 Libint->vrr_classes[11][8] = int_stack + 101744;
 Libint->vrr_classes[11][9] = int_stack + 105254;
 Libint->vrr_classes[11][10] = int_stack + 109544;
 Libint->vrr_classes[11][11] = int_stack + 114692;
 Libint->vrr_classes[11][12] = int_stack + 120776;
 Libint->vrr_classes[11][13] = int_stack + 127874;
 Libint->vrr_classes[11][14] = int_stack + 136064;
 Libint->vrr_classes[12][7] = int_stack + 145424;
 Libint->vrr_classes[12][8] = int_stack + 148700;
 Libint->vrr_classes[12][9] = int_stack + 152795;
 Libint->vrr_classes[12][10] = int_stack + 157800;
 Libint->vrr_classes[12][11] = int_stack + 163806;
 Libint->vrr_classes[12][12] = int_stack + 170904;
 Libint->vrr_classes[12][13] = int_stack + 179185;
 Libint->vrr_classes[12][14] = int_stack + 188740;
 Libint->vrr_classes[13][7] = int_stack + 199660;
 Libint->vrr_classes[13][8] = int_stack + 203440;
 Libint->vrr_classes[13][9] = int_stack + 208165;
 Libint->vrr_classes[13][10] = int_stack + 213940;
 Libint->vrr_classes[13][11] = int_stack + 220870;
 Libint->vrr_classes[13][12] = int_stack + 229060;
 Libint->vrr_classes[13][13] = int_stack + 238615;
 Libint->vrr_classes[13][14] = int_stack + 249640;
 Libint->vrr_classes[14][7] = int_stack + 262240;
 Libint->vrr_classes[14][8] = int_stack + 266560;
 Libint->vrr_classes[14][9] = int_stack + 271960;
 Libint->vrr_classes[14][10] = int_stack + 278560;
 Libint->vrr_classes[14][11] = int_stack + 286480;
 Libint->vrr_classes[14][12] = int_stack + 295840;
 Libint->vrr_classes[14][13] = int_stack + 306760;
 Libint->vrr_classes[14][14] = int_stack + 319360;
 memset(int_stack,0,333760*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 333760;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_likk(Libint, Data);
   Data++;
 }
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+333760,int_stack+1620,int_stack+0,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+338620,int_stack+3645,int_stack+1620,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+344695,int_stack+338620,int_stack+333760,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+354415,int_stack+6120,int_stack+3645,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+361840,int_stack+354415,int_stack+338620,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+373990,int_stack+361840,int_stack+344695,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+333760,int_stack+9090,int_stack+6120,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+390190,int_stack+333760,int_stack+354415,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+405040,int_stack+390190,int_stack+361840,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+342670,int_stack+405040,int_stack+373990,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+366970,int_stack+12600,int_stack+9090,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+425290,int_stack+366970,int_stack+333760,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+443110,int_stack+425290,int_stack+390190,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+467860,int_stack+443110,int_stack+405040,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+377500,int_stack+467860,int_stack+342670,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+333760,int_stack+16695,int_stack+12600,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+498235,int_stack+333760,int_stack+366970,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+346045,int_stack+498235,int_stack+425290,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+519295,int_stack+346045,int_stack+443110,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+411520,int_stack+519295,int_stack+467860,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+556420,int_stack+411520,int_stack+377500,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+375745,int_stack+21420,int_stack+16695,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+454045,int_stack+375745,int_stack+333760,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+375745,int_stack+454045,int_stack+498235,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+454045,int_stack+375745,int_stack+346045,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+333760,int_stack+454045,int_stack+519295,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+454045,int_stack+333760,int_stack+411520,45);
 /*--- compute (l0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+333760,int_stack+454045,int_stack+556420,45);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+392080,int_stack+28800,int_stack+26820,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+398020,int_stack+31275,int_stack+28800,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+405445,int_stack+398020,int_stack+392080,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+417325,int_stack+34300,int_stack+31275,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+426400,int_stack+417325,int_stack+398020,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+441250,int_stack+426400,int_stack+405445,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+392080,int_stack+37930,int_stack+34300,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+461050,int_stack+392080,int_stack+417325,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+479200,int_stack+461050,int_stack+426400,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+402970,int_stack+479200,int_stack+441250,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+432670,int_stack+42220,int_stack+37930,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+503950,int_stack+432670,int_stack+392080,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+525730,int_stack+503950,int_stack+461050,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+555980,int_stack+525730,int_stack+479200,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+445540,int_stack+555980,int_stack+402970,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+392080,int_stack+47225,int_stack+42220,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+392080,int_stack+432670,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+407095,int_stack+0,int_stack+503950,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+593105,int_stack+407095,int_stack+525730,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+487120,int_stack+593105,int_stack+555980,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+638480,int_stack+487120,int_stack+445540,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+443395,int_stack+53000,int_stack+47225,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+539095,int_stack+443395,int_stack+392080,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+443395,int_stack+539095,int_stack+0,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+443395,int_stack+407095,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+392080,int_stack+0,int_stack+593105,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+539095,int_stack+392080,int_stack+487120,55);
 /*--- compute (m0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+392080,int_stack+539095,int_stack+638480,55);
 /*--- compute (lp|kk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+463360,int_stack+392080,int_stack+333760,1296);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+333760,int_stack+61976,int_stack+59600,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+340888,int_stack+64946,int_stack+61976,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+349798,int_stack+340888,int_stack+333760,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+364054,int_stack+68576,int_stack+64946,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+638320,int_stack+364054,int_stack+340888,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+656140,int_stack+638320,int_stack+349798,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+333760,int_stack+72932,int_stack+68576,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+333760,int_stack+364054,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+346828,int_stack+0,int_stack+638320,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+21780,int_stack+346828,int_stack+656140,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+638320,int_stack+78080,int_stack+72932,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+653764,int_stack+638320,int_stack+333760,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+679900,int_stack+653764,int_stack+0,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+716200,int_stack+679900,int_stack+346828,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+333760,int_stack+716200,int_stack+21780,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+84086,int_stack+78080,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+18018,int_stack+0,int_stack+638320,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+760750,int_stack+18018,int_stack+653764,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+804310,int_stack+760750,int_stack+679900,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+638320,int_stack+804310,int_stack+716200,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+858760,int_stack+638320,int_stack+333760,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+333760,int_stack+91016,int_stack+84086,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+354550,int_stack+333760,int_stack+0,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+700690,int_stack+354550,int_stack+18018,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+700690,int_stack+760750,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+700690,int_stack+0,int_stack+804310,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+700690,int_stack+638320,66);
 /*--- compute (n0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+638320,int_stack+0,int_stack+858760,66);
 /*--- compute (mp|kk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+723856,int_stack+638320,int_stack+392080,1296);
 /*--- compute (ld|kk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+937696,int_stack+723856,int_stack+463360,1296);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+101744,int_stack+98936,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8424,int_stack+105254,int_stack+101744,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+18954,int_stack+8424,int_stack+0,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+35802,int_stack+109544,int_stack+105254,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+48672,int_stack+35802,int_stack+8424,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+69732,int_stack+48672,int_stack+18954,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+114692,int_stack+109544,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+333760,int_stack+0,int_stack+35802,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+359500,int_stack+333760,int_stack+48672,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+15444,int_stack+359500,int_stack+69732,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+57564,int_stack+120776,int_stack+114692,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+75816,int_stack+57564,int_stack+0,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+394600,int_stack+75816,int_stack+333760,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+437500,int_stack+394600,int_stack+359500,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+333760,int_stack+437500,int_stack+15444,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+127874,int_stack+120776,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+490150,int_stack+0,int_stack+57564,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+21294,int_stack+490150,int_stack+75816,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+526654,int_stack+21294,int_stack+394600,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1287616,int_stack+526654,int_stack+437500,78);
 /*--- compute (o0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+392728,int_stack+1287616,int_stack+333760,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+333760,int_stack+136064,int_stack+127874,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+72774,int_stack+333760,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1361326,int_stack+72774,int_stack+490150,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1422166,int_stack+1361326,int_stack+21294,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+1422166,int_stack+526654,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1361326,int_stack+0,int_stack+1287616,78);
 /*--- compute (o0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+0,int_stack+1361326,int_stack+392728,78);
 /*--- compute (np|kk) ---*/
 hrr1_build_np(Libint->AB,int_stack+333760,int_stack+0,int_stack+638320,1296);
 /*--- compute (md|kk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1287616,int_stack+333760,int_stack+723856,1296);
 /*--- compute (lf|kk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1715296,int_stack+1287616,int_stack+937696,1296);
 /*--- compute (q0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+101088,int_stack+148700,int_stack+145424,91);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+110916,int_stack+152795,int_stack+148700,91);
 /*--- compute (q0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+123201,int_stack+110916,int_stack+101088,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+590368,int_stack+157800,int_stack+152795,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+605383,int_stack+590368,int_stack+110916,91);
 /*--- compute (q0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+629953,int_stack+605383,int_stack+123201,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+101088,int_stack+163806,int_stack+157800,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+119106,int_stack+101088,int_stack+590368,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+662713,int_stack+119106,int_stack+605383,91);
 /*--- compute (q0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+703663,int_stack+662713,int_stack+629953,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+590368,int_stack+170904,int_stack+163806,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+611662,int_stack+590368,int_stack+101088,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+752803,int_stack+611662,int_stack+119106,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+101088,int_stack+752803,int_stack+662713,91);
 /*--- compute (q0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+802853,int_stack+101088,int_stack+703663,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+647698,int_stack+179185,int_stack+170904,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+672541,int_stack+647698,int_stack+590368,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+871649,int_stack+672541,int_stack+611662,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+931709,int_stack+871649,int_stack+752803,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+715129,int_stack+931709,int_stack+101088,91);
 /*--- compute (q0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+1006784,int_stack+715129,int_stack+802853,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+101088,int_stack+188740,int_stack+179185,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+129753,int_stack+101088,int_stack+647698,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+590368,int_stack+129753,int_stack+672541,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+101088,int_stack+590368,int_stack+871649,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+590368,int_stack+101088,int_stack+931709,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+801124,int_stack+590368,int_stack+715129,91);
 /*--- compute (q0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+590368,int_stack+801124,int_stack+1006784,91);
 /*--- compute (op|kk) ---*/
 hrr1_build_op(Libint->AB,int_stack+708304,int_stack+590368,int_stack+0,1296);
 /*--- compute (nd|kk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2298496,int_stack+708304,int_stack+333760,1296);
 /*--- compute (mf|kk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2811712,int_stack+2298496,int_stack+1287616,1296);
 /*--- compute (lg|kk) ---*/
 hrr1_build_lg(Libint->AB,int_stack+3524512,int_stack+2811712,int_stack+1715296,1296);
 /*--- compute (r0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+333760,int_stack+203440,int_stack+199660,105);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+345100,int_stack+208165,int_stack+203440,105);
 /*--- compute (r0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+359275,int_stack+345100,int_stack+333760,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+381955,int_stack+213940,int_stack+208165,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+399280,int_stack+381955,int_stack+345100,105);
 /*--- compute (r0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+427630,int_stack+399280,int_stack+359275,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+333760,int_stack+220870,int_stack+213940,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+465430,int_stack+333760,int_stack+381955,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+500080,int_stack+465430,int_stack+399280,105);
 /*--- compute (r0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+354550,int_stack+500080,int_stack+427630,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+411250,int_stack+229060,int_stack+220870,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+547330,int_stack+411250,int_stack+333760,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+547330,int_stack+465430,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+57750,int_stack+0,int_stack+500080,105);
 /*--- compute (r0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+435820,int_stack+57750,int_stack+354550,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+333760,int_stack+238615,int_stack+229060,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+128625,int_stack+333760,int_stack+411250,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+362425,int_stack+128625,int_stack+547330,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1011568,int_stack+362425,int_stack+0,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1098193,int_stack+1011568,int_stack+57750,105);
 /*--- compute (r0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+0,int_stack+1098193,int_stack+435820,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+431725,int_stack+249640,int_stack+238615,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+464800,int_stack+431725,int_stack+333760,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+177765,int_stack+464800,int_stack+128625,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+431725,int_stack+177765,int_stack+362425,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+105840,int_stack+431725,int_stack+1011568,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+333760,int_stack+105840,int_stack+1098193,105);
 /*--- compute (r0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+105840,int_stack+333760,int_stack+0,105);
 /*--- compute (qp|kk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1011568,int_stack+105840,int_stack+590368,1296);
 /*--- compute (od|kk) ---*/
 hrr1_build_od(Libint->AB,int_stack+1365376,int_stack+1011568,int_stack+708304,1296);
 /*--- compute (nf|kk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+4399312,int_stack+1365376,int_stack+2298496,1296);
 /*--- compute (mg|kk) ---*/
 hrr1_build_mg(Libint->AB,int_stack+5254672,int_stack+4399312,int_stack+2811712,1296);
 /*--- compute (lh|kk) ---*/
 hrr1_build_lh(Libint->AB,int_stack+1971904,int_stack+5254672,int_stack+3524512,1296);
 /*--- compute (t0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+266560,int_stack+262240,120);
 /*--- compute (t0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+12960,int_stack+271960,int_stack+266560,120);
 /*--- compute (t0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+29160,int_stack+12960,int_stack+0,120);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+55080,int_stack+278560,int_stack+271960,120);
 /*--- compute (t0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+333760,int_stack+55080,int_stack+12960,120);
 /*--- compute (t0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+366160,int_stack+333760,int_stack+29160,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+286480,int_stack+278560,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+409360,int_stack+0,int_stack+55080,120);
 /*--- compute (t0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+23760,int_stack+409360,int_stack+333760,120);
 /*--- compute (t0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+448960,int_stack+23760,int_stack+366160,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+77760,int_stack+295840,int_stack+286480,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+333760,int_stack+77760,int_stack+0,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+513760,int_stack+333760,int_stack+409360,120);
 /*--- compute (t0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+579760,int_stack+513760,int_stack+23760,120);
 /*--- compute (t0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+660760,int_stack+579760,int_stack+448960,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+306760,int_stack+295840,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+381280,int_stack+0,int_stack+77760,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+751480,int_stack+381280,int_stack+333760,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+830680,int_stack+751480,int_stack+513760,120);
 /*--- compute (t0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+437440,int_stack+830680,int_stack+579760,120);
 /*--- compute (t0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+3196624,int_stack+437440,int_stack+660760,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+333760,int_stack+319360,int_stack+306760,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+32760,int_stack+333760,int_stack+0,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+550840,int_stack+32760,int_stack+381280,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+241920,int_stack+550840,int_stack+751480,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+550840,int_stack+241920,int_stack+830680,120);
 /*--- compute (t0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+241920,int_stack+550840,int_stack+437440,120);
 /*--- compute (t0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+393120,int_stack+241920,int_stack+3196624,120);
 /*--- compute (rp|kk) ---*/
 hrr1_build_rp(Libint->AB,int_stack+3196624,int_stack+393120,int_stack+105840,1296);
 /*--- compute (qd|kk) ---*/
 hrr1_build_qd(Libint->AB,int_stack+3604864,int_stack+3196624,int_stack+1011568,1296);
 /*--- compute (of|kk) ---*/
 hrr1_build_of(Libint->AB,int_stack+0,int_stack+3604864,int_stack+1365376,1296);
 /*--- compute (ng|kk) ---*/
 hrr1_build_ng(Libint->AB,int_stack+6323872,int_stack+0,int_stack+4399312,1296);
 /*--- compute (mh|kk) ---*/
 hrr1_build_mh(Libint->AB,int_stack+0,int_stack+6323872,int_stack+5254672,1296);
 /*--- compute (li|kk) ---*/
 hrr1_build_li(Libint->AB,int_stack+3196624,int_stack+0,int_stack+1971904,1296);
 return int_stack+3196624;}
