/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lili(Libint_t*, prim_data*);

  /* Computes quartets of (li|li) integrals */

REALTYPE *hrr_order_lili(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][8] = int_stack + 0;
 Libint->vrr_classes[8][9] = int_stack + 2025;
 Libint->vrr_classes[8][10] = int_stack + 4500;
 Libint->vrr_classes[8][11] = int_stack + 7470;
 Libint->vrr_classes[8][12] = int_stack + 10980;
 Libint->vrr_classes[8][13] = int_stack + 15075;
 Libint->vrr_classes[8][14] = int_stack + 19800;
 Libint->vrr_classes[9][8] = int_stack + 25200;
 Libint->vrr_classes[9][9] = int_stack + 27675;
 Libint->vrr_classes[9][10] = int_stack + 30700;
 Libint->vrr_classes[9][11] = int_stack + 34330;
 Libint->vrr_classes[9][12] = int_stack + 38620;
 Libint->vrr_classes[9][13] = int_stack + 43625;
 Libint->vrr_classes[9][14] = int_stack + 49400;
 Libint->vrr_classes[10][8] = int_stack + 56000;
 Libint->vrr_classes[10][9] = int_stack + 58970;
 Libint->vrr_classes[10][10] = int_stack + 62600;
 Libint->vrr_classes[10][11] = int_stack + 66956;
 Libint->vrr_classes[10][12] = int_stack + 72104;
 Libint->vrr_classes[10][13] = int_stack + 78110;
 Libint->vrr_classes[10][14] = int_stack + 85040;
 Libint->vrr_classes[11][8] = int_stack + 92960;
 Libint->vrr_classes[11][9] = int_stack + 96470;
 Libint->vrr_classes[11][10] = int_stack + 100760;
 Libint->vrr_classes[11][11] = int_stack + 105908;
 Libint->vrr_classes[11][12] = int_stack + 111992;
 Libint->vrr_classes[11][13] = int_stack + 119090;
 Libint->vrr_classes[11][14] = int_stack + 127280;
 Libint->vrr_classes[12][8] = int_stack + 136640;
 Libint->vrr_classes[12][9] = int_stack + 140735;
 Libint->vrr_classes[12][10] = int_stack + 145740;
 Libint->vrr_classes[12][11] = int_stack + 151746;
 Libint->vrr_classes[12][12] = int_stack + 158844;
 Libint->vrr_classes[12][13] = int_stack + 167125;
 Libint->vrr_classes[12][14] = int_stack + 176680;
 Libint->vrr_classes[13][8] = int_stack + 187600;
 Libint->vrr_classes[13][9] = int_stack + 192325;
 Libint->vrr_classes[13][10] = int_stack + 198100;
 Libint->vrr_classes[13][11] = int_stack + 205030;
 Libint->vrr_classes[13][12] = int_stack + 213220;
 Libint->vrr_classes[13][13] = int_stack + 222775;
 Libint->vrr_classes[13][14] = int_stack + 233800;
 Libint->vrr_classes[14][8] = int_stack + 246400;
 Libint->vrr_classes[14][9] = int_stack + 251800;
 Libint->vrr_classes[14][10] = int_stack + 258400;
 Libint->vrr_classes[14][11] = int_stack + 266320;
 Libint->vrr_classes[14][12] = int_stack + 275680;
 Libint->vrr_classes[14][13] = int_stack + 286600;
 Libint->vrr_classes[14][14] = int_stack + 299200;
 memset(int_stack,0,313600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 313600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lili(Libint, Data);
   Data++;
 }
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+313600,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+319675,int_stack+4500,int_stack+2025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+327100,int_stack+319675,int_stack+313600,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+339250,int_stack+7470,int_stack+4500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+348160,int_stack+339250,int_stack+319675,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+363010,int_stack+348160,int_stack+327100,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+313600,int_stack+10980,int_stack+7470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+383260,int_stack+313600,int_stack+339250,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+401080,int_stack+383260,int_stack+348160,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+324130,int_stack+401080,int_stack+363010,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+354505,int_stack+15075,int_stack+10980,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+425830,int_stack+354505,int_stack+313600,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+446890,int_stack+425830,int_stack+383260,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+476590,int_stack+446890,int_stack+401080,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+366790,int_stack+476590,int_stack+324130,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+313600,int_stack+19800,int_stack+15075,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+327775,int_stack+313600,int_stack+354505,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+513715,int_stack+327775,int_stack+425830,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+313600,int_stack+513715,int_stack+446890,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+409315,int_stack+313600,int_stack+476590,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+461290,int_stack+409315,int_stack+366790,45);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+313600,int_stack+27675,int_stack+25200,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+321025,int_stack+30700,int_stack+27675,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+330100,int_stack+321025,int_stack+313600,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+344950,int_stack+34330,int_stack+30700,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+355840,int_stack+344950,int_stack+321025,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+373990,int_stack+355840,int_stack+330100,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+313600,int_stack+38620,int_stack+34330,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+398740,int_stack+313600,int_stack+344950,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+420520,int_stack+398740,int_stack+355840,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+326470,int_stack+420520,int_stack+373990,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+363595,int_stack+43625,int_stack+38620,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+517990,int_stack+363595,int_stack+313600,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+517990,int_stack+398740,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+543730,int_stack+0,int_stack+420520,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+378610,int_stack+543730,int_stack+326470,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+313600,int_stack+49400,int_stack+43625,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+330925,int_stack+313600,int_stack+363595,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+589105,int_stack+330925,int_stack+517990,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+313600,int_stack+589105,int_stack+0,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+589105,int_stack+313600,int_stack+543730,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+517990,int_stack+589105,int_stack+378610,55);
 /*--- compute (lp|li) ---*/
 hrr1_build_lp(Libint->AB,int_stack+587290,int_stack+517990,int_stack+461290,1260);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+313600,int_stack+58970,int_stack+56000,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+322510,int_stack+62600,int_stack+58970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+333400,int_stack+322510,int_stack+313600,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+351220,int_stack+66956,int_stack+62600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+364288,int_stack+351220,int_stack+322510,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+386068,int_stack+364288,int_stack+333400,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+313600,int_stack+72104,int_stack+66956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+415768,int_stack+313600,int_stack+351220,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+441904,int_stack+415768,int_stack+364288,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+329044,int_stack+441904,int_stack+386068,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+373594,int_stack+78110,int_stack+72104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+478204,int_stack+373594,int_stack+313600,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+478204,int_stack+415768,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+757390,int_stack+0,int_stack+441904,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+391612,int_stack+757390,int_stack+329044,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+313600,int_stack+85040,int_stack+78110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+334390,int_stack+313600,int_stack+373594,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+811840,int_stack+334390,int_stack+478204,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+313600,int_stack+811840,int_stack+0,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+313600,int_stack+757390,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+757390,int_stack+0,int_stack+391612,66);
 /*--- compute (mp|li) ---*/
 hrr1_build_mp(Libint->AB,int_stack+840550,int_stack+757390,int_stack+517990,1260);
 /*--- compute (ld|li) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1048450,int_stack+840550,int_stack+587290,1260);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+96470,int_stack+92960,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10530,int_stack+100760,int_stack+96470,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23400,int_stack+10530,int_stack+0,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44460,int_stack+105908,int_stack+100760,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+59904,int_stack+44460,int_stack+10530,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+313600,int_stack+59904,int_stack+23400,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+111992,int_stack+105908,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+348700,int_stack+0,int_stack+44460,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+379588,int_stack+348700,int_stack+59904,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+18252,int_stack+379588,int_stack+313600,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+313600,int_stack+119090,int_stack+111992,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+70902,int_stack+313600,int_stack+0,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+422488,int_stack+70902,int_stack+348700,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+473968,int_stack+422488,int_stack+379588,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+334894,int_stack+473968,int_stack+18252,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+127280,int_stack+119090,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+24570,int_stack+0,int_stack+313600,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+538318,int_stack+24570,int_stack+70902,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+538318,int_stack+422488,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+538318,int_stack+0,int_stack+473968,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+538318,int_stack+334894,78);
 /*--- compute (np|li) ---*/
 hrr1_build_np(Libint->AB,int_stack+313600,int_stack+0,int_stack+757390,1260);
 /*--- compute (md|li) ---*/
 hrr1_build_md(Libint->AB,int_stack+1388650,int_stack+313600,int_stack+840550,1260);
 /*--- compute (lf|li) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1804450,int_stack+1388650,int_stack+1048450,1260);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+98280,int_stack+140735,int_stack+136640,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+110565,int_stack+145740,int_stack+140735,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+563080,int_stack+110565,int_stack+98280,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+125580,int_stack+151746,int_stack+145740,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+587650,int_stack+125580,int_stack+110565,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+617680,int_stack+587650,int_stack+563080,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+563080,int_stack+158844,int_stack+151746,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+658630,int_stack+563080,int_stack+125580,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+98280,int_stack+658630,int_stack+587650,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+694666,int_stack+98280,int_stack+617680,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+584374,int_stack+167125,int_stack+158844,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+609217,int_stack+584374,int_stack+563080,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+756091,int_stack+609217,int_stack+658630,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+816151,int_stack+756091,int_stack+98280,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+891226,int_stack+816151,int_stack+694666,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+98280,int_stack+176680,int_stack+167125,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+126945,int_stack+98280,int_stack+584374,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+651805,int_stack+126945,int_stack+609217,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+977221,int_stack+651805,int_stack+756091,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+563080,int_stack+977221,int_stack+816151,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+977221,int_stack+563080,int_stack+891226,91);
 /*--- compute (op|li) ---*/
 hrr1_build_op(Libint->AB,int_stack+563080,int_stack+977221,int_stack+0,1260);
 /*--- compute (nd|li) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2371450,int_stack+563080,int_stack+313600,1260);
 /*--- compute (mf|li) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2870410,int_stack+2371450,int_stack+1388650,1260);
 /*--- compute (lg|li) ---*/
 hrr1_build_lg(Libint->AB,int_stack+3563410,int_stack+2870410,int_stack+1804450,1260);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+313600,int_stack+192325,int_stack+187600,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+327775,int_stack+198100,int_stack+192325,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+345100,int_stack+327775,int_stack+313600,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+373450,int_stack+205030,int_stack+198100,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+394240,int_stack+373450,int_stack+327775,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+428890,int_stack+394240,int_stack+345100,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+313600,int_stack+213220,int_stack+205030,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+476140,int_stack+313600,int_stack+373450,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+476140,int_stack+394240,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+338170,int_stack+0,int_stack+428890,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+409045,int_stack+222775,int_stack+213220,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+57750,int_stack+409045,int_stack+313600,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+106890,int_stack+57750,int_stack+476140,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+437710,int_stack+106890,int_stack+0,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+857920,int_stack+437710,int_stack+338170,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+233800,int_stack+222775,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+313600,int_stack+0,int_stack+409045,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1091881,int_stack+313600,int_stack+57750,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+313600,int_stack+1091881,int_stack+106890,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1091881,int_stack+313600,int_stack+437710,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+313600,int_stack+1091881,int_stack+857920,105);
 /*--- compute (qp|li) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1091881,int_stack+313600,int_stack+977221,1260);
 /*--- compute (od|li) ---*/
 hrr1_build_od(Libint->AB,int_stack+1435861,int_stack+1091881,int_stack+563080,1260);
 /*--- compute (nf|li) ---*/
 hrr1_build_nf(Libint->AB,int_stack+4413910,int_stack+1435861,int_stack+2371450,1260);
 /*--- compute (mg|li) ---*/
 hrr1_build_mg(Libint->AB,int_stack+5245510,int_stack+4413910,int_stack+2870410,1260);
 /*--- compute (lh|li) ---*/
 hrr1_build_lh(Libint->AB,int_stack+2025541,int_stack+5245510,int_stack+3563410,1260);
 /*--- compute (t0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3216241,int_stack+251800,int_stack+246400,120);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3232441,int_stack+258400,int_stack+251800,120);
 /*--- compute (t0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+3252241,int_stack+3232441,int_stack+3216241,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3284641,int_stack+266320,int_stack+258400,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+3308401,int_stack+3284641,int_stack+3232441,120);
 /*--- compute (t0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+3348001,int_stack+3308401,int_stack+3252241,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3216241,int_stack+275680,int_stack+266320,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+3402001,int_stack+3216241,int_stack+3284641,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+3449521,int_stack+3402001,int_stack+3308401,120);
 /*--- compute (t0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+3244321,int_stack+3449521,int_stack+3348001,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3325321,int_stack+286600,int_stack+275680,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3515521,int_stack+3325321,int_stack+3216241,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3571681,int_stack+3515521,int_stack+3402001,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+3650881,int_stack+3571681,int_stack+3449521,120);
 /*--- compute (t0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+3358081,int_stack+3650881,int_stack+3244321,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+3216241,int_stack+299200,int_stack+286600,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3254041,int_stack+3216241,int_stack+3325321,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3749881,int_stack+3254041,int_stack+3515521,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3216241,int_stack+3749881,int_stack+3571681,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+3749881,int_stack+3216241,int_stack+3650881,120);
 /*--- compute (t0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+3888481,int_stack+3749881,int_stack+3358081,120);
 /*--- compute (rp|li) ---*/
 hrr1_build_rp(Libint->AB,int_stack+3216241,int_stack+3888481,int_stack+313600,1260);
 /*--- compute (qd|li) ---*/
 hrr1_build_qd(Libint->AB,int_stack+3613141,int_stack+3216241,int_stack+1091881,1260);
 /*--- compute (of|li) ---*/
 hrr1_build_of(Libint->AB,int_stack+0,int_stack+3613141,int_stack+1435861,1260);
 /*--- compute (ng|li) ---*/
 hrr1_build_ng(Libint->AB,int_stack+6285010,int_stack+0,int_stack+4413910,1260);
 /*--- compute (mh|li) ---*/
 hrr1_build_mh(Libint->AB,int_stack+0,int_stack+6285010,int_stack+5245510,1260);
 /*--- compute (li|li) ---*/
 hrr1_build_li(Libint->AB,int_stack+3216241,int_stack+0,int_stack+2025541,1260);
 return int_stack+3216241;}
