/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lpii(Libint_t*, prim_data*);

  /* Computes quartets of (lp|ii) integrals */

REALTYPE *hrr_order_lpii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][6] = int_stack + 0;
 Libint->vrr_classes[8][7] = int_stack + 1260;
 Libint->vrr_classes[8][8] = int_stack + 2880;
 Libint->vrr_classes[8][9] = int_stack + 4905;
 Libint->vrr_classes[8][10] = int_stack + 7380;
 Libint->vrr_classes[8][11] = int_stack + 10350;
 Libint->vrr_classes[8][12] = int_stack + 13860;
 Libint->vrr_classes[9][6] = int_stack + 17955;
 Libint->vrr_classes[9][7] = int_stack + 19495;
 Libint->vrr_classes[9][8] = int_stack + 21475;
 Libint->vrr_classes[9][9] = int_stack + 23950;
 Libint->vrr_classes[9][10] = int_stack + 26975;
 Libint->vrr_classes[9][11] = int_stack + 30605;
 Libint->vrr_classes[9][12] = int_stack + 34895;
 memset(int_stack,0,39900*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 39900;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lpii(Libint, Data);
   Data++;
 }
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+39900,int_stack+1260,int_stack+0,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+43680,int_stack+2880,int_stack+1260,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+48540,int_stack+43680,int_stack+39900,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+56100,int_stack+4905,int_stack+2880,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+62175,int_stack+56100,int_stack+43680,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+71895,int_stack+62175,int_stack+48540,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+39900,int_stack+7380,int_stack+4905,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+84495,int_stack+39900,int_stack+56100,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+96645,int_stack+84495,int_stack+62175,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+47325,int_stack+96645,int_stack+71895,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+66225,int_stack+10350,int_stack+7380,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+112845,int_stack+66225,int_stack+39900,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+127695,int_stack+112845,int_stack+84495,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+147945,int_stack+127695,int_stack+96645,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+75135,int_stack+147945,int_stack+47325,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+39900,int_stack+13860,int_stack+10350,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+39900,int_stack+66225,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+39900,int_stack+0,int_stack+112845,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+172245,int_stack+39900,int_stack+127695,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+39900,int_stack+172245,int_stack+147945,45);
 /*--- compute (l0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+101595,int_stack+39900,int_stack+75135,45);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+39900,int_stack+19495,int_stack+17955,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+44520,int_stack+21475,int_stack+19495,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+50460,int_stack+44520,int_stack+39900,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+59700,int_stack+23950,int_stack+21475,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+67125,int_stack+59700,int_stack+44520,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+79005,int_stack+67125,int_stack+50460,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+39900,int_stack+26975,int_stack+23950,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+39900,int_stack+59700,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+136875,int_stack+0,int_stack+67125,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+48975,int_stack+136875,int_stack+79005,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+72075,int_stack+30605,int_stack+26975,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+82965,int_stack+72075,int_stack+39900,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+156675,int_stack+82965,int_stack+0,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+156675,int_stack+136875,55);
 /*--- compute (m0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+181425,int_stack+0,int_stack+48975,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+136875,int_stack+34895,int_stack+30605,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+29700,int_stack+136875,int_stack+72075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+51480,int_stack+29700,int_stack+82965,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+213765,int_stack+51480,int_stack+156675,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+29700,int_stack+213765,int_stack+0,55);
 /*--- compute (m0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+136875,int_stack+29700,int_stack+181425,55);
 /*--- compute (lp|ii) ---*/
 hrr1_build_lp(Libint->AB,int_stack+179995,int_stack+136875,int_stack+101595,784);
 return int_stack+179995;}
