/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lpkg(Libint_t*, prim_data*);

  /* Computes quartets of (lp|kg) integrals */

REALTYPE *hrr_order_lpkg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][7] = int_stack + 0;
 Libint->vrr_classes[8][8] = int_stack + 1620;
 Libint->vrr_classes[8][9] = int_stack + 3645;
 Libint->vrr_classes[8][10] = int_stack + 6120;
 Libint->vrr_classes[8][11] = int_stack + 9090;
 Libint->vrr_classes[9][7] = int_stack + 12600;
 Libint->vrr_classes[9][8] = int_stack + 14580;
 Libint->vrr_classes[9][9] = int_stack + 17055;
 Libint->vrr_classes[9][10] = int_stack + 20080;
 Libint->vrr_classes[9][11] = int_stack + 23710;
 memset(int_stack,0,28000*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 28000;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lpkg(Libint, Data);
   Data++;
 }
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+28000,int_stack+1620,int_stack+0,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+32860,int_stack+3645,int_stack+1620,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+38935,int_stack+32860,int_stack+28000,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+48655,int_stack+6120,int_stack+3645,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+56080,int_stack+48655,int_stack+32860,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+68230,int_stack+56080,int_stack+38935,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+28000,int_stack+9090,int_stack+6120,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+84430,int_stack+28000,int_stack+48655,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+28000,int_stack+84430,int_stack+56080,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+84430,int_stack+28000,int_stack+68230,45);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+28000,int_stack+14580,int_stack+12600,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+33940,int_stack+17055,int_stack+14580,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+41365,int_stack+33940,int_stack+28000,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+53245,int_stack+20080,int_stack+17055,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+62320,int_stack+53245,int_stack+33940,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+62320,int_stack+41365,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+28000,int_stack+23710,int_stack+20080,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+108730,int_stack+28000,int_stack+53245,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+19800,int_stack+108730,int_stack+62320,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+44550,int_stack+19800,int_stack+0,55);
 /*--- compute (lp|kg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+108730,int_stack+44550,int_stack+84430,540);
 return int_stack+108730;}
