/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_m0mh(Libint_t*, prim_data*);

  /* Computes quartets of (m0|mh) integrals */

REALTYPE *hrr_order_m0mh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 memset(int_stack,0,28325*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 28325;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_m0mh(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+28325,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37400,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+48290,int_stack+37400,int_stack+28325,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+66440,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+79310,int_stack+66440,int_stack+37400,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+101090,int_stack+79310,int_stack+48290,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+28325,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+131340,int_stack+28325,int_stack+66440,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+157080,int_stack+131340,int_stack+79310,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+43340,int_stack+157080,int_stack+101090,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+88715,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+193380,int_stack+88715,int_stack+28325,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+193380,int_stack+131340,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+88715,int_stack+0,int_stack+157080,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+143165,int_stack+88715,int_stack+43340,55);
 return int_stack+143165;}
