/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mdmg(Libint_t*, prim_data*);

  /* Computes quartets of (md|mg) integrals */

REALTYPE *hrr_order_mdmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[10][9] = int_stack + 21725;
 Libint->vrr_classes[10][10] = int_stack + 25355;
 Libint->vrr_classes[10][11] = int_stack + 29711;
 Libint->vrr_classes[10][12] = int_stack + 34859;
 Libint->vrr_classes[10][13] = int_stack + 40865;
 Libint->vrr_classes[11][9] = int_stack + 47795;
 Libint->vrr_classes[11][10] = int_stack + 52085;
 Libint->vrr_classes[11][11] = int_stack + 57233;
 Libint->vrr_classes[11][12] = int_stack + 63317;
 Libint->vrr_classes[11][13] = int_stack + 70415;
 memset(int_stack,0,78605*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 78605;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mdmg(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+78605,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+87680,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+98570,int_stack+87680,int_stack+78605,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+116720,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+129590,int_stack+116720,int_stack+87680,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+151370,int_stack+129590,int_stack+98570,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+78605,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+181620,int_stack+78605,int_stack+116720,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+78605,int_stack+181620,int_stack+129590,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+181620,int_stack+78605,int_stack+151370,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+78605,int_stack+25355,int_stack+21725,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+89495,int_stack+29711,int_stack+25355,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+102563,int_stack+89495,int_stack+78605,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+124343,int_stack+34859,int_stack+29711,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+139787,int_stack+124343,int_stack+89495,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+226995,int_stack+139787,int_stack+102563,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+78605,int_stack+40865,int_stack+34859,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+78605,int_stack+124343,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+78605,int_stack+0,int_stack+139787,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+122165,int_stack+78605,int_stack+226995,66);
 /*--- compute (mp|mg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+226995,int_stack+122165,int_stack+181620,825);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+78605,int_stack+52085,int_stack+47795,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+91475,int_stack+57233,int_stack+52085,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+91475,int_stack+78605,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+25740,int_stack+63317,int_stack+57233,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+176615,int_stack+25740,int_stack+91475,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+78605,int_stack+176615,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+70415,int_stack+63317,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+363120,int_stack+0,int_stack+25740,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+363120,int_stack+176615,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+363120,int_stack+0,int_stack+78605,78);
 /*--- compute (np|mg) ---*/
 hrr1_build_np(Libint->AB,int_stack+427470,int_stack+363120,int_stack+122165,825);
 /*--- compute (md|mg) ---*/
 hrr1_build_md(Libint->AB,int_stack+590820,int_stack+427470,int_stack+226995,825);
 return int_stack+590820;}
