/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mdmh(Libint_t*, prim_data*);

  /* Computes quartets of (md|mh) integrals */

REALTYPE *hrr_order_mdmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[10][9] = int_stack + 28325;
 Libint->vrr_classes[10][10] = int_stack + 31955;
 Libint->vrr_classes[10][11] = int_stack + 36311;
 Libint->vrr_classes[10][12] = int_stack + 41459;
 Libint->vrr_classes[10][13] = int_stack + 47465;
 Libint->vrr_classes[10][14] = int_stack + 54395;
 Libint->vrr_classes[11][9] = int_stack + 62315;
 Libint->vrr_classes[11][10] = int_stack + 66605;
 Libint->vrr_classes[11][11] = int_stack + 71753;
 Libint->vrr_classes[11][12] = int_stack + 77837;
 Libint->vrr_classes[11][13] = int_stack + 84935;
 Libint->vrr_classes[11][14] = int_stack + 93125;
 memset(int_stack,0,102485*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 102485;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mdmh(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+102485,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+111560,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+122450,int_stack+111560,int_stack+102485,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+140600,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+153470,int_stack+140600,int_stack+111560,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+175250,int_stack+153470,int_stack+122450,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+102485,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+205500,int_stack+102485,int_stack+140600,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+231240,int_stack+205500,int_stack+153470,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+117500,int_stack+231240,int_stack+175250,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+162875,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+267540,int_stack+162875,int_stack+102485,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+297570,int_stack+267540,int_stack+205500,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+162875,int_stack+297570,int_stack+231240,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+217325,int_stack+162875,int_stack+117500,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+102485,int_stack+31955,int_stack+28325,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+113375,int_stack+36311,int_stack+31955,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+126443,int_stack+113375,int_stack+102485,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+148223,int_stack+41459,int_stack+36311,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+163667,int_stack+148223,int_stack+113375,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+280850,int_stack+163667,int_stack+126443,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+102485,int_stack+47465,int_stack+41459,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+102485,int_stack+148223,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+317150,int_stack+0,int_stack+163667,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+120503,int_stack+317150,int_stack+280850,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+280850,int_stack+54395,int_stack+47465,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+174953,int_stack+280850,int_stack+102485,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+360710,int_stack+174953,int_stack+0,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+412190,int_stack+360710,int_stack+317150,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+280850,int_stack+412190,int_stack+120503,66);
 /*--- compute (mp|mh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+357080,int_stack+280850,int_stack+217325,1155);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+66605,int_stack+62315,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+71753,int_stack+66605,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+102485,int_stack+77837,int_stack+71753,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+120737,int_stack+102485,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+151625,int_stack+120737,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+84935,int_stack+77837,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+21294,int_stack+0,int_stack+102485,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+194525,int_stack+21294,int_stack+120737,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+547655,int_stack+194525,int_stack+151625,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+102485,int_stack+93125,int_stack+84935,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+127055,int_stack+102485,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+57798,int_stack+127055,int_stack+21294,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+612005,int_stack+57798,int_stack+194525,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+612005,int_stack+547655,78);
 /*--- compute (np|mh) ---*/
 hrr1_build_np(Libint->AB,int_stack+547655,int_stack+0,int_stack+280850,1155);
 /*--- compute (md|mh) ---*/
 hrr1_build_md(Libint->AB,int_stack+776345,int_stack+547655,int_stack+357080,1155);
 return int_stack+776345;}
