/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mfmi(Libint_t*, prim_data*);

  /* Computes quartets of (mf|mi) integrals */

REALTYPE *hrr_order_mfmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[9][15] = int_stack + 28325;
 Libint->vrr_classes[10][9] = int_stack + 35805;
 Libint->vrr_classes[10][10] = int_stack + 39435;
 Libint->vrr_classes[10][11] = int_stack + 43791;
 Libint->vrr_classes[10][12] = int_stack + 48939;
 Libint->vrr_classes[10][13] = int_stack + 54945;
 Libint->vrr_classes[10][14] = int_stack + 61875;
 Libint->vrr_classes[10][15] = int_stack + 69795;
 Libint->vrr_classes[11][9] = int_stack + 78771;
 Libint->vrr_classes[11][10] = int_stack + 83061;
 Libint->vrr_classes[11][11] = int_stack + 88209;
 Libint->vrr_classes[11][12] = int_stack + 94293;
 Libint->vrr_classes[11][13] = int_stack + 101391;
 Libint->vrr_classes[11][14] = int_stack + 109581;
 Libint->vrr_classes[11][15] = int_stack + 118941;
 Libint->vrr_classes[12][9] = int_stack + 129549;
 Libint->vrr_classes[12][10] = int_stack + 134554;
 Libint->vrr_classes[12][11] = int_stack + 140560;
 Libint->vrr_classes[12][12] = int_stack + 147658;
 Libint->vrr_classes[12][13] = int_stack + 155939;
 Libint->vrr_classes[12][14] = int_stack + 165494;
 Libint->vrr_classes[12][15] = int_stack + 176414;
 memset(int_stack,0,188790*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 188790;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mfmi(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+188790,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+197865,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+208755,int_stack+197865,int_stack+188790,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+226905,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+239775,int_stack+226905,int_stack+197865,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+261555,int_stack+239775,int_stack+208755,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+188790,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+291805,int_stack+188790,int_stack+226905,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+317545,int_stack+291805,int_stack+239775,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+203805,int_stack+317545,int_stack+261555,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+249180,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+353845,int_stack+249180,int_stack+188790,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+383875,int_stack+353845,int_stack+291805,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+426775,int_stack+383875,int_stack+317545,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+266505,int_stack+426775,int_stack+203805,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+188790,int_stack+28325,int_stack+21725,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+208590,int_stack+188790,int_stack+249180,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+481225,int_stack+208590,int_stack+353845,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+188790,int_stack+481225,int_stack+383875,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+330030,int_stack+188790,int_stack+426775,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+406260,int_stack+330030,int_stack+266505,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+188790,int_stack+39435,int_stack+35805,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+199680,int_stack+43791,int_stack+39435,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+212748,int_stack+199680,int_stack+188790,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+234528,int_stack+48939,int_stack+43791,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+249972,int_stack+234528,int_stack+199680,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+276108,int_stack+249972,int_stack+212748,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+188790,int_stack+54945,int_stack+48939,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+312408,int_stack+188790,int_stack+234528,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+343296,int_stack+312408,int_stack+249972,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+206808,int_stack+343296,int_stack+276108,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+261258,int_stack+61875,int_stack+54945,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+490960,int_stack+261258,int_stack+188790,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+490960,int_stack+312408,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+526996,int_stack+0,int_stack+343296,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+282048,int_stack+526996,int_stack+206808,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+188790,int_stack+69795,int_stack+61875,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+212550,int_stack+188790,int_stack+261258,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+592336,int_stack+212550,int_stack+490960,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+188790,int_stack+592336,int_stack+0,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+592336,int_stack+188790,int_stack+526996,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+683812,int_stack+592336,int_stack+282048,66);
 /*--- compute (mp|mi) ---*/
 hrr1_build_mp(Libint->AB,int_stack+785452,int_stack+683812,int_stack+406260,1540);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+188790,int_stack+83061,int_stack+78771,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+201660,int_stack+88209,int_stack+83061,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+217104,int_stack+201660,int_stack+188790,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+242844,int_stack+94293,int_stack+88209,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+261096,int_stack+242844,int_stack+201660,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+291984,int_stack+261096,int_stack+217104,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+188790,int_stack+101391,int_stack+94293,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+334884,int_stack+188790,int_stack+242844,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+371388,int_stack+334884,int_stack+261096,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+210084,int_stack+371388,int_stack+291984,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+274434,int_stack+109581,int_stack+101391,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+422868,int_stack+274434,int_stack+188790,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+465456,int_stack+422868,int_stack+334884,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+526296,int_stack+465456,int_stack+371388,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+299004,int_stack+526296,int_stack+210084,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+188790,int_stack+118941,int_stack+109581,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+216870,int_stack+188790,int_stack+274434,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+603516,int_stack+216870,int_stack+422868,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+188790,int_stack+603516,int_stack+465456,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+389094,int_stack+188790,int_stack+526296,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+497202,int_stack+389094,int_stack+299004,78);
 /*--- compute (np|mi) ---*/
 hrr1_build_np(Libint->AB,int_stack+188790,int_stack+497202,int_stack+683812,1540);
 /*--- compute (md|mi) ---*/
 hrr1_build_md(Libint->AB,int_stack+1039552,int_stack+188790,int_stack+785452,1540);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+617322,int_stack+134554,int_stack+129549,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+632337,int_stack+140560,int_stack+134554,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+650355,int_stack+632337,int_stack+617322,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+680385,int_stack+147658,int_stack+140560,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+701679,int_stack+680385,int_stack+632337,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+737715,int_stack+701679,int_stack+650355,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+617322,int_stack+155939,int_stack+147658,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+787765,int_stack+617322,int_stack+680385,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+830353,int_stack+787765,int_stack+701679,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+642165,int_stack+830353,int_stack+737715,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+717240,int_stack+165494,int_stack+155939,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+890413,int_stack+717240,int_stack+617322,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+940099,int_stack+890413,int_stack+787765,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+940099,int_stack+830353,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+745905,int_stack+0,int_stack+642165,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+617322,int_stack+176414,int_stack+165494,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+650082,int_stack+617322,int_stack+717240,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+90090,int_stack+650082,int_stack+890413,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+617322,int_stack+90090,int_stack+940099,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+851010,int_stack+617322,int_stack+0,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+851010,int_stack+745905,91);
 /*--- compute (op|mi) ---*/
 hrr1_build_op(Libint->AB,int_stack+617322,int_stack+0,int_stack+497202,1540);
 /*--- compute (nd|mi) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1547752,int_stack+617322,int_stack+188790,1540);
 /*--- compute (mf|mi) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+1547752,int_stack+1039552,1540);
 return int_stack+0;}
