/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mfnf(Libint_t*, prim_data*);

  /* Computes quartets of (mf|nf) integrals */

REALTYPE *hrr_order_mfnf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[10][10] = int_stack + 18700;
 Libint->vrr_classes[10][11] = int_stack + 23056;
 Libint->vrr_classes[10][12] = int_stack + 28204;
 Libint->vrr_classes[10][13] = int_stack + 34210;
 Libint->vrr_classes[11][10] = int_stack + 41140;
 Libint->vrr_classes[11][11] = int_stack + 46288;
 Libint->vrr_classes[11][12] = int_stack + 52372;
 Libint->vrr_classes[11][13] = int_stack + 59470;
 Libint->vrr_classes[12][10] = int_stack + 67660;
 Libint->vrr_classes[12][11] = int_stack + 73666;
 Libint->vrr_classes[12][12] = int_stack + 80764;
 Libint->vrr_classes[12][13] = int_stack + 89045;
 memset(int_stack,0,98600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 98600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mfnf(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+98600,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+109490,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+122360,int_stack+109490,int_stack+98600,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+144140,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+159155,int_stack+144140,int_stack+109490,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+184895,int_stack+159155,int_stack+122360,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+98600,int_stack+23056,int_stack+18700,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+111668,int_stack+28204,int_stack+23056,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+127112,int_stack+111668,int_stack+98600,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+153248,int_stack+34210,int_stack+28204,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+153248,int_stack+111668,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+221195,int_stack+0,int_stack+127112,66);
 /*--- compute (mp|nf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+264755,int_stack+221195,int_stack+184895,660);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+46288,int_stack+41140,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+52372,int_stack+46288,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+98600,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+129488,int_stack+59470,int_stack+52372,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+150782,int_stack+129488,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+150782,int_stack+98600,78);
 /*--- compute (np|nf) ---*/
 hrr1_build_np(Libint->AB,int_stack+373655,int_stack+0,int_stack+221195,660);
 /*--- compute (md|nf) ---*/
 hrr1_build_md(Libint->AB,int_stack+504335,int_stack+373655,int_stack+264755,660);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+98600,int_stack+73666,int_stack+67660,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+116618,int_stack+80764,int_stack+73666,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+137912,int_stack+116618,int_stack+98600,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+173948,int_stack+89045,int_stack+80764,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+198791,int_stack+173948,int_stack+116618,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+241379,int_stack+198791,int_stack+137912,91);
 /*--- compute (op|nf) ---*/
 hrr1_build_op(Libint->AB,int_stack+51480,int_stack+241379,int_stack+0,660);
 /*--- compute (nd|nf) ---*/
 hrr1_build_nd(Libint->AB,int_stack+722135,int_stack+51480,int_stack+373655,660);
 /*--- compute (mf|nf) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+722135,int_stack+504335,660);
 return int_stack+0;}
