/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mgli(Libint_t*, prim_data*);

  /* Computes quartets of (mg|li) integrals */

REALTYPE *hrr_order_mgli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[9][12] = int_stack + 13420;
 Libint->vrr_classes[9][13] = int_stack + 18425;
 Libint->vrr_classes[9][14] = int_stack + 24200;
 Libint->vrr_classes[10][8] = int_stack + 30800;
 Libint->vrr_classes[10][9] = int_stack + 33770;
 Libint->vrr_classes[10][10] = int_stack + 37400;
 Libint->vrr_classes[10][11] = int_stack + 41756;
 Libint->vrr_classes[10][12] = int_stack + 46904;
 Libint->vrr_classes[10][13] = int_stack + 52910;
 Libint->vrr_classes[10][14] = int_stack + 59840;
 Libint->vrr_classes[11][8] = int_stack + 67760;
 Libint->vrr_classes[11][9] = int_stack + 71270;
 Libint->vrr_classes[11][10] = int_stack + 75560;
 Libint->vrr_classes[11][11] = int_stack + 80708;
 Libint->vrr_classes[11][12] = int_stack + 86792;
 Libint->vrr_classes[11][13] = int_stack + 93890;
 Libint->vrr_classes[11][14] = int_stack + 102080;
 Libint->vrr_classes[12][8] = int_stack + 111440;
 Libint->vrr_classes[12][9] = int_stack + 115535;
 Libint->vrr_classes[12][10] = int_stack + 120540;
 Libint->vrr_classes[12][11] = int_stack + 126546;
 Libint->vrr_classes[12][12] = int_stack + 133644;
 Libint->vrr_classes[12][13] = int_stack + 141925;
 Libint->vrr_classes[12][14] = int_stack + 151480;
 Libint->vrr_classes[13][8] = int_stack + 162400;
 Libint->vrr_classes[13][9] = int_stack + 167125;
 Libint->vrr_classes[13][10] = int_stack + 172900;
 Libint->vrr_classes[13][11] = int_stack + 179830;
 Libint->vrr_classes[13][12] = int_stack + 188020;
 Libint->vrr_classes[13][13] = int_stack + 197575;
 Libint->vrr_classes[13][14] = int_stack + 208600;
 memset(int_stack,0,221200*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 221200;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mgli(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+221200,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+228625,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+237700,int_stack+228625,int_stack+221200,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+252550,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+263440,int_stack+252550,int_stack+228625,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+281590,int_stack+263440,int_stack+237700,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+221200,int_stack+13420,int_stack+9130,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+306340,int_stack+221200,int_stack+252550,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+328120,int_stack+306340,int_stack+263440,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+234070,int_stack+328120,int_stack+281590,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+271195,int_stack+18425,int_stack+13420,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+358370,int_stack+271195,int_stack+221200,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+384110,int_stack+358370,int_stack+306340,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+420410,int_stack+384110,int_stack+328120,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+286210,int_stack+420410,int_stack+234070,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+221200,int_stack+24200,int_stack+18425,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+238525,int_stack+221200,int_stack+271195,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+465785,int_stack+238525,int_stack+358370,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+221200,int_stack+465785,int_stack+384110,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+338185,int_stack+221200,int_stack+420410,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+401710,int_stack+338185,int_stack+286210,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+221200,int_stack+33770,int_stack+30800,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+230110,int_stack+37400,int_stack+33770,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+241000,int_stack+230110,int_stack+221200,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+258820,int_stack+41756,int_stack+37400,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+271888,int_stack+258820,int_stack+230110,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+293668,int_stack+271888,int_stack+241000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+221200,int_stack+46904,int_stack+41756,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+323368,int_stack+221200,int_stack+258820,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+349504,int_stack+323368,int_stack+271888,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+236644,int_stack+349504,int_stack+293668,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+281194,int_stack+52910,int_stack+46904,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+471010,int_stack+281194,int_stack+221200,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+471010,int_stack+323368,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+501898,int_stack+0,int_stack+349504,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+299212,int_stack+501898,int_stack+236644,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+221200,int_stack+59840,int_stack+52910,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+241990,int_stack+221200,int_stack+281194,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+556348,int_stack+241990,int_stack+471010,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+221200,int_stack+556348,int_stack+0,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+556348,int_stack+221200,int_stack+501898,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+471010,int_stack+556348,int_stack+299212,66);
 /*--- compute (mp|li) ---*/
 hrr1_build_mp(Libint->AB,int_stack+554170,int_stack+471010,int_stack+401710,1260);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+221200,int_stack+71270,int_stack+67760,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+231730,int_stack+75560,int_stack+71270,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+244600,int_stack+231730,int_stack+221200,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+265660,int_stack+80708,int_stack+75560,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+281104,int_stack+265660,int_stack+231730,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+306844,int_stack+281104,int_stack+244600,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+221200,int_stack+86792,int_stack+80708,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+341944,int_stack+221200,int_stack+265660,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+372832,int_stack+341944,int_stack+281104,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+239452,int_stack+372832,int_stack+306844,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+292102,int_stack+93890,int_stack+86792,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+415732,int_stack+292102,int_stack+221200,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+415732,int_stack+341944,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+762070,int_stack+0,int_stack+372832,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+313396,int_stack+762070,int_stack+239452,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+221200,int_stack+102080,int_stack+93890,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+245770,int_stack+221200,int_stack+292102,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+826420,int_stack+245770,int_stack+415732,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+221200,int_stack+826420,int_stack+0,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+221200,int_stack+762070,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+762070,int_stack+0,int_stack+313396,78);
 /*--- compute (np|li) ---*/
 hrr1_build_np(Libint->AB,int_stack+221200,int_stack+762070,int_stack+471010,1260);
 /*--- compute (md|li) ---*/
 hrr1_build_md(Libint->AB,int_stack+860350,int_stack+221200,int_stack+554170,1260);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+115535,int_stack+111440,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12285,int_stack+120540,int_stack+115535,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+27300,int_stack+12285,int_stack+0,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51870,int_stack+126546,int_stack+120540,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+69888,int_stack+51870,int_stack+12285,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+470680,int_stack+69888,int_stack+27300,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+133644,int_stack+126546,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+511630,int_stack+0,int_stack+51870,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+547666,int_stack+511630,int_stack+69888,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+21294,int_stack+547666,int_stack+470680,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+470680,int_stack+141925,int_stack+133644,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+82719,int_stack+470680,int_stack+0,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+597716,int_stack+82719,int_stack+511630,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+657776,int_stack+597716,int_stack+547666,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+495523,int_stack+657776,int_stack+21294,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+151480,int_stack+141925,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+28665,int_stack+0,int_stack+470680,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1276150,int_stack+28665,int_stack+82719,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+1276150,int_stack+597716,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1276150,int_stack+0,int_stack+657776,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+1276150,int_stack+495523,91);
 /*--- compute (op|li) ---*/
 hrr1_build_op(Libint->AB,int_stack+1276150,int_stack+0,int_stack+762070,1260);
 /*--- compute (nd|li) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1570990,int_stack+1276150,int_stack+221200,1260);
 /*--- compute (mf|li) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2069950,int_stack+1570990,int_stack+860350,1260);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+221200,int_stack+167125,int_stack+162400,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+235375,int_stack+172900,int_stack+167125,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+252700,int_stack+235375,int_stack+221200,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+281050,int_stack+179830,int_stack+172900,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+301840,int_stack+281050,int_stack+235375,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+336490,int_stack+301840,int_stack+252700,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+221200,int_stack+188020,int_stack+179830,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+383740,int_stack+221200,int_stack+281050,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+425320,int_stack+383740,int_stack+301840,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+245770,int_stack+425320,int_stack+336490,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+316645,int_stack+197575,int_stack+188020,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+483070,int_stack+316645,int_stack+221200,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+532210,int_stack+483070,int_stack+383740,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+601510,int_stack+532210,int_stack+425320,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+345310,int_stack+601510,int_stack+245770,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+221200,int_stack+208600,int_stack+197575,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+254275,int_stack+221200,int_stack+316645,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+688135,int_stack+254275,int_stack+483070,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+770035,int_stack+688135,int_stack+532210,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+444535,int_stack+770035,int_stack+601510,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+565810,int_stack+444535,int_stack+345310,105);
 /*--- compute (qp|li) ---*/
 hrr1_build_qp(Libint->AB,int_stack+698110,int_stack+565810,int_stack+0,1260);
 /*--- compute (od|li) ---*/
 hrr1_build_od(Libint->AB,int_stack+0,int_stack+698110,int_stack+1276150,1260);
 /*--- compute (nf|li) ---*/
 hrr1_build_nf(Libint->AB,int_stack+589680,int_stack+0,int_stack+1570990,1260);
 /*--- compute (mg|li) ---*/
 hrr1_build_mg(Libint->AB,int_stack+2762950,int_stack+589680,int_stack+2069950,1260);
 return int_stack+2762950;}
