/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mgnk(Libint_t*, prim_data*);

  /* Computes quartets of (mg|nk) integrals */

REALTYPE *hrr_order_mgnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[9][17] = int_stack + 41195;
 Libint->vrr_classes[10][10] = int_stack + 50600;
 Libint->vrr_classes[10][11] = int_stack + 54956;
 Libint->vrr_classes[10][12] = int_stack + 60104;
 Libint->vrr_classes[10][13] = int_stack + 66110;
 Libint->vrr_classes[10][14] = int_stack + 73040;
 Libint->vrr_classes[10][15] = int_stack + 80960;
 Libint->vrr_classes[10][16] = int_stack + 89936;
 Libint->vrr_classes[10][17] = int_stack + 100034;
 Libint->vrr_classes[11][10] = int_stack + 111320;
 Libint->vrr_classes[11][11] = int_stack + 116468;
 Libint->vrr_classes[11][12] = int_stack + 122552;
 Libint->vrr_classes[11][13] = int_stack + 129650;
 Libint->vrr_classes[11][14] = int_stack + 137840;
 Libint->vrr_classes[11][15] = int_stack + 147200;
 Libint->vrr_classes[11][16] = int_stack + 157808;
 Libint->vrr_classes[11][17] = int_stack + 169742;
 Libint->vrr_classes[12][10] = int_stack + 183080;
 Libint->vrr_classes[12][11] = int_stack + 189086;
 Libint->vrr_classes[12][12] = int_stack + 196184;
 Libint->vrr_classes[12][13] = int_stack + 204465;
 Libint->vrr_classes[12][14] = int_stack + 214020;
 Libint->vrr_classes[12][15] = int_stack + 224940;
 Libint->vrr_classes[12][16] = int_stack + 237316;
 Libint->vrr_classes[12][17] = int_stack + 251239;
 Libint->vrr_classes[13][10] = int_stack + 266800;
 Libint->vrr_classes[13][11] = int_stack + 273730;
 Libint->vrr_classes[13][12] = int_stack + 281920;
 Libint->vrr_classes[13][13] = int_stack + 291475;
 Libint->vrr_classes[13][14] = int_stack + 302500;
 Libint->vrr_classes[13][15] = int_stack + 315100;
 Libint->vrr_classes[13][16] = int_stack + 329380;
 Libint->vrr_classes[13][17] = int_stack + 345445;
 memset(int_stack,0,363400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 363400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mgnk(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+363400,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+374290,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+387160,int_stack+374290,int_stack+363400,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+408940,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+423955,int_stack+408940,int_stack+374290,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+449695,int_stack+423955,int_stack+387160,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+363400,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+485995,int_stack+363400,int_stack+408940,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+380725,int_stack+485995,int_stack+423955,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+516025,int_stack+380725,int_stack+449695,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+423625,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+443425,int_stack+423625,int_stack+363400,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+570475,int_stack+443425,int_stack+485995,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+620525,int_stack+570475,int_stack+380725,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+684875,int_stack+620525,int_stack+516025,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+363400,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+478075,int_stack+363400,int_stack+423625,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+761105,int_stack+478075,int_stack+443425,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+385840,int_stack+761105,int_stack+570475,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+517675,int_stack+385840,int_stack+620525,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+818855,int_stack+517675,int_stack+684875,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+607765,int_stack+41195,int_stack+32780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+633010,int_stack+607765,int_stack+363400,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+677890,int_stack+633010,int_stack+478075,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+920495,int_stack+677890,int_stack+761105,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+607765,int_stack+920495,int_stack+385840,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+363400,int_stack+607765,int_stack+517675,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+483520,int_stack+363400,int_stack+818855,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+363400,int_stack+54956,int_stack+50600,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+376468,int_stack+60104,int_stack+54956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+391912,int_stack+376468,int_stack+363400,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+418048,int_stack+66110,int_stack+60104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+436066,int_stack+418048,int_stack+376468,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+614200,int_stack+436066,int_stack+391912,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+363400,int_stack+73040,int_stack+66110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+657760,int_stack+363400,int_stack+418048,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+384190,int_stack+657760,int_stack+436066,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+693796,int_stack+384190,int_stack+614200,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+614200,int_stack+80960,int_stack+73040,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+435670,int_stack+614200,int_stack+363400,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+759136,int_stack+435670,int_stack+657760,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+819196,int_stack+759136,int_stack+384190,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+896416,int_stack+819196,int_stack+693796,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+363400,int_stack+89936,int_stack+80960,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+637960,int_stack+363400,int_stack+614200,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+685480,int_stack+637960,int_stack+435670,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+390328,int_stack+685480,int_stack+759136,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+987892,int_stack+390328,int_stack+819196,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+754780,int_stack+987892,int_stack+896416,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+876748,int_stack+100034,int_stack+89936,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+907042,int_stack+876748,int_stack+363400,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+907042,int_stack+637960,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+876748,int_stack+0,int_stack+685480,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+614200,int_stack+876748,int_stack+390328,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1096000,int_stack+614200,int_stack+987892,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+876748,int_stack+1096000,int_stack+754780,66);
 /*--- compute (mp|nk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1033564,int_stack+876748,int_stack+483520,2376);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+116468,int_stack+111320,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+122552,int_stack+116468,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+129650,int_stack+122552,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+363400,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+137840,int_stack+129650,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+414880,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+414880,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+457468,int_stack+24570,int_stack+363400,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+363400,int_stack+147200,int_stack+137840,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+85410,int_stack+363400,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+534688,int_stack+85410,int_stack+414880,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+605668,int_stack+534688,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+696928,int_stack+605668,int_stack+457468,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+157808,int_stack+147200,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+391480,int_stack+0,int_stack+363400,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+447640,int_stack+391480,int_stack+85410,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+31824,int_stack+447640,int_stack+534688,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1425604,int_stack+31824,int_stack+605668,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+529540,int_stack+1425604,int_stack+696928,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+673684,int_stack+169742,int_stack+157808,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+709486,int_stack+673684,int_stack+0,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+773134,int_stack+709486,int_stack+391480,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1553368,int_stack+773134,int_stack+447640,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+673684,int_stack+1553368,int_stack+31824,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+673684,int_stack+1425604,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1425604,int_stack+0,int_stack+529540,78);
 /*--- compute (np|nk) ---*/
 hrr1_build_np(Libint->AB,int_stack+363400,int_stack+1425604,int_stack+876748,2376);
 /*--- compute (md|nk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1610932,int_stack+363400,int_stack+1033564,2376);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+189086,int_stack+183080,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+196184,int_stack+189086,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+204465,int_stack+196184,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142779,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+214020,int_stack+204465,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+833848,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+833848,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+883534,int_stack+28665,int_stack+142779,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99645,int_stack+224940,int_stack+214020,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+132405,int_stack+99645,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+973624,int_stack+132405,int_stack+833848,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1056434,int_stack+973624,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1162904,int_stack+1056434,int_stack+883534,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+833848,int_stack+237316,int_stack+224940,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+870976,int_stack+833848,int_stack+99645,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+870976,int_stack+132405,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+95550,int_stack+0,int_stack+973624,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2395012,int_stack+95550,int_stack+1056434,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+936496,int_stack+2395012,int_stack+1162904,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1104664,int_stack+251239,int_stack+237316,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1146433,int_stack+1104664,int_stack+833848,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1220689,int_stack+1146433,int_stack+870976,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2544070,int_stack+1220689,int_stack+0,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1104664,int_stack+2544070,int_stack+95550,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1104664,int_stack+2395012,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2395012,int_stack+0,int_stack+936496,91);
 /*--- compute (op|nk) ---*/
 hrr1_build_op(Libint->AB,int_stack+833848,int_stack+2395012,int_stack+1425604,2376);
 /*--- compute (nd|nk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2611228,int_stack+833848,int_stack+363400,2376);
 /*--- compute (mf|nk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3552124,int_stack+2611228,int_stack+1610932,2376);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+363400,int_stack+273730,int_stack+266800,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+384190,int_stack+281920,int_stack+273730,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+408760,int_stack+384190,int_stack+363400,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+450340,int_stack+291475,int_stack+281920,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+479005,int_stack+450340,int_stack+384190,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+528145,int_stack+479005,int_stack+408760,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+363400,int_stack+302500,int_stack+291475,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+597445,int_stack+363400,int_stack+450340,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+396475,int_stack+597445,int_stack+479005,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+654775,int_stack+396475,int_stack+528145,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+478375,int_stack+315100,int_stack+302500,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+516175,int_stack+478375,int_stack+363400,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+516175,int_stack+597445,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+95550,int_stack+0,int_stack+396475,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1389832,int_stack+95550,int_stack+654775,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+363400,int_stack+329380,int_stack+315100,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+582325,int_stack+363400,int_stack+478375,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+657925,int_stack+582325,int_stack+516175,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+406240,int_stack+657925,int_stack+0,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1535362,int_stack+406240,int_stack+95550,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1535362,int_stack+1389832,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1389832,int_stack+345445,int_stack+329380,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1438027,int_stack+1389832,int_stack+363400,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+194040,int_stack+1438027,int_stack+582325,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1707352,int_stack+194040,int_stack+657925,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+194040,int_stack+1707352,int_stack+406240,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1707352,int_stack+194040,int_stack+1535362,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+194040,int_stack+1707352,int_stack+0,105);
 /*--- compute (qp|nk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1389832,int_stack+194040,int_stack+2395012,2376);
 /*--- compute (od|nk) ---*/
 hrr1_build_od(Libint->AB,int_stack+4858924,int_stack+1389832,int_stack+833848,2376);
 /*--- compute (nf|nk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+4858924,int_stack+2611228,2376);
 /*--- compute (mg|nk) ---*/
 hrr1_build_mg(Libint->AB,int_stack+1568160,int_stack+0,int_stack+3552124,2376);
 return int_stack+1568160;}
