/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mhmm(Libint_t*, prim_data*);

  /* Computes quartets of (mh|mm) integrals */

REALTYPE *hrr_order_mhmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[9][15] = int_stack + 28325;
 Libint->vrr_classes[9][16] = int_stack + 35805;
 Libint->vrr_classes[9][17] = int_stack + 44220;
 Libint->vrr_classes[9][18] = int_stack + 53625;
 Libint->vrr_classes[10][9] = int_stack + 64075;
 Libint->vrr_classes[10][10] = int_stack + 67705;
 Libint->vrr_classes[10][11] = int_stack + 72061;
 Libint->vrr_classes[10][12] = int_stack + 77209;
 Libint->vrr_classes[10][13] = int_stack + 83215;
 Libint->vrr_classes[10][14] = int_stack + 90145;
 Libint->vrr_classes[10][15] = int_stack + 98065;
 Libint->vrr_classes[10][16] = int_stack + 107041;
 Libint->vrr_classes[10][17] = int_stack + 117139;
 Libint->vrr_classes[10][18] = int_stack + 128425;
 Libint->vrr_classes[11][9] = int_stack + 140965;
 Libint->vrr_classes[11][10] = int_stack + 145255;
 Libint->vrr_classes[11][11] = int_stack + 150403;
 Libint->vrr_classes[11][12] = int_stack + 156487;
 Libint->vrr_classes[11][13] = int_stack + 163585;
 Libint->vrr_classes[11][14] = int_stack + 171775;
 Libint->vrr_classes[11][15] = int_stack + 181135;
 Libint->vrr_classes[11][16] = int_stack + 191743;
 Libint->vrr_classes[11][17] = int_stack + 203677;
 Libint->vrr_classes[11][18] = int_stack + 217015;
 Libint->vrr_classes[12][9] = int_stack + 231835;
 Libint->vrr_classes[12][10] = int_stack + 236840;
 Libint->vrr_classes[12][11] = int_stack + 242846;
 Libint->vrr_classes[12][12] = int_stack + 249944;
 Libint->vrr_classes[12][13] = int_stack + 258225;
 Libint->vrr_classes[12][14] = int_stack + 267780;
 Libint->vrr_classes[12][15] = int_stack + 278700;
 Libint->vrr_classes[12][16] = int_stack + 291076;
 Libint->vrr_classes[12][17] = int_stack + 304999;
 Libint->vrr_classes[12][18] = int_stack + 320560;
 Libint->vrr_classes[13][9] = int_stack + 337850;
 Libint->vrr_classes[13][10] = int_stack + 343625;
 Libint->vrr_classes[13][11] = int_stack + 350555;
 Libint->vrr_classes[13][12] = int_stack + 358745;
 Libint->vrr_classes[13][13] = int_stack + 368300;
 Libint->vrr_classes[13][14] = int_stack + 379325;
 Libint->vrr_classes[13][15] = int_stack + 391925;
 Libint->vrr_classes[13][16] = int_stack + 406205;
 Libint->vrr_classes[13][17] = int_stack + 422270;
 Libint->vrr_classes[13][18] = int_stack + 440225;
 Libint->vrr_classes[14][9] = int_stack + 460175;
 Libint->vrr_classes[14][10] = int_stack + 466775;
 Libint->vrr_classes[14][11] = int_stack + 474695;
 Libint->vrr_classes[14][12] = int_stack + 484055;
 Libint->vrr_classes[14][13] = int_stack + 494975;
 Libint->vrr_classes[14][14] = int_stack + 507575;
 Libint->vrr_classes[14][15] = int_stack + 521975;
 Libint->vrr_classes[14][16] = int_stack + 538295;
 Libint->vrr_classes[14][17] = int_stack + 556655;
 Libint->vrr_classes[14][18] = int_stack + 577175;
 memset(int_stack,0,599975*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 599975;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mhmm(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+599975,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+609050,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+619940,int_stack+609050,int_stack+599975,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+638090,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+650960,int_stack+638090,int_stack+609050,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+672740,int_stack+650960,int_stack+619940,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+599975,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+702990,int_stack+599975,int_stack+638090,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+728730,int_stack+702990,int_stack+650960,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+614990,int_stack+728730,int_stack+672740,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+660365,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+765030,int_stack+660365,int_stack+599975,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+795060,int_stack+765030,int_stack+702990,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+837960,int_stack+795060,int_stack+728730,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+677690,int_stack+837960,int_stack+614990,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+599975,int_stack+28325,int_stack+21725,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+619775,int_stack+599975,int_stack+660365,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+892410,int_stack+619775,int_stack+765030,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+942460,int_stack+892410,int_stack+795060,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+741215,int_stack+942460,int_stack+837960,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1006810,int_stack+741215,int_stack+677690,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+654425,int_stack+35805,int_stack+28325,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+676865,int_stack+654425,int_stack+599975,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+817445,int_stack+676865,int_stack+619775,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1091510,int_stack+817445,int_stack+892410,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1166585,int_stack+1091510,int_stack+942460,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+875195,int_stack+1166585,int_stack+741215,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1256675,int_stack+875195,int_stack+1006810,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+599975,int_stack+44220,int_stack+35805,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+716465,int_stack+599975,int_stack+654425,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+976835,int_stack+716465,int_stack+676865,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+625220,int_stack+976835,int_stack+817445,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+761345,int_stack+625220,int_stack+1091510,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1042835,int_stack+761345,int_stack+1166585,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1365575,int_stack+1042835,int_stack+875195,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1496255,int_stack+1365575,int_stack+1256675,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+866450,int_stack+53625,int_stack+44220,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+894665,int_stack+866450,int_stack+599975,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1162955,int_stack+894665,int_stack+716465,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+866450,int_stack+1162955,int_stack+976835,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1162955,int_stack+866450,int_stack+625220,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+866450,int_stack+1162955,int_stack+761345,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1162955,int_stack+866450,int_stack+1042835,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+599975,int_stack+1162955,int_stack+1365575,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+763325,int_stack+599975,int_stack+1496255,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+599975,int_stack+67705,int_stack+64075,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+610865,int_stack+72061,int_stack+67705,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+623933,int_stack+610865,int_stack+599975,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+645713,int_stack+77209,int_stack+72061,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+661157,int_stack+645713,int_stack+610865,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+687293,int_stack+661157,int_stack+623933,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+599975,int_stack+83215,int_stack+77209,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+723593,int_stack+599975,int_stack+645713,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+929700,int_stack+723593,int_stack+661157,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+617993,int_stack+929700,int_stack+687293,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+672443,int_stack+90145,int_stack+83215,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+973260,int_stack+672443,int_stack+599975,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1009296,int_stack+973260,int_stack+723593,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+693233,int_stack+1009296,int_stack+929700,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1060776,int_stack+693233,int_stack+617993,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+929700,int_stack+98065,int_stack+90145,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+599975,int_stack+929700,int_stack+672443,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1137006,int_stack+599975,int_stack+973260,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1197066,int_stack+1137006,int_stack+1009296,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+953460,int_stack+1197066,int_stack+693233,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+641555,int_stack+953460,int_stack+1060776,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1044936,int_stack+107041,int_stack+98065,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1071864,int_stack+1044936,int_stack+929700,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1274286,int_stack+1071864,int_stack+599975,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1343586,int_stack+1274286,int_stack+1137006,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1433676,int_stack+1343586,int_stack+1197066,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1119384,int_stack+1433676,int_stack+953460,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1541784,int_stack+1119384,int_stack+641555,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+599975,int_stack+117139,int_stack+107041,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+630269,int_stack+599975,int_stack+1044936,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+684125,int_stack+630269,int_stack+1071864,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+929700,int_stack+684125,int_stack+1274286,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1672464,int_stack+929700,int_stack+1343586,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1241352,int_stack+1672464,int_stack+1433676,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1798590,int_stack+1241352,int_stack+1119384,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1033650,int_stack+1798590,int_stack+1541784,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1197000,int_stack+128425,int_stack+117139,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1385496,int_stack+1197000,int_stack+599975,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1446084,int_stack+1385496,int_stack+630269,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1535844,int_stack+1446084,int_stack+684125,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1385496,int_stack+1535844,int_stack+929700,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1955406,int_stack+1385496,int_stack+1672464,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1385496,int_stack+1955406,int_stack+1241352,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1570824,int_stack+1385496,int_stack+1798590,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1766844,int_stack+1570824,int_stack+1033650,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+929700,int_stack+1766844,int_stack+763325,3025);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1966494,int_stack+145255,int_stack+140965,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1979364,int_stack+150403,int_stack+145255,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1994808,int_stack+1979364,int_stack+1966494,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2020548,int_stack+156487,int_stack+150403,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2038800,int_stack+2020548,int_stack+1979364,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2069688,int_stack+2038800,int_stack+1994808,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1966494,int_stack+163585,int_stack+156487,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1428825,int_stack+1966494,int_stack+2020548,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1465329,int_stack+1428825,int_stack+2038800,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1987788,int_stack+1465329,int_stack+2069688,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2052138,int_stack+171775,int_stack+163585,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2076708,int_stack+2052138,int_stack+1966494,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1516809,int_stack+2076708,int_stack+1428825,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1577649,int_stack+1516809,int_stack+1465329,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1654869,int_stack+1577649,int_stack+1987788,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1428825,int_stack+181135,int_stack+171775,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1456905,int_stack+1428825,int_stack+2052138,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1966494,int_stack+1456905,int_stack+2076708,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+599975,int_stack+1966494,int_stack+1516809,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+691235,int_stack+599975,int_stack+1577649,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1506045,int_stack+691235,int_stack+1654869,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1626165,int_stack+191743,int_stack+181135,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1657989,int_stack+1626165,int_stack+1428825,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2037474,int_stack+1657989,int_stack+1456905,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+799343,int_stack+2037474,int_stack+1966494,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+799343,int_stack+599975,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2119374,int_stack+0,int_stack+691235,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+599975,int_stack+2119374,int_stack+1506045,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+754415,int_stack+203677,int_stack+191743,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1966494,int_stack+754415,int_stack+1626165,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1428825,int_stack+1966494,int_stack+1657989,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1522425,int_stack+1428825,int_stack+2037474,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2263518,int_stack+1522425,int_stack+799343,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2412576,int_stack+2263518,int_stack+0,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2412576,int_stack+2119374,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2030142,int_stack+0,int_stack+599975,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+599975,int_stack+217015,int_stack+203677,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+639989,int_stack+599975,int_stack+754415,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+711593,int_stack+639989,int_stack+1966494,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2582928,int_stack+711593,int_stack+1428825,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+599975,int_stack+2582928,int_stack+1522425,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1428825,int_stack+599975,int_stack+2263518,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+599975,int_stack+1428825,int_stack+2412576,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1428825,int_stack+599975,int_stack+0,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+599975,int_stack+1428825,int_stack+2030142,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+1966494,int_stack+599975,int_stack+1766844,3025);
 /*--- compute (md|mm) ---*/
 hrr1_build_md(Libint->AB,int_stack+2565444,int_stack+1966494,int_stack+929700,3025);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+236840,int_stack+231835,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+242846,int_stack+236840,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+249944,int_stack+242846,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+120393,int_stack+84357,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+258225,int_stack+249944,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+170443,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+835925,int_stack+170443,int_stack+84357,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+24843,int_stack+835925,int_stack+120393,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+99918,int_stack+267780,int_stack+258225,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+213031,int_stack+99918,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+895985,int_stack+213031,int_stack+170443,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+966965,int_stack+895985,int_stack+835925,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1057055,int_stack+966965,int_stack+24843,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+835925,int_stack+278700,int_stack+267780,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+835925,int_stack+99918,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+57330,int_stack+0,int_stack+213031,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+140140,int_stack+57330,int_stack+895985,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1162160,int_stack+140140,int_stack+966965,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+868685,int_stack+1162160,int_stack+1057055,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1008825,int_stack+291076,int_stack+278700,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1045953,int_stack+1008825,int_stack+835925,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1288286,int_stack+1045953,int_stack+0,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1383836,int_stack+1288286,int_stack+57330,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1508051,int_stack+1383836,int_stack+140140,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1508051,int_stack+1162160,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1657109,int_stack+0,int_stack+868685,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+168168,int_stack+304999,int_stack+291076,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+209937,int_stack+168168,int_stack+1008825,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+835925,int_stack+209937,int_stack+1045953,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+945125,int_stack+835925,int_stack+1288286,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1088450,int_stack+945125,int_stack+1383836,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1262351,int_stack+1088450,int_stack+1508051,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3563694,int_stack+1262351,int_stack+0,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3779910,int_stack+3563694,int_stack+1657109,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+320560,int_stack+304999,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+46683,int_stack+0,int_stack+168168,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1461095,int_stack+46683,int_stack+209937,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+1461095,int_stack+835925,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1461095,int_stack+0,int_stack+945125,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+1461095,int_stack+1088450,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1461095,int_stack+0,int_stack+1262351,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1461095,int_stack+3563694,91);
 /*--- compute (q0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+835925,int_stack+0,int_stack+3779910,91);
 /*--- compute (op|mm) ---*/
 hrr1_build_op(Libint->AB,int_stack+1111200,int_stack+835925,int_stack+599975,3025);
 /*--- compute (nd|mm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3563694,int_stack+1111200,int_stack+1966494,3025);
 /*--- compute (mf|mm) ---*/
 hrr1_build_mf(Libint->AB,int_stack+4761594,int_stack+3563694,int_stack+2565444,3025);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+599975,int_stack+343625,int_stack+337850,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+617300,int_stack+350555,int_stack+343625,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+638090,int_stack+617300,int_stack+599975,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+672740,int_stack+358745,int_stack+350555,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+697310,int_stack+672740,int_stack+617300,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+738890,int_stack+697310,int_stack+638090,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+599975,int_stack+368300,int_stack+358745,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+599975,int_stack+672740,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+49140,int_stack+0,int_stack+697310,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+628640,int_stack+49140,int_stack+738890,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+715265,int_stack+379325,int_stack+368300,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+748340,int_stack+715265,int_stack+599975,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+118440,int_stack+748340,int_stack+0,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+200340,int_stack+118440,int_stack+49140,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1819050,int_stack+200340,int_stack+628640,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+391925,int_stack+379325,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+37800,int_stack+0,int_stack+715265,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+599975,int_stack+37800,int_stack+748340,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+695525,int_stack+599975,int_stack+118440,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1940325,int_stack+695525,int_stack+200340,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+103950,int_stack+1940325,int_stack+1819050,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1819050,int_stack+406205,int_stack+391925,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1861890,int_stack+1819050,int_stack+0,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+265650,int_stack+1861890,int_stack+37800,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2085855,int_stack+265650,int_stack+599975,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2229180,int_stack+2085855,int_stack+695525,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+599975,int_stack+2229180,int_stack+1940325,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2401170,int_stack+599975,int_stack+103950,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+422270,int_stack+406205,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+48195,int_stack+0,int_stack+1819050,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+133875,int_stack+48195,int_stack+1861890,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1819050,int_stack+133875,int_stack+265650,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2609070,int_stack+1819050,int_stack+2085855,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1984425,int_stack+2609070,int_stack+2229180,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2809725,int_stack+1984425,int_stack+599975,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3059205,int_stack+2809725,int_stack+2401170,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+599975,int_stack+440225,int_stack+422270,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+653840,int_stack+599975,int_stack+0,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2213745,int_stack+653840,int_stack+48195,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+599975,int_stack+2213745,int_stack+133875,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2213745,int_stack+599975,int_stack+1819050,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+2213745,int_stack+2609070,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2213745,int_stack+0,int_stack+1984425,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+2213745,int_stack+2809725,105);
 /*--- compute (r0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1819050,int_stack+0,int_stack+3059205,105);
 /*--- compute (qp|mm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2136675,int_stack+1819050,int_stack+835925,3025);
 /*--- compute (od|mm) ---*/
 hrr1_build_od(Libint->AB,int_stack+6425344,int_stack+2136675,int_stack+1111200,3025);
 /*--- compute (nf|mm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+7841044,int_stack+6425344,int_stack+3563694,3025);
 /*--- compute (mg|mm) ---*/
 hrr1_build_mg(Libint->AB,int_stack+9837544,int_stack+7841044,int_stack+4761594,3025);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+466775,int_stack+460175,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+19800,int_stack+474695,int_stack+466775,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+43560,int_stack+19800,int_stack+0,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+83160,int_stack+484055,int_stack+474695,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+111240,int_stack+83160,int_stack+19800,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+158760,int_stack+111240,int_stack+43560,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+494975,int_stack+484055,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+224760,int_stack+0,int_stack+83160,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+280920,int_stack+224760,int_stack+111240,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+32760,int_stack+280920,int_stack+158760,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+131760,int_stack+507575,int_stack+494975,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+360120,int_stack+131760,int_stack+0,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2962500,int_stack+360120,int_stack+224760,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3056100,int_stack+2962500,int_stack+280920,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+169560,int_stack+3056100,int_stack+32760,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+521975,int_stack+507575,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+43200,int_stack+0,int_stack+131760,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3174900,int_stack+43200,int_stack+360120,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+308160,int_stack+3174900,int_stack+2962500,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3284100,int_stack+308160,int_stack+3056100,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2962500,int_stack+3284100,int_stack+169560,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+118800,int_stack+538295,int_stack+521975,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+167760,int_stack+118800,int_stack+0,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3450420,int_stack+167760,int_stack+43200,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+3576420,int_stack+3450420,int_stack+3174900,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3740220,int_stack+3576420,int_stack+308160,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+254160,int_stack+3740220,int_stack+3284100,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+3147300,int_stack+254160,int_stack+2962500,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2962500,int_stack+556655,int_stack+538295,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3017580,int_stack+2962500,int_stack+118800,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+3017580,int_stack+167760,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3936780,int_stack+0,int_stack+3450420,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+4125780,int_stack+3936780,int_stack+3576420,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3384900,int_stack+4125780,int_stack+3740220,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3646980,int_stack+3384900,int_stack+254160,120);
 /*--- compute (t0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+144000,int_stack+3646980,int_stack+3147300,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+3115500,int_stack+577175,int_stack+556655,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+3177060,int_stack+3115500,int_stack+2962500,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+441000,int_stack+3177060,int_stack+3017580,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2962500,int_stack+441000,int_stack+0,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+441000,int_stack+2962500,int_stack+3936780,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2962500,int_stack+441000,int_stack+4125780,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+441000,int_stack+2962500,int_stack+3384900,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2962500,int_stack+441000,int_stack+3646980,120);
 /*--- compute (t0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+441000,int_stack+2962500,int_stack+144000,120);
 /*--- compute (rp|mm) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2962500,int_stack+441000,int_stack+1819050,3025);
 /*--- compute (qd|mm) ---*/
 hrr1_build_qd(Libint->AB,int_stack+3915375,int_stack+2962500,int_stack+2136675,3025);
 /*--- compute (of|mm) ---*/
 hrr1_build_of(Libint->AB,int_stack+0,int_stack+3915375,int_stack+6425344,3025);
 /*--- compute (ng|mm) ---*/
 hrr1_build_ng(Libint->AB,int_stack+2359500,int_stack+0,int_stack+7841044,3025);
 /*--- compute (mh|mm) ---*/
 hrr1_build_mh(Libint->AB,int_stack+5354250,int_stack+2359500,int_stack+9837544,3025);
 return int_stack+5354250;}
