/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mhnh(Libint_t*, prim_data*);

  /* Computes quartets of (mh|nh) integrals */

REALTYPE *hrr_order_mhnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[10][10] = int_stack + 32780;
 Libint->vrr_classes[10][11] = int_stack + 37136;
 Libint->vrr_classes[10][12] = int_stack + 42284;
 Libint->vrr_classes[10][13] = int_stack + 48290;
 Libint->vrr_classes[10][14] = int_stack + 55220;
 Libint->vrr_classes[10][15] = int_stack + 63140;
 Libint->vrr_classes[11][10] = int_stack + 72116;
 Libint->vrr_classes[11][11] = int_stack + 77264;
 Libint->vrr_classes[11][12] = int_stack + 83348;
 Libint->vrr_classes[11][13] = int_stack + 90446;
 Libint->vrr_classes[11][14] = int_stack + 98636;
 Libint->vrr_classes[11][15] = int_stack + 107996;
 Libint->vrr_classes[12][10] = int_stack + 118604;
 Libint->vrr_classes[12][11] = int_stack + 124610;
 Libint->vrr_classes[12][12] = int_stack + 131708;
 Libint->vrr_classes[12][13] = int_stack + 139989;
 Libint->vrr_classes[12][14] = int_stack + 149544;
 Libint->vrr_classes[12][15] = int_stack + 160464;
 Libint->vrr_classes[13][10] = int_stack + 172840;
 Libint->vrr_classes[13][11] = int_stack + 179770;
 Libint->vrr_classes[13][12] = int_stack + 187960;
 Libint->vrr_classes[13][13] = int_stack + 197515;
 Libint->vrr_classes[13][14] = int_stack + 208540;
 Libint->vrr_classes[13][15] = int_stack + 221140;
 Libint->vrr_classes[14][10] = int_stack + 235420;
 Libint->vrr_classes[14][11] = int_stack + 243340;
 Libint->vrr_classes[14][12] = int_stack + 252700;
 Libint->vrr_classes[14][13] = int_stack + 263620;
 Libint->vrr_classes[14][14] = int_stack + 276220;
 Libint->vrr_classes[14][15] = int_stack + 290620;
 memset(int_stack,0,306940*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 306940;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mhnh(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+306940,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+317830,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+330700,int_stack+317830,int_stack+306940,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+352480,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+367495,int_stack+352480,int_stack+317830,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+393235,int_stack+367495,int_stack+330700,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+306940,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+429535,int_stack+306940,int_stack+352480,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+324265,int_stack+429535,int_stack+367495,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+459565,int_stack+324265,int_stack+393235,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+367165,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+386965,int_stack+367165,int_stack+306940,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+514015,int_stack+386965,int_stack+429535,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+367165,int_stack+514015,int_stack+324265,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+514015,int_stack+367165,int_stack+459565,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+306940,int_stack+37136,int_stack+32780,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+320008,int_stack+42284,int_stack+37136,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+335452,int_stack+320008,int_stack+306940,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+361588,int_stack+48290,int_stack+42284,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+379606,int_stack+361588,int_stack+320008,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+410494,int_stack+379606,int_stack+335452,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+306940,int_stack+55220,int_stack+48290,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+454054,int_stack+306940,int_stack+361588,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+327730,int_stack+454054,int_stack+379606,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+590245,int_stack+327730,int_stack+410494,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+379210,int_stack+63140,int_stack+55220,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+402970,int_stack+379210,int_stack+306940,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+402970,int_stack+454054,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+379210,int_stack+0,int_stack+327730,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+655585,int_stack+379210,int_stack+590245,66);
 /*--- compute (mp|nh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+747061,int_stack+655585,int_stack+514015,1386);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+77264,int_stack+72116,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+83348,int_stack+77264,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+306940,int_stack+90446,int_stack+83348,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+328234,int_stack+306940,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+364738,int_stack+328234,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+98636,int_stack+90446,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+24570,int_stack+0,int_stack+306940,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+416218,int_stack+24570,int_stack+328234,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+477058,int_stack+416218,int_stack+364738,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+306940,int_stack+107996,int_stack+98636,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+335020,int_stack+306940,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+554278,int_stack+335020,int_stack+24570,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+554278,int_stack+416218,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+306940,int_stack+0,int_stack+477058,78);
 /*--- compute (np|nh) ---*/
 hrr1_build_np(Libint->AB,int_stack+975751,int_stack+306940,int_stack+655585,1386);
 /*--- compute (md|nh) ---*/
 hrr1_build_md(Libint->AB,int_stack+1250179,int_stack+975751,int_stack+747061,1386);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+124610,int_stack+118604,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+131708,int_stack+124610,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+139989,int_stack+131708,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+415048,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+457636,int_stack+415048,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+149544,int_stack+139989,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+517696,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+517696,int_stack+415048,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+567382,int_stack+28665,int_stack+457636,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+415048,int_stack+160464,int_stack+149544,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+447808,int_stack+415048,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+657472,int_stack+447808,int_stack+517696,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+415048,int_stack+657472,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+657472,int_stack+415048,int_stack+567382,91);
 /*--- compute (op|nh) ---*/
 hrr1_build_op(Libint->AB,int_stack+1707559,int_stack+657472,int_stack+306940,1386);
 /*--- compute (nd|nh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2031883,int_stack+1707559,int_stack+975751,1386);
 /*--- compute (mf|nh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2580739,int_stack+2031883,int_stack+1250179,1386);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+306940,int_stack+179770,int_stack+172840,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+327730,int_stack+187960,int_stack+179770,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+352300,int_stack+327730,int_stack+306940,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+393880,int_stack+197515,int_stack+187960,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+422545,int_stack+393880,int_stack+327730,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+471685,int_stack+422545,int_stack+352300,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+306940,int_stack+208540,int_stack+197515,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+540985,int_stack+306940,int_stack+393880,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+340015,int_stack+540985,int_stack+422545,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+783598,int_stack+340015,int_stack+471685,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+421915,int_stack+221140,int_stack+208540,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+459715,int_stack+421915,int_stack+306940,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+887548,int_stack+459715,int_stack+540985,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+421915,int_stack+887548,int_stack+340015,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+887548,int_stack+421915,int_stack+783598,105);
 /*--- compute (qp|nh) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1033078,int_stack+887548,int_stack+657472,1386);
 /*--- compute (od|nh) ---*/
 hrr1_build_od(Libint->AB,int_stack+3343039,int_stack+1033078,int_stack+1707559,1386);
 /*--- compute (nf|nh) ---*/
 hrr1_build_nf(Libint->AB,int_stack+3991687,int_stack+3343039,int_stack+2031883,1386);
 /*--- compute (mg|nh) ---*/
 hrr1_build_mg(Libint->AB,int_stack+1411456,int_stack+3991687,int_stack+2580739,1386);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2554906,int_stack+243340,int_stack+235420,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2578666,int_stack+252700,int_stack+243340,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2606746,int_stack+2578666,int_stack+2554906,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2654266,int_stack+263620,int_stack+252700,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2687026,int_stack+2654266,int_stack+2578666,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2743186,int_stack+2687026,int_stack+2606746,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2554906,int_stack+276220,int_stack+263620,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2822386,int_stack+2554906,int_stack+2654266,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2592706,int_stack+2822386,int_stack+2687026,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2887906,int_stack+2592706,int_stack+2743186,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2686306,int_stack+290620,int_stack+276220,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2729506,int_stack+2686306,int_stack+2554906,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3006706,int_stack+2729506,int_stack+2822386,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2686306,int_stack+3006706,int_stack+2592706,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3006706,int_stack+2686306,int_stack+2887906,120);
 /*--- compute (rp|nh) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2554906,int_stack+3006706,int_stack+887548,1386);
 /*--- compute (qd|nh) ---*/
 hrr1_build_qd(Libint->AB,int_stack+0,int_stack+2554906,int_stack+1033078,1386);
 /*--- compute (of|nh) ---*/
 hrr1_build_of(Libint->AB,int_stack+4906447,int_stack+0,int_stack+3343039,1386);
 /*--- compute (ng|nh) ---*/
 hrr1_build_ng(Libint->AB,int_stack+0,int_stack+4906447,int_stack+3991687,1386);
 /*--- compute (mh|nh) ---*/
 hrr1_build_mh(Libint->AB,int_stack+2554906,int_stack+0,int_stack+1411456,1386);
 return int_stack+2554906;}
