/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mlmm(Libint_t*, prim_data*);

  /* Computes quartets of (ml|mm) integrals */

REALTYPE *hrr_order_mlmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[9][15] = int_stack + 28325;
 Libint->vrr_classes[9][16] = int_stack + 35805;
 Libint->vrr_classes[9][17] = int_stack + 44220;
 Libint->vrr_classes[9][18] = int_stack + 53625;
 Libint->vrr_classes[10][9] = int_stack + 64075;
 Libint->vrr_classes[10][10] = int_stack + 67705;
 Libint->vrr_classes[10][11] = int_stack + 72061;
 Libint->vrr_classes[10][12] = int_stack + 77209;
 Libint->vrr_classes[10][13] = int_stack + 83215;
 Libint->vrr_classes[10][14] = int_stack + 90145;
 Libint->vrr_classes[10][15] = int_stack + 98065;
 Libint->vrr_classes[10][16] = int_stack + 107041;
 Libint->vrr_classes[10][17] = int_stack + 117139;
 Libint->vrr_classes[10][18] = int_stack + 128425;
 Libint->vrr_classes[11][9] = int_stack + 140965;
 Libint->vrr_classes[11][10] = int_stack + 145255;
 Libint->vrr_classes[11][11] = int_stack + 150403;
 Libint->vrr_classes[11][12] = int_stack + 156487;
 Libint->vrr_classes[11][13] = int_stack + 163585;
 Libint->vrr_classes[11][14] = int_stack + 171775;
 Libint->vrr_classes[11][15] = int_stack + 181135;
 Libint->vrr_classes[11][16] = int_stack + 191743;
 Libint->vrr_classes[11][17] = int_stack + 203677;
 Libint->vrr_classes[11][18] = int_stack + 217015;
 Libint->vrr_classes[12][9] = int_stack + 231835;
 Libint->vrr_classes[12][10] = int_stack + 236840;
 Libint->vrr_classes[12][11] = int_stack + 242846;
 Libint->vrr_classes[12][12] = int_stack + 249944;
 Libint->vrr_classes[12][13] = int_stack + 258225;
 Libint->vrr_classes[12][14] = int_stack + 267780;
 Libint->vrr_classes[12][15] = int_stack + 278700;
 Libint->vrr_classes[12][16] = int_stack + 291076;
 Libint->vrr_classes[12][17] = int_stack + 304999;
 Libint->vrr_classes[12][18] = int_stack + 320560;
 Libint->vrr_classes[13][9] = int_stack + 337850;
 Libint->vrr_classes[13][10] = int_stack + 343625;
 Libint->vrr_classes[13][11] = int_stack + 350555;
 Libint->vrr_classes[13][12] = int_stack + 358745;
 Libint->vrr_classes[13][13] = int_stack + 368300;
 Libint->vrr_classes[13][14] = int_stack + 379325;
 Libint->vrr_classes[13][15] = int_stack + 391925;
 Libint->vrr_classes[13][16] = int_stack + 406205;
 Libint->vrr_classes[13][17] = int_stack + 422270;
 Libint->vrr_classes[13][18] = int_stack + 440225;
 Libint->vrr_classes[14][9] = int_stack + 460175;
 Libint->vrr_classes[14][10] = int_stack + 466775;
 Libint->vrr_classes[14][11] = int_stack + 474695;
 Libint->vrr_classes[14][12] = int_stack + 484055;
 Libint->vrr_classes[14][13] = int_stack + 494975;
 Libint->vrr_classes[14][14] = int_stack + 507575;
 Libint->vrr_classes[14][15] = int_stack + 521975;
 Libint->vrr_classes[14][16] = int_stack + 538295;
 Libint->vrr_classes[14][17] = int_stack + 556655;
 Libint->vrr_classes[14][18] = int_stack + 577175;
 Libint->vrr_classes[15][9] = int_stack + 599975;
 Libint->vrr_classes[15][10] = int_stack + 607455;
 Libint->vrr_classes[15][11] = int_stack + 616431;
 Libint->vrr_classes[15][12] = int_stack + 627039;
 Libint->vrr_classes[15][13] = int_stack + 639415;
 Libint->vrr_classes[15][14] = int_stack + 653695;
 Libint->vrr_classes[15][15] = int_stack + 670015;
 Libint->vrr_classes[15][16] = int_stack + 688511;
 Libint->vrr_classes[15][17] = int_stack + 709319;
 Libint->vrr_classes[15][18] = int_stack + 732575;
 Libint->vrr_classes[16][9] = int_stack + 758415;
 Libint->vrr_classes[16][10] = int_stack + 766830;
 Libint->vrr_classes[16][11] = int_stack + 776928;
 Libint->vrr_classes[16][12] = int_stack + 788862;
 Libint->vrr_classes[16][13] = int_stack + 802785;
 Libint->vrr_classes[16][14] = int_stack + 818850;
 Libint->vrr_classes[16][15] = int_stack + 837210;
 Libint->vrr_classes[16][16] = int_stack + 858018;
 Libint->vrr_classes[16][17] = int_stack + 881427;
 Libint->vrr_classes[16][18] = int_stack + 907590;
 Libint->vrr_classes[17][9] = int_stack + 936660;
 Libint->vrr_classes[17][10] = int_stack + 946065;
 Libint->vrr_classes[17][11] = int_stack + 957351;
 Libint->vrr_classes[17][12] = int_stack + 970689;
 Libint->vrr_classes[17][13] = int_stack + 986250;
 Libint->vrr_classes[17][14] = int_stack + 1004205;
 Libint->vrr_classes[17][15] = int_stack + 1024725;
 Libint->vrr_classes[17][16] = int_stack + 1047981;
 Libint->vrr_classes[17][17] = int_stack + 1074144;
 Libint->vrr_classes[17][18] = int_stack + 1103385;
 memset(int_stack,0,1135875*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1135875;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mlmm(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1135875,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1144950,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1155840,int_stack+1144950,int_stack+1135875,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1173990,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1186860,int_stack+1173990,int_stack+1144950,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1208640,int_stack+1186860,int_stack+1155840,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1135875,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1238890,int_stack+1135875,int_stack+1173990,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1264630,int_stack+1238890,int_stack+1186860,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1150890,int_stack+1264630,int_stack+1208640,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1196265,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1300930,int_stack+1196265,int_stack+1135875,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1330960,int_stack+1300930,int_stack+1238890,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1373860,int_stack+1330960,int_stack+1264630,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1213590,int_stack+1373860,int_stack+1150890,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1135875,int_stack+28325,int_stack+21725,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1155675,int_stack+1135875,int_stack+1196265,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1428310,int_stack+1155675,int_stack+1300930,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1478360,int_stack+1428310,int_stack+1330960,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1277115,int_stack+1478360,int_stack+1373860,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1542710,int_stack+1277115,int_stack+1213590,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1190325,int_stack+35805,int_stack+28325,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1212765,int_stack+1190325,int_stack+1135875,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1353345,int_stack+1212765,int_stack+1155675,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1627410,int_stack+1353345,int_stack+1428310,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1702485,int_stack+1627410,int_stack+1478360,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1411095,int_stack+1702485,int_stack+1277115,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1792575,int_stack+1411095,int_stack+1542710,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1135875,int_stack+44220,int_stack+35805,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1252365,int_stack+1135875,int_stack+1190325,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1512735,int_stack+1252365,int_stack+1212765,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1161120,int_stack+1512735,int_stack+1353345,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1297245,int_stack+1161120,int_stack+1627410,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1578735,int_stack+1297245,int_stack+1702485,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1901475,int_stack+1578735,int_stack+1411095,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2032155,int_stack+1901475,int_stack+1792575,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1402350,int_stack+53625,int_stack+44220,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1430565,int_stack+1402350,int_stack+1135875,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1698855,int_stack+1430565,int_stack+1252365,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1402350,int_stack+1698855,int_stack+1512735,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1698855,int_stack+1402350,int_stack+1161120,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1402350,int_stack+1698855,int_stack+1297245,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1698855,int_stack+1402350,int_stack+1578735,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1135875,int_stack+1698855,int_stack+1901475,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1299225,int_stack+1135875,int_stack+2032155,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1135875,int_stack+67705,int_stack+64075,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1146765,int_stack+72061,int_stack+67705,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1159833,int_stack+1146765,int_stack+1135875,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1181613,int_stack+77209,int_stack+72061,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1197057,int_stack+1181613,int_stack+1146765,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1223193,int_stack+1197057,int_stack+1159833,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1135875,int_stack+83215,int_stack+77209,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1259493,int_stack+1135875,int_stack+1181613,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1465600,int_stack+1259493,int_stack+1197057,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1153893,int_stack+1465600,int_stack+1223193,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1208343,int_stack+90145,int_stack+83215,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1509160,int_stack+1208343,int_stack+1135875,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1545196,int_stack+1509160,int_stack+1259493,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1229133,int_stack+1545196,int_stack+1465600,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1596676,int_stack+1229133,int_stack+1153893,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1465600,int_stack+98065,int_stack+90145,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1135875,int_stack+1465600,int_stack+1208343,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1672906,int_stack+1135875,int_stack+1509160,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1732966,int_stack+1672906,int_stack+1545196,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1489360,int_stack+1732966,int_stack+1229133,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1177455,int_stack+1489360,int_stack+1596676,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1580836,int_stack+107041,int_stack+98065,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1607764,int_stack+1580836,int_stack+1465600,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1810186,int_stack+1607764,int_stack+1135875,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1879486,int_stack+1810186,int_stack+1672906,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1969576,int_stack+1879486,int_stack+1732966,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1655284,int_stack+1969576,int_stack+1489360,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2077684,int_stack+1655284,int_stack+1177455,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1135875,int_stack+117139,int_stack+107041,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1166169,int_stack+1135875,int_stack+1580836,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1220025,int_stack+1166169,int_stack+1607764,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1465600,int_stack+1220025,int_stack+1810186,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2208364,int_stack+1465600,int_stack+1879486,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1777252,int_stack+2208364,int_stack+1969576,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2334490,int_stack+1777252,int_stack+1655284,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1569550,int_stack+2334490,int_stack+2077684,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1732900,int_stack+128425,int_stack+117139,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1921396,int_stack+1732900,int_stack+1135875,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1981984,int_stack+1921396,int_stack+1166169,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2071744,int_stack+1981984,int_stack+1220025,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1921396,int_stack+2071744,int_stack+1465600,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2491306,int_stack+1921396,int_stack+2208364,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1921396,int_stack+2491306,int_stack+1777252,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2106724,int_stack+1921396,int_stack+2334490,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+2302744,int_stack+2106724,int_stack+1569550,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1465600,int_stack+2302744,int_stack+1299225,3025);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2502394,int_stack+145255,int_stack+140965,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2515264,int_stack+150403,int_stack+145255,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2530708,int_stack+2515264,int_stack+2502394,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2556448,int_stack+156487,int_stack+150403,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2574700,int_stack+2556448,int_stack+2515264,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2605588,int_stack+2574700,int_stack+2530708,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2502394,int_stack+163585,int_stack+156487,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1964725,int_stack+2502394,int_stack+2556448,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2001229,int_stack+1964725,int_stack+2574700,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2523688,int_stack+2001229,int_stack+2605588,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2588038,int_stack+171775,int_stack+163585,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2612608,int_stack+2588038,int_stack+2502394,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2052709,int_stack+2612608,int_stack+1964725,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2113549,int_stack+2052709,int_stack+2001229,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2190769,int_stack+2113549,int_stack+2523688,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1964725,int_stack+181135,int_stack+171775,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1992805,int_stack+1964725,int_stack+2588038,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2502394,int_stack+1992805,int_stack+2612608,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1135875,int_stack+2502394,int_stack+2052709,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1227135,int_stack+1135875,int_stack+2113549,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2041945,int_stack+1227135,int_stack+2190769,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2162065,int_stack+191743,int_stack+181135,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2193889,int_stack+2162065,int_stack+1964725,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2573374,int_stack+2193889,int_stack+1992805,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1335243,int_stack+2573374,int_stack+2502394,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+1335243,int_stack+1135875,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2655274,int_stack+0,int_stack+1227135,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1135875,int_stack+2655274,int_stack+2041945,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1290315,int_stack+203677,int_stack+191743,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2502394,int_stack+1290315,int_stack+2162065,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1964725,int_stack+2502394,int_stack+2193889,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2058325,int_stack+1964725,int_stack+2573374,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2799418,int_stack+2058325,int_stack+1335243,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2948476,int_stack+2799418,int_stack+0,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2948476,int_stack+2655274,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2566042,int_stack+0,int_stack+1135875,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1135875,int_stack+217015,int_stack+203677,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1175889,int_stack+1135875,int_stack+1290315,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1247493,int_stack+1175889,int_stack+2502394,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3118828,int_stack+1247493,int_stack+1964725,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1135875,int_stack+3118828,int_stack+2058325,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1964725,int_stack+1135875,int_stack+2799418,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1135875,int_stack+1964725,int_stack+2948476,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1964725,int_stack+1135875,int_stack+0,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1135875,int_stack+1964725,int_stack+2566042,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+2502394,int_stack+1135875,int_stack+2302744,3025);
 /*--- compute (md|mm) ---*/
 hrr1_build_md(Libint->AB,int_stack+3101344,int_stack+2502394,int_stack+1465600,3025);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+236840,int_stack+231835,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+242846,int_stack+236840,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+249944,int_stack+242846,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+120393,int_stack+84357,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+258225,int_stack+249944,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+170443,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1371825,int_stack+170443,int_stack+84357,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+24843,int_stack+1371825,int_stack+120393,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+99918,int_stack+267780,int_stack+258225,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+213031,int_stack+99918,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1431885,int_stack+213031,int_stack+170443,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1502865,int_stack+1431885,int_stack+1371825,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1592955,int_stack+1502865,int_stack+24843,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1371825,int_stack+278700,int_stack+267780,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+1371825,int_stack+99918,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+57330,int_stack+0,int_stack+213031,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+140140,int_stack+57330,int_stack+1431885,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1698060,int_stack+140140,int_stack+1502865,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1404585,int_stack+1698060,int_stack+1592955,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1544725,int_stack+291076,int_stack+278700,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1581853,int_stack+1544725,int_stack+1371825,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1824186,int_stack+1581853,int_stack+0,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1919736,int_stack+1824186,int_stack+57330,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2043951,int_stack+1919736,int_stack+140140,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+2043951,int_stack+1698060,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2193009,int_stack+0,int_stack+1404585,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+168168,int_stack+304999,int_stack+291076,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+209937,int_stack+168168,int_stack+1544725,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1371825,int_stack+209937,int_stack+1581853,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1481025,int_stack+1371825,int_stack+1824186,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1624350,int_stack+1481025,int_stack+1919736,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1798251,int_stack+1624350,int_stack+2043951,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4099594,int_stack+1798251,int_stack+0,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+4315810,int_stack+4099594,int_stack+2193009,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+320560,int_stack+304999,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+46683,int_stack+0,int_stack+168168,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1996995,int_stack+46683,int_stack+209937,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+1996995,int_stack+1371825,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1996995,int_stack+0,int_stack+1481025,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+1996995,int_stack+1624350,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1996995,int_stack+0,int_stack+1798251,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1996995,int_stack+4099594,91);
 /*--- compute (q0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1371825,int_stack+0,int_stack+4315810,91);
 /*--- compute (op|mm) ---*/
 hrr1_build_op(Libint->AB,int_stack+1647100,int_stack+1371825,int_stack+1135875,3025);
 /*--- compute (nd|mm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4099594,int_stack+1647100,int_stack+2502394,3025);
 /*--- compute (mf|mm) ---*/
 hrr1_build_mf(Libint->AB,int_stack+5297494,int_stack+4099594,int_stack+3101344,3025);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1135875,int_stack+343625,int_stack+337850,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1153200,int_stack+350555,int_stack+343625,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1173990,int_stack+1153200,int_stack+1135875,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1208640,int_stack+358745,int_stack+350555,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1233210,int_stack+1208640,int_stack+1153200,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1274790,int_stack+1233210,int_stack+1173990,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1135875,int_stack+368300,int_stack+358745,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+1135875,int_stack+1208640,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+49140,int_stack+0,int_stack+1233210,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1164540,int_stack+49140,int_stack+1274790,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1251165,int_stack+379325,int_stack+368300,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1284240,int_stack+1251165,int_stack+1135875,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+118440,int_stack+1284240,int_stack+0,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+200340,int_stack+118440,int_stack+49140,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2354950,int_stack+200340,int_stack+1164540,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+391925,int_stack+379325,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+37800,int_stack+0,int_stack+1251165,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1135875,int_stack+37800,int_stack+1284240,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1231425,int_stack+1135875,int_stack+118440,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2476225,int_stack+1231425,int_stack+200340,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+103950,int_stack+2476225,int_stack+2354950,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2354950,int_stack+406205,int_stack+391925,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2397790,int_stack+2354950,int_stack+0,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+265650,int_stack+2397790,int_stack+37800,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2621755,int_stack+265650,int_stack+1135875,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2765080,int_stack+2621755,int_stack+1231425,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1135875,int_stack+2765080,int_stack+2476225,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2937070,int_stack+1135875,int_stack+103950,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+422270,int_stack+406205,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+48195,int_stack+0,int_stack+2354950,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+133875,int_stack+48195,int_stack+2397790,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2354950,int_stack+133875,int_stack+265650,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3144970,int_stack+2354950,int_stack+2621755,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2520325,int_stack+3144970,int_stack+2765080,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3345625,int_stack+2520325,int_stack+1135875,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3595105,int_stack+3345625,int_stack+2937070,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1135875,int_stack+440225,int_stack+422270,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1189740,int_stack+1135875,int_stack+0,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2749645,int_stack+1189740,int_stack+48195,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1135875,int_stack+2749645,int_stack+133875,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2749645,int_stack+1135875,int_stack+2354950,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+2749645,int_stack+3144970,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2749645,int_stack+0,int_stack+2520325,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+2749645,int_stack+3345625,105);
 /*--- compute (r0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+2354950,int_stack+0,int_stack+3595105,105);
 /*--- compute (qp|mm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2672575,int_stack+2354950,int_stack+1371825,3025);
 /*--- compute (od|mm) ---*/
 hrr1_build_od(Libint->AB,int_stack+6961244,int_stack+2672575,int_stack+1647100,3025);
 /*--- compute (nf|mm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+8376944,int_stack+6961244,int_stack+4099594,3025);
 /*--- compute (mg|mm) ---*/
 hrr1_build_mg(Libint->AB,int_stack+10373444,int_stack+8376944,int_stack+5297494,3025);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+466775,int_stack+460175,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+19800,int_stack+474695,int_stack+466775,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+43560,int_stack+19800,int_stack+0,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+83160,int_stack+484055,int_stack+474695,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+111240,int_stack+83160,int_stack+19800,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+158760,int_stack+111240,int_stack+43560,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+494975,int_stack+484055,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+224760,int_stack+0,int_stack+83160,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+280920,int_stack+224760,int_stack+111240,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+32760,int_stack+280920,int_stack+158760,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+131760,int_stack+507575,int_stack+494975,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+360120,int_stack+131760,int_stack+0,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3498400,int_stack+360120,int_stack+224760,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3592000,int_stack+3498400,int_stack+280920,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+169560,int_stack+3592000,int_stack+32760,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+521975,int_stack+507575,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+43200,int_stack+0,int_stack+131760,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3710800,int_stack+43200,int_stack+360120,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+308160,int_stack+3710800,int_stack+3498400,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3820000,int_stack+308160,int_stack+3592000,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+3498400,int_stack+3820000,int_stack+169560,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+118800,int_stack+538295,int_stack+521975,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+167760,int_stack+118800,int_stack+0,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3986320,int_stack+167760,int_stack+43200,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+4112320,int_stack+3986320,int_stack+3710800,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+4276120,int_stack+4112320,int_stack+308160,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+254160,int_stack+4276120,int_stack+3820000,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+3683200,int_stack+254160,int_stack+3498400,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3498400,int_stack+556655,int_stack+538295,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3553480,int_stack+3498400,int_stack+118800,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+3553480,int_stack+167760,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4472680,int_stack+0,int_stack+3986320,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+4661680,int_stack+4472680,int_stack+4112320,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3920800,int_stack+4661680,int_stack+4276120,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4182880,int_stack+3920800,int_stack+254160,120);
 /*--- compute (t0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+144000,int_stack+4182880,int_stack+3683200,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+3651400,int_stack+577175,int_stack+556655,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+3712960,int_stack+3651400,int_stack+3498400,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+4891000,int_stack+3712960,int_stack+3553480,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3498400,int_stack+4891000,int_stack+0,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4891000,int_stack+3498400,int_stack+4472680,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3498400,int_stack+4891000,int_stack+4661680,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4468000,int_stack+3498400,int_stack+3920800,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3498400,int_stack+4468000,int_stack+4182880,120);
 /*--- compute (t0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+3854800,int_stack+3498400,int_stack+144000,120);
 /*--- compute (rp|mm) ---*/
 hrr1_build_rp(Libint->AB,int_stack+4217800,int_stack+3854800,int_stack+2354950,3025);
 /*--- compute (qd|mm) ---*/
 hrr1_build_qd(Libint->AB,int_stack+5170675,int_stack+4217800,int_stack+2672575,3025);
 /*--- compute (of|mm) ---*/
 hrr1_build_of(Libint->AB,int_stack+1135875,int_stack+5170675,int_stack+6961244,3025);
 /*--- compute (ng|mm) ---*/
 hrr1_build_ng(Libint->AB,int_stack+12869069,int_stack+1135875,int_stack+8376944,3025);
 /*--- compute (mh|mm) ---*/
 hrr1_build_mh(Libint->AB,int_stack+6822325,int_stack+12869069,int_stack+10373444,3025);
 /*--- compute (u0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10316200,int_stack+607455,int_stack+599975,136);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10338640,int_stack+616431,int_stack+607455,136);
 /*--- compute (u0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+10365568,int_stack+10338640,int_stack+10316200,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10410448,int_stack+627039,int_stack+616431,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+10442272,int_stack+10410448,int_stack+10338640,136);
 /*--- compute (u0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+10496128,int_stack+10442272,int_stack+10365568,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+10316200,int_stack+639415,int_stack+627039,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+10570928,int_stack+10316200,int_stack+10410448,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+10634576,int_stack+10570928,int_stack+10442272,136);
 /*--- compute (u0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+10353328,int_stack+10634576,int_stack+10496128,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+10465528,int_stack+653695,int_stack+639415,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+10724336,int_stack+10465528,int_stack+10316200,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+10798592,int_stack+10724336,int_stack+10570928,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+10904672,int_stack+10798592,int_stack+10634576,136);
 /*--- compute (u0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+10508368,int_stack+10904672,int_stack+10353328,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+10316200,int_stack+670015,int_stack+653695,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+10365160,int_stack+10316200,int_stack+10465528,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+11039312,int_stack+10365160,int_stack+10724336,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+11163072,int_stack+11039312,int_stack+10798592,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+10665448,int_stack+11163072,int_stack+10904672,136);
 /*--- compute (u0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+11322192,int_stack+10665448,int_stack+10508368,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+10450840,int_stack+688511,int_stack+670015,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+10506328,int_stack+10450840,int_stack+10316200,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+10853944,int_stack+10506328,int_stack+10365160,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+11531632,int_stack+10853944,int_stack+11039312,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+11717272,int_stack+11531632,int_stack+11163072,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+10996744,int_stack+11717272,int_stack+10665448,136);
 /*--- compute (u0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+11940040,int_stack+10996744,int_stack+11322192,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+10316200,int_stack+709319,int_stack+688511,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+10604248,int_stack+10316200,int_stack+10450840,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+11248072,int_stack+10604248,int_stack+10506328,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+10378624,int_stack+11248072,int_stack+10853944,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+10715224,int_stack+10378624,int_stack+11531632,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+11411272,int_stack+10715224,int_stack+11717272,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+12209320,int_stack+11411272,int_stack+10996744,136);
 /*--- compute (u0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+12532456,int_stack+12209320,int_stack+11940040,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+10975120,int_stack+732575,int_stack+709319,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+11044888,int_stack+10975120,int_stack+10316200,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+11708296,int_stack+11044888,int_stack+10604248,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+10975120,int_stack+11708296,int_stack+11248072,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+11708296,int_stack+10975120,int_stack+10378624,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+10975120,int_stack+11708296,int_stack+10715224,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+11708296,int_stack+10975120,int_stack+11411272,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+10316200,int_stack+11708296,int_stack+12209320,136);
 /*--- compute (u0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+10720120,int_stack+10316200,int_stack+12532456,136);
 /*--- compute (tp|mm) ---*/
 hrr1_build_tp(Libint->AB,int_stack+11131520,int_stack+10720120,int_stack+3854800,3025);
 /*--- compute (rd|mm) ---*/
 hrr1_build_rd(Libint->AB,int_stack+15863819,int_stack+11131520,int_stack+4217800,3025);
 /*--- compute (qf|mm) ---*/
 hrr1_build_qf(Libint->AB,int_stack+17769569,int_stack+15863819,int_stack+5170675,3025);
 /*--- compute (og|mm) ---*/
 hrr1_build_og(Libint->AB,int_stack+20522319,int_stack+17769569,int_stack+1135875,3025);
 /*--- compute (nh|mm) ---*/
 hrr1_build_nh(Libint->AB,int_stack+1135875,int_stack+20522319,int_stack+12869069,3025);
 /*--- compute (mi|mm) ---*/
 hrr1_build_mi(Libint->AB,int_stack+24061569,int_stack+1135875,int_stack+6822325,3025);
 /*--- compute (v0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+5328525,int_stack+766830,int_stack+758415,153);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+5353770,int_stack+776928,int_stack+766830,153);
 /*--- compute (v0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+5384064,int_stack+5353770,int_stack+5328525,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5434554,int_stack+788862,int_stack+776928,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+5470356,int_stack+5434554,int_stack+5353770,153);
 /*--- compute (v0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+5530944,int_stack+5470356,int_stack+5384064,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+5328525,int_stack+802785,int_stack+788862,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+5615094,int_stack+5328525,int_stack+5434554,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+5686698,int_stack+5615094,int_stack+5470356,153);
 /*--- compute (v0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+5370294,int_stack+5686698,int_stack+5530944,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+5496519,int_stack+818850,int_stack+802785,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+5787678,int_stack+5496519,int_stack+5328525,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+5871216,int_stack+5787678,int_stack+5615094,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+5990556,int_stack+5871216,int_stack+5686698,153);
 /*--- compute (v0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+5544714,int_stack+5990556,int_stack+5370294,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+5328525,int_stack+837210,int_stack+818850,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+5383605,int_stack+5328525,int_stack+5496519,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+6142026,int_stack+5383605,int_stack+5787678,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+6281256,int_stack+6142026,int_stack+5871216,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+5721429,int_stack+6281256,int_stack+5990556,153);
 /*--- compute (v0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+6460266,int_stack+5721429,int_stack+5544714,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+5479995,int_stack+858018,int_stack+837210,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+5542419,int_stack+5479995,int_stack+5328525,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+5933487,int_stack+5542419,int_stack+5383605,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+6695886,int_stack+5933487,int_stack+6142026,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+6904731,int_stack+6695886,int_stack+6281256,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+6094137,int_stack+6904731,int_stack+5721429,153);
 /*--- compute (v0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+7155345,int_stack+6094137,int_stack+6460266,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+5328525,int_stack+881427,int_stack+858018,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+5652579,int_stack+5328525,int_stack+5479995,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+6376881,int_stack+5652579,int_stack+5542419,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+5398752,int_stack+6376881,int_stack+5933487,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+5777427,int_stack+5398752,int_stack+6695886,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+6560481,int_stack+5777427,int_stack+6904731,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+7458285,int_stack+6560481,int_stack+6094137,153);
 /*--- compute (v0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+7821813,int_stack+7458285,int_stack+7155345,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+6069810,int_stack+907590,int_stack+881427,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+6148299,int_stack+6069810,int_stack+5328525,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+6894633,int_stack+6148299,int_stack+5652579,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+6069810,int_stack+6894633,int_stack+6376881,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+6894633,int_stack+6069810,int_stack+5398752,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+6069810,int_stack+6894633,int_stack+5777427,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+6894633,int_stack+6069810,int_stack+6560481,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5328525,int_stack+6894633,int_stack+7458285,153);
 /*--- compute (v0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+5782935,int_stack+5328525,int_stack+7821813,153);
 /*--- compute (up|mm) ---*/
 hrr1_build_up(Libint->AB,int_stack+6245760,int_stack+5782935,int_stack+10720120,3025);
 /*--- compute (td|mm) ---*/
 hrr1_build_td(Libint->AB,int_stack+7479960,int_stack+6245760,int_stack+11131520,3025);
 /*--- compute (rf|mm) ---*/
 hrr1_build_rf(Libint->AB,int_stack+9657960,int_stack+7479960,int_stack+15863819,3025);
 /*--- compute (qg|mm) ---*/
 hrr1_build_qg(Libint->AB,int_stack+12834210,int_stack+9657960,int_stack+17769569,3025);
 /*--- compute (oh|mm) ---*/
 hrr1_build_oh(Libint->AB,int_stack+28720069,int_stack+12834210,int_stack+20522319,3025);
 /*--- compute (ni|mm) ---*/
 hrr1_build_ni(Libint->AB,int_stack+16963335,int_stack+28720069,int_stack+1135875,3025);
 /*--- compute (mk|mm) ---*/
 hrr1_build_mk(Libint->AB,int_stack+33675019,int_stack+16963335,int_stack+24061569,3025);
 /*--- compute (w0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1135875,int_stack+946065,int_stack+936660,171);
 /*--- compute (w0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1164090,int_stack+957351,int_stack+946065,171);
 /*--- compute (w0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1197948,int_stack+1164090,int_stack+1135875,171);
 /*--- compute (w0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1254378,int_stack+970689,int_stack+957351,171);
 /*--- compute (w0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1294392,int_stack+1254378,int_stack+1164090,171);
 /*--- compute (w0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1362108,int_stack+1294392,int_stack+1197948,171);
 /*--- compute (w0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1135875,int_stack+986250,int_stack+970689,171);
 /*--- compute (w0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1456158,int_stack+1135875,int_stack+1254378,171);
 /*--- compute (w0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1536186,int_stack+1456158,int_stack+1294392,171);
 /*--- compute (w0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1182558,int_stack+1536186,int_stack+1362108,171);
 /*--- compute (w0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1323633,int_stack+1004205,int_stack+986250,171);
 /*--- compute (w0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1649046,int_stack+1323633,int_stack+1135875,171);
 /*--- compute (w0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1742412,int_stack+1649046,int_stack+1456158,171);
 /*--- compute (w0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1875792,int_stack+1742412,int_stack+1536186,171);
 /*--- compute (w0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1377498,int_stack+1875792,int_stack+1182558,171);
 /*--- compute (w0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1135875,int_stack+1024725,int_stack+1004205,171);
 /*--- compute (w0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1197435,int_stack+1135875,int_stack+1323633,171);
 /*--- compute (w0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2045082,int_stack+1197435,int_stack+1649046,171);
 /*--- compute (w0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2200692,int_stack+2045082,int_stack+1742412,171);
 /*--- compute (w0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1575003,int_stack+2200692,int_stack+1875792,171);
 /*--- compute (w0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2400762,int_stack+1575003,int_stack+1377498,171);
 /*--- compute (w0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1305165,int_stack+1047981,int_stack+1024725,171);
 /*--- compute (w0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1374933,int_stack+1305165,int_stack+1135875,171);
 /*--- compute (w0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1812009,int_stack+1374933,int_stack+1197435,171);
 /*--- compute (w0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2664102,int_stack+1812009,int_stack+2045082,171);
 /*--- compute (w0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2897517,int_stack+2664102,int_stack+2200692,171);
 /*--- compute (w0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1991559,int_stack+2897517,int_stack+1575003,171);
 /*--- compute (w0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+3177615,int_stack+1991559,int_stack+2400762,171);
 /*--- compute (w0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1135875,int_stack+1074144,int_stack+1047981,171);
 /*--- compute (w0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1498053,int_stack+1135875,int_stack+1305165,171);
 /*--- compute (w0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2307567,int_stack+1498053,int_stack+1374933,171);
 /*--- compute (w0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1214364,int_stack+2307567,int_stack+1812009,171);
 /*--- compute (w0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1637589,int_stack+1214364,int_stack+2664102,171);
 /*--- compute (w0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2512767,int_stack+1637589,int_stack+2897517,171);
 /*--- compute (w0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3516195,int_stack+2512767,int_stack+1991559,171);
 /*--- compute (w0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3922491,int_stack+3516195,int_stack+3177615,171);
 /*--- compute (w0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1964370,int_stack+1103385,int_stack+1074144,171);
 /*--- compute (w0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2052093,int_stack+1964370,int_stack+1135875,171);
 /*--- compute (w0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2886231,int_stack+2052093,int_stack+1498053,171);
 /*--- compute (w0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1964370,int_stack+2886231,int_stack+2307567,171);
 /*--- compute (w0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2886231,int_stack+1964370,int_stack+1214364,171);
 /*--- compute (w0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1964370,int_stack+2886231,int_stack+1637589,171);
 /*--- compute (w0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2886231,int_stack+1964370,int_stack+2512767,171);
 /*--- compute (w0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4345716,int_stack+2886231,int_stack+3516195,171);
 /*--- compute (w0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+4853586,int_stack+4345716,int_stack+3922491,171);
 /*--- compute (vp|mm) ---*/
 hrr1_build_vp(Libint->AB,int_stack+22553535,int_stack+4853586,int_stack+5782935,3025);
 /*--- compute (ud|mm) ---*/
 hrr1_build_ud(Libint->AB,int_stack+23942010,int_stack+22553535,int_stack+6245760,3025);
 /*--- compute (tf|mm) ---*/
 hrr1_build_tf(Libint->AB,int_stack+0,int_stack+23942010,int_stack+7479960,3025);
 /*--- compute (rg|mm) ---*/
 hrr1_build_rg(Libint->AB,int_stack+22553535,int_stack+0,int_stack+9657960,3025);
 /*--- compute (qh|mm) ---*/
 hrr1_build_qh(Libint->AB,int_stack+0,int_stack+22553535,int_stack+12834210,3025);
 /*--- compute (oi|mm) ---*/
 hrr1_build_oi(Libint->AB,int_stack+5780775,int_stack+0,int_stack+28720069,3025);
 /*--- compute (nk|mm) ---*/
 hrr1_build_nk(Libint->AB,int_stack+22553535,int_stack+5780775,int_stack+16963335,3025);
 /*--- compute (ml|mm) ---*/
 hrr1_build_ml(Libint->AB,int_stack+0,int_stack+22553535,int_stack+33675019,3025);
 return int_stack+0;}
