/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mpld(Libint_t*, prim_data*);

  /* Computes quartets of (mp|ld) integrals */

REALTYPE *hrr_order_mpld(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[10][8] = int_stack + 9130;
 Libint->vrr_classes[10][9] = int_stack + 12100;
 Libint->vrr_classes[10][10] = int_stack + 15730;
 memset(int_stack,0,20086*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 20086;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mpld(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20086,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+27511,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+36586,int_stack+27511,int_stack+20086,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20086,int_stack+12100,int_stack+9130,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+15730,int_stack+12100,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+51436,int_stack+0,int_stack+20086,66);
 /*--- compute (mp|ld) ---*/
 hrr1_build_mp(Libint->AB,int_stack+69256,int_stack+51436,int_stack+36586,270);
 return int_stack+69256;}
