/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mpml(Libint_t*, prim_data*);

  /* Computes quartets of (mp|ml) integrals */

REALTYPE *hrr_order_mpml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[9][15] = int_stack + 28325;
 Libint->vrr_classes[9][16] = int_stack + 35805;
 Libint->vrr_classes[9][17] = int_stack + 44220;
 Libint->vrr_classes[10][9] = int_stack + 53625;
 Libint->vrr_classes[10][10] = int_stack + 57255;
 Libint->vrr_classes[10][11] = int_stack + 61611;
 Libint->vrr_classes[10][12] = int_stack + 66759;
 Libint->vrr_classes[10][13] = int_stack + 72765;
 Libint->vrr_classes[10][14] = int_stack + 79695;
 Libint->vrr_classes[10][15] = int_stack + 87615;
 Libint->vrr_classes[10][16] = int_stack + 96591;
 Libint->vrr_classes[10][17] = int_stack + 106689;
 memset(int_stack,0,117975*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 117975;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mpml(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+117975,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+127050,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+137940,int_stack+127050,int_stack+117975,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+156090,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+168960,int_stack+156090,int_stack+127050,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+190740,int_stack+168960,int_stack+137940,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+117975,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+220990,int_stack+117975,int_stack+156090,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+246730,int_stack+220990,int_stack+168960,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+132990,int_stack+246730,int_stack+190740,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+178365,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+283030,int_stack+178365,int_stack+117975,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+313060,int_stack+283030,int_stack+220990,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+355960,int_stack+313060,int_stack+246730,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+195690,int_stack+355960,int_stack+132990,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+117975,int_stack+28325,int_stack+21725,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+137775,int_stack+117975,int_stack+178365,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+410410,int_stack+137775,int_stack+283030,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+460460,int_stack+410410,int_stack+313060,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+259215,int_stack+460460,int_stack+355960,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+524810,int_stack+259215,int_stack+195690,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+172425,int_stack+35805,int_stack+28325,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+194865,int_stack+172425,int_stack+117975,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+335445,int_stack+194865,int_stack+137775,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+609510,int_stack+335445,int_stack+410410,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+684585,int_stack+609510,int_stack+460460,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+393195,int_stack+684585,int_stack+259215,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+774675,int_stack+393195,int_stack+524810,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+117975,int_stack+44220,int_stack+35805,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+234465,int_stack+117975,int_stack+172425,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+117975,int_stack+234465,int_stack+194865,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+183975,int_stack+117975,int_stack+335445,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+270600,int_stack+183975,int_stack+609510,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+117975,int_stack+270600,int_stack+684585,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+238095,int_stack+117975,int_stack+393195,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+368775,int_stack+238095,int_stack+774675,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+117975,int_stack+57255,int_stack+53625,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+128865,int_stack+61611,int_stack+57255,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+141933,int_stack+128865,int_stack+117975,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+163713,int_stack+66759,int_stack+61611,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+179157,int_stack+163713,int_stack+128865,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+205293,int_stack+179157,int_stack+141933,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+117975,int_stack+72765,int_stack+66759,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+241593,int_stack+117975,int_stack+163713,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+272481,int_stack+241593,int_stack+179157,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+135993,int_stack+272481,int_stack+205293,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+190443,int_stack+79695,int_stack+72765,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+316041,int_stack+190443,int_stack+117975,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+504900,int_stack+316041,int_stack+241593,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+556380,int_stack+504900,int_stack+272481,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+211233,int_stack+556380,int_stack+135993,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+117975,int_stack+87615,int_stack+79695,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+141735,int_stack+117975,int_stack+190443,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+621720,int_stack+141735,int_stack+316041,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+287463,int_stack+621720,int_stack+504900,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+681780,int_stack+287463,int_stack+556380,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+504900,int_stack+681780,int_stack+211233,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+183315,int_stack+96591,int_stack+87615,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+210243,int_stack+183315,int_stack+117975,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+773256,int_stack+210243,int_stack+141735,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+773256,int_stack+621720,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+842556,int_stack+0,int_stack+287463,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+950664,int_stack+842556,int_stack+681780,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+606540,int_stack+950664,int_stack+504900,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+504900,int_stack+106689,int_stack+96591,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+535194,int_stack+504900,int_stack+183315,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+257763,int_stack+535194,int_stack+210243,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+90090,int_stack+257763,int_stack+773256,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+194040,int_stack+90090,int_stack+0,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+194040,int_stack+842556,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+144144,int_stack+0,int_stack+950664,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+737220,int_stack+144144,int_stack+606540,66);
 /*--- compute (mp|ml) ---*/
 hrr1_build_mp(Libint->AB,int_stack+900570,int_stack+737220,int_stack+368775,2475);
 return int_stack+900570;}
