/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ngnn(Libint_t*, prim_data*);

  /* Computes quartets of (ng|nn) integrals */

REALTYPE *hrr_order_ngnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[10][18] = int_stack + 60720;
 Libint->vrr_classes[10][19] = int_stack + 73260;
 Libint->vrr_classes[10][20] = int_stack + 87120;
 Libint->vrr_classes[11][10] = int_stack + 102366;
 Libint->vrr_classes[11][11] = int_stack + 107514;
 Libint->vrr_classes[11][12] = int_stack + 113598;
 Libint->vrr_classes[11][13] = int_stack + 120696;
 Libint->vrr_classes[11][14] = int_stack + 128886;
 Libint->vrr_classes[11][15] = int_stack + 138246;
 Libint->vrr_classes[11][16] = int_stack + 148854;
 Libint->vrr_classes[11][17] = int_stack + 160788;
 Libint->vrr_classes[11][18] = int_stack + 174126;
 Libint->vrr_classes[11][19] = int_stack + 188946;
 Libint->vrr_classes[11][20] = int_stack + 205326;
 Libint->vrr_classes[12][10] = int_stack + 223344;
 Libint->vrr_classes[12][11] = int_stack + 229350;
 Libint->vrr_classes[12][12] = int_stack + 236448;
 Libint->vrr_classes[12][13] = int_stack + 244729;
 Libint->vrr_classes[12][14] = int_stack + 254284;
 Libint->vrr_classes[12][15] = int_stack + 265204;
 Libint->vrr_classes[12][16] = int_stack + 277580;
 Libint->vrr_classes[12][17] = int_stack + 291503;
 Libint->vrr_classes[12][18] = int_stack + 307064;
 Libint->vrr_classes[12][19] = int_stack + 324354;
 Libint->vrr_classes[12][20] = int_stack + 343464;
 Libint->vrr_classes[13][10] = int_stack + 364485;
 Libint->vrr_classes[13][11] = int_stack + 371415;
 Libint->vrr_classes[13][12] = int_stack + 379605;
 Libint->vrr_classes[13][13] = int_stack + 389160;
 Libint->vrr_classes[13][14] = int_stack + 400185;
 Libint->vrr_classes[13][15] = int_stack + 412785;
 Libint->vrr_classes[13][16] = int_stack + 427065;
 Libint->vrr_classes[13][17] = int_stack + 443130;
 Libint->vrr_classes[13][18] = int_stack + 461085;
 Libint->vrr_classes[13][19] = int_stack + 481035;
 Libint->vrr_classes[13][20] = int_stack + 503085;
 Libint->vrr_classes[14][10] = int_stack + 527340;
 Libint->vrr_classes[14][11] = int_stack + 535260;
 Libint->vrr_classes[14][12] = int_stack + 544620;
 Libint->vrr_classes[14][13] = int_stack + 555540;
 Libint->vrr_classes[14][14] = int_stack + 568140;
 Libint->vrr_classes[14][15] = int_stack + 582540;
 Libint->vrr_classes[14][16] = int_stack + 598860;
 Libint->vrr_classes[14][17] = int_stack + 617220;
 Libint->vrr_classes[14][18] = int_stack + 637740;
 Libint->vrr_classes[14][19] = int_stack + 660540;
 Libint->vrr_classes[14][20] = int_stack + 685740;
 memset(int_stack,0,713460*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 713460;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ngnn(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+713460,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+726528,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+741972,int_stack+726528,int_stack+713460,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+768108,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+786126,int_stack+768108,int_stack+726528,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+817014,int_stack+786126,int_stack+741972,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+713460,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+860574,int_stack+713460,int_stack+768108,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+734250,int_stack+860574,int_stack+786126,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+896610,int_stack+734250,int_stack+817014,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+785730,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+809490,int_stack+785730,int_stack+713460,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+961950,int_stack+809490,int_stack+860574,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1022010,int_stack+961950,int_stack+734250,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1099230,int_stack+1022010,int_stack+896610,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+713460,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+851070,int_stack+713460,int_stack+785730,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1190706,int_stack+851070,int_stack+809490,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+740388,int_stack+1190706,int_stack+961950,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+898590,int_stack+740388,int_stack+1022010,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1260006,int_stack+898590,int_stack+1099230,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1006698,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1036992,int_stack+1006698,int_stack+713460,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1090848,int_stack+1036992,int_stack+851070,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1381974,int_stack+1090848,int_stack+1190706,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1485924,int_stack+1381974,int_stack+740388,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+713460,int_stack+1485924,int_stack+898590,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1612050,int_stack+713460,int_stack+1260006,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+857604,int_stack+60720,int_stack+49434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+891462,int_stack+857604,int_stack+1006698,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1170048,int_stack+891462,int_stack+1036992,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+952050,int_stack+1170048,int_stack+1090848,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1768866,int_stack+952050,int_stack+1381974,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1259808,int_stack+1768866,int_stack+1485924,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1914396,int_stack+1259808,int_stack+713460,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2099724,int_stack+1914396,int_stack+1612050,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+713460,int_stack+73260,int_stack+60720,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+751080,int_stack+713460,int_stack+857604,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1427976,int_stack+751080,int_stack+891462,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1528956,int_stack+1427976,int_stack+1170048,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1070850,int_stack+1528956,int_stack+952050,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+818796,int_stack+1070850,int_stack+1768866,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1663596,int_stack+818796,int_stack+1259808,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2295744,int_stack+1663596,int_stack+1914396,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2527404,int_stack+2295744,int_stack+2099724,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1012836,int_stack+87120,int_stack+73260,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1237170,int_stack+1012836,int_stack+713460,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1312410,int_stack+1237170,int_stack+751080,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1879812,int_stack+1312410,int_stack+1427976,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1237170,int_stack+1879812,int_stack+1528956,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1879812,int_stack+1237170,int_stack+1070850,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1012836,int_stack+1879812,int_stack+818796,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1879812,int_stack+1012836,int_stack+1663596,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+713460,int_stack+1879812,int_stack+2295744,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+996600,int_stack+713460,int_stack+2527404,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+713460,int_stack+107514,int_stack+102366,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+728904,int_stack+113598,int_stack+107514,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+747156,int_stack+728904,int_stack+713460,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+778044,int_stack+120696,int_stack+113598,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+799338,int_stack+778044,int_stack+728904,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+835842,int_stack+799338,int_stack+747156,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+713460,int_stack+128886,int_stack+120696,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+887322,int_stack+713460,int_stack+778044,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+738030,int_stack+887322,int_stack+799338,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1284096,int_stack+738030,int_stack+835842,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+798870,int_stack+138246,int_stack+128886,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+826950,int_stack+798870,int_stack+713460,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1361316,int_stack+826950,int_stack+887322,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+876090,int_stack+1361316,int_stack+738030,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1432296,int_stack+876090,int_stack+1284096,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1284096,int_stack+148854,int_stack+138246,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+713460,int_stack+1284096,int_stack+798870,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1540404,int_stack+713460,int_stack+826950,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+769620,int_stack+1540404,int_stack+1361316,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1622304,int_stack+769620,int_stack+876090,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1750068,int_stack+1622304,int_stack+1432296,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+876090,int_stack+160788,int_stack+148854,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+911892,int_stack+876090,int_stack+1284096,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1284096,int_stack+911892,int_stack+713460,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1377696,int_stack+1284096,int_stack+1540404,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1894212,int_stack+1377696,int_stack+769620,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2043270,int_stack+1894212,int_stack+1622304,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1500546,int_stack+2043270,int_stack+1750068,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+713460,int_stack+174126,int_stack+160788,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+753474,int_stack+713460,int_stack+876090,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1685874,int_stack+753474,int_stack+911892,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+825078,int_stack+1685874,int_stack+1284096,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2213622,int_stack+825078,int_stack+1377696,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1284096,int_stack+2213622,int_stack+1894212,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1791954,int_stack+1284096,int_stack+2043270,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2385612,int_stack+1791954,int_stack+1500546,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1482840,int_stack+188946,int_stack+174126,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1527300,int_stack+1482840,int_stack+713460,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2010978,int_stack+1527300,int_stack+753474,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+2010978,int_stack+1685874,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2617272,int_stack+0,int_stack+825078,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+713460,int_stack+2617272,int_stack+2213622,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2813832,int_stack+713460,int_stack+1284096,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3069360,int_stack+2813832,int_stack+1791954,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1607328,int_stack+3069360,int_stack+2385612,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1284096,int_stack+205326,int_stack+188946,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1333236,int_stack+1284096,int_stack+1482840,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+2130318,int_stack+1333236,int_stack+1527300,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1284096,int_stack+2130318,int_stack+2010978,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1890468,int_stack+1284096,int_stack+0,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1284096,int_stack+1890468,int_stack+2617272,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1890468,int_stack+1284096,int_stack+713460,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1284096,int_stack+1890468,int_stack+2813832,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1890468,int_stack+1284096,int_stack+3069360,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2225088,int_stack+1890468,int_stack+1607328,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+1284096,int_stack+2225088,int_stack+996600,4356);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2146584,int_stack+229350,int_stack+223344,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2164602,int_stack+236448,int_stack+229350,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2185896,int_stack+2164602,int_stack+2146584,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2564856,int_stack+244729,int_stack+236448,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2589699,int_stack+2564856,int_stack+2164602,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2632287,int_stack+2589699,int_stack+2185896,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2146584,int_stack+254284,int_stack+244729,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2175249,int_stack+2146584,int_stack+2564856,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2692347,int_stack+2175249,int_stack+2589699,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2763327,int_stack+2692347,int_stack+2632287,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2564856,int_stack+265204,int_stack+254284,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2597616,int_stack+2564856,int_stack+2146584,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2853417,int_stack+2597616,int_stack+2175249,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2936227,int_stack+2853417,int_stack+2692347,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3042697,int_stack+2936227,int_stack+2763327,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2146584,int_stack+277580,int_stack+265204,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2654946,int_stack+2146584,int_stack+2564856,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2720466,int_stack+2654946,int_stack+2597616,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+3168823,int_stack+2720466,int_stack+2853417,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+713460,int_stack+3168823,int_stack+2936227,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2816016,int_stack+713460,int_stack+3042697,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2564856,int_stack+291503,int_stack+277580,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2984184,int_stack+2564856,int_stack+2146584,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3058440,int_stack+2984184,int_stack+2654946,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+862518,int_stack+3058440,int_stack+2720466,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2606625,int_stack+862518,int_stack+3168823,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1005843,int_stack+2606625,int_stack+713460,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1005843,int_stack+2816016,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+713460,int_stack+307064,int_stack+291503,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+760143,int_stack+713460,int_stack+2564856,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2780526,int_stack+760143,int_stack+2984184,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3167640,int_stack+2780526,int_stack+3058440,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2904286,int_stack+3167640,int_stack+862518,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3331440,int_stack+2904286,int_stack+2606625,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3563308,int_stack+3331440,int_stack+1005843,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+843681,int_stack+3563308,int_stack+0,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+324354,int_stack+307064,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+51870,int_stack+0,int_stack+713460,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+145236,int_stack+51870,int_stack+760143,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2564856,int_stack+145236,int_stack+2780526,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3818836,int_stack+2564856,int_stack+3167640,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+4048156,int_stack+3818836,int_stack+2904286,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2750496,int_stack+4048156,int_stack+3331440,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3048612,int_stack+2750496,int_stack+3563308,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+3368022,int_stack+3048612,int_stack+843681,91);
 /*--- compute (q0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+713460,int_stack+343464,int_stack+324354,91);
 /*--- compute (q0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+770790,int_stack+713460,int_stack+0,91);
 /*--- compute (q0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+874530,int_stack+770790,int_stack+51870,91);
 /*--- compute (q0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1030140,int_stack+874530,int_stack+145236,91);
 /*--- compute (q0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+1030140,int_stack+2564856,91);
 /*--- compute (q0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+713460,int_stack+0,int_stack+3818836,91);
 /*--- compute (q0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+713460,int_stack+4048156,91);
 /*--- compute (q0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+713460,int_stack+0,int_stack+2750496,91);
 /*--- compute (q0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2564856,int_stack+713460,int_stack+3048612,91);
 /*--- compute (q0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+713460,int_stack+2564856,int_stack+3368022,91);
 /*--- compute (op|nn) ---*/
 hrr1_build_op(Libint->AB,int_stack+2564856,int_stack+713460,int_stack+2225088,4356);
 /*--- compute (nd|nn) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3584160,int_stack+2564856,int_stack+1284096,4356);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1109856,int_stack+371415,int_stack+364485,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1130646,int_stack+379605,int_stack+371415,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1155216,int_stack+1130646,int_stack+1109856,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1196796,int_stack+389160,int_stack+379605,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1225461,int_stack+1196796,int_stack+1130646,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1274601,int_stack+1225461,int_stack+1155216,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1109856,int_stack+400185,int_stack+389160,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1343901,int_stack+1109856,int_stack+1196796,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1142931,int_stack+1343901,int_stack+1225461,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1401231,int_stack+1142931,int_stack+1274601,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1224831,int_stack+412785,int_stack+400185,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1262631,int_stack+1224831,int_stack+1109856,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1505181,int_stack+1262631,int_stack+1343901,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1600731,int_stack+1505181,int_stack+1142931,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1723581,int_stack+1600731,int_stack+1401231,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1109856,int_stack+427065,int_stack+412785,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1328781,int_stack+1109856,int_stack+1224831,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1869111,int_stack+1328781,int_stack+1262631,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1152696,int_stack+1869111,int_stack+1505181,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1404381,int_stack+1152696,int_stack+1600731,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1979361,int_stack+1404381,int_stack+1723581,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1576371,int_stack+443130,int_stack+427065,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1624566,int_stack+1576371,int_stack+1109856,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1710246,int_stack+1624566,int_stack+1328781,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2173401,int_stack+1710246,int_stack+1869111,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2338776,int_stack+2173401,int_stack+1152696,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1109856,int_stack+2338776,int_stack+1404381,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1109856,int_stack+1979361,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1339176,int_stack+461085,int_stack+443130,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1393041,int_stack+1339176,int_stack+1576371,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1836246,int_stack+1393041,int_stack+1624566,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1489431,int_stack+1836246,int_stack+1710246,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+5309136,int_stack+1489431,int_stack+2173401,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1979046,int_stack+5309136,int_stack+2338776,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2246586,int_stack+1979046,int_stack+1109856,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5540661,int_stack+2246586,int_stack+0,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+481035,int_stack+461085,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+59850,int_stack+0,int_stack+1339176,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+167580,int_stack+59850,int_stack+1393041,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1109856,int_stack+167580,int_stack+1836246,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1678431,int_stack+1109856,int_stack+1489431,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1324056,int_stack+1678431,int_stack+5309136,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+5852511,int_stack+1324056,int_stack+1979046,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+6196491,int_stack+5852511,int_stack+2246586,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1943031,int_stack+6196491,int_stack+5540661,105);
 /*--- compute (r0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+5309136,int_stack+503085,int_stack+481035,105);
 /*--- compute (r0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+5375286,int_stack+5309136,int_stack+0,105);
 /*--- compute (r0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+5494986,int_stack+5375286,int_stack+59850,105);
 /*--- compute (r0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+6565041,int_stack+5494986,int_stack+167580,105);
 /*--- compute (r0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+6565041,int_stack+1109856,105);
 /*--- compute (r0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+5309136,int_stack+0,int_stack+1678431,105);
 /*--- compute (r0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+5309136,int_stack+1324056,105);
 /*--- compute (r0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+5309136,int_stack+0,int_stack+5852511,105);
 /*--- compute (r0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+5309136,int_stack+6196491,105);
 /*--- compute (r0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+5309136,int_stack+0,int_stack+1943031,105);
 /*--- compute (qp|nn) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1109856,int_stack+5309136,int_stack+713460,4356);
 /*--- compute (od|nn) ---*/
 hrr1_build_od(Libint->AB,int_stack+5766516,int_stack+1109856,int_stack+2564856,4356);
 /*--- compute (nf|nn) ---*/
 hrr1_build_nf(Libint->AB,int_stack+7805124,int_stack+5766516,int_stack+3584160,4356);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+713460,int_stack+535260,int_stack+527340,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+737220,int_stack+544620,int_stack+535260,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+765300,int_stack+737220,int_stack+713460,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+812820,int_stack+555540,int_stack+544620,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+845580,int_stack+812820,int_stack+737220,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+901740,int_stack+845580,int_stack+765300,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+713460,int_stack+568140,int_stack+555540,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+980940,int_stack+713460,int_stack+812820,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+751260,int_stack+980940,int_stack+845580,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+751260,int_stack+901740,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+844860,int_stack+582540,int_stack+568140,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+888060,int_stack+844860,int_stack+713460,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+118800,int_stack+888060,int_stack+980940,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+963660,int_stack+118800,int_stack+751260,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+228000,int_stack+963660,int_stack+0,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+598860,int_stack+582540,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+713460,int_stack+0,int_stack+844860,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+394320,int_stack+713460,int_stack+888060,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+799860,int_stack+394320,int_stack+118800,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2299044,int_stack+799860,int_stack+963660,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2495604,int_stack+2299044,int_stack+228000,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+963660,int_stack+617220,int_stack+598860,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+48960,int_stack+963660,int_stack+0,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+146880,int_stack+48960,int_stack+713460,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2717364,int_stack+146880,int_stack+394320,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+290880,int_stack+2717364,int_stack+799860,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2906364,int_stack+290880,int_stack+2299044,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3168444,int_stack+2906364,int_stack+2495604,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2299044,int_stack+637740,int_stack+617220,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2360604,int_stack+2299044,int_stack+963660,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2470764,int_stack+2360604,int_stack+48960,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+713460,int_stack+2470764,int_stack+146880,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+713460,int_stack+2717364,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3453564,int_stack+0,int_stack+290880,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+264600,int_stack+3453564,int_stack+2906364,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2633964,int_stack+264600,int_stack+3168444,120);
 /*--- compute (t0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+2990364,int_stack+660540,int_stack+637740,120);
 /*--- compute (t0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+3058764,int_stack+2990364,int_stack+2299044,120);
 /*--- compute (t0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+3181884,int_stack+3058764,int_stack+2360604,120);
 /*--- compute (t0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+3759324,int_stack+3181884,int_stack+2470764,120);
 /*--- compute (t0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2299044,int_stack+3759324,int_stack+713460,120);
 /*--- compute (t0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+713460,int_stack+2299044,int_stack+0,120);
 /*--- compute (t0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+4004124,int_stack+713460,int_stack+3453564,120);
 /*--- compute (t0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+4397244,int_stack+4004124,int_stack+264600,120);
 /*--- compute (t0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+4397244,int_stack+2633964,120);
 /*--- compute (t0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+435600,int_stack+685740,int_stack+660540,120);
 /*--- compute (t0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+511200,int_stack+435600,int_stack+2990364,120);
 /*--- compute (t0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+2601444,int_stack+511200,int_stack+3058764,120);
 /*--- compute (t0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+435600,int_stack+2601444,int_stack+3181884,120);
 /*--- compute (t0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+2601444,int_stack+435600,int_stack+3759324,120);
 /*--- compute (t0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2944164,int_stack+2601444,int_stack+2299044,120);
 /*--- compute (t0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+2299044,int_stack+2944164,int_stack+713460,120);
 /*--- compute (t0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2752644,int_stack+2299044,int_stack+4004124,120);
 /*--- compute (t0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+3244044,int_stack+2752644,int_stack+4397244,120);
 /*--- compute (t0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2299044,int_stack+3244044,int_stack+0,120);
 /*--- compute (rp|nn) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2821764,int_stack+2299044,int_stack+5309136,4356);
 /*--- compute (qd|nn) ---*/
 hrr1_build_qd(Libint->AB,int_stack+10680084,int_stack+2821764,int_stack+1109856,4356);
 /*--- compute (of|nn) ---*/
 hrr1_build_of(Libint->AB,int_stack+0,int_stack+10680084,int_stack+5766516,4356);
 /*--- compute (ng|nn) ---*/
 hrr1_build_ng(Libint->AB,int_stack+3397680,int_stack+0,int_stack+7805124,4356);
 return int_stack+3397680;}
