/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nlnm(Libint_t*, prim_data*);

  /* Computes quartets of (nl|nm) integrals */

REALTYPE *hrr_order_nlnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[10][18] = int_stack + 60720;
 Libint->vrr_classes[10][19] = int_stack + 73260;
 Libint->vrr_classes[11][10] = int_stack + 87120;
 Libint->vrr_classes[11][11] = int_stack + 92268;
 Libint->vrr_classes[11][12] = int_stack + 98352;
 Libint->vrr_classes[11][13] = int_stack + 105450;
 Libint->vrr_classes[11][14] = int_stack + 113640;
 Libint->vrr_classes[11][15] = int_stack + 123000;
 Libint->vrr_classes[11][16] = int_stack + 133608;
 Libint->vrr_classes[11][17] = int_stack + 145542;
 Libint->vrr_classes[11][18] = int_stack + 158880;
 Libint->vrr_classes[11][19] = int_stack + 173700;
 Libint->vrr_classes[12][10] = int_stack + 190080;
 Libint->vrr_classes[12][11] = int_stack + 196086;
 Libint->vrr_classes[12][12] = int_stack + 203184;
 Libint->vrr_classes[12][13] = int_stack + 211465;
 Libint->vrr_classes[12][14] = int_stack + 221020;
 Libint->vrr_classes[12][15] = int_stack + 231940;
 Libint->vrr_classes[12][16] = int_stack + 244316;
 Libint->vrr_classes[12][17] = int_stack + 258239;
 Libint->vrr_classes[12][18] = int_stack + 273800;
 Libint->vrr_classes[12][19] = int_stack + 291090;
 Libint->vrr_classes[13][10] = int_stack + 310200;
 Libint->vrr_classes[13][11] = int_stack + 317130;
 Libint->vrr_classes[13][12] = int_stack + 325320;
 Libint->vrr_classes[13][13] = int_stack + 334875;
 Libint->vrr_classes[13][14] = int_stack + 345900;
 Libint->vrr_classes[13][15] = int_stack + 358500;
 Libint->vrr_classes[13][16] = int_stack + 372780;
 Libint->vrr_classes[13][17] = int_stack + 388845;
 Libint->vrr_classes[13][18] = int_stack + 406800;
 Libint->vrr_classes[13][19] = int_stack + 426750;
 Libint->vrr_classes[14][10] = int_stack + 448800;
 Libint->vrr_classes[14][11] = int_stack + 456720;
 Libint->vrr_classes[14][12] = int_stack + 466080;
 Libint->vrr_classes[14][13] = int_stack + 477000;
 Libint->vrr_classes[14][14] = int_stack + 489600;
 Libint->vrr_classes[14][15] = int_stack + 504000;
 Libint->vrr_classes[14][16] = int_stack + 520320;
 Libint->vrr_classes[14][17] = int_stack + 538680;
 Libint->vrr_classes[14][18] = int_stack + 559200;
 Libint->vrr_classes[14][19] = int_stack + 582000;
 Libint->vrr_classes[15][10] = int_stack + 607200;
 Libint->vrr_classes[15][11] = int_stack + 616176;
 Libint->vrr_classes[15][12] = int_stack + 626784;
 Libint->vrr_classes[15][13] = int_stack + 639160;
 Libint->vrr_classes[15][14] = int_stack + 653440;
 Libint->vrr_classes[15][15] = int_stack + 669760;
 Libint->vrr_classes[15][16] = int_stack + 688256;
 Libint->vrr_classes[15][17] = int_stack + 709064;
 Libint->vrr_classes[15][18] = int_stack + 732320;
 Libint->vrr_classes[15][19] = int_stack + 758160;
 Libint->vrr_classes[16][10] = int_stack + 786720;
 Libint->vrr_classes[16][11] = int_stack + 796818;
 Libint->vrr_classes[16][12] = int_stack + 808752;
 Libint->vrr_classes[16][13] = int_stack + 822675;
 Libint->vrr_classes[16][14] = int_stack + 838740;
 Libint->vrr_classes[16][15] = int_stack + 857100;
 Libint->vrr_classes[16][16] = int_stack + 877908;
 Libint->vrr_classes[16][17] = int_stack + 901317;
 Libint->vrr_classes[16][18] = int_stack + 927480;
 Libint->vrr_classes[16][19] = int_stack + 956550;
 Libint->vrr_classes[17][10] = int_stack + 988680;
 Libint->vrr_classes[17][11] = int_stack + 999966;
 Libint->vrr_classes[17][12] = int_stack + 1013304;
 Libint->vrr_classes[17][13] = int_stack + 1028865;
 Libint->vrr_classes[17][14] = int_stack + 1046820;
 Libint->vrr_classes[17][15] = int_stack + 1067340;
 Libint->vrr_classes[17][16] = int_stack + 1090596;
 Libint->vrr_classes[17][17] = int_stack + 1116759;
 Libint->vrr_classes[17][18] = int_stack + 1146000;
 Libint->vrr_classes[17][19] = int_stack + 1178490;
 Libint->vrr_classes[18][10] = int_stack + 1214400;
 Libint->vrr_classes[18][11] = int_stack + 1226940;
 Libint->vrr_classes[18][12] = int_stack + 1241760;
 Libint->vrr_classes[18][13] = int_stack + 1259050;
 Libint->vrr_classes[18][14] = int_stack + 1279000;
 Libint->vrr_classes[18][15] = int_stack + 1301800;
 Libint->vrr_classes[18][16] = int_stack + 1327640;
 Libint->vrr_classes[18][17] = int_stack + 1356710;
 Libint->vrr_classes[18][18] = int_stack + 1389200;
 Libint->vrr_classes[18][19] = int_stack + 1425300;
 memset(int_stack,0,1465200*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1465200;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nlnm(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1465200,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1478268,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1493712,int_stack+1478268,int_stack+1465200,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1519848,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1537866,int_stack+1519848,int_stack+1478268,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1568754,int_stack+1537866,int_stack+1493712,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1465200,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1612314,int_stack+1465200,int_stack+1519848,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1485990,int_stack+1612314,int_stack+1537866,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1648350,int_stack+1485990,int_stack+1568754,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1537470,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1561230,int_stack+1537470,int_stack+1465200,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1713690,int_stack+1561230,int_stack+1612314,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1773750,int_stack+1713690,int_stack+1485990,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1850970,int_stack+1773750,int_stack+1648350,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1465200,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1602810,int_stack+1465200,int_stack+1537470,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1942446,int_stack+1602810,int_stack+1561230,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1492128,int_stack+1942446,int_stack+1713690,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1650330,int_stack+1492128,int_stack+1773750,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2011746,int_stack+1650330,int_stack+1850970,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1758438,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1788732,int_stack+1758438,int_stack+1465200,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1842588,int_stack+1788732,int_stack+1602810,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2133714,int_stack+1842588,int_stack+1942446,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2237664,int_stack+2133714,int_stack+1492128,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1465200,int_stack+2237664,int_stack+1650330,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2363790,int_stack+1465200,int_stack+2011746,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1609344,int_stack+60720,int_stack+49434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1643202,int_stack+1609344,int_stack+1758438,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1921788,int_stack+1643202,int_stack+1788732,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1703790,int_stack+1921788,int_stack+1842588,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2520606,int_stack+1703790,int_stack+2133714,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2011548,int_stack+2520606,int_stack+2237664,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2666136,int_stack+2011548,int_stack+1465200,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2851464,int_stack+2666136,int_stack+2363790,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1465200,int_stack+73260,int_stack+60720,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1502820,int_stack+1465200,int_stack+1609344,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2179716,int_stack+1502820,int_stack+1643202,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1465200,int_stack+2179716,int_stack+1921788,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2179716,int_stack+1465200,int_stack+1703790,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1465200,int_stack+2179716,int_stack+2520606,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2179716,int_stack+1465200,int_stack+2011548,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1465200,int_stack+2179716,int_stack+2666136,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1696860,int_stack+1465200,int_stack+2851464,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1465200,int_stack+92268,int_stack+87120,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1480644,int_stack+98352,int_stack+92268,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1498896,int_stack+1480644,int_stack+1465200,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1529784,int_stack+105450,int_stack+98352,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1551078,int_stack+1529784,int_stack+1480644,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1587582,int_stack+1551078,int_stack+1498896,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1465200,int_stack+113640,int_stack+105450,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1639062,int_stack+1465200,int_stack+1529784,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1489770,int_stack+1639062,int_stack+1551078,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1936440,int_stack+1489770,int_stack+1587582,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1550610,int_stack+123000,int_stack+113640,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1578690,int_stack+1550610,int_stack+1465200,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2013660,int_stack+1578690,int_stack+1639062,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2084640,int_stack+2013660,int_stack+1489770,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2175900,int_stack+2084640,int_stack+1936440,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1936440,int_stack+133608,int_stack+123000,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1465200,int_stack+1936440,int_stack+1550610,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2284008,int_stack+1465200,int_stack+1578690,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1521360,int_stack+2284008,int_stack+2013660,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2365908,int_stack+1521360,int_stack+2084640,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1968264,int_stack+2365908,int_stack+2175900,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2112408,int_stack+145542,int_stack+133608,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2148210,int_stack+2112408,int_stack+1936440,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2493672,int_stack+2148210,int_stack+1465200,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2587272,int_stack+2493672,int_stack+2284008,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2211858,int_stack+2587272,int_stack+1521360,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1465200,int_stack+2211858,int_stack+2365908,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2710122,int_stack+1465200,int_stack+1968264,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1635552,int_stack+158880,int_stack+145542,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1936440,int_stack+1635552,int_stack+2112408,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2008044,int_stack+1936440,int_stack+2148210,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2895450,int_stack+2008044,int_stack+2493672,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2360916,int_stack+2895450,int_stack+2587272,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3035850,int_stack+2360916,int_stack+2211858,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2114124,int_stack+3035850,int_stack+1465200,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3234594,int_stack+2114124,int_stack+2710122,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1465200,int_stack+173700,int_stack+158880,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1509660,int_stack+1465200,int_stack+1635552,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2532906,int_stack+1509660,int_stack+1936440,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1465200,int_stack+2532906,int_stack+2008044,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2532906,int_stack+1465200,int_stack+2895450,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1465200,int_stack+2532906,int_stack+2360916,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2333148,int_stack+1465200,int_stack+3035850,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2588676,int_stack+2333148,int_stack+2114124,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1936440,int_stack+2588676,int_stack+3234594,78);
 /*--- compute (np|nm) ---*/
 hrr1_build_np(Libint->AB,int_stack+2219580,int_stack+1936440,int_stack+1696860,3630);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1465200,int_stack+196086,int_stack+190080,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1483218,int_stack+203184,int_stack+196086,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1504512,int_stack+1483218,int_stack+1465200,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1540548,int_stack+211465,int_stack+203184,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1565391,int_stack+1540548,int_stack+1483218,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1607979,int_stack+1565391,int_stack+1504512,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1465200,int_stack+221020,int_stack+211465,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1668039,int_stack+1465200,int_stack+1540548,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1493865,int_stack+1668039,int_stack+1565391,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1717725,int_stack+1493865,int_stack+1607979,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1564845,int_stack+231940,int_stack+221020,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1597605,int_stack+1564845,int_stack+1465200,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1807815,int_stack+1597605,int_stack+1668039,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2938320,int_stack+1807815,int_stack+1493865,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3044790,int_stack+2938320,int_stack+1717725,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1465200,int_stack+244316,int_stack+231940,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1654935,int_stack+1465200,int_stack+1564845,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3170916,int_stack+1654935,int_stack+1597605,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1502328,int_stack+3170916,int_stack+1807815,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1720455,int_stack+1502328,int_stack+2938320,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3266466,int_stack+1720455,int_stack+3044790,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2938320,int_stack+258239,int_stack+244316,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2980089,int_stack+2938320,int_stack+1465200,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3054345,int_stack+2980089,int_stack+1654935,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+3054345,int_stack+3170916,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3434634,int_stack+0,int_stack+1502328,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1465200,int_stack+3434634,int_stack+1720455,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1663944,int_stack+1465200,int_stack+3266466,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1880160,int_stack+273800,int_stack+258239,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+3163545,int_stack+1880160,int_stack+2938320,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3247083,int_stack+3163545,int_stack+2980089,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3608535,int_stack+3247083,int_stack+3054345,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2938320,int_stack+3608535,int_stack+0,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+2938320,int_stack+3434634,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3772335,int_stack+0,int_stack+1465200,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4027863,int_stack+3772335,int_stack+1663944,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1465200,int_stack+291090,int_stack+273800,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1517070,int_stack+1465200,int_stack+1880160,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1610436,int_stack+1517070,int_stack+3163545,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1749666,int_stack+1610436,int_stack+3247083,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1465200,int_stack+1749666,int_stack+3608535,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+3138975,int_stack+1465200,int_stack+2938320,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1465200,int_stack+3138975,int_stack+0,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2938320,int_stack+1465200,int_stack+3772335,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1465200,int_stack+2938320,int_stack+4027863,91);
 /*--- compute (op|nm) ---*/
 hrr1_build_op(Libint->AB,int_stack+2938320,int_stack+1465200,int_stack+1936440,3630);
 /*--- compute (nd|nm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3787740,int_stack+2938320,int_stack+2219580,3630);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1795530,int_stack+317130,int_stack+310200,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1816320,int_stack+325320,int_stack+317130,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1840890,int_stack+1816320,int_stack+1795530,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1882470,int_stack+334875,int_stack+325320,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1911135,int_stack+1882470,int_stack+1816320,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1960275,int_stack+1911135,int_stack+1840890,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1795530,int_stack+345900,int_stack+334875,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2029575,int_stack+1795530,int_stack+1882470,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1828605,int_stack+2029575,int_stack+1911135,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2086905,int_stack+1828605,int_stack+1960275,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1910505,int_stack+358500,int_stack+345900,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1948305,int_stack+1910505,int_stack+1795530,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2190855,int_stack+1948305,int_stack+2029575,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2286405,int_stack+2190855,int_stack+1828605,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2409255,int_stack+2286405,int_stack+2086905,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1795530,int_stack+372780,int_stack+358500,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2014455,int_stack+1795530,int_stack+1910505,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2554785,int_stack+2014455,int_stack+1948305,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1838370,int_stack+2554785,int_stack+2190855,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2090055,int_stack+1838370,int_stack+2286405,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2665035,int_stack+2090055,int_stack+2409255,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2262045,int_stack+388845,int_stack+372780,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2310240,int_stack+2262045,int_stack+1795530,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2395920,int_stack+2310240,int_stack+2014455,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+2395920,int_stack+2554785,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+165375,int_stack+0,int_stack+1838370,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1795530,int_stack+165375,int_stack+2090055,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+5225220,int_stack+1795530,int_stack+2665035,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2024850,int_stack+406800,int_stack+388845,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2078715,int_stack+2024850,int_stack+2262045,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2521920,int_stack+2078715,int_stack+2310240,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2175105,int_stack+2521920,int_stack+2395920,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2664720,int_stack+2175105,int_stack+0,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+5474700,int_stack+2664720,int_stack+165375,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+5474700,int_stack+1795530,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5742240,int_stack+0,int_stack+5225220,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+5225220,int_stack+426750,int_stack+406800,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+5285070,int_stack+5225220,int_stack+2024850,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1795530,int_stack+5285070,int_stack+2078715,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+5225220,int_stack+1795530,int_stack+2521920,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1795530,int_stack+5225220,int_stack+2175105,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2060130,int_stack+1795530,int_stack+2664720,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2368830,int_stack+2060130,int_stack+5474700,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1795530,int_stack+2368830,int_stack+0,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+1795530,int_stack+5742240,105);
 /*--- compute (qp|nm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1795530,int_stack+0,int_stack+1465200,3630);
 /*--- compute (od|nm) ---*/
 hrr1_build_od(Libint->AB,int_stack+5225220,int_stack+1795530,int_stack+2938320,3630);
 /*--- compute (nf|nm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+6924060,int_stack+5225220,int_stack+3787740,3630);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1465200,int_stack+456720,int_stack+448800,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1488960,int_stack+466080,int_stack+456720,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1517040,int_stack+1488960,int_stack+1465200,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1564560,int_stack+477000,int_stack+466080,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1597320,int_stack+1564560,int_stack+1488960,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1653480,int_stack+1597320,int_stack+1517040,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1465200,int_stack+489600,int_stack+477000,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2786520,int_stack+1465200,int_stack+1564560,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1503000,int_stack+2786520,int_stack+1597320,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2852040,int_stack+1503000,int_stack+1653480,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1596600,int_stack+504000,int_stack+489600,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1639800,int_stack+1596600,int_stack+1465200,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2970840,int_stack+1639800,int_stack+2786520,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3080040,int_stack+2970840,int_stack+1503000,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3220440,int_stack+3080040,int_stack+2852040,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2786520,int_stack+520320,int_stack+504000,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2835480,int_stack+2786520,int_stack+1596600,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1465200,int_stack+2835480,int_stack+1639800,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1591200,int_stack+1465200,int_stack+2970840,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3386760,int_stack+1591200,int_stack+3080040,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2921880,int_stack+3386760,int_stack+3220440,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3143640,int_stack+538680,int_stack+520320,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3198720,int_stack+3143640,int_stack+2786520,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3583320,int_stack+3198720,int_stack+2835480,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3727320,int_stack+3583320,int_stack+1465200,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3916320,int_stack+3727320,int_stack+1591200,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1465200,int_stack+3916320,int_stack+3386760,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3296640,int_stack+1465200,int_stack+2921880,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1727280,int_stack+559200,int_stack+538680,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2786520,int_stack+1727280,int_stack+3143640,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2896680,int_stack+2786520,int_stack+3198720,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3059880,int_stack+2896680,int_stack+3583320,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4145640,int_stack+3059880,int_stack+3727320,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3581760,int_stack+4145640,int_stack+3916320,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4410240,int_stack+3581760,int_stack+1465200,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4747200,int_stack+4410240,int_stack+3296640,120);
 /*--- compute (t0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1465200,int_stack+582000,int_stack+559200,120);
 /*--- compute (t0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1533600,int_stack+1465200,int_stack+1727280,120);
 /*--- compute (t0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+3275880,int_stack+1533600,int_stack+2786520,120);
 /*--- compute (t0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1465200,int_stack+3275880,int_stack+2896680,120);
 /*--- compute (t0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3275880,int_stack+1465200,int_stack+3059880,120);
 /*--- compute (t0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2786520,int_stack+3275880,int_stack+4145640,120);
 /*--- compute (t0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3139320,int_stack+2786520,int_stack+3581760,120);
 /*--- compute (t0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3532440,int_stack+3139320,int_stack+4410240,120);
 /*--- compute (t0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2786520,int_stack+3532440,int_stack+4747200,120);
 /*--- compute (rp|nm) ---*/
 hrr1_build_rp(Libint->AB,int_stack+3222120,int_stack+2786520,int_stack+0,3630);
 /*--- compute (qd|nm) ---*/
 hrr1_build_qd(Libint->AB,int_stack+9319860,int_stack+3222120,int_stack+1795530,3630);
 /*--- compute (of|nm) ---*/
 hrr1_build_of(Libint->AB,int_stack+11301840,int_stack+9319860,int_stack+5225220,3630);
 /*--- compute (ng|nm) ---*/
 hrr1_build_ng(Libint->AB,int_stack+14133240,int_stack+11301840,int_stack+6924060,3630);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+616176,int_stack+607200,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+26928,int_stack+626784,int_stack+616176,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58752,int_stack+26928,int_stack+0,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+112608,int_stack+639160,int_stack+626784,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+149736,int_stack+112608,int_stack+26928,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+213384,int_stack+149736,int_stack+58752,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+653440,int_stack+639160,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+303144,int_stack+0,int_stack+112608,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+42840,int_stack+303144,int_stack+149736,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+377400,int_stack+42840,int_stack+213384,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+148920,int_stack+669760,int_stack+653440,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+197880,int_stack+148920,int_stack+0,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+512040,int_stack+197880,int_stack+303144,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+4365570,int_stack+512040,int_stack+42840,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+4524690,int_stack+4365570,int_stack+377400,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+688256,int_stack+669760,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+283560,int_stack+0,int_stack+148920,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4713186,int_stack+283560,int_stack+197880,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+55488,int_stack+4713186,int_stack+512040,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+381480,int_stack+55488,int_stack+4365570,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4855986,int_stack+381480,int_stack+4524690,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+4365570,int_stack+709064,int_stack+688256,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+4427994,int_stack+4365570,int_stack+0,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+4538970,int_stack+4427994,int_stack+283560,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+5107314,int_stack+4538970,int_stack+4713186,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+5321514,int_stack+5107314,int_stack+55488,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+5321514,int_stack+381480,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+297024,int_stack+0,int_stack+4855986,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+620160,int_stack+732320,int_stack+709064,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+4702170,int_stack+620160,int_stack+4365570,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+4827018,int_stack+4702170,int_stack+4427994,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+5581410,int_stack+4827018,int_stack+4538970,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4365570,int_stack+5581410,int_stack+5107314,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+5826210,int_stack+4365570,int_stack+5321514,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+5011978,int_stack+5826210,int_stack+0,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+6172738,int_stack+5011978,int_stack+297024,136);
 /*--- compute (u0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+758160,int_stack+732320,136);
 /*--- compute (u0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+77520,int_stack+0,int_stack+620160,136);
 /*--- compute (u0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+217056,int_stack+77520,int_stack+4702170,136);
 /*--- compute (u0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+425136,int_stack+217056,int_stack+4827018,136);
 /*--- compute (u0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+425136,int_stack+5581410,136);
 /*--- compute (u0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+342720,int_stack+0,int_stack+4365570,136);
 /*--- compute (u0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+4365570,int_stack+342720,int_stack+5826210,136);
 /*--- compute (u0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+4365570,int_stack+5011978,136);
 /*--- compute (u0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+4365570,int_stack+0,int_stack+6172738,136);
 /*--- compute (tp|nm) ---*/
 hrr1_build_tp(Libint->AB,int_stack+4859250,int_stack+4365570,int_stack+2786520,3630);
 /*--- compute (rd|nm) ---*/
 hrr1_build_rd(Libint->AB,int_stack+6166050,int_stack+4859250,int_stack+3222120,3630);
 /*--- compute (qf|nm) ---*/
 hrr1_build_qf(Libint->AB,int_stack+17726940,int_stack+6166050,int_stack+9319860,3630);
 /*--- compute (og|nm) ---*/
 hrr1_build_og(Libint->AB,int_stack+21030240,int_stack+17726940,int_stack+11301840,3630);
 /*--- compute (nh|nm) ---*/
 hrr1_build_nh(Libint->AB,int_stack+8452950,int_stack+21030240,int_stack+14133240,3630);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+796818,int_stack+786720,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+30294,int_stack+808752,int_stack+796818,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+66096,int_stack+30294,int_stack+0,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+126684,int_stack+822675,int_stack+808752,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+168453,int_stack+126684,int_stack+30294,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+240057,int_stack+168453,int_stack+66096,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+838740,int_stack+822675,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+341037,int_stack+0,int_stack+126684,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+48195,int_stack+341037,int_stack+168453,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+424575,int_stack+48195,int_stack+240057,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+167535,int_stack+857100,int_stack+838740,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+222615,int_stack+167535,int_stack+0,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+576045,int_stack+222615,int_stack+341037,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+13484130,int_stack+576045,int_stack+48195,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+13663140,int_stack+13484130,int_stack+424575,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+877908,int_stack+857100,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+319005,int_stack+0,int_stack+167535,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+715275,int_stack+319005,int_stack+222615,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+62424,int_stack+715275,int_stack+576045,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+429165,int_stack+62424,int_stack+13484130,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+13875198,int_stack+429165,int_stack+13663140,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+13484130,int_stack+901317,int_stack+877908,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+13554357,int_stack+13484130,int_stack+0,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+13679205,int_stack+13554357,int_stack+319005,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+14157942,int_stack+13679205,int_stack+715275,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+14398917,int_stack+14157942,int_stack+62424,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+14398917,int_stack+429165,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+334152,int_stack+0,int_stack+13875198,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+697680,int_stack+927480,int_stack+901317,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+776169,int_stack+697680,int_stack+13484130,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+13862805,int_stack+776169,int_stack+13554357,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+14691300,int_stack+13862805,int_stack+13679205,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+13484130,int_stack+14691300,int_stack+14157942,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+14966700,int_stack+13484130,int_stack+14398917,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+14070885,int_stack+14966700,int_stack+0,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+15356544,int_stack+14070885,int_stack+334152,153);
 /*--- compute (v0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+956550,int_stack+927480,153);
 /*--- compute (v0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+87210,int_stack+0,int_stack+697680,153);
 /*--- compute (v0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+244188,int_stack+87210,int_stack+776169,153);
 /*--- compute (v0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+478278,int_stack+244188,int_stack+13862805,153);
 /*--- compute (v0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+478278,int_stack+14691300,153);
 /*--- compute (v0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+385560,int_stack+0,int_stack+13484130,153);
 /*--- compute (v0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+13484130,int_stack+385560,int_stack+14966700,153);
 /*--- compute (v0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+13484130,int_stack+14070885,153);
 /*--- compute (v0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+13484130,int_stack+0,int_stack+15356544,153);
 /*--- compute (up|nm) ---*/
 hrr1_build_up(Libint->AB,int_stack+14039520,int_stack+13484130,int_stack+4365570,3630);
 /*--- compute (td|nm) ---*/
 hrr1_build_td(Libint->AB,int_stack+1465200,int_stack+14039520,int_stack+4859250,3630);
 /*--- compute (rf|nm) ---*/
 hrr1_build_rf(Libint->AB,int_stack+25277340,int_stack+1465200,int_stack+6166050,3630);
 /*--- compute (qg|nm) ---*/
 hrr1_build_qg(Libint->AB,int_stack+29088840,int_stack+25277340,int_stack+17726940,3630);
 /*--- compute (oh|nm) ---*/
 hrr1_build_oh(Libint->AB,int_stack+34043790,int_stack+29088840,int_stack+21030240,3630);
 /*--- compute (ni|nm) ---*/
 hrr1_build_ni(Libint->AB,int_stack+15520560,int_stack+34043790,int_stack+8452950,3630);
 /*--- compute (w0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+999966,int_stack+988680,171);
 /*--- compute (w0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33858,int_stack+1013304,int_stack+999966,171);
 /*--- compute (w0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+73872,int_stack+33858,int_stack+0,171);
 /*--- compute (w0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+141588,int_stack+1028865,int_stack+1013304,171);
 /*--- compute (w0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+188271,int_stack+141588,int_stack+33858,171);
 /*--- compute (w0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+268299,int_stack+188271,int_stack+73872,171);
 /*--- compute (w0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+1046820,int_stack+1028865,171);
 /*--- compute (w0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+381159,int_stack+0,int_stack+141588,171);
 /*--- compute (w0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+53865,int_stack+381159,int_stack+188271,171);
 /*--- compute (w0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+474525,int_stack+53865,int_stack+268299,171);
 /*--- compute (w0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+187245,int_stack+1067340,int_stack+1046820,171);
 /*--- compute (w0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+248805,int_stack+187245,int_stack+0,171);
 /*--- compute (w0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+643815,int_stack+248805,int_stack+381159,171);
 /*--- compute (w0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+799425,int_stack+643815,int_stack+53865,171);
 /*--- compute (w0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+22228800,int_stack+799425,int_stack+474525,171);
 /*--- compute (w0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+1090596,int_stack+1067340,171);
 /*--- compute (w0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+356535,int_stack+0,int_stack+187245,171);
 /*--- compute (w0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+22465806,int_stack+356535,int_stack+248805,171);
 /*--- compute (w0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+69768,int_stack+22465806,int_stack+643815,171);
 /*--- compute (w0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+479655,int_stack+69768,int_stack+799425,171);
 /*--- compute (w0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+759753,int_stack+479655,int_stack+22228800,171);
 /*--- compute (w0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+22228800,int_stack+1116759,int_stack+1090596,171);
 /*--- compute (w0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+22307289,int_stack+22228800,int_stack+0,171);
 /*--- compute (w0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+22645356,int_stack+22307289,int_stack+356535,171);
 /*--- compute (w0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+22850556,int_stack+22645356,int_stack+22465806,171);
 /*--- compute (w0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+23119881,int_stack+22850556,int_stack+69768,171);
 /*--- compute (w0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+23119881,int_stack+479655,171);
 /*--- compute (w0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+23446662,int_stack+0,int_stack+759753,171);
 /*--- compute (w0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+373464,int_stack+1146000,int_stack+1116759,171);
 /*--- compute (w0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+461187,int_stack+373464,int_stack+22228800,171);
 /*--- compute (w0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+618165,int_stack+461187,int_stack+22307289,171);
 /*--- compute (w0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+22228800,int_stack+618165,int_stack+22645356,171);
 /*--- compute (w0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+23852958,int_stack+22228800,int_stack+22850556,171);
 /*--- compute (w0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+22536600,int_stack+23852958,int_stack+23119881,171);
 /*--- compute (w0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+24230013,int_stack+22536600,int_stack+0,171);
 /*--- compute (w0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+24710181,int_stack+24230013,int_stack+23446662,171);
 /*--- compute (w0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+1178490,int_stack+1146000,171);
 /*--- compute (w0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+97470,int_stack+0,int_stack+373464,171);
 /*--- compute (w0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+22972308,int_stack+97470,int_stack+461187,171);
 /*--- compute (w0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+22972308,int_stack+618165,171);
 /*--- compute (w0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+22972308,int_stack+0,int_stack+22228800,171);
 /*--- compute (w0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+0,int_stack+22972308,int_stack+23852958,171);
 /*--- compute (w0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+22972308,int_stack+0,int_stack+22536600,171);
 /*--- compute (w0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+22972308,int_stack+24230013,171);
 /*--- compute (w0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+22228800,int_stack+0,int_stack+24710181,171);
 /*--- compute (vp|nm) ---*/
 hrr1_build_vp(Libint->AB,int_stack+22849530,int_stack+22228800,int_stack+13484130,3630);
 /*--- compute (ud|nm) ---*/
 hrr1_build_ud(Libint->AB,int_stack+4078800,int_stack+22849530,int_stack+14039520,3630);
 /*--- compute (tf|nm) ---*/
 hrr1_build_tf(Libint->AB,int_stack+7040880,int_stack+4078800,int_stack+1465200,3630);
 /*--- compute (rg|nm) ---*/
 hrr1_build_rg(Libint->AB,int_stack+39989730,int_stack+7040880,int_stack+25277340,3630);
 /*--- compute (qh|nm) ---*/
 hrr1_build_qh(Libint->AB,int_stack+45706980,int_stack+39989730,int_stack+29088840,3630);
 /*--- compute (oi|nm) ---*/
 hrr1_build_oi(Libint->AB,int_stack+24515700,int_stack+45706980,int_stack+34043790,3630);
 /*--- compute (nk|nm) ---*/
 hrr1_build_nk(Libint->AB,int_stack+52643910,int_stack+24515700,int_stack+15520560,3630);
 /*--- compute (x0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1465200,int_stack+1226940,int_stack+1214400,190);
 /*--- compute (x0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1502820,int_stack+1241760,int_stack+1226940,190);
 /*--- compute (x0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1547280,int_stack+1502820,int_stack+1465200,190);
 /*--- compute (x0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1622520,int_stack+1259050,int_stack+1241760,190);
 /*--- compute (x0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1674390,int_stack+1622520,int_stack+1502820,190);
 /*--- compute (x0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1763310,int_stack+1674390,int_stack+1547280,190);
 /*--- compute (x0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1465200,int_stack+1279000,int_stack+1259050,190);
 /*--- compute (x0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1888710,int_stack+1465200,int_stack+1622520,190);
 /*--- compute (x0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1525050,int_stack+1888710,int_stack+1674390,190);
 /*--- compute (x0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1992450,int_stack+1525050,int_stack+1763310,190);
 /*--- compute (x0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1673250,int_stack+1301800,int_stack+1279000,190);
 /*--- compute (x0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1741650,int_stack+1673250,int_stack+1465200,190);
 /*--- compute (x0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2180550,int_stack+1741650,int_stack+1888710,190);
 /*--- compute (x0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2353450,int_stack+2180550,int_stack+1525050,190);
 /*--- compute (x0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2575750,int_stack+2353450,int_stack+1992450,190);
 /*--- compute (x0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1465200,int_stack+1327640,int_stack+1301800,190);
 /*--- compute (x0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1861350,int_stack+1465200,int_stack+1673250,190);
 /*--- compute (x0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2839090,int_stack+1861350,int_stack+1741650,190);
 /*--- compute (x0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1542720,int_stack+2839090,int_stack+2180550,190);
 /*--- compute (x0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1998150,int_stack+1542720,int_stack+2353450,190);
 /*--- compute (x0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3038590,int_stack+1998150,int_stack+2575750,190);
 /*--- compute (x0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2309370,int_stack+1356710,int_stack+1327640,190);
 /*--- compute (x0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2396580,int_stack+2309370,int_stack+1465200,190);
 /*--- compute (x0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2551620,int_stack+2396580,int_stack+1861350,190);
 /*--- compute (x0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3389710,int_stack+2551620,int_stack+2839090,190);
 /*--- compute (x0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3688960,int_stack+3389710,int_stack+1542720,190);
 /*--- compute (x0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1465200,int_stack+3688960,int_stack+1998150,190);
 /*--- compute (x0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1465200,int_stack+3038590,190);
 /*--- compute (x0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1880160,int_stack+1389200,int_stack+1356710,190);
 /*--- compute (x0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1977630,int_stack+1880160,int_stack+2309370,190);
 /*--- compute (x0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2779620,int_stack+1977630,int_stack+2396580,190);
 /*--- compute (x0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2152050,int_stack+2779620,int_stack+2551620,190);
 /*--- compute (x0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+451440,int_stack+2152050,int_stack+3389710,190);
 /*--- compute (x0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3038020,int_stack+451440,int_stack+3688960,190);
 /*--- compute (x0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3522140,int_stack+3038020,int_stack+1465200,190);
 /*--- compute (x0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+32443620,int_stack+3522140,int_stack+0,190);
 /*--- compute (x0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+1425300,int_stack+1389200,190);
 /*--- compute (x0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+108300,int_stack+0,int_stack+1880160,190);
 /*--- compute (x0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+870390,int_stack+108300,int_stack+1977630,190);
 /*--- compute (x0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+870390,int_stack+2779620,190);
 /*--- compute (x0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+870390,int_stack+0,int_stack+2152050,190);
 /*--- compute (x0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1349190,int_stack+870390,int_stack+451440,190);
 /*--- compute (x0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+0,int_stack+1349190,int_stack+3038020,190);
 /*--- compute (x0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+622440,int_stack+0,int_stack+3522140,190);
 /*--- compute (x0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1289340,int_stack+622440,int_stack+32443620,190);
 /*--- compute (wp|nm) ---*/
 hrr1_build_wp(Libint->AB,int_stack+32443620,int_stack+1289340,int_stack+22228800,3630);
 /*--- compute (vd|nm) ---*/
 hrr1_build_vd(Libint->AB,int_stack+34305810,int_stack+32443620,int_stack+22849530,3630);
 /*--- compute (uf|nm) ---*/
 hrr1_build_uf(Libint->AB,int_stack+11396880,int_stack+34305810,int_stack+4078800,3630);
 /*--- compute (tg|nm) ---*/
 hrr1_build_tg(Libint->AB,int_stack+32443620,int_stack+11396880,int_stack+7040880,3630);
 /*--- compute (rh|nm) ---*/
 hrr1_build_rh(Libint->AB,int_stack+0,int_stack+32443620,int_stack+39989730,3630);
 /*--- compute (qi|nm) ---*/
 hrr1_build_qi(Libint->AB,int_stack+32443620,int_stack+0,int_stack+45706980,3630);
 /*--- compute (ok|nm) ---*/
 hrr1_build_ok(Libint->AB,int_stack+0,int_stack+32443620,int_stack+24515700,3630);
 /*--- compute (nl|nm) ---*/
 hrr1_build_nl(Libint->AB,int_stack+10193040,int_stack+0,int_stack+52643910,3630);
 return int_stack+10193040;}
