/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nplk(Libint_t*, prim_data*);

  /* Computes quartets of (np|lk) integrals */

REALTYPE *hrr_order_nplk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][8] = int_stack + 0;
 Libint->vrr_classes[10][9] = int_stack + 2970;
 Libint->vrr_classes[10][10] = int_stack + 6600;
 Libint->vrr_classes[10][11] = int_stack + 10956;
 Libint->vrr_classes[10][12] = int_stack + 16104;
 Libint->vrr_classes[10][13] = int_stack + 22110;
 Libint->vrr_classes[10][14] = int_stack + 29040;
 Libint->vrr_classes[10][15] = int_stack + 36960;
 Libint->vrr_classes[11][8] = int_stack + 45936;
 Libint->vrr_classes[11][9] = int_stack + 49446;
 Libint->vrr_classes[11][10] = int_stack + 53736;
 Libint->vrr_classes[11][11] = int_stack + 58884;
 Libint->vrr_classes[11][12] = int_stack + 64968;
 Libint->vrr_classes[11][13] = int_stack + 72066;
 Libint->vrr_classes[11][14] = int_stack + 80256;
 Libint->vrr_classes[11][15] = int_stack + 89616;
 memset(int_stack,0,100224*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 100224;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nplk(Libint, Data);
   Data++;
 }
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+100224,int_stack+2970,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+109134,int_stack+6600,int_stack+2970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+120024,int_stack+109134,int_stack+100224,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+137844,int_stack+10956,int_stack+6600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+150912,int_stack+137844,int_stack+109134,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+172692,int_stack+150912,int_stack+120024,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+100224,int_stack+16104,int_stack+10956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+202392,int_stack+100224,int_stack+137844,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+228528,int_stack+202392,int_stack+150912,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+115668,int_stack+228528,int_stack+172692,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+160218,int_stack+22110,int_stack+16104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+264828,int_stack+160218,int_stack+100224,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+295716,int_stack+264828,int_stack+202392,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+339276,int_stack+295716,int_stack+228528,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+178236,int_stack+339276,int_stack+115668,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+100224,int_stack+29040,int_stack+22110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+121014,int_stack+100224,int_stack+160218,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+393726,int_stack+121014,int_stack+264828,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+445206,int_stack+393726,int_stack+295716,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+240606,int_stack+445206,int_stack+339276,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+510546,int_stack+240606,int_stack+178236,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+157050,int_stack+36960,int_stack+29040,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+180810,int_stack+157050,int_stack+100224,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+316836,int_stack+180810,int_stack+121014,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+100224,int_stack+316836,int_stack+393726,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+316836,int_stack+100224,int_stack+445206,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+100224,int_stack+316836,int_stack+240606,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+201864,int_stack+100224,int_stack+510546,66);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+100224,int_stack+49446,int_stack+45936,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+110754,int_stack+53736,int_stack+49446,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+123624,int_stack+110754,int_stack+100224,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+144684,int_stack+58884,int_stack+53736,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+160128,int_stack+144684,int_stack+110754,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+308784,int_stack+160128,int_stack+123624,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+100224,int_stack+64968,int_stack+58884,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+343884,int_stack+100224,int_stack+144684,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+374772,int_stack+343884,int_stack+160128,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+118476,int_stack+374772,int_stack+308784,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+308784,int_stack+72066,int_stack+64968,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+417672,int_stack+308784,int_stack+100224,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+454176,int_stack+417672,int_stack+343884,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+505656,int_stack+454176,int_stack+374772,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+330078,int_stack+505656,int_stack+118476,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+100224,int_stack+80256,int_stack+72066,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+124794,int_stack+100224,int_stack+308784,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+124794,int_stack+417672,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+570006,int_stack+0,int_stack+454176,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+403788,int_stack+570006,int_stack+505656,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+647226,int_stack+403788,int_stack+330078,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+308784,int_stack+89616,int_stack+80256,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+336864,int_stack+308784,int_stack+100224,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+493878,int_stack+336864,int_stack+124794,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+308784,int_stack+493878,int_stack+0,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+308784,int_stack+570006,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+493878,int_stack+0,int_stack+403788,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+0,int_stack+493878,int_stack+647226,78);
 /*--- compute (np|lk) ---*/
 hrr1_build_np(Libint->AB,int_stack+308784,int_stack+0,int_stack+201864,1620);
 return int_stack+308784;}
