/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_p0if(Libint_t*, prim_data*);

  /* Computes quartets of (p0|if) integrals */

REALTYPE *hrr_order_p0if(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][6] = int_stack + 0;
 Libint->vrr_classes[1][7] = int_stack + 84;
 Libint->vrr_classes[1][8] = int_stack + 192;
 Libint->vrr_classes[1][9] = int_stack + 327;
 memset(int_stack,0,492*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 492;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_p0if(Libint, Data);
   Data++;
 }
 /*--- compute (p0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+492,int_stack+84,int_stack+0,3);
 /*--- compute (p0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+744,int_stack+192,int_stack+84,3);
 /*--- compute (p0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+1068,int_stack+744,int_stack+492,3);
 /*--- compute (p0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+1572,int_stack+327,int_stack+192,3);
 /*--- compute (p0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+0,int_stack+1572,int_stack+744,3);
 /*--- compute (p0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+1572,int_stack+0,int_stack+1068,3);
 return int_stack+1572;}
