/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ppkg(Libint_t*, prim_data*);

  /* Computes quartets of (pp|kg) integrals */

REALTYPE *hrr_order_ppkg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][7] = int_stack + 0;
 Libint->vrr_classes[1][8] = int_stack + 108;
 Libint->vrr_classes[1][9] = int_stack + 243;
 Libint->vrr_classes[1][10] = int_stack + 408;
 Libint->vrr_classes[1][11] = int_stack + 606;
 Libint->vrr_classes[2][7] = int_stack + 840;
 Libint->vrr_classes[2][8] = int_stack + 1056;
 Libint->vrr_classes[2][9] = int_stack + 1326;
 Libint->vrr_classes[2][10] = int_stack + 1656;
 Libint->vrr_classes[2][11] = int_stack + 2052;
 memset(int_stack,0,2520*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 2520;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ppkg(Libint, Data);
   Data++;
 }
 /*--- compute (p0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+2520,int_stack+108,int_stack+0,3);
 /*--- compute (p0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+2844,int_stack+243,int_stack+108,3);
 /*--- compute (p0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+3249,int_stack+2844,int_stack+2520,3);
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3897,int_stack+408,int_stack+243,3);
 /*--- compute (p0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+4392,int_stack+3897,int_stack+2844,3);
 /*--- compute (p0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+5202,int_stack+4392,int_stack+3249,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2520,int_stack+606,int_stack+408,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+6282,int_stack+2520,int_stack+3897,3);
 /*--- compute (p0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+2520,int_stack+6282,int_stack+4392,3);
 /*--- compute (p0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+6282,int_stack+2520,int_stack+5202,3);
 /*--- compute (d0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+2520,int_stack+1056,int_stack+840,6);
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3168,int_stack+1326,int_stack+1056,6);
 /*--- compute (d0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+3978,int_stack+3168,int_stack+2520,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+5274,int_stack+1656,int_stack+1326,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+5274,int_stack+3168,6);
 /*--- compute (d0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+7902,int_stack+0,int_stack+3978,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2520,int_stack+2052,int_stack+1656,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+10062,int_stack+2520,int_stack+5274,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+1620,int_stack+10062,int_stack+0,6);
 /*--- compute (d0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+10062,int_stack+1620,int_stack+7902,6);
 /*--- compute (pp|kg) ---*/
 hrr1_build_pp(Libint->AB,int_stack+0,int_stack+10062,int_stack+6282,540);
 return int_stack+0;}
