/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ppng(Libint_t*, prim_data*);

  /* Computes quartets of (pp|ng) integrals */

REALTYPE *hrr_order_ppng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][10] = int_stack + 0;
 Libint->vrr_classes[1][11] = int_stack + 198;
 Libint->vrr_classes[1][12] = int_stack + 432;
 Libint->vrr_classes[1][13] = int_stack + 705;
 Libint->vrr_classes[1][14] = int_stack + 1020;
 Libint->vrr_classes[2][10] = int_stack + 1380;
 Libint->vrr_classes[2][11] = int_stack + 1776;
 Libint->vrr_classes[2][12] = int_stack + 2244;
 Libint->vrr_classes[2][13] = int_stack + 2790;
 Libint->vrr_classes[2][14] = int_stack + 3420;
 memset(int_stack,0,4140*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 4140;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ppng(Libint, Data);
   Data++;
 }
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4140,int_stack+198,int_stack+0,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+4734,int_stack+432,int_stack+198,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+5436,int_stack+4734,int_stack+4140,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+6624,int_stack+705,int_stack+432,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+7443,int_stack+6624,int_stack+4734,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+8847,int_stack+7443,int_stack+5436,3);
 /*--- compute (p0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+4140,int_stack+1020,int_stack+705,3);
 /*--- compute (p0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+10827,int_stack+4140,int_stack+6624,3);
 /*--- compute (p0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+4140,int_stack+10827,int_stack+7443,3);
 /*--- compute (p0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+10827,int_stack+4140,int_stack+8847,3);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4140,int_stack+1776,int_stack+1380,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5328,int_stack+2244,int_stack+1776,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+6732,int_stack+5328,int_stack+4140,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+9108,int_stack+2790,int_stack+2244,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+13797,int_stack+9108,int_stack+5328,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+16605,int_stack+13797,int_stack+6732,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+4140,int_stack+3420,int_stack+2790,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+4140,int_stack+9108,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3276,int_stack+0,int_stack+13797,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+20565,int_stack+3276,int_stack+16605,6);
 /*--- compute (pp|ng) ---*/
 hrr1_build_pp(Libint->AB,int_stack+0,int_stack+20565,int_stack+10827,990);
 return int_stack+0;}
