/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (dd|kp) integrals */

void vrr_order_ddkp(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+5, Data->F+6, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+6, vrr_stack+31, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+9, vrr_stack+34, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+50, vrr_stack+21, vrr_stack+40, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+0, vrr_stack+3, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+65, vrr_stack+15, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+71, vrr_stack+21, vrr_stack+65, vrr_stack+15, NULL);
 _BUILD_p0g0(Data,vrr_stack+96, vrr_stack+81, vrr_stack+50, NULL, NULL, vrr_stack+21);
 _BUILD_00h0(Data,vrr_stack+141, vrr_stack+81, vrr_stack+50, vrr_stack+71, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+162, vrr_stack+15, vrr_stack+65, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+172, vrr_stack+162, vrr_stack+71, vrr_stack+15, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+187, vrr_stack+172, vrr_stack+81, vrr_stack+162, vrr_stack+71, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+31, vrr_stack+0, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+34, vrr_stack+65, vrr_stack+6, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+208, vrr_stack+40, vrr_stack+71, vrr_stack+9, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+223, vrr_stack+50, vrr_stack+208, vrr_stack+21, vrr_stack+40, NULL);
 _BUILD_p0h0(Data,vrr_stack+244, vrr_stack+141, vrr_stack+223, NULL, NULL, vrr_stack+50);
 _BUILD_p0h0(Data,vrr_stack+307, vrr_stack+187, vrr_stack+141, NULL, NULL, vrr_stack+81);
 _BUILD_d0h0(Data,vrr_stack+370, vrr_stack+307, vrr_stack+244, vrr_stack+187, vrr_stack+141, vrr_stack+96);
 _BUILD_00i0(Data,vrr_stack+96, vrr_stack+141, vrr_stack+223, vrr_stack+81, vrr_stack+50, NULL);
 _BUILD_00i0(Data,vrr_stack+496, vrr_stack+187, vrr_stack+141, vrr_stack+172, vrr_stack+81, NULL);
 _BUILD_p0i0(Data,vrr_stack+524, vrr_stack+496, vrr_stack+96, NULL, NULL, vrr_stack+141);
 _BUILD_00p0(Data,vrr_stack+81, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+84, vrr_stack+81, vrr_stack+3, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+84, vrr_stack+15, vrr_stack+81, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+124, vrr_stack+21, vrr_stack+162, vrr_stack+84, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+608, vrr_stack+124, vrr_stack+172, vrr_stack+21, vrr_stack+162, NULL);
 _BUILD_00i0(Data,vrr_stack+629, vrr_stack+608, vrr_stack+187, vrr_stack+124, vrr_stack+172, NULL);
 _BUILD_p0i0(Data,vrr_stack+657, vrr_stack+629, vrr_stack+496, NULL, NULL, vrr_stack+187);
 _BUILD_00p0(Data,vrr_stack+162, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+90, vrr_stack+0, vrr_stack+162, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+165, vrr_stack+65, vrr_stack+90, vrr_stack+31, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+71, vrr_stack+165, vrr_stack+34, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+741, vrr_stack+208, vrr_stack+3, vrr_stack+40, vrr_stack+71, NULL);
 _BUILD_00i0(Data,vrr_stack+762, vrr_stack+223, vrr_stack+741, vrr_stack+50, vrr_stack+208, NULL);
 _BUILD_p0i0(Data,vrr_stack+790, vrr_stack+96, vrr_stack+762, NULL, NULL, vrr_stack+223);
 _BUILD_d0i0(Data,vrr_stack+874, vrr_stack+524, vrr_stack+790, vrr_stack+496, vrr_stack+96, vrr_stack+244);
 _BUILD_d0i0(Data,vrr_stack+1042, vrr_stack+657, vrr_stack+524, vrr_stack+629, vrr_stack+496, vrr_stack+307);
 _BUILD_f0i0(Data,vrr_stack+1210, vrr_stack+1042, vrr_stack+874, vrr_stack+657, vrr_stack+524, vrr_stack+370);
 _BUILD_00k0(Data,vrr_stack+244, vrr_stack+496, vrr_stack+96, vrr_stack+187, vrr_stack+141, NULL);
 _BUILD_00k0(Data,vrr_stack+280, vrr_stack+629, vrr_stack+496, vrr_stack+608, vrr_stack+187, NULL);
 _BUILD_00k0(Data,vrr_stack+316, vrr_stack+96, vrr_stack+762, vrr_stack+141, vrr_stack+223, NULL);
 _BUILD_p0k0(Data,vrr_stack+352, vrr_stack+244, vrr_stack+316, NULL, NULL, vrr_stack+96);
 _BUILD_p0k0(Data,vrr_stack+1490, vrr_stack+280, vrr_stack+244, NULL, NULL, vrr_stack+496);
 _BUILD_d0k0(Data,vrr_stack+1598, vrr_stack+1490, vrr_stack+352, vrr_stack+280, vrr_stack+244, vrr_stack+524);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+524, vrr_stack+18, vrr_stack+81, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+530, vrr_stack+524, vrr_stack+84, vrr_stack+18, vrr_stack+81, NULL);
 _BUILD_00g0(Data,vrr_stack+540, vrr_stack+530, vrr_stack+21, vrr_stack+524, vrr_stack+84, NULL);
 _BUILD_00h0(Data,vrr_stack+555, vrr_stack+540, vrr_stack+124, vrr_stack+530, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+18, vrr_stack+555, vrr_stack+608, vrr_stack+540, vrr_stack+124, NULL);
 _BUILD_00k0(Data,vrr_stack+460, vrr_stack+18, vrr_stack+629, vrr_stack+555, vrr_stack+608, NULL);
 _BUILD_p0k0(Data,vrr_stack+1814, vrr_stack+460, vrr_stack+280, NULL, NULL, vrr_stack+629);
 _BUILD_d0k0(Data,vrr_stack+1922, vrr_stack+1814, vrr_stack+1490, vrr_stack+460, vrr_stack+280, vrr_stack+657);
   tmp = vrr_stack + 1922;
   target_ptr = Libint->vrr_classes[2][7];
   for(i=0;i<216;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+657, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+660, vrr_stack+162, vrr_stack+657, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+666, vrr_stack+90, vrr_stack+660, vrr_stack+0, vrr_stack+162, NULL);
 _BUILD_00g0(Data,vrr_stack+676, vrr_stack+165, vrr_stack+666, vrr_stack+65, vrr_stack+90, NULL);
 _BUILD_00h0(Data,vrr_stack+691, vrr_stack+3, vrr_stack+676, vrr_stack+71, vrr_stack+165, NULL);
 _BUILD_00i0(Data,vrr_stack+712, vrr_stack+741, vrr_stack+691, vrr_stack+208, vrr_stack+3, NULL);
 _BUILD_00k0(Data,vrr_stack+124, vrr_stack+762, vrr_stack+712, vrr_stack+223, vrr_stack+741, NULL);
 _BUILD_p0k0(Data,vrr_stack+2138, vrr_stack+316, vrr_stack+124, NULL, NULL, vrr_stack+762);
 _BUILD_d0k0(Data,vrr_stack+2246, vrr_stack+352, vrr_stack+2138, vrr_stack+244, vrr_stack+316, vrr_stack+790);
 _BUILD_f0k0(Data,vrr_stack+2462, vrr_stack+1598, vrr_stack+2246, vrr_stack+1490, vrr_stack+352, vrr_stack+874);
 _BUILD_f0k0(Data,vrr_stack+2822, vrr_stack+1922, vrr_stack+1598, vrr_stack+1814, vrr_stack+1490, vrr_stack+1042);
   tmp = vrr_stack + 2822;
   target_ptr = Libint->vrr_classes[3][7];
   for(i=0;i<360;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+1814, vrr_stack+244, vrr_stack+316, vrr_stack+496, vrr_stack+96, NULL);
 _BUILD_00l0(Data,vrr_stack+1859, vrr_stack+280, vrr_stack+244, vrr_stack+629, vrr_stack+496, NULL);
 _BUILD_00l0(Data,vrr_stack+496, vrr_stack+316, vrr_stack+124, vrr_stack+96, vrr_stack+762, NULL);
 _BUILD_p0l0(Data,vrr_stack+790, vrr_stack+1814, vrr_stack+496, NULL, NULL, vrr_stack+316);
 _BUILD_p0l0(Data,vrr_stack+925, vrr_stack+1859, vrr_stack+1814, NULL, NULL, vrr_stack+244);
 _BUILD_d0l0(Data,vrr_stack+3182, vrr_stack+925, vrr_stack+790, vrr_stack+1859, vrr_stack+1814, vrr_stack+352);
 _BUILD_00l0(Data,vrr_stack+316, vrr_stack+460, vrr_stack+280, vrr_stack+18, vrr_stack+629, NULL);
 _BUILD_p0l0(Data,vrr_stack+361, vrr_stack+316, vrr_stack+1859, NULL, NULL, vrr_stack+280);
 _BUILD_d0l0(Data,vrr_stack+3452, vrr_stack+361, vrr_stack+925, vrr_stack+316, vrr_stack+1859, vrr_stack+1490);
   tmp = vrr_stack + 3452;
   target_ptr = Libint->vrr_classes[2][8];
   for(i=0;i<270;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1490, vrr_stack+657, vrr_stack+0, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+1496, vrr_stack+660, vrr_stack+1490, vrr_stack+162, vrr_stack+657, NULL);
 _BUILD_00g0(Data,vrr_stack+1506, vrr_stack+666, vrr_stack+1496, vrr_stack+90, vrr_stack+660, NULL);
 _BUILD_00h0(Data,vrr_stack+1521, vrr_stack+676, vrr_stack+1506, vrr_stack+165, vrr_stack+666, NULL);
 _BUILD_00i0(Data,vrr_stack+1490, vrr_stack+691, vrr_stack+1521, vrr_stack+3, vrr_stack+676, NULL);
 _BUILD_00k0(Data,vrr_stack+1518, vrr_stack+712, vrr_stack+1490, vrr_stack+741, vrr_stack+691, NULL);
 _BUILD_00l0(Data,vrr_stack+0, vrr_stack+124, vrr_stack+1518, vrr_stack+762, vrr_stack+712, NULL);
 _BUILD_p0l0(Data,vrr_stack+541, vrr_stack+496, vrr_stack+0, NULL, NULL, vrr_stack+124);
 _BUILD_d0l0(Data,vrr_stack+0, vrr_stack+790, vrr_stack+541, vrr_stack+1814, vrr_stack+496, vrr_stack+2138);
 _BUILD_f0l0(Data,vrr_stack+3722, vrr_stack+3182, vrr_stack+0, vrr_stack+925, vrr_stack+790, vrr_stack+2246);
 _BUILD_f0l0(Data,vrr_stack+4172, vrr_stack+3452, vrr_stack+3182, vrr_stack+361, vrr_stack+925, vrr_stack+1598);
   tmp = vrr_stack + 4172;
   target_ptr = Libint->vrr_classes[3][8];
   for(i=0;i<450;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0k0(Data,vrr_stack+0, vrr_stack+2822, vrr_stack+2462, vrr_stack+1922, vrr_stack+1598, vrr_stack+1210);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[4][7];
   for(i=0;i<540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0l0(Data,vrr_stack+540, vrr_stack+4172, vrr_stack+3722, vrr_stack+3452, vrr_stack+3182, vrr_stack+2462);
   tmp = vrr_stack + 540;
   target_ptr = Libint->vrr_classes[4][8];
   for(i=0;i<675;i++)
     target_ptr[i] += tmp[i];

}

