/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (f0|kp) integrals */

void vrr_order_f0kp(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+12, vrr_stack+3, Data->F+3, Data->F+4, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+0, vrr_stack+21, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+6, vrr_stack+24, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+6, vrr_stack+12, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+50, vrr_stack+40, vrr_stack+30, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+21, vrr_stack+3, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+24, vrr_stack+65, vrr_stack+0, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+30, vrr_stack+71, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+50, vrr_stack+81, vrr_stack+40, vrr_stack+30, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+0, vrr_stack+12, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+6, vrr_stack+15, vrr_stack+0, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+127, vrr_stack+117, vrr_stack+40, vrr_stack+6, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+127, vrr_stack+50, vrr_stack+117, vrr_stack+40, NULL);
 _BUILD_p0h0(Data,vrr_stack+163, vrr_stack+142, vrr_stack+96, NULL, NULL, vrr_stack+50);
 _BUILD_00i0(Data,vrr_stack+226, vrr_stack+142, vrr_stack+96, vrr_stack+127, vrr_stack+50, NULL);
 _BUILD_00p0(Data,vrr_stack+40, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+43, vrr_stack+40, vrr_stack+0, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+254, vrr_stack+43, vrr_stack+6, vrr_stack+40, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+264, vrr_stack+254, vrr_stack+117, vrr_stack+43, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+279, vrr_stack+264, vrr_stack+127, vrr_stack+254, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+300, vrr_stack+279, vrr_stack+142, vrr_stack+264, vrr_stack+127, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+117, vrr_stack+3, vrr_stack+0, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+123, vrr_stack+65, vrr_stack+117, vrr_stack+21, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+6, vrr_stack+71, vrr_stack+123, vrr_stack+24, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+328, vrr_stack+81, vrr_stack+6, vrr_stack+30, vrr_stack+71, NULL);
 _BUILD_00i0(Data,vrr_stack+349, vrr_stack+96, vrr_stack+328, vrr_stack+50, vrr_stack+81, NULL);
 _BUILD_p0i0(Data,vrr_stack+377, vrr_stack+226, vrr_stack+349, NULL, NULL, vrr_stack+96);
 _BUILD_p0i0(Data,vrr_stack+461, vrr_stack+300, vrr_stack+226, NULL, NULL, vrr_stack+142);
 _BUILD_d0i0(Data,vrr_stack+545, vrr_stack+461, vrr_stack+377, vrr_stack+300, vrr_stack+226, vrr_stack+163);
 _BUILD_00k0(Data,vrr_stack+163, vrr_stack+226, vrr_stack+349, vrr_stack+142, vrr_stack+96, NULL);
 _BUILD_00k0(Data,vrr_stack+713, vrr_stack+300, vrr_stack+226, vrr_stack+279, vrr_stack+142, NULL);
 _BUILD_p0k0(Data,vrr_stack+749, vrr_stack+713, vrr_stack+163, NULL, NULL, vrr_stack+226);
 _BUILD_00p0(Data,vrr_stack+199, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+202, vrr_stack+199, vrr_stack+40, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+208, vrr_stack+202, vrr_stack+43, vrr_stack+199, vrr_stack+40, NULL);
 _BUILD_00g0(Data,vrr_stack+133, vrr_stack+208, vrr_stack+254, vrr_stack+202, vrr_stack+43, NULL);
 _BUILD_00h0(Data,vrr_stack+21, vrr_stack+133, vrr_stack+264, vrr_stack+208, vrr_stack+254, NULL);
 _BUILD_00i0(Data,vrr_stack+857, vrr_stack+21, vrr_stack+279, vrr_stack+133, vrr_stack+264, NULL);
 _BUILD_00k0(Data,vrr_stack+885, vrr_stack+857, vrr_stack+300, vrr_stack+21, vrr_stack+279, NULL);
 _BUILD_p0k0(Data,vrr_stack+921, vrr_stack+885, vrr_stack+713, NULL, NULL, vrr_stack+300);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+0, vrr_stack+21, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+117, vrr_stack+24, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+40, vrr_stack+123, vrr_stack+30, vrr_stack+65, vrr_stack+117, NULL);
 _BUILD_00h0(Data,vrr_stack+133, vrr_stack+6, vrr_stack+40, vrr_stack+71, vrr_stack+123, NULL);
 _BUILD_00i0(Data,vrr_stack+254, vrr_stack+328, vrr_stack+133, vrr_stack+81, vrr_stack+6, NULL);
 _BUILD_00k0(Data,vrr_stack+55, vrr_stack+349, vrr_stack+254, vrr_stack+96, vrr_stack+328, NULL);
 _BUILD_p0k0(Data,vrr_stack+1029, vrr_stack+163, vrr_stack+55, NULL, NULL, vrr_stack+349);
 _BUILD_d0k0(Data,vrr_stack+1137, vrr_stack+749, vrr_stack+1029, vrr_stack+713, vrr_stack+163, vrr_stack+377);
 _BUILD_d0k0(Data,vrr_stack+1353, vrr_stack+921, vrr_stack+749, vrr_stack+885, vrr_stack+713, vrr_stack+461);
 _BUILD_00l0(Data,vrr_stack+377, vrr_stack+163, vrr_stack+55, vrr_stack+226, vrr_stack+349, NULL);
 _BUILD_00l0(Data,vrr_stack+422, vrr_stack+713, vrr_stack+163, vrr_stack+300, vrr_stack+226, NULL);
 _BUILD_p0l0(Data,vrr_stack+1569, vrr_stack+422, vrr_stack+377, NULL, NULL, vrr_stack+163);
 _BUILD_00l0(Data,vrr_stack+467, vrr_stack+885, vrr_stack+713, vrr_stack+857, vrr_stack+300, NULL);
 _BUILD_p0l0(Data,vrr_stack+1704, vrr_stack+467, vrr_stack+422, NULL, NULL, vrr_stack+713);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+713, vrr_stack+21, vrr_stack+3, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+719, vrr_stack+24, vrr_stack+713, vrr_stack+0, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+729, vrr_stack+30, vrr_stack+719, vrr_stack+117, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+857, vrr_stack+40, vrr_stack+729, vrr_stack+123, vrr_stack+30, NULL);
 _BUILD_00i0(Data,vrr_stack+713, vrr_stack+133, vrr_stack+857, vrr_stack+6, vrr_stack+40, NULL);
 _BUILD_00k0(Data,vrr_stack+857, vrr_stack+254, vrr_stack+713, vrr_stack+328, vrr_stack+133, NULL);
 _BUILD_00l0(Data,vrr_stack+0, vrr_stack+55, vrr_stack+857, vrr_stack+349, vrr_stack+254, NULL);
 _BUILD_p0l0(Data,vrr_stack+91, vrr_stack+377, vrr_stack+0, NULL, NULL, vrr_stack+55);
 _BUILD_d0l0(Data,vrr_stack+1839, vrr_stack+1569, vrr_stack+91, vrr_stack+422, vrr_stack+377, vrr_stack+1029);
 _BUILD_d0l0(Data,vrr_stack+0, vrr_stack+1704, vrr_stack+1569, vrr_stack+467, vrr_stack+422, vrr_stack+749);
 _BUILD_f0k0(Data,vrr_stack+2109, vrr_stack+1353, vrr_stack+1137, vrr_stack+921, vrr_stack+749, vrr_stack+545);
   tmp = vrr_stack + 2109;
   target_ptr = Libint->vrr_classes[3][7];
   for(i=0;i<360;i++)
     target_ptr[i] += tmp[i];
 _BUILD_f0l0(Data,vrr_stack+270, vrr_stack+0, vrr_stack+1839, vrr_stack+1704, vrr_stack+1569, vrr_stack+1137);
   tmp = vrr_stack + 270;
   target_ptr = Libint->vrr_classes[3][8];
   for(i=0;i<450;i++)
     target_ptr[i] += tmp[i];

}

