/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (fd|hf) integrals */

void vrr_order_fdhf(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, NULL, NULL, Data->F+5);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+21, vrr_stack+3, Data->F+3, Data->F+4, NULL);
 _BUILD_00p0(Data,vrr_stack+30, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+33, vrr_stack+0, vrr_stack+30, Data->F+5, Data->F+6, NULL);
 _BUILD_p0d0(Data,vrr_stack+39, vrr_stack+15, vrr_stack+33, NULL, NULL, vrr_stack+0);
 _BUILD_p0d0(Data,vrr_stack+57, vrr_stack+24, vrr_stack+15, NULL, NULL, vrr_stack+3);
 _BUILD_d0d0(Data,vrr_stack+75, vrr_stack+57, vrr_stack+39, vrr_stack+24, vrr_stack+15, vrr_stack+6);
 _BUILD_00f0(Data,vrr_stack+111, vrr_stack+15, vrr_stack+33, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00f0(Data,vrr_stack+121, vrr_stack+24, vrr_stack+15, vrr_stack+21, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+131, vrr_stack+121, vrr_stack+111, NULL, NULL, vrr_stack+15);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+21, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+161, vrr_stack+6, vrr_stack+24, vrr_stack+3, vrr_stack+21, NULL);
 _BUILD_p0f0(Data,vrr_stack+171, vrr_stack+161, vrr_stack+121, NULL, NULL, vrr_stack+24);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+201, vrr_stack+30, vrr_stack+21, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+207, vrr_stack+33, vrr_stack+201, vrr_stack+0, vrr_stack+30, NULL);
 _BUILD_p0f0(Data,vrr_stack+217, vrr_stack+111, vrr_stack+207, NULL, NULL, vrr_stack+33);
 _BUILD_d0f0(Data,vrr_stack+247, vrr_stack+131, vrr_stack+217, vrr_stack+121, vrr_stack+111, vrr_stack+39);
 _BUILD_d0f0(Data,vrr_stack+307, vrr_stack+171, vrr_stack+131, vrr_stack+161, vrr_stack+121, vrr_stack+57);
 _BUILD_f0f0(Data,vrr_stack+367, vrr_stack+307, vrr_stack+247, vrr_stack+171, vrr_stack+131, vrr_stack+75);
 _BUILD_00g0(Data,vrr_stack+39, vrr_stack+121, vrr_stack+111, vrr_stack+24, vrr_stack+15, NULL);
 _BUILD_00g0(Data,vrr_stack+54, vrr_stack+161, vrr_stack+121, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_00g0(Data,vrr_stack+69, vrr_stack+111, vrr_stack+207, vrr_stack+15, vrr_stack+33, NULL);
 _BUILD_p0g0(Data,vrr_stack+467, vrr_stack+39, vrr_stack+69, NULL, NULL, vrr_stack+111);
 _BUILD_p0g0(Data,vrr_stack+512, vrr_stack+54, vrr_stack+39, NULL, NULL, vrr_stack+121);
 _BUILD_d0g0(Data,vrr_stack+557, vrr_stack+512, vrr_stack+467, vrr_stack+54, vrr_stack+39, vrr_stack+131);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+0, vrr_stack+3, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+131, vrr_stack+24, vrr_stack+6, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+141, vrr_stack+131, vrr_stack+161, vrr_stack+24, vrr_stack+6, NULL);
 _BUILD_p0g0(Data,vrr_stack+647, vrr_stack+141, vrr_stack+54, NULL, NULL, vrr_stack+161);
 _BUILD_d0g0(Data,vrr_stack+692, vrr_stack+647, vrr_stack+512, vrr_stack+141, vrr_stack+54, vrr_stack+171);
 _BUILD_00p0(Data,vrr_stack+171, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+174, vrr_stack+21, vrr_stack+171, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+180, vrr_stack+201, vrr_stack+174, vrr_stack+30, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+207, vrr_stack+180, vrr_stack+33, vrr_stack+201, NULL);
 _BUILD_p0g0(Data,vrr_stack+782, vrr_stack+69, vrr_stack+3, NULL, NULL, vrr_stack+207);
 _BUILD_d0g0(Data,vrr_stack+827, vrr_stack+467, vrr_stack+782, vrr_stack+39, vrr_stack+69, vrr_stack+217);
 _BUILD_f0g0(Data,vrr_stack+917, vrr_stack+557, vrr_stack+827, vrr_stack+512, vrr_stack+467, vrr_stack+247);
 _BUILD_f0g0(Data,vrr_stack+1067, vrr_stack+692, vrr_stack+557, vrr_stack+647, vrr_stack+512, vrr_stack+307);
 _BUILD_g0g0(Data,vrr_stack+1217, vrr_stack+1067, vrr_stack+917, vrr_stack+692, vrr_stack+557, vrr_stack+367);
 _BUILD_00h0(Data,vrr_stack+217, vrr_stack+39, vrr_stack+69, vrr_stack+121, vrr_stack+111, NULL);
 _BUILD_00h0(Data,vrr_stack+238, vrr_stack+54, vrr_stack+39, vrr_stack+161, vrr_stack+121, NULL);
 _BUILD_p0h0(Data,vrr_stack+259, vrr_stack+238, vrr_stack+217, NULL, NULL, vrr_stack+39);
 _BUILD_00h0(Data,vrr_stack+322, vrr_stack+141, vrr_stack+54, vrr_stack+131, vrr_stack+161, NULL);
 _BUILD_p0h0(Data,vrr_stack+343, vrr_stack+322, vrr_stack+238, NULL, NULL, vrr_stack+54);
 _BUILD_00h0(Data,vrr_stack+406, vrr_stack+69, vrr_stack+3, vrr_stack+111, vrr_stack+207, NULL);
 _BUILD_p0h0(Data,vrr_stack+1442, vrr_stack+217, vrr_stack+406, NULL, NULL, vrr_stack+69);
 _BUILD_d0h0(Data,vrr_stack+1505, vrr_stack+259, vrr_stack+1442, vrr_stack+238, vrr_stack+217, vrr_stack+467);
 _BUILD_d0h0(Data,vrr_stack+1631, vrr_stack+343, vrr_stack+259, vrr_stack+322, vrr_stack+238, vrr_stack+512);
 _BUILD_f0h0(Data,vrr_stack+1757, vrr_stack+1631, vrr_stack+1505, vrr_stack+343, vrr_stack+259, vrr_stack+557);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+427, vrr_stack+18, vrr_stack+0, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+433, vrr_stack+427, vrr_stack+24, vrr_stack+18, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+156, vrr_stack+433, vrr_stack+131, vrr_stack+427, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+443, vrr_stack+156, vrr_stack+141, vrr_stack+433, vrr_stack+131, NULL);
 _BUILD_p0h0(Data,vrr_stack+464, vrr_stack+443, vrr_stack+322, NULL, NULL, vrr_stack+141);
 _BUILD_d0h0(Data,vrr_stack+1967, vrr_stack+464, vrr_stack+343, vrr_stack+443, vrr_stack+322, vrr_stack+647);
 _BUILD_f0h0(Data,vrr_stack+2093, vrr_stack+1967, vrr_stack+1631, vrr_stack+464, vrr_stack+343, vrr_stack+692);
   tmp = vrr_stack + 2093;
   target_ptr = Libint->vrr_classes[3][5];
   for(i=0;i<210;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+464, vrr_stack+171, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+470, vrr_stack+174, vrr_stack+464, vrr_stack+21, vrr_stack+171, NULL);
 _BUILD_00g0(Data,vrr_stack+480, vrr_stack+180, vrr_stack+470, vrr_stack+201, vrr_stack+174, NULL);
 _BUILD_00h0(Data,vrr_stack+18, vrr_stack+3, vrr_stack+480, vrr_stack+207, vrr_stack+180, NULL);
 _BUILD_p0h0(Data,vrr_stack+495, vrr_stack+406, vrr_stack+18, NULL, NULL, vrr_stack+3);
 _BUILD_d0h0(Data,vrr_stack+558, vrr_stack+1442, vrr_stack+495, vrr_stack+217, vrr_stack+406, vrr_stack+782);
 _BUILD_f0h0(Data,vrr_stack+2303, vrr_stack+1505, vrr_stack+558, vrr_stack+259, vrr_stack+1442, vrr_stack+827);
 _BUILD_g0h0(Data,vrr_stack+2513, vrr_stack+1757, vrr_stack+2303, vrr_stack+1631, vrr_stack+1505, vrr_stack+917);
 _BUILD_g0h0(Data,vrr_stack+684, vrr_stack+2093, vrr_stack+1757, vrr_stack+1967, vrr_stack+1631, vrr_stack+1067);
   tmp = vrr_stack + 684;
   target_ptr = Libint->vrr_classes[4][5];
   for(i=0;i<315;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00i0(Data,vrr_stack+1967, vrr_stack+217, vrr_stack+406, vrr_stack+39, vrr_stack+69, NULL);
 _BUILD_00i0(Data,vrr_stack+1995, vrr_stack+238, vrr_stack+217, vrr_stack+54, vrr_stack+39, NULL);
 _BUILD_p0i0(Data,vrr_stack+999, vrr_stack+1995, vrr_stack+1967, NULL, NULL, vrr_stack+217);
 _BUILD_00i0(Data,vrr_stack+2023, vrr_stack+322, vrr_stack+238, vrr_stack+141, vrr_stack+54, NULL);
 _BUILD_p0i0(Data,vrr_stack+1083, vrr_stack+2023, vrr_stack+1995, NULL, NULL, vrr_stack+238);
 _BUILD_00i0(Data,vrr_stack+39, vrr_stack+406, vrr_stack+18, vrr_stack+69, vrr_stack+3, NULL);
 _BUILD_p0i0(Data,vrr_stack+2828, vrr_stack+1967, vrr_stack+39, NULL, NULL, vrr_stack+406);
 _BUILD_d0i0(Data,vrr_stack+2912, vrr_stack+999, vrr_stack+2828, vrr_stack+1995, vrr_stack+1967, vrr_stack+1442);
 _BUILD_d0i0(Data,vrr_stack+3080, vrr_stack+1083, vrr_stack+999, vrr_stack+2023, vrr_stack+1995, vrr_stack+259);
 _BUILD_f0i0(Data,vrr_stack+3248, vrr_stack+3080, vrr_stack+2912, vrr_stack+1083, vrr_stack+999, vrr_stack+1505);
 _BUILD_00i0(Data,vrr_stack+259, vrr_stack+443, vrr_stack+322, vrr_stack+156, vrr_stack+141, NULL);
 _BUILD_p0i0(Data,vrr_stack+1442, vrr_stack+259, vrr_stack+2023, NULL, NULL, vrr_stack+322);
 _BUILD_d0i0(Data,vrr_stack+3528, vrr_stack+1442, vrr_stack+1083, vrr_stack+259, vrr_stack+2023, vrr_stack+343);
 _BUILD_f0i0(Data,vrr_stack+3696, vrr_stack+3528, vrr_stack+3080, vrr_stack+1442, vrr_stack+1083, vrr_stack+1631);
   tmp = vrr_stack + 3696;
   target_ptr = Libint->vrr_classes[3][6];
   for(i=0;i<280;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+1442, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1445, vrr_stack+0, vrr_stack+1442, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+1451, vrr_stack+464, vrr_stack+1445, vrr_stack+171, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+1461, vrr_stack+470, vrr_stack+1451, vrr_stack+174, vrr_stack+464, NULL);
 _BUILD_00h0(Data,vrr_stack+1476, vrr_stack+480, vrr_stack+1461, vrr_stack+180, vrr_stack+470, NULL);
 _BUILD_00i0(Data,vrr_stack+1497, vrr_stack+18, vrr_stack+1476, vrr_stack+3, vrr_stack+480, NULL);
 _BUILD_p0i0(Data,vrr_stack+1525, vrr_stack+39, vrr_stack+1497, NULL, NULL, vrr_stack+18);
 _BUILD_d0i0(Data,vrr_stack+3976, vrr_stack+2828, vrr_stack+1525, vrr_stack+1967, vrr_stack+39, vrr_stack+495);
 _BUILD_f0i0(Data,vrr_stack+4144, vrr_stack+2912, vrr_stack+3976, vrr_stack+999, vrr_stack+2828, vrr_stack+558);
 _BUILD_g0i0(Data,vrr_stack+4424, vrr_stack+3248, vrr_stack+4144, vrr_stack+3080, vrr_stack+2912, vrr_stack+2303);
 _BUILD_g0i0(Data,vrr_stack+4844, vrr_stack+3696, vrr_stack+3248, vrr_stack+3528, vrr_stack+3080, vrr_stack+1757);
   tmp = vrr_stack + 4844;
   target_ptr = Libint->vrr_classes[4][6];
   for(i=0;i<420;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00k0(Data,vrr_stack+3528, vrr_stack+1967, vrr_stack+39, vrr_stack+217, vrr_stack+406, NULL);
 _BUILD_00k0(Data,vrr_stack+3564, vrr_stack+1995, vrr_stack+1967, vrr_stack+238, vrr_stack+217, NULL);
 _BUILD_p0k0(Data,vrr_stack+2303, vrr_stack+3564, vrr_stack+3528, NULL, NULL, vrr_stack+1967);
 _BUILD_00k0(Data,vrr_stack+3600, vrr_stack+2023, vrr_stack+1995, vrr_stack+322, vrr_stack+238, NULL);
 _BUILD_p0k0(Data,vrr_stack+495, vrr_stack+3600, vrr_stack+3564, NULL, NULL, vrr_stack+1995);
 _BUILD_00k0(Data,vrr_stack+3636, vrr_stack+39, vrr_stack+1497, vrr_stack+406, vrr_stack+18, NULL);
 _BUILD_p0k0(Data,vrr_stack+1609, vrr_stack+3528, vrr_stack+3636, NULL, NULL, vrr_stack+39);
 _BUILD_d0k0(Data,vrr_stack+5264, vrr_stack+2303, vrr_stack+1609, vrr_stack+3564, vrr_stack+3528, vrr_stack+2828);
 _BUILD_d0k0(Data,vrr_stack+5480, vrr_stack+495, vrr_stack+2303, vrr_stack+3600, vrr_stack+3564, vrr_stack+999);
 _BUILD_f0k0(Data,vrr_stack+5696, vrr_stack+5480, vrr_stack+5264, vrr_stack+495, vrr_stack+2303, vrr_stack+2912);
 _BUILD_00k0(Data,vrr_stack+999, vrr_stack+259, vrr_stack+2023, vrr_stack+443, vrr_stack+322, NULL);
 _BUILD_p0k0(Data,vrr_stack+2828, vrr_stack+999, vrr_stack+3600, NULL, NULL, vrr_stack+2023);
 _BUILD_d0k0(Data,vrr_stack+6056, vrr_stack+2828, vrr_stack+495, vrr_stack+999, vrr_stack+3600, vrr_stack+1083);
 _BUILD_f0k0(Data,vrr_stack+6272, vrr_stack+6056, vrr_stack+5480, vrr_stack+2828, vrr_stack+495, vrr_stack+3080);
   tmp = vrr_stack + 6272;
   target_ptr = Libint->vrr_classes[3][7];
   for(i=0;i<360;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+2828, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2831, vrr_stack+1442, vrr_stack+2828, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+2837, vrr_stack+1445, vrr_stack+2831, vrr_stack+0, vrr_stack+1442, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+1451, vrr_stack+2837, vrr_stack+464, vrr_stack+1445, NULL);
 _BUILD_00h0(Data,vrr_stack+2847, vrr_stack+1461, vrr_stack+0, vrr_stack+470, vrr_stack+1451, NULL);
 _BUILD_00i0(Data,vrr_stack+2868, vrr_stack+1476, vrr_stack+2847, vrr_stack+480, vrr_stack+1461, NULL);
 _BUILD_00k0(Data,vrr_stack+2896, vrr_stack+1497, vrr_stack+2868, vrr_stack+18, vrr_stack+1476, NULL);
 _BUILD_p0k0(Data,vrr_stack+2932, vrr_stack+3636, vrr_stack+2896, NULL, NULL, vrr_stack+1497);
 _BUILD_d0k0(Data,vrr_stack+6632, vrr_stack+1609, vrr_stack+2932, vrr_stack+3528, vrr_stack+3636, vrr_stack+1525);
 _BUILD_f0k0(Data,vrr_stack+6848, vrr_stack+5264, vrr_stack+6632, vrr_stack+2303, vrr_stack+1609, vrr_stack+3976);
 _BUILD_g0k0(Data,vrr_stack+7208, vrr_stack+5696, vrr_stack+6848, vrr_stack+5480, vrr_stack+5264, vrr_stack+4144);
 _BUILD_g0k0(Data,vrr_stack+7748, vrr_stack+6272, vrr_stack+5696, vrr_stack+6056, vrr_stack+5480, vrr_stack+3248);
   tmp = vrr_stack + 7748;
   target_ptr = Libint->vrr_classes[4][7];
   for(i=0;i<540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+6056, vrr_stack+3528, vrr_stack+3636, vrr_stack+1967, vrr_stack+39, NULL);
 _BUILD_00l0(Data,vrr_stack+6101, vrr_stack+3564, vrr_stack+3528, vrr_stack+1995, vrr_stack+1967, NULL);
 _BUILD_p0l0(Data,vrr_stack+3976, vrr_stack+6101, vrr_stack+6056, NULL, NULL, vrr_stack+3528);
 _BUILD_00l0(Data,vrr_stack+6146, vrr_stack+3600, vrr_stack+3564, vrr_stack+2023, vrr_stack+1995, NULL);
 _BUILD_p0l0(Data,vrr_stack+4111, vrr_stack+6146, vrr_stack+6101, NULL, NULL, vrr_stack+3564);
 _BUILD_00l0(Data,vrr_stack+3528, vrr_stack+3636, vrr_stack+2896, vrr_stack+39, vrr_stack+1497, NULL);
 _BUILD_p0l0(Data,vrr_stack+4246, vrr_stack+6056, vrr_stack+3528, NULL, NULL, vrr_stack+3636);
 _BUILD_d0l0(Data,vrr_stack+8288, vrr_stack+3976, vrr_stack+4246, vrr_stack+6101, vrr_stack+6056, vrr_stack+1609);
 _BUILD_d0l0(Data,vrr_stack+8558, vrr_stack+4111, vrr_stack+3976, vrr_stack+6146, vrr_stack+6101, vrr_stack+2303);
 _BUILD_f0l0(Data,vrr_stack+8828, vrr_stack+8558, vrr_stack+8288, vrr_stack+4111, vrr_stack+3976, vrr_stack+5264);
 _BUILD_00l0(Data,vrr_stack+6101, vrr_stack+999, vrr_stack+3600, vrr_stack+259, vrr_stack+2023, NULL);
 _BUILD_p0l0(Data,vrr_stack+999, vrr_stack+6101, vrr_stack+6146, NULL, NULL, vrr_stack+3600);
 _BUILD_d0l0(Data,vrr_stack+15, vrr_stack+999, vrr_stack+4111, vrr_stack+6101, vrr_stack+6146, vrr_stack+495);
 _BUILD_f0l0(Data,vrr_stack+9278, vrr_stack+15, vrr_stack+8558, vrr_stack+999, vrr_stack+4111, vrr_stack+5480);
   tmp = vrr_stack + 9278;
   target_ptr = Libint->vrr_classes[3][8];
   for(i=0;i<450;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+4111, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+4114, vrr_stack+2828, vrr_stack+4111, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+4120, vrr_stack+2831, vrr_stack+4114, vrr_stack+1442, vrr_stack+2828, NULL);
 _BUILD_00g0(Data,vrr_stack+4130, vrr_stack+2837, vrr_stack+4120, vrr_stack+1445, vrr_stack+2831, NULL);
 _BUILD_00h0(Data,vrr_stack+4145, vrr_stack+0, vrr_stack+4130, vrr_stack+1451, vrr_stack+2837, NULL);
 _BUILD_00i0(Data,vrr_stack+4111, vrr_stack+2847, vrr_stack+4145, vrr_stack+1461, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+4139, vrr_stack+2868, vrr_stack+4111, vrr_stack+1476, vrr_stack+2847, NULL);
 _BUILD_00l0(Data,vrr_stack+1442, vrr_stack+2896, vrr_stack+4139, vrr_stack+1497, vrr_stack+2868, NULL);
 _BUILD_p0l0(Data,vrr_stack+4111, vrr_stack+3528, vrr_stack+1442, NULL, NULL, vrr_stack+2896);
 _BUILD_d0l0(Data,vrr_stack+1442, vrr_stack+4246, vrr_stack+4111, vrr_stack+6056, vrr_stack+3528, vrr_stack+2932);
 _BUILD_f0l0(Data,vrr_stack+9728, vrr_stack+8288, vrr_stack+1442, vrr_stack+3976, vrr_stack+4246, vrr_stack+6632);
 _BUILD_g0l0(Data,vrr_stack+10178, vrr_stack+8828, vrr_stack+9728, vrr_stack+8558, vrr_stack+8288, vrr_stack+6848);
 _BUILD_g0l0(Data,vrr_stack+10853, vrr_stack+9278, vrr_stack+8828, vrr_stack+15, vrr_stack+8558, vrr_stack+5696);
   tmp = vrr_stack + 10853;
   target_ptr = Libint->vrr_classes[4][8];
   for(i=0;i<675;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0h0(Data,vrr_stack+8288, vrr_stack+684, vrr_stack+2513, vrr_stack+2093, vrr_stack+1757, vrr_stack+1217);
   tmp = vrr_stack + 8288;
   target_ptr = Libint->vrr_classes[5][5];
   for(i=0;i<441;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0i0(Data,vrr_stack+0, vrr_stack+4844, vrr_stack+4424, vrr_stack+3696, vrr_stack+3248, vrr_stack+2513);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[5][6];
   for(i=0;i<588;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0k0(Data,vrr_stack+4844, vrr_stack+7748, vrr_stack+7208, vrr_stack+6272, vrr_stack+5696, vrr_stack+4424);
   tmp = vrr_stack + 4844;
   target_ptr = Libint->vrr_classes[5][7];
   for(i=0;i<756;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0l0(Data,vrr_stack+5600, vrr_stack+10853, vrr_stack+10178, vrr_stack+9278, vrr_stack+8828, vrr_stack+7208);
   tmp = vrr_stack + 5600;
   target_ptr = Libint->vrr_classes[5][8];
   for(i=0;i<945;i++)
     target_ptr[i] += tmp[i];

}

