/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (hp|ip) integrals */

void vrr_order_hpip(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, NULL, NULL, Data->F+6);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+5, Data->F+6, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+21, vrr_stack+3, Data->F+4, Data->F+5, NULL);
 _BUILD_00p0(Data,vrr_stack+30, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+33, vrr_stack+0, vrr_stack+30, Data->F+6, Data->F+7, NULL);
 _BUILD_p0d0(Data,vrr_stack+39, vrr_stack+15, vrr_stack+33, NULL, NULL, vrr_stack+0);
 _BUILD_p0d0(Data,vrr_stack+57, vrr_stack+24, vrr_stack+15, NULL, NULL, vrr_stack+3);
 _BUILD_d0d0(Data,vrr_stack+75, vrr_stack+57, vrr_stack+39, vrr_stack+24, vrr_stack+15, vrr_stack+6);
 _BUILD_00f0(Data,vrr_stack+111, vrr_stack+15, vrr_stack+33, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00f0(Data,vrr_stack+121, vrr_stack+24, vrr_stack+15, vrr_stack+21, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+131, vrr_stack+121, vrr_stack+111, NULL, NULL, vrr_stack+15);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+21, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+161, vrr_stack+6, vrr_stack+24, vrr_stack+3, vrr_stack+21, NULL);
 _BUILD_p0f0(Data,vrr_stack+171, vrr_stack+161, vrr_stack+121, NULL, NULL, vrr_stack+24);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+201, vrr_stack+30, vrr_stack+21, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+207, vrr_stack+33, vrr_stack+201, vrr_stack+0, vrr_stack+30, NULL);
 _BUILD_p0f0(Data,vrr_stack+217, vrr_stack+111, vrr_stack+207, NULL, NULL, vrr_stack+33);
 _BUILD_d0f0(Data,vrr_stack+247, vrr_stack+131, vrr_stack+217, vrr_stack+121, vrr_stack+111, vrr_stack+39);
 _BUILD_d0f0(Data,vrr_stack+307, vrr_stack+171, vrr_stack+131, vrr_stack+161, vrr_stack+121, vrr_stack+57);
 _BUILD_f0f0(Data,vrr_stack+367, vrr_stack+307, vrr_stack+247, vrr_stack+171, vrr_stack+131, vrr_stack+75);
 _BUILD_00g0(Data,vrr_stack+39, vrr_stack+121, vrr_stack+111, vrr_stack+24, vrr_stack+15, NULL);
 _BUILD_00g0(Data,vrr_stack+54, vrr_stack+161, vrr_stack+121, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_00g0(Data,vrr_stack+69, vrr_stack+111, vrr_stack+207, vrr_stack+15, vrr_stack+33, NULL);
 _BUILD_p0g0(Data,vrr_stack+467, vrr_stack+39, vrr_stack+69, NULL, NULL, vrr_stack+111);
 _BUILD_p0g0(Data,vrr_stack+512, vrr_stack+54, vrr_stack+39, NULL, NULL, vrr_stack+121);
 _BUILD_d0g0(Data,vrr_stack+557, vrr_stack+512, vrr_stack+467, vrr_stack+54, vrr_stack+39, vrr_stack+131);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+0, vrr_stack+3, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+131, vrr_stack+24, vrr_stack+6, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+141, vrr_stack+131, vrr_stack+161, vrr_stack+24, vrr_stack+6, NULL);
 _BUILD_p0g0(Data,vrr_stack+647, vrr_stack+141, vrr_stack+54, NULL, NULL, vrr_stack+161);
 _BUILD_d0g0(Data,vrr_stack+692, vrr_stack+647, vrr_stack+512, vrr_stack+141, vrr_stack+54, vrr_stack+171);
 _BUILD_00p0(Data,vrr_stack+171, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+174, vrr_stack+21, vrr_stack+171, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+180, vrr_stack+201, vrr_stack+174, vrr_stack+30, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+207, vrr_stack+180, vrr_stack+33, vrr_stack+201, NULL);
 _BUILD_p0g0(Data,vrr_stack+782, vrr_stack+69, vrr_stack+3, NULL, NULL, vrr_stack+207);
 _BUILD_d0g0(Data,vrr_stack+827, vrr_stack+467, vrr_stack+782, vrr_stack+39, vrr_stack+69, vrr_stack+217);
 _BUILD_f0g0(Data,vrr_stack+917, vrr_stack+557, vrr_stack+827, vrr_stack+512, vrr_stack+467, vrr_stack+247);
 _BUILD_f0g0(Data,vrr_stack+1067, vrr_stack+692, vrr_stack+557, vrr_stack+647, vrr_stack+512, vrr_stack+307);
 _BUILD_g0g0(Data,vrr_stack+1217, vrr_stack+1067, vrr_stack+917, vrr_stack+692, vrr_stack+557, vrr_stack+367);
 _BUILD_00h0(Data,vrr_stack+217, vrr_stack+39, vrr_stack+69, vrr_stack+121, vrr_stack+111, NULL);
 _BUILD_00h0(Data,vrr_stack+238, vrr_stack+54, vrr_stack+39, vrr_stack+161, vrr_stack+121, NULL);
 _BUILD_p0h0(Data,vrr_stack+259, vrr_stack+238, vrr_stack+217, NULL, NULL, vrr_stack+39);
 _BUILD_00h0(Data,vrr_stack+322, vrr_stack+141, vrr_stack+54, vrr_stack+131, vrr_stack+161, NULL);
 _BUILD_p0h0(Data,vrr_stack+343, vrr_stack+322, vrr_stack+238, NULL, NULL, vrr_stack+54);
 _BUILD_00h0(Data,vrr_stack+406, vrr_stack+69, vrr_stack+3, vrr_stack+111, vrr_stack+207, NULL);
 _BUILD_p0h0(Data,vrr_stack+1442, vrr_stack+217, vrr_stack+406, NULL, NULL, vrr_stack+69);
 _BUILD_d0h0(Data,vrr_stack+1505, vrr_stack+259, vrr_stack+1442, vrr_stack+238, vrr_stack+217, vrr_stack+467);
 _BUILD_d0h0(Data,vrr_stack+1631, vrr_stack+343, vrr_stack+259, vrr_stack+322, vrr_stack+238, vrr_stack+512);
 _BUILD_f0h0(Data,vrr_stack+1757, vrr_stack+1631, vrr_stack+1505, vrr_stack+343, vrr_stack+259, vrr_stack+557);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+427, vrr_stack+18, vrr_stack+0, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+433, vrr_stack+427, vrr_stack+24, vrr_stack+18, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+156, vrr_stack+433, vrr_stack+131, vrr_stack+427, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+443, vrr_stack+156, vrr_stack+141, vrr_stack+433, vrr_stack+131, NULL);
 _BUILD_p0h0(Data,vrr_stack+464, vrr_stack+443, vrr_stack+322, NULL, NULL, vrr_stack+141);
 _BUILD_d0h0(Data,vrr_stack+1967, vrr_stack+464, vrr_stack+343, vrr_stack+443, vrr_stack+322, vrr_stack+647);
 _BUILD_f0h0(Data,vrr_stack+2093, vrr_stack+1967, vrr_stack+1631, vrr_stack+464, vrr_stack+343, vrr_stack+692);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+171, vrr_stack+0, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+527, vrr_stack+174, vrr_stack+24, vrr_stack+21, vrr_stack+171, NULL);
 _BUILD_00g0(Data,vrr_stack+537, vrr_stack+180, vrr_stack+527, vrr_stack+201, vrr_stack+174, NULL);
 _BUILD_00h0(Data,vrr_stack+552, vrr_stack+3, vrr_stack+537, vrr_stack+207, vrr_stack+180, NULL);
 _BUILD_p0h0(Data,vrr_stack+573, vrr_stack+406, vrr_stack+552, NULL, NULL, vrr_stack+3);
 _BUILD_d0h0(Data,vrr_stack+636, vrr_stack+1442, vrr_stack+573, vrr_stack+217, vrr_stack+406, vrr_stack+782);
 _BUILD_f0h0(Data,vrr_stack+2303, vrr_stack+1505, vrr_stack+636, vrr_stack+259, vrr_stack+1442, vrr_stack+827);
 _BUILD_g0h0(Data,vrr_stack+2513, vrr_stack+1757, vrr_stack+2303, vrr_stack+1631, vrr_stack+1505, vrr_stack+917);
 _BUILD_g0h0(Data,vrr_stack+2828, vrr_stack+2093, vrr_stack+1757, vrr_stack+1967, vrr_stack+1631, vrr_stack+1067);
 _BUILD_h0h0(Data,vrr_stack+762, vrr_stack+2828, vrr_stack+2513, vrr_stack+2093, vrr_stack+1757, vrr_stack+1217);
 _BUILD_00i0(Data,vrr_stack+1203, vrr_stack+238, vrr_stack+217, vrr_stack+54, vrr_stack+39, NULL);
 _BUILD_00i0(Data,vrr_stack+1231, vrr_stack+322, vrr_stack+238, vrr_stack+141, vrr_stack+54, NULL);
 _BUILD_00i0(Data,vrr_stack+1259, vrr_stack+217, vrr_stack+406, vrr_stack+39, vrr_stack+69, NULL);
 _BUILD_p0i0(Data,vrr_stack+1287, vrr_stack+1203, vrr_stack+1259, NULL, NULL, vrr_stack+217);
 _BUILD_p0i0(Data,vrr_stack+3143, vrr_stack+1231, vrr_stack+1203, NULL, NULL, vrr_stack+238);
 _BUILD_d0i0(Data,vrr_stack+3227, vrr_stack+3143, vrr_stack+1287, vrr_stack+1231, vrr_stack+1203, vrr_stack+259);
 _BUILD_00i0(Data,vrr_stack+259, vrr_stack+443, vrr_stack+322, vrr_stack+156, vrr_stack+141, NULL);
 _BUILD_p0i0(Data,vrr_stack+3395, vrr_stack+259, vrr_stack+1231, NULL, NULL, vrr_stack+322);
 _BUILD_d0i0(Data,vrr_stack+3479, vrr_stack+3395, vrr_stack+3143, vrr_stack+259, vrr_stack+1231, vrr_stack+343);
 _BUILD_00i0(Data,vrr_stack+343, vrr_stack+406, vrr_stack+552, vrr_stack+69, vrr_stack+3, NULL);
 _BUILD_p0i0(Data,vrr_stack+30, vrr_stack+1259, vrr_stack+343, NULL, NULL, vrr_stack+406);
 _BUILD_d0i0(Data,vrr_stack+3647, vrr_stack+1287, vrr_stack+30, vrr_stack+1203, vrr_stack+1259, vrr_stack+1442);
 _BUILD_f0i0(Data,vrr_stack+3815, vrr_stack+3227, vrr_stack+3647, vrr_stack+3143, vrr_stack+1287, vrr_stack+1505);
 _BUILD_f0i0(Data,vrr_stack+4095, vrr_stack+3479, vrr_stack+3227, vrr_stack+3395, vrr_stack+3143, vrr_stack+1631);
 _BUILD_g0i0(Data,vrr_stack+4375, vrr_stack+4095, vrr_stack+3815, vrr_stack+3479, vrr_stack+3227, vrr_stack+1757);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+371, vrr_stack+21, vrr_stack+18, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+377, vrr_stack+371, vrr_stack+427, vrr_stack+21, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+387, vrr_stack+377, vrr_stack+433, vrr_stack+371, vrr_stack+427, NULL);
 _BUILD_00h0(Data,vrr_stack+287, vrr_stack+387, vrr_stack+156, vrr_stack+377, vrr_stack+433, NULL);
 _BUILD_00i0(Data,vrr_stack+114, vrr_stack+287, vrr_stack+443, vrr_stack+387, vrr_stack+156, NULL);
 _BUILD_p0i0(Data,vrr_stack+1371, vrr_stack+114, vrr_stack+259, NULL, NULL, vrr_stack+443);
 _BUILD_d0i0(Data,vrr_stack+1455, vrr_stack+1371, vrr_stack+3395, vrr_stack+114, vrr_stack+259, vrr_stack+464);
 _BUILD_f0i0(Data,vrr_stack+1623, vrr_stack+1455, vrr_stack+3479, vrr_stack+1371, vrr_stack+3395, vrr_stack+1967);
 _BUILD_g0i0(Data,vrr_stack+4795, vrr_stack+1623, vrr_stack+4095, vrr_stack+1455, vrr_stack+3479, vrr_stack+2093);
 _BUILD_00p0(Data,vrr_stack+1371, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+18, vrr_stack+0, vrr_stack+1371, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+1374, vrr_stack+24, vrr_stack+18, vrr_stack+171, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+1384, vrr_stack+527, vrr_stack+1374, vrr_stack+174, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+1399, vrr_stack+537, vrr_stack+1384, vrr_stack+180, vrr_stack+527, NULL);
 _BUILD_00i0(Data,vrr_stack+1420, vrr_stack+552, vrr_stack+1399, vrr_stack+3, vrr_stack+537, NULL);
 _BUILD_p0i0(Data,vrr_stack+1448, vrr_stack+343, vrr_stack+1420, NULL, NULL, vrr_stack+552);
 _BUILD_d0i0(Data,vrr_stack+1903, vrr_stack+30, vrr_stack+1448, vrr_stack+1259, vrr_stack+343, vrr_stack+573);
 _BUILD_f0i0(Data,vrr_stack+5215, vrr_stack+3647, vrr_stack+1903, vrr_stack+1287, vrr_stack+30, vrr_stack+636);
 _BUILD_g0i0(Data,vrr_stack+5495, vrr_stack+3815, vrr_stack+5215, vrr_stack+3227, vrr_stack+3647, vrr_stack+2303);
 _BUILD_h0i0(Data,vrr_stack+5915, vrr_stack+4375, vrr_stack+5495, vrr_stack+4095, vrr_stack+3815, vrr_stack+2513);
 _BUILD_h0i0(Data,vrr_stack+2071, vrr_stack+4795, vrr_stack+4375, vrr_stack+1623, vrr_stack+4095, vrr_stack+2828);
   tmp = vrr_stack + 2071;
   target_ptr = Libint->vrr_classes[5][6];
   for(i=0;i<588;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00k0(Data,vrr_stack+573, vrr_stack+1203, vrr_stack+1259, vrr_stack+238, vrr_stack+217, NULL);
 _BUILD_00k0(Data,vrr_stack+609, vrr_stack+1231, vrr_stack+1203, vrr_stack+322, vrr_stack+238, NULL);
 _BUILD_00k0(Data,vrr_stack+645, vrr_stack+1259, vrr_stack+343, vrr_stack+217, vrr_stack+406, NULL);
 _BUILD_p0k0(Data,vrr_stack+1532, vrr_stack+573, vrr_stack+645, NULL, NULL, vrr_stack+1259);
 _BUILD_p0k0(Data,vrr_stack+1640, vrr_stack+609, vrr_stack+573, NULL, NULL, vrr_stack+1203);
 _BUILD_d0k0(Data,vrr_stack+2659, vrr_stack+1640, vrr_stack+1532, vrr_stack+609, vrr_stack+573, vrr_stack+1287);
 _BUILD_00k0(Data,vrr_stack+1259, vrr_stack+259, vrr_stack+1231, vrr_stack+443, vrr_stack+322, NULL);
 _BUILD_p0k0(Data,vrr_stack+1748, vrr_stack+1259, vrr_stack+609, NULL, NULL, vrr_stack+1231);
 _BUILD_d0k0(Data,vrr_stack+2875, vrr_stack+1748, vrr_stack+1640, vrr_stack+1259, vrr_stack+609, vrr_stack+3143);
 _BUILD_00k0(Data,vrr_stack+609, vrr_stack+343, vrr_stack+1420, vrr_stack+406, vrr_stack+552, NULL);
 _BUILD_p0k0(Data,vrr_stack+142, vrr_stack+645, vrr_stack+609, NULL, NULL, vrr_stack+343);
 _BUILD_d0k0(Data,vrr_stack+6503, vrr_stack+1532, vrr_stack+142, vrr_stack+573, vrr_stack+645, vrr_stack+30);
 _BUILD_f0k0(Data,vrr_stack+6719, vrr_stack+2659, vrr_stack+6503, vrr_stack+1640, vrr_stack+1532, vrr_stack+3647);
 _BUILD_f0k0(Data,vrr_stack+7079, vrr_stack+2875, vrr_stack+2659, vrr_stack+1748, vrr_stack+1640, vrr_stack+3227);
 _BUILD_g0k0(Data,vrr_stack+7439, vrr_stack+7079, vrr_stack+6719, vrr_stack+2875, vrr_stack+2659, vrr_stack+3815);
 _BUILD_00k0(Data,vrr_stack+573, vrr_stack+114, vrr_stack+259, vrr_stack+287, vrr_stack+443, NULL);
 _BUILD_p0k0(Data,vrr_stack+1640, vrr_stack+573, vrr_stack+1259, NULL, NULL, vrr_stack+259);
 _BUILD_d0k0(Data,vrr_stack+3647, vrr_stack+1640, vrr_stack+1748, vrr_stack+573, vrr_stack+1259, vrr_stack+3395);
 _BUILD_f0k0(Data,vrr_stack+3091, vrr_stack+3647, vrr_stack+2875, vrr_stack+1640, vrr_stack+1748, vrr_stack+3479);
 _BUILD_g0k0(Data,vrr_stack+7979, vrr_stack+3091, vrr_stack+7079, vrr_stack+3647, vrr_stack+2875, vrr_stack+4095);
 _BUILD_00p0(Data,vrr_stack+2875, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2878, vrr_stack+1371, vrr_stack+2875, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+2884, vrr_stack+18, vrr_stack+2878, vrr_stack+0, vrr_stack+1371, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+1374, vrr_stack+2884, vrr_stack+24, vrr_stack+18, NULL);
 _BUILD_00h0(Data,vrr_stack+15, vrr_stack+1384, vrr_stack+0, vrr_stack+527, vrr_stack+1374, NULL);
 _BUILD_00i0(Data,vrr_stack+36, vrr_stack+1399, vrr_stack+15, vrr_stack+537, vrr_stack+1384, NULL);
 _BUILD_00k0(Data,vrr_stack+0, vrr_stack+1420, vrr_stack+36, vrr_stack+552, vrr_stack+1399, NULL);
 _BUILD_p0k0(Data,vrr_stack+2875, vrr_stack+609, vrr_stack+0, NULL, NULL, vrr_stack+1420);
 _BUILD_d0k0(Data,vrr_stack+1640, vrr_stack+142, vrr_stack+2875, vrr_stack+645, vrr_stack+609, vrr_stack+1448);
 _BUILD_f0k0(Data,vrr_stack+250, vrr_stack+6503, vrr_stack+1640, vrr_stack+1532, vrr_stack+142, vrr_stack+1903);
 _BUILD_g0k0(Data,vrr_stack+1203, vrr_stack+6719, vrr_stack+250, vrr_stack+2659, vrr_stack+6503, vrr_stack+5215);
 _BUILD_h0k0(Data,vrr_stack+0, vrr_stack+7439, vrr_stack+1203, vrr_stack+7079, vrr_stack+6719, vrr_stack+5495);
 _BUILD_h0k0(Data,vrr_stack+1203, vrr_stack+7979, vrr_stack+7439, vrr_stack+3091, vrr_stack+7079, vrr_stack+4375);
   tmp = vrr_stack + 1203;
   target_ptr = Libint->vrr_classes[5][7];
   for(i=0;i<756;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0i0(Data,vrr_stack+6503, vrr_stack+2071, vrr_stack+5915, vrr_stack+4795, vrr_stack+4375, vrr_stack+762);
   tmp = vrr_stack + 6503;
   target_ptr = Libint->vrr_classes[6][6];
   for(i=0;i<784;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0k0(Data,vrr_stack+1959, vrr_stack+1203, vrr_stack+0, vrr_stack+7979, vrr_stack+7439, vrr_stack+5915);
   tmp = vrr_stack + 1959;
   target_ptr = Libint->vrr_classes[6][7];
   for(i=0;i<1008;i++)
     target_ptr[i] += tmp[i];

}

