/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (kg|kh) integrals */

void vrr_order_kgkh(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+3, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_p000(Data,vrr_stack+12, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+15, vrr_stack+12, vrr_stack+3, Data->F+7, Data->F+8, NULL);
 _BUILD_p000(Data,vrr_stack+21, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+24, vrr_stack+0, vrr_stack+21, Data->F+9, Data->F+10, NULL);
 _BUILD_f000(Data,vrr_stack+30, vrr_stack+6, vrr_stack+24, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_f000(Data,vrr_stack+40, vrr_stack+15, vrr_stack+6, vrr_stack+12, vrr_stack+3, NULL);
 _BUILD_g000(Data,vrr_stack+50, vrr_stack+40, vrr_stack+30, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_00p0(Data,vrr_stack+65, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+68, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+71, vrr_stack+68, vrr_stack+65, NULL, NULL, Data->F+9);
 _BUILD_00p0(Data,vrr_stack+80, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+83, vrr_stack+80, vrr_stack+68, NULL, NULL, Data->F+8);
 _BUILD_00p0(Data,vrr_stack+92, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+95, vrr_stack+65, vrr_stack+92, NULL, NULL, Data->F+10);
 _BUILD_d0p0(Data,vrr_stack+104, vrr_stack+71, vrr_stack+95, vrr_stack+68, vrr_stack+65, vrr_stack+0);
 _BUILD_d0p0(Data,vrr_stack+122, vrr_stack+83, vrr_stack+71, vrr_stack+80, vrr_stack+68, vrr_stack+3);
 _BUILD_f0p0(Data,vrr_stack+140, vrr_stack+122, vrr_stack+104, vrr_stack+83, vrr_stack+71, vrr_stack+6);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+3, vrr_stack+0, vrr_stack+80, NULL, NULL, Data->F+7);
 _BUILD_d0p0(Data,vrr_stack+170, vrr_stack+3, vrr_stack+83, vrr_stack+0, vrr_stack+80, vrr_stack+12);
 _BUILD_f0p0(Data,vrr_stack+188, vrr_stack+170, vrr_stack+122, vrr_stack+3, vrr_stack+83, vrr_stack+15);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+218, vrr_stack+92, vrr_stack+12, NULL, NULL, Data->F+11);
 _BUILD_d0p0(Data,vrr_stack+227, vrr_stack+95, vrr_stack+218, vrr_stack+65, vrr_stack+92, vrr_stack+21);
 _BUILD_f0p0(Data,vrr_stack+245, vrr_stack+104, vrr_stack+227, vrr_stack+71, vrr_stack+95, vrr_stack+24);
 _BUILD_g0p0(Data,vrr_stack+275, vrr_stack+140, vrr_stack+245, vrr_stack+122, vrr_stack+104, vrr_stack+30);
 _BUILD_g0p0(Data,vrr_stack+320, vrr_stack+188, vrr_stack+140, vrr_stack+170, vrr_stack+122, vrr_stack+40);
 _BUILD_h0p0(Data,vrr_stack+365, vrr_stack+320, vrr_stack+275, vrr_stack+188, vrr_stack+140, vrr_stack+50);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+68, vrr_stack+65, Data->F+8, Data->F+9, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+80, vrr_stack+68, Data->F+7, Data->F+8, NULL);
 _BUILD_00d0(Data,vrr_stack+27, vrr_stack+65, vrr_stack+92, Data->F+9, Data->F+10, NULL);
 _BUILD_p0d0(Data,vrr_stack+33, vrr_stack+15, vrr_stack+27, NULL, NULL, vrr_stack+65);
 _BUILD_p0d0(Data,vrr_stack+428, vrr_stack+21, vrr_stack+15, NULL, NULL, vrr_stack+68);
 _BUILD_d0d0(Data,vrr_stack+446, vrr_stack+428, vrr_stack+33, vrr_stack+21, vrr_stack+15, vrr_stack+71);
 _BUILD_00d0(Data,vrr_stack+71, vrr_stack+0, vrr_stack+80, Data->F+6, Data->F+7, NULL);
 _BUILD_p0d0(Data,vrr_stack+482, vrr_stack+71, vrr_stack+21, NULL, NULL, vrr_stack+80);
 _BUILD_d0d0(Data,vrr_stack+500, vrr_stack+482, vrr_stack+428, vrr_stack+71, vrr_stack+21, vrr_stack+83);
 _BUILD_00d0(Data,vrr_stack+83, vrr_stack+92, vrr_stack+12, Data->F+10, Data->F+11, NULL);
 _BUILD_p0d0(Data,vrr_stack+536, vrr_stack+27, vrr_stack+83, NULL, NULL, vrr_stack+92);
 _BUILD_d0d0(Data,vrr_stack+554, vrr_stack+33, vrr_stack+536, vrr_stack+15, vrr_stack+27, vrr_stack+95);
 _BUILD_f0d0(Data,vrr_stack+590, vrr_stack+446, vrr_stack+554, vrr_stack+428, vrr_stack+33, vrr_stack+104);
 _BUILD_f0d0(Data,vrr_stack+650, vrr_stack+500, vrr_stack+446, vrr_stack+482, vrr_stack+428, vrr_stack+122);
 _BUILD_g0d0(Data,vrr_stack+710, vrr_stack+650, vrr_stack+590, vrr_stack+500, vrr_stack+446, vrr_stack+140);
 _BUILD_00p0(Data,vrr_stack+89, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+95, vrr_stack+89, vrr_stack+0, Data->F+5, Data->F+6, NULL);
 _BUILD_p0d0(Data,vrr_stack+101, vrr_stack+95, vrr_stack+71, NULL, NULL, vrr_stack+0);
 _BUILD_d0d0(Data,vrr_stack+119, vrr_stack+101, vrr_stack+482, vrr_stack+95, vrr_stack+71, vrr_stack+3);
 _BUILD_f0d0(Data,vrr_stack+800, vrr_stack+119, vrr_stack+500, vrr_stack+101, vrr_stack+482, vrr_stack+170);
 _BUILD_g0d0(Data,vrr_stack+860, vrr_stack+800, vrr_stack+650, vrr_stack+119, vrr_stack+500, vrr_stack+188);
 _BUILD_00p0(Data,vrr_stack+77, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3, vrr_stack+12, vrr_stack+77, Data->F+11, Data->F+12, NULL);
 _BUILD_p0d0(Data,vrr_stack+155, vrr_stack+83, vrr_stack+3, NULL, NULL, vrr_stack+12);
 _BUILD_d0d0(Data,vrr_stack+173, vrr_stack+536, vrr_stack+155, vrr_stack+27, vrr_stack+83, vrr_stack+218);
 _BUILD_f0d0(Data,vrr_stack+950, vrr_stack+554, vrr_stack+173, vrr_stack+33, vrr_stack+536, vrr_stack+227);
 _BUILD_g0d0(Data,vrr_stack+1010, vrr_stack+590, vrr_stack+950, vrr_stack+446, vrr_stack+554, vrr_stack+245);
 _BUILD_h0d0(Data,vrr_stack+1100, vrr_stack+710, vrr_stack+1010, vrr_stack+650, vrr_stack+590, vrr_stack+275);
 _BUILD_h0d0(Data,vrr_stack+1226, vrr_stack+860, vrr_stack+710, vrr_stack+800, vrr_stack+650, vrr_stack+320);
 _BUILD_i0d0(Data,vrr_stack+1352, vrr_stack+1226, vrr_stack+1100, vrr_stack+860, vrr_stack+710, vrr_stack+365);
 _BUILD_00f0(Data,vrr_stack+209, vrr_stack+15, vrr_stack+27, vrr_stack+68, vrr_stack+65, NULL);
 _BUILD_00f0(Data,vrr_stack+219, vrr_stack+21, vrr_stack+15, vrr_stack+80, vrr_stack+68, NULL);
 _BUILD_p0f0(Data,vrr_stack+229, vrr_stack+219, vrr_stack+209, NULL, NULL, vrr_stack+15);
 _BUILD_00f0(Data,vrr_stack+259, vrr_stack+71, vrr_stack+21, vrr_stack+0, vrr_stack+80, NULL);
 _BUILD_p0f0(Data,vrr_stack+269, vrr_stack+259, vrr_stack+219, NULL, NULL, vrr_stack+21);
 _BUILD_00f0(Data,vrr_stack+299, vrr_stack+27, vrr_stack+83, vrr_stack+65, vrr_stack+92, NULL);
 _BUILD_p0f0(Data,vrr_stack+309, vrr_stack+209, vrr_stack+299, NULL, NULL, vrr_stack+27);
 _BUILD_d0f0(Data,vrr_stack+339, vrr_stack+229, vrr_stack+309, vrr_stack+219, vrr_stack+209, vrr_stack+33);
 _BUILD_d0f0(Data,vrr_stack+1520, vrr_stack+269, vrr_stack+229, vrr_stack+259, vrr_stack+219, vrr_stack+428);
 _BUILD_f0f0(Data,vrr_stack+1580, vrr_stack+1520, vrr_stack+339, vrr_stack+269, vrr_stack+229, vrr_stack+446);
 _BUILD_00f0(Data,vrr_stack+33, vrr_stack+95, vrr_stack+71, vrr_stack+89, vrr_stack+0, NULL);
 _BUILD_p0f0(Data,vrr_stack+399, vrr_stack+33, vrr_stack+259, NULL, NULL, vrr_stack+71);
 _BUILD_d0f0(Data,vrr_stack+1680, vrr_stack+399, vrr_stack+269, vrr_stack+33, vrr_stack+259, vrr_stack+482);
 _BUILD_f0f0(Data,vrr_stack+1740, vrr_stack+1680, vrr_stack+1520, vrr_stack+399, vrr_stack+269, vrr_stack+500);
 _BUILD_00f0(Data,vrr_stack+43, vrr_stack+83, vrr_stack+3, vrr_stack+92, vrr_stack+12, NULL);
 _BUILD_p0f0(Data,vrr_stack+429, vrr_stack+299, vrr_stack+43, NULL, NULL, vrr_stack+83);
 _BUILD_d0f0(Data,vrr_stack+459, vrr_stack+309, vrr_stack+429, vrr_stack+209, vrr_stack+299, vrr_stack+536);
 _BUILD_f0f0(Data,vrr_stack+1840, vrr_stack+339, vrr_stack+459, vrr_stack+229, vrr_stack+309, vrr_stack+554);
 _BUILD_g0f0(Data,vrr_stack+1940, vrr_stack+1580, vrr_stack+1840, vrr_stack+1520, vrr_stack+339, vrr_stack+590);
 _BUILD_g0f0(Data,vrr_stack+2090, vrr_stack+1740, vrr_stack+1580, vrr_stack+1680, vrr_stack+1520, vrr_stack+650);
 _BUILD_h0f0(Data,vrr_stack+2240, vrr_stack+2090, vrr_stack+1940, vrr_stack+1740, vrr_stack+1580, vrr_stack+710);
 _BUILD_00p0(Data,vrr_stack+92, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+53, vrr_stack+92, vrr_stack+89, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+59, vrr_stack+53, vrr_stack+95, vrr_stack+92, vrr_stack+89, NULL);
 _BUILD_p0f0(Data,vrr_stack+519, vrr_stack+59, vrr_stack+33, NULL, NULL, vrr_stack+95);
 _BUILD_d0f0(Data,vrr_stack+549, vrr_stack+519, vrr_stack+399, vrr_stack+59, vrr_stack+33, vrr_stack+101);
 _BUILD_f0f0(Data,vrr_stack+609, vrr_stack+549, vrr_stack+1680, vrr_stack+519, vrr_stack+399, vrr_stack+119);
 _BUILD_g0f0(Data,vrr_stack+2450, vrr_stack+609, vrr_stack+1740, vrr_stack+549, vrr_stack+1680, vrr_stack+800);
 _BUILD_h0f0(Data,vrr_stack+2600, vrr_stack+2450, vrr_stack+2090, vrr_stack+609, vrr_stack+1740, vrr_stack+860);
 _BUILD_00p0(Data,vrr_stack+89, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+101, vrr_stack+77, vrr_stack+89, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+107, vrr_stack+3, vrr_stack+101, vrr_stack+12, vrr_stack+77, NULL);
 _BUILD_p0f0(Data,vrr_stack+117, vrr_stack+43, vrr_stack+107, NULL, NULL, vrr_stack+3);
 _BUILD_d0f0(Data,vrr_stack+709, vrr_stack+429, vrr_stack+117, vrr_stack+299, vrr_stack+43, vrr_stack+155);
 _BUILD_f0f0(Data,vrr_stack+769, vrr_stack+459, vrr_stack+709, vrr_stack+309, vrr_stack+429, vrr_stack+173);
 _BUILD_g0f0(Data,vrr_stack+2810, vrr_stack+1840, vrr_stack+769, vrr_stack+339, vrr_stack+459, vrr_stack+950);
 _BUILD_h0f0(Data,vrr_stack+2960, vrr_stack+1940, vrr_stack+2810, vrr_stack+1580, vrr_stack+1840, vrr_stack+1010);
 _BUILD_i0f0(Data,vrr_stack+3170, vrr_stack+2240, vrr_stack+2960, vrr_stack+2090, vrr_stack+1940, vrr_stack+1100);
 _BUILD_i0f0(Data,vrr_stack+869, vrr_stack+2600, vrr_stack+2240, vrr_stack+2450, vrr_stack+2090, vrr_stack+1226);
 _BUILD_k0f0(Data,vrr_stack+3450, vrr_stack+869, vrr_stack+3170, vrr_stack+2600, vrr_stack+2240, vrr_stack+1352);
 _BUILD_00g0(Data,vrr_stack+147, vrr_stack+219, vrr_stack+209, vrr_stack+21, vrr_stack+15, NULL);
 _BUILD_00g0(Data,vrr_stack+162, vrr_stack+259, vrr_stack+219, vrr_stack+71, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+177, vrr_stack+209, vrr_stack+299, vrr_stack+15, vrr_stack+27, NULL);
 _BUILD_p0g0(Data,vrr_stack+1149, vrr_stack+147, vrr_stack+177, NULL, NULL, vrr_stack+209);
 _BUILD_p0g0(Data,vrr_stack+1194, vrr_stack+162, vrr_stack+147, NULL, NULL, vrr_stack+219);
 _BUILD_d0g0(Data,vrr_stack+1239, vrr_stack+1194, vrr_stack+1149, vrr_stack+162, vrr_stack+147, vrr_stack+229);
 _BUILD_00g0(Data,vrr_stack+229, vrr_stack+33, vrr_stack+259, vrr_stack+95, vrr_stack+71, NULL);
 _BUILD_p0g0(Data,vrr_stack+1329, vrr_stack+229, vrr_stack+162, NULL, NULL, vrr_stack+259);
 _BUILD_d0g0(Data,vrr_stack+1374, vrr_stack+1329, vrr_stack+1194, vrr_stack+229, vrr_stack+162, vrr_stack+269);
 _BUILD_00g0(Data,vrr_stack+244, vrr_stack+299, vrr_stack+43, vrr_stack+27, vrr_stack+83, NULL);
 _BUILD_p0g0(Data,vrr_stack+1464, vrr_stack+177, vrr_stack+244, NULL, NULL, vrr_stack+299);
 _BUILD_d0g0(Data,vrr_stack+3810, vrr_stack+1149, vrr_stack+1464, vrr_stack+147, vrr_stack+177, vrr_stack+309);
 _BUILD_f0g0(Data,vrr_stack+3900, vrr_stack+1239, vrr_stack+3810, vrr_stack+1194, vrr_stack+1149, vrr_stack+339);
 _BUILD_f0g0(Data,vrr_stack+4050, vrr_stack+1374, vrr_stack+1239, vrr_stack+1329, vrr_stack+1194, vrr_stack+1520);
 _BUILD_g0g0(Data,vrr_stack+4200, vrr_stack+4050, vrr_stack+3900, vrr_stack+1374, vrr_stack+1239, vrr_stack+1580);
 _BUILD_00g0(Data,vrr_stack+309, vrr_stack+59, vrr_stack+33, vrr_stack+53, vrr_stack+95, NULL);
 _BUILD_p0g0(Data,vrr_stack+324, vrr_stack+309, vrr_stack+229, NULL, NULL, vrr_stack+33);
 _BUILD_d0g0(Data,vrr_stack+1509, vrr_stack+324, vrr_stack+1329, vrr_stack+309, vrr_stack+229, vrr_stack+399);
 _BUILD_f0g0(Data,vrr_stack+4425, vrr_stack+1509, vrr_stack+1374, vrr_stack+324, vrr_stack+1329, vrr_stack+1680);
 _BUILD_g0g0(Data,vrr_stack+4575, vrr_stack+4425, vrr_stack+4050, vrr_stack+1509, vrr_stack+1374, vrr_stack+1740);
 _BUILD_00g0(Data,vrr_stack+369, vrr_stack+43, vrr_stack+107, vrr_stack+83, vrr_stack+3, NULL);
 _BUILD_p0g0(Data,vrr_stack+384, vrr_stack+244, vrr_stack+369, NULL, NULL, vrr_stack+43);
 _BUILD_d0g0(Data,vrr_stack+1599, vrr_stack+1464, vrr_stack+384, vrr_stack+177, vrr_stack+244, vrr_stack+429);
 _BUILD_f0g0(Data,vrr_stack+1689, vrr_stack+3810, vrr_stack+1599, vrr_stack+1149, vrr_stack+1464, vrr_stack+459);
 _BUILD_g0g0(Data,vrr_stack+4800, vrr_stack+3900, vrr_stack+1689, vrr_stack+1239, vrr_stack+3810, vrr_stack+1840);
 _BUILD_h0g0(Data,vrr_stack+5025, vrr_stack+4200, vrr_stack+4800, vrr_stack+4050, vrr_stack+3900, vrr_stack+1940);
 _BUILD_h0g0(Data,vrr_stack+5340, vrr_stack+4575, vrr_stack+4200, vrr_stack+4425, vrr_stack+4050, vrr_stack+2090);
 _BUILD_i0g0(Data,vrr_stack+5655, vrr_stack+5340, vrr_stack+5025, vrr_stack+4575, vrr_stack+4200, vrr_stack+2240);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+95, vrr_stack+0, vrr_stack+92, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+429, vrr_stack+95, vrr_stack+53, vrr_stack+0, vrr_stack+92, NULL);
 _BUILD_00g0(Data,vrr_stack+439, vrr_stack+429, vrr_stack+59, vrr_stack+95, vrr_stack+53, NULL);
 _BUILD_p0g0(Data,vrr_stack+454, vrr_stack+439, vrr_stack+309, NULL, NULL, vrr_stack+59);
 _BUILD_d0g0(Data,vrr_stack+1839, vrr_stack+454, vrr_stack+324, vrr_stack+439, vrr_stack+309, vrr_stack+519);
 _BUILD_f0g0(Data,vrr_stack+1929, vrr_stack+1839, vrr_stack+1509, vrr_stack+454, vrr_stack+324, vrr_stack+549);
 _BUILD_g0g0(Data,vrr_stack+2079, vrr_stack+1929, vrr_stack+4425, vrr_stack+1839, vrr_stack+1509, vrr_stack+609);
 _BUILD_h0g0(Data,vrr_stack+6075, vrr_stack+2079, vrr_stack+4575, vrr_stack+1929, vrr_stack+4425, vrr_stack+2450);
 _BUILD_i0g0(Data,vrr_stack+6390, vrr_stack+6075, vrr_stack+5340, vrr_stack+2079, vrr_stack+4575, vrr_stack+2600);
 _BUILD_00p0(Data,vrr_stack+92, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+53, vrr_stack+89, vrr_stack+92, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+499, vrr_stack+101, vrr_stack+53, vrr_stack+77, vrr_stack+89, NULL);
 _BUILD_00g0(Data,vrr_stack+509, vrr_stack+107, vrr_stack+499, vrr_stack+3, vrr_stack+101, NULL);
 _BUILD_p0g0(Data,vrr_stack+524, vrr_stack+369, vrr_stack+509, NULL, NULL, vrr_stack+107);
 _BUILD_d0g0(Data,vrr_stack+569, vrr_stack+384, vrr_stack+524, vrr_stack+244, vrr_stack+369, vrr_stack+117);
 _BUILD_f0g0(Data,vrr_stack+2304, vrr_stack+1599, vrr_stack+569, vrr_stack+1464, vrr_stack+384, vrr_stack+709);
 _BUILD_g0g0(Data,vrr_stack+2454, vrr_stack+1689, vrr_stack+2304, vrr_stack+3810, vrr_stack+1599, vrr_stack+769);
 _BUILD_h0g0(Data,vrr_stack+6810, vrr_stack+4800, vrr_stack+2454, vrr_stack+3900, vrr_stack+1689, vrr_stack+2810);
 _BUILD_i0g0(Data,vrr_stack+7125, vrr_stack+5025, vrr_stack+6810, vrr_stack+4200, vrr_stack+4800, vrr_stack+2960);
 _BUILD_k0g0(Data,vrr_stack+7545, vrr_stack+5655, vrr_stack+7125, vrr_stack+5340, vrr_stack+5025, vrr_stack+3170);
 _BUILD_k0g0(Data,vrr_stack+2679, vrr_stack+6390, vrr_stack+5655, vrr_stack+6075, vrr_stack+5340, vrr_stack+869);
 _BUILD_l0g0(Data,vrr_stack+8085, vrr_stack+2679, vrr_stack+7545, vrr_stack+6390, vrr_stack+5655, vrr_stack+3450);
 _BUILD_00h0(Data,vrr_stack+117, vrr_stack+147, vrr_stack+177, vrr_stack+219, vrr_stack+209, NULL);
 _BUILD_00h0(Data,vrr_stack+3, vrr_stack+162, vrr_stack+147, vrr_stack+259, vrr_stack+219, NULL);
 _BUILD_p0h0(Data,vrr_stack+659, vrr_stack+3, vrr_stack+117, NULL, NULL, vrr_stack+147);
 _BUILD_00h0(Data,vrr_stack+722, vrr_stack+229, vrr_stack+162, vrr_stack+33, vrr_stack+259, NULL);
 _BUILD_p0h0(Data,vrr_stack+743, vrr_stack+722, vrr_stack+3, NULL, NULL, vrr_stack+162);
 _BUILD_00h0(Data,vrr_stack+259, vrr_stack+177, vrr_stack+244, vrr_stack+209, vrr_stack+299, NULL);
 _BUILD_p0h0(Data,vrr_stack+806, vrr_stack+117, vrr_stack+259, NULL, NULL, vrr_stack+177);
 _BUILD_d0h0(Data,vrr_stack+869, vrr_stack+659, vrr_stack+806, vrr_stack+3, vrr_stack+117, vrr_stack+1149);
 _BUILD_d0h0(Data,vrr_stack+995, vrr_stack+743, vrr_stack+659, vrr_stack+722, vrr_stack+3, vrr_stack+1194);
 _BUILD_f0h0(Data,vrr_stack+3219, vrr_stack+995, vrr_stack+869, vrr_stack+743, vrr_stack+659, vrr_stack+1239);
 _BUILD_00h0(Data,vrr_stack+1121, vrr_stack+309, vrr_stack+229, vrr_stack+59, vrr_stack+33, NULL);
 _BUILD_p0h0(Data,vrr_stack+1142, vrr_stack+1121, vrr_stack+722, NULL, NULL, vrr_stack+229);
 _BUILD_d0h0(Data,vrr_stack+3429, vrr_stack+1142, vrr_stack+743, vrr_stack+1121, vrr_stack+722, vrr_stack+1329);
 _BUILD_f0h0(Data,vrr_stack+3555, vrr_stack+3429, vrr_stack+995, vrr_stack+1142, vrr_stack+743, vrr_stack+1374);
 _BUILD_00h0(Data,vrr_stack+1205, vrr_stack+244, vrr_stack+369, vrr_stack+299, vrr_stack+43, NULL);
 _BUILD_p0h0(Data,vrr_stack+1226, vrr_stack+259, vrr_stack+1205, NULL, NULL, vrr_stack+244);
 _BUILD_d0h0(Data,vrr_stack+1289, vrr_stack+806, vrr_stack+1226, vrr_stack+117, vrr_stack+259, vrr_stack+1464);
 _BUILD_f0h0(Data,vrr_stack+8760, vrr_stack+869, vrr_stack+1289, vrr_stack+659, vrr_stack+806, vrr_stack+3810);
 _BUILD_g0h0(Data,vrr_stack+8970, vrr_stack+3219, vrr_stack+8760, vrr_stack+995, vrr_stack+869, vrr_stack+3900);
 _BUILD_g0h0(Data,vrr_stack+9285, vrr_stack+3555, vrr_stack+3219, vrr_stack+3429, vrr_stack+995, vrr_stack+4050);
 _BUILD_h0h0(Data,vrr_stack+9600, vrr_stack+9285, vrr_stack+8970, vrr_stack+3555, vrr_stack+3219, vrr_stack+4200);
 _BUILD_00h0(Data,vrr_stack+280, vrr_stack+439, vrr_stack+309, vrr_stack+429, vrr_stack+59, NULL);
 _BUILD_p0h0(Data,vrr_stack+1415, vrr_stack+280, vrr_stack+1121, NULL, NULL, vrr_stack+309);
 _BUILD_d0h0(Data,vrr_stack+3765, vrr_stack+1415, vrr_stack+1142, vrr_stack+280, vrr_stack+1121, vrr_stack+324);
 _BUILD_f0h0(Data,vrr_stack+3891, vrr_stack+3765, vrr_stack+3429, vrr_stack+1415, vrr_stack+1142, vrr_stack+1509);
 _BUILD_g0h0(Data,vrr_stack+4101, vrr_stack+3891, vrr_stack+3555, vrr_stack+3765, vrr_stack+3429, vrr_stack+4425);
 _BUILD_h0h0(Data,vrr_stack+10041, vrr_stack+4101, vrr_stack+9285, vrr_stack+3891, vrr_stack+3555, vrr_stack+4575);
 _BUILD_00h0(Data,vrr_stack+324, vrr_stack+369, vrr_stack+509, vrr_stack+43, vrr_stack+107, NULL);
 _BUILD_p0h0(Data,vrr_stack+1478, vrr_stack+1205, vrr_stack+324, NULL, NULL, vrr_stack+369);
 _BUILD_d0h0(Data,vrr_stack+4416, vrr_stack+1226, vrr_stack+1478, vrr_stack+259, vrr_stack+1205, vrr_stack+384);
 _BUILD_f0h0(Data,vrr_stack+4542, vrr_stack+1289, vrr_stack+4416, vrr_stack+806, vrr_stack+1226, vrr_stack+1599);
 _BUILD_g0h0(Data,vrr_stack+10482, vrr_stack+8760, vrr_stack+4542, vrr_stack+869, vrr_stack+1289, vrr_stack+1689);
 _BUILD_h0h0(Data,vrr_stack+10797, vrr_stack+8970, vrr_stack+10482, vrr_stack+3219, vrr_stack+8760, vrr_stack+4800);
 _BUILD_i0h0(Data,vrr_stack+11238, vrr_stack+9600, vrr_stack+10797, vrr_stack+9285, vrr_stack+8970, vrr_stack+5025);
 _BUILD_i0h0(Data,vrr_stack+4752, vrr_stack+10041, vrr_stack+9600, vrr_stack+4101, vrr_stack+9285, vrr_stack+5340);
 _BUILD_k0h0(Data,vrr_stack+11826, vrr_stack+4752, vrr_stack+11238, vrr_stack+10041, vrr_stack+9600, vrr_stack+5655);
 _BUILD_00p0(Data,vrr_stack+5340, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+5343, vrr_stack+5340, vrr_stack+0, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+5349, vrr_stack+5343, vrr_stack+95, vrr_stack+5340, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+5359, vrr_stack+5349, vrr_stack+429, vrr_stack+5343, vrr_stack+95, NULL);
 _BUILD_00h0(Data,vrr_stack+5374, vrr_stack+5359, vrr_stack+439, vrr_stack+5349, vrr_stack+429, NULL);
 _BUILD_p0h0(Data,vrr_stack+5395, vrr_stack+5374, vrr_stack+280, NULL, NULL, vrr_stack+439);
 _BUILD_d0h0(Data,vrr_stack+5458, vrr_stack+5395, vrr_stack+1415, vrr_stack+5374, vrr_stack+280, vrr_stack+454);
 _BUILD_f0h0(Data,vrr_stack+5584, vrr_stack+5458, vrr_stack+3765, vrr_stack+5395, vrr_stack+1415, vrr_stack+1839);
 _BUILD_g0h0(Data,vrr_stack+1541, vrr_stack+5584, vrr_stack+3891, vrr_stack+5458, vrr_stack+3765, vrr_stack+1929);
 _BUILD_h0h0(Data,vrr_stack+12582, vrr_stack+1541, vrr_stack+4101, vrr_stack+5584, vrr_stack+3891, vrr_stack+2079);
 _BUILD_i0h0(Data,vrr_stack+13023, vrr_stack+12582, vrr_stack+10041, vrr_stack+1541, vrr_stack+4101, vrr_stack+6075);
 _BUILD_k0h0(Data,vrr_stack+13611, vrr_stack+13023, vrr_stack+4752, vrr_stack+12582, vrr_stack+10041, vrr_stack+6390);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+95, vrr_stack+92, vrr_stack+0, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+454, vrr_stack+53, vrr_stack+95, vrr_stack+89, vrr_stack+92, NULL);
 _BUILD_00g0(Data,vrr_stack+464, vrr_stack+499, vrr_stack+454, vrr_stack+101, vrr_stack+53, NULL);
 _BUILD_00h0(Data,vrr_stack+5794, vrr_stack+509, vrr_stack+464, vrr_stack+107, vrr_stack+499, NULL);
 _BUILD_p0h0(Data,vrr_stack+5815, vrr_stack+324, vrr_stack+5794, NULL, NULL, vrr_stack+509);
 _BUILD_d0h0(Data,vrr_stack+5878, vrr_stack+1478, vrr_stack+5815, vrr_stack+1205, vrr_stack+324, vrr_stack+524);
 _BUILD_f0h0(Data,vrr_stack+6004, vrr_stack+4416, vrr_stack+5878, vrr_stack+1226, vrr_stack+1478, vrr_stack+569);
 _BUILD_g0h0(Data,vrr_stack+6214, vrr_stack+4542, vrr_stack+6004, vrr_stack+1289, vrr_stack+4416, vrr_stack+2304);
 _BUILD_h0h0(Data,vrr_stack+1856, vrr_stack+10482, vrr_stack+6214, vrr_stack+8760, vrr_stack+4542, vrr_stack+2454);
 _BUILD_i0h0(Data,vrr_stack+14367, vrr_stack+10797, vrr_stack+1856, vrr_stack+8970, vrr_stack+10482, vrr_stack+6810);
 _BUILD_k0h0(Data,vrr_stack+14955, vrr_stack+11238, vrr_stack+14367, vrr_stack+9600, vrr_stack+10797, vrr_stack+7125);
 _BUILD_l0h0(Data,vrr_stack+6529, vrr_stack+11826, vrr_stack+14955, vrr_stack+4752, vrr_stack+11238, vrr_stack+7545);
 _BUILD_l0h0(Data,vrr_stack+15711, vrr_stack+13611, vrr_stack+11826, vrr_stack+13023, vrr_stack+4752, vrr_stack+2679);
 _BUILD_m0h0(Data,vrr_stack+16656, vrr_stack+15711, vrr_stack+6529, vrr_stack+13611, vrr_stack+11826, vrr_stack+8085);
 _BUILD_00i0(Data,vrr_stack+524, vrr_stack+3, vrr_stack+117, vrr_stack+162, vrr_stack+147, NULL);
 _BUILD_00i0(Data,vrr_stack+552, vrr_stack+722, vrr_stack+3, vrr_stack+229, vrr_stack+162, NULL);
 _BUILD_00i0(Data,vrr_stack+580, vrr_stack+117, vrr_stack+259, vrr_stack+147, vrr_stack+177, NULL);
 _BUILD_p0i0(Data,vrr_stack+7474, vrr_stack+524, vrr_stack+580, NULL, NULL, vrr_stack+117);
 _BUILD_p0i0(Data,vrr_stack+7558, vrr_stack+552, vrr_stack+524, NULL, NULL, vrr_stack+3);
 _BUILD_d0i0(Data,vrr_stack+7642, vrr_stack+7558, vrr_stack+7474, vrr_stack+552, vrr_stack+524, vrr_stack+659);
 _BUILD_00i0(Data,vrr_stack+608, vrr_stack+1121, vrr_stack+722, vrr_stack+309, vrr_stack+229, NULL);
 _BUILD_p0i0(Data,vrr_stack+636, vrr_stack+608, vrr_stack+552, NULL, NULL, vrr_stack+722);
 _BUILD_d0i0(Data,vrr_stack+7810, vrr_stack+636, vrr_stack+7558, vrr_stack+608, vrr_stack+552, vrr_stack+743);
 _BUILD_00i0(Data,vrr_stack+743, vrr_stack+259, vrr_stack+1205, vrr_stack+177, vrr_stack+244, NULL);
 _BUILD_p0i0(Data,vrr_stack+7978, vrr_stack+580, vrr_stack+743, NULL, NULL, vrr_stack+259);
 _BUILD_d0i0(Data,vrr_stack+8062, vrr_stack+7474, vrr_stack+7978, vrr_stack+524, vrr_stack+580, vrr_stack+806);
 _BUILD_f0i0(Data,vrr_stack+8230, vrr_stack+7642, vrr_stack+8062, vrr_stack+7558, vrr_stack+7474, vrr_stack+869);
 _BUILD_f0i0(Data,vrr_stack+2297, vrr_stack+7810, vrr_stack+7642, vrr_stack+636, vrr_stack+7558, vrr_stack+995);
 _BUILD_g0i0(Data,vrr_stack+2577, vrr_stack+2297, vrr_stack+8230, vrr_stack+7810, vrr_stack+7642, vrr_stack+3219);
 _BUILD_00i0(Data,vrr_stack+771, vrr_stack+280, vrr_stack+1121, vrr_stack+439, vrr_stack+309, NULL);
 _BUILD_p0i0(Data,vrr_stack+799, vrr_stack+771, vrr_stack+608, NULL, NULL, vrr_stack+1121);
 _BUILD_d0i0(Data,vrr_stack+883, vrr_stack+799, vrr_stack+636, vrr_stack+771, vrr_stack+608, vrr_stack+1142);
 _BUILD_f0i0(Data,vrr_stack+2997, vrr_stack+883, vrr_stack+7810, vrr_stack+799, vrr_stack+636, vrr_stack+3429);
 _BUILD_g0i0(Data,vrr_stack+17811, vrr_stack+2997, vrr_stack+2297, vrr_stack+883, vrr_stack+7810, vrr_stack+3555);
 _BUILD_00i0(Data,vrr_stack+1142, vrr_stack+1205, vrr_stack+324, vrr_stack+244, vrr_stack+369, NULL);
 _BUILD_p0i0(Data,vrr_stack+8510, vrr_stack+743, vrr_stack+1142, NULL, NULL, vrr_stack+1205);
 _BUILD_d0i0(Data,vrr_stack+3277, vrr_stack+7978, vrr_stack+8510, vrr_stack+580, vrr_stack+743, vrr_stack+1226);
 _BUILD_f0i0(Data,vrr_stack+3445, vrr_stack+8062, vrr_stack+3277, vrr_stack+7474, vrr_stack+7978, vrr_stack+1289);
 _BUILD_g0i0(Data,vrr_stack+18231, vrr_stack+8230, vrr_stack+3445, vrr_stack+7642, vrr_stack+8062, vrr_stack+8760);
 _BUILD_h0i0(Data,vrr_stack+18651, vrr_stack+2577, vrr_stack+18231, vrr_stack+2297, vrr_stack+8230, vrr_stack+8970);
 _BUILD_h0i0(Data,vrr_stack+8594, vrr_stack+17811, vrr_stack+2577, vrr_stack+2997, vrr_stack+2297, vrr_stack+9285);
 _BUILD_i0i0(Data,vrr_stack+19239, vrr_stack+8594, vrr_stack+18651, vrr_stack+17811, vrr_stack+2577, vrr_stack+9600);
 _BUILD_00i0(Data,vrr_stack+1226, vrr_stack+5374, vrr_stack+280, vrr_stack+5359, vrr_stack+439, NULL);
 _BUILD_p0i0(Data,vrr_stack+1254, vrr_stack+1226, vrr_stack+771, NULL, NULL, vrr_stack+280);
 _BUILD_d0i0(Data,vrr_stack+9182, vrr_stack+1254, vrr_stack+799, vrr_stack+1226, vrr_stack+771, vrr_stack+1415);
 _BUILD_f0i0(Data,vrr_stack+9350, vrr_stack+9182, vrr_stack+883, vrr_stack+1254, vrr_stack+799, vrr_stack+3765);
 _BUILD_g0i0(Data,vrr_stack+20023, vrr_stack+9350, vrr_stack+2997, vrr_stack+9182, vrr_stack+883, vrr_stack+3891);
 _BUILD_h0i0(Data,vrr_stack+20443, vrr_stack+20023, vrr_stack+17811, vrr_stack+9350, vrr_stack+2997, vrr_stack+4101);
 _BUILD_i0i0(Data,vrr_stack+21031, vrr_stack+20443, vrr_stack+8594, vrr_stack+20023, vrr_stack+17811, vrr_stack+10041);
 _BUILD_00i0(Data,vrr_stack+1338, vrr_stack+324, vrr_stack+5794, vrr_stack+369, vrr_stack+509, NULL);
 _BUILD_p0i0(Data,vrr_stack+1366, vrr_stack+1142, vrr_stack+1338, NULL, NULL, vrr_stack+324);
 _BUILD_d0i0(Data,vrr_stack+9630, vrr_stack+8510, vrr_stack+1366, vrr_stack+743, vrr_stack+1142, vrr_stack+1478);
 _BUILD_f0i0(Data,vrr_stack+9798, vrr_stack+3277, vrr_stack+9630, vrr_stack+7978, vrr_stack+8510, vrr_stack+4416);
 _BUILD_g0i0(Data,vrr_stack+3725, vrr_stack+3445, vrr_stack+9798, vrr_stack+8062, vrr_stack+3277, vrr_stack+4542);
 _BUILD_h0i0(Data,vrr_stack+4145, vrr_stack+18231, vrr_stack+3725, vrr_stack+8230, vrr_stack+3445, vrr_stack+10482);
 _BUILD_i0i0(Data,vrr_stack+21815, vrr_stack+18651, vrr_stack+4145, vrr_stack+2577, vrr_stack+18231, vrr_stack+10797);
 _BUILD_k0i0(Data,vrr_stack+10078, vrr_stack+19239, vrr_stack+21815, vrr_stack+8594, vrr_stack+18651, vrr_stack+11238);
 _BUILD_k0i0(Data,vrr_stack+22599, vrr_stack+21031, vrr_stack+19239, vrr_stack+20443, vrr_stack+8594, vrr_stack+4752);
 _BUILD_l0i0(Data,vrr_stack+23607, vrr_stack+22599, vrr_stack+10078, vrr_stack+21031, vrr_stack+19239, vrr_stack+11826);
 _BUILD_00p0(Data,vrr_stack+1450, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1453, vrr_stack+1450, vrr_stack+5340, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+1459, vrr_stack+1453, vrr_stack+5343, vrr_stack+1450, vrr_stack+5340, NULL);
 _BUILD_00g0(Data,vrr_stack+1469, vrr_stack+1459, vrr_stack+5349, vrr_stack+1453, vrr_stack+5343, NULL);
 _BUILD_00h0(Data,vrr_stack+1484, vrr_stack+1469, vrr_stack+5359, vrr_stack+1459, vrr_stack+5349, NULL);
 _BUILD_00i0(Data,vrr_stack+1505, vrr_stack+1484, vrr_stack+5374, vrr_stack+1469, vrr_stack+5359, NULL);
 _BUILD_p0i0(Data,vrr_stack+11086, vrr_stack+1505, vrr_stack+1226, NULL, NULL, vrr_stack+5374);
 _BUILD_d0i0(Data,vrr_stack+11170, vrr_stack+11086, vrr_stack+1254, vrr_stack+1505, vrr_stack+1226, vrr_stack+5395);
 _BUILD_f0i0(Data,vrr_stack+11338, vrr_stack+11170, vrr_stack+9182, vrr_stack+11086, vrr_stack+1254, vrr_stack+5458);
 _BUILD_g0i0(Data,vrr_stack+11618, vrr_stack+11338, vrr_stack+9350, vrr_stack+11170, vrr_stack+9182, vrr_stack+5584);
 _BUILD_h0i0(Data,vrr_stack+4733, vrr_stack+11618, vrr_stack+20023, vrr_stack+11338, vrr_stack+9350, vrr_stack+1541);
 _BUILD_i0i0(Data,vrr_stack+24867, vrr_stack+4733, vrr_stack+20443, vrr_stack+11618, vrr_stack+20023, vrr_stack+12582);
 _BUILD_k0i0(Data,vrr_stack+25651, vrr_stack+24867, vrr_stack+21031, vrr_stack+4733, vrr_stack+20443, vrr_stack+13023);
 _BUILD_l0i0(Data,vrr_stack+12038, vrr_stack+25651, vrr_stack+22599, vrr_stack+24867, vrr_stack+21031, vrr_stack+13611);
 _BUILD_00p0(Data,vrr_stack+5395, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+5398, vrr_stack+0, vrr_stack+5395, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+5404, vrr_stack+95, vrr_stack+5398, vrr_stack+92, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+5414, vrr_stack+454, vrr_stack+5404, vrr_stack+53, vrr_stack+95, NULL);
 _BUILD_00h0(Data,vrr_stack+5429, vrr_stack+464, vrr_stack+5414, vrr_stack+499, vrr_stack+454, NULL);
 _BUILD_00i0(Data,vrr_stack+5450, vrr_stack+5794, vrr_stack+5429, vrr_stack+509, vrr_stack+464, NULL);
 _BUILD_p0i0(Data,vrr_stack+5478, vrr_stack+1338, vrr_stack+5450, NULL, NULL, vrr_stack+5794);
 _BUILD_d0i0(Data,vrr_stack+5562, vrr_stack+1366, vrr_stack+5478, vrr_stack+1142, vrr_stack+1338, vrr_stack+5815);
 _BUILD_f0i0(Data,vrr_stack+1533, vrr_stack+9630, vrr_stack+5562, vrr_stack+8510, vrr_stack+1366, vrr_stack+5878);
 _BUILD_g0i0(Data,vrr_stack+13298, vrr_stack+9798, vrr_stack+1533, vrr_stack+3277, vrr_stack+9630, vrr_stack+6004);
 _BUILD_h0i0(Data,vrr_stack+13718, vrr_stack+3725, vrr_stack+13298, vrr_stack+3445, vrr_stack+9798, vrr_stack+6214);
 _BUILD_i0i0(Data,vrr_stack+26659, vrr_stack+4145, vrr_stack+13718, vrr_stack+18231, vrr_stack+3725, vrr_stack+1856);
 _BUILD_k0i0(Data,vrr_stack+27443, vrr_stack+21815, vrr_stack+26659, vrr_stack+18651, vrr_stack+4145, vrr_stack+14367);
 _BUILD_l0i0(Data,vrr_stack+28451, vrr_stack+10078, vrr_stack+27443, vrr_stack+19239, vrr_stack+21815, vrr_stack+14955);
 _BUILD_m0i0(Data,vrr_stack+29711, vrr_stack+23607, vrr_stack+28451, vrr_stack+22599, vrr_stack+10078, vrr_stack+6529);
 _BUILD_m0i0(Data,vrr_stack+5815, vrr_stack+12038, vrr_stack+23607, vrr_stack+25651, vrr_stack+22599, vrr_stack+15711);
 _BUILD_n0i0(Data,vrr_stack+14306, vrr_stack+5815, vrr_stack+29711, vrr_stack+12038, vrr_stack+23607, vrr_stack+16656);
 _BUILD_00k0(Data,vrr_stack+7355, vrr_stack+524, vrr_stack+580, vrr_stack+3, vrr_stack+117, NULL);
 _BUILD_00k0(Data,vrr_stack+7391, vrr_stack+552, vrr_stack+524, vrr_stack+722, vrr_stack+3, NULL);
 _BUILD_p0k0(Data,vrr_stack+1813, vrr_stack+7391, vrr_stack+7355, NULL, NULL, vrr_stack+524);
 _BUILD_00k0(Data,vrr_stack+3, vrr_stack+608, vrr_stack+552, vrr_stack+1121, vrr_stack+722, NULL);
 _BUILD_p0k0(Data,vrr_stack+1921, vrr_stack+3, vrr_stack+7391, NULL, NULL, vrr_stack+552);
 _BUILD_00k0(Data,vrr_stack+39, vrr_stack+580, vrr_stack+743, vrr_stack+117, vrr_stack+259, NULL);
 _BUILD_p0k0(Data,vrr_stack+2029, vrr_stack+7355, vrr_stack+39, NULL, NULL, vrr_stack+580);
 _BUILD_d0k0(Data,vrr_stack+16154, vrr_stack+1813, vrr_stack+2029, vrr_stack+7391, vrr_stack+7355, vrr_stack+7474);
 _BUILD_d0k0(Data,vrr_stack+16370, vrr_stack+1921, vrr_stack+1813, vrr_stack+3, vrr_stack+7391, vrr_stack+7558);
 _BUILD_f0k0(Data,vrr_stack+16586, vrr_stack+16370, vrr_stack+16154, vrr_stack+1921, vrr_stack+1813, vrr_stack+7642);
 _BUILD_00k0(Data,vrr_stack+7427, vrr_stack+771, vrr_stack+608, vrr_stack+280, vrr_stack+1121, NULL);
 _BUILD_p0k0(Data,vrr_stack+7463, vrr_stack+7427, vrr_stack+3, NULL, NULL, vrr_stack+608);
 _BUILD_d0k0(Data,vrr_stack+7571, vrr_stack+7463, vrr_stack+1921, vrr_stack+7427, vrr_stack+3, vrr_stack+636);
 _BUILD_f0k0(Data,vrr_stack+16946, vrr_stack+7571, vrr_stack+16370, vrr_stack+7463, vrr_stack+1921, vrr_stack+7810);
 _BUILD_00k0(Data,vrr_stack+636, vrr_stack+743, vrr_stack+1142, vrr_stack+259, vrr_stack+1205, NULL);
 _BUILD_p0k0(Data,vrr_stack+7787, vrr_stack+39, vrr_stack+636, NULL, NULL, vrr_stack+743);
 _BUILD_d0k0(Data,vrr_stack+17306, vrr_stack+2029, vrr_stack+7787, vrr_stack+7355, vrr_stack+39, vrr_stack+7978);
 _BUILD_f0k0(Data,vrr_stack+31251, vrr_stack+16154, vrr_stack+17306, vrr_stack+1813, vrr_stack+2029, vrr_stack+8062);
 _BUILD_g0k0(Data,vrr_stack+31611, vrr_stack+16586, vrr_stack+31251, vrr_stack+16370, vrr_stack+16154, vrr_stack+8230);
 _BUILD_g0k0(Data,vrr_stack+7895, vrr_stack+16946, vrr_stack+16586, vrr_stack+7571, vrr_stack+16370, vrr_stack+2297);
 _BUILD_h0k0(Data,vrr_stack+32151, vrr_stack+7895, vrr_stack+31611, vrr_stack+16946, vrr_stack+16586, vrr_stack+2577);
 _BUILD_00k0(Data,vrr_stack+672, vrr_stack+1226, vrr_stack+771, vrr_stack+5374, vrr_stack+280, NULL);
 _BUILD_p0k0(Data,vrr_stack+2137, vrr_stack+672, vrr_stack+7427, NULL, NULL, vrr_stack+771);
 _BUILD_d0k0(Data,vrr_stack+2245, vrr_stack+2137, vrr_stack+7463, vrr_stack+672, vrr_stack+7427, vrr_stack+799);
 _BUILD_f0k0(Data,vrr_stack+2461, vrr_stack+2245, vrr_stack+7571, vrr_stack+2137, vrr_stack+7463, vrr_stack+883);
 _BUILD_g0k0(Data,vrr_stack+32907, vrr_stack+2461, vrr_stack+16946, vrr_stack+2245, vrr_stack+7571, vrr_stack+2997);
 _BUILD_h0k0(Data,vrr_stack+33447, vrr_stack+32907, vrr_stack+7895, vrr_stack+2461, vrr_stack+16946, vrr_stack+17811);
 _BUILD_00k0(Data,vrr_stack+799, vrr_stack+1142, vrr_stack+1338, vrr_stack+1205, vrr_stack+324, NULL);
 _BUILD_p0k0(Data,vrr_stack+835, vrr_stack+636, vrr_stack+799, NULL, NULL, vrr_stack+1142);
 _BUILD_d0k0(Data,vrr_stack+2821, vrr_stack+7787, vrr_stack+835, vrr_stack+39, vrr_stack+636, vrr_stack+8510);
 _BUILD_f0k0(Data,vrr_stack+17522, vrr_stack+17306, vrr_stack+2821, vrr_stack+2029, vrr_stack+7787, vrr_stack+3277);
 _BUILD_g0k0(Data,vrr_stack+34203, vrr_stack+31251, vrr_stack+17522, vrr_stack+16154, vrr_stack+17306, vrr_stack+3445);
 _BUILD_h0k0(Data,vrr_stack+34743, vrr_stack+31611, vrr_stack+34203, vrr_stack+16586, vrr_stack+31251, vrr_stack+18231);
 _BUILD_i0k0(Data,vrr_stack+35499, vrr_stack+32151, vrr_stack+34743, vrr_stack+7895, vrr_stack+31611, vrr_stack+18651);
 _BUILD_i0k0(Data,vrr_stack+17882, vrr_stack+33447, vrr_stack+32151, vrr_stack+32907, vrr_stack+7895, vrr_stack+8594);
 _BUILD_k0k0(Data,vrr_stack+36507, vrr_stack+17882, vrr_stack+35499, vrr_stack+33447, vrr_stack+32151, vrr_stack+19239);
 _BUILD_00k0(Data,vrr_stack+943, vrr_stack+1505, vrr_stack+1226, vrr_stack+1484, vrr_stack+5374, NULL);
 _BUILD_p0k0(Data,vrr_stack+979, vrr_stack+943, vrr_stack+672, NULL, NULL, vrr_stack+1226);
 _BUILD_d0k0(Data,vrr_stack+8435, vrr_stack+979, vrr_stack+2137, vrr_stack+943, vrr_stack+672, vrr_stack+1254);
 _BUILD_f0k0(Data,vrr_stack+8651, vrr_stack+8435, vrr_stack+2245, vrr_stack+979, vrr_stack+2137, vrr_stack+9182);
 _BUILD_g0k0(Data,vrr_stack+3037, vrr_stack+8651, vrr_stack+2461, vrr_stack+8435, vrr_stack+2245, vrr_stack+9350);
 _BUILD_h0k0(Data,vrr_stack+18890, vrr_stack+3037, vrr_stack+32907, vrr_stack+8651, vrr_stack+2461, vrr_stack+20023);
 _BUILD_i0k0(Data,vrr_stack+37803, vrr_stack+18890, vrr_stack+33447, vrr_stack+3037, vrr_stack+32907, vrr_stack+20443);
 _BUILD_k0k0(Data,vrr_stack+19646, vrr_stack+37803, vrr_stack+17882, vrr_stack+18890, vrr_stack+33447, vrr_stack+21031);
 _BUILD_00k0(Data,vrr_stack+1254, vrr_stack+1338, vrr_stack+5450, vrr_stack+324, vrr_stack+5794, NULL);
 _BUILD_p0k0(Data,vrr_stack+9011, vrr_stack+799, vrr_stack+1254, NULL, NULL, vrr_stack+1338);
 _BUILD_d0k0(Data,vrr_stack+9119, vrr_stack+835, vrr_stack+9011, vrr_stack+636, vrr_stack+799, vrr_stack+1366);
 _BUILD_f0k0(Data,vrr_stack+20942, vrr_stack+2821, vrr_stack+9119, vrr_stack+7787, vrr_stack+835, vrr_stack+9630);
 _BUILD_g0k0(Data,vrr_stack+38811, vrr_stack+17522, vrr_stack+20942, vrr_stack+17306, vrr_stack+2821, vrr_stack+9798);
 _BUILD_h0k0(Data,vrr_stack+39351, vrr_stack+34203, vrr_stack+38811, vrr_stack+31251, vrr_stack+17522, vrr_stack+3725);
 _BUILD_i0k0(Data,vrr_stack+40107, vrr_stack+34743, vrr_stack+39351, vrr_stack+31611, vrr_stack+34203, vrr_stack+4145);
 _BUILD_k0k0(Data,vrr_stack+41115, vrr_stack+35499, vrr_stack+40107, vrr_stack+32151, vrr_stack+34743, vrr_stack+21815);
 _BUILD_l0k0(Data,vrr_stack+42411, vrr_stack+36507, vrr_stack+41115, vrr_stack+17882, vrr_stack+35499, vrr_stack+10078);
 _BUILD_l0k0(Data,vrr_stack+9335, vrr_stack+19646, vrr_stack+36507, vrr_stack+37803, vrr_stack+17882, vrr_stack+22599);
 _BUILD_m0k0(Data,vrr_stack+21302, vrr_stack+9335, vrr_stack+42411, vrr_stack+19646, vrr_stack+36507, vrr_stack+23607);
 _BUILD_00p0(Data,vrr_stack+1366, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1369, vrr_stack+1366, vrr_stack+1450, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+1375, vrr_stack+1369, vrr_stack+1453, vrr_stack+1366, vrr_stack+1450, NULL);
 _BUILD_00g0(Data,vrr_stack+1385, vrr_stack+1375, vrr_stack+1459, vrr_stack+1369, vrr_stack+1453, NULL);
 _BUILD_00h0(Data,vrr_stack+1400, vrr_stack+1385, vrr_stack+1469, vrr_stack+1375, vrr_stack+1459, NULL);
 _BUILD_00i0(Data,vrr_stack+1421, vrr_stack+1400, vrr_stack+1484, vrr_stack+1385, vrr_stack+1469, NULL);
 _BUILD_00k0(Data,vrr_stack+1290, vrr_stack+1421, vrr_stack+1505, vrr_stack+1400, vrr_stack+1484, NULL);
 _BUILD_p0k0(Data,vrr_stack+10955, vrr_stack+1290, vrr_stack+943, NULL, NULL, vrr_stack+1505);
 _BUILD_d0k0(Data,vrr_stack+3577, vrr_stack+10955, vrr_stack+979, vrr_stack+1290, vrr_stack+943, vrr_stack+11086);
 _BUILD_f0k0(Data,vrr_stack+3793, vrr_stack+3577, vrr_stack+8435, vrr_stack+10955, vrr_stack+979, vrr_stack+11170);
 _BUILD_g0k0(Data,vrr_stack+4153, vrr_stack+3793, vrr_stack+8651, vrr_stack+3577, vrr_stack+8435, vrr_stack+11338);
 _BUILD_h0k0(Data,vrr_stack+23282, vrr_stack+4153, vrr_stack+3037, vrr_stack+3793, vrr_stack+8651, vrr_stack+11618);
 _BUILD_i0k0(Data,vrr_stack+10955, vrr_stack+23282, vrr_stack+18890, vrr_stack+4153, vrr_stack+3037, vrr_stack+4733);
 _BUILD_k0k0(Data,vrr_stack+3577, vrr_stack+10955, vrr_stack+37803, vrr_stack+23282, vrr_stack+18890, vrr_stack+24867);
   tmp = vrr_stack + 3577;
   target_ptr = Libint->vrr_classes[7][7];
   for(i=0;i<1296;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0k0(Data,vrr_stack+23282, vrr_stack+3577, vrr_stack+19646, vrr_stack+10955, vrr_stack+37803, vrr_stack+25651);
   tmp = vrr_stack + 23282;
   target_ptr = Libint->vrr_classes[8][7];
   for(i=0;i<1620;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0k0(Data,vrr_stack+44031, vrr_stack+23282, vrr_stack+9335, vrr_stack+3577, vrr_stack+19646, vrr_stack+12038);
   tmp = vrr_stack + 44031;
   target_ptr = Libint->vrr_classes[9][7];
   for(i=0;i<1980;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+3577, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3580, vrr_stack+5395, vrr_stack+3577, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+3586, vrr_stack+5398, vrr_stack+3580, vrr_stack+0, vrr_stack+5395, NULL);
 _BUILD_00g0(Data,vrr_stack+3596, vrr_stack+5404, vrr_stack+3586, vrr_stack+95, vrr_stack+5398, NULL);
 _BUILD_00h0(Data,vrr_stack+3611, vrr_stack+5414, vrr_stack+3596, vrr_stack+454, vrr_stack+5404, NULL);
 _BUILD_00i0(Data,vrr_stack+3632, vrr_stack+5429, vrr_stack+3611, vrr_stack+464, vrr_stack+5414, NULL);
 _BUILD_00k0(Data,vrr_stack+3660, vrr_stack+5450, vrr_stack+3632, vrr_stack+5794, vrr_stack+5429, NULL);
 _BUILD_p0k0(Data,vrr_stack+3696, vrr_stack+1254, vrr_stack+3660, NULL, NULL, vrr_stack+5450);
 _BUILD_d0k0(Data,vrr_stack+3804, vrr_stack+9011, vrr_stack+3696, vrr_stack+799, vrr_stack+1254, vrr_stack+5478);
 _BUILD_f0k0(Data,vrr_stack+4020, vrr_stack+9119, vrr_stack+3804, vrr_stack+835, vrr_stack+9011, vrr_stack+5562);
 _BUILD_g0k0(Data,vrr_stack+4380, vrr_stack+20942, vrr_stack+4020, vrr_stack+2821, vrr_stack+9119, vrr_stack+1533);
 _BUILD_h0k0(Data,vrr_stack+10955, vrr_stack+38811, vrr_stack+4380, vrr_stack+17522, vrr_stack+20942, vrr_stack+13298);
 _BUILD_i0k0(Data,vrr_stack+11711, vrr_stack+39351, vrr_stack+10955, vrr_stack+34203, vrr_stack+38811, vrr_stack+13718);
 _BUILD_k0k0(Data,vrr_stack+12719, vrr_stack+40107, vrr_stack+11711, vrr_stack+34743, vrr_stack+39351, vrr_stack+26659);
 _BUILD_l0k0(Data,vrr_stack+24902, vrr_stack+41115, vrr_stack+12719, vrr_stack+35499, vrr_stack+40107, vrr_stack+27443);
 _BUILD_m0k0(Data,vrr_stack+46011, vrr_stack+42411, vrr_stack+24902, vrr_stack+36507, vrr_stack+41115, vrr_stack+28451);
 _BUILD_n0k0(Data,vrr_stack+26522, vrr_stack+21302, vrr_stack+46011, vrr_stack+9335, vrr_stack+42411, vrr_stack+29711);
 _BUILD_n0k0(Data,vrr_stack+47991, vrr_stack+44031, vrr_stack+21302, vrr_stack+23282, vrr_stack+9335, vrr_stack+5815);
   tmp = vrr_stack + 47991;
   target_ptr = Libint->vrr_classes[10][7];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+23282, vrr_stack+7355, vrr_stack+39, vrr_stack+524, vrr_stack+580, NULL);
 _BUILD_00l0(Data,vrr_stack+23327, vrr_stack+7391, vrr_stack+7355, vrr_stack+552, vrr_stack+524, NULL);
 _BUILD_p0l0(Data,vrr_stack+23372, vrr_stack+23327, vrr_stack+23282, NULL, NULL, vrr_stack+7355);
 _BUILD_00l0(Data,vrr_stack+23507, vrr_stack+3, vrr_stack+7391, vrr_stack+608, vrr_stack+552, NULL);
 _BUILD_p0l0(Data,vrr_stack+23552, vrr_stack+23507, vrr_stack+23327, NULL, NULL, vrr_stack+7391);
 _BUILD_00l0(Data,vrr_stack+23687, vrr_stack+39, vrr_stack+636, vrr_stack+580, vrr_stack+743, NULL);
 _BUILD_p0l0(Data,vrr_stack+23732, vrr_stack+23282, vrr_stack+23687, NULL, NULL, vrr_stack+39);
 _BUILD_d0l0(Data,vrr_stack+23867, vrr_stack+23372, vrr_stack+23732, vrr_stack+23327, vrr_stack+23282, vrr_stack+2029);
 _BUILD_d0l0(Data,vrr_stack+24137, vrr_stack+23552, vrr_stack+23372, vrr_stack+23507, vrr_stack+23327, vrr_stack+1813);
 _BUILD_f0l0(Data,vrr_stack+24407, vrr_stack+24137, vrr_stack+23867, vrr_stack+23552, vrr_stack+23372, vrr_stack+16154);
 _BUILD_00l0(Data,vrr_stack+24857, vrr_stack+7427, vrr_stack+3, vrr_stack+771, vrr_stack+608, NULL);
 _BUILD_p0l0(Data,vrr_stack+16154, vrr_stack+24857, vrr_stack+23507, NULL, NULL, vrr_stack+3);
 _BUILD_d0l0(Data,vrr_stack+1533, vrr_stack+16154, vrr_stack+23552, vrr_stack+24857, vrr_stack+23507, vrr_stack+1921);
 _BUILD_f0l0(Data,vrr_stack+5478, vrr_stack+1533, vrr_stack+24137, vrr_stack+16154, vrr_stack+23552, vrr_stack+16370);
 _BUILD_00l0(Data,vrr_stack+16289, vrr_stack+636, vrr_stack+799, vrr_stack+743, vrr_stack+1142, NULL);
 _BUILD_p0l0(Data,vrr_stack+16334, vrr_stack+23687, vrr_stack+16289, NULL, NULL, vrr_stack+636);
 _BUILD_d0l0(Data,vrr_stack+1803, vrr_stack+23732, vrr_stack+16334, vrr_stack+23282, vrr_stack+23687, vrr_stack+7787);
 _BUILD_f0l0(Data,vrr_stack+5928, vrr_stack+23867, vrr_stack+1803, vrr_stack+23372, vrr_stack+23732, vrr_stack+17306);
 _BUILD_g0l0(Data,vrr_stack+6378, vrr_stack+24407, vrr_stack+5928, vrr_stack+24137, vrr_stack+23867, vrr_stack+31251);
 _BUILD_g0l0(Data,vrr_stack+28898, vrr_stack+5478, vrr_stack+24407, vrr_stack+1533, vrr_stack+24137, vrr_stack+16586);
 _BUILD_h0l0(Data,vrr_stack+29573, vrr_stack+28898, vrr_stack+6378, vrr_stack+5478, vrr_stack+24407, vrr_stack+31611);
 _BUILD_00l0(Data,vrr_stack+17306, vrr_stack+672, vrr_stack+7427, vrr_stack+1226, vrr_stack+771, NULL);
 _BUILD_p0l0(Data,vrr_stack+17351, vrr_stack+17306, vrr_stack+24857, NULL, NULL, vrr_stack+7427);
 _BUILD_d0l0(Data,vrr_stack+16469, vrr_stack+17351, vrr_stack+16154, vrr_stack+17306, vrr_stack+24857, vrr_stack+7463);
 _BUILD_f0l0(Data,vrr_stack+4920, vrr_stack+16469, vrr_stack+1533, vrr_stack+17351, vrr_stack+16154, vrr_stack+7571);
 _BUILD_g0l0(Data,vrr_stack+30518, vrr_stack+4920, vrr_stack+5478, vrr_stack+16469, vrr_stack+1533, vrr_stack+16946);
 _BUILD_h0l0(Data,vrr_stack+31193, vrr_stack+30518, vrr_stack+28898, vrr_stack+4920, vrr_stack+5478, vrr_stack+7895);
 _BUILD_00l0(Data,vrr_stack+7463, vrr_stack+799, vrr_stack+1254, vrr_stack+1142, vrr_stack+1338, NULL);
 _BUILD_p0l0(Data,vrr_stack+7508, vrr_stack+16289, vrr_stack+7463, NULL, NULL, vrr_stack+799);
 _BUILD_d0l0(Data,vrr_stack+7643, vrr_stack+16334, vrr_stack+7508, vrr_stack+23687, vrr_stack+16289, vrr_stack+835);
 _BUILD_f0l0(Data,vrr_stack+7913, vrr_stack+1803, vrr_stack+7643, vrr_stack+23732, vrr_stack+16334, vrr_stack+2821);
 _BUILD_g0l0(Data,vrr_stack+50367, vrr_stack+5928, vrr_stack+7913, vrr_stack+23867, vrr_stack+1803, vrr_stack+17522);
 _BUILD_h0l0(Data,vrr_stack+51042, vrr_stack+6378, vrr_stack+50367, vrr_stack+24407, vrr_stack+5928, vrr_stack+34203);
 _BUILD_i0l0(Data,vrr_stack+51987, vrr_stack+29573, vrr_stack+51042, vrr_stack+28898, vrr_stack+6378, vrr_stack+34743);
 _BUILD_i0l0(Data,vrr_stack+34203, vrr_stack+31193, vrr_stack+29573, vrr_stack+30518, vrr_stack+28898, vrr_stack+32151);
 _BUILD_k0l0(Data,vrr_stack+53247, vrr_stack+34203, vrr_stack+51987, vrr_stack+31193, vrr_stack+29573, vrr_stack+35499);
 _BUILD_00l0(Data,vrr_stack+35463, vrr_stack+943, vrr_stack+672, vrr_stack+1505, vrr_stack+1226, NULL);
 _BUILD_p0l0(Data,vrr_stack+35508, vrr_stack+35463, vrr_stack+17306, NULL, NULL, vrr_stack+672);
 _BUILD_d0l0(Data,vrr_stack+35643, vrr_stack+35508, vrr_stack+17351, vrr_stack+35463, vrr_stack+17306, vrr_stack+2137);
 _BUILD_f0l0(Data,vrr_stack+35913, vrr_stack+35643, vrr_stack+16469, vrr_stack+35508, vrr_stack+17351, vrr_stack+2245);
 _BUILD_g0l0(Data,vrr_stack+32138, vrr_stack+35913, vrr_stack+4920, vrr_stack+35643, vrr_stack+16469, vrr_stack+2461);
 _BUILD_h0l0(Data,vrr_stack+2073, vrr_stack+32138, vrr_stack+30518, vrr_stack+35913, vrr_stack+4920, vrr_stack+32907);
 _BUILD_i0l0(Data,vrr_stack+54867, vrr_stack+2073, vrr_stack+31193, vrr_stack+32138, vrr_stack+30518, vrr_stack+33447);
 _BUILD_k0l0(Data,vrr_stack+56127, vrr_stack+54867, vrr_stack+34203, vrr_stack+2073, vrr_stack+31193, vrr_stack+17882);
 _BUILD_00l0(Data,vrr_stack+36363, vrr_stack+1254, vrr_stack+3660, vrr_stack+1338, vrr_stack+5450, NULL);
 _BUILD_p0l0(Data,vrr_stack+17486, vrr_stack+7463, vrr_stack+36363, NULL, NULL, vrr_stack+1254);
 _BUILD_d0l0(Data,vrr_stack+17621, vrr_stack+7508, vrr_stack+17486, vrr_stack+16289, vrr_stack+7463, vrr_stack+9011);
 _BUILD_f0l0(Data,vrr_stack+17891, vrr_stack+7643, vrr_stack+17621, vrr_stack+16334, vrr_stack+7508, vrr_stack+9119);
 _BUILD_g0l0(Data,vrr_stack+32813, vrr_stack+7913, vrr_stack+17891, vrr_stack+1803, vrr_stack+7643, vrr_stack+20942);
 _BUILD_h0l0(Data,vrr_stack+57747, vrr_stack+50367, vrr_stack+32813, vrr_stack+5928, vrr_stack+7913, vrr_stack+38811);
 _BUILD_i0l0(Data,vrr_stack+58692, vrr_stack+51042, vrr_stack+57747, vrr_stack+6378, vrr_stack+50367, vrr_stack+39351);
 _BUILD_k0l0(Data,vrr_stack+59952, vrr_stack+51987, vrr_stack+58692, vrr_stack+29573, vrr_stack+51042, vrr_stack+40107);
 _BUILD_l0l0(Data,vrr_stack+38811, vrr_stack+53247, vrr_stack+59952, vrr_stack+34203, vrr_stack+51987, vrr_stack+41115);
 _BUILD_l0l0(Data,vrr_stack+61572, vrr_stack+56127, vrr_stack+53247, vrr_stack+54867, vrr_stack+34203, vrr_stack+36507);
 _BUILD_m0l0(Data,vrr_stack+63597, vrr_stack+61572, vrr_stack+38811, vrr_stack+56127, vrr_stack+53247, vrr_stack+42411);
 _BUILD_00l0(Data,vrr_stack+40836, vrr_stack+1290, vrr_stack+943, vrr_stack+1421, vrr_stack+1505, NULL);
 _BUILD_p0l0(Data,vrr_stack+40881, vrr_stack+40836, vrr_stack+35463, NULL, NULL, vrr_stack+943);
 _BUILD_d0l0(Data,vrr_stack+41016, vrr_stack+40881, vrr_stack+35508, vrr_stack+40836, vrr_stack+35463, vrr_stack+979);
 _BUILD_f0l0(Data,vrr_stack+41286, vrr_stack+41016, vrr_stack+35643, vrr_stack+40881, vrr_stack+35508, vrr_stack+8435);
 _BUILD_g0l0(Data,vrr_stack+41736, vrr_stack+41286, vrr_stack+35913, vrr_stack+41016, vrr_stack+35643, vrr_stack+8651);
 _BUILD_h0l0(Data,vrr_stack+42411, vrr_stack+41736, vrr_stack+32138, vrr_stack+41286, vrr_stack+35913, vrr_stack+3037);
 _BUILD_i0l0(Data,vrr_stack+36408, vrr_stack+42411, vrr_stack+2073, vrr_stack+41736, vrr_stack+32138, vrr_stack+18890);
 _BUILD_k0l0(Data,vrr_stack+66072, vrr_stack+36408, vrr_stack+54867, vrr_stack+42411, vrr_stack+2073, vrr_stack+37803);
   tmp = vrr_stack + 66072;
   target_ptr = Libint->vrr_classes[7][8];
   for(i=0;i<1620;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0l0(Data,vrr_stack+40881, vrr_stack+66072, vrr_stack+56127, vrr_stack+36408, vrr_stack+54867, vrr_stack+19646);
   tmp = vrr_stack + 40881;
   target_ptr = Libint->vrr_classes[8][8];
   for(i=0;i<2025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0l0(Data,vrr_stack+18341, vrr_stack+40881, vrr_stack+61572, vrr_stack+66072, vrr_stack+56127, vrr_stack+9335);
   tmp = vrr_stack + 18341;
   target_ptr = Libint->vrr_classes[9][8];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+66072, vrr_stack+3577, vrr_stack+0, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+66078, vrr_stack+3580, vrr_stack+66072, vrr_stack+5395, vrr_stack+3577, NULL);
 _BUILD_00g0(Data,vrr_stack+66088, vrr_stack+3586, vrr_stack+66078, vrr_stack+5398, vrr_stack+3580, NULL);
 _BUILD_00h0(Data,vrr_stack+66103, vrr_stack+3596, vrr_stack+66088, vrr_stack+5404, vrr_stack+3586, NULL);
 _BUILD_00i0(Data,vrr_stack+66124, vrr_stack+3611, vrr_stack+66103, vrr_stack+5414, vrr_stack+3596, NULL);
 _BUILD_00k0(Data,vrr_stack+66152, vrr_stack+3632, vrr_stack+66124, vrr_stack+5429, vrr_stack+3611, NULL);
 _BUILD_00l0(Data,vrr_stack+66188, vrr_stack+3660, vrr_stack+66152, vrr_stack+5450, vrr_stack+3632, NULL);
 _BUILD_p0l0(Data,vrr_stack+66233, vrr_stack+36363, vrr_stack+66188, NULL, NULL, vrr_stack+3660);
 _BUILD_d0l0(Data,vrr_stack+66368, vrr_stack+17486, vrr_stack+66233, vrr_stack+7463, vrr_stack+36363, vrr_stack+3696);
 _BUILD_f0l0(Data,vrr_stack+66638, vrr_stack+17621, vrr_stack+66368, vrr_stack+7508, vrr_stack+17486, vrr_stack+3804);
 _BUILD_g0l0(Data,vrr_stack+67088, vrr_stack+17891, vrr_stack+66638, vrr_stack+7643, vrr_stack+17621, vrr_stack+4020);
 _BUILD_h0l0(Data,vrr_stack+36408, vrr_stack+32813, vrr_stack+67088, vrr_stack+7913, vrr_stack+17891, vrr_stack+4380);
 _BUILD_i0l0(Data,vrr_stack+37353, vrr_stack+57747, vrr_stack+36408, vrr_stack+50367, vrr_stack+32813, vrr_stack+10955);
 _BUILD_k0l0(Data,vrr_stack+8363, vrr_stack+58692, vrr_stack+37353, vrr_stack+51042, vrr_stack+57747, vrr_stack+11711);
 _BUILD_l0l0(Data,vrr_stack+9983, vrr_stack+59952, vrr_stack+8363, vrr_stack+51987, vrr_stack+58692, vrr_stack+12719);
 _BUILD_m0l0(Data,vrr_stack+67763, vrr_stack+38811, vrr_stack+9983, vrr_stack+53247, vrr_stack+59952, vrr_stack+24902);
 _BUILD_n0l0(Data,vrr_stack+70238, vrr_stack+63597, vrr_stack+67763, vrr_stack+61572, vrr_stack+38811, vrr_stack+46011);
 _BUILD_n0l0(Data,vrr_stack+73208, vrr_stack+18341, vrr_stack+63597, vrr_stack+40881, vrr_stack+61572, vrr_stack+21302);
   tmp = vrr_stack + 73208;
   target_ptr = Libint->vrr_classes[10][8];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+40881, vrr_stack+23282, vrr_stack+23687, vrr_stack+7355, vrr_stack+39, NULL);
 _BUILD_00m0(Data,vrr_stack+40936, vrr_stack+23327, vrr_stack+23282, vrr_stack+7391, vrr_stack+7355, NULL);
 _BUILD_p0m0(Data,vrr_stack+40991, vrr_stack+40936, vrr_stack+40881, NULL, NULL, vrr_stack+23282);
 _BUILD_00m0(Data,vrr_stack+41156, vrr_stack+23507, vrr_stack+23327, vrr_stack+3, vrr_stack+7391, NULL);
 _BUILD_p0m0(Data,vrr_stack+41211, vrr_stack+41156, vrr_stack+40936, NULL, NULL, vrr_stack+23327);
 _BUILD_00m0(Data,vrr_stack+41376, vrr_stack+23687, vrr_stack+16289, vrr_stack+39, vrr_stack+636, NULL);
 _BUILD_p0m0(Data,vrr_stack+39, vrr_stack+40881, vrr_stack+41376, NULL, NULL, vrr_stack+23687);
 _BUILD_d0m0(Data,vrr_stack+204, vrr_stack+40991, vrr_stack+39, vrr_stack+40936, vrr_stack+40881, vrr_stack+23732);
 _BUILD_d0m0(Data,vrr_stack+41431, vrr_stack+41211, vrr_stack+40991, vrr_stack+41156, vrr_stack+40936, vrr_stack+23372);
 _BUILD_f0m0(Data,vrr_stack+41761, vrr_stack+41431, vrr_stack+204, vrr_stack+41211, vrr_stack+40991, vrr_stack+23867);
 _BUILD_00m0(Data,vrr_stack+23372, vrr_stack+24857, vrr_stack+23507, vrr_stack+7427, vrr_stack+3, NULL);
 _BUILD_p0m0(Data,vrr_stack+23732, vrr_stack+23372, vrr_stack+41156, NULL, NULL, vrr_stack+23507);
 _BUILD_d0m0(Data,vrr_stack+42311, vrr_stack+23732, vrr_stack+41211, vrr_stack+23372, vrr_stack+41156, vrr_stack+23552);
 _BUILD_f0m0(Data,vrr_stack+42641, vrr_stack+42311, vrr_stack+41431, vrr_stack+23732, vrr_stack+41211, vrr_stack+24137);
 _BUILD_00m0(Data,vrr_stack+23552, vrr_stack+16289, vrr_stack+7463, vrr_stack+636, vrr_stack+799, NULL);
 _BUILD_p0m0(Data,vrr_stack+23897, vrr_stack+41376, vrr_stack+23552, NULL, NULL, vrr_stack+16289);
 _BUILD_d0m0(Data,vrr_stack+24062, vrr_stack+39, vrr_stack+23897, vrr_stack+40881, vrr_stack+41376, vrr_stack+16334);
 _BUILD_f0m0(Data,vrr_stack+43191, vrr_stack+204, vrr_stack+24062, vrr_stack+40991, vrr_stack+39, vrr_stack+1803);
 _BUILD_g0m0(Data,vrr_stack+46011, vrr_stack+41761, vrr_stack+43191, vrr_stack+41431, vrr_stack+204, vrr_stack+5928);
 _BUILD_g0m0(Data,vrr_stack+46836, vrr_stack+42641, vrr_stack+41761, vrr_stack+42311, vrr_stack+41431, vrr_stack+24407);
 _BUILD_h0m0(Data,vrr_stack+24902, vrr_stack+46836, vrr_stack+46011, vrr_stack+42641, vrr_stack+41761, vrr_stack+6378);
 _BUILD_00m0(Data,vrr_stack+5928, vrr_stack+17306, vrr_stack+24857, vrr_stack+672, vrr_stack+7427, NULL);
 _BUILD_p0m0(Data,vrr_stack+5983, vrr_stack+5928, vrr_stack+23372, NULL, NULL, vrr_stack+24857);
 _BUILD_d0m0(Data,vrr_stack+47661, vrr_stack+5983, vrr_stack+23732, vrr_stack+5928, vrr_stack+23372, vrr_stack+16154);
 _BUILD_f0m0(Data,vrr_stack+6148, vrr_stack+47661, vrr_stack+42311, vrr_stack+5983, vrr_stack+23732, vrr_stack+1533);
 _BUILD_g0m0(Data,vrr_stack+3696, vrr_stack+6148, vrr_stack+42641, vrr_stack+47661, vrr_stack+42311, vrr_stack+5478);
 _BUILD_h0m0(Data,vrr_stack+12008, vrr_stack+3696, vrr_stack+46836, vrr_stack+6148, vrr_stack+42641, vrr_stack+28898);
 _BUILD_00m0(Data,vrr_stack+28898, vrr_stack+7463, vrr_stack+36363, vrr_stack+799, vrr_stack+1254, NULL);
 _BUILD_p0m0(Data,vrr_stack+28953, vrr_stack+23552, vrr_stack+28898, NULL, NULL, vrr_stack+7463);
 _BUILD_d0m0(Data,vrr_stack+29118, vrr_stack+23897, vrr_stack+28953, vrr_stack+41376, vrr_stack+23552, vrr_stack+7508);
 _BUILD_f0m0(Data,vrr_stack+6698, vrr_stack+24062, vrr_stack+29118, vrr_stack+39, vrr_stack+23897, vrr_stack+7643);
 _BUILD_g0m0(Data,vrr_stack+13163, vrr_stack+43191, vrr_stack+6698, vrr_stack+204, vrr_stack+24062, vrr_stack+7913);
 _BUILD_h0m0(Data,vrr_stack+76178, vrr_stack+46011, vrr_stack+13163, vrr_stack+41761, vrr_stack+43191, vrr_stack+50367);
 _BUILD_i0m0(Data,vrr_stack+77333, vrr_stack+24902, vrr_stack+76178, vrr_stack+46836, vrr_stack+46011, vrr_stack+51042);
 _BUILD_i0m0(Data,vrr_stack+50367, vrr_stack+12008, vrr_stack+24902, vrr_stack+3696, vrr_stack+46836, vrr_stack+29573);
 _BUILD_k0m0(Data,vrr_stack+78873, vrr_stack+50367, vrr_stack+77333, vrr_stack+12008, vrr_stack+24902, vrr_stack+51987);
 _BUILD_00m0(Data,vrr_stack+51907, vrr_stack+35463, vrr_stack+17306, vrr_stack+943, vrr_stack+672, NULL);
 _BUILD_p0m0(Data,vrr_stack+51962, vrr_stack+51907, vrr_stack+5928, NULL, NULL, vrr_stack+17306);
 _BUILD_d0m0(Data,vrr_stack+52127, vrr_stack+51962, vrr_stack+5983, vrr_stack+51907, vrr_stack+5928, vrr_stack+17351);
 _BUILD_f0m0(Data,vrr_stack+52457, vrr_stack+52127, vrr_stack+47661, vrr_stack+51962, vrr_stack+5983, vrr_stack+16469);
 _BUILD_g0m0(Data,vrr_stack+7508, vrr_stack+52457, vrr_stack+6148, vrr_stack+52127, vrr_stack+47661, vrr_stack+4920);
 _BUILD_h0m0(Data,vrr_stack+4521, vrr_stack+7508, vrr_stack+3696, vrr_stack+52457, vrr_stack+6148, vrr_stack+30518);
 _BUILD_i0m0(Data,vrr_stack+29448, vrr_stack+4521, vrr_stack+12008, vrr_stack+7508, vrr_stack+3696, vrr_stack+31193);
 _BUILD_k0m0(Data,vrr_stack+80853, vrr_stack+29448, vrr_stack+50367, vrr_stack+4521, vrr_stack+12008, vrr_stack+34203);
 _BUILD_00m0(Data,vrr_stack+17351, vrr_stack+36363, vrr_stack+66188, vrr_stack+1254, vrr_stack+3660, NULL);
 _BUILD_p0m0(Data,vrr_stack+53007, vrr_stack+28898, vrr_stack+17351, NULL, NULL, vrr_stack+36363);
 _BUILD_d0m0(Data,vrr_stack+30988, vrr_stack+28953, vrr_stack+53007, vrr_stack+23552, vrr_stack+28898, vrr_stack+17486);
 _BUILD_f0m0(Data,vrr_stack+31318, vrr_stack+29118, vrr_stack+30988, vrr_stack+23897, vrr_stack+28953, vrr_stack+17621);
 _BUILD_g0m0(Data,vrr_stack+16334, vrr_stack+6698, vrr_stack+31318, vrr_stack+24062, vrr_stack+29118, vrr_stack+17891);
 _BUILD_h0m0(Data,vrr_stack+33488, vrr_stack+13163, vrr_stack+16334, vrr_stack+43191, vrr_stack+6698, vrr_stack+32813);
 _BUILD_i0m0(Data,vrr_stack+82833, vrr_stack+76178, vrr_stack+33488, vrr_stack+46011, vrr_stack+13163, vrr_stack+57747);
 _BUILD_k0m0(Data,vrr_stack+84373, vrr_stack+77333, vrr_stack+82833, vrr_stack+24902, vrr_stack+76178, vrr_stack+58692);
 _BUILD_l0m0(Data,vrr_stack+86353, vrr_stack+78873, vrr_stack+84373, vrr_stack+50367, vrr_stack+77333, vrr_stack+59952);
 _BUILD_l0m0(Data,vrr_stack+57747, vrr_stack+80853, vrr_stack+78873, vrr_stack+29448, vrr_stack+50367, vrr_stack+53247);
 _BUILD_m0m0(Data,vrr_stack+88828, vrr_stack+57747, vrr_stack+86353, vrr_stack+80853, vrr_stack+78873, vrr_stack+38811);
 _BUILD_00m0(Data,vrr_stack+60222, vrr_stack+40836, vrr_stack+35463, vrr_stack+1290, vrr_stack+943, NULL);
 _BUILD_p0m0(Data,vrr_stack+60277, vrr_stack+60222, vrr_stack+51907, NULL, NULL, vrr_stack+35463);
 _BUILD_d0m0(Data,vrr_stack+60442, vrr_stack+60277, vrr_stack+51962, vrr_stack+60222, vrr_stack+51907, vrr_stack+35508);
 _BUILD_f0m0(Data,vrr_stack+60772, vrr_stack+60442, vrr_stack+52127, vrr_stack+60277, vrr_stack+51962, vrr_stack+35643);
 _BUILD_g0m0(Data,vrr_stack+17406, vrr_stack+60772, vrr_stack+52457, vrr_stack+60442, vrr_stack+52127, vrr_stack+35913);
 _BUILD_h0m0(Data,vrr_stack+53172, vrr_stack+17406, vrr_stack+7508, vrr_stack+60772, vrr_stack+52457, vrr_stack+32138);
 _BUILD_i0m0(Data,vrr_stack+31868, vrr_stack+53172, vrr_stack+4521, vrr_stack+17406, vrr_stack+7508, vrr_stack+2073);
 _BUILD_k0m0(Data,vrr_stack+534, vrr_stack+31868, vrr_stack+29448, vrr_stack+53172, vrr_stack+4521, vrr_stack+54867);
   tmp = vrr_stack + 534;
   target_ptr = Libint->vrr_classes[7][9];
   for(i=0;i<1980;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0m0(Data,vrr_stack+53172, vrr_stack+534, vrr_stack+80853, vrr_stack+31868, vrr_stack+29448, vrr_stack+56127);
   tmp = vrr_stack + 53172;
   target_ptr = Libint->vrr_classes[8][9];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0m0(Data,vrr_stack+91853, vrr_stack+53172, vrr_stack+57747, vrr_stack+534, vrr_stack+80853, vrr_stack+61572);
   tmp = vrr_stack + 91853;
   target_ptr = Libint->vrr_classes[9][9];
   for(i=0;i<3025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+534, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+537, vrr_stack+0, vrr_stack+534, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+543, vrr_stack+66072, vrr_stack+537, vrr_stack+3577, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+553, vrr_stack+66078, vrr_stack+543, vrr_stack+3580, vrr_stack+66072, NULL);
 _BUILD_00h0(Data,vrr_stack+568, vrr_stack+66088, vrr_stack+553, vrr_stack+3586, vrr_stack+66078, NULL);
 _BUILD_00i0(Data,vrr_stack+589, vrr_stack+66103, vrr_stack+568, vrr_stack+3596, vrr_stack+66088, NULL);
 _BUILD_00k0(Data,vrr_stack+3, vrr_stack+66124, vrr_stack+589, vrr_stack+3611, vrr_stack+66103, NULL);
 _BUILD_00l0(Data,vrr_stack+617, vrr_stack+66152, vrr_stack+3, vrr_stack+3632, vrr_stack+66124, NULL);
 _BUILD_00m0(Data,vrr_stack+662, vrr_stack+66188, vrr_stack+617, vrr_stack+3660, vrr_stack+66152, NULL);
 _BUILD_p0m0(Data,vrr_stack+717, vrr_stack+17351, vrr_stack+662, NULL, NULL, vrr_stack+66188);
 _BUILD_d0m0(Data,vrr_stack+882, vrr_stack+53007, vrr_stack+717, vrr_stack+28898, vrr_stack+17351, vrr_stack+66233);
 _BUILD_f0m0(Data,vrr_stack+1212, vrr_stack+30988, vrr_stack+882, vrr_stack+28953, vrr_stack+53007, vrr_stack+66368);
 _BUILD_g0m0(Data,vrr_stack+1762, vrr_stack+31318, vrr_stack+1212, vrr_stack+29118, vrr_stack+30988, vrr_stack+66638);
 _BUILD_h0m0(Data,vrr_stack+31868, vrr_stack+16334, vrr_stack+1762, vrr_stack+6698, vrr_stack+31318, vrr_stack+67088);
 _BUILD_i0m0(Data,vrr_stack+55647, vrr_stack+33488, vrr_stack+31868, vrr_stack+13163, vrr_stack+16334, vrr_stack+36408);
 _BUILD_k0m0(Data,vrr_stack+60277, vrr_stack+82833, vrr_stack+55647, vrr_stack+76178, vrr_stack+33488, vrr_stack+37353);
 _BUILD_l0m0(Data,vrr_stack+36408, vrr_stack+84373, vrr_stack+60277, vrr_stack+77333, vrr_stack+82833, vrr_stack+8363);
 _BUILD_m0m0(Data,vrr_stack+94878, vrr_stack+86353, vrr_stack+36408, vrr_stack+78873, vrr_stack+84373, vrr_stack+9983);
 _BUILD_n0m0(Data,vrr_stack+8333, vrr_stack+88828, vrr_stack+94878, vrr_stack+57747, vrr_stack+86353, vrr_stack+67763);
 _BUILD_n0m0(Data,vrr_stack+66233, vrr_stack+91853, vrr_stack+88828, vrr_stack+53172, vrr_stack+57747, vrr_stack+63597);
   tmp = vrr_stack + 66233;
   target_ptr = Libint->vrr_classes[10][9];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+53172, vrr_stack+40881, vrr_stack+41376, vrr_stack+23282, vrr_stack+23687, NULL);
 _BUILD_00n0(Data,vrr_stack+53238, vrr_stack+40936, vrr_stack+40881, vrr_stack+23327, vrr_stack+23282, NULL);
 _BUILD_p0n0(Data,vrr_stack+53304, vrr_stack+53238, vrr_stack+53172, NULL, NULL, vrr_stack+40881);
 _BUILD_00n0(Data,vrr_stack+53502, vrr_stack+41156, vrr_stack+40936, vrr_stack+23507, vrr_stack+23327, NULL);
 _BUILD_p0n0(Data,vrr_stack+53568, vrr_stack+53502, vrr_stack+53238, NULL, NULL, vrr_stack+40936);
 _BUILD_00n0(Data,vrr_stack+23282, vrr_stack+41376, vrr_stack+23552, vrr_stack+23687, vrr_stack+16289, NULL);
 _BUILD_p0n0(Data,vrr_stack+53766, vrr_stack+53172, vrr_stack+23282, NULL, NULL, vrr_stack+41376);
 _BUILD_d0n0(Data,vrr_stack+53964, vrr_stack+53304, vrr_stack+53766, vrr_stack+53238, vrr_stack+53172, vrr_stack+39);
 _BUILD_d0n0(Data,vrr_stack+54360, vrr_stack+53568, vrr_stack+53304, vrr_stack+53502, vrr_stack+53238, vrr_stack+40991);
 _BUILD_f0n0(Data,vrr_stack+54756, vrr_stack+54360, vrr_stack+53964, vrr_stack+53568, vrr_stack+53304, vrr_stack+204);
 _BUILD_00n0(Data,vrr_stack+40991, vrr_stack+23372, vrr_stack+41156, vrr_stack+24857, vrr_stack+23507, NULL);
 _BUILD_p0n0(Data,vrr_stack+39, vrr_stack+40991, vrr_stack+53502, NULL, NULL, vrr_stack+41156);
 _BUILD_d0n0(Data,vrr_stack+38883, vrr_stack+39, vrr_stack+53568, vrr_stack+40991, vrr_stack+53502, vrr_stack+41211);
 _BUILD_f0n0(Data,vrr_stack+39279, vrr_stack+38883, vrr_stack+54360, vrr_stack+39, vrr_stack+53568, vrr_stack+41431);
 _BUILD_00n0(Data,vrr_stack+41431, vrr_stack+23552, vrr_stack+28898, vrr_stack+16289, vrr_stack+7463, NULL);
 _BUILD_p0n0(Data,vrr_stack+41497, vrr_stack+23282, vrr_stack+41431, NULL, NULL, vrr_stack+23552);
 _BUILD_d0n0(Data,vrr_stack+39939, vrr_stack+53766, vrr_stack+41497, vrr_stack+53172, vrr_stack+23282, vrr_stack+23897);
 _BUILD_f0n0(Data,vrr_stack+2587, vrr_stack+53964, vrr_stack+39939, vrr_stack+53304, vrr_stack+53766, vrr_stack+24062);
 _BUILD_g0n0(Data,vrr_stack+62257, vrr_stack+54756, vrr_stack+2587, vrr_stack+54360, vrr_stack+53964, vrr_stack+43191);
 _BUILD_g0n0(Data,vrr_stack+97903, vrr_stack+39279, vrr_stack+54756, vrr_stack+38883, vrr_stack+54360, vrr_stack+41761);
 _BUILD_h0n0(Data,vrr_stack+98893, vrr_stack+97903, vrr_stack+62257, vrr_stack+39279, vrr_stack+54756, vrr_stack+46011);
 _BUILD_00n0(Data,vrr_stack+46011, vrr_stack+5928, vrr_stack+23372, vrr_stack+17306, vrr_stack+24857, NULL);
 _BUILD_p0n0(Data,vrr_stack+46077, vrr_stack+46011, vrr_stack+40991, NULL, NULL, vrr_stack+23372);
 _BUILD_d0n0(Data,vrr_stack+46275, vrr_stack+46077, vrr_stack+39, vrr_stack+46011, vrr_stack+40991, vrr_stack+23732);
 _BUILD_f0n0(Data,vrr_stack+43191, vrr_stack+46275, vrr_stack+38883, vrr_stack+46077, vrr_stack+39, vrr_stack+42311);
 _BUILD_g0n0(Data,vrr_stack+23607, vrr_stack+43191, vrr_stack+39279, vrr_stack+46275, vrr_stack+38883, vrr_stack+42641);
 _BUILD_h0n0(Data,vrr_stack+41695, vrr_stack+23607, vrr_stack+97903, vrr_stack+43191, vrr_stack+39279, vrr_stack+46836);
 _BUILD_00n0(Data,vrr_stack+46671, vrr_stack+28898, vrr_stack+17351, vrr_stack+7463, vrr_stack+36363, NULL);
 _BUILD_p0n0(Data,vrr_stack+46737, vrr_stack+41431, vrr_stack+46671, NULL, NULL, vrr_stack+28898);
 _BUILD_d0n0(Data,vrr_stack+46935, vrr_stack+41497, vrr_stack+46737, vrr_stack+23282, vrr_stack+41431, vrr_stack+28953);
 _BUILD_f0n0(Data,vrr_stack+17406, vrr_stack+39939, vrr_stack+46935, vrr_stack+53766, vrr_stack+41497, vrr_stack+29118);
 _BUILD_g0n0(Data,vrr_stack+100279, vrr_stack+2587, vrr_stack+17406, vrr_stack+53964, vrr_stack+39939, vrr_stack+6698);
 _BUILD_h0n0(Data,vrr_stack+101269, vrr_stack+62257, vrr_stack+100279, vrr_stack+54756, vrr_stack+2587, vrr_stack+13163);
 _BUILD_i0n0(Data,vrr_stack+102655, vrr_stack+98893, vrr_stack+101269, vrr_stack+97903, vrr_stack+62257, vrr_stack+76178);
 _BUILD_i0n0(Data,vrr_stack+104503, vrr_stack+41695, vrr_stack+98893, vrr_stack+23607, vrr_stack+97903, vrr_stack+24902);
 _BUILD_k0n0(Data,vrr_stack+106351, vrr_stack+104503, vrr_stack+102655, vrr_stack+41695, vrr_stack+98893, vrr_stack+77333);
 _BUILD_00n0(Data,vrr_stack+76178, vrr_stack+51907, vrr_stack+5928, vrr_stack+35463, vrr_stack+17306, NULL);
 _BUILD_p0n0(Data,vrr_stack+76244, vrr_stack+76178, vrr_stack+46011, NULL, NULL, vrr_stack+5928);
 _BUILD_d0n0(Data,vrr_stack+76442, vrr_stack+76244, vrr_stack+46077, vrr_stack+76178, vrr_stack+46011, vrr_stack+5983);
 _BUILD_f0n0(Data,vrr_stack+76838, vrr_stack+76442, vrr_stack+46275, vrr_stack+76244, vrr_stack+46077, vrr_stack+47661);
 _BUILD_g0n0(Data,vrr_stack+77498, vrr_stack+76838, vrr_stack+43191, vrr_stack+76442, vrr_stack+46275, vrr_stack+6148);
 _BUILD_h0n0(Data,vrr_stack+5983, vrr_stack+77498, vrr_stack+23607, vrr_stack+76838, vrr_stack+43191, vrr_stack+3696);
 _BUILD_i0n0(Data,vrr_stack+24597, vrr_stack+5983, vrr_stack+41695, vrr_stack+77498, vrr_stack+23607, vrr_stack+12008);
 _BUILD_k0n0(Data,vrr_stack+108727, vrr_stack+24597, vrr_stack+104503, vrr_stack+5983, vrr_stack+41695, vrr_stack+50367);
 _BUILD_00n0(Data,vrr_stack+50367, vrr_stack+17351, vrr_stack+662, vrr_stack+36363, vrr_stack+66188, NULL);
 _BUILD_p0n0(Data,vrr_stack+50433, vrr_stack+46671, vrr_stack+50367, NULL, NULL, vrr_stack+17351);
 _BUILD_d0n0(Data,vrr_stack+50631, vrr_stack+46737, vrr_stack+50433, vrr_stack+41431, vrr_stack+46671, vrr_stack+53007);
 _BUILD_f0n0(Data,vrr_stack+47331, vrr_stack+46935, vrr_stack+50631, vrr_stack+41497, vrr_stack+46737, vrr_stack+30988);
 _BUILD_g0n0(Data,vrr_stack+3247, vrr_stack+17406, vrr_stack+47331, vrr_stack+39939, vrr_stack+46935, vrr_stack+31318);
 _BUILD_h0n0(Data,vrr_stack+11963, vrr_stack+100279, vrr_stack+3247, vrr_stack+2587, vrr_stack+17406, vrr_stack+16334);
 _BUILD_i0n0(Data,vrr_stack+111103, vrr_stack+101269, vrr_stack+11963, vrr_stack+62257, vrr_stack+100279, vrr_stack+33488);
 _BUILD_k0n0(Data,vrr_stack+33023, vrr_stack+102655, vrr_stack+111103, vrr_stack+98893, vrr_stack+101269, vrr_stack+82833);
 _BUILD_l0n0(Data,vrr_stack+112951, vrr_stack+106351, vrr_stack+33023, vrr_stack+104503, vrr_stack+102655, vrr_stack+84373);
 _BUILD_l0n0(Data,vrr_stack+82833, vrr_stack+108727, vrr_stack+106351, vrr_stack+24597, vrr_stack+104503, vrr_stack+78873);
 _BUILD_m0n0(Data,vrr_stack+115921, vrr_stack+82833, vrr_stack+112951, vrr_stack+108727, vrr_stack+106351, vrr_stack+86353);
 _BUILD_00n0(Data,vrr_stack+85803, vrr_stack+60222, vrr_stack+51907, vrr_stack+40836, vrr_stack+35463, NULL);
 _BUILD_p0n0(Data,vrr_stack+85869, vrr_stack+85803, vrr_stack+76178, NULL, NULL, vrr_stack+51907);
 _BUILD_d0n0(Data,vrr_stack+86067, vrr_stack+85869, vrr_stack+76244, vrr_stack+85803, vrr_stack+76178, vrr_stack+51962);
 _BUILD_f0n0(Data,vrr_stack+86463, vrr_stack+86067, vrr_stack+76442, vrr_stack+85869, vrr_stack+76244, vrr_stack+52127);
 _BUILD_g0n0(Data,vrr_stack+87123, vrr_stack+86463, vrr_stack+76838, vrr_stack+86067, vrr_stack+76442, vrr_stack+52457);
 _BUILD_h0n0(Data,vrr_stack+78488, vrr_stack+87123, vrr_stack+77498, vrr_stack+86463, vrr_stack+76838, vrr_stack+7508);
 _BUILD_i0n0(Data,vrr_stack+119551, vrr_stack+78488, vrr_stack+5983, vrr_stack+87123, vrr_stack+77498, vrr_stack+4521);
 _BUILD_k0n0(Data,vrr_stack+85869, vrr_stack+119551, vrr_stack+24597, vrr_stack+78488, vrr_stack+5983, vrr_stack+29448);
   tmp = vrr_stack + 85869;
   target_ptr = Libint->vrr_classes[7][10];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0n0(Data,vrr_stack+121399, vrr_stack+85869, vrr_stack+108727, vrr_stack+119551, vrr_stack+24597, vrr_stack+80853);
   tmp = vrr_stack + 121399;
   target_ptr = Libint->vrr_classes[8][10];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0n0(Data,vrr_stack+78488, vrr_stack+121399, vrr_stack+82833, vrr_stack+85869, vrr_stack+108727, vrr_stack+57747);
   tmp = vrr_stack + 78488;
   target_ptr = Libint->vrr_classes[9][10];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+85869, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+85872, vrr_stack+534, vrr_stack+85869, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+85878, vrr_stack+537, vrr_stack+85872, vrr_stack+0, vrr_stack+534, NULL);
 _BUILD_00g0(Data,vrr_stack+85888, vrr_stack+543, vrr_stack+85878, vrr_stack+66072, vrr_stack+537, NULL);
 _BUILD_00h0(Data,vrr_stack+85903, vrr_stack+553, vrr_stack+85888, vrr_stack+66078, vrr_stack+543, NULL);
 _BUILD_00i0(Data,vrr_stack+85924, vrr_stack+568, vrr_stack+85903, vrr_stack+66088, vrr_stack+553, NULL);
 _BUILD_00k0(Data,vrr_stack+85952, vrr_stack+589, vrr_stack+85924, vrr_stack+66103, vrr_stack+568, NULL);
 _BUILD_00l0(Data,vrr_stack+66072, vrr_stack+3, vrr_stack+85952, vrr_stack+66124, vrr_stack+589, NULL);
 _BUILD_00m0(Data,vrr_stack+85988, vrr_stack+617, vrr_stack+66072, vrr_stack+66152, vrr_stack+3, NULL);
 _BUILD_00n0(Data,vrr_stack+66117, vrr_stack+662, vrr_stack+85988, vrr_stack+66188, vrr_stack+617, NULL);
 _BUILD_p0n0(Data,vrr_stack+86043, vrr_stack+50367, vrr_stack+66117, NULL, NULL, vrr_stack+662);
 _BUILD_d0n0(Data,vrr_stack+86241, vrr_stack+50433, vrr_stack+86043, vrr_stack+46671, vrr_stack+50367, vrr_stack+717);
 _BUILD_f0n0(Data,vrr_stack+86637, vrr_stack+50631, vrr_stack+86241, vrr_stack+46737, vrr_stack+50433, vrr_stack+882);
 _BUILD_g0n0(Data,vrr_stack+87297, vrr_stack+47331, vrr_stack+86637, vrr_stack+46935, vrr_stack+50631, vrr_stack+1212);
 _BUILD_h0n0(Data,vrr_stack+119551, vrr_stack+3247, vrr_stack+87297, vrr_stack+17406, vrr_stack+47331, vrr_stack+1762);
 _BUILD_i0n0(Data,vrr_stack+717, vrr_stack+11963, vrr_stack+119551, vrr_stack+100279, vrr_stack+3247, vrr_stack+31868);
 _BUILD_k0n0(Data,vrr_stack+28953, vrr_stack+111103, vrr_stack+717, vrr_stack+101269, vrr_stack+11963, vrr_stack+55647);
 _BUILD_l0n0(Data,vrr_stack+55416, vrr_stack+33023, vrr_stack+28953, vrr_stack+102655, vrr_stack+111103, vrr_stack+60277);
 _BUILD_m0n0(Data,vrr_stack+124369, vrr_stack+112951, vrr_stack+55416, vrr_stack+106351, vrr_stack+33023, vrr_stack+36408);
 _BUILD_n0n0(Data,vrr_stack+127999, vrr_stack+115921, vrr_stack+124369, vrr_stack+82833, vrr_stack+112951, vrr_stack+94878);
 _BUILD_n0n0(Data,vrr_stack+132355, vrr_stack+78488, vrr_stack+115921, vrr_stack+121399, vrr_stack+82833, vrr_stack+88828);
   tmp = vrr_stack + 132355;
   target_ptr = Libint->vrr_classes[10][10];
   for(i=0;i<4356;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+94878, vrr_stack+53172, vrr_stack+23282, vrr_stack+40881, vrr_stack+41376, NULL);
 _BUILD_00o0(Data,vrr_stack+94956, vrr_stack+53238, vrr_stack+53172, vrr_stack+40936, vrr_stack+40881, NULL);
 _BUILD_p0o0(Data,vrr_stack+95034, vrr_stack+94956, vrr_stack+94878, NULL, NULL, vrr_stack+53172);
 _BUILD_00o0(Data,vrr_stack+95268, vrr_stack+53502, vrr_stack+53238, vrr_stack+41156, vrr_stack+40936, NULL);
 _BUILD_p0o0(Data,vrr_stack+95346, vrr_stack+95268, vrr_stack+94956, NULL, NULL, vrr_stack+53238);
 _BUILD_00o0(Data,vrr_stack+95580, vrr_stack+23282, vrr_stack+41431, vrr_stack+41376, vrr_stack+23552, NULL);
 _BUILD_p0o0(Data,vrr_stack+95658, vrr_stack+94878, vrr_stack+95580, NULL, NULL, vrr_stack+23282);
 _BUILD_d0o0(Data,vrr_stack+95892, vrr_stack+95034, vrr_stack+95658, vrr_stack+94956, vrr_stack+94878, vrr_stack+53766);
 _BUILD_d0o0(Data,vrr_stack+96360, vrr_stack+95346, vrr_stack+95034, vrr_stack+95268, vrr_stack+94956, vrr_stack+53304);
 _BUILD_f0o0(Data,vrr_stack+96828, vrr_stack+96360, vrr_stack+95892, vrr_stack+95346, vrr_stack+95034, vrr_stack+53964);
 _BUILD_00o0(Data,vrr_stack+53304, vrr_stack+40991, vrr_stack+53502, vrr_stack+23372, vrr_stack+41156, NULL);
 _BUILD_p0o0(Data,vrr_stack+53766, vrr_stack+53304, vrr_stack+95268, NULL, NULL, vrr_stack+53502);
 _BUILD_d0o0(Data,vrr_stack+60277, vrr_stack+53766, vrr_stack+95346, vrr_stack+53304, vrr_stack+95268, vrr_stack+53568);
 _BUILD_f0o0(Data,vrr_stack+60745, vrr_stack+60277, vrr_stack+96360, vrr_stack+53766, vrr_stack+95346, vrr_stack+54360);
 _BUILD_00o0(Data,vrr_stack+53568, vrr_stack+41431, vrr_stack+46671, vrr_stack+23552, vrr_stack+28898, NULL);
 _BUILD_p0o0(Data,vrr_stack+54000, vrr_stack+95580, vrr_stack+53568, NULL, NULL, vrr_stack+41431);
 _BUILD_d0o0(Data,vrr_stack+54234, vrr_stack+95658, vrr_stack+54000, vrr_stack+94878, vrr_stack+95580, vrr_stack+41497);
 _BUILD_f0o0(Data,vrr_stack+120937, vrr_stack+95892, vrr_stack+54234, vrr_stack+95034, vrr_stack+95658, vrr_stack+39939);
 _BUILD_g0o0(Data,vrr_stack+121717, vrr_stack+96828, vrr_stack+120937, vrr_stack+96360, vrr_stack+95892, vrr_stack+2587);
 _BUILD_g0o0(Data,vrr_stack+122887, vrr_stack+60745, vrr_stack+96828, vrr_stack+60277, vrr_stack+96360, vrr_stack+54756);
 _BUILD_h0o0(Data,vrr_stack+31329, vrr_stack+122887, vrr_stack+121717, vrr_stack+60745, vrr_stack+96828, vrr_stack+62257);
 _BUILD_00o0(Data,vrr_stack+39939, vrr_stack+46011, vrr_stack+40991, vrr_stack+5928, vrr_stack+23372, NULL);
 _BUILD_p0o0(Data,vrr_stack+40017, vrr_stack+39939, vrr_stack+53304, NULL, NULL, vrr_stack+40991);
 _BUILD_d0o0(Data,vrr_stack+40251, vrr_stack+40017, vrr_stack+53766, vrr_stack+39939, vrr_stack+53304, vrr_stack+39);
 _BUILD_f0o0(Data,vrr_stack+61525, vrr_stack+40251, vrr_stack+60277, vrr_stack+40017, vrr_stack+53766, vrr_stack+38883);
 _BUILD_g0o0(Data,vrr_stack+62305, vrr_stack+61525, vrr_stack+60745, vrr_stack+40251, vrr_stack+60277, vrr_stack+39279);
 _BUILD_h0o0(Data,vrr_stack+58386, vrr_stack+62305, vrr_stack+122887, vrr_stack+61525, vrr_stack+60745, vrr_stack+97903);
 _BUILD_00o0(Data,vrr_stack+39, vrr_stack+46671, vrr_stack+50367, vrr_stack+28898, vrr_stack+17351, NULL);
 _BUILD_p0o0(Data,vrr_stack+117, vrr_stack+53568, vrr_stack+39, NULL, NULL, vrr_stack+46671);
 _BUILD_d0o0(Data,vrr_stack+54702, vrr_stack+54000, vrr_stack+117, vrr_stack+95580, vrr_stack+53568, vrr_stack+46737);
 _BUILD_f0o0(Data,vrr_stack+97608, vrr_stack+54234, vrr_stack+54702, vrr_stack+95658, vrr_stack+54000, vrr_stack+46935);
 _BUILD_g0o0(Data,vrr_stack+51962, vrr_stack+120937, vrr_stack+97608, vrr_stack+95892, vrr_stack+54234, vrr_stack+17406);
 _BUILD_h0o0(Data,vrr_stack+4237, vrr_stack+121717, vrr_stack+51962, vrr_stack+96828, vrr_stack+120937, vrr_stack+100279);
 _BUILD_i0o0(Data,vrr_stack+35399, vrr_stack+31329, vrr_stack+4237, vrr_stack+122887, vrr_stack+121717, vrr_stack+101269);
 _BUILD_i0o0(Data,vrr_stack+100279, vrr_stack+58386, vrr_stack+31329, vrr_stack+62305, vrr_stack+122887, vrr_stack+98893);
 _BUILD_k0o0(Data,vrr_stack+136711, vrr_stack+100279, vrr_stack+35399, vrr_stack+58386, vrr_stack+31329, vrr_stack+102655);
 _BUILD_00o0(Data,vrr_stack+102463, vrr_stack+76178, vrr_stack+46011, vrr_stack+51907, vrr_stack+5928, NULL);
 _BUILD_p0o0(Data,vrr_stack+102541, vrr_stack+102463, vrr_stack+39939, NULL, NULL, vrr_stack+46011);
 _BUILD_d0o0(Data,vrr_stack+102775, vrr_stack+102541, vrr_stack+40017, vrr_stack+102463, vrr_stack+39939, vrr_stack+46077);
 _BUILD_f0o0(Data,vrr_stack+103243, vrr_stack+102775, vrr_stack+40251, vrr_stack+102541, vrr_stack+40017, vrr_stack+46275);
 _BUILD_g0o0(Data,vrr_stack+98388, vrr_stack+103243, vrr_stack+61525, vrr_stack+102775, vrr_stack+40251, vrr_stack+43191);
 _BUILD_h0o0(Data,vrr_stack+37583, vrr_stack+98388, vrr_stack+62305, vrr_stack+103243, vrr_stack+61525, vrr_stack+23607);
 _BUILD_i0o0(Data,vrr_stack+139519, vrr_stack+37583, vrr_stack+58386, vrr_stack+98388, vrr_stack+62305, vrr_stack+41695);
 _BUILD_k0o0(Data,vrr_stack+141703, vrr_stack+139519, vrr_stack+100279, vrr_stack+37583, vrr_stack+58386, vrr_stack+104503);
 _BUILD_00o0(Data,vrr_stack+46077, vrr_stack+50367, vrr_stack+66117, vrr_stack+17351, vrr_stack+662, NULL);
 _BUILD_p0o0(Data,vrr_stack+46155, vrr_stack+39, vrr_stack+46077, NULL, NULL, vrr_stack+50367);
 _BUILD_d0o0(Data,vrr_stack+104023, vrr_stack+117, vrr_stack+46155, vrr_stack+53568, vrr_stack+39, vrr_stack+50433);
 _BUILD_f0o0(Data,vrr_stack+104491, vrr_stack+54702, vrr_stack+104023, vrr_stack+54000, vrr_stack+117, vrr_stack+50631);
 _BUILD_g0o0(Data,vrr_stack+50433, vrr_stack+97608, vrr_stack+104491, vrr_stack+54234, vrr_stack+54702, vrr_stack+47331);
 _BUILD_h0o0(Data,vrr_stack+41497, vrr_stack+51962, vrr_stack+50433, vrr_stack+120937, vrr_stack+97608, vrr_stack+3247);
 _BUILD_i0o0(Data,vrr_stack+16154, vrr_stack+4237, vrr_stack+41497, vrr_stack+121717, vrr_stack+51962, vrr_stack+11963);
 _BUILD_k0o0(Data,vrr_stack+144511, vrr_stack+35399, vrr_stack+16154, vrr_stack+31329, vrr_stack+4237, vrr_stack+111103);
 _BUILD_l0o0(Data,vrr_stack+147319, vrr_stack+136711, vrr_stack+144511, vrr_stack+100279, vrr_stack+35399, vrr_stack+33023);
 _BUILD_l0o0(Data,vrr_stack+150829, vrr_stack+141703, vrr_stack+136711, vrr_stack+139519, vrr_stack+100279, vrr_stack+106351);
 _BUILD_m0o0(Data,vrr_stack+154339, vrr_stack+150829, vrr_stack+147319, vrr_stack+141703, vrr_stack+136711, vrr_stack+112951);
 _BUILD_00o0(Data,vrr_stack+111103, vrr_stack+85803, vrr_stack+76178, vrr_stack+60222, vrr_stack+51907, NULL);
 _BUILD_p0o0(Data,vrr_stack+111181, vrr_stack+111103, vrr_stack+102463, NULL, NULL, vrr_stack+76178);
 _BUILD_d0o0(Data,vrr_stack+111415, vrr_stack+111181, vrr_stack+102541, vrr_stack+111103, vrr_stack+102463, vrr_stack+76244);
 _BUILD_f0o0(Data,vrr_stack+111883, vrr_stack+111415, vrr_stack+102775, vrr_stack+111181, vrr_stack+102541, vrr_stack+76442);
 _BUILD_g0o0(Data,vrr_stack+112663, vrr_stack+111883, vrr_stack+103243, vrr_stack+111415, vrr_stack+102775, vrr_stack+76838);
 _BUILD_h0o0(Data,vrr_stack+113833, vrr_stack+112663, vrr_stack+98388, vrr_stack+111883, vrr_stack+103243, vrr_stack+77498);
 _BUILD_i0o0(Data,vrr_stack+76244, vrr_stack+113833, vrr_stack+37583, vrr_stack+112663, vrr_stack+98388, vrr_stack+5983);
 _BUILD_k0o0(Data,vrr_stack+105271, vrr_stack+76244, vrr_stack+139519, vrr_stack+113833, vrr_stack+37583, vrr_stack+24597);
   tmp = vrr_stack + 105271;
   target_ptr = Libint->vrr_classes[7][11];
   for(i=0;i<2808;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0o0(Data,vrr_stack+111181, vrr_stack+105271, vrr_stack+141703, vrr_stack+76244, vrr_stack+139519, vrr_stack+108727);
   tmp = vrr_stack + 111181;
   target_ptr = Libint->vrr_classes[8][11];
   for(i=0;i<3510;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0o0(Data,vrr_stack+158629, vrr_stack+111181, vrr_stack+150829, vrr_stack+105271, vrr_stack+141703, vrr_stack+82833);
   tmp = vrr_stack + 158629;
   target_ptr = Libint->vrr_classes[9][11];
   for(i=0;i<4290;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+21, Data->F+22, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+105271, vrr_stack+85869, vrr_stack+0, Data->F+20, Data->F+21, NULL);
 _BUILD_00f0(Data,vrr_stack+105277, vrr_stack+85872, vrr_stack+105271, vrr_stack+534, vrr_stack+85869, NULL);
 _BUILD_00g0(Data,vrr_stack+105287, vrr_stack+85878, vrr_stack+105277, vrr_stack+537, vrr_stack+85872, NULL);
 _BUILD_00h0(Data,vrr_stack+105302, vrr_stack+85888, vrr_stack+105287, vrr_stack+543, vrr_stack+85878, NULL);
 _BUILD_00i0(Data,vrr_stack+105323, vrr_stack+85903, vrr_stack+105302, vrr_stack+553, vrr_stack+85888, NULL);
 _BUILD_00k0(Data,vrr_stack+105351, vrr_stack+85924, vrr_stack+105323, vrr_stack+568, vrr_stack+85903, NULL);
 _BUILD_00l0(Data,vrr_stack+105387, vrr_stack+85952, vrr_stack+105351, vrr_stack+589, vrr_stack+85924, NULL);
 _BUILD_00m0(Data,vrr_stack+28898, vrr_stack+66072, vrr_stack+105387, vrr_stack+3, vrr_stack+85952, NULL);
 _BUILD_00n0(Data,vrr_stack+105432, vrr_stack+85988, vrr_stack+28898, vrr_stack+617, vrr_stack+66072, NULL);
 _BUILD_00o0(Data,vrr_stack+105498, vrr_stack+66117, vrr_stack+105432, vrr_stack+662, vrr_stack+85988, NULL);
 _BUILD_p0o0(Data,vrr_stack+105576, vrr_stack+46077, vrr_stack+105498, NULL, NULL, vrr_stack+66117);
 _BUILD_d0o0(Data,vrr_stack+105810, vrr_stack+46155, vrr_stack+105576, vrr_stack+39, vrr_stack+46077, vrr_stack+86043);
 _BUILD_f0o0(Data,vrr_stack+106278, vrr_stack+104023, vrr_stack+105810, vrr_stack+117, vrr_stack+46155, vrr_stack+86241);
 _BUILD_g0o0(Data,vrr_stack+107058, vrr_stack+104491, vrr_stack+106278, vrr_stack+54702, vrr_stack+104023, vrr_stack+86637);
 _BUILD_h0o0(Data,vrr_stack+108228, vrr_stack+50433, vrr_stack+107058, vrr_stack+97608, vrr_stack+104491, vrr_stack+87297);
 _BUILD_i0o0(Data,vrr_stack+86043, vrr_stack+41497, vrr_stack+108228, vrr_stack+51962, vrr_stack+50433, vrr_stack+119551);
 _BUILD_k0o0(Data,vrr_stack+82118, vrr_stack+16154, vrr_stack+86043, vrr_stack+4237, vrr_stack+41497, vrr_stack+717);
 _BUILD_l0o0(Data,vrr_stack+351, vrr_stack+144511, vrr_stack+82118, vrr_stack+35399, vrr_stack+16154, vrr_stack+28953);
 _BUILD_m0o0(Data,vrr_stack+162919, vrr_stack+147319, vrr_stack+351, vrr_stack+136711, vrr_stack+144511, vrr_stack+55416);
 _BUILD_n0o0(Data,vrr_stack+167209, vrr_stack+154339, vrr_stack+162919, vrr_stack+150829, vrr_stack+147319, vrr_stack+124369);
 _BUILD_n0o0(Data,vrr_stack+172357, vrr_stack+158629, vrr_stack+154339, vrr_stack+111181, vrr_stack+150829, vrr_stack+115921);
   tmp = vrr_stack + 172357;
   target_ptr = Libint->vrr_classes[10][11];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+111181, vrr_stack+94878, vrr_stack+95580, vrr_stack+53172, vrr_stack+23282, NULL);
 _BUILD_00q0(Data,vrr_stack+111272, vrr_stack+94956, vrr_stack+94878, vrr_stack+53238, vrr_stack+53172, NULL);
 _BUILD_p0q0(Data,vrr_stack+111363, vrr_stack+111272, vrr_stack+111181, NULL, NULL, vrr_stack+94878);
 _BUILD_00q0(Data,vrr_stack+111636, vrr_stack+95268, vrr_stack+94956, vrr_stack+53502, vrr_stack+53238, NULL);
 _BUILD_p0q0(Data,vrr_stack+111727, vrr_stack+111636, vrr_stack+111272, NULL, NULL, vrr_stack+94956);
 _BUILD_00q0(Data,vrr_stack+94878, vrr_stack+95580, vrr_stack+53568, vrr_stack+23282, vrr_stack+41431, NULL);
 _BUILD_p0q0(Data,vrr_stack+23282, vrr_stack+111181, vrr_stack+94878, NULL, NULL, vrr_stack+95580);
 _BUILD_d0q0(Data,vrr_stack+23555, vrr_stack+111363, vrr_stack+23282, vrr_stack+111272, vrr_stack+111181, vrr_stack+95658);
 _BUILD_d0q0(Data,vrr_stack+24101, vrr_stack+111727, vrr_stack+111363, vrr_stack+111636, vrr_stack+111272, vrr_stack+95034);
 _BUILD_f0q0(Data,vrr_stack+24647, vrr_stack+24101, vrr_stack+23555, vrr_stack+111727, vrr_stack+111363, vrr_stack+95892);
 _BUILD_00q0(Data,vrr_stack+111272, vrr_stack+53304, vrr_stack+95268, vrr_stack+40991, vrr_stack+53502, NULL);
 _BUILD_p0q0(Data,vrr_stack+95580, vrr_stack+111272, vrr_stack+111636, NULL, NULL, vrr_stack+95268);
 _BUILD_d0q0(Data,vrr_stack+25557, vrr_stack+95580, vrr_stack+111727, vrr_stack+111272, vrr_stack+111636, vrr_stack+95346);
 _BUILD_f0q0(Data,vrr_stack+112000, vrr_stack+25557, vrr_stack+24101, vrr_stack+95580, vrr_stack+111727, vrr_stack+96360);
 _BUILD_00q0(Data,vrr_stack+111636, vrr_stack+53568, vrr_stack+39, vrr_stack+41431, vrr_stack+46671, NULL);
 _BUILD_p0q0(Data,vrr_stack+111727, vrr_stack+94878, vrr_stack+111636, NULL, NULL, vrr_stack+53568);
 _BUILD_d0q0(Data,vrr_stack+95853, vrr_stack+23282, vrr_stack+111727, vrr_stack+111181, vrr_stack+94878, vrr_stack+54000);
 _BUILD_f0q0(Data,vrr_stack+112910, vrr_stack+23555, vrr_stack+95853, vrr_stack+111363, vrr_stack+23282, vrr_stack+54234);
 _BUILD_g0q0(Data,vrr_stack+113820, vrr_stack+24647, vrr_stack+112910, vrr_stack+24101, vrr_stack+23555, vrr_stack+120937);
 _BUILD_g0q0(Data,vrr_stack+28953, vrr_stack+112000, vrr_stack+24647, vrr_stack+25557, vrr_stack+24101, vrr_stack+96828);
 _BUILD_h0q0(Data,vrr_stack+119551, vrr_stack+28953, vrr_stack+113820, vrr_stack+112000, vrr_stack+24647, vrr_stack+121717);
 _BUILD_00q0(Data,vrr_stack+111181, vrr_stack+39939, vrr_stack+53304, vrr_stack+46011, vrr_stack+40991, NULL);
 _BUILD_p0q0(Data,vrr_stack+111363, vrr_stack+111181, vrr_stack+111272, NULL, NULL, vrr_stack+53304);
 _BUILD_d0q0(Data,vrr_stack+24101, vrr_stack+111363, vrr_stack+95580, vrr_stack+111181, vrr_stack+111272, vrr_stack+53766);
 _BUILD_f0q0(Data,vrr_stack+96399, vrr_stack+24101, vrr_stack+25557, vrr_stack+111363, vrr_stack+95580, vrr_stack+60277);
 _BUILD_g0q0(Data,vrr_stack+121462, vrr_stack+96399, vrr_stack+112000, vrr_stack+24101, vrr_stack+25557, vrr_stack+60745);
 _BUILD_h0q0(Data,vrr_stack+76244, vrr_stack+121462, vrr_stack+28953, vrr_stack+96399, vrr_stack+112000, vrr_stack+122887);
 _BUILD_00q0(Data,vrr_stack+111272, vrr_stack+39, vrr_stack+46077, vrr_stack+46671, vrr_stack+50367, NULL);
 _BUILD_p0q0(Data,vrr_stack+112000, vrr_stack+111636, vrr_stack+111272, NULL, NULL, vrr_stack+39);
 _BUILD_d0q0(Data,vrr_stack+112273, vrr_stack+111727, vrr_stack+112000, vrr_stack+94878, vrr_stack+111636, vrr_stack+117);
 _BUILD_f0q0(Data,vrr_stack+94878, vrr_stack+95853, vrr_stack+112273, vrr_stack+23282, vrr_stack+111727, vrr_stack+54702);
 _BUILD_g0q0(Data,vrr_stack+122827, vrr_stack+112910, vrr_stack+94878, vrr_stack+23555, vrr_stack+95853, vrr_stack+97608);
 _BUILD_h0q0(Data,vrr_stack+124192, vrr_stack+113820, vrr_stack+122827, vrr_stack+24647, vrr_stack+112910, vrr_stack+51962);
 _BUILD_i0q0(Data,vrr_stack+51603, vrr_stack+119551, vrr_stack+124192, vrr_stack+28953, vrr_stack+113820, vrr_stack+4237);
 _BUILD_i0q0(Data,vrr_stack+54151, vrr_stack+76244, vrr_stack+119551, vrr_stack+121462, vrr_stack+28953, vrr_stack+31329);
 _BUILD_k0q0(Data,vrr_stack+28953, vrr_stack+54151, vrr_stack+51603, vrr_stack+76244, vrr_stack+119551, vrr_stack+35399);
 _BUILD_00q0(Data,vrr_stack+112819, vrr_stack+102463, vrr_stack+39939, vrr_stack+76178, vrr_stack+46011, NULL);
 _BUILD_p0q0(Data,vrr_stack+32229, vrr_stack+112819, vrr_stack+111181, NULL, NULL, vrr_stack+39939);
 _BUILD_d0q0(Data,vrr_stack+32502, vrr_stack+32229, vrr_stack+111363, vrr_stack+112819, vrr_stack+111181, vrr_stack+40017);
 _BUILD_f0q0(Data,vrr_stack+33048, vrr_stack+32502, vrr_stack+24101, vrr_stack+32229, vrr_stack+111363, vrr_stack+40251);
 _BUILD_g0q0(Data,vrr_stack+33958, vrr_stack+33048, vrr_stack+96399, vrr_stack+32502, vrr_stack+24101, vrr_stack+61525);
 _BUILD_h0q0(Data,vrr_stack+35323, vrr_stack+33958, vrr_stack+121462, vrr_stack+33048, vrr_stack+96399, vrr_stack+62305);
 _BUILD_i0q0(Data,vrr_stack+23282, vrr_stack+35323, vrr_stack+76244, vrr_stack+33958, vrr_stack+121462, vrr_stack+58386);
 _BUILD_k0q0(Data,vrr_stack+56699, vrr_stack+23282, vrr_stack+54151, vrr_stack+35323, vrr_stack+76244, vrr_stack+100279);
 _BUILD_00q0(Data,vrr_stack+111181, vrr_stack+46077, vrr_stack+105498, vrr_stack+50367, vrr_stack+66117, NULL);
 _BUILD_p0q0(Data,vrr_stack+111363, vrr_stack+111272, vrr_stack+111181, NULL, NULL, vrr_stack+46077);
 _BUILD_d0q0(Data,vrr_stack+76244, vrr_stack+112000, vrr_stack+111363, vrr_stack+111636, vrr_stack+111272, vrr_stack+46155);
 _BUILD_f0q0(Data,vrr_stack+76790, vrr_stack+112273, vrr_stack+76244, vrr_stack+111727, vrr_stack+112000, vrr_stack+104023);
 _BUILD_g0q0(Data,vrr_stack+121462, vrr_stack+94878, vrr_stack+76790, vrr_stack+95853, vrr_stack+112273, vrr_stack+104491);
 _BUILD_h0q0(Data,vrr_stack+46011, vrr_stack+122827, vrr_stack+121462, vrr_stack+112910, vrr_stack+94878, vrr_stack+50433);
 _BUILD_i0q0(Data,vrr_stack+95788, vrr_stack+124192, vrr_stack+46011, vrr_stack+113820, vrr_stack+122827, vrr_stack+41497);
 _BUILD_k0q0(Data,vrr_stack+59975, vrr_stack+51603, vrr_stack+95788, vrr_stack+119551, vrr_stack+124192, vrr_stack+16154);
 _BUILD_l0q0(Data,vrr_stack+3861, vrr_stack+28953, vrr_stack+59975, vrr_stack+54151, vrr_stack+51603, vrr_stack+144511);
 _BUILD_l0q0(Data,vrr_stack+39221, vrr_stack+56699, vrr_stack+28953, vrr_stack+23282, vrr_stack+54151, vrr_stack+136711);
 _BUILD_m0q0(Data,vrr_stack+177505, vrr_stack+39221, vrr_stack+3861, vrr_stack+56699, vrr_stack+28953, vrr_stack+147319);
 _BUILD_00q0(Data,vrr_stack+136711, vrr_stack+111103, vrr_stack+102463, vrr_stack+85803, vrr_stack+76178, NULL);
 _BUILD_p0q0(Data,vrr_stack+136802, vrr_stack+136711, vrr_stack+112819, NULL, NULL, vrr_stack+102463);
 _BUILD_d0q0(Data,vrr_stack+137075, vrr_stack+136802, vrr_stack+32229, vrr_stack+136711, vrr_stack+112819, vrr_stack+102541);
 _BUILD_f0q0(Data,vrr_stack+112819, vrr_stack+137075, vrr_stack+32502, vrr_stack+136802, vrr_stack+32229, vrr_stack+102775);
 _BUILD_g0q0(Data,vrr_stack+113729, vrr_stack+112819, vrr_stack+33048, vrr_stack+137075, vrr_stack+32502, vrr_stack+103243);
 _BUILD_h0q0(Data,vrr_stack+119551, vrr_stack+113729, vrr_stack+33958, vrr_stack+112819, vrr_stack+33048, vrr_stack+98388);
 _BUILD_i0q0(Data,vrr_stack+54151, vrr_stack+119551, vrr_stack+35323, vrr_stack+113729, vrr_stack+33958, vrr_stack+37583);
 _BUILD_k0q0(Data,vrr_stack+144511, vrr_stack+54151, vrr_stack+23282, vrr_stack+119551, vrr_stack+35323, vrr_stack+139519);
   tmp = vrr_stack + 144511;
   target_ptr = Libint->vrr_classes[7][12];
   for(i=0;i<3276;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0q0(Data,vrr_stack+32229, vrr_stack+144511, vrr_stack+56699, vrr_stack+54151, vrr_stack+23282, vrr_stack+141703);
   tmp = vrr_stack + 32229;
   target_ptr = Libint->vrr_classes[8][12];
   for(i=0;i<4095;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0q0(Data,vrr_stack+136711, vrr_stack+32229, vrr_stack+39221, vrr_stack+144511, vrr_stack+56699, vrr_stack+150829);
   tmp = vrr_stack + 136711;
   target_ptr = Libint->vrr_classes[9][12];
   for(i=0;i<5005;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+23282, Data->F+22, Data->F+23, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+23285, vrr_stack+0, vrr_stack+23282, Data->F+21, Data->F+22, NULL);
 _BUILD_00f0(Data,vrr_stack+23291, vrr_stack+105271, vrr_stack+23285, vrr_stack+85869, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+105277, vrr_stack+23291, vrr_stack+85872, vrr_stack+105271, NULL);
 _BUILD_00h0(Data,vrr_stack+15, vrr_stack+105287, vrr_stack+0, vrr_stack+85878, vrr_stack+105277, NULL);
 _BUILD_00i0(Data,vrr_stack+36, vrr_stack+105302, vrr_stack+15, vrr_stack+85888, vrr_stack+105287, NULL);
 _BUILD_00k0(Data,vrr_stack+0, vrr_stack+105323, vrr_stack+36, vrr_stack+85903, vrr_stack+105302, NULL);
 _BUILD_00l0(Data,vrr_stack+36, vrr_stack+105351, vrr_stack+0, vrr_stack+85924, vrr_stack+105323, NULL);
 _BUILD_00m0(Data,vrr_stack+81, vrr_stack+105387, vrr_stack+36, vrr_stack+85952, vrr_stack+105351, NULL);
 _BUILD_00n0(Data,vrr_stack+76178, vrr_stack+28898, vrr_stack+81, vrr_stack+66072, vrr_stack+105387, NULL);
 _BUILD_00o0(Data,vrr_stack+0, vrr_stack+105432, vrr_stack+76178, vrr_stack+85988, vrr_stack+28898, NULL);
 _BUILD_00q0(Data,vrr_stack+78, vrr_stack+105498, vrr_stack+0, vrr_stack+66117, vrr_stack+105432, NULL);
 _BUILD_p0q0(Data,vrr_stack+23282, vrr_stack+111181, vrr_stack+78, NULL, NULL, vrr_stack+105498);
 _BUILD_d0q0(Data,vrr_stack+23555, vrr_stack+111363, vrr_stack+23282, vrr_stack+111272, vrr_stack+111181, vrr_stack+105576);
 _BUILD_f0q0(Data,vrr_stack+24101, vrr_stack+76244, vrr_stack+23555, vrr_stack+112000, vrr_stack+111363, vrr_stack+105810);
 _BUILD_g0q0(Data,vrr_stack+25011, vrr_stack+76790, vrr_stack+24101, vrr_stack+112273, vrr_stack+76244, vrr_stack+106278);
 _BUILD_h0q0(Data,vrr_stack+119551, vrr_stack+121462, vrr_stack+25011, vrr_stack+94878, vrr_stack+76790, vrr_stack+107058);
 _BUILD_i0q0(Data,vrr_stack+23282, vrr_stack+46011, vrr_stack+119551, vrr_stack+122827, vrr_stack+121462, vrr_stack+108228);
 _BUILD_k0q0(Data,vrr_stack+119551, vrr_stack+95788, vrr_stack+23282, vrr_stack+124192, vrr_stack+46011, vrr_stack+86043);
 _BUILD_l0q0(Data,vrr_stack+122827, vrr_stack+59975, vrr_stack+119551, vrr_stack+51603, vrr_stack+95788, vrr_stack+82118);
 _BUILD_m0q0(Data,vrr_stack+82118, vrr_stack+3861, vrr_stack+122827, vrr_stack+28953, vrr_stack+59975, vrr_stack+351);
 _BUILD_n0q0(Data,vrr_stack+119551, vrr_stack+177505, vrr_stack+82118, vrr_stack+39221, vrr_stack+3861, vrr_stack+162919);
 _BUILD_n0q0(Data,vrr_stack+82118, vrr_stack+136711, vrr_stack+177505, vrr_stack+32229, vrr_stack+39221, vrr_stack+154339);
   tmp = vrr_stack + 82118;
   target_ptr = Libint->vrr_classes[10][12];
   for(i=0;i<6006;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0k0(Data,vrr_stack+162919, vrr_stack+47991, vrr_stack+26522, vrr_stack+44031, vrr_stack+21302, vrr_stack+14306);
   tmp = vrr_stack + 162919;
   target_ptr = Libint->vrr_classes[11][7];
   for(i=0;i<2808;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0l0(Data,vrr_stack+94878, vrr_stack+73208, vrr_stack+70238, vrr_stack+18341, vrr_stack+63597, vrr_stack+26522);
   tmp = vrr_stack + 94878;
   target_ptr = Libint->vrr_classes[11][8];
   for(i=0;i<3510;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0m0(Data,vrr_stack+73208, vrr_stack+66233, vrr_stack+8333, vrr_stack+91853, vrr_stack+88828, vrr_stack+70238);
   tmp = vrr_stack + 73208;
   target_ptr = Libint->vrr_classes[11][9];
   for(i=0;i<4290;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0n0(Data,vrr_stack+88124, vrr_stack+132355, vrr_stack+127999, vrr_stack+78488, vrr_stack+115921, vrr_stack+8333);
   tmp = vrr_stack + 88124;
   target_ptr = Libint->vrr_classes[11][10];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0o0(Data,vrr_stack+98388, vrr_stack+172357, vrr_stack+167209, vrr_stack+158629, vrr_stack+154339, vrr_stack+127999);
   tmp = vrr_stack + 98388;
   target_ptr = Libint->vrr_classes[11][11];
   for(i=0;i<6084;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0q0(Data,vrr_stack+125557, vrr_stack+82118, vrr_stack+119551, vrr_stack+136711, vrr_stack+177505, vrr_stack+167209);
   tmp = vrr_stack + 125557;
   target_ptr = Libint->vrr_classes[11][12];
   for(i=0;i<7098;i++)
     target_ptr[i] += tmp[i];

}

