/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (lf|mf) integrals */

void vrr_order_lfmf(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+3, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+9, Data->F+10, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+15, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+18, vrr_stack+15, vrr_stack+12, NULL, NULL, Data->F+10);
 _BUILD_00p0(Data,vrr_stack+27, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+30, vrr_stack+27, vrr_stack+15, NULL, NULL, Data->F+9);
 _BUILD_00p0(Data,vrr_stack+39, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+42, vrr_stack+12, vrr_stack+39, NULL, NULL, Data->F+11);
 _BUILD_d0p0(Data,vrr_stack+51, vrr_stack+18, vrr_stack+42, vrr_stack+15, vrr_stack+12, vrr_stack+0);
 _BUILD_d0p0(Data,vrr_stack+69, vrr_stack+30, vrr_stack+18, vrr_stack+27, vrr_stack+15, vrr_stack+3);
 _BUILD_f0p0(Data,vrr_stack+87, vrr_stack+69, vrr_stack+51, vrr_stack+30, vrr_stack+18, vrr_stack+6);
 _BUILD_00d0(Data,vrr_stack+0, vrr_stack+15, vrr_stack+12, Data->F+9, Data->F+10, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+27, vrr_stack+15, Data->F+8, Data->F+9, NULL);
 _BUILD_00d0(Data,vrr_stack+117, vrr_stack+12, vrr_stack+39, Data->F+10, Data->F+11, NULL);
 _BUILD_p0d0(Data,vrr_stack+123, vrr_stack+0, vrr_stack+117, NULL, NULL, vrr_stack+12);
 _BUILD_p0d0(Data,vrr_stack+141, vrr_stack+6, vrr_stack+0, NULL, NULL, vrr_stack+15);
 _BUILD_d0d0(Data,vrr_stack+159, vrr_stack+141, vrr_stack+123, vrr_stack+6, vrr_stack+0, vrr_stack+18);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+18, vrr_stack+27, Data->F+7, Data->F+8, NULL);
 _BUILD_p0d0(Data,vrr_stack+195, vrr_stack+21, vrr_stack+6, NULL, NULL, vrr_stack+27);
 _BUILD_d0d0(Data,vrr_stack+213, vrr_stack+195, vrr_stack+141, vrr_stack+21, vrr_stack+6, vrr_stack+30);
 _BUILD_00p0(Data,vrr_stack+30, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+33, vrr_stack+39, vrr_stack+30, Data->F+11, Data->F+12, NULL);
 _BUILD_p0d0(Data,vrr_stack+249, vrr_stack+117, vrr_stack+33, NULL, NULL, vrr_stack+39);
 _BUILD_d0d0(Data,vrr_stack+267, vrr_stack+123, vrr_stack+249, vrr_stack+0, vrr_stack+117, vrr_stack+42);
 _BUILD_f0d0(Data,vrr_stack+303, vrr_stack+159, vrr_stack+267, vrr_stack+141, vrr_stack+123, vrr_stack+51);
 _BUILD_f0d0(Data,vrr_stack+363, vrr_stack+213, vrr_stack+159, vrr_stack+195, vrr_stack+141, vrr_stack+69);
 _BUILD_g0d0(Data,vrr_stack+423, vrr_stack+363, vrr_stack+303, vrr_stack+213, vrr_stack+159, vrr_stack+87);
 _BUILD_00f0(Data,vrr_stack+42, vrr_stack+0, vrr_stack+117, vrr_stack+15, vrr_stack+12, NULL);
 _BUILD_00f0(Data,vrr_stack+52, vrr_stack+6, vrr_stack+0, vrr_stack+27, vrr_stack+15, NULL);
 _BUILD_p0f0(Data,vrr_stack+62, vrr_stack+52, vrr_stack+42, NULL, NULL, vrr_stack+0);
 _BUILD_00f0(Data,vrr_stack+92, vrr_stack+21, vrr_stack+6, vrr_stack+18, vrr_stack+27, NULL);
 _BUILD_p0f0(Data,vrr_stack+513, vrr_stack+92, vrr_stack+52, NULL, NULL, vrr_stack+6);
 _BUILD_00f0(Data,vrr_stack+102, vrr_stack+117, vrr_stack+33, vrr_stack+12, vrr_stack+39, NULL);
 _BUILD_p0f0(Data,vrr_stack+543, vrr_stack+42, vrr_stack+102, NULL, NULL, vrr_stack+117);
 _BUILD_d0f0(Data,vrr_stack+573, vrr_stack+62, vrr_stack+543, vrr_stack+52, vrr_stack+42, vrr_stack+123);
 _BUILD_d0f0(Data,vrr_stack+633, vrr_stack+513, vrr_stack+62, vrr_stack+92, vrr_stack+52, vrr_stack+141);
 _BUILD_f0f0(Data,vrr_stack+693, vrr_stack+633, vrr_stack+573, vrr_stack+513, vrr_stack+62, vrr_stack+159);
 _BUILD_00p0(Data,vrr_stack+27, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+12, vrr_stack+27, vrr_stack+18, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+123, vrr_stack+12, vrr_stack+21, vrr_stack+27, vrr_stack+18, NULL);
 _BUILD_p0f0(Data,vrr_stack+133, vrr_stack+123, vrr_stack+92, NULL, NULL, vrr_stack+21);
 _BUILD_d0f0(Data,vrr_stack+793, vrr_stack+133, vrr_stack+513, vrr_stack+123, vrr_stack+92, vrr_stack+195);
 _BUILD_f0f0(Data,vrr_stack+853, vrr_stack+793, vrr_stack+633, vrr_stack+133, vrr_stack+513, vrr_stack+213);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+163, vrr_stack+30, vrr_stack+18, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+169, vrr_stack+33, vrr_stack+163, vrr_stack+39, vrr_stack+30, NULL);
 _BUILD_p0f0(Data,vrr_stack+179, vrr_stack+102, vrr_stack+169, NULL, NULL, vrr_stack+33);
 _BUILD_d0f0(Data,vrr_stack+953, vrr_stack+543, vrr_stack+179, vrr_stack+42, vrr_stack+102, vrr_stack+249);
 _BUILD_f0f0(Data,vrr_stack+1013, vrr_stack+573, vrr_stack+953, vrr_stack+62, vrr_stack+543, vrr_stack+267);
 _BUILD_g0f0(Data,vrr_stack+1113, vrr_stack+693, vrr_stack+1013, vrr_stack+633, vrr_stack+573, vrr_stack+303);
 _BUILD_g0f0(Data,vrr_stack+209, vrr_stack+853, vrr_stack+693, vrr_stack+793, vrr_stack+633, vrr_stack+363);
 _BUILD_h0f0(Data,vrr_stack+1263, vrr_stack+209, vrr_stack+1113, vrr_stack+853, vrr_stack+693, vrr_stack+423);
 _BUILD_00g0(Data,vrr_stack+359, vrr_stack+52, vrr_stack+42, vrr_stack+6, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+374, vrr_stack+92, vrr_stack+52, vrr_stack+21, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+389, vrr_stack+42, vrr_stack+102, vrr_stack+0, vrr_stack+117, NULL);
 _BUILD_p0g0(Data,vrr_stack+404, vrr_stack+359, vrr_stack+389, NULL, NULL, vrr_stack+42);
 _BUILD_p0g0(Data,vrr_stack+449, vrr_stack+374, vrr_stack+359, NULL, NULL, vrr_stack+52);
 _BUILD_d0g0(Data,vrr_stack+1473, vrr_stack+449, vrr_stack+404, vrr_stack+374, vrr_stack+359, vrr_stack+62);
 _BUILD_00g0(Data,vrr_stack+62, vrr_stack+123, vrr_stack+92, vrr_stack+12, vrr_stack+21, NULL);
 _BUILD_p0g0(Data,vrr_stack+1563, vrr_stack+62, vrr_stack+374, NULL, NULL, vrr_stack+92);
 _BUILD_d0g0(Data,vrr_stack+1608, vrr_stack+1563, vrr_stack+449, vrr_stack+62, vrr_stack+374, vrr_stack+513);
 _BUILD_00g0(Data,vrr_stack+77, vrr_stack+102, vrr_stack+169, vrr_stack+117, vrr_stack+33, NULL);
 _BUILD_p0g0(Data,vrr_stack+494, vrr_stack+389, vrr_stack+77, NULL, NULL, vrr_stack+102);
 _BUILD_d0g0(Data,vrr_stack+1698, vrr_stack+404, vrr_stack+494, vrr_stack+359, vrr_stack+389, vrr_stack+543);
 _BUILD_f0g0(Data,vrr_stack+1788, vrr_stack+1473, vrr_stack+1698, vrr_stack+449, vrr_stack+404, vrr_stack+573);
 _BUILD_f0g0(Data,vrr_stack+1938, vrr_stack+1608, vrr_stack+1473, vrr_stack+1563, vrr_stack+449, vrr_stack+633);
 _BUILD_g0g0(Data,vrr_stack+2088, vrr_stack+1938, vrr_stack+1788, vrr_stack+1608, vrr_stack+1473, vrr_stack+693);
 _BUILD_00p0(Data,vrr_stack+39, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+39, vrr_stack+27, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+0, vrr_stack+21, vrr_stack+12, vrr_stack+39, vrr_stack+27, NULL);
 _BUILD_00g0(Data,vrr_stack+539, vrr_stack+0, vrr_stack+123, vrr_stack+21, vrr_stack+12, NULL);
 _BUILD_p0g0(Data,vrr_stack+554, vrr_stack+539, vrr_stack+62, NULL, NULL, vrr_stack+123);
 _BUILD_d0g0(Data,vrr_stack+599, vrr_stack+554, vrr_stack+1563, vrr_stack+539, vrr_stack+62, vrr_stack+133);
 _BUILD_f0g0(Data,vrr_stack+2313, vrr_stack+599, vrr_stack+1608, vrr_stack+554, vrr_stack+1563, vrr_stack+793);
 _BUILD_g0g0(Data,vrr_stack+2463, vrr_stack+2313, vrr_stack+1938, vrr_stack+599, vrr_stack+1608, vrr_stack+853);
 _BUILD_00p0(Data,vrr_stack+27, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+133, vrr_stack+18, vrr_stack+27, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+139, vrr_stack+163, vrr_stack+133, vrr_stack+30, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+689, vrr_stack+169, vrr_stack+139, vrr_stack+33, vrr_stack+163, NULL);
 _BUILD_p0g0(Data,vrr_stack+704, vrr_stack+77, vrr_stack+689, NULL, NULL, vrr_stack+169);
 _BUILD_d0g0(Data,vrr_stack+749, vrr_stack+494, vrr_stack+704, vrr_stack+389, vrr_stack+77, vrr_stack+179);
 _BUILD_f0g0(Data,vrr_stack+2688, vrr_stack+1698, vrr_stack+749, vrr_stack+404, vrr_stack+494, vrr_stack+953);
 _BUILD_g0g0(Data,vrr_stack+2838, vrr_stack+1788, vrr_stack+2688, vrr_stack+1473, vrr_stack+1698, vrr_stack+1013);
 _BUILD_h0g0(Data,vrr_stack+3063, vrr_stack+2088, vrr_stack+2838, vrr_stack+1938, vrr_stack+1788, vrr_stack+1113);
 _BUILD_h0g0(Data,vrr_stack+839, vrr_stack+2463, vrr_stack+2088, vrr_stack+2313, vrr_stack+1938, vrr_stack+209);
 _BUILD_i0g0(Data,vrr_stack+3378, vrr_stack+839, vrr_stack+3063, vrr_stack+2463, vrr_stack+2088, vrr_stack+1263);
 _BUILD_00h0(Data,vrr_stack+179, vrr_stack+359, vrr_stack+389, vrr_stack+52, vrr_stack+42, NULL);
 _BUILD_00h0(Data,vrr_stack+200, vrr_stack+374, vrr_stack+359, vrr_stack+92, vrr_stack+52, NULL);
 _BUILD_p0h0(Data,vrr_stack+221, vrr_stack+200, vrr_stack+179, NULL, NULL, vrr_stack+359);
 _BUILD_00h0(Data,vrr_stack+284, vrr_stack+62, vrr_stack+374, vrr_stack+123, vrr_stack+92, NULL);
 _BUILD_p0h0(Data,vrr_stack+1154, vrr_stack+284, vrr_stack+200, NULL, NULL, vrr_stack+374);
 _BUILD_00h0(Data,vrr_stack+305, vrr_stack+389, vrr_stack+77, vrr_stack+42, vrr_stack+102, NULL);
 _BUILD_p0h0(Data,vrr_stack+1217, vrr_stack+179, vrr_stack+305, NULL, NULL, vrr_stack+389);
 _BUILD_d0h0(Data,vrr_stack+1280, vrr_stack+221, vrr_stack+1217, vrr_stack+200, vrr_stack+179, vrr_stack+404);
 _BUILD_d0h0(Data,vrr_stack+3798, vrr_stack+1154, vrr_stack+221, vrr_stack+284, vrr_stack+200, vrr_stack+449);
 _BUILD_f0h0(Data,vrr_stack+3924, vrr_stack+3798, vrr_stack+1280, vrr_stack+1154, vrr_stack+221, vrr_stack+1473);
 _BUILD_00h0(Data,vrr_stack+404, vrr_stack+539, vrr_stack+62, vrr_stack+0, vrr_stack+123, NULL);
 _BUILD_p0h0(Data,vrr_stack+425, vrr_stack+404, vrr_stack+284, NULL, NULL, vrr_stack+62);
 _BUILD_d0h0(Data,vrr_stack+1406, vrr_stack+425, vrr_stack+1154, vrr_stack+404, vrr_stack+284, vrr_stack+1563);
 _BUILD_f0h0(Data,vrr_stack+4134, vrr_stack+1406, vrr_stack+3798, vrr_stack+425, vrr_stack+1154, vrr_stack+1608);
 _BUILD_00h0(Data,vrr_stack+112, vrr_stack+77, vrr_stack+689, vrr_stack+102, vrr_stack+169, NULL);
 _BUILD_p0h0(Data,vrr_stack+1532, vrr_stack+305, vrr_stack+112, NULL, NULL, vrr_stack+77);
 _BUILD_d0h0(Data,vrr_stack+4344, vrr_stack+1217, vrr_stack+1532, vrr_stack+179, vrr_stack+305, vrr_stack+494);
 _BUILD_f0h0(Data,vrr_stack+4470, vrr_stack+1280, vrr_stack+4344, vrr_stack+221, vrr_stack+1217, vrr_stack+1698);
 _BUILD_g0h0(Data,vrr_stack+4680, vrr_stack+3924, vrr_stack+4470, vrr_stack+3798, vrr_stack+1280, vrr_stack+1788);
 _BUILD_g0h0(Data,vrr_stack+1595, vrr_stack+4134, vrr_stack+3924, vrr_stack+1406, vrr_stack+3798, vrr_stack+1938);
 _BUILD_h0h0(Data,vrr_stack+4995, vrr_stack+1595, vrr_stack+4680, vrr_stack+4134, vrr_stack+3924, vrr_stack+2088);
 _BUILD_00p0(Data,vrr_stack+488, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+491, vrr_stack+488, vrr_stack+39, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+497, vrr_stack+491, vrr_stack+21, vrr_stack+488, vrr_stack+39, NULL);
 _BUILD_00g0(Data,vrr_stack+507, vrr_stack+497, vrr_stack+0, vrr_stack+491, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+326, vrr_stack+507, vrr_stack+539, vrr_stack+497, vrr_stack+0, NULL);
 _BUILD_p0h0(Data,vrr_stack+1910, vrr_stack+326, vrr_stack+404, NULL, NULL, vrr_stack+539);
 _BUILD_d0h0(Data,vrr_stack+1973, vrr_stack+1910, vrr_stack+425, vrr_stack+326, vrr_stack+404, vrr_stack+554);
 _BUILD_f0h0(Data,vrr_stack+2099, vrr_stack+1973, vrr_stack+1406, vrr_stack+1910, vrr_stack+425, vrr_stack+599);
 _BUILD_g0h0(Data,vrr_stack+5436, vrr_stack+2099, vrr_stack+4134, vrr_stack+1973, vrr_stack+1406, vrr_stack+2313);
 _BUILD_h0h0(Data,vrr_stack+5751, vrr_stack+5436, vrr_stack+1595, vrr_stack+2099, vrr_stack+4134, vrr_stack+2463);
 _BUILD_00p0(Data,vrr_stack+554, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+27, vrr_stack+554, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+557, vrr_stack+133, vrr_stack+21, vrr_stack+18, vrr_stack+27, NULL);
 _BUILD_00g0(Data,vrr_stack+567, vrr_stack+139, vrr_stack+557, vrr_stack+163, vrr_stack+133, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+689, vrr_stack+567, vrr_stack+169, vrr_stack+139, NULL);
 _BUILD_p0h0(Data,vrr_stack+582, vrr_stack+112, vrr_stack+0, NULL, NULL, vrr_stack+689);
 _BUILD_d0h0(Data,vrr_stack+2309, vrr_stack+1532, vrr_stack+582, vrr_stack+305, vrr_stack+112, vrr_stack+704);
 _BUILD_f0h0(Data,vrr_stack+2435, vrr_stack+4344, vrr_stack+2309, vrr_stack+1217, vrr_stack+1532, vrr_stack+749);
 _BUILD_g0h0(Data,vrr_stack+6192, vrr_stack+4470, vrr_stack+2435, vrr_stack+1280, vrr_stack+4344, vrr_stack+2688);
 _BUILD_h0h0(Data,vrr_stack+6507, vrr_stack+4680, vrr_stack+6192, vrr_stack+3924, vrr_stack+4470, vrr_stack+2838);
 _BUILD_i0h0(Data,vrr_stack+6948, vrr_stack+4995, vrr_stack+6507, vrr_stack+1595, vrr_stack+4680, vrr_stack+3063);
 _BUILD_i0h0(Data,vrr_stack+2645, vrr_stack+5751, vrr_stack+4995, vrr_stack+5436, vrr_stack+1595, vrr_stack+839);
 _BUILD_k0h0(Data,vrr_stack+7536, vrr_stack+2645, vrr_stack+6948, vrr_stack+5751, vrr_stack+4995, vrr_stack+3378);
 _BUILD_00i0(Data,vrr_stack+704, vrr_stack+200, vrr_stack+179, vrr_stack+374, vrr_stack+359, NULL);
 _BUILD_00i0(Data,vrr_stack+732, vrr_stack+284, vrr_stack+200, vrr_stack+62, vrr_stack+374, NULL);
 _BUILD_00i0(Data,vrr_stack+760, vrr_stack+179, vrr_stack+305, vrr_stack+359, vrr_stack+389, NULL);
 _BUILD_p0i0(Data,vrr_stack+788, vrr_stack+704, vrr_stack+760, NULL, NULL, vrr_stack+179);
 _BUILD_p0i0(Data,vrr_stack+872, vrr_stack+732, vrr_stack+704, NULL, NULL, vrr_stack+200);
 _BUILD_d0i0(Data,vrr_stack+956, vrr_stack+872, vrr_stack+788, vrr_stack+732, vrr_stack+704, vrr_stack+221);
 _BUILD_00i0(Data,vrr_stack+221, vrr_stack+404, vrr_stack+284, vrr_stack+539, vrr_stack+62, NULL);
 _BUILD_p0i0(Data,vrr_stack+3233, vrr_stack+221, vrr_stack+732, NULL, NULL, vrr_stack+284);
 _BUILD_d0i0(Data,vrr_stack+3317, vrr_stack+3233, vrr_stack+872, vrr_stack+221, vrr_stack+732, vrr_stack+1154);
 _BUILD_00i0(Data,vrr_stack+249, vrr_stack+305, vrr_stack+112, vrr_stack+389, vrr_stack+77, NULL);
 _BUILD_p0i0(Data,vrr_stack+1124, vrr_stack+760, vrr_stack+249, NULL, NULL, vrr_stack+305);
 _BUILD_d0i0(Data,vrr_stack+3485, vrr_stack+788, vrr_stack+1124, vrr_stack+704, vrr_stack+760, vrr_stack+1217);
 _BUILD_f0i0(Data,vrr_stack+8292, vrr_stack+956, vrr_stack+3485, vrr_stack+872, vrr_stack+788, vrr_stack+1280);
 _BUILD_f0i0(Data,vrr_stack+8572, vrr_stack+3317, vrr_stack+956, vrr_stack+3233, vrr_stack+872, vrr_stack+3798);
 _BUILD_g0i0(Data,vrr_stack+8852, vrr_stack+8572, vrr_stack+8292, vrr_stack+3317, vrr_stack+956, vrr_stack+3924);
 _BUILD_00i0(Data,vrr_stack+1208, vrr_stack+326, vrr_stack+404, vrr_stack+507, vrr_stack+539, NULL);
 _BUILD_p0i0(Data,vrr_stack+1236, vrr_stack+1208, vrr_stack+221, NULL, NULL, vrr_stack+404);
 _BUILD_d0i0(Data,vrr_stack+3653, vrr_stack+1236, vrr_stack+3233, vrr_stack+1208, vrr_stack+221, vrr_stack+425);
 _BUILD_f0i0(Data,vrr_stack+3821, vrr_stack+3653, vrr_stack+3317, vrr_stack+1236, vrr_stack+3233, vrr_stack+1406);
 _BUILD_g0i0(Data,vrr_stack+9272, vrr_stack+3821, vrr_stack+8572, vrr_stack+3653, vrr_stack+3317, vrr_stack+4134);
 _BUILD_00i0(Data,vrr_stack+425, vrr_stack+112, vrr_stack+0, vrr_stack+77, vrr_stack+689, NULL);
 _BUILD_p0i0(Data,vrr_stack+1320, vrr_stack+249, vrr_stack+425, NULL, NULL, vrr_stack+112);
 _BUILD_d0i0(Data,vrr_stack+4101, vrr_stack+1124, vrr_stack+1320, vrr_stack+760, vrr_stack+249, vrr_stack+1532);
 _BUILD_f0i0(Data,vrr_stack+9692, vrr_stack+3485, vrr_stack+4101, vrr_stack+788, vrr_stack+1124, vrr_stack+4344);
 _BUILD_g0i0(Data,vrr_stack+9972, vrr_stack+8292, vrr_stack+9692, vrr_stack+956, vrr_stack+3485, vrr_stack+4470);
 _BUILD_h0i0(Data,vrr_stack+10392, vrr_stack+8852, vrr_stack+9972, vrr_stack+8572, vrr_stack+8292, vrr_stack+4680);
 _BUILD_h0i0(Data,vrr_stack+4269, vrr_stack+9272, vrr_stack+8852, vrr_stack+3821, vrr_stack+8572, vrr_stack+1595);
 _BUILD_i0i0(Data,vrr_stack+10980, vrr_stack+4269, vrr_stack+10392, vrr_stack+9272, vrr_stack+8852, vrr_stack+4995);
 _BUILD_00p0(Data,vrr_stack+453, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+456, vrr_stack+453, vrr_stack+488, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+462, vrr_stack+456, vrr_stack+491, vrr_stack+453, vrr_stack+488, NULL);
 _BUILD_00g0(Data,vrr_stack+472, vrr_stack+462, vrr_stack+497, vrr_stack+456, vrr_stack+491, NULL);
 _BUILD_00h0(Data,vrr_stack+1404, vrr_stack+472, vrr_stack+507, vrr_stack+462, vrr_stack+497, NULL);
 _BUILD_00i0(Data,vrr_stack+1425, vrr_stack+1404, vrr_stack+326, vrr_stack+472, vrr_stack+507, NULL);
 _BUILD_p0i0(Data,vrr_stack+1453, vrr_stack+1425, vrr_stack+1208, NULL, NULL, vrr_stack+326);
 _BUILD_d0i0(Data,vrr_stack+1537, vrr_stack+1453, vrr_stack+1236, vrr_stack+1425, vrr_stack+1208, vrr_stack+1910);
 _BUILD_f0i0(Data,vrr_stack+4857, vrr_stack+1537, vrr_stack+3653, vrr_stack+1453, vrr_stack+1236, vrr_stack+1973);
 _BUILD_g0i0(Data,vrr_stack+11764, vrr_stack+4857, vrr_stack+3821, vrr_stack+1537, vrr_stack+3653, vrr_stack+2099);
 _BUILD_h0i0(Data,vrr_stack+1705, vrr_stack+11764, vrr_stack+9272, vrr_stack+4857, vrr_stack+3821, vrr_stack+5436);
 _BUILD_i0i0(Data,vrr_stack+12184, vrr_stack+1705, vrr_stack+4269, vrr_stack+11764, vrr_stack+9272, vrr_stack+5751);
 _BUILD_00p0(Data,vrr_stack+487, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+490, vrr_stack+554, vrr_stack+487, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+496, vrr_stack+21, vrr_stack+490, vrr_stack+27, vrr_stack+554, NULL);
 _BUILD_00g0(Data,vrr_stack+27, vrr_stack+557, vrr_stack+496, vrr_stack+133, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+42, vrr_stack+567, vrr_stack+27, vrr_stack+139, vrr_stack+557, NULL);
 _BUILD_00i0(Data,vrr_stack+133, vrr_stack+0, vrr_stack+42, vrr_stack+689, vrr_stack+567, NULL);
 _BUILD_p0i0(Data,vrr_stack+5137, vrr_stack+425, vrr_stack+133, NULL, NULL, vrr_stack+0);
 _BUILD_d0i0(Data,vrr_stack+5221, vrr_stack+1320, vrr_stack+5137, vrr_stack+249, vrr_stack+425, vrr_stack+582);
 _BUILD_f0i0(Data,vrr_stack+5389, vrr_stack+4101, vrr_stack+5221, vrr_stack+1124, vrr_stack+1320, vrr_stack+2309);
 _BUILD_g0i0(Data,vrr_stack+5669, vrr_stack+9692, vrr_stack+5389, vrr_stack+3485, vrr_stack+4101, vrr_stack+2435);
 _BUILD_h0i0(Data,vrr_stack+12968, vrr_stack+9972, vrr_stack+5669, vrr_stack+8292, vrr_stack+9692, vrr_stack+6192);
 _BUILD_i0i0(Data,vrr_stack+13556, vrr_stack+10392, vrr_stack+12968, vrr_stack+8852, vrr_stack+9972, vrr_stack+6507);
 _BUILD_k0i0(Data,vrr_stack+14340, vrr_stack+10980, vrr_stack+13556, vrr_stack+4269, vrr_stack+10392, vrr_stack+6948);
 _BUILD_k0i0(Data,vrr_stack+6089, vrr_stack+12184, vrr_stack+10980, vrr_stack+1705, vrr_stack+4269, vrr_stack+2645);
 _BUILD_l0i0(Data,vrr_stack+15348, vrr_stack+6089, vrr_stack+14340, vrr_stack+12184, vrr_stack+10980, vrr_stack+7536);
 _BUILD_00k0(Data,vrr_stack+582, vrr_stack+704, vrr_stack+760, vrr_stack+200, vrr_stack+179, NULL);
 _BUILD_00k0(Data,vrr_stack+618, vrr_stack+732, vrr_stack+704, vrr_stack+284, vrr_stack+200, NULL);
 _BUILD_p0k0(Data,vrr_stack+2293, vrr_stack+618, vrr_stack+582, NULL, NULL, vrr_stack+704);
 _BUILD_00k0(Data,vrr_stack+654, vrr_stack+221, vrr_stack+732, vrr_stack+404, vrr_stack+284, NULL);
 _BUILD_p0k0(Data,vrr_stack+2401, vrr_stack+654, vrr_stack+618, NULL, NULL, vrr_stack+732);
 _BUILD_00k0(Data,vrr_stack+63, vrr_stack+760, vrr_stack+249, vrr_stack+179, vrr_stack+305, NULL);
 _BUILD_p0k0(Data,vrr_stack+2509, vrr_stack+582, vrr_stack+63, NULL, NULL, vrr_stack+760);
 _BUILD_d0k0(Data,vrr_stack+2617, vrr_stack+2293, vrr_stack+2509, vrr_stack+618, vrr_stack+582, vrr_stack+788);
 _BUILD_d0k0(Data,vrr_stack+2833, vrr_stack+2401, vrr_stack+2293, vrr_stack+654, vrr_stack+618, vrr_stack+872);
 _BUILD_f0k0(Data,vrr_stack+7097, vrr_stack+2833, vrr_stack+2617, vrr_stack+2401, vrr_stack+2293, vrr_stack+956);
 _BUILD_00k0(Data,vrr_stack+788, vrr_stack+1208, vrr_stack+221, vrr_stack+326, vrr_stack+404, NULL);
 _BUILD_p0k0(Data,vrr_stack+824, vrr_stack+788, vrr_stack+654, NULL, NULL, vrr_stack+221);
 _BUILD_d0k0(Data,vrr_stack+7457, vrr_stack+824, vrr_stack+2401, vrr_stack+788, vrr_stack+654, vrr_stack+3233);
 _BUILD_f0k0(Data,vrr_stack+7673, vrr_stack+7457, vrr_stack+2833, vrr_stack+824, vrr_stack+2401, vrr_stack+3317);
 _BUILD_00k0(Data,vrr_stack+932, vrr_stack+249, vrr_stack+425, vrr_stack+305, vrr_stack+112, NULL);
 _BUILD_p0k0(Data,vrr_stack+968, vrr_stack+63, vrr_stack+932, NULL, NULL, vrr_stack+249);
 _BUILD_d0k0(Data,vrr_stack+3049, vrr_stack+2509, vrr_stack+968, vrr_stack+582, vrr_stack+63, vrr_stack+1124);
 _BUILD_f0k0(Data,vrr_stack+16608, vrr_stack+2617, vrr_stack+3049, vrr_stack+2293, vrr_stack+2509, vrr_stack+3485);
 _BUILD_g0k0(Data,vrr_stack+16968, vrr_stack+7097, vrr_stack+16608, vrr_stack+2833, vrr_stack+2617, vrr_stack+8292);
 _BUILD_g0k0(Data,vrr_stack+17508, vrr_stack+7673, vrr_stack+7097, vrr_stack+7457, vrr_stack+2833, vrr_stack+8572);
 _BUILD_h0k0(Data,vrr_stack+8033, vrr_stack+17508, vrr_stack+16968, vrr_stack+7673, vrr_stack+7097, vrr_stack+8852);
 _BUILD_00k0(Data,vrr_stack+1076, vrr_stack+1425, vrr_stack+1208, vrr_stack+1404, vrr_stack+326, NULL);
 _BUILD_p0k0(Data,vrr_stack+277, vrr_stack+1076, vrr_stack+788, NULL, NULL, vrr_stack+1208);
 _BUILD_d0k0(Data,vrr_stack+3265, vrr_stack+277, vrr_stack+824, vrr_stack+1076, vrr_stack+788, vrr_stack+1236);
 _BUILD_f0k0(Data,vrr_stack+8789, vrr_stack+3265, vrr_stack+7457, vrr_stack+277, vrr_stack+824, vrr_stack+3653);
 _BUILD_g0k0(Data,vrr_stack+18048, vrr_stack+8789, vrr_stack+7673, vrr_stack+3265, vrr_stack+7457, vrr_stack+3821);
 _BUILD_h0k0(Data,vrr_stack+18588, vrr_stack+18048, vrr_stack+17508, vrr_stack+8789, vrr_stack+7673, vrr_stack+9272);
 _BUILD_00k0(Data,vrr_stack+1236, vrr_stack+425, vrr_stack+133, vrr_stack+112, vrr_stack+0, NULL);
 _BUILD_p0k0(Data,vrr_stack+3481, vrr_stack+932, vrr_stack+1236, NULL, NULL, vrr_stack+425);
 _BUILD_d0k0(Data,vrr_stack+3589, vrr_stack+968, vrr_stack+3481, vrr_stack+63, vrr_stack+932, vrr_stack+1320);
 _BUILD_f0k0(Data,vrr_stack+9149, vrr_stack+3049, vrr_stack+3589, vrr_stack+2509, vrr_stack+968, vrr_stack+4101);
 _BUILD_g0k0(Data,vrr_stack+19344, vrr_stack+16608, vrr_stack+9149, vrr_stack+2617, vrr_stack+3049, vrr_stack+9692);
 _BUILD_h0k0(Data,vrr_stack+19884, vrr_stack+16968, vrr_stack+19344, vrr_stack+7097, vrr_stack+16608, vrr_stack+9972);
 _BUILD_i0k0(Data,vrr_stack+20640, vrr_stack+8033, vrr_stack+19884, vrr_stack+17508, vrr_stack+16968, vrr_stack+10392);
 _BUILD_i0k0(Data,vrr_stack+9509, vrr_stack+18588, vrr_stack+8033, vrr_stack+18048, vrr_stack+17508, vrr_stack+4269);
 _BUILD_k0k0(Data,vrr_stack+21648, vrr_stack+9509, vrr_stack+20640, vrr_stack+18588, vrr_stack+8033, vrr_stack+10980);
 _BUILD_00p0(Data,vrr_stack+1272, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1275, vrr_stack+1272, vrr_stack+453, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+1281, vrr_stack+1275, vrr_stack+456, vrr_stack+1272, vrr_stack+453, NULL);
 _BUILD_00g0(Data,vrr_stack+1291, vrr_stack+1281, vrr_stack+462, vrr_stack+1275, vrr_stack+456, NULL);
 _BUILD_00h0(Data,vrr_stack+1306, vrr_stack+1291, vrr_stack+472, vrr_stack+1281, vrr_stack+462, NULL);
 _BUILD_00i0(Data,vrr_stack+1327, vrr_stack+1306, vrr_stack+1404, vrr_stack+1291, vrr_stack+472, NULL);
 _BUILD_00k0(Data,vrr_stack+1355, vrr_stack+1327, vrr_stack+1425, vrr_stack+1306, vrr_stack+1404, NULL);
 _BUILD_p0k0(Data,vrr_stack+3805, vrr_stack+1355, vrr_stack+1076, NULL, NULL, vrr_stack+1425);
 _BUILD_d0k0(Data,vrr_stack+3913, vrr_stack+3805, vrr_stack+277, vrr_stack+1355, vrr_stack+1076, vrr_stack+1453);
 _BUILD_f0k0(Data,vrr_stack+4129, vrr_stack+3913, vrr_stack+3265, vrr_stack+3805, vrr_stack+277, vrr_stack+1537);
 _BUILD_g0k0(Data,vrr_stack+10517, vrr_stack+4129, vrr_stack+8789, vrr_stack+3913, vrr_stack+3265, vrr_stack+4857);
 _BUILD_h0k0(Data,vrr_stack+22944, vrr_stack+10517, vrr_stack+18048, vrr_stack+4129, vrr_stack+8789, vrr_stack+11764);
 _BUILD_i0k0(Data,vrr_stack+11057, vrr_stack+22944, vrr_stack+18588, vrr_stack+10517, vrr_stack+18048, vrr_stack+1705);
 _BUILD_k0k0(Data,vrr_stack+23700, vrr_stack+11057, vrr_stack+9509, vrr_stack+22944, vrr_stack+18588, vrr_stack+12184);
 _BUILD_00p0(Data,vrr_stack+1453, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1456, vrr_stack+487, vrr_stack+1453, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+1462, vrr_stack+490, vrr_stack+1456, vrr_stack+554, vrr_stack+487, NULL);
 _BUILD_00g0(Data,vrr_stack+1472, vrr_stack+496, vrr_stack+1462, vrr_stack+21, vrr_stack+490, NULL);
 _BUILD_00h0(Data,vrr_stack+1487, vrr_stack+27, vrr_stack+1472, vrr_stack+557, vrr_stack+496, NULL);
 _BUILD_00i0(Data,vrr_stack+1508, vrr_stack+42, vrr_stack+1487, vrr_stack+567, vrr_stack+27, NULL);
 _BUILD_00k0(Data,vrr_stack+1536, vrr_stack+133, vrr_stack+1508, vrr_stack+0, vrr_stack+42, NULL);
 _BUILD_p0k0(Data,vrr_stack+1572, vrr_stack+1236, vrr_stack+1536, NULL, NULL, vrr_stack+133);
 _BUILD_d0k0(Data,vrr_stack+1680, vrr_stack+3481, vrr_stack+1572, vrr_stack+932, vrr_stack+1236, vrr_stack+5137);
 _BUILD_f0k0(Data,vrr_stack+1896, vrr_stack+3589, vrr_stack+1680, vrr_stack+968, vrr_stack+3481, vrr_stack+5221);
 _BUILD_g0k0(Data,vrr_stack+4489, vrr_stack+9149, vrr_stack+1896, vrr_stack+3049, vrr_stack+3589, vrr_stack+5389);
 _BUILD_h0k0(Data,vrr_stack+12065, vrr_stack+19344, vrr_stack+4489, vrr_stack+16608, vrr_stack+9149, vrr_stack+5669);
 _BUILD_i0k0(Data,vrr_stack+5029, vrr_stack+19884, vrr_stack+12065, vrr_stack+16968, vrr_stack+19344, vrr_stack+12968);
 _BUILD_k0k0(Data,vrr_stack+24996, vrr_stack+20640, vrr_stack+5029, vrr_stack+8033, vrr_stack+19884, vrr_stack+13556);
 _BUILD_l0k0(Data,vrr_stack+26292, vrr_stack+21648, vrr_stack+24996, vrr_stack+9509, vrr_stack+20640, vrr_stack+14340);
 _BUILD_l0k0(Data,vrr_stack+12821, vrr_stack+23700, vrr_stack+21648, vrr_stack+11057, vrr_stack+9509, vrr_stack+6089);
 _BUILD_m0k0(Data,vrr_stack+27912, vrr_stack+12821, vrr_stack+26292, vrr_stack+23700, vrr_stack+21648, vrr_stack+15348);
 _BUILD_00l0(Data,vrr_stack+1112, vrr_stack+618, vrr_stack+582, vrr_stack+732, vrr_stack+704, NULL);
 _BUILD_00l0(Data,vrr_stack+1157, vrr_stack+654, vrr_stack+618, vrr_stack+221, vrr_stack+732, NULL);
 _BUILD_00l0(Data,vrr_stack+161, vrr_stack+582, vrr_stack+63, vrr_stack+704, vrr_stack+760, NULL);
 _BUILD_p0l0(Data,vrr_stack+6037, vrr_stack+1112, vrr_stack+161, NULL, NULL, vrr_stack+582);
 _BUILD_p0l0(Data,vrr_stack+6172, vrr_stack+1157, vrr_stack+1112, NULL, NULL, vrr_stack+618);
 _BUILD_d0l0(Data,vrr_stack+6307, vrr_stack+6172, vrr_stack+6037, vrr_stack+1157, vrr_stack+1112, vrr_stack+2293);
 _BUILD_00l0(Data,vrr_stack+2256, vrr_stack+788, vrr_stack+654, vrr_stack+1208, vrr_stack+221, NULL);
 _BUILD_p0l0(Data,vrr_stack+6577, vrr_stack+2256, vrr_stack+1157, NULL, NULL, vrr_stack+654);
 _BUILD_d0l0(Data,vrr_stack+6712, vrr_stack+6577, vrr_stack+6172, vrr_stack+2256, vrr_stack+1157, vrr_stack+2401);
 _BUILD_00l0(Data,vrr_stack+2301, vrr_stack+63, vrr_stack+932, vrr_stack+760, vrr_stack+249, NULL);
 _BUILD_p0l0(Data,vrr_stack+2346, vrr_stack+161, vrr_stack+2301, NULL, NULL, vrr_stack+63);
 _BUILD_d0l0(Data,vrr_stack+14441, vrr_stack+6037, vrr_stack+2346, vrr_stack+1112, vrr_stack+161, vrr_stack+2509);
 _BUILD_f0l0(Data,vrr_stack+14711, vrr_stack+6307, vrr_stack+14441, vrr_stack+6172, vrr_stack+6037, vrr_stack+2617);
 _BUILD_f0l0(Data,vrr_stack+15161, vrr_stack+6712, vrr_stack+6307, vrr_stack+6577, vrr_stack+6172, vrr_stack+2833);
 _BUILD_g0l0(Data,vrr_stack+15611, vrr_stack+15161, vrr_stack+14711, vrr_stack+6712, vrr_stack+6307, vrr_stack+7097);
 _BUILD_00l0(Data,vrr_stack+2481, vrr_stack+1076, vrr_stack+788, vrr_stack+1425, vrr_stack+1208, NULL);
 _BUILD_p0l0(Data,vrr_stack+2526, vrr_stack+2481, vrr_stack+2256, NULL, NULL, vrr_stack+788);
 _BUILD_d0l0(Data,vrr_stack+2661, vrr_stack+2526, vrr_stack+6577, vrr_stack+2481, vrr_stack+2256, vrr_stack+824);
 _BUILD_f0l0(Data,vrr_stack+6982, vrr_stack+2661, vrr_stack+6712, vrr_stack+2526, vrr_stack+6577, vrr_stack+7457);
 _BUILD_g0l0(Data,vrr_stack+29892, vrr_stack+6982, vrr_stack+15161, vrr_stack+2661, vrr_stack+6712, vrr_stack+7673);
 _BUILD_00l0(Data,vrr_stack+824, vrr_stack+932, vrr_stack+1236, vrr_stack+249, vrr_stack+425, NULL);
 _BUILD_p0l0(Data,vrr_stack+7432, vrr_stack+2301, vrr_stack+824, NULL, NULL, vrr_stack+932);
 _BUILD_d0l0(Data,vrr_stack+7567, vrr_stack+2346, vrr_stack+7432, vrr_stack+161, vrr_stack+2301, vrr_stack+968);
 _BUILD_f0l0(Data,vrr_stack+30567, vrr_stack+14441, vrr_stack+7567, vrr_stack+6037, vrr_stack+2346, vrr_stack+3049);
 _BUILD_g0l0(Data,vrr_stack+31017, vrr_stack+14711, vrr_stack+30567, vrr_stack+6307, vrr_stack+14441, vrr_stack+16608);
 _BUILD_h0l0(Data,vrr_stack+31692, vrr_stack+15611, vrr_stack+31017, vrr_stack+15161, vrr_stack+14711, vrr_stack+16968);
 _BUILD_h0l0(Data,vrr_stack+16286, vrr_stack+29892, vrr_stack+15611, vrr_stack+6982, vrr_stack+15161, vrr_stack+17508);
 _BUILD_i0l0(Data,vrr_stack+32637, vrr_stack+16286, vrr_stack+31692, vrr_stack+29892, vrr_stack+15611, vrr_stack+8033);
 _BUILD_00l0(Data,vrr_stack+968, vrr_stack+1355, vrr_stack+1076, vrr_stack+1327, vrr_stack+1425, NULL);
 _BUILD_p0l0(Data,vrr_stack+2931, vrr_stack+968, vrr_stack+2481, NULL, NULL, vrr_stack+1076);
 _BUILD_d0l0(Data,vrr_stack+7837, vrr_stack+2931, vrr_stack+2526, vrr_stack+968, vrr_stack+2481, vrr_stack+277);
 _BUILD_f0l0(Data,vrr_stack+8107, vrr_stack+7837, vrr_stack+2661, vrr_stack+2931, vrr_stack+2526, vrr_stack+3265);
 _BUILD_g0l0(Data,vrr_stack+17231, vrr_stack+8107, vrr_stack+6982, vrr_stack+7837, vrr_stack+2661, vrr_stack+8789);
 _BUILD_h0l0(Data,vrr_stack+33897, vrr_stack+17231, vrr_stack+29892, vrr_stack+8107, vrr_stack+6982, vrr_stack+18048);
 _BUILD_i0l0(Data,vrr_stack+34842, vrr_stack+33897, vrr_stack+16286, vrr_stack+17231, vrr_stack+29892, vrr_stack+18588);
 _BUILD_00l0(Data,vrr_stack+1013, vrr_stack+1236, vrr_stack+1536, vrr_stack+425, vrr_stack+133, NULL);
 _BUILD_p0l0(Data,vrr_stack+3066, vrr_stack+824, vrr_stack+1013, NULL, NULL, vrr_stack+1236);
 _BUILD_d0l0(Data,vrr_stack+3201, vrr_stack+7432, vrr_stack+3066, vrr_stack+2301, vrr_stack+824, vrr_stack+3481);
 _BUILD_f0l0(Data,vrr_stack+8557, vrr_stack+7567, vrr_stack+3201, vrr_stack+2346, vrr_stack+7432, vrr_stack+3589);
 _BUILD_g0l0(Data,vrr_stack+17906, vrr_stack+30567, vrr_stack+8557, vrr_stack+14441, vrr_stack+7567, vrr_stack+9149);
 _BUILD_h0l0(Data,vrr_stack+36102, vrr_stack+31017, vrr_stack+17906, vrr_stack+14711, vrr_stack+30567, vrr_stack+19344);
 _BUILD_i0l0(Data,vrr_stack+18581, vrr_stack+31692, vrr_stack+36102, vrr_stack+15611, vrr_stack+31017, vrr_stack+19884);
 _BUILD_k0l0(Data,vrr_stack+37047, vrr_stack+32637, vrr_stack+18581, vrr_stack+16286, vrr_stack+31692, vrr_stack+20640);
 _BUILD_k0l0(Data,vrr_stack+19841, vrr_stack+34842, vrr_stack+32637, vrr_stack+33897, vrr_stack+16286, vrr_stack+9509);
 _BUILD_l0l0(Data,vrr_stack+38667, vrr_stack+19841, vrr_stack+37047, vrr_stack+34842, vrr_stack+32637, vrr_stack+21648);
 _BUILD_00p0(Data,vrr_stack+1058, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1061, vrr_stack+1058, vrr_stack+1272, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+869, vrr_stack+1061, vrr_stack+1275, vrr_stack+1058, vrr_stack+1272, NULL);
 _BUILD_00g0(Data,vrr_stack+879, vrr_stack+869, vrr_stack+1281, vrr_stack+1061, vrr_stack+1275, NULL);
 _BUILD_00h0(Data,vrr_stack+894, vrr_stack+879, vrr_stack+1291, vrr_stack+869, vrr_stack+1281, NULL);
 _BUILD_00i0(Data,vrr_stack+3471, vrr_stack+894, vrr_stack+1306, vrr_stack+879, vrr_stack+1291, NULL);
 _BUILD_00k0(Data,vrr_stack+3499, vrr_stack+3471, vrr_stack+1327, vrr_stack+894, vrr_stack+1306, NULL);
 _BUILD_00l0(Data,vrr_stack+1272, vrr_stack+3499, vrr_stack+1355, vrr_stack+3471, vrr_stack+1327, NULL);
 _BUILD_p0l0(Data,vrr_stack+3535, vrr_stack+1272, vrr_stack+968, NULL, NULL, vrr_stack+1355);
 _BUILD_d0l0(Data,vrr_stack+206, vrr_stack+3535, vrr_stack+2931, vrr_stack+1272, vrr_stack+968, vrr_stack+3805);
 _BUILD_f0l0(Data,vrr_stack+9007, vrr_stack+206, vrr_stack+7837, vrr_stack+3535, vrr_stack+2931, vrr_stack+3913);
 _BUILD_g0l0(Data,vrr_stack+9457, vrr_stack+9007, vrr_stack+8107, vrr_stack+206, vrr_stack+7837, vrr_stack+4129);
 _BUILD_h0l0(Data,vrr_stack+21461, vrr_stack+9457, vrr_stack+17231, vrr_stack+9007, vrr_stack+8107, vrr_stack+10517);
 _BUILD_i0l0(Data,vrr_stack+40692, vrr_stack+21461, vrr_stack+33897, vrr_stack+9457, vrr_stack+17231, vrr_stack+22944);
 _BUILD_k0l0(Data,vrr_stack+41952, vrr_stack+40692, vrr_stack+34842, vrr_stack+21461, vrr_stack+33897, vrr_stack+11057);
 _BUILD_l0l0(Data,vrr_stack+43572, vrr_stack+41952, vrr_stack+19841, vrr_stack+40692, vrr_stack+34842, vrr_stack+23700);
 _BUILD_00p0(Data,vrr_stack+1317, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1320, vrr_stack+1453, vrr_stack+1317, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+1326, vrr_stack+1456, vrr_stack+1320, vrr_stack+487, vrr_stack+1453, NULL);
 _BUILD_00g0(Data,vrr_stack+1336, vrr_stack+1462, vrr_stack+1326, vrr_stack+490, vrr_stack+1456, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+1472, vrr_stack+1336, vrr_stack+496, vrr_stack+1462, NULL);
 _BUILD_00i0(Data,vrr_stack+3670, vrr_stack+1487, vrr_stack+0, vrr_stack+27, vrr_stack+1472, NULL);
 _BUILD_00k0(Data,vrr_stack+3698, vrr_stack+1508, vrr_stack+3670, vrr_stack+42, vrr_stack+1487, NULL);
 _BUILD_00l0(Data,vrr_stack+3734, vrr_stack+1536, vrr_stack+3698, vrr_stack+133, vrr_stack+1508, NULL);
 _BUILD_p0l0(Data,vrr_stack+3779, vrr_stack+1013, vrr_stack+3734, NULL, NULL, vrr_stack+1536);
 _BUILD_d0l0(Data,vrr_stack+3914, vrr_stack+3066, vrr_stack+3779, vrr_stack+824, vrr_stack+1013, vrr_stack+1572);
 _BUILD_f0l0(Data,vrr_stack+10132, vrr_stack+3201, vrr_stack+3914, vrr_stack+7432, vrr_stack+3066, vrr_stack+1680);
 _BUILD_g0l0(Data,vrr_stack+10582, vrr_stack+8557, vrr_stack+10132, vrr_stack+7567, vrr_stack+3201, vrr_stack+1896);
 _BUILD_h0l0(Data,vrr_stack+22406, vrr_stack+17906, vrr_stack+10582, vrr_stack+30567, vrr_stack+8557, vrr_stack+4489);
 _BUILD_i0l0(Data,vrr_stack+23351, vrr_stack+36102, vrr_stack+22406, vrr_stack+31017, vrr_stack+17906, vrr_stack+12065);
 _BUILD_k0l0(Data,vrr_stack+45597, vrr_stack+18581, vrr_stack+23351, vrr_stack+31692, vrr_stack+36102, vrr_stack+5029);
 _BUILD_l0l0(Data,vrr_stack+47217, vrr_stack+37047, vrr_stack+45597, vrr_stack+32637, vrr_stack+18581, vrr_stack+24996);
 _BUILD_m0l0(Data,vrr_stack+49242, vrr_stack+38667, vrr_stack+47217, vrr_stack+19841, vrr_stack+37047, vrr_stack+26292);
 _BUILD_m0l0(Data,vrr_stack+24611, vrr_stack+43572, vrr_stack+38667, vrr_stack+41952, vrr_stack+19841, vrr_stack+12821);
 _BUILD_n0l0(Data,vrr_stack+11257, vrr_stack+24611, vrr_stack+49242, vrr_stack+43572, vrr_stack+38667, vrr_stack+27912);
 _BUILD_00m0(Data,vrr_stack+1572, vrr_stack+1112, vrr_stack+161, vrr_stack+618, vrr_stack+582, NULL);
 _BUILD_00m0(Data,vrr_stack+1627, vrr_stack+1157, vrr_stack+1112, vrr_stack+654, vrr_stack+618, NULL);
 _BUILD_p0m0(Data,vrr_stack+1682, vrr_stack+1627, vrr_stack+1572, NULL, NULL, vrr_stack+1112);
 _BUILD_00m0(Data,vrr_stack+1847, vrr_stack+2256, vrr_stack+1157, vrr_stack+788, vrr_stack+654, NULL);
 _BUILD_p0m0(Data,vrr_stack+618, vrr_stack+1847, vrr_stack+1627, NULL, NULL, vrr_stack+1157);
 _BUILD_00m0(Data,vrr_stack+1902, vrr_stack+161, vrr_stack+2301, vrr_stack+582, vrr_stack+63, NULL);
 _BUILD_p0m0(Data,vrr_stack+1957, vrr_stack+1572, vrr_stack+1902, NULL, NULL, vrr_stack+161);
 _BUILD_d0m0(Data,vrr_stack+4184, vrr_stack+1682, vrr_stack+1957, vrr_stack+1627, vrr_stack+1572, vrr_stack+6037);
 _BUILD_d0m0(Data,vrr_stack+4514, vrr_stack+618, vrr_stack+1682, vrr_stack+1847, vrr_stack+1627, vrr_stack+6172);
 _BUILD_f0m0(Data,vrr_stack+4844, vrr_stack+4514, vrr_stack+4184, vrr_stack+618, vrr_stack+1682, vrr_stack+6307);
 _BUILD_00m0(Data,vrr_stack+2122, vrr_stack+2481, vrr_stack+2256, vrr_stack+1076, vrr_stack+788, NULL);
 _BUILD_p0m0(Data,vrr_stack+5394, vrr_stack+2122, vrr_stack+1847, NULL, NULL, vrr_stack+2256);
 _BUILD_d0m0(Data,vrr_stack+5559, vrr_stack+5394, vrr_stack+618, vrr_stack+2122, vrr_stack+1847, vrr_stack+6577);
 _BUILD_f0m0(Data,vrr_stack+5889, vrr_stack+5559, vrr_stack+4514, vrr_stack+5394, vrr_stack+618, vrr_stack+6712);
 _BUILD_00m0(Data,vrr_stack+2177, vrr_stack+2301, vrr_stack+824, vrr_stack+63, vrr_stack+932, NULL);
 _BUILD_p0m0(Data,vrr_stack+6439, vrr_stack+1902, vrr_stack+2177, NULL, NULL, vrr_stack+2301);
 _BUILD_d0m0(Data,vrr_stack+6604, vrr_stack+1957, vrr_stack+6439, vrr_stack+1572, vrr_stack+1902, vrr_stack+2346);
 _BUILD_f0m0(Data,vrr_stack+27086, vrr_stack+4184, vrr_stack+6604, vrr_stack+1682, vrr_stack+1957, vrr_stack+14441);
 _BUILD_g0m0(Data,vrr_stack+27636, vrr_stack+4844, vrr_stack+27086, vrr_stack+4514, vrr_stack+4184, vrr_stack+14711);
 _BUILD_g0m0(Data,vrr_stack+14227, vrr_stack+5889, vrr_stack+4844, vrr_stack+5559, vrr_stack+4514, vrr_stack+15161);
 _BUILD_h0m0(Data,vrr_stack+28461, vrr_stack+14227, vrr_stack+27636, vrr_stack+5889, vrr_stack+4844, vrr_stack+15611);
 _BUILD_00m0(Data,vrr_stack+2346, vrr_stack+968, vrr_stack+2481, vrr_stack+1355, vrr_stack+1076, NULL);
 _BUILD_p0m0(Data,vrr_stack+15052, vrr_stack+2346, vrr_stack+2122, NULL, NULL, vrr_stack+2481);
 _BUILD_d0m0(Data,vrr_stack+15217, vrr_stack+15052, vrr_stack+5394, vrr_stack+2346, vrr_stack+2122, vrr_stack+2526);
 _BUILD_f0m0(Data,vrr_stack+15547, vrr_stack+15217, vrr_stack+5559, vrr_stack+15052, vrr_stack+5394, vrr_stack+2661);
 _BUILD_g0m0(Data,vrr_stack+51717, vrr_stack+15547, vrr_stack+5889, vrr_stack+15217, vrr_stack+5559, vrr_stack+6982);
 _BUILD_h0m0(Data,vrr_stack+52542, vrr_stack+51717, vrr_stack+14227, vrr_stack+15547, vrr_stack+5889, vrr_stack+29892);
 _BUILD_00m0(Data,vrr_stack+2526, vrr_stack+824, vrr_stack+1013, vrr_stack+932, vrr_stack+1236, NULL);
 _BUILD_p0m0(Data,vrr_stack+2581, vrr_stack+2177, vrr_stack+2526, NULL, NULL, vrr_stack+824);
 _BUILD_d0m0(Data,vrr_stack+6934, vrr_stack+6439, vrr_stack+2581, vrr_stack+1902, vrr_stack+2177, vrr_stack+7432);
 _BUILD_f0m0(Data,vrr_stack+29616, vrr_stack+6604, vrr_stack+6934, vrr_stack+1957, vrr_stack+6439, vrr_stack+7567);
 _BUILD_g0m0(Data,vrr_stack+53697, vrr_stack+27086, vrr_stack+29616, vrr_stack+4184, vrr_stack+6604, vrr_stack+30567);
 _BUILD_h0m0(Data,vrr_stack+54522, vrr_stack+27636, vrr_stack+53697, vrr_stack+4844, vrr_stack+27086, vrr_stack+31017);
 _BUILD_i0m0(Data,vrr_stack+55677, vrr_stack+28461, vrr_stack+54522, vrr_stack+14227, vrr_stack+27636, vrr_stack+31692);
 _BUILD_i0m0(Data,vrr_stack+30166, vrr_stack+52542, vrr_stack+28461, vrr_stack+51717, vrr_stack+14227, vrr_stack+16286);
 _BUILD_k0m0(Data,vrr_stack+57217, vrr_stack+30166, vrr_stack+55677, vrr_stack+52542, vrr_stack+28461, vrr_stack+32637);
 _BUILD_00m0(Data,vrr_stack+2746, vrr_stack+1272, vrr_stack+968, vrr_stack+3499, vrr_stack+1355, NULL);
 _BUILD_p0m0(Data,vrr_stack+7264, vrr_stack+2746, vrr_stack+2346, NULL, NULL, vrr_stack+968);
 _BUILD_d0m0(Data,vrr_stack+7429, vrr_stack+7264, vrr_stack+15052, vrr_stack+2746, vrr_stack+2346, vrr_stack+2931);
 _BUILD_f0m0(Data,vrr_stack+16097, vrr_stack+7429, vrr_stack+15217, vrr_stack+7264, vrr_stack+15052, vrr_stack+7837);
 _BUILD_g0m0(Data,vrr_stack+31706, vrr_stack+16097, vrr_stack+15547, vrr_stack+7429, vrr_stack+15217, vrr_stack+8107);
 _BUILD_h0m0(Data,vrr_stack+32531, vrr_stack+31706, vrr_stack+51717, vrr_stack+16097, vrr_stack+15547, vrr_stack+17231);
 _BUILD_i0m0(Data,vrr_stack+59197, vrr_stack+32531, vrr_stack+52542, vrr_stack+31706, vrr_stack+51717, vrr_stack+33897);
 _BUILD_k0m0(Data,vrr_stack+60737, vrr_stack+59197, vrr_stack+30166, vrr_stack+32531, vrr_stack+52542, vrr_stack+34842);
 _BUILD_00m0(Data,vrr_stack+2801, vrr_stack+1013, vrr_stack+3734, vrr_stack+1236, vrr_stack+1536, NULL);
 _BUILD_p0m0(Data,vrr_stack+2856, vrr_stack+2526, vrr_stack+2801, NULL, NULL, vrr_stack+1013);
 _BUILD_d0m0(Data,vrr_stack+7759, vrr_stack+2581, vrr_stack+2856, vrr_stack+2177, vrr_stack+2526, vrr_stack+3066);
 _BUILD_f0m0(Data,vrr_stack+16647, vrr_stack+6934, vrr_stack+7759, vrr_stack+6439, vrr_stack+2581, vrr_stack+3201);
 _BUILD_g0m0(Data,vrr_stack+33686, vrr_stack+29616, vrr_stack+16647, vrr_stack+6604, vrr_stack+6934, vrr_stack+8557);
 _BUILD_h0m0(Data,vrr_stack+34511, vrr_stack+53697, vrr_stack+33686, vrr_stack+27086, vrr_stack+29616, vrr_stack+17906);
 _BUILD_i0m0(Data,vrr_stack+62717, vrr_stack+54522, vrr_stack+34511, vrr_stack+27636, vrr_stack+53697, vrr_stack+36102);
 _BUILD_k0m0(Data,vrr_stack+64257, vrr_stack+55677, vrr_stack+62717, vrr_stack+28461, vrr_stack+54522, vrr_stack+18581);
 _BUILD_l0m0(Data,vrr_stack+17197, vrr_stack+57217, vrr_stack+64257, vrr_stack+30166, vrr_stack+55677, vrr_stack+37047);
 _BUILD_l0m0(Data,vrr_stack+35666, vrr_stack+60737, vrr_stack+57217, vrr_stack+59197, vrr_stack+30166, vrr_stack+19841);
 _BUILD_m0m0(Data,vrr_stack+66237, vrr_stack+35666, vrr_stack+17197, vrr_stack+60737, vrr_stack+57217, vrr_stack+38667);
 _BUILD_00p0(Data,vrr_stack+3021, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3024, vrr_stack+3021, vrr_stack+1058, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+3030, vrr_stack+3024, vrr_stack+1061, vrr_stack+3021, vrr_stack+1058, NULL);
 _BUILD_00g0(Data,vrr_stack+3040, vrr_stack+3030, vrr_stack+869, vrr_stack+3024, vrr_stack+1061, NULL);
 _BUILD_00h0(Data,vrr_stack+1058, vrr_stack+3040, vrr_stack+879, vrr_stack+3030, vrr_stack+869, NULL);
 _BUILD_00i0(Data,vrr_stack+1079, vrr_stack+1058, vrr_stack+894, vrr_stack+3040, vrr_stack+879, NULL);
 _BUILD_00k0(Data,vrr_stack+3021, vrr_stack+1079, vrr_stack+3471, vrr_stack+1058, vrr_stack+894, NULL);
 _BUILD_00l0(Data,vrr_stack+869, vrr_stack+3021, vrr_stack+3499, vrr_stack+1079, vrr_stack+3471, NULL);
 _BUILD_00m0(Data,vrr_stack+3057, vrr_stack+869, vrr_stack+1272, vrr_stack+3021, vrr_stack+3499, NULL);
 _BUILD_p0m0(Data,vrr_stack+3112, vrr_stack+3057, vrr_stack+2746, NULL, NULL, vrr_stack+1272);
 _BUILD_d0m0(Data,vrr_stack+8089, vrr_stack+3112, vrr_stack+7264, vrr_stack+3057, vrr_stack+2746, vrr_stack+3535);
 _BUILD_f0m0(Data,vrr_stack+8419, vrr_stack+8089, vrr_stack+7429, vrr_stack+3112, vrr_stack+7264, vrr_stack+206);
 _BUILD_g0m0(Data,vrr_stack+19672, vrr_stack+8419, vrr_stack+16097, vrr_stack+8089, vrr_stack+7429, vrr_stack+9007);
 _BUILD_h0m0(Data,vrr_stack+38141, vrr_stack+19672, vrr_stack+31706, vrr_stack+8419, vrr_stack+16097, vrr_stack+9457);
 _BUILD_i0m0(Data,vrr_stack+8089, vrr_stack+38141, vrr_stack+32531, vrr_stack+19672, vrr_stack+31706, vrr_stack+21461);
 _BUILD_k0m0(Data,vrr_stack+19672, vrr_stack+8089, vrr_stack+59197, vrr_stack+38141, vrr_stack+32531, vrr_stack+40692);
 _BUILD_l0m0(Data,vrr_stack+38141, vrr_stack+19672, vrr_stack+60737, vrr_stack+8089, vrr_stack+59197, vrr_stack+41952);
   tmp = vrr_stack + 38141;
   target_ptr = Libint->vrr_classes[8][9];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0m0(Data,vrr_stack+69262, vrr_stack+38141, vrr_stack+35666, vrr_stack+19672, vrr_stack+60737, vrr_stack+43572);
   tmp = vrr_stack + 69262;
   target_ptr = Libint->vrr_classes[9][9];
   for(i=0;i<3025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+19672, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+19675, vrr_stack+1317, vrr_stack+19672, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+19681, vrr_stack+1320, vrr_stack+19675, vrr_stack+1453, vrr_stack+1317, NULL);
 _BUILD_00g0(Data,vrr_stack+19691, vrr_stack+1326, vrr_stack+19681, vrr_stack+1456, vrr_stack+1320, NULL);
 _BUILD_00h0(Data,vrr_stack+19706, vrr_stack+1336, vrr_stack+19691, vrr_stack+1462, vrr_stack+1326, NULL);
 _BUILD_00i0(Data,vrr_stack+19727, vrr_stack+0, vrr_stack+19706, vrr_stack+1472, vrr_stack+1336, NULL);
 _BUILD_00k0(Data,vrr_stack+3021, vrr_stack+3670, vrr_stack+19727, vrr_stack+1487, vrr_stack+0, NULL);
 _BUILD_00l0(Data,vrr_stack+19755, vrr_stack+3698, vrr_stack+3021, vrr_stack+1508, vrr_stack+3670, NULL);
 _BUILD_00m0(Data,vrr_stack+19800, vrr_stack+3734, vrr_stack+19755, vrr_stack+1536, vrr_stack+3698, NULL);
 _BUILD_p0m0(Data,vrr_stack+19855, vrr_stack+2801, vrr_stack+19800, NULL, NULL, vrr_stack+3734);
 _BUILD_d0m0(Data,vrr_stack+20020, vrr_stack+2856, vrr_stack+19855, vrr_stack+2526, vrr_stack+2801, vrr_stack+3779);
 _BUILD_f0m0(Data,vrr_stack+20350, vrr_stack+7759, vrr_stack+20020, vrr_stack+2581, vrr_stack+2856, vrr_stack+3914);
 _BUILD_g0m0(Data,vrr_stack+20900, vrr_stack+16647, vrr_stack+20350, vrr_stack+6934, vrr_stack+7759, vrr_stack+10132);
 _BUILD_h0m0(Data,vrr_stack+8089, vrr_stack+33686, vrr_stack+20900, vrr_stack+29616, vrr_stack+16647, vrr_stack+10582);
 _BUILD_i0m0(Data,vrr_stack+9244, vrr_stack+34511, vrr_stack+8089, vrr_stack+53697, vrr_stack+33686, vrr_stack+22406);
 _BUILD_k0m0(Data,vrr_stack+40616, vrr_stack+62717, vrr_stack+9244, vrr_stack+54522, vrr_stack+34511, vrr_stack+23351);
 _BUILD_l0m0(Data,vrr_stack+21725, vrr_stack+64257, vrr_stack+40616, vrr_stack+55677, vrr_stack+62717, vrr_stack+45597);
 _BUILD_m0m0(Data,vrr_stack+42596, vrr_stack+17197, vrr_stack+21725, vrr_stack+57217, vrr_stack+64257, vrr_stack+47217);
 _BUILD_n0m0(Data,vrr_stack+72287, vrr_stack+66237, vrr_stack+42596, vrr_stack+35666, vrr_stack+17197, vrr_stack+49242);
 _BUILD_n0m0(Data,vrr_stack+45621, vrr_stack+69262, vrr_stack+66237, vrr_stack+38141, vrr_stack+35666, vrr_stack+24611);
   tmp = vrr_stack + 45621;
   target_ptr = Libint->vrr_classes[10][9];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+38141, vrr_stack+1572, vrr_stack+1902, vrr_stack+1112, vrr_stack+161, NULL);
 _BUILD_00n0(Data,vrr_stack+38207, vrr_stack+1627, vrr_stack+1572, vrr_stack+1157, vrr_stack+1112, NULL);
 _BUILD_p0n0(Data,vrr_stack+38273, vrr_stack+38207, vrr_stack+38141, NULL, NULL, vrr_stack+1572);
 _BUILD_00n0(Data,vrr_stack+38471, vrr_stack+1847, vrr_stack+1627, vrr_stack+2256, vrr_stack+1157, NULL);
 _BUILD_p0n0(Data,vrr_stack+38537, vrr_stack+38471, vrr_stack+38207, NULL, NULL, vrr_stack+1627);
 _BUILD_00n0(Data,vrr_stack+38735, vrr_stack+1902, vrr_stack+2177, vrr_stack+161, vrr_stack+2301, NULL);
 _BUILD_p0n0(Data,vrr_stack+38801, vrr_stack+38141, vrr_stack+38735, NULL, NULL, vrr_stack+1902);
 _BUILD_d0n0(Data,vrr_stack+38999, vrr_stack+38273, vrr_stack+38801, vrr_stack+38207, vrr_stack+38141, vrr_stack+1957);
 _BUILD_d0n0(Data,vrr_stack+39395, vrr_stack+38537, vrr_stack+38273, vrr_stack+38471, vrr_stack+38207, vrr_stack+1682);
 _BUILD_f0n0(Data,vrr_stack+39791, vrr_stack+39395, vrr_stack+38999, vrr_stack+38537, vrr_stack+38273, vrr_stack+4184);
 _BUILD_00n0(Data,vrr_stack+1682, vrr_stack+2122, vrr_stack+1847, vrr_stack+2481, vrr_stack+2256, NULL);
 _BUILD_p0n0(Data,vrr_stack+3779, vrr_stack+1682, vrr_stack+38471, NULL, NULL, vrr_stack+1847);
 _BUILD_d0n0(Data,vrr_stack+3977, vrr_stack+3779, vrr_stack+38537, vrr_stack+1682, vrr_stack+38471, vrr_stack+618);
 _BUILD_f0n0(Data,vrr_stack+24200, vrr_stack+3977, vrr_stack+39395, vrr_stack+3779, vrr_stack+38537, vrr_stack+4514);
 _BUILD_00n0(Data,vrr_stack+1748, vrr_stack+2177, vrr_stack+2526, vrr_stack+2301, vrr_stack+824, NULL);
 _BUILD_p0n0(Data,vrr_stack+4373, vrr_stack+38735, vrr_stack+1748, NULL, NULL, vrr_stack+2177);
 _BUILD_d0n0(Data,vrr_stack+24860, vrr_stack+38801, vrr_stack+4373, vrr_stack+38141, vrr_stack+38735, vrr_stack+6439);
 _BUILD_f0n0(Data,vrr_stack+25256, vrr_stack+38999, vrr_stack+24860, vrr_stack+38273, vrr_stack+38801, vrr_stack+6604);
 _BUILD_g0n0(Data,vrr_stack+25916, vrr_stack+39791, vrr_stack+25256, vrr_stack+39395, vrr_stack+38999, vrr_stack+27086);
 _BUILD_g0n0(Data,vrr_stack+49251, vrr_stack+24200, vrr_stack+39791, vrr_stack+3977, vrr_stack+39395, vrr_stack+4844);
 _BUILD_h0n0(Data,vrr_stack+50241, vrr_stack+49251, vrr_stack+25916, vrr_stack+24200, vrr_stack+39791, vrr_stack+27636);
 _BUILD_00n0(Data,vrr_stack+6439, vrr_stack+2346, vrr_stack+2122, vrr_stack+968, vrr_stack+2481, NULL);
 _BUILD_p0n0(Data,vrr_stack+6505, vrr_stack+6439, vrr_stack+1682, NULL, NULL, vrr_stack+2122);
 _BUILD_d0n0(Data,vrr_stack+4571, vrr_stack+6505, vrr_stack+3779, vrr_stack+6439, vrr_stack+1682, vrr_stack+5394);
 _BUILD_f0n0(Data,vrr_stack+26906, vrr_stack+4571, vrr_stack+3977, vrr_stack+6505, vrr_stack+3779, vrr_stack+5559);
 _BUILD_g0n0(Data,vrr_stack+75917, vrr_stack+26906, vrr_stack+24200, vrr_stack+4571, vrr_stack+3977, vrr_stack+5889);
 _BUILD_h0n0(Data,vrr_stack+4967, vrr_stack+75917, vrr_stack+49251, vrr_stack+26906, vrr_stack+24200, vrr_stack+14227);
 _BUILD_00n0(Data,vrr_stack+14227, vrr_stack+2526, vrr_stack+2801, vrr_stack+824, vrr_stack+1013, NULL);
 _BUILD_p0n0(Data,vrr_stack+14293, vrr_stack+1748, vrr_stack+14227, NULL, NULL, vrr_stack+2526);
 _BUILD_d0n0(Data,vrr_stack+14491, vrr_stack+4373, vrr_stack+14293, vrr_stack+38735, vrr_stack+1748, vrr_stack+2581);
 _BUILD_f0n0(Data,vrr_stack+27566, vrr_stack+24860, vrr_stack+14491, vrr_stack+38801, vrr_stack+4373, vrr_stack+6934);
 _BUILD_g0n0(Data,vrr_stack+76907, vrr_stack+25256, vrr_stack+27566, vrr_stack+38999, vrr_stack+24860, vrr_stack+29616);
 _BUILD_h0n0(Data,vrr_stack+77897, vrr_stack+25916, vrr_stack+76907, vrr_stack+39791, vrr_stack+25256, vrr_stack+53697);
 _BUILD_i0n0(Data,vrr_stack+79283, vrr_stack+50241, vrr_stack+77897, vrr_stack+49251, vrr_stack+25916, vrr_stack+54522);
 _BUILD_i0n0(Data,vrr_stack+53697, vrr_stack+4967, vrr_stack+50241, vrr_stack+75917, vrr_stack+49251, vrr_stack+28461);
 _BUILD_k0n0(Data,vrr_stack+81131, vrr_stack+53697, vrr_stack+79283, vrr_stack+4967, vrr_stack+50241, vrr_stack+55677);
 _BUILD_00n0(Data,vrr_stack+55545, vrr_stack+2746, vrr_stack+2346, vrr_stack+1272, vrr_stack+968, NULL);
 _BUILD_p0n0(Data,vrr_stack+55611, vrr_stack+55545, vrr_stack+6439, NULL, NULL, vrr_stack+2346);
 _BUILD_d0n0(Data,vrr_stack+55809, vrr_stack+55611, vrr_stack+6505, vrr_stack+55545, vrr_stack+6439, vrr_stack+15052);
 _BUILD_f0n0(Data,vrr_stack+56205, vrr_stack+55809, vrr_stack+4571, vrr_stack+55611, vrr_stack+6505, vrr_stack+15217);
 _BUILD_g0n0(Data,vrr_stack+28226, vrr_stack+56205, vrr_stack+26906, vrr_stack+55809, vrr_stack+4571, vrr_stack+15547);
 _BUILD_h0n0(Data,vrr_stack+83507, vrr_stack+28226, vrr_stack+75917, vrr_stack+56205, vrr_stack+26906, vrr_stack+51717);
 _BUILD_i0n0(Data,vrr_stack+84893, vrr_stack+83507, vrr_stack+4967, vrr_stack+28226, vrr_stack+75917, vrr_stack+52542);
 _BUILD_k0n0(Data,vrr_stack+86741, vrr_stack+84893, vrr_stack+53697, vrr_stack+83507, vrr_stack+4967, vrr_stack+30166);
 _BUILD_00n0(Data,vrr_stack+56865, vrr_stack+2801, vrr_stack+19800, vrr_stack+1013, vrr_stack+3734, NULL);
 _BUILD_p0n0(Data,vrr_stack+56931, vrr_stack+14227, vrr_stack+56865, NULL, NULL, vrr_stack+2801);
 _BUILD_d0n0(Data,vrr_stack+14887, vrr_stack+14293, vrr_stack+56931, vrr_stack+1748, vrr_stack+14227, vrr_stack+2856);
 _BUILD_f0n0(Data,vrr_stack+15283, vrr_stack+14491, vrr_stack+14887, vrr_stack+4373, vrr_stack+14293, vrr_stack+7759);
 _BUILD_g0n0(Data,vrr_stack+29216, vrr_stack+27566, vrr_stack+15283, vrr_stack+24860, vrr_stack+14491, vrr_stack+16647);
 _BUILD_h0n0(Data,vrr_stack+30206, vrr_stack+76907, vrr_stack+29216, vrr_stack+25256, vrr_stack+27566, vrr_stack+33686);
 _BUILD_i0n0(Data,vrr_stack+51627, vrr_stack+77897, vrr_stack+30206, vrr_stack+25916, vrr_stack+76907, vrr_stack+34511);
 _BUILD_k0n0(Data,vrr_stack+89117, vrr_stack+79283, vrr_stack+51627, vrr_stack+50241, vrr_stack+77897, vrr_stack+62717);
 _BUILD_l0n0(Data,vrr_stack+91493, vrr_stack+81131, vrr_stack+89117, vrr_stack+53697, vrr_stack+79283, vrr_stack+64257);
 _BUILD_l0n0(Data,vrr_stack+62717, vrr_stack+86741, vrr_stack+81131, vrr_stack+84893, vrr_stack+53697, vrr_stack+57217);
 _BUILD_m0n0(Data,vrr_stack+94463, vrr_stack+62717, vrr_stack+91493, vrr_stack+86741, vrr_stack+81131, vrr_stack+17197);
 _BUILD_00n0(Data,vrr_stack+65687, vrr_stack+3057, vrr_stack+2746, vrr_stack+869, vrr_stack+1272, NULL);
 _BUILD_p0n0(Data,vrr_stack+65753, vrr_stack+65687, vrr_stack+55545, NULL, NULL, vrr_stack+2746);
 _BUILD_d0n0(Data,vrr_stack+33686, vrr_stack+65753, vrr_stack+55611, vrr_stack+65687, vrr_stack+55545, vrr_stack+7264);
 _BUILD_f0n0(Data,vrr_stack+34082, vrr_stack+33686, vrr_stack+55809, vrr_stack+65753, vrr_stack+55611, vrr_stack+7429);
 _BUILD_g0n0(Data,vrr_stack+16647, vrr_stack+34082, vrr_stack+56205, vrr_stack+33686, vrr_stack+55809, vrr_stack+16097);
 _BUILD_h0n0(Data,vrr_stack+6703, vrr_stack+16647, vrr_stack+28226, vrr_stack+34082, vrr_stack+56205, vrr_stack+31706);
 _BUILD_i0n0(Data,vrr_stack+33686, vrr_stack+6703, vrr_stack+83507, vrr_stack+16647, vrr_stack+28226, vrr_stack+32531);
 _BUILD_k0n0(Data,vrr_stack+15943, vrr_stack+33686, vrr_stack+84893, vrr_stack+6703, vrr_stack+83507, vrr_stack+59197);
 _BUILD_l0n0(Data,vrr_stack+57129, vrr_stack+15943, vrr_stack+86741, vrr_stack+33686, vrr_stack+84893, vrr_stack+60737);
   tmp = vrr_stack + 57129;
   target_ptr = Libint->vrr_classes[8][10];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0n0(Data,vrr_stack+31592, vrr_stack+57129, vrr_stack+62717, vrr_stack+15943, vrr_stack+86741, vrr_stack+35666);
   tmp = vrr_stack + 31592;
   target_ptr = Libint->vrr_classes[9][10];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+15943, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15946, vrr_stack+19672, vrr_stack+15943, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+15952, vrr_stack+19675, vrr_stack+15946, vrr_stack+1317, vrr_stack+19672, NULL);
 _BUILD_00g0(Data,vrr_stack+15962, vrr_stack+19681, vrr_stack+15952, vrr_stack+1320, vrr_stack+19675, NULL);
 _BUILD_00h0(Data,vrr_stack+15977, vrr_stack+19691, vrr_stack+15962, vrr_stack+1326, vrr_stack+19681, NULL);
 _BUILD_00i0(Data,vrr_stack+15998, vrr_stack+19706, vrr_stack+15977, vrr_stack+1336, vrr_stack+19691, NULL);
 _BUILD_00k0(Data,vrr_stack+16026, vrr_stack+19727, vrr_stack+15998, vrr_stack+0, vrr_stack+19706, NULL);
 _BUILD_00l0(Data,vrr_stack+0, vrr_stack+3021, vrr_stack+16026, vrr_stack+3670, vrr_stack+19727, NULL);
 _BUILD_00m0(Data,vrr_stack+45, vrr_stack+19755, vrr_stack+0, vrr_stack+3698, vrr_stack+3021, NULL);
 _BUILD_00n0(Data,vrr_stack+100, vrr_stack+19800, vrr_stack+45, vrr_stack+3734, vrr_stack+19755, NULL);
 _BUILD_p0n0(Data,vrr_stack+166, vrr_stack+56865, vrr_stack+100, NULL, NULL, vrr_stack+19800);
 _BUILD_d0n0(Data,vrr_stack+364, vrr_stack+56931, vrr_stack+166, vrr_stack+14227, vrr_stack+56865, vrr_stack+19855);
 _BUILD_f0n0(Data,vrr_stack+760, vrr_stack+14887, vrr_stack+364, vrr_stack+14293, vrr_stack+56931, vrr_stack+20020);
 _BUILD_g0n0(Data,vrr_stack+16062, vrr_stack+15283, vrr_stack+760, vrr_stack+14491, vrr_stack+14887, vrr_stack+20350);
 _BUILD_h0n0(Data,vrr_stack+6703, vrr_stack+29216, vrr_stack+16062, vrr_stack+27566, vrr_stack+15283, vrr_stack+20900);
 _BUILD_i0n0(Data,vrr_stack+19855, vrr_stack+30206, vrr_stack+6703, vrr_stack+76907, vrr_stack+29216, vrr_stack+8089);
 _BUILD_k0n0(Data,vrr_stack+17052, vrr_stack+51627, vrr_stack+19855, vrr_stack+77897, vrr_stack+30206, vrr_stack+9244);
 _BUILD_l0n0(Data,vrr_stack+8089, vrr_stack+89117, vrr_stack+17052, vrr_stack+79283, vrr_stack+51627, vrr_stack+40616);
 _BUILD_m0n0(Data,vrr_stack+98093, vrr_stack+91493, vrr_stack+8089, vrr_stack+81131, vrr_stack+89117, vrr_stack+21725);
 _BUILD_n0n0(Data,vrr_stack+101723, vrr_stack+94463, vrr_stack+98093, vrr_stack+62717, vrr_stack+91493, vrr_stack+42596);
 _BUILD_n0n0(Data,vrr_stack+40451, vrr_stack+31592, vrr_stack+94463, vrr_stack+57129, vrr_stack+62717, vrr_stack+66237);
   tmp = vrr_stack + 40451;
   target_ptr = Libint->vrr_classes[10][10];
   for(i=0;i<4356;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+57129, vrr_stack+38141, vrr_stack+38735, vrr_stack+1572, vrr_stack+1902, NULL);
 _BUILD_00o0(Data,vrr_stack+57207, vrr_stack+38207, vrr_stack+38141, vrr_stack+1627, vrr_stack+1572, NULL);
 _BUILD_p0o0(Data,vrr_stack+57285, vrr_stack+57207, vrr_stack+57129, NULL, NULL, vrr_stack+38141);
 _BUILD_00o0(Data,vrr_stack+57519, vrr_stack+38471, vrr_stack+38207, vrr_stack+1847, vrr_stack+1627, NULL);
 _BUILD_p0o0(Data,vrr_stack+57597, vrr_stack+57519, vrr_stack+57207, NULL, NULL, vrr_stack+38207);
 _BUILD_00o0(Data,vrr_stack+57831, vrr_stack+38735, vrr_stack+1748, vrr_stack+1902, vrr_stack+2177, NULL);
 _BUILD_p0o0(Data,vrr_stack+57909, vrr_stack+57129, vrr_stack+57831, NULL, NULL, vrr_stack+38735);
 _BUILD_d0o0(Data,vrr_stack+58143, vrr_stack+57285, vrr_stack+57909, vrr_stack+57207, vrr_stack+57129, vrr_stack+38801);
 _BUILD_d0o0(Data,vrr_stack+58611, vrr_stack+57597, vrr_stack+57285, vrr_stack+57519, vrr_stack+57207, vrr_stack+38273);
 _BUILD_f0o0(Data,vrr_stack+59079, vrr_stack+58611, vrr_stack+58143, vrr_stack+57597, vrr_stack+57285, vrr_stack+38999);
 _BUILD_00o0(Data,vrr_stack+38273, vrr_stack+1682, vrr_stack+38471, vrr_stack+2122, vrr_stack+1847, NULL);
 _BUILD_p0o0(Data,vrr_stack+38801, vrr_stack+38273, vrr_stack+57519, NULL, NULL, vrr_stack+38471);
 _BUILD_d0o0(Data,vrr_stack+59859, vrr_stack+38801, vrr_stack+57597, vrr_stack+38273, vrr_stack+57519, vrr_stack+38537);
 _BUILD_f0o0(Data,vrr_stack+60327, vrr_stack+59859, vrr_stack+58611, vrr_stack+38801, vrr_stack+57597, vrr_stack+39395);
 _BUILD_00o0(Data,vrr_stack+38537, vrr_stack+1748, vrr_stack+14227, vrr_stack+2177, vrr_stack+2526, NULL);
 _BUILD_p0o0(Data,vrr_stack+39035, vrr_stack+57831, vrr_stack+38537, NULL, NULL, vrr_stack+1748);
 _BUILD_d0o0(Data,vrr_stack+39269, vrr_stack+57909, vrr_stack+39035, vrr_stack+57129, vrr_stack+57831, vrr_stack+4373);
 _BUILD_f0o0(Data,vrr_stack+61107, vrr_stack+58143, vrr_stack+39269, vrr_stack+57285, vrr_stack+57909, vrr_stack+24860);
 _BUILD_g0o0(Data,vrr_stack+21703, vrr_stack+59079, vrr_stack+61107, vrr_stack+58611, vrr_stack+58143, vrr_stack+25256);
 _BUILD_g0o0(Data,vrr_stack+22873, vrr_stack+60327, vrr_stack+59079, vrr_stack+59859, vrr_stack+58611, vrr_stack+39791);
 _BUILD_h0o0(Data,vrr_stack+35222, vrr_stack+22873, vrr_stack+21703, vrr_stack+60327, vrr_stack+59079, vrr_stack+25916);
 _BUILD_00o0(Data,vrr_stack+24860, vrr_stack+6439, vrr_stack+1682, vrr_stack+2346, vrr_stack+2122, NULL);
 _BUILD_p0o0(Data,vrr_stack+24938, vrr_stack+24860, vrr_stack+38273, NULL, NULL, vrr_stack+1682);
 _BUILD_d0o0(Data,vrr_stack+25172, vrr_stack+24938, vrr_stack+38801, vrr_stack+24860, vrr_stack+38273, vrr_stack+3779);
 _BUILD_f0o0(Data,vrr_stack+25640, vrr_stack+25172, vrr_stack+59859, vrr_stack+24938, vrr_stack+38801, vrr_stack+3977);
 _BUILD_g0o0(Data,vrr_stack+36860, vrr_stack+25640, vrr_stack+60327, vrr_stack+25172, vrr_stack+59859, vrr_stack+24200);
 _BUILD_h0o0(Data,vrr_stack+106079, vrr_stack+36860, vrr_stack+22873, vrr_stack+25640, vrr_stack+60327, vrr_stack+49251);
 _BUILD_00o0(Data,vrr_stack+49251, vrr_stack+14227, vrr_stack+56865, vrr_stack+2526, vrr_stack+2801, NULL);
 _BUILD_p0o0(Data,vrr_stack+49329, vrr_stack+38537, vrr_stack+49251, NULL, NULL, vrr_stack+14227);
 _BUILD_d0o0(Data,vrr_stack+49563, vrr_stack+39035, vrr_stack+49329, vrr_stack+57831, vrr_stack+38537, vrr_stack+14293);
 _BUILD_f0o0(Data,vrr_stack+61887, vrr_stack+39269, vrr_stack+49563, vrr_stack+57909, vrr_stack+39035, vrr_stack+14491);
 _BUILD_g0o0(Data,vrr_stack+3112, vrr_stack+61107, vrr_stack+61887, vrr_stack+58143, vrr_stack+39269, vrr_stack+27566);
 _BUILD_h0o0(Data,vrr_stack+107717, vrr_stack+21703, vrr_stack+3112, vrr_stack+59079, vrr_stack+61107, vrr_stack+76907);
 _BUILD_i0o0(Data,vrr_stack+109355, vrr_stack+35222, vrr_stack+107717, vrr_stack+22873, vrr_stack+21703, vrr_stack+77897);
 _BUILD_i0o0(Data,vrr_stack+76907, vrr_stack+106079, vrr_stack+35222, vrr_stack+36860, vrr_stack+22873, vrr_stack+50241);
 _BUILD_k0o0(Data,vrr_stack+111539, vrr_stack+76907, vrr_stack+109355, vrr_stack+106079, vrr_stack+35222, vrr_stack+79283);
 _BUILD_00o0(Data,vrr_stack+79091, vrr_stack+55545, vrr_stack+6439, vrr_stack+2746, vrr_stack+2346, NULL);
 _BUILD_p0o0(Data,vrr_stack+79169, vrr_stack+79091, vrr_stack+24860, NULL, NULL, vrr_stack+6439);
 _BUILD_d0o0(Data,vrr_stack+79403, vrr_stack+79169, vrr_stack+24938, vrr_stack+79091, vrr_stack+24860, vrr_stack+6505);
 _BUILD_f0o0(Data,vrr_stack+79871, vrr_stack+79403, vrr_stack+25172, vrr_stack+79169, vrr_stack+24938, vrr_stack+4571);
 _BUILD_g0o0(Data,vrr_stack+50031, vrr_stack+79871, vrr_stack+25640, vrr_stack+79403, vrr_stack+25172, vrr_stack+26906);
 _BUILD_h0o0(Data,vrr_stack+26420, vrr_stack+50031, vrr_stack+36860, vrr_stack+79871, vrr_stack+25640, vrr_stack+75917);
 _BUILD_i0o0(Data,vrr_stack+114347, vrr_stack+26420, vrr_stack+106079, vrr_stack+50031, vrr_stack+36860, vrr_stack+4967);
 _BUILD_k0o0(Data,vrr_stack+116531, vrr_stack+114347, vrr_stack+76907, vrr_stack+26420, vrr_stack+106079, vrr_stack+53697);
 _BUILD_00o0(Data,vrr_stack+75917, vrr_stack+56865, vrr_stack+100, vrr_stack+2801, vrr_stack+19800, NULL);
 _BUILD_p0o0(Data,vrr_stack+75995, vrr_stack+49251, vrr_stack+75917, NULL, NULL, vrr_stack+56865);
 _BUILD_d0o0(Data,vrr_stack+76229, vrr_stack+49329, vrr_stack+75995, vrr_stack+38537, vrr_stack+49251, vrr_stack+56931);
 _BUILD_f0o0(Data,vrr_stack+24043, vrr_stack+49563, vrr_stack+76229, vrr_stack+39035, vrr_stack+49329, vrr_stack+14887);
 _BUILD_g0o0(Data,vrr_stack+53475, vrr_stack+61887, vrr_stack+24043, vrr_stack+39269, vrr_stack+49563, vrr_stack+15283);
 _BUILD_h0o0(Data,vrr_stack+14293, vrr_stack+3112, vrr_stack+53475, vrr_stack+61107, vrr_stack+61887, vrr_stack+29216);
 _BUILD_i0o0(Data,vrr_stack+119339, vrr_stack+107717, vrr_stack+14293, vrr_stack+21703, vrr_stack+3112, vrr_stack+30206);
 _BUILD_k0o0(Data,vrr_stack+121523, vrr_stack+109355, vrr_stack+119339, vrr_stack+35222, vrr_stack+107717, vrr_stack+51627);
 _BUILD_l0o0(Data,vrr_stack+124331, vrr_stack+111539, vrr_stack+121523, vrr_stack+76907, vrr_stack+109355, vrr_stack+89117);
 _BUILD_l0o0(Data,vrr_stack+127841, vrr_stack+116531, vrr_stack+111539, vrr_stack+114347, vrr_stack+76907, vrr_stack+81131);
 _BUILD_m0o0(Data,vrr_stack+131351, vrr_stack+127841, vrr_stack+124331, vrr_stack+116531, vrr_stack+111539, vrr_stack+91493);
 _BUILD_00o0(Data,vrr_stack+89117, vrr_stack+65687, vrr_stack+55545, vrr_stack+3057, vrr_stack+2746, NULL);
 _BUILD_p0o0(Data,vrr_stack+89195, vrr_stack+89117, vrr_stack+79091, NULL, NULL, vrr_stack+55545);
 _BUILD_d0o0(Data,vrr_stack+89429, vrr_stack+89195, vrr_stack+79169, vrr_stack+89117, vrr_stack+79091, vrr_stack+55611);
 _BUILD_f0o0(Data,vrr_stack+89897, vrr_stack+89429, vrr_stack+79403, vrr_stack+89195, vrr_stack+79169, vrr_stack+55809);
 _BUILD_g0o0(Data,vrr_stack+90677, vrr_stack+89897, vrr_stack+79871, vrr_stack+89429, vrr_stack+79403, vrr_stack+56205);
 _BUILD_h0o0(Data,vrr_stack+91847, vrr_stack+90677, vrr_stack+50031, vrr_stack+89897, vrr_stack+79871, vrr_stack+28226);
 _BUILD_i0o0(Data,vrr_stack+80651, vrr_stack+91847, vrr_stack+26420, vrr_stack+90677, vrr_stack+50031, vrr_stack+83507);
 _BUILD_k0o0(Data,vrr_stack+28058, vrr_stack+80651, vrr_stack+114347, vrr_stack+91847, vrr_stack+26420, vrr_stack+84893);
 _BUILD_l0o0(Data,vrr_stack+89195, vrr_stack+28058, vrr_stack+116531, vrr_stack+80651, vrr_stack+114347, vrr_stack+86741);
   tmp = vrr_stack + 89195;
   target_ptr = Libint->vrr_classes[8][11];
   for(i=0;i<3510;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0o0(Data,vrr_stack+80651, vrr_stack+89195, vrr_stack+127841, vrr_stack+28058, vrr_stack+116531, vrr_stack+62717);
   tmp = vrr_stack + 80651;
   target_ptr = Libint->vrr_classes[9][11];
   for(i=0;i<4290;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+28058, Data->F+21, Data->F+22, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+28061, vrr_stack+15943, vrr_stack+28058, Data->F+20, Data->F+21, NULL);
 _BUILD_00f0(Data,vrr_stack+28067, vrr_stack+15946, vrr_stack+28061, vrr_stack+19672, vrr_stack+15943, NULL);
 _BUILD_00g0(Data,vrr_stack+28077, vrr_stack+15952, vrr_stack+28067, vrr_stack+19675, vrr_stack+15946, NULL);
 _BUILD_00h0(Data,vrr_stack+28092, vrr_stack+15962, vrr_stack+28077, vrr_stack+19681, vrr_stack+15952, NULL);
 _BUILD_00i0(Data,vrr_stack+28113, vrr_stack+15977, vrr_stack+28092, vrr_stack+19691, vrr_stack+15962, NULL);
 _BUILD_00k0(Data,vrr_stack+28141, vrr_stack+15998, vrr_stack+28113, vrr_stack+19706, vrr_stack+15977, NULL);
 _BUILD_00l0(Data,vrr_stack+28177, vrr_stack+16026, vrr_stack+28141, vrr_stack+19727, vrr_stack+15998, NULL);
 _BUILD_00m0(Data,vrr_stack+3057, vrr_stack+0, vrr_stack+28177, vrr_stack+3021, vrr_stack+16026, NULL);
 _BUILD_00n0(Data,vrr_stack+28222, vrr_stack+45, vrr_stack+3057, vrr_stack+19755, vrr_stack+0, NULL);
 _BUILD_00o0(Data,vrr_stack+28288, vrr_stack+100, vrr_stack+28222, vrr_stack+19800, vrr_stack+45, NULL);
 _BUILD_p0o0(Data,vrr_stack+28366, vrr_stack+75917, vrr_stack+28288, NULL, NULL, vrr_stack+100);
 _BUILD_d0o0(Data,vrr_stack+28600, vrr_stack+75995, vrr_stack+28366, vrr_stack+49251, vrr_stack+75917, vrr_stack+166);
 _BUILD_f0o0(Data,vrr_stack+29068, vrr_stack+76229, vrr_stack+28600, vrr_stack+49329, vrr_stack+75995, vrr_stack+364);
 _BUILD_g0o0(Data,vrr_stack+29848, vrr_stack+24043, vrr_stack+29068, vrr_stack+49563, vrr_stack+76229, vrr_stack+760);
 _BUILD_h0o0(Data,vrr_stack+84941, vrr_stack+53475, vrr_stack+29848, vrr_stack+61887, vrr_stack+24043, vrr_stack+16062);
 _BUILD_i0o0(Data,vrr_stack+86579, vrr_stack+14293, vrr_stack+84941, vrr_stack+3112, vrr_stack+53475, vrr_stack+6703);
 _BUILD_k0o0(Data,vrr_stack+62667, vrr_stack+119339, vrr_stack+86579, vrr_stack+107717, vrr_stack+14293, vrr_stack+19855);
 _BUILD_l0o0(Data,vrr_stack+135641, vrr_stack+121523, vrr_stack+62667, vrr_stack+109355, vrr_stack+119339, vrr_stack+17052);
 _BUILD_m0o0(Data,vrr_stack+16062, vrr_stack+124331, vrr_stack+135641, vrr_stack+111539, vrr_stack+121523, vrr_stack+8089);
 _BUILD_n0o0(Data,vrr_stack+139151, vrr_stack+131351, vrr_stack+16062, vrr_stack+127841, vrr_stack+124331, vrr_stack+98093);
 _BUILD_n0o0(Data,vrr_stack+144299, vrr_stack+80651, vrr_stack+131351, vrr_stack+89195, vrr_stack+127841, vrr_stack+94463);
   tmp = vrr_stack + 144299;
   target_ptr = Libint->vrr_classes[10][11];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+89195, vrr_stack+57129, vrr_stack+57831, vrr_stack+38141, vrr_stack+38735, NULL);
 _BUILD_00q0(Data,vrr_stack+89286, vrr_stack+57207, vrr_stack+57129, vrr_stack+38207, vrr_stack+38141, NULL);
 _BUILD_p0q0(Data,vrr_stack+89377, vrr_stack+89286, vrr_stack+89195, NULL, NULL, vrr_stack+57129);
 _BUILD_00q0(Data,vrr_stack+89650, vrr_stack+57519, vrr_stack+57207, vrr_stack+38471, vrr_stack+38207, NULL);
 _BUILD_p0q0(Data,vrr_stack+89741, vrr_stack+89650, vrr_stack+89286, NULL, NULL, vrr_stack+57207);
 _BUILD_00q0(Data,vrr_stack+90014, vrr_stack+57831, vrr_stack+38537, vrr_stack+38735, vrr_stack+1748, NULL);
 _BUILD_p0q0(Data,vrr_stack+90105, vrr_stack+89195, vrr_stack+90014, NULL, NULL, vrr_stack+57831);
 _BUILD_d0q0(Data,vrr_stack+90378, vrr_stack+89377, vrr_stack+90105, vrr_stack+89286, vrr_stack+89195, vrr_stack+57909);
 _BUILD_d0q0(Data,vrr_stack+90924, vrr_stack+89741, vrr_stack+89377, vrr_stack+89650, vrr_stack+89286, vrr_stack+57285);
 _BUILD_f0q0(Data,vrr_stack+91470, vrr_stack+90924, vrr_stack+90378, vrr_stack+89741, vrr_stack+89377, vrr_stack+58143);
 _BUILD_00q0(Data,vrr_stack+89286, vrr_stack+38273, vrr_stack+57519, vrr_stack+1682, vrr_stack+38471, NULL);
 _BUILD_p0q0(Data,vrr_stack+57831, vrr_stack+89286, vrr_stack+89650, NULL, NULL, vrr_stack+57519);
 _BUILD_d0q0(Data,vrr_stack+92380, vrr_stack+57831, vrr_stack+89741, vrr_stack+89286, vrr_stack+89650, vrr_stack+57597);
 _BUILD_f0q0(Data,vrr_stack+92926, vrr_stack+92380, vrr_stack+90924, vrr_stack+57831, vrr_stack+89741, vrr_stack+58611);
 _BUILD_00q0(Data,vrr_stack+89650, vrr_stack+38537, vrr_stack+49251, vrr_stack+1748, vrr_stack+14227, NULL);
 _BUILD_p0q0(Data,vrr_stack+89741, vrr_stack+90014, vrr_stack+89650, NULL, NULL, vrr_stack+38537);
 _BUILD_d0q0(Data,vrr_stack+1748, vrr_stack+90105, vrr_stack+89741, vrr_stack+89195, vrr_stack+90014, vrr_stack+39035);
 _BUILD_f0q0(Data,vrr_stack+58104, vrr_stack+90378, vrr_stack+1748, vrr_stack+89377, vrr_stack+90105, vrr_stack+39269);
 _BUILD_g0q0(Data,vrr_stack+39035, vrr_stack+91470, vrr_stack+58104, vrr_stack+90924, vrr_stack+90378, vrr_stack+61107);
 _BUILD_g0q0(Data,vrr_stack+98093, vrr_stack+92926, vrr_stack+91470, vrr_stack+92380, vrr_stack+90924, vrr_stack+59079);
 _BUILD_h0q0(Data,vrr_stack+99458, vrr_stack+98093, vrr_stack+39035, vrr_stack+92926, vrr_stack+91470, vrr_stack+21703);
 _BUILD_00q0(Data,vrr_stack+89195, vrr_stack+24860, vrr_stack+38273, vrr_stack+6439, vrr_stack+1682, NULL);
 _BUILD_p0q0(Data,vrr_stack+89377, vrr_stack+89195, vrr_stack+89286, NULL, NULL, vrr_stack+38273);
 _BUILD_d0q0(Data,vrr_stack+90924, vrr_stack+89377, vrr_stack+57831, vrr_stack+89195, vrr_stack+89286, vrr_stack+38801);
 _BUILD_f0q0(Data,vrr_stack+20352, vrr_stack+90924, vrr_stack+92380, vrr_stack+89377, vrr_stack+57831, vrr_stack+59859);
 _BUILD_g0q0(Data,vrr_stack+21262, vrr_stack+20352, vrr_stack+92926, vrr_stack+90924, vrr_stack+92380, vrr_stack+60327);
 _BUILD_h0q0(Data,vrr_stack+59014, vrr_stack+21262, vrr_stack+98093, vrr_stack+20352, vrr_stack+92926, vrr_stack+22873);
 _BUILD_00q0(Data,vrr_stack+89286, vrr_stack+49251, vrr_stack+75917, vrr_stack+14227, vrr_stack+56865, NULL);
 _BUILD_p0q0(Data,vrr_stack+92380, vrr_stack+89650, vrr_stack+89286, NULL, NULL, vrr_stack+49251);
 _BUILD_d0q0(Data,vrr_stack+92653, vrr_stack+89741, vrr_stack+92380, vrr_stack+90014, vrr_stack+89650, vrr_stack+49329);
 _BUILD_f0q0(Data,vrr_stack+93199, vrr_stack+1748, vrr_stack+92653, vrr_stack+90105, vrr_stack+89741, vrr_stack+49563);
 _BUILD_g0q0(Data,vrr_stack+22627, vrr_stack+58104, vrr_stack+93199, vrr_stack+90378, vrr_stack+1748, vrr_stack+61887);
 _BUILD_h0q0(Data,vrr_stack+6505, vrr_stack+39035, vrr_stack+22627, vrr_stack+91470, vrr_stack+58104, vrr_stack+3112);
 _BUILD_i0q0(Data,vrr_stack+3112, vrr_stack+99458, vrr_stack+6505, vrr_stack+98093, vrr_stack+39035, vrr_stack+107717);
 _BUILD_i0q0(Data,vrr_stack+8416, vrr_stack+59014, vrr_stack+99458, vrr_stack+21262, vrr_stack+98093, vrr_stack+35222);
 _BUILD_k0q0(Data,vrr_stack+149447, vrr_stack+8416, vrr_stack+3112, vrr_stack+59014, vrr_stack+99458, vrr_stack+109355);
 _BUILD_00q0(Data,vrr_stack+35222, vrr_stack+79091, vrr_stack+24860, vrr_stack+55545, vrr_stack+6439, NULL);
 _BUILD_p0q0(Data,vrr_stack+35313, vrr_stack+35222, vrr_stack+89195, NULL, NULL, vrr_stack+24860);
 _BUILD_d0q0(Data,vrr_stack+35586, vrr_stack+35313, vrr_stack+89377, vrr_stack+35222, vrr_stack+89195, vrr_stack+24938);
 _BUILD_f0q0(Data,vrr_stack+91470, vrr_stack+35586, vrr_stack+90924, vrr_stack+35313, vrr_stack+89377, vrr_stack+25172);
 _BUILD_g0q0(Data,vrr_stack+98093, vrr_stack+91470, vrr_stack+20352, vrr_stack+35586, vrr_stack+90924, vrr_stack+25640);
 _BUILD_h0q0(Data,vrr_stack+107717, vrr_stack+98093, vrr_stack+21262, vrr_stack+91470, vrr_stack+20352, vrr_stack+36860);
 _BUILD_i0q0(Data,vrr_stack+36132, vrr_stack+107717, vrr_stack+59014, vrr_stack+98093, vrr_stack+21262, vrr_stack+106079);
 _BUILD_k0q0(Data,vrr_stack+152723, vrr_stack+36132, vrr_stack+8416, vrr_stack+107717, vrr_stack+59014, vrr_stack+76907);
 _BUILD_00q0(Data,vrr_stack+89195, vrr_stack+75917, vrr_stack+28288, vrr_stack+56865, vrr_stack+100, NULL);
 _BUILD_p0q0(Data,vrr_stack+89377, vrr_stack+89286, vrr_stack+89195, NULL, NULL, vrr_stack+75917);
 _BUILD_d0q0(Data,vrr_stack+59014, vrr_stack+92380, vrr_stack+89377, vrr_stack+89650, vrr_stack+89286, vrr_stack+75995);
 _BUILD_f0q0(Data,vrr_stack+59560, vrr_stack+92653, vrr_stack+59014, vrr_stack+89741, vrr_stack+92380, vrr_stack+76229);
 _BUILD_g0q0(Data,vrr_stack+89650, vrr_stack+93199, vrr_stack+59560, vrr_stack+1748, vrr_stack+92653, vrr_stack+24043);
 _BUILD_h0q0(Data,vrr_stack+109628, vrr_stack+22627, vrr_stack+89650, vrr_stack+58104, vrr_stack+93199, vrr_stack+53475);
 _BUILD_i0q0(Data,vrr_stack+75917, vrr_stack+6505, vrr_stack+109628, vrr_stack+39035, vrr_stack+22627, vrr_stack+14293);
 _BUILD_k0q0(Data,vrr_stack+55611, vrr_stack+3112, vrr_stack+75917, vrr_stack+99458, vrr_stack+6505, vrr_stack+119339);
 _BUILD_l0q0(Data,vrr_stack+51201, vrr_stack+149447, vrr_stack+55611, vrr_stack+8416, vrr_stack+3112, vrr_stack+121523);
 _BUILD_l0q0(Data,vrr_stack+119339, vrr_stack+152723, vrr_stack+149447, vrr_stack+36132, vrr_stack+8416, vrr_stack+111539);
 _BUILD_m0q0(Data,vrr_stack+155999, vrr_stack+119339, vrr_stack+51201, vrr_stack+152723, vrr_stack+149447, vrr_stack+124331);
 _BUILD_00q0(Data,vrr_stack+111539, vrr_stack+89117, vrr_stack+79091, vrr_stack+65687, vrr_stack+55545, NULL);
 _BUILD_p0q0(Data,vrr_stack+111630, vrr_stack+111539, vrr_stack+35222, NULL, NULL, vrr_stack+79091);
 _BUILD_d0q0(Data,vrr_stack+111903, vrr_stack+111630, vrr_stack+35313, vrr_stack+111539, vrr_stack+35222, vrr_stack+79169);
 _BUILD_f0q0(Data,vrr_stack+112449, vrr_stack+111903, vrr_stack+35586, vrr_stack+111630, vrr_stack+35313, vrr_stack+79403);
 _BUILD_g0q0(Data,vrr_stack+8416, vrr_stack+112449, vrr_stack+91470, vrr_stack+111903, vrr_stack+35586, vrr_stack+79871);
 _BUILD_h0q0(Data,vrr_stack+123434, vrr_stack+8416, vrr_stack+98093, vrr_stack+112449, vrr_stack+91470, vrr_stack+50031);
 _BUILD_i0q0(Data,vrr_stack+111539, vrr_stack+123434, vrr_stack+107717, vrr_stack+8416, vrr_stack+98093, vrr_stack+26420);
 _BUILD_k0q0(Data,vrr_stack+98093, vrr_stack+111539, vrr_stack+36132, vrr_stack+123434, vrr_stack+107717, vrr_stack+114347);
 _BUILD_l0q0(Data,vrr_stack+123434, vrr_stack+98093, vrr_stack+152723, vrr_stack+111539, vrr_stack+36132, vrr_stack+116531);
   tmp = vrr_stack + 123434;
   target_ptr = Libint->vrr_classes[8][12];
   for(i=0;i<4095;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0q0(Data,vrr_stack+111539, vrr_stack+123434, vrr_stack+119339, vrr_stack+98093, vrr_stack+152723, vrr_stack+127841);
   tmp = vrr_stack + 111539;
   target_ptr = Libint->vrr_classes[9][12];
   for(i=0;i<5005;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+152723, Data->F+22, Data->F+23, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+152726, vrr_stack+28058, vrr_stack+152723, Data->F+21, Data->F+22, NULL);
 _BUILD_00f0(Data,vrr_stack+152732, vrr_stack+28061, vrr_stack+152726, vrr_stack+15943, vrr_stack+28058, NULL);
 _BUILD_00g0(Data,vrr_stack+152742, vrr_stack+28067, vrr_stack+152732, vrr_stack+15946, vrr_stack+28061, NULL);
 _BUILD_00h0(Data,vrr_stack+152757, vrr_stack+28077, vrr_stack+152742, vrr_stack+15952, vrr_stack+28067, NULL);
 _BUILD_00i0(Data,vrr_stack+152723, vrr_stack+28092, vrr_stack+152757, vrr_stack+15962, vrr_stack+28077, NULL);
 _BUILD_00k0(Data,vrr_stack+152751, vrr_stack+28113, vrr_stack+152723, vrr_stack+15977, vrr_stack+28092, NULL);
 _BUILD_00l0(Data,vrr_stack+152787, vrr_stack+28141, vrr_stack+152751, vrr_stack+15998, vrr_stack+28113, NULL);
 _BUILD_00m0(Data,vrr_stack+152723, vrr_stack+28177, vrr_stack+152787, vrr_stack+16026, vrr_stack+28141, NULL);
 _BUILD_00n0(Data,vrr_stack+152778, vrr_stack+3057, vrr_stack+152723, vrr_stack+0, vrr_stack+28177, NULL);
 _BUILD_00o0(Data,vrr_stack+152844, vrr_stack+28222, vrr_stack+152778, vrr_stack+45, vrr_stack+3057, NULL);
 _BUILD_00q0(Data,vrr_stack+0, vrr_stack+28288, vrr_stack+152844, vrr_stack+100, vrr_stack+28222, NULL);
 _BUILD_p0q0(Data,vrr_stack+91, vrr_stack+89195, vrr_stack+0, NULL, NULL, vrr_stack+28288);
 _BUILD_d0q0(Data,vrr_stack+364, vrr_stack+89377, vrr_stack+91, vrr_stack+89286, vrr_stack+89195, vrr_stack+28366);
 _BUILD_f0q0(Data,vrr_stack+910, vrr_stack+59014, vrr_stack+364, vrr_stack+92380, vrr_stack+89377, vrr_stack+28600);
 _BUILD_g0q0(Data,vrr_stack+152723, vrr_stack+59560, vrr_stack+910, vrr_stack+92653, vrr_stack+59014, vrr_stack+29068);
 _BUILD_h0q0(Data,vrr_stack+154088, vrr_stack+89650, vrr_stack+152723, vrr_stack+93199, vrr_stack+59560, vrr_stack+29848);
 _BUILD_i0q0(Data,vrr_stack+0, vrr_stack+109628, vrr_stack+154088, vrr_stack+22627, vrr_stack+89650, vrr_stack+84941);
 _BUILD_k0q0(Data,vrr_stack+152723, vrr_stack+75917, vrr_stack+0, vrr_stack+6505, vrr_stack+109628, vrr_stack+86579);
 _BUILD_l0q0(Data,vrr_stack+84941, vrr_stack+55611, vrr_stack+152723, vrr_stack+3112, vrr_stack+75917, vrr_stack+62667);
 _BUILD_m0q0(Data,vrr_stack+0, vrr_stack+51201, vrr_stack+84941, vrr_stack+149447, vrr_stack+55611, vrr_stack+135641);
 _BUILD_n0q0(Data,vrr_stack+149447, vrr_stack+155999, vrr_stack+0, vrr_stack+119339, vrr_stack+51201, vrr_stack+16062);
 _BUILD_n0q0(Data,vrr_stack+0, vrr_stack+111539, vrr_stack+155999, vrr_stack+123434, vrr_stack+119339, vrr_stack+131351);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[10][12];
   for(i=0;i<6006;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0m0(Data,vrr_stack+6006, vrr_stack+45621, vrr_stack+72287, vrr_stack+69262, vrr_stack+66237, vrr_stack+11257);
   tmp = vrr_stack + 6006;
   target_ptr = Libint->vrr_classes[11][9];
   for(i=0;i<4290;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0n0(Data,vrr_stack+10296, vrr_stack+40451, vrr_stack+101723, vrr_stack+31592, vrr_stack+94463, vrr_stack+72287);
   tmp = vrr_stack + 10296;
   target_ptr = Libint->vrr_classes[11][10];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0o0(Data,vrr_stack+15444, vrr_stack+144299, vrr_stack+139151, vrr_stack+80651, vrr_stack+131351, vrr_stack+101723);
   tmp = vrr_stack + 15444;
   target_ptr = Libint->vrr_classes[11][11];
   for(i=0;i<6084;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0q0(Data,vrr_stack+21528, vrr_stack+0, vrr_stack+149447, vrr_stack+111539, vrr_stack+155999, vrr_stack+139151);
   tmp = vrr_stack + 21528;
   target_ptr = Libint->vrr_classes[11][12];
   for(i=0;i<7098;i++)
     target_ptr[i] += tmp[i];

}

