/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_p0hp(Libr12_t *, prim_data *);

  /* Computes (p0|hp) integrals for linear R12-methods */

void hrr_grt_order_p0hp(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->gvrr_classes[2][5] = int_stack + 0;
 Libr12->t2vrr_classes[1][5] = int_stack + 126;
 Libr12->t2vrr_classes[1][6] = int_stack + 189;
 Libr12->t1vrr_classes[1][5] = int_stack + 273;
 Libr12->t1vrr_classes[1][6] = int_stack + 336;
 Libr12->rvrr_classes[1][5] = int_stack + 420;
 Libr12->rvrr_classes[1][6] = int_stack + 483;
 Libr12->gvrr_classes[1][5] = int_stack + 567;
 Libr12->gvrr_classes[1][6] = int_stack + 630;
 memset(int_stack,0,714*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 714;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_p0hp(Libr12, Data);
   Data++;
 }

 /*--- compute (p0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+714, int_stack+189, int_stack+126, int_stack+630, int_stack+0, int_stack+567, 1, 0);
     Libr12->te_ptr[3] = int_stack + 714;
 /*--- compute (p0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+336, int_stack+273, 3);
     Libr12->te_ptr[2] = int_stack + 0;
 /*--- compute (p0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+189, int_stack+483, int_stack+420, 3);
     Libr12->te_ptr[1] = int_stack + 189;
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+378, int_stack+630, int_stack+567, 3);
     Libr12->te_ptr[0] = int_stack + 378;

}
