/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ds||fs) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _r_build_d0f0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE oneo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (oneo2z)*I1[0] - (oneo4zn)*I4[0] - (threeo4zn)*I5[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1]
        + (oneo2z)*I1[1] - (oneo4zn)*I4[1] - (twoo4zn)*I5[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2]
        + (oneo2z)*I1[2] - (oneo4zn)*I4[2] - (twoo4zn)*I5[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3]
        + (oneo2z)*I1[3] - (oneo4zn)*I4[3] - (oneo4zn)*I5[3];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4]
        + (oneo2z)*I1[4] - (oneo4zn)*I4[4] - (oneo4zn)*I5[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5]
        + (oneo2z)*I1[5] - (oneo4zn)*I4[5] - (oneo4zn)*I5[5];
*(vp++) = U00*I0[6] - U10*I3[6] + loo2p*I2[6]
        + (oneo2z)*I1[6] - (oneo4zn)*I4[6];
*(vp++) = U00*I0[7] - U10*I3[7] + loo2p*I2[7]
        + (oneo2z)*I1[7] - (oneo4zn)*I4[7];
*(vp++) = U00*I0[8] - U10*I3[8] + loo2p*I2[8]
        + (oneo2z)*I1[8] - (oneo4zn)*I4[8];
*(vp++) = U00*I0[9] - U10*I3[9] + loo2p*I2[9]
        + (oneo2z)*I1[9] - (oneo4zn)*I4[9];
*(vp++) = U00*I0[10] - U10*I3[10] + loo2p*I2[10] - (threeo4zn)*I5[6];
*(vp++) = U00*I0[11] - U10*I3[11] + loo2p*I2[11] - (twoo4zn)*I5[7];
*(vp++) = U00*I0[12] - U10*I3[12] + loo2p*I2[12] - (twoo4zn)*I5[8];
*(vp++) = U00*I0[13] - U10*I3[13] + loo2p*I2[13] - (oneo4zn)*I5[9];
*(vp++) = U00*I0[14] - U10*I3[14] + loo2p*I2[14] - (oneo4zn)*I5[10];
*(vp++) = U00*I0[15] - U10*I3[15] + loo2p*I2[15] - (oneo4zn)*I5[11];
*(vp++) = U00*I0[16] - U10*I3[16] + loo2p*I2[16];
*(vp++) = U00*I0[17] - U10*I3[17] + loo2p*I2[17];
*(vp++) = U00*I0[18] - U10*I3[18] + loo2p*I2[18];
*(vp++) = U00*I0[19] - U10*I3[19] + loo2p*I2[19];
*(vp++) = U00*I0[20] - U10*I3[20] + loo2p*I2[20] - (threeo4zn)*I5[12];
*(vp++) = U00*I0[21] - U10*I3[21] + loo2p*I2[21] - (twoo4zn)*I5[13];
*(vp++) = U00*I0[22] - U10*I3[22] + loo2p*I2[22] - (twoo4zn)*I5[14];
*(vp++) = U00*I0[23] - U10*I3[23] + loo2p*I2[23] - (oneo4zn)*I5[15];
*(vp++) = U00*I0[24] - U10*I3[24] + loo2p*I2[24] - (oneo4zn)*I5[16];
*(vp++) = U00*I0[25] - U10*I3[25] + loo2p*I2[25] - (oneo4zn)*I5[17];
*(vp++) = U00*I0[26] - U10*I3[26] + loo2p*I2[26];
*(vp++) = U00*I0[27] - U10*I3[27] + loo2p*I2[27];
*(vp++) = U00*I0[28] - U10*I3[28] + loo2p*I2[28];
*(vp++) = U00*I0[29] - U10*I3[29] + loo2p*I2[29];
*(vp++) = U01*I0[10] - U11*I3[10] + loo2p*I2[30]
        + (oneo2z)*I1[0] - (oneo4zn)*I4[0];
*(vp++) = U01*I0[11] - U11*I3[11] + loo2p*I2[31]
        + (oneo2z)*I1[1] - (oneo4zn)*I4[1] - (oneo4zn)*I5[6];
*(vp++) = U01*I0[12] - U11*I3[12] + loo2p*I2[32]
        + (oneo2z)*I1[2] - (oneo4zn)*I4[2];
*(vp++) = U01*I0[13] - U11*I3[13] + loo2p*I2[33]
        + (oneo2z)*I1[3] - (oneo4zn)*I4[3] - (twoo4zn)*I5[7];
*(vp++) = U01*I0[14] - U11*I3[14] + loo2p*I2[34]
        + (oneo2z)*I1[4] - (oneo4zn)*I4[4] - (oneo4zn)*I5[8];
*(vp++) = U01*I0[15] - U11*I3[15] + loo2p*I2[35]
        + (oneo2z)*I1[5] - (oneo4zn)*I4[5];
*(vp++) = U01*I0[16] - U11*I3[16] + loo2p*I2[36]
        + (oneo2z)*I1[6] - (oneo4zn)*I4[6] - (threeo4zn)*I5[9];
*(vp++) = U01*I0[17] - U11*I3[17] + loo2p*I2[37]
        + (oneo2z)*I1[7] - (oneo4zn)*I4[7] - (twoo4zn)*I5[10];
*(vp++) = U01*I0[18] - U11*I3[18] + loo2p*I2[38]
        + (oneo2z)*I1[8] - (oneo4zn)*I4[8] - (oneo4zn)*I5[11];
*(vp++) = U01*I0[19] - U11*I3[19] + loo2p*I2[39]
        + (oneo2z)*I1[9] - (oneo4zn)*I4[9];
*(vp++) = U01*I0[20] - U11*I3[20] + loo2p*I2[40];
*(vp++) = U01*I0[21] - U11*I3[21] + loo2p*I2[41] - (oneo4zn)*I5[12];
*(vp++) = U01*I0[22] - U11*I3[22] + loo2p*I2[42];
*(vp++) = U01*I0[23] - U11*I3[23] + loo2p*I2[43] - (twoo4zn)*I5[13];
*(vp++) = U01*I0[24] - U11*I3[24] + loo2p*I2[44] - (oneo4zn)*I5[14];
*(vp++) = U01*I0[25] - U11*I3[25] + loo2p*I2[45];
*(vp++) = U01*I0[26] - U11*I3[26] + loo2p*I2[46] - (threeo4zn)*I5[15];
*(vp++) = U01*I0[27] - U11*I3[27] + loo2p*I2[47] - (twoo4zn)*I5[16];
*(vp++) = U01*I0[28] - U11*I3[28] + loo2p*I2[48] - (oneo4zn)*I5[17];
*(vp++) = U01*I0[29] - U11*I3[29] + loo2p*I2[49];
*(vp++) = U02*I0[20] - U12*I3[20] + loo2p*I2[50]
        + (oneo2z)*I1[0] - (oneo4zn)*I4[0];
*(vp++) = U02*I0[21] - U12*I3[21] + loo2p*I2[51]
        + (oneo2z)*I1[1] - (oneo4zn)*I4[1];
*(vp++) = U02*I0[22] - U12*I3[22] + loo2p*I2[52]
        + (oneo2z)*I1[2] - (oneo4zn)*I4[2] - (oneo4zn)*I5[12];
*(vp++) = U02*I0[23] - U12*I3[23] + loo2p*I2[53]
        + (oneo2z)*I1[3] - (oneo4zn)*I4[3];
*(vp++) = U02*I0[24] - U12*I3[24] + loo2p*I2[54]
        + (oneo2z)*I1[4] - (oneo4zn)*I4[4] - (oneo4zn)*I5[13];
*(vp++) = U02*I0[25] - U12*I3[25] + loo2p*I2[55]
        + (oneo2z)*I1[5] - (oneo4zn)*I4[5] - (twoo4zn)*I5[14];
*(vp++) = U02*I0[26] - U12*I3[26] + loo2p*I2[56]
        + (oneo2z)*I1[6] - (oneo4zn)*I4[6];
*(vp++) = U02*I0[27] - U12*I3[27] + loo2p*I2[57]
        + (oneo2z)*I1[7] - (oneo4zn)*I4[7] - (oneo4zn)*I5[15];
*(vp++) = U02*I0[28] - U12*I3[28] + loo2p*I2[58]
        + (oneo2z)*I1[8] - (oneo4zn)*I4[8] - (twoo4zn)*I5[16];
*(vp++) = U02*I0[29] - U12*I3[29] + loo2p*I2[59]
        + (oneo2z)*I1[9] - (oneo4zn)*I4[9] - (threeo4zn)*I5[17];

}
