/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ks||ds) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _r_build_k0d0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (sixo2z)*I1[0] - (sixo4zn)*I4[0] - (twoo4zn)*I5[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1]
        + (sixo2z)*I1[1] - (sixo4zn)*I4[1] - (oneo4zn)*I5[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2]
        + (sixo2z)*I1[2] - (sixo4zn)*I4[2] - (oneo4zn)*I5[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3]
        + (sixo2z)*I1[3] - (sixo4zn)*I4[3];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4]
        + (sixo2z)*I1[4] - (sixo4zn)*I4[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5]
        + (sixo2z)*I1[5] - (sixo4zn)*I4[5];
*(vp++) = U00*I0[6] - U10*I3[6] + loo2p*I2[6]
        + (fiveo2z)*I1[6] - (fiveo4zn)*I4[6] - (twoo4zn)*I5[3];
*(vp++) = U00*I0[7] - U10*I3[7] + loo2p*I2[7]
        + (fiveo2z)*I1[7] - (fiveo4zn)*I4[7] - (oneo4zn)*I5[4];
*(vp++) = U00*I0[8] - U10*I3[8] + loo2p*I2[8]
        + (fiveo2z)*I1[8] - (fiveo4zn)*I4[8] - (oneo4zn)*I5[5];
*(vp++) = U00*I0[9] - U10*I3[9] + loo2p*I2[9]
        + (fiveo2z)*I1[9] - (fiveo4zn)*I4[9];
*(vp++) = U00*I0[10] - U10*I3[10] + loo2p*I2[10]
        + (fiveo2z)*I1[10] - (fiveo4zn)*I4[10];
*(vp++) = U00*I0[11] - U10*I3[11] + loo2p*I2[11]
        + (fiveo2z)*I1[11] - (fiveo4zn)*I4[11];
*(vp++) = U00*I0[12] - U10*I3[12] + loo2p*I2[12]
        + (fiveo2z)*I1[12] - (fiveo4zn)*I4[12] - (twoo4zn)*I5[6];
*(vp++) = U00*I0[13] - U10*I3[13] + loo2p*I2[13]
        + (fiveo2z)*I1[13] - (fiveo4zn)*I4[13] - (oneo4zn)*I5[7];
*(vp++) = U00*I0[14] - U10*I3[14] + loo2p*I2[14]
        + (fiveo2z)*I1[14] - (fiveo4zn)*I4[14] - (oneo4zn)*I5[8];
*(vp++) = U00*I0[15] - U10*I3[15] + loo2p*I2[15]
        + (fiveo2z)*I1[15] - (fiveo4zn)*I4[15];
*(vp++) = U00*I0[16] - U10*I3[16] + loo2p*I2[16]
        + (fiveo2z)*I1[16] - (fiveo4zn)*I4[16];
*(vp++) = U00*I0[17] - U10*I3[17] + loo2p*I2[17]
        + (fiveo2z)*I1[17] - (fiveo4zn)*I4[17];
*(vp++) = U00*I0[18] - U10*I3[18] + loo2p*I2[18]
        + (fouro2z)*I1[18] - (fouro4zn)*I4[18] - (twoo4zn)*I5[9];
*(vp++) = U00*I0[19] - U10*I3[19] + loo2p*I2[19]
        + (fouro2z)*I1[19] - (fouro4zn)*I4[19] - (oneo4zn)*I5[10];
*(vp++) = U00*I0[20] - U10*I3[20] + loo2p*I2[20]
        + (fouro2z)*I1[20] - (fouro4zn)*I4[20] - (oneo4zn)*I5[11];
*(vp++) = U00*I0[21] - U10*I3[21] + loo2p*I2[21]
        + (fouro2z)*I1[21] - (fouro4zn)*I4[21];
*(vp++) = U00*I0[22] - U10*I3[22] + loo2p*I2[22]
        + (fouro2z)*I1[22] - (fouro4zn)*I4[22];
*(vp++) = U00*I0[23] - U10*I3[23] + loo2p*I2[23]
        + (fouro2z)*I1[23] - (fouro4zn)*I4[23];
*(vp++) = U00*I0[24] - U10*I3[24] + loo2p*I2[24]
        + (fouro2z)*I1[24] - (fouro4zn)*I4[24] - (twoo4zn)*I5[12];
*(vp++) = U00*I0[25] - U10*I3[25] + loo2p*I2[25]
        + (fouro2z)*I1[25] - (fouro4zn)*I4[25] - (oneo4zn)*I5[13];
*(vp++) = U00*I0[26] - U10*I3[26] + loo2p*I2[26]
        + (fouro2z)*I1[26] - (fouro4zn)*I4[26] - (oneo4zn)*I5[14];
*(vp++) = U00*I0[27] - U10*I3[27] + loo2p*I2[27]
        + (fouro2z)*I1[27] - (fouro4zn)*I4[27];
*(vp++) = U00*I0[28] - U10*I3[28] + loo2p*I2[28]
        + (fouro2z)*I1[28] - (fouro4zn)*I4[28];
*(vp++) = U00*I0[29] - U10*I3[29] + loo2p*I2[29]
        + (fouro2z)*I1[29] - (fouro4zn)*I4[29];
*(vp++) = U00*I0[30] - U10*I3[30] + loo2p*I2[30]
        + (fouro2z)*I1[30] - (fouro4zn)*I4[30] - (twoo4zn)*I5[15];
*(vp++) = U00*I0[31] - U10*I3[31] + loo2p*I2[31]
        + (fouro2z)*I1[31] - (fouro4zn)*I4[31] - (oneo4zn)*I5[16];
*(vp++) = U00*I0[32] - U10*I3[32] + loo2p*I2[32]
        + (fouro2z)*I1[32] - (fouro4zn)*I4[32] - (oneo4zn)*I5[17];
*(vp++) = U00*I0[33] - U10*I3[33] + loo2p*I2[33]
        + (fouro2z)*I1[33] - (fouro4zn)*I4[33];
*(vp++) = U00*I0[34] - U10*I3[34] + loo2p*I2[34]
        + (fouro2z)*I1[34] - (fouro4zn)*I4[34];
*(vp++) = U00*I0[35] - U10*I3[35] + loo2p*I2[35]
        + (fouro2z)*I1[35] - (fouro4zn)*I4[35];
*(vp++) = U00*I0[36] - U10*I3[36] + loo2p*I2[36]
        + (threeo2z)*I1[36] - (threeo4zn)*I4[36] - (twoo4zn)*I5[18];
*(vp++) = U00*I0[37] - U10*I3[37] + loo2p*I2[37]
        + (threeo2z)*I1[37] - (threeo4zn)*I4[37] - (oneo4zn)*I5[19];
*(vp++) = U00*I0[38] - U10*I3[38] + loo2p*I2[38]
        + (threeo2z)*I1[38] - (threeo4zn)*I4[38] - (oneo4zn)*I5[20];
*(vp++) = U00*I0[39] - U10*I3[39] + loo2p*I2[39]
        + (threeo2z)*I1[39] - (threeo4zn)*I4[39];
*(vp++) = U00*I0[40] - U10*I3[40] + loo2p*I2[40]
        + (threeo2z)*I1[40] - (threeo4zn)*I4[40];
*(vp++) = U00*I0[41] - U10*I3[41] + loo2p*I2[41]
        + (threeo2z)*I1[41] - (threeo4zn)*I4[41];
*(vp++) = U00*I0[42] - U10*I3[42] + loo2p*I2[42]
        + (threeo2z)*I1[42] - (threeo4zn)*I4[42] - (twoo4zn)*I5[21];
*(vp++) = U00*I0[43] - U10*I3[43] + loo2p*I2[43]
        + (threeo2z)*I1[43] - (threeo4zn)*I4[43] - (oneo4zn)*I5[22];
*(vp++) = U00*I0[44] - U10*I3[44] + loo2p*I2[44]
        + (threeo2z)*I1[44] - (threeo4zn)*I4[44] - (oneo4zn)*I5[23];
*(vp++) = U00*I0[45] - U10*I3[45] + loo2p*I2[45]
        + (threeo2z)*I1[45] - (threeo4zn)*I4[45];
*(vp++) = U00*I0[46] - U10*I3[46] + loo2p*I2[46]
        + (threeo2z)*I1[46] - (threeo4zn)*I4[46];
*(vp++) = U00*I0[47] - U10*I3[47] + loo2p*I2[47]
        + (threeo2z)*I1[47] - (threeo4zn)*I4[47];
*(vp++) = U00*I0[48] - U10*I3[48] + loo2p*I2[48]
        + (threeo2z)*I1[48] - (threeo4zn)*I4[48] - (twoo4zn)*I5[24];
*(vp++) = U00*I0[49] - U10*I3[49] + loo2p*I2[49]
        + (threeo2z)*I1[49] - (threeo4zn)*I4[49] - (oneo4zn)*I5[25];
*(vp++) = U00*I0[50] - U10*I3[50] + loo2p*I2[50]
        + (threeo2z)*I1[50] - (threeo4zn)*I4[50] - (oneo4zn)*I5[26];
*(vp++) = U00*I0[51] - U10*I3[51] + loo2p*I2[51]
        + (threeo2z)*I1[51] - (threeo4zn)*I4[51];
*(vp++) = U00*I0[52] - U10*I3[52] + loo2p*I2[52]
        + (threeo2z)*I1[52] - (threeo4zn)*I4[52];
*(vp++) = U00*I0[53] - U10*I3[53] + loo2p*I2[53]
        + (threeo2z)*I1[53] - (threeo4zn)*I4[53];
*(vp++) = U00*I0[54] - U10*I3[54] + loo2p*I2[54]
        + (threeo2z)*I1[54] - (threeo4zn)*I4[54] - (twoo4zn)*I5[27];
*(vp++) = U00*I0[55] - U10*I3[55] + loo2p*I2[55]
        + (threeo2z)*I1[55] - (threeo4zn)*I4[55] - (oneo4zn)*I5[28];
*(vp++) = U00*I0[56] - U10*I3[56] + loo2p*I2[56]
        + (threeo2z)*I1[56] - (threeo4zn)*I4[56] - (oneo4zn)*I5[29];
*(vp++) = U00*I0[57] - U10*I3[57] + loo2p*I2[57]
        + (threeo2z)*I1[57] - (threeo4zn)*I4[57];
*(vp++) = U00*I0[58] - U10*I3[58] + loo2p*I2[58]
        + (threeo2z)*I1[58] - (threeo4zn)*I4[58];
*(vp++) = U00*I0[59] - U10*I3[59] + loo2p*I2[59]
        + (threeo2z)*I1[59] - (threeo4zn)*I4[59];
*(vp++) = U00*I0[60] - U10*I3[60] + loo2p*I2[60]
        + (twoo2z)*I1[60] - (twoo4zn)*I4[60] - (twoo4zn)*I5[30];
*(vp++) = U00*I0[61] - U10*I3[61] + loo2p*I2[61]
        + (twoo2z)*I1[61] - (twoo4zn)*I4[61] - (oneo4zn)*I5[31];
*(vp++) = U00*I0[62] - U10*I3[62] + loo2p*I2[62]
        + (twoo2z)*I1[62] - (twoo4zn)*I4[62] - (oneo4zn)*I5[32];
*(vp++) = U00*I0[63] - U10*I3[63] + loo2p*I2[63]
        + (twoo2z)*I1[63] - (twoo4zn)*I4[63];
*(vp++) = U00*I0[64] - U10*I3[64] + loo2p*I2[64]
        + (twoo2z)*I1[64] - (twoo4zn)*I4[64];
*(vp++) = U00*I0[65] - U10*I3[65] + loo2p*I2[65]
        + (twoo2z)*I1[65] - (twoo4zn)*I4[65];
*(vp++) = U00*I0[66] - U10*I3[66] + loo2p*I2[66]
        + (twoo2z)*I1[66] - (twoo4zn)*I4[66] - (twoo4zn)*I5[33];
*(vp++) = U00*I0[67] - U10*I3[67] + loo2p*I2[67]
        + (twoo2z)*I1[67] - (twoo4zn)*I4[67] - (oneo4zn)*I5[34];
*(vp++) = U00*I0[68] - U10*I3[68] + loo2p*I2[68]
        + (twoo2z)*I1[68] - (twoo4zn)*I4[68] - (oneo4zn)*I5[35];
*(vp++) = U00*I0[69] - U10*I3[69] + loo2p*I2[69]
        + (twoo2z)*I1[69] - (twoo4zn)*I4[69];
*(vp++) = U00*I0[70] - U10*I3[70] + loo2p*I2[70]
        + (twoo2z)*I1[70] - (twoo4zn)*I4[70];
*(vp++) = U00*I0[71] - U10*I3[71] + loo2p*I2[71]
        + (twoo2z)*I1[71] - (twoo4zn)*I4[71];
*(vp++) = U00*I0[72] - U10*I3[72] + loo2p*I2[72]
        + (twoo2z)*I1[72] - (twoo4zn)*I4[72] - (twoo4zn)*I5[36];
*(vp++) = U00*I0[73] - U10*I3[73] + loo2p*I2[73]
        + (twoo2z)*I1[73] - (twoo4zn)*I4[73] - (oneo4zn)*I5[37];
*(vp++) = U00*I0[74] - U10*I3[74] + loo2p*I2[74]
        + (twoo2z)*I1[74] - (twoo4zn)*I4[74] - (oneo4zn)*I5[38];
*(vp++) = U00*I0[75] - U10*I3[75] + loo2p*I2[75]
        + (twoo2z)*I1[75] - (twoo4zn)*I4[75];
*(vp++) = U00*I0[76] - U10*I3[76] + loo2p*I2[76]
        + (twoo2z)*I1[76] - (twoo4zn)*I4[76];
*(vp++) = U00*I0[77] - U10*I3[77] + loo2p*I2[77]
        + (twoo2z)*I1[77] - (twoo4zn)*I4[77];
*(vp++) = U00*I0[78] - U10*I3[78] + loo2p*I2[78]
        + (twoo2z)*I1[78] - (twoo4zn)*I4[78] - (twoo4zn)*I5[39];
*(vp++) = U00*I0[79] - U10*I3[79] + loo2p*I2[79]
        + (twoo2z)*I1[79] - (twoo4zn)*I4[79] - (oneo4zn)*I5[40];
*(vp++) = U00*I0[80] - U10*I3[80] + loo2p*I2[80]
        + (twoo2z)*I1[80] - (twoo4zn)*I4[80] - (oneo4zn)*I5[41];
*(vp++) = U00*I0[81] - U10*I3[81] + loo2p*I2[81]
        + (twoo2z)*I1[81] - (twoo4zn)*I4[81];
*(vp++) = U00*I0[82] - U10*I3[82] + loo2p*I2[82]
        + (twoo2z)*I1[82] - (twoo4zn)*I4[82];
*(vp++) = U00*I0[83] - U10*I3[83] + loo2p*I2[83]
        + (twoo2z)*I1[83] - (twoo4zn)*I4[83];
*(vp++) = U00*I0[84] - U10*I3[84] + loo2p*I2[84]
        + (twoo2z)*I1[84] - (twoo4zn)*I4[84] - (twoo4zn)*I5[42];
*(vp++) = U00*I0[85] - U10*I3[85] + loo2p*I2[85]
        + (twoo2z)*I1[85] - (twoo4zn)*I4[85] - (oneo4zn)*I5[43];
*(vp++) = U00*I0[86] - U10*I3[86] + loo2p*I2[86]
        + (twoo2z)*I1[86] - (twoo4zn)*I4[86] - (oneo4zn)*I5[44];
*(vp++) = U00*I0[87] - U10*I3[87] + loo2p*I2[87]
        + (twoo2z)*I1[87] - (twoo4zn)*I4[87];
*(vp++) = U00*I0[88] - U10*I3[88] + loo2p*I2[88]
        + (twoo2z)*I1[88] - (twoo4zn)*I4[88];
*(vp++) = U00*I0[89] - U10*I3[89] + loo2p*I2[89]
        + (twoo2z)*I1[89] - (twoo4zn)*I4[89];
*(vp++) = U00*I0[90] - U10*I3[90] + loo2p*I2[90]
        + (oneo2z)*I1[90] - (oneo4zn)*I4[90] - (twoo4zn)*I5[45];
*(vp++) = U00*I0[91] - U10*I3[91] + loo2p*I2[91]
        + (oneo2z)*I1[91] - (oneo4zn)*I4[91] - (oneo4zn)*I5[46];
*(vp++) = U00*I0[92] - U10*I3[92] + loo2p*I2[92]
        + (oneo2z)*I1[92] - (oneo4zn)*I4[92] - (oneo4zn)*I5[47];
*(vp++) = U00*I0[93] - U10*I3[93] + loo2p*I2[93]
        + (oneo2z)*I1[93] - (oneo4zn)*I4[93];
*(vp++) = U00*I0[94] - U10*I3[94] + loo2p*I2[94]
        + (oneo2z)*I1[94] - (oneo4zn)*I4[94];
*(vp++) = U00*I0[95] - U10*I3[95] + loo2p*I2[95]
        + (oneo2z)*I1[95] - (oneo4zn)*I4[95];
*(vp++) = U00*I0[96] - U10*I3[96] + loo2p*I2[96]
        + (oneo2z)*I1[96] - (oneo4zn)*I4[96] - (twoo4zn)*I5[48];
*(vp++) = U00*I0[97] - U10*I3[97] + loo2p*I2[97]
        + (oneo2z)*I1[97] - (oneo4zn)*I4[97] - (oneo4zn)*I5[49];
*(vp++) = U00*I0[98] - U10*I3[98] + loo2p*I2[98]
        + (oneo2z)*I1[98] - (oneo4zn)*I4[98] - (oneo4zn)*I5[50];
*(vp++) = U00*I0[99] - U10*I3[99] + loo2p*I2[99]
        + (oneo2z)*I1[99] - (oneo4zn)*I4[99];
*(vp++) = U00*I0[100] - U10*I3[100] + loo2p*I2[100]
        + (oneo2z)*I1[100] - (oneo4zn)*I4[100];
*(vp++) = U00*I0[101] - U10*I3[101] + loo2p*I2[101]
        + (oneo2z)*I1[101] - (oneo4zn)*I4[101];
*(vp++) = U00*I0[102] - U10*I3[102] + loo2p*I2[102]
        + (oneo2z)*I1[102] - (oneo4zn)*I4[102] - (twoo4zn)*I5[51];
*(vp++) = U00*I0[103] - U10*I3[103] + loo2p*I2[103]
        + (oneo2z)*I1[103] - (oneo4zn)*I4[103] - (oneo4zn)*I5[52];
*(vp++) = U00*I0[104] - U10*I3[104] + loo2p*I2[104]
        + (oneo2z)*I1[104] - (oneo4zn)*I4[104] - (oneo4zn)*I5[53];
*(vp++) = U00*I0[105] - U10*I3[105] + loo2p*I2[105]
        + (oneo2z)*I1[105] - (oneo4zn)*I4[105];
*(vp++) = U00*I0[106] - U10*I3[106] + loo2p*I2[106]
        + (oneo2z)*I1[106] - (oneo4zn)*I4[106];
*(vp++) = U00*I0[107] - U10*I3[107] + loo2p*I2[107]
        + (oneo2z)*I1[107] - (oneo4zn)*I4[107];
*(vp++) = U00*I0[108] - U10*I3[108] + loo2p*I2[108]
        + (oneo2z)*I1[108] - (oneo4zn)*I4[108] - (twoo4zn)*I5[54];
*(vp++) = U00*I0[109] - U10*I3[109] + loo2p*I2[109]
        + (oneo2z)*I1[109] - (oneo4zn)*I4[109] - (oneo4zn)*I5[55];
*(vp++) = U00*I0[110] - U10*I3[110] + loo2p*I2[110]
        + (oneo2z)*I1[110] - (oneo4zn)*I4[110] - (oneo4zn)*I5[56];
*(vp++) = U00*I0[111] - U10*I3[111] + loo2p*I2[111]
        + (oneo2z)*I1[111] - (oneo4zn)*I4[111];
*(vp++) = U00*I0[112] - U10*I3[112] + loo2p*I2[112]
        + (oneo2z)*I1[112] - (oneo4zn)*I4[112];
*(vp++) = U00*I0[113] - U10*I3[113] + loo2p*I2[113]
        + (oneo2z)*I1[113] - (oneo4zn)*I4[113];
*(vp++) = U00*I0[114] - U10*I3[114] + loo2p*I2[114]
        + (oneo2z)*I1[114] - (oneo4zn)*I4[114] - (twoo4zn)*I5[57];
*(vp++) = U00*I0[115] - U10*I3[115] + loo2p*I2[115]
        + (oneo2z)*I1[115] - (oneo4zn)*I4[115] - (oneo4zn)*I5[58];
*(vp++) = U00*I0[116] - U10*I3[116] + loo2p*I2[116]
        + (oneo2z)*I1[116] - (oneo4zn)*I4[116] - (oneo4zn)*I5[59];
*(vp++) = U00*I0[117] - U10*I3[117] + loo2p*I2[117]
        + (oneo2z)*I1[117] - (oneo4zn)*I4[117];
*(vp++) = U00*I0[118] - U10*I3[118] + loo2p*I2[118]
        + (oneo2z)*I1[118] - (oneo4zn)*I4[118];
*(vp++) = U00*I0[119] - U10*I3[119] + loo2p*I2[119]
        + (oneo2z)*I1[119] - (oneo4zn)*I4[119];
*(vp++) = U00*I0[120] - U10*I3[120] + loo2p*I2[120]
        + (oneo2z)*I1[120] - (oneo4zn)*I4[120] - (twoo4zn)*I5[60];
*(vp++) = U00*I0[121] - U10*I3[121] + loo2p*I2[121]
        + (oneo2z)*I1[121] - (oneo4zn)*I4[121] - (oneo4zn)*I5[61];
*(vp++) = U00*I0[122] - U10*I3[122] + loo2p*I2[122]
        + (oneo2z)*I1[122] - (oneo4zn)*I4[122] - (oneo4zn)*I5[62];
*(vp++) = U00*I0[123] - U10*I3[123] + loo2p*I2[123]
        + (oneo2z)*I1[123] - (oneo4zn)*I4[123];
*(vp++) = U00*I0[124] - U10*I3[124] + loo2p*I2[124]
        + (oneo2z)*I1[124] - (oneo4zn)*I4[124];
*(vp++) = U00*I0[125] - U10*I3[125] + loo2p*I2[125]
        + (oneo2z)*I1[125] - (oneo4zn)*I4[125];
*(vp++) = U00*I0[126] - U10*I3[126] + loo2p*I2[126] - (twoo4zn)*I5[63];
*(vp++) = U00*I0[127] - U10*I3[127] + loo2p*I2[127] - (oneo4zn)*I5[64];
*(vp++) = U00*I0[128] - U10*I3[128] + loo2p*I2[128] - (oneo4zn)*I5[65];
*(vp++) = U00*I0[129] - U10*I3[129] + loo2p*I2[129];
*(vp++) = U00*I0[130] - U10*I3[130] + loo2p*I2[130];
*(vp++) = U00*I0[131] - U10*I3[131] + loo2p*I2[131];
*(vp++) = U00*I0[132] - U10*I3[132] + loo2p*I2[132] - (twoo4zn)*I5[66];
*(vp++) = U00*I0[133] - U10*I3[133] + loo2p*I2[133] - (oneo4zn)*I5[67];
*(vp++) = U00*I0[134] - U10*I3[134] + loo2p*I2[134] - (oneo4zn)*I5[68];
*(vp++) = U00*I0[135] - U10*I3[135] + loo2p*I2[135];
*(vp++) = U00*I0[136] - U10*I3[136] + loo2p*I2[136];
*(vp++) = U00*I0[137] - U10*I3[137] + loo2p*I2[137];
*(vp++) = U00*I0[138] - U10*I3[138] + loo2p*I2[138] - (twoo4zn)*I5[69];
*(vp++) = U00*I0[139] - U10*I3[139] + loo2p*I2[139] - (oneo4zn)*I5[70];
*(vp++) = U00*I0[140] - U10*I3[140] + loo2p*I2[140] - (oneo4zn)*I5[71];
*(vp++) = U00*I0[141] - U10*I3[141] + loo2p*I2[141];
*(vp++) = U00*I0[142] - U10*I3[142] + loo2p*I2[142];
*(vp++) = U00*I0[143] - U10*I3[143] + loo2p*I2[143];
*(vp++) = U00*I0[144] - U10*I3[144] + loo2p*I2[144] - (twoo4zn)*I5[72];
*(vp++) = U00*I0[145] - U10*I3[145] + loo2p*I2[145] - (oneo4zn)*I5[73];
*(vp++) = U00*I0[146] - U10*I3[146] + loo2p*I2[146] - (oneo4zn)*I5[74];
*(vp++) = U00*I0[147] - U10*I3[147] + loo2p*I2[147];
*(vp++) = U00*I0[148] - U10*I3[148] + loo2p*I2[148];
*(vp++) = U00*I0[149] - U10*I3[149] + loo2p*I2[149];
*(vp++) = U00*I0[150] - U10*I3[150] + loo2p*I2[150] - (twoo4zn)*I5[75];
*(vp++) = U00*I0[151] - U10*I3[151] + loo2p*I2[151] - (oneo4zn)*I5[76];
*(vp++) = U00*I0[152] - U10*I3[152] + loo2p*I2[152] - (oneo4zn)*I5[77];
*(vp++) = U00*I0[153] - U10*I3[153] + loo2p*I2[153];
*(vp++) = U00*I0[154] - U10*I3[154] + loo2p*I2[154];
*(vp++) = U00*I0[155] - U10*I3[155] + loo2p*I2[155];
*(vp++) = U00*I0[156] - U10*I3[156] + loo2p*I2[156] - (twoo4zn)*I5[78];
*(vp++) = U00*I0[157] - U10*I3[157] + loo2p*I2[157] - (oneo4zn)*I5[79];
*(vp++) = U00*I0[158] - U10*I3[158] + loo2p*I2[158] - (oneo4zn)*I5[80];
*(vp++) = U00*I0[159] - U10*I3[159] + loo2p*I2[159];
*(vp++) = U00*I0[160] - U10*I3[160] + loo2p*I2[160];
*(vp++) = U00*I0[161] - U10*I3[161] + loo2p*I2[161];
*(vp++) = U00*I0[162] - U10*I3[162] + loo2p*I2[162] - (twoo4zn)*I5[81];
*(vp++) = U00*I0[163] - U10*I3[163] + loo2p*I2[163] - (oneo4zn)*I5[82];
*(vp++) = U00*I0[164] - U10*I3[164] + loo2p*I2[164] - (oneo4zn)*I5[83];
*(vp++) = U00*I0[165] - U10*I3[165] + loo2p*I2[165];
*(vp++) = U00*I0[166] - U10*I3[166] + loo2p*I2[166];
*(vp++) = U00*I0[167] - U10*I3[167] + loo2p*I2[167];
*(vp++) = U01*I0[126] - U11*I3[126] + loo2p*I2[168]
        + (sixo2z)*I1[90] - (sixo4zn)*I4[90];
*(vp++) = U01*I0[127] - U11*I3[127] + loo2p*I2[169]
        + (sixo2z)*I1[91] - (sixo4zn)*I4[91] - (oneo4zn)*I5[63];
*(vp++) = U01*I0[128] - U11*I3[128] + loo2p*I2[170]
        + (sixo2z)*I1[92] - (sixo4zn)*I4[92];
*(vp++) = U01*I0[129] - U11*I3[129] + loo2p*I2[171]
        + (sixo2z)*I1[93] - (sixo4zn)*I4[93] - (twoo4zn)*I5[64];
*(vp++) = U01*I0[130] - U11*I3[130] + loo2p*I2[172]
        + (sixo2z)*I1[94] - (sixo4zn)*I4[94] - (oneo4zn)*I5[65];
*(vp++) = U01*I0[131] - U11*I3[131] + loo2p*I2[173]
        + (sixo2z)*I1[95] - (sixo4zn)*I4[95];
*(vp++) = U01*I0[132] - U11*I3[132] + loo2p*I2[174]
        + (fiveo2z)*I1[96] - (fiveo4zn)*I4[96];
*(vp++) = U01*I0[133] - U11*I3[133] + loo2p*I2[175]
        + (fiveo2z)*I1[97] - (fiveo4zn)*I4[97] - (oneo4zn)*I5[66];
*(vp++) = U01*I0[134] - U11*I3[134] + loo2p*I2[176]
        + (fiveo2z)*I1[98] - (fiveo4zn)*I4[98];
*(vp++) = U01*I0[135] - U11*I3[135] + loo2p*I2[177]
        + (fiveo2z)*I1[99] - (fiveo4zn)*I4[99] - (twoo4zn)*I5[67];
*(vp++) = U01*I0[136] - U11*I3[136] + loo2p*I2[178]
        + (fiveo2z)*I1[100] - (fiveo4zn)*I4[100] - (oneo4zn)*I5[68];
*(vp++) = U01*I0[137] - U11*I3[137] + loo2p*I2[179]
        + (fiveo2z)*I1[101] - (fiveo4zn)*I4[101];
*(vp++) = U01*I0[138] - U11*I3[138] + loo2p*I2[180]
        + (fouro2z)*I1[102] - (fouro4zn)*I4[102];
*(vp++) = U01*I0[139] - U11*I3[139] + loo2p*I2[181]
        + (fouro2z)*I1[103] - (fouro4zn)*I4[103] - (oneo4zn)*I5[69];
*(vp++) = U01*I0[140] - U11*I3[140] + loo2p*I2[182]
        + (fouro2z)*I1[104] - (fouro4zn)*I4[104];
*(vp++) = U01*I0[141] - U11*I3[141] + loo2p*I2[183]
        + (fouro2z)*I1[105] - (fouro4zn)*I4[105] - (twoo4zn)*I5[70];
*(vp++) = U01*I0[142] - U11*I3[142] + loo2p*I2[184]
        + (fouro2z)*I1[106] - (fouro4zn)*I4[106] - (oneo4zn)*I5[71];
*(vp++) = U01*I0[143] - U11*I3[143] + loo2p*I2[185]
        + (fouro2z)*I1[107] - (fouro4zn)*I4[107];
*(vp++) = U01*I0[144] - U11*I3[144] + loo2p*I2[186]
        + (threeo2z)*I1[108] - (threeo4zn)*I4[108];
*(vp++) = U01*I0[145] - U11*I3[145] + loo2p*I2[187]
        + (threeo2z)*I1[109] - (threeo4zn)*I4[109] - (oneo4zn)*I5[72];
*(vp++) = U01*I0[146] - U11*I3[146] + loo2p*I2[188]
        + (threeo2z)*I1[110] - (threeo4zn)*I4[110];
*(vp++) = U01*I0[147] - U11*I3[147] + loo2p*I2[189]
        + (threeo2z)*I1[111] - (threeo4zn)*I4[111] - (twoo4zn)*I5[73];
*(vp++) = U01*I0[148] - U11*I3[148] + loo2p*I2[190]
        + (threeo2z)*I1[112] - (threeo4zn)*I4[112] - (oneo4zn)*I5[74];
*(vp++) = U01*I0[149] - U11*I3[149] + loo2p*I2[191]
        + (threeo2z)*I1[113] - (threeo4zn)*I4[113];
*(vp++) = U01*I0[150] - U11*I3[150] + loo2p*I2[192]
        + (twoo2z)*I1[114] - (twoo4zn)*I4[114];
*(vp++) = U01*I0[151] - U11*I3[151] + loo2p*I2[193]
        + (twoo2z)*I1[115] - (twoo4zn)*I4[115] - (oneo4zn)*I5[75];
*(vp++) = U01*I0[152] - U11*I3[152] + loo2p*I2[194]
        + (twoo2z)*I1[116] - (twoo4zn)*I4[116];
*(vp++) = U01*I0[153] - U11*I3[153] + loo2p*I2[195]
        + (twoo2z)*I1[117] - (twoo4zn)*I4[117] - (twoo4zn)*I5[76];
*(vp++) = U01*I0[154] - U11*I3[154] + loo2p*I2[196]
        + (twoo2z)*I1[118] - (twoo4zn)*I4[118] - (oneo4zn)*I5[77];
*(vp++) = U01*I0[155] - U11*I3[155] + loo2p*I2[197]
        + (twoo2z)*I1[119] - (twoo4zn)*I4[119];
*(vp++) = U01*I0[156] - U11*I3[156] + loo2p*I2[198]
        + (oneo2z)*I1[120] - (oneo4zn)*I4[120];
*(vp++) = U01*I0[157] - U11*I3[157] + loo2p*I2[199]
        + (oneo2z)*I1[121] - (oneo4zn)*I4[121] - (oneo4zn)*I5[78];
*(vp++) = U01*I0[158] - U11*I3[158] + loo2p*I2[200]
        + (oneo2z)*I1[122] - (oneo4zn)*I4[122];
*(vp++) = U01*I0[159] - U11*I3[159] + loo2p*I2[201]
        + (oneo2z)*I1[123] - (oneo4zn)*I4[123] - (twoo4zn)*I5[79];
*(vp++) = U01*I0[160] - U11*I3[160] + loo2p*I2[202]
        + (oneo2z)*I1[124] - (oneo4zn)*I4[124] - (oneo4zn)*I5[80];
*(vp++) = U01*I0[161] - U11*I3[161] + loo2p*I2[203]
        + (oneo2z)*I1[125] - (oneo4zn)*I4[125];
*(vp++) = U01*I0[162] - U11*I3[162] + loo2p*I2[204];
*(vp++) = U01*I0[163] - U11*I3[163] + loo2p*I2[205] - (oneo4zn)*I5[81];
*(vp++) = U01*I0[164] - U11*I3[164] + loo2p*I2[206];
*(vp++) = U01*I0[165] - U11*I3[165] + loo2p*I2[207] - (twoo4zn)*I5[82];
*(vp++) = U01*I0[166] - U11*I3[166] + loo2p*I2[208] - (oneo4zn)*I5[83];
*(vp++) = U01*I0[167] - U11*I3[167] + loo2p*I2[209];
*(vp++) = U02*I0[162] - U12*I3[162] + loo2p*I2[210]
        + (sixo2z)*I1[120] - (sixo4zn)*I4[120];
*(vp++) = U02*I0[163] - U12*I3[163] + loo2p*I2[211]
        + (sixo2z)*I1[121] - (sixo4zn)*I4[121];
*(vp++) = U02*I0[164] - U12*I3[164] + loo2p*I2[212]
        + (sixo2z)*I1[122] - (sixo4zn)*I4[122] - (oneo4zn)*I5[81];
*(vp++) = U02*I0[165] - U12*I3[165] + loo2p*I2[213]
        + (sixo2z)*I1[123] - (sixo4zn)*I4[123];
*(vp++) = U02*I0[166] - U12*I3[166] + loo2p*I2[214]
        + (sixo2z)*I1[124] - (sixo4zn)*I4[124] - (oneo4zn)*I5[82];
*(vp++) = U02*I0[167] - U12*I3[167] + loo2p*I2[215]
        + (sixo2z)*I1[125] - (sixo4zn)*I4[125] - (twoo4zn)*I5[83];

}
