/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (gs|[r12,T1]|ps) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _t1_build_g0p0(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  REALTYPE onezboz;
  REALTYPE twozboz;
  REALTYPE threezboz;
  REALTYPE fourzboz;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  onezboz = 1.0*(Data->twozeta_b*Data->oo2z);
  twozboz = 2.0*(Data->twozeta_b*Data->oo2z);
  threezboz = 3.0*(Data->twozeta_b*Data->oo2z);
  fourzboz = 4.0*(Data->twozeta_b*Data->oo2z);
  U10 = ShellData->AB[0]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U11 = ShellData->AB[1]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U12 = ShellData->AB[2]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U0  = (Data->twozeta_a - Data->twozeta_b*(Data->twozeta_a*ShellData->ABdotAC + 5.000000))*Data->oo2z;

*(vp++) = U0*I0[0]
          - U10*(I1[0] - I2[0])
          - U11*(I1[3] - I2[1])
          - U12*(I1[6] - I2[2])
          + (fourzboz)*(I3[0] - AC0*I4[0]);
*(vp++) = U0*I0[1]
          - U10*(I1[1] - I2[1])
          - U11*(I1[4] - I2[3])
          - U12*(I1[7] - I2[4])
          + (fourzboz)*(I3[1] - AC0*I4[1]);
*(vp++) = U0*I0[2]
          - U10*(I1[2] - I2[2])
          - U11*(I1[5] - I2[4])
          - U12*(I1[8] - I2[5])
          + (fourzboz)*(I3[2] - AC0*I4[2]);
*(vp++) = U0*I0[3]
          - U10*(I1[3] - I2[6])
          - U11*(I1[9] - I2[7])
          - U12*(I1[12] - I2[8])
          + (threezboz)*(I3[6] - AC0*I4[3])
          + (onezboz)*(I3[1] - AC1*I4[0]);
*(vp++) = U0*I0[4]
          - U10*(I1[4] - I2[7])
          - U11*(I1[10] - I2[9])
          - U12*(I1[13] - I2[10])
          + (threezboz)*(I3[7] - AC0*I4[4])
          + (onezboz)*(I3[3] - AC1*I4[1]);
*(vp++) = U0*I0[5]
          - U10*(I1[5] - I2[8])
          - U11*(I1[11] - I2[10])
          - U12*(I1[14] - I2[11])
          + (threezboz)*(I3[8] - AC0*I4[5])
          + (onezboz)*(I3[4] - AC1*I4[2]);
*(vp++) = U0*I0[6]
          - U10*(I1[6] - I2[12])
          - U11*(I1[12] - I2[13])
          - U12*(I1[15] - I2[14])
          + (threezboz)*(I3[12] - AC0*I4[6])
          + (onezboz)*(I3[2] - AC2*I4[0]);
*(vp++) = U0*I0[7]
          - U10*(I1[7] - I2[13])
          - U11*(I1[13] - I2[15])
          - U12*(I1[16] - I2[16])
          + (threezboz)*(I3[13] - AC0*I4[7])
          + (onezboz)*(I3[4] - AC2*I4[1]);
*(vp++) = U0*I0[8]
          - U10*(I1[8] - I2[14])
          - U11*(I1[14] - I2[16])
          - U12*(I1[17] - I2[17])
          + (threezboz)*(I3[14] - AC0*I4[8])
          + (onezboz)*(I3[5] - AC2*I4[2]);
*(vp++) = U0*I0[9]
          - U10*(I1[9] - I2[18])
          - U11*(I1[18] - I2[19])
          - U12*(I1[21] - I2[20])
          + (twozboz)*(I3[18] - AC0*I4[9])
          + (twozboz)*(I3[7] - AC1*I4[3]);
*(vp++) = U0*I0[10]
          - U10*(I1[10] - I2[19])
          - U11*(I1[19] - I2[21])
          - U12*(I1[22] - I2[22])
          + (twozboz)*(I3[19] - AC0*I4[10])
          + (twozboz)*(I3[9] - AC1*I4[4]);
*(vp++) = U0*I0[11]
          - U10*(I1[11] - I2[20])
          - U11*(I1[20] - I2[22])
          - U12*(I1[23] - I2[23])
          + (twozboz)*(I3[20] - AC0*I4[11])
          + (twozboz)*(I3[10] - AC1*I4[5]);
*(vp++) = U0*I0[12]
          - U10*(I1[12] - I2[24])
          - U11*(I1[21] - I2[25])
          - U12*(I1[24] - I2[26])
          + (twozboz)*(I3[24] - AC0*I4[12])
          + (onezboz)*(I3[13] - AC1*I4[6])
          + (onezboz)*(I3[8] - AC2*I4[3]);
*(vp++) = U0*I0[13]
          - U10*(I1[13] - I2[25])
          - U11*(I1[22] - I2[27])
          - U12*(I1[25] - I2[28])
          + (twozboz)*(I3[25] - AC0*I4[13])
          + (onezboz)*(I3[15] - AC1*I4[7])
          + (onezboz)*(I3[10] - AC2*I4[4]);
*(vp++) = U0*I0[14]
          - U10*(I1[14] - I2[26])
          - U11*(I1[23] - I2[28])
          - U12*(I1[26] - I2[29])
          + (twozboz)*(I3[26] - AC0*I4[14])
          + (onezboz)*(I3[16] - AC1*I4[8])
          + (onezboz)*(I3[11] - AC2*I4[5]);
*(vp++) = U0*I0[15]
          - U10*(I1[15] - I2[30])
          - U11*(I1[24] - I2[31])
          - U12*(I1[27] - I2[32])
          + (twozboz)*(I3[30] - AC0*I4[15])
          + (twozboz)*(I3[14] - AC2*I4[6]);
*(vp++) = U0*I0[16]
          - U10*(I1[16] - I2[31])
          - U11*(I1[25] - I2[33])
          - U12*(I1[28] - I2[34])
          + (twozboz)*(I3[31] - AC0*I4[16])
          + (twozboz)*(I3[16] - AC2*I4[7]);
*(vp++) = U0*I0[17]
          - U10*(I1[17] - I2[32])
          - U11*(I1[26] - I2[34])
          - U12*(I1[29] - I2[35])
          + (twozboz)*(I3[32] - AC0*I4[17])
          + (twozboz)*(I3[17] - AC2*I4[8]);
*(vp++) = U0*I0[18]
          - U10*(I1[18] - I2[36])
          - U11*(I1[30] - I2[37])
          - U12*(I1[33] - I2[38])
          + (onezboz)*(I3[36] - AC0*I4[18])
          + (threezboz)*(I3[19] - AC1*I4[9]);
*(vp++) = U0*I0[19]
          - U10*(I1[19] - I2[37])
          - U11*(I1[31] - I2[39])
          - U12*(I1[34] - I2[40])
          + (onezboz)*(I3[37] - AC0*I4[19])
          + (threezboz)*(I3[21] - AC1*I4[10]);
*(vp++) = U0*I0[20]
          - U10*(I1[20] - I2[38])
          - U11*(I1[32] - I2[40])
          - U12*(I1[35] - I2[41])
          + (onezboz)*(I3[38] - AC0*I4[20])
          + (threezboz)*(I3[22] - AC1*I4[11]);
*(vp++) = U0*I0[21]
          - U10*(I1[21] - I2[42])
          - U11*(I1[33] - I2[43])
          - U12*(I1[36] - I2[44])
          + (onezboz)*(I3[42] - AC0*I4[21])
          + (twozboz)*(I3[25] - AC1*I4[12])
          + (onezboz)*(I3[20] - AC2*I4[9]);
*(vp++) = U0*I0[22]
          - U10*(I1[22] - I2[43])
          - U11*(I1[34] - I2[45])
          - U12*(I1[37] - I2[46])
          + (onezboz)*(I3[43] - AC0*I4[22])
          + (twozboz)*(I3[27] - AC1*I4[13])
          + (onezboz)*(I3[22] - AC2*I4[10]);
*(vp++) = U0*I0[23]
          - U10*(I1[23] - I2[44])
          - U11*(I1[35] - I2[46])
          - U12*(I1[38] - I2[47])
          + (onezboz)*(I3[44] - AC0*I4[23])
          + (twozboz)*(I3[28] - AC1*I4[14])
          + (onezboz)*(I3[23] - AC2*I4[11]);
*(vp++) = U0*I0[24]
          - U10*(I1[24] - I2[48])
          - U11*(I1[36] - I2[49])
          - U12*(I1[39] - I2[50])
          + (onezboz)*(I3[48] - AC0*I4[24])
          + (onezboz)*(I3[31] - AC1*I4[15])
          + (twozboz)*(I3[26] - AC2*I4[12]);
*(vp++) = U0*I0[25]
          - U10*(I1[25] - I2[49])
          - U11*(I1[37] - I2[51])
          - U12*(I1[40] - I2[52])
          + (onezboz)*(I3[49] - AC0*I4[25])
          + (onezboz)*(I3[33] - AC1*I4[16])
          + (twozboz)*(I3[28] - AC2*I4[13]);
*(vp++) = U0*I0[26]
          - U10*(I1[26] - I2[50])
          - U11*(I1[38] - I2[52])
          - U12*(I1[41] - I2[53])
          + (onezboz)*(I3[50] - AC0*I4[26])
          + (onezboz)*(I3[34] - AC1*I4[17])
          + (twozboz)*(I3[29] - AC2*I4[14]);
*(vp++) = U0*I0[27]
          - U10*(I1[27] - I2[54])
          - U11*(I1[39] - I2[55])
          - U12*(I1[42] - I2[56])
          + (onezboz)*(I3[54] - AC0*I4[27])
          + (threezboz)*(I3[32] - AC2*I4[15]);
*(vp++) = U0*I0[28]
          - U10*(I1[28] - I2[55])
          - U11*(I1[40] - I2[57])
          - U12*(I1[43] - I2[58])
          + (onezboz)*(I3[55] - AC0*I4[28])
          + (threezboz)*(I3[34] - AC2*I4[16]);
*(vp++) = U0*I0[29]
          - U10*(I1[29] - I2[56])
          - U11*(I1[41] - I2[58])
          - U12*(I1[44] - I2[59])
          + (onezboz)*(I3[56] - AC0*I4[29])
          + (threezboz)*(I3[35] - AC2*I4[17]);
*(vp++) = U0*I0[30]
          - U10*(I1[30] - I2[60])
          - U11*(I1[45] - I2[61])
          - U12*(I1[48] - I2[62])
          + (fourzboz)*(I3[37] - AC1*I4[18]);
*(vp++) = U0*I0[31]
          - U10*(I1[31] - I2[61])
          - U11*(I1[46] - I2[63])
          - U12*(I1[49] - I2[64])
          + (fourzboz)*(I3[39] - AC1*I4[19]);
*(vp++) = U0*I0[32]
          - U10*(I1[32] - I2[62])
          - U11*(I1[47] - I2[64])
          - U12*(I1[50] - I2[65])
          + (fourzboz)*(I3[40] - AC1*I4[20]);
*(vp++) = U0*I0[33]
          - U10*(I1[33] - I2[66])
          - U11*(I1[48] - I2[67])
          - U12*(I1[51] - I2[68])
          + (threezboz)*(I3[43] - AC1*I4[21])
          + (onezboz)*(I3[38] - AC2*I4[18]);
*(vp++) = U0*I0[34]
          - U10*(I1[34] - I2[67])
          - U11*(I1[49] - I2[69])
          - U12*(I1[52] - I2[70])
          + (threezboz)*(I3[45] - AC1*I4[22])
          + (onezboz)*(I3[40] - AC2*I4[19]);
*(vp++) = U0*I0[35]
          - U10*(I1[35] - I2[68])
          - U11*(I1[50] - I2[70])
          - U12*(I1[53] - I2[71])
          + (threezboz)*(I3[46] - AC1*I4[23])
          + (onezboz)*(I3[41] - AC2*I4[20]);
*(vp++) = U0*I0[36]
          - U10*(I1[36] - I2[72])
          - U11*(I1[51] - I2[73])
          - U12*(I1[54] - I2[74])
          + (twozboz)*(I3[49] - AC1*I4[24])
          + (twozboz)*(I3[44] - AC2*I4[21]);
*(vp++) = U0*I0[37]
          - U10*(I1[37] - I2[73])
          - U11*(I1[52] - I2[75])
          - U12*(I1[55] - I2[76])
          + (twozboz)*(I3[51] - AC1*I4[25])
          + (twozboz)*(I3[46] - AC2*I4[22]);
*(vp++) = U0*I0[38]
          - U10*(I1[38] - I2[74])
          - U11*(I1[53] - I2[76])
          - U12*(I1[56] - I2[77])
          + (twozboz)*(I3[52] - AC1*I4[26])
          + (twozboz)*(I3[47] - AC2*I4[23]);
*(vp++) = U0*I0[39]
          - U10*(I1[39] - I2[78])
          - U11*(I1[54] - I2[79])
          - U12*(I1[57] - I2[80])
          + (onezboz)*(I3[55] - AC1*I4[27])
          + (threezboz)*(I3[50] - AC2*I4[24]);
*(vp++) = U0*I0[40]
          - U10*(I1[40] - I2[79])
          - U11*(I1[55] - I2[81])
          - U12*(I1[58] - I2[82])
          + (onezboz)*(I3[57] - AC1*I4[28])
          + (threezboz)*(I3[52] - AC2*I4[25]);
*(vp++) = U0*I0[41]
          - U10*(I1[41] - I2[80])
          - U11*(I1[56] - I2[82])
          - U12*(I1[59] - I2[83])
          + (onezboz)*(I3[58] - AC1*I4[29])
          + (threezboz)*(I3[53] - AC2*I4[26]);
*(vp++) = U0*I0[42]
          - U10*(I1[42] - I2[84])
          - U11*(I1[57] - I2[85])
          - U12*(I1[60] - I2[86])
          + (fourzboz)*(I3[56] - AC2*I4[27]);
*(vp++) = U0*I0[43]
          - U10*(I1[43] - I2[85])
          - U11*(I1[58] - I2[87])
          - U12*(I1[61] - I2[88])
          + (fourzboz)*(I3[58] - AC2*I4[28]);
*(vp++) = U0*I0[44]
          - U10*(I1[44] - I2[86])
          - U11*(I1[59] - I2[88])
          - U12*(I1[62] - I2[89])
          + (fourzboz)*(I3[59] - AC2*I4[29]);

}
