/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ps|[r12,T1]|ds) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _t1_build_p0d0(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  REALTYPE onezboz;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  onezboz = 1.0*(Data->twozeta_b*Data->oo2z);
  U10 = ShellData->AB[0]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U11 = ShellData->AB[1]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U12 = ShellData->AB[2]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U0  = (Data->twozeta_a - Data->twozeta_b*(Data->twozeta_a*ShellData->ABdotAC + 2.000000))*Data->oo2z;

*(vp++) = U0*I0[0]
          - U10*(I1[0] - I2[0])
          - U11*(I1[6] - I2[1])
          - U12*(I1[12] - I2[2])
          + (onezboz)*(I3[0] - AC0*I4[0]);
*(vp++) = U0*I0[1]
          - U10*(I1[1] - I2[1])
          - U11*(I1[7] - I2[3])
          - U12*(I1[13] - I2[4])
          + (onezboz)*(I3[1] - AC0*I4[1]);
*(vp++) = U0*I0[2]
          - U10*(I1[2] - I2[2])
          - U11*(I1[8] - I2[4])
          - U12*(I1[14] - I2[5])
          + (onezboz)*(I3[2] - AC0*I4[2]);
*(vp++) = U0*I0[3]
          - U10*(I1[3] - I2[3])
          - U11*(I1[9] - I2[6])
          - U12*(I1[15] - I2[7])
          + (onezboz)*(I3[3] - AC0*I4[3]);
*(vp++) = U0*I0[4]
          - U10*(I1[4] - I2[4])
          - U11*(I1[10] - I2[7])
          - U12*(I1[16] - I2[8])
          + (onezboz)*(I3[4] - AC0*I4[4]);
*(vp++) = U0*I0[5]
          - U10*(I1[5] - I2[5])
          - U11*(I1[11] - I2[8])
          - U12*(I1[17] - I2[9])
          + (onezboz)*(I3[5] - AC0*I4[5]);
*(vp++) = U0*I0[6]
          - U10*(I1[6] - I2[10])
          - U11*(I1[18] - I2[11])
          - U12*(I1[24] - I2[12])
          + (onezboz)*(I3[1] - AC1*I4[0]);
*(vp++) = U0*I0[7]
          - U10*(I1[7] - I2[11])
          - U11*(I1[19] - I2[13])
          - U12*(I1[25] - I2[14])
          + (onezboz)*(I3[3] - AC1*I4[1]);
*(vp++) = U0*I0[8]
          - U10*(I1[8] - I2[12])
          - U11*(I1[20] - I2[14])
          - U12*(I1[26] - I2[15])
          + (onezboz)*(I3[4] - AC1*I4[2]);
*(vp++) = U0*I0[9]
          - U10*(I1[9] - I2[13])
          - U11*(I1[21] - I2[16])
          - U12*(I1[27] - I2[17])
          + (onezboz)*(I3[6] - AC1*I4[3]);
*(vp++) = U0*I0[10]
          - U10*(I1[10] - I2[14])
          - U11*(I1[22] - I2[17])
          - U12*(I1[28] - I2[18])
          + (onezboz)*(I3[7] - AC1*I4[4]);
*(vp++) = U0*I0[11]
          - U10*(I1[11] - I2[15])
          - U11*(I1[23] - I2[18])
          - U12*(I1[29] - I2[19])
          + (onezboz)*(I3[8] - AC1*I4[5]);
*(vp++) = U0*I0[12]
          - U10*(I1[12] - I2[20])
          - U11*(I1[24] - I2[21])
          - U12*(I1[30] - I2[22])
          + (onezboz)*(I3[2] - AC2*I4[0]);
*(vp++) = U0*I0[13]
          - U10*(I1[13] - I2[21])
          - U11*(I1[25] - I2[23])
          - U12*(I1[31] - I2[24])
          + (onezboz)*(I3[4] - AC2*I4[1]);
*(vp++) = U0*I0[14]
          - U10*(I1[14] - I2[22])
          - U11*(I1[26] - I2[24])
          - U12*(I1[32] - I2[25])
          + (onezboz)*(I3[5] - AC2*I4[2]);
*(vp++) = U0*I0[15]
          - U10*(I1[15] - I2[23])
          - U11*(I1[27] - I2[26])
          - U12*(I1[33] - I2[27])
          + (onezboz)*(I3[7] - AC2*I4[3]);
*(vp++) = U0*I0[16]
          - U10*(I1[16] - I2[24])
          - U11*(I1[28] - I2[27])
          - U12*(I1[34] - I2[28])
          + (onezboz)*(I3[8] - AC2*I4[4]);
*(vp++) = U0*I0[17]
          - U10*(I1[17] - I2[25])
          - U11*(I1[29] - I2[28])
          - U12*(I1[35] - I2[29])
          + (onezboz)*(I3[9] - AC2*I4[5]);

}
