/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (hs|[r12,T2]|fs) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _t2_build_h0f0(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  REALTYPE onezdon;
  REALTYPE twozdon;
  REALTYPE threezdon;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  onezdon = 1.0*(Data->twozeta_d*Data->oo2n);
  twozdon = 2.0*(Data->twozeta_d*Data->oo2n);
  threezdon = 3.0*(Data->twozeta_d*Data->oo2n);
  U10 = ShellData->CD[0]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U11 = ShellData->CD[1]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U12 = ShellData->CD[2]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U0  = (Data->twozeta_c - Data->twozeta_d*(Data->twozeta_c*ShellData->CDdotCA + 4.000000))*Data->oo2n;

*(vp++) = U0*I0[0]
          - U10*(I1[0] - I2[0])
          - U11*(I1[1] - I2[10])
          - U12*(I1[2] - I2[20])
          + (threezdon)*(I3[0] + AC0*I4[0]);
*(vp++) = U0*I0[1]
          - U10*(I1[1] - I2[1])
          - U11*(I1[3] - I2[11])
          - U12*(I1[4] - I2[21])
          + (twozdon)*(I3[1] + AC0*I4[1])
          + (onezdon)*(I3[6] + AC1*I4[0]);
*(vp++) = U0*I0[2]
          - U10*(I1[2] - I2[2])
          - U11*(I1[4] - I2[12])
          - U12*(I1[5] - I2[22])
          + (twozdon)*(I3[2] + AC0*I4[2])
          + (onezdon)*(I3[12] + AC2*I4[0]);
*(vp++) = U0*I0[3]
          - U10*(I1[3] - I2[3])
          - U11*(I1[6] - I2[13])
          - U12*(I1[7] - I2[23])
          + (onezdon)*(I3[3] + AC0*I4[3])
          + (twozdon)*(I3[7] + AC1*I4[1]);
*(vp++) = U0*I0[4]
          - U10*(I1[4] - I2[4])
          - U11*(I1[7] - I2[14])
          - U12*(I1[8] - I2[24])
          + (onezdon)*(I3[4] + AC0*I4[4])
          + (onezdon)*(I3[8] + AC1*I4[2])
          + (onezdon)*(I3[13] + AC2*I4[1]);
*(vp++) = U0*I0[5]
          - U10*(I1[5] - I2[5])
          - U11*(I1[8] - I2[15])
          - U12*(I1[9] - I2[25])
          + (onezdon)*(I3[5] + AC0*I4[5])
          + (twozdon)*(I3[14] + AC2*I4[2]);
*(vp++) = U0*I0[6]
          - U10*(I1[6] - I2[6])
          - U11*(I1[10] - I2[16])
          - U12*(I1[11] - I2[26])
          + (threezdon)*(I3[9] + AC1*I4[3]);
*(vp++) = U0*I0[7]
          - U10*(I1[7] - I2[7])
          - U11*(I1[11] - I2[17])
          - U12*(I1[12] - I2[27])
          + (twozdon)*(I3[10] + AC1*I4[4])
          + (onezdon)*(I3[15] + AC2*I4[3]);
*(vp++) = U0*I0[8]
          - U10*(I1[8] - I2[8])
          - U11*(I1[12] - I2[18])
          - U12*(I1[13] - I2[28])
          + (onezdon)*(I3[11] + AC1*I4[5])
          + (twozdon)*(I3[16] + AC2*I4[4]);
*(vp++) = U0*I0[9]
          - U10*(I1[9] - I2[9])
          - U11*(I1[13] - I2[19])
          - U12*(I1[14] - I2[29])
          + (threezdon)*(I3[17] + AC2*I4[5]);
*(vp++) = U0*I0[10]
          - U10*(I1[15] - I2[10])
          - U11*(I1[16] - I2[30])
          - U12*(I1[17] - I2[40])
          + (threezdon)*(I3[6] + AC0*I4[6]);
*(vp++) = U0*I0[11]
          - U10*(I1[16] - I2[11])
          - U11*(I1[18] - I2[31])
          - U12*(I1[19] - I2[41])
          + (twozdon)*(I3[7] + AC0*I4[7])
          + (onezdon)*(I3[18] + AC1*I4[6]);
*(vp++) = U0*I0[12]
          - U10*(I1[17] - I2[12])
          - U11*(I1[19] - I2[32])
          - U12*(I1[20] - I2[42])
          + (twozdon)*(I3[8] + AC0*I4[8])
          + (onezdon)*(I3[24] + AC2*I4[6]);
*(vp++) = U0*I0[13]
          - U10*(I1[18] - I2[13])
          - U11*(I1[21] - I2[33])
          - U12*(I1[22] - I2[43])
          + (onezdon)*(I3[9] + AC0*I4[9])
          + (twozdon)*(I3[19] + AC1*I4[7]);
*(vp++) = U0*I0[14]
          - U10*(I1[19] - I2[14])
          - U11*(I1[22] - I2[34])
          - U12*(I1[23] - I2[44])
          + (onezdon)*(I3[10] + AC0*I4[10])
          + (onezdon)*(I3[20] + AC1*I4[8])
          + (onezdon)*(I3[25] + AC2*I4[7]);
*(vp++) = U0*I0[15]
          - U10*(I1[20] - I2[15])
          - U11*(I1[23] - I2[35])
          - U12*(I1[24] - I2[45])
          + (onezdon)*(I3[11] + AC0*I4[11])
          + (twozdon)*(I3[26] + AC2*I4[8]);
*(vp++) = U0*I0[16]
          - U10*(I1[21] - I2[16])
          - U11*(I1[25] - I2[36])
          - U12*(I1[26] - I2[46])
          + (threezdon)*(I3[21] + AC1*I4[9]);
*(vp++) = U0*I0[17]
          - U10*(I1[22] - I2[17])
          - U11*(I1[26] - I2[37])
          - U12*(I1[27] - I2[47])
          + (twozdon)*(I3[22] + AC1*I4[10])
          + (onezdon)*(I3[27] + AC2*I4[9]);
*(vp++) = U0*I0[18]
          - U10*(I1[23] - I2[18])
          - U11*(I1[27] - I2[38])
          - U12*(I1[28] - I2[48])
          + (onezdon)*(I3[23] + AC1*I4[11])
          + (twozdon)*(I3[28] + AC2*I4[10]);
*(vp++) = U0*I0[19]
          - U10*(I1[24] - I2[19])
          - U11*(I1[28] - I2[39])
          - U12*(I1[29] - I2[49])
          + (threezdon)*(I3[29] + AC2*I4[11]);
*(vp++) = U0*I0[20]
          - U10*(I1[30] - I2[20])
          - U11*(I1[31] - I2[40])
          - U12*(I1[32] - I2[50])
          + (threezdon)*(I3[12] + AC0*I4[12]);
*(vp++) = U0*I0[21]
          - U10*(I1[31] - I2[21])
          - U11*(I1[33] - I2[41])
          - U12*(I1[34] - I2[51])
          + (twozdon)*(I3[13] + AC0*I4[13])
          + (onezdon)*(I3[24] + AC1*I4[12]);
*(vp++) = U0*I0[22]
          - U10*(I1[32] - I2[22])
          - U11*(I1[34] - I2[42])
          - U12*(I1[35] - I2[52])
          + (twozdon)*(I3[14] + AC0*I4[14])
          + (onezdon)*(I3[30] + AC2*I4[12]);
*(vp++) = U0*I0[23]
          - U10*(I1[33] - I2[23])
          - U11*(I1[36] - I2[43])
          - U12*(I1[37] - I2[53])
          + (onezdon)*(I3[15] + AC0*I4[15])
          + (twozdon)*(I3[25] + AC1*I4[13]);
*(vp++) = U0*I0[24]
          - U10*(I1[34] - I2[24])
          - U11*(I1[37] - I2[44])
          - U12*(I1[38] - I2[54])
          + (onezdon)*(I3[16] + AC0*I4[16])
          + (onezdon)*(I3[26] + AC1*I4[14])
          + (onezdon)*(I3[31] + AC2*I4[13]);
*(vp++) = U0*I0[25]
          - U10*(I1[35] - I2[25])
          - U11*(I1[38] - I2[45])
          - U12*(I1[39] - I2[55])
          + (onezdon)*(I3[17] + AC0*I4[17])
          + (twozdon)*(I3[32] + AC2*I4[14]);
*(vp++) = U0*I0[26]
          - U10*(I1[36] - I2[26])
          - U11*(I1[40] - I2[46])
          - U12*(I1[41] - I2[56])
          + (threezdon)*(I3[27] + AC1*I4[15]);
*(vp++) = U0*I0[27]
          - U10*(I1[37] - I2[27])
          - U11*(I1[41] - I2[47])
          - U12*(I1[42] - I2[57])
          + (twozdon)*(I3[28] + AC1*I4[16])
          + (onezdon)*(I3[33] + AC2*I4[15]);
*(vp++) = U0*I0[28]
          - U10*(I1[38] - I2[28])
          - U11*(I1[42] - I2[48])
          - U12*(I1[43] - I2[58])
          + (onezdon)*(I3[29] + AC1*I4[17])
          + (twozdon)*(I3[34] + AC2*I4[16]);
*(vp++) = U0*I0[29]
          - U10*(I1[39] - I2[29])
          - U11*(I1[43] - I2[49])
          - U12*(I1[44] - I2[59])
          + (threezdon)*(I3[35] + AC2*I4[17]);
*(vp++) = U0*I0[30]
          - U10*(I1[45] - I2[30])
          - U11*(I1[46] - I2[60])
          - U12*(I1[47] - I2[70])
          + (threezdon)*(I3[18] + AC0*I4[18]);
*(vp++) = U0*I0[31]
          - U10*(I1[46] - I2[31])
          - U11*(I1[48] - I2[61])
          - U12*(I1[49] - I2[71])
          + (twozdon)*(I3[19] + AC0*I4[19])
          + (onezdon)*(I3[36] + AC1*I4[18]);
*(vp++) = U0*I0[32]
          - U10*(I1[47] - I2[32])
          - U11*(I1[49] - I2[62])
          - U12*(I1[50] - I2[72])
          + (twozdon)*(I3[20] + AC0*I4[20])
          + (onezdon)*(I3[42] + AC2*I4[18]);
*(vp++) = U0*I0[33]
          - U10*(I1[48] - I2[33])
          - U11*(I1[51] - I2[63])
          - U12*(I1[52] - I2[73])
          + (onezdon)*(I3[21] + AC0*I4[21])
          + (twozdon)*(I3[37] + AC1*I4[19]);
*(vp++) = U0*I0[34]
          - U10*(I1[49] - I2[34])
          - U11*(I1[52] - I2[64])
          - U12*(I1[53] - I2[74])
          + (onezdon)*(I3[22] + AC0*I4[22])
          + (onezdon)*(I3[38] + AC1*I4[20])
          + (onezdon)*(I3[43] + AC2*I4[19]);
*(vp++) = U0*I0[35]
          - U10*(I1[50] - I2[35])
          - U11*(I1[53] - I2[65])
          - U12*(I1[54] - I2[75])
          + (onezdon)*(I3[23] + AC0*I4[23])
          + (twozdon)*(I3[44] + AC2*I4[20]);
*(vp++) = U0*I0[36]
          - U10*(I1[51] - I2[36])
          - U11*(I1[55] - I2[66])
          - U12*(I1[56] - I2[76])
          + (threezdon)*(I3[39] + AC1*I4[21]);
*(vp++) = U0*I0[37]
          - U10*(I1[52] - I2[37])
          - U11*(I1[56] - I2[67])
          - U12*(I1[57] - I2[77])
          + (twozdon)*(I3[40] + AC1*I4[22])
          + (onezdon)*(I3[45] + AC2*I4[21]);
*(vp++) = U0*I0[38]
          - U10*(I1[53] - I2[38])
          - U11*(I1[57] - I2[68])
          - U12*(I1[58] - I2[78])
          + (onezdon)*(I3[41] + AC1*I4[23])
          + (twozdon)*(I3[46] + AC2*I4[22]);
*(vp++) = U0*I0[39]
          - U10*(I1[54] - I2[39])
          - U11*(I1[58] - I2[69])
          - U12*(I1[59] - I2[79])
          + (threezdon)*(I3[47] + AC2*I4[23]);
*(vp++) = U0*I0[40]
          - U10*(I1[60] - I2[40])
          - U11*(I1[61] - I2[70])
          - U12*(I1[62] - I2[80])
          + (threezdon)*(I3[24] + AC0*I4[24]);
*(vp++) = U0*I0[41]
          - U10*(I1[61] - I2[41])
          - U11*(I1[63] - I2[71])
          - U12*(I1[64] - I2[81])
          + (twozdon)*(I3[25] + AC0*I4[25])
          + (onezdon)*(I3[42] + AC1*I4[24]);
*(vp++) = U0*I0[42]
          - U10*(I1[62] - I2[42])
          - U11*(I1[64] - I2[72])
          - U12*(I1[65] - I2[82])
          + (twozdon)*(I3[26] + AC0*I4[26])
          + (onezdon)*(I3[48] + AC2*I4[24]);
*(vp++) = U0*I0[43]
          - U10*(I1[63] - I2[43])
          - U11*(I1[66] - I2[73])
          - U12*(I1[67] - I2[83])
          + (onezdon)*(I3[27] + AC0*I4[27])
          + (twozdon)*(I3[43] + AC1*I4[25]);
*(vp++) = U0*I0[44]
          - U10*(I1[64] - I2[44])
          - U11*(I1[67] - I2[74])
          - U12*(I1[68] - I2[84])
          + (onezdon)*(I3[28] + AC0*I4[28])
          + (onezdon)*(I3[44] + AC1*I4[26])
          + (onezdon)*(I3[49] + AC2*I4[25]);
*(vp++) = U0*I0[45]
          - U10*(I1[65] - I2[45])
          - U11*(I1[68] - I2[75])
          - U12*(I1[69] - I2[85])
          + (onezdon)*(I3[29] + AC0*I4[29])
          + (twozdon)*(I3[50] + AC2*I4[26]);
*(vp++) = U0*I0[46]
          - U10*(I1[66] - I2[46])
          - U11*(I1[70] - I2[76])
          - U12*(I1[71] - I2[86])
          + (threezdon)*(I3[45] + AC1*I4[27]);
*(vp++) = U0*I0[47]
          - U10*(I1[67] - I2[47])
          - U11*(I1[71] - I2[77])
          - U12*(I1[72] - I2[87])
          + (twozdon)*(I3[46] + AC1*I4[28])
          + (onezdon)*(I3[51] + AC2*I4[27]);
*(vp++) = U0*I0[48]
          - U10*(I1[68] - I2[48])
          - U11*(I1[72] - I2[78])
          - U12*(I1[73] - I2[88])
          + (onezdon)*(I3[47] + AC1*I4[29])
          + (twozdon)*(I3[52] + AC2*I4[28]);
*(vp++) = U0*I0[49]
          - U10*(I1[69] - I2[49])
          - U11*(I1[73] - I2[79])
          - U12*(I1[74] - I2[89])
          + (threezdon)*(I3[53] + AC2*I4[29]);
*(vp++) = U0*I0[50]
          - U10*(I1[75] - I2[50])
          - U11*(I1[76] - I2[80])
          - U12*(I1[77] - I2[90])
          + (threezdon)*(I3[30] + AC0*I4[30]);
*(vp++) = U0*I0[51]
          - U10*(I1[76] - I2[51])
          - U11*(I1[78] - I2[81])
          - U12*(I1[79] - I2[91])
          + (twozdon)*(I3[31] + AC0*I4[31])
          + (onezdon)*(I3[48] + AC1*I4[30]);
*(vp++) = U0*I0[52]
          - U10*(I1[77] - I2[52])
          - U11*(I1[79] - I2[82])
          - U12*(I1[80] - I2[92])
          + (twozdon)*(I3[32] + AC0*I4[32])
          + (onezdon)*(I3[54] + AC2*I4[30]);
*(vp++) = U0*I0[53]
          - U10*(I1[78] - I2[53])
          - U11*(I1[81] - I2[83])
          - U12*(I1[82] - I2[93])
          + (onezdon)*(I3[33] + AC0*I4[33])
          + (twozdon)*(I3[49] + AC1*I4[31]);
*(vp++) = U0*I0[54]
          - U10*(I1[79] - I2[54])
          - U11*(I1[82] - I2[84])
          - U12*(I1[83] - I2[94])
          + (onezdon)*(I3[34] + AC0*I4[34])
          + (onezdon)*(I3[50] + AC1*I4[32])
          + (onezdon)*(I3[55] + AC2*I4[31]);
*(vp++) = U0*I0[55]
          - U10*(I1[80] - I2[55])
          - U11*(I1[83] - I2[85])
          - U12*(I1[84] - I2[95])
          + (onezdon)*(I3[35] + AC0*I4[35])
          + (twozdon)*(I3[56] + AC2*I4[32]);
*(vp++) = U0*I0[56]
          - U10*(I1[81] - I2[56])
          - U11*(I1[85] - I2[86])
          - U12*(I1[86] - I2[96])
          + (threezdon)*(I3[51] + AC1*I4[33]);
*(vp++) = U0*I0[57]
          - U10*(I1[82] - I2[57])
          - U11*(I1[86] - I2[87])
          - U12*(I1[87] - I2[97])
          + (twozdon)*(I3[52] + AC1*I4[34])
          + (onezdon)*(I3[57] + AC2*I4[33]);
*(vp++) = U0*I0[58]
          - U10*(I1[83] - I2[58])
          - U11*(I1[87] - I2[88])
          - U12*(I1[88] - I2[98])
          + (onezdon)*(I3[53] + AC1*I4[35])
          + (twozdon)*(I3[58] + AC2*I4[34]);
*(vp++) = U0*I0[59]
          - U10*(I1[84] - I2[59])
          - U11*(I1[88] - I2[89])
          - U12*(I1[89] - I2[99])
          + (threezdon)*(I3[59] + AC2*I4[35]);
*(vp++) = U0*I0[60]
          - U10*(I1[90] - I2[60])
          - U11*(I1[91] - I2[100])
          - U12*(I1[92] - I2[110])
          + (threezdon)*(I3[36] + AC0*I4[36]);
*(vp++) = U0*I0[61]
          - U10*(I1[91] - I2[61])
          - U11*(I1[93] - I2[101])
          - U12*(I1[94] - I2[111])
          + (twozdon)*(I3[37] + AC0*I4[37])
          + (onezdon)*(I3[60] + AC1*I4[36]);
*(vp++) = U0*I0[62]
          - U10*(I1[92] - I2[62])
          - U11*(I1[94] - I2[102])
          - U12*(I1[95] - I2[112])
          + (twozdon)*(I3[38] + AC0*I4[38])
          + (onezdon)*(I3[66] + AC2*I4[36]);
*(vp++) = U0*I0[63]
          - U10*(I1[93] - I2[63])
          - U11*(I1[96] - I2[103])
          - U12*(I1[97] - I2[113])
          + (onezdon)*(I3[39] + AC0*I4[39])
          + (twozdon)*(I3[61] + AC1*I4[37]);
*(vp++) = U0*I0[64]
          - U10*(I1[94] - I2[64])
          - U11*(I1[97] - I2[104])
          - U12*(I1[98] - I2[114])
          + (onezdon)*(I3[40] + AC0*I4[40])
          + (onezdon)*(I3[62] + AC1*I4[38])
          + (onezdon)*(I3[67] + AC2*I4[37]);
*(vp++) = U0*I0[65]
          - U10*(I1[95] - I2[65])
          - U11*(I1[98] - I2[105])
          - U12*(I1[99] - I2[115])
          + (onezdon)*(I3[41] + AC0*I4[41])
          + (twozdon)*(I3[68] + AC2*I4[38]);
*(vp++) = U0*I0[66]
          - U10*(I1[96] - I2[66])
          - U11*(I1[100] - I2[106])
          - U12*(I1[101] - I2[116])
          + (threezdon)*(I3[63] + AC1*I4[39]);
*(vp++) = U0*I0[67]
          - U10*(I1[97] - I2[67])
          - U11*(I1[101] - I2[107])
          - U12*(I1[102] - I2[117])
          + (twozdon)*(I3[64] + AC1*I4[40])
          + (onezdon)*(I3[69] + AC2*I4[39]);
*(vp++) = U0*I0[68]
          - U10*(I1[98] - I2[68])
          - U11*(I1[102] - I2[108])
          - U12*(I1[103] - I2[118])
          + (onezdon)*(I3[65] + AC1*I4[41])
          + (twozdon)*(I3[70] + AC2*I4[40]);
*(vp++) = U0*I0[69]
          - U10*(I1[99] - I2[69])
          - U11*(I1[103] - I2[109])
          - U12*(I1[104] - I2[119])
          + (threezdon)*(I3[71] + AC2*I4[41]);
*(vp++) = U0*I0[70]
          - U10*(I1[105] - I2[70])
          - U11*(I1[106] - I2[110])
          - U12*(I1[107] - I2[120])
          + (threezdon)*(I3[42] + AC0*I4[42]);
*(vp++) = U0*I0[71]
          - U10*(I1[106] - I2[71])
          - U11*(I1[108] - I2[111])
          - U12*(I1[109] - I2[121])
          + (twozdon)*(I3[43] + AC0*I4[43])
          + (onezdon)*(I3[66] + AC1*I4[42]);
*(vp++) = U0*I0[72]
          - U10*(I1[107] - I2[72])
          - U11*(I1[109] - I2[112])
          - U12*(I1[110] - I2[122])
          + (twozdon)*(I3[44] + AC0*I4[44])
          + (onezdon)*(I3[72] + AC2*I4[42]);
*(vp++) = U0*I0[73]
          - U10*(I1[108] - I2[73])
          - U11*(I1[111] - I2[113])
          - U12*(I1[112] - I2[123])
          + (onezdon)*(I3[45] + AC0*I4[45])
          + (twozdon)*(I3[67] + AC1*I4[43]);
*(vp++) = U0*I0[74]
          - U10*(I1[109] - I2[74])
          - U11*(I1[112] - I2[114])
          - U12*(I1[113] - I2[124])
          + (onezdon)*(I3[46] + AC0*I4[46])
          + (onezdon)*(I3[68] + AC1*I4[44])
          + (onezdon)*(I3[73] + AC2*I4[43]);
*(vp++) = U0*I0[75]
          - U10*(I1[110] - I2[75])
          - U11*(I1[113] - I2[115])
          - U12*(I1[114] - I2[125])
          + (onezdon)*(I3[47] + AC0*I4[47])
          + (twozdon)*(I3[74] + AC2*I4[44]);
*(vp++) = U0*I0[76]
          - U10*(I1[111] - I2[76])
          - U11*(I1[115] - I2[116])
          - U12*(I1[116] - I2[126])
          + (threezdon)*(I3[69] + AC1*I4[45]);
*(vp++) = U0*I0[77]
          - U10*(I1[112] - I2[77])
          - U11*(I1[116] - I2[117])
          - U12*(I1[117] - I2[127])
          + (twozdon)*(I3[70] + AC1*I4[46])
          + (onezdon)*(I3[75] + AC2*I4[45]);
*(vp++) = U0*I0[78]
          - U10*(I1[113] - I2[78])
          - U11*(I1[117] - I2[118])
          - U12*(I1[118] - I2[128])
          + (onezdon)*(I3[71] + AC1*I4[47])
          + (twozdon)*(I3[76] + AC2*I4[46]);
*(vp++) = U0*I0[79]
          - U10*(I1[114] - I2[79])
          - U11*(I1[118] - I2[119])
          - U12*(I1[119] - I2[129])
          + (threezdon)*(I3[77] + AC2*I4[47]);
*(vp++) = U0*I0[80]
          - U10*(I1[120] - I2[80])
          - U11*(I1[121] - I2[120])
          - U12*(I1[122] - I2[130])
          + (threezdon)*(I3[48] + AC0*I4[48]);
*(vp++) = U0*I0[81]
          - U10*(I1[121] - I2[81])
          - U11*(I1[123] - I2[121])
          - U12*(I1[124] - I2[131])
          + (twozdon)*(I3[49] + AC0*I4[49])
          + (onezdon)*(I3[72] + AC1*I4[48]);
*(vp++) = U0*I0[82]
          - U10*(I1[122] - I2[82])
          - U11*(I1[124] - I2[122])
          - U12*(I1[125] - I2[132])
          + (twozdon)*(I3[50] + AC0*I4[50])
          + (onezdon)*(I3[78] + AC2*I4[48]);
*(vp++) = U0*I0[83]
          - U10*(I1[123] - I2[83])
          - U11*(I1[126] - I2[123])
          - U12*(I1[127] - I2[133])
          + (onezdon)*(I3[51] + AC0*I4[51])
          + (twozdon)*(I3[73] + AC1*I4[49]);
*(vp++) = U0*I0[84]
          - U10*(I1[124] - I2[84])
          - U11*(I1[127] - I2[124])
          - U12*(I1[128] - I2[134])
          + (onezdon)*(I3[52] + AC0*I4[52])
          + (onezdon)*(I3[74] + AC1*I4[50])
          + (onezdon)*(I3[79] + AC2*I4[49]);
*(vp++) = U0*I0[85]
          - U10*(I1[125] - I2[85])
          - U11*(I1[128] - I2[125])
          - U12*(I1[129] - I2[135])
          + (onezdon)*(I3[53] + AC0*I4[53])
          + (twozdon)*(I3[80] + AC2*I4[50]);
*(vp++) = U0*I0[86]
          - U10*(I1[126] - I2[86])
          - U11*(I1[130] - I2[126])
          - U12*(I1[131] - I2[136])
          + (threezdon)*(I3[75] + AC1*I4[51]);
*(vp++) = U0*I0[87]
          - U10*(I1[127] - I2[87])
          - U11*(I1[131] - I2[127])
          - U12*(I1[132] - I2[137])
          + (twozdon)*(I3[76] + AC1*I4[52])
          + (onezdon)*(I3[81] + AC2*I4[51]);
*(vp++) = U0*I0[88]
          - U10*(I1[128] - I2[88])
          - U11*(I1[132] - I2[128])
          - U12*(I1[133] - I2[138])
          + (onezdon)*(I3[77] + AC1*I4[53])
          + (twozdon)*(I3[82] + AC2*I4[52]);
*(vp++) = U0*I0[89]
          - U10*(I1[129] - I2[89])
          - U11*(I1[133] - I2[129])
          - U12*(I1[134] - I2[139])
          + (threezdon)*(I3[83] + AC2*I4[53]);
*(vp++) = U0*I0[90]
          - U10*(I1[135] - I2[90])
          - U11*(I1[136] - I2[130])
          - U12*(I1[137] - I2[140])
          + (threezdon)*(I3[54] + AC0*I4[54]);
*(vp++) = U0*I0[91]
          - U10*(I1[136] - I2[91])
          - U11*(I1[138] - I2[131])
          - U12*(I1[139] - I2[141])
          + (twozdon)*(I3[55] + AC0*I4[55])
          + (onezdon)*(I3[78] + AC1*I4[54]);
*(vp++) = U0*I0[92]
          - U10*(I1[137] - I2[92])
          - U11*(I1[139] - I2[132])
          - U12*(I1[140] - I2[142])
          + (twozdon)*(I3[56] + AC0*I4[56])
          + (onezdon)*(I3[84] + AC2*I4[54]);
*(vp++) = U0*I0[93]
          - U10*(I1[138] - I2[93])
          - U11*(I1[141] - I2[133])
          - U12*(I1[142] - I2[143])
          + (onezdon)*(I3[57] + AC0*I4[57])
          + (twozdon)*(I3[79] + AC1*I4[55]);
*(vp++) = U0*I0[94]
          - U10*(I1[139] - I2[94])
          - U11*(I1[142] - I2[134])
          - U12*(I1[143] - I2[144])
          + (onezdon)*(I3[58] + AC0*I4[58])
          + (onezdon)*(I3[80] + AC1*I4[56])
          + (onezdon)*(I3[85] + AC2*I4[55]);
*(vp++) = U0*I0[95]
          - U10*(I1[140] - I2[95])
          - U11*(I1[143] - I2[135])
          - U12*(I1[144] - I2[145])
          + (onezdon)*(I3[59] + AC0*I4[59])
          + (twozdon)*(I3[86] + AC2*I4[56]);
*(vp++) = U0*I0[96]
          - U10*(I1[141] - I2[96])
          - U11*(I1[145] - I2[136])
          - U12*(I1[146] - I2[146])
          + (threezdon)*(I3[81] + AC1*I4[57]);
*(vp++) = U0*I0[97]
          - U10*(I1[142] - I2[97])
          - U11*(I1[146] - I2[137])
          - U12*(I1[147] - I2[147])
          + (twozdon)*(I3[82] + AC1*I4[58])
          + (onezdon)*(I3[87] + AC2*I4[57]);
*(vp++) = U0*I0[98]
          - U10*(I1[143] - I2[98])
          - U11*(I1[147] - I2[138])
          - U12*(I1[148] - I2[148])
          + (onezdon)*(I3[83] + AC1*I4[59])
          + (twozdon)*(I3[88] + AC2*I4[58]);
*(vp++) = U0*I0[99]
          - U10*(I1[144] - I2[99])
          - U11*(I1[148] - I2[139])
          - U12*(I1[149] - I2[149])
          + (threezdon)*(I3[89] + AC2*I4[59]);
*(vp++) = U0*I0[100]
          - U10*(I1[150] - I2[100])
          - U11*(I1[151] - I2[150])
          - U12*(I1[152] - I2[160])
          + (threezdon)*(I3[60] + AC0*I4[60]);
*(vp++) = U0*I0[101]
          - U10*(I1[151] - I2[101])
          - U11*(I1[153] - I2[151])
          - U12*(I1[154] - I2[161])
          + (twozdon)*(I3[61] + AC0*I4[61])
          + (onezdon)*(I3[90] + AC1*I4[60]);
*(vp++) = U0*I0[102]
          - U10*(I1[152] - I2[102])
          - U11*(I1[154] - I2[152])
          - U12*(I1[155] - I2[162])
          + (twozdon)*(I3[62] + AC0*I4[62])
          + (onezdon)*(I3[96] + AC2*I4[60]);
*(vp++) = U0*I0[103]
          - U10*(I1[153] - I2[103])
          - U11*(I1[156] - I2[153])
          - U12*(I1[157] - I2[163])
          + (onezdon)*(I3[63] + AC0*I4[63])
          + (twozdon)*(I3[91] + AC1*I4[61]);
*(vp++) = U0*I0[104]
          - U10*(I1[154] - I2[104])
          - U11*(I1[157] - I2[154])
          - U12*(I1[158] - I2[164])
          + (onezdon)*(I3[64] + AC0*I4[64])
          + (onezdon)*(I3[92] + AC1*I4[62])
          + (onezdon)*(I3[97] + AC2*I4[61]);
*(vp++) = U0*I0[105]
          - U10*(I1[155] - I2[105])
          - U11*(I1[158] - I2[155])
          - U12*(I1[159] - I2[165])
          + (onezdon)*(I3[65] + AC0*I4[65])
          + (twozdon)*(I3[98] + AC2*I4[62]);
*(vp++) = U0*I0[106]
          - U10*(I1[156] - I2[106])
          - U11*(I1[160] - I2[156])
          - U12*(I1[161] - I2[166])
          + (threezdon)*(I3[93] + AC1*I4[63]);
*(vp++) = U0*I0[107]
          - U10*(I1[157] - I2[107])
          - U11*(I1[161] - I2[157])
          - U12*(I1[162] - I2[167])
          + (twozdon)*(I3[94] + AC1*I4[64])
          + (onezdon)*(I3[99] + AC2*I4[63]);
*(vp++) = U0*I0[108]
          - U10*(I1[158] - I2[108])
          - U11*(I1[162] - I2[158])
          - U12*(I1[163] - I2[168])
          + (onezdon)*(I3[95] + AC1*I4[65])
          + (twozdon)*(I3[100] + AC2*I4[64]);
*(vp++) = U0*I0[109]
          - U10*(I1[159] - I2[109])
          - U11*(I1[163] - I2[159])
          - U12*(I1[164] - I2[169])
          + (threezdon)*(I3[101] + AC2*I4[65]);
*(vp++) = U0*I0[110]
          - U10*(I1[165] - I2[110])
          - U11*(I1[166] - I2[160])
          - U12*(I1[167] - I2[170])
          + (threezdon)*(I3[66] + AC0*I4[66]);
*(vp++) = U0*I0[111]
          - U10*(I1[166] - I2[111])
          - U11*(I1[168] - I2[161])
          - U12*(I1[169] - I2[171])
          + (twozdon)*(I3[67] + AC0*I4[67])
          + (onezdon)*(I3[96] + AC1*I4[66]);
*(vp++) = U0*I0[112]
          - U10*(I1[167] - I2[112])
          - U11*(I1[169] - I2[162])
          - U12*(I1[170] - I2[172])
          + (twozdon)*(I3[68] + AC0*I4[68])
          + (onezdon)*(I3[102] + AC2*I4[66]);
*(vp++) = U0*I0[113]
          - U10*(I1[168] - I2[113])
          - U11*(I1[171] - I2[163])
          - U12*(I1[172] - I2[173])
          + (onezdon)*(I3[69] + AC0*I4[69])
          + (twozdon)*(I3[97] + AC1*I4[67]);
*(vp++) = U0*I0[114]
          - U10*(I1[169] - I2[114])
          - U11*(I1[172] - I2[164])
          - U12*(I1[173] - I2[174])
          + (onezdon)*(I3[70] + AC0*I4[70])
          + (onezdon)*(I3[98] + AC1*I4[68])
          + (onezdon)*(I3[103] + AC2*I4[67]);
*(vp++) = U0*I0[115]
          - U10*(I1[170] - I2[115])
          - U11*(I1[173] - I2[165])
          - U12*(I1[174] - I2[175])
          + (onezdon)*(I3[71] + AC0*I4[71])
          + (twozdon)*(I3[104] + AC2*I4[68]);
*(vp++) = U0*I0[116]
          - U10*(I1[171] - I2[116])
          - U11*(I1[175] - I2[166])
          - U12*(I1[176] - I2[176])
          + (threezdon)*(I3[99] + AC1*I4[69]);
*(vp++) = U0*I0[117]
          - U10*(I1[172] - I2[117])
          - U11*(I1[176] - I2[167])
          - U12*(I1[177] - I2[177])
          + (twozdon)*(I3[100] + AC1*I4[70])
          + (onezdon)*(I3[105] + AC2*I4[69]);
*(vp++) = U0*I0[118]
          - U10*(I1[173] - I2[118])
          - U11*(I1[177] - I2[168])
          - U12*(I1[178] - I2[178])
          + (onezdon)*(I3[101] + AC1*I4[71])
          + (twozdon)*(I3[106] + AC2*I4[70]);
*(vp++) = U0*I0[119]
          - U10*(I1[174] - I2[119])
          - U11*(I1[178] - I2[169])
          - U12*(I1[179] - I2[179])
          + (threezdon)*(I3[107] + AC2*I4[71]);
*(vp++) = U0*I0[120]
          - U10*(I1[180] - I2[120])
          - U11*(I1[181] - I2[170])
          - U12*(I1[182] - I2[180])
          + (threezdon)*(I3[72] + AC0*I4[72]);
*(vp++) = U0*I0[121]
          - U10*(I1[181] - I2[121])
          - U11*(I1[183] - I2[171])
          - U12*(I1[184] - I2[181])
          + (twozdon)*(I3[73] + AC0*I4[73])
          + (onezdon)*(I3[102] + AC1*I4[72]);
*(vp++) = U0*I0[122]
          - U10*(I1[182] - I2[122])
          - U11*(I1[184] - I2[172])
          - U12*(I1[185] - I2[182])
          + (twozdon)*(I3[74] + AC0*I4[74])
          + (onezdon)*(I3[108] + AC2*I4[72]);
*(vp++) = U0*I0[123]
          - U10*(I1[183] - I2[123])
          - U11*(I1[186] - I2[173])
          - U12*(I1[187] - I2[183])
          + (onezdon)*(I3[75] + AC0*I4[75])
          + (twozdon)*(I3[103] + AC1*I4[73]);
*(vp++) = U0*I0[124]
          - U10*(I1[184] - I2[124])
          - U11*(I1[187] - I2[174])
          - U12*(I1[188] - I2[184])
          + (onezdon)*(I3[76] + AC0*I4[76])
          + (onezdon)*(I3[104] + AC1*I4[74])
          + (onezdon)*(I3[109] + AC2*I4[73]);
*(vp++) = U0*I0[125]
          - U10*(I1[185] - I2[125])
          - U11*(I1[188] - I2[175])
          - U12*(I1[189] - I2[185])
          + (onezdon)*(I3[77] + AC0*I4[77])
          + (twozdon)*(I3[110] + AC2*I4[74]);
*(vp++) = U0*I0[126]
          - U10*(I1[186] - I2[126])
          - U11*(I1[190] - I2[176])
          - U12*(I1[191] - I2[186])
          + (threezdon)*(I3[105] + AC1*I4[75]);
*(vp++) = U0*I0[127]
          - U10*(I1[187] - I2[127])
          - U11*(I1[191] - I2[177])
          - U12*(I1[192] - I2[187])
          + (twozdon)*(I3[106] + AC1*I4[76])
          + (onezdon)*(I3[111] + AC2*I4[75]);
*(vp++) = U0*I0[128]
          - U10*(I1[188] - I2[128])
          - U11*(I1[192] - I2[178])
          - U12*(I1[193] - I2[188])
          + (onezdon)*(I3[107] + AC1*I4[77])
          + (twozdon)*(I3[112] + AC2*I4[76]);
*(vp++) = U0*I0[129]
          - U10*(I1[189] - I2[129])
          - U11*(I1[193] - I2[179])
          - U12*(I1[194] - I2[189])
          + (threezdon)*(I3[113] + AC2*I4[77]);
*(vp++) = U0*I0[130]
          - U10*(I1[195] - I2[130])
          - U11*(I1[196] - I2[180])
          - U12*(I1[197] - I2[190])
          + (threezdon)*(I3[78] + AC0*I4[78]);
*(vp++) = U0*I0[131]
          - U10*(I1[196] - I2[131])
          - U11*(I1[198] - I2[181])
          - U12*(I1[199] - I2[191])
          + (twozdon)*(I3[79] + AC0*I4[79])
          + (onezdon)*(I3[108] + AC1*I4[78]);
*(vp++) = U0*I0[132]
          - U10*(I1[197] - I2[132])
          - U11*(I1[199] - I2[182])
          - U12*(I1[200] - I2[192])
          + (twozdon)*(I3[80] + AC0*I4[80])
          + (onezdon)*(I3[114] + AC2*I4[78]);
*(vp++) = U0*I0[133]
          - U10*(I1[198] - I2[133])
          - U11*(I1[201] - I2[183])
          - U12*(I1[202] - I2[193])
          + (onezdon)*(I3[81] + AC0*I4[81])
          + (twozdon)*(I3[109] + AC1*I4[79]);
*(vp++) = U0*I0[134]
          - U10*(I1[199] - I2[134])
          - U11*(I1[202] - I2[184])
          - U12*(I1[203] - I2[194])
          + (onezdon)*(I3[82] + AC0*I4[82])
          + (onezdon)*(I3[110] + AC1*I4[80])
          + (onezdon)*(I3[115] + AC2*I4[79]);
*(vp++) = U0*I0[135]
          - U10*(I1[200] - I2[135])
          - U11*(I1[203] - I2[185])
          - U12*(I1[204] - I2[195])
          + (onezdon)*(I3[83] + AC0*I4[83])
          + (twozdon)*(I3[116] + AC2*I4[80]);
*(vp++) = U0*I0[136]
          - U10*(I1[201] - I2[136])
          - U11*(I1[205] - I2[186])
          - U12*(I1[206] - I2[196])
          + (threezdon)*(I3[111] + AC1*I4[81]);
*(vp++) = U0*I0[137]
          - U10*(I1[202] - I2[137])
          - U11*(I1[206] - I2[187])
          - U12*(I1[207] - I2[197])
          + (twozdon)*(I3[112] + AC1*I4[82])
          + (onezdon)*(I3[117] + AC2*I4[81]);
*(vp++) = U0*I0[138]
          - U10*(I1[203] - I2[138])
          - U11*(I1[207] - I2[188])
          - U12*(I1[208] - I2[198])
          + (onezdon)*(I3[113] + AC1*I4[83])
          + (twozdon)*(I3[118] + AC2*I4[82]);
*(vp++) = U0*I0[139]
          - U10*(I1[204] - I2[139])
          - U11*(I1[208] - I2[189])
          - U12*(I1[209] - I2[199])
          + (threezdon)*(I3[119] + AC2*I4[83]);
*(vp++) = U0*I0[140]
          - U10*(I1[210] - I2[140])
          - U11*(I1[211] - I2[190])
          - U12*(I1[212] - I2[200])
          + (threezdon)*(I3[84] + AC0*I4[84]);
*(vp++) = U0*I0[141]
          - U10*(I1[211] - I2[141])
          - U11*(I1[213] - I2[191])
          - U12*(I1[214] - I2[201])
          + (twozdon)*(I3[85] + AC0*I4[85])
          + (onezdon)*(I3[114] + AC1*I4[84]);
*(vp++) = U0*I0[142]
          - U10*(I1[212] - I2[142])
          - U11*(I1[214] - I2[192])
          - U12*(I1[215] - I2[202])
          + (twozdon)*(I3[86] + AC0*I4[86])
          + (onezdon)*(I3[120] + AC2*I4[84]);
*(vp++) = U0*I0[143]
          - U10*(I1[213] - I2[143])
          - U11*(I1[216] - I2[193])
          - U12*(I1[217] - I2[203])
          + (onezdon)*(I3[87] + AC0*I4[87])
          + (twozdon)*(I3[115] + AC1*I4[85]);
*(vp++) = U0*I0[144]
          - U10*(I1[214] - I2[144])
          - U11*(I1[217] - I2[194])
          - U12*(I1[218] - I2[204])
          + (onezdon)*(I3[88] + AC0*I4[88])
          + (onezdon)*(I3[116] + AC1*I4[86])
          + (onezdon)*(I3[121] + AC2*I4[85]);
*(vp++) = U0*I0[145]
          - U10*(I1[215] - I2[145])
          - U11*(I1[218] - I2[195])
          - U12*(I1[219] - I2[205])
          + (onezdon)*(I3[89] + AC0*I4[89])
          + (twozdon)*(I3[122] + AC2*I4[86]);
*(vp++) = U0*I0[146]
          - U10*(I1[216] - I2[146])
          - U11*(I1[220] - I2[196])
          - U12*(I1[221] - I2[206])
          + (threezdon)*(I3[117] + AC1*I4[87]);
*(vp++) = U0*I0[147]
          - U10*(I1[217] - I2[147])
          - U11*(I1[221] - I2[197])
          - U12*(I1[222] - I2[207])
          + (twozdon)*(I3[118] + AC1*I4[88])
          + (onezdon)*(I3[123] + AC2*I4[87]);
*(vp++) = U0*I0[148]
          - U10*(I1[218] - I2[148])
          - U11*(I1[222] - I2[198])
          - U12*(I1[223] - I2[208])
          + (onezdon)*(I3[119] + AC1*I4[89])
          + (twozdon)*(I3[124] + AC2*I4[88]);
*(vp++) = U0*I0[149]
          - U10*(I1[219] - I2[149])
          - U11*(I1[223] - I2[199])
          - U12*(I1[224] - I2[209])
          + (threezdon)*(I3[125] + AC2*I4[89]);
*(vp++) = U0*I0[150]
          - U10*(I1[225] - I2[150])
          - U11*(I1[226] - I2[210])
          - U12*(I1[227] - I2[220])
          + (threezdon)*(I3[90] + AC0*I4[90]);
*(vp++) = U0*I0[151]
          - U10*(I1[226] - I2[151])
          - U11*(I1[228] - I2[211])
          - U12*(I1[229] - I2[221])
          + (twozdon)*(I3[91] + AC0*I4[91])
          + (onezdon)*(I3[126] + AC1*I4[90]);
*(vp++) = U0*I0[152]
          - U10*(I1[227] - I2[152])
          - U11*(I1[229] - I2[212])
          - U12*(I1[230] - I2[222])
          + (twozdon)*(I3[92] + AC0*I4[92])
          + (onezdon)*(I3[132] + AC2*I4[90]);
*(vp++) = U0*I0[153]
          - U10*(I1[228] - I2[153])
          - U11*(I1[231] - I2[213])
          - U12*(I1[232] - I2[223])
          + (onezdon)*(I3[93] + AC0*I4[93])
          + (twozdon)*(I3[127] + AC1*I4[91]);
*(vp++) = U0*I0[154]
          - U10*(I1[229] - I2[154])
          - U11*(I1[232] - I2[214])
          - U12*(I1[233] - I2[224])
          + (onezdon)*(I3[94] + AC0*I4[94])
          + (onezdon)*(I3[128] + AC1*I4[92])
          + (onezdon)*(I3[133] + AC2*I4[91]);
*(vp++) = U0*I0[155]
          - U10*(I1[230] - I2[155])
          - U11*(I1[233] - I2[215])
          - U12*(I1[234] - I2[225])
          + (onezdon)*(I3[95] + AC0*I4[95])
          + (twozdon)*(I3[134] + AC2*I4[92]);
*(vp++) = U0*I0[156]
          - U10*(I1[231] - I2[156])
          - U11*(I1[235] - I2[216])
          - U12*(I1[236] - I2[226])
          + (threezdon)*(I3[129] + AC1*I4[93]);
*(vp++) = U0*I0[157]
          - U10*(I1[232] - I2[157])
          - U11*(I1[236] - I2[217])
          - U12*(I1[237] - I2[227])
          + (twozdon)*(I3[130] + AC1*I4[94])
          + (onezdon)*(I3[135] + AC2*I4[93]);
*(vp++) = U0*I0[158]
          - U10*(I1[233] - I2[158])
          - U11*(I1[237] - I2[218])
          - U12*(I1[238] - I2[228])
          + (onezdon)*(I3[131] + AC1*I4[95])
          + (twozdon)*(I3[136] + AC2*I4[94]);
*(vp++) = U0*I0[159]
          - U10*(I1[234] - I2[159])
          - U11*(I1[238] - I2[219])
          - U12*(I1[239] - I2[229])
          + (threezdon)*(I3[137] + AC2*I4[95]);
*(vp++) = U0*I0[160]
          - U10*(I1[240] - I2[160])
          - U11*(I1[241] - I2[220])
          - U12*(I1[242] - I2[230])
          + (threezdon)*(I3[96] + AC0*I4[96]);
*(vp++) = U0*I0[161]
          - U10*(I1[241] - I2[161])
          - U11*(I1[243] - I2[221])
          - U12*(I1[244] - I2[231])
          + (twozdon)*(I3[97] + AC0*I4[97])
          + (onezdon)*(I3[132] + AC1*I4[96]);
*(vp++) = U0*I0[162]
          - U10*(I1[242] - I2[162])
          - U11*(I1[244] - I2[222])
          - U12*(I1[245] - I2[232])
          + (twozdon)*(I3[98] + AC0*I4[98])
          + (onezdon)*(I3[138] + AC2*I4[96]);
*(vp++) = U0*I0[163]
          - U10*(I1[243] - I2[163])
          - U11*(I1[246] - I2[223])
          - U12*(I1[247] - I2[233])
          + (onezdon)*(I3[99] + AC0*I4[99])
          + (twozdon)*(I3[133] + AC1*I4[97]);
*(vp++) = U0*I0[164]
          - U10*(I1[244] - I2[164])
          - U11*(I1[247] - I2[224])
          - U12*(I1[248] - I2[234])
          + (onezdon)*(I3[100] + AC0*I4[100])
          + (onezdon)*(I3[134] + AC1*I4[98])
          + (onezdon)*(I3[139] + AC2*I4[97]);
*(vp++) = U0*I0[165]
          - U10*(I1[245] - I2[165])
          - U11*(I1[248] - I2[225])
          - U12*(I1[249] - I2[235])
          + (onezdon)*(I3[101] + AC0*I4[101])
          + (twozdon)*(I3[140] + AC2*I4[98]);
*(vp++) = U0*I0[166]
          - U10*(I1[246] - I2[166])
          - U11*(I1[250] - I2[226])
          - U12*(I1[251] - I2[236])
          + (threezdon)*(I3[135] + AC1*I4[99]);
*(vp++) = U0*I0[167]
          - U10*(I1[247] - I2[167])
          - U11*(I1[251] - I2[227])
          - U12*(I1[252] - I2[237])
          + (twozdon)*(I3[136] + AC1*I4[100])
          + (onezdon)*(I3[141] + AC2*I4[99]);
*(vp++) = U0*I0[168]
          - U10*(I1[248] - I2[168])
          - U11*(I1[252] - I2[228])
          - U12*(I1[253] - I2[238])
          + (onezdon)*(I3[137] + AC1*I4[101])
          + (twozdon)*(I3[142] + AC2*I4[100]);
*(vp++) = U0*I0[169]
          - U10*(I1[249] - I2[169])
          - U11*(I1[253] - I2[229])
          - U12*(I1[254] - I2[239])
          + (threezdon)*(I3[143] + AC2*I4[101]);
*(vp++) = U0*I0[170]
          - U10*(I1[255] - I2[170])
          - U11*(I1[256] - I2[230])
          - U12*(I1[257] - I2[240])
          + (threezdon)*(I3[102] + AC0*I4[102]);
*(vp++) = U0*I0[171]
          - U10*(I1[256] - I2[171])
          - U11*(I1[258] - I2[231])
          - U12*(I1[259] - I2[241])
          + (twozdon)*(I3[103] + AC0*I4[103])
          + (onezdon)*(I3[138] + AC1*I4[102]);
*(vp++) = U0*I0[172]
          - U10*(I1[257] - I2[172])
          - U11*(I1[259] - I2[232])
          - U12*(I1[260] - I2[242])
          + (twozdon)*(I3[104] + AC0*I4[104])
          + (onezdon)*(I3[144] + AC2*I4[102]);
*(vp++) = U0*I0[173]
          - U10*(I1[258] - I2[173])
          - U11*(I1[261] - I2[233])
          - U12*(I1[262] - I2[243])
          + (onezdon)*(I3[105] + AC0*I4[105])
          + (twozdon)*(I3[139] + AC1*I4[103]);
*(vp++) = U0*I0[174]
          - U10*(I1[259] - I2[174])
          - U11*(I1[262] - I2[234])
          - U12*(I1[263] - I2[244])
          + (onezdon)*(I3[106] + AC0*I4[106])
          + (onezdon)*(I3[140] + AC1*I4[104])
          + (onezdon)*(I3[145] + AC2*I4[103]);
*(vp++) = U0*I0[175]
          - U10*(I1[260] - I2[175])
          - U11*(I1[263] - I2[235])
          - U12*(I1[264] - I2[245])
          + (onezdon)*(I3[107] + AC0*I4[107])
          + (twozdon)*(I3[146] + AC2*I4[104]);
*(vp++) = U0*I0[176]
          - U10*(I1[261] - I2[176])
          - U11*(I1[265] - I2[236])
          - U12*(I1[266] - I2[246])
          + (threezdon)*(I3[141] + AC1*I4[105]);
*(vp++) = U0*I0[177]
          - U10*(I1[262] - I2[177])
          - U11*(I1[266] - I2[237])
          - U12*(I1[267] - I2[247])
          + (twozdon)*(I3[142] + AC1*I4[106])
          + (onezdon)*(I3[147] + AC2*I4[105]);
*(vp++) = U0*I0[178]
          - U10*(I1[263] - I2[178])
          - U11*(I1[267] - I2[238])
          - U12*(I1[268] - I2[248])
          + (onezdon)*(I3[143] + AC1*I4[107])
          + (twozdon)*(I3[148] + AC2*I4[106]);
*(vp++) = U0*I0[179]
          - U10*(I1[264] - I2[179])
          - U11*(I1[268] - I2[239])
          - U12*(I1[269] - I2[249])
          + (threezdon)*(I3[149] + AC2*I4[107]);
*(vp++) = U0*I0[180]
          - U10*(I1[270] - I2[180])
          - U11*(I1[271] - I2[240])
          - U12*(I1[272] - I2[250])
          + (threezdon)*(I3[108] + AC0*I4[108]);
*(vp++) = U0*I0[181]
          - U10*(I1[271] - I2[181])
          - U11*(I1[273] - I2[241])
          - U12*(I1[274] - I2[251])
          + (twozdon)*(I3[109] + AC0*I4[109])
          + (onezdon)*(I3[144] + AC1*I4[108]);
*(vp++) = U0*I0[182]
          - U10*(I1[272] - I2[182])
          - U11*(I1[274] - I2[242])
          - U12*(I1[275] - I2[252])
          + (twozdon)*(I3[110] + AC0*I4[110])
          + (onezdon)*(I3[150] + AC2*I4[108]);
*(vp++) = U0*I0[183]
          - U10*(I1[273] - I2[183])
          - U11*(I1[276] - I2[243])
          - U12*(I1[277] - I2[253])
          + (onezdon)*(I3[111] + AC0*I4[111])
          + (twozdon)*(I3[145] + AC1*I4[109]);
*(vp++) = U0*I0[184]
          - U10*(I1[274] - I2[184])
          - U11*(I1[277] - I2[244])
          - U12*(I1[278] - I2[254])
          + (onezdon)*(I3[112] + AC0*I4[112])
          + (onezdon)*(I3[146] + AC1*I4[110])
          + (onezdon)*(I3[151] + AC2*I4[109]);
*(vp++) = U0*I0[185]
          - U10*(I1[275] - I2[185])
          - U11*(I1[278] - I2[245])
          - U12*(I1[279] - I2[255])
          + (onezdon)*(I3[113] + AC0*I4[113])
          + (twozdon)*(I3[152] + AC2*I4[110]);
*(vp++) = U0*I0[186]
          - U10*(I1[276] - I2[186])
          - U11*(I1[280] - I2[246])
          - U12*(I1[281] - I2[256])
          + (threezdon)*(I3[147] + AC1*I4[111]);
*(vp++) = U0*I0[187]
          - U10*(I1[277] - I2[187])
          - U11*(I1[281] - I2[247])
          - U12*(I1[282] - I2[257])
          + (twozdon)*(I3[148] + AC1*I4[112])
          + (onezdon)*(I3[153] + AC2*I4[111]);
*(vp++) = U0*I0[188]
          - U10*(I1[278] - I2[188])
          - U11*(I1[282] - I2[248])
          - U12*(I1[283] - I2[258])
          + (onezdon)*(I3[149] + AC1*I4[113])
          + (twozdon)*(I3[154] + AC2*I4[112]);
*(vp++) = U0*I0[189]
          - U10*(I1[279] - I2[189])
          - U11*(I1[283] - I2[249])
          - U12*(I1[284] - I2[259])
          + (threezdon)*(I3[155] + AC2*I4[113]);
*(vp++) = U0*I0[190]
          - U10*(I1[285] - I2[190])
          - U11*(I1[286] - I2[250])
          - U12*(I1[287] - I2[260])
          + (threezdon)*(I3[114] + AC0*I4[114]);
*(vp++) = U0*I0[191]
          - U10*(I1[286] - I2[191])
          - U11*(I1[288] - I2[251])
          - U12*(I1[289] - I2[261])
          + (twozdon)*(I3[115] + AC0*I4[115])
          + (onezdon)*(I3[150] + AC1*I4[114]);
*(vp++) = U0*I0[192]
          - U10*(I1[287] - I2[192])
          - U11*(I1[289] - I2[252])
          - U12*(I1[290] - I2[262])
          + (twozdon)*(I3[116] + AC0*I4[116])
          + (onezdon)*(I3[156] + AC2*I4[114]);
*(vp++) = U0*I0[193]
          - U10*(I1[288] - I2[193])
          - U11*(I1[291] - I2[253])
          - U12*(I1[292] - I2[263])
          + (onezdon)*(I3[117] + AC0*I4[117])
          + (twozdon)*(I3[151] + AC1*I4[115]);
*(vp++) = U0*I0[194]
          - U10*(I1[289] - I2[194])
          - U11*(I1[292] - I2[254])
          - U12*(I1[293] - I2[264])
          + (onezdon)*(I3[118] + AC0*I4[118])
          + (onezdon)*(I3[152] + AC1*I4[116])
          + (onezdon)*(I3[157] + AC2*I4[115]);
*(vp++) = U0*I0[195]
          - U10*(I1[290] - I2[195])
          - U11*(I1[293] - I2[255])
          - U12*(I1[294] - I2[265])
          + (onezdon)*(I3[119] + AC0*I4[119])
          + (twozdon)*(I3[158] + AC2*I4[116]);
*(vp++) = U0*I0[196]
          - U10*(I1[291] - I2[196])
          - U11*(I1[295] - I2[256])
          - U12*(I1[296] - I2[266])
          + (threezdon)*(I3[153] + AC1*I4[117]);
*(vp++) = U0*I0[197]
          - U10*(I1[292] - I2[197])
          - U11*(I1[296] - I2[257])
          - U12*(I1[297] - I2[267])
          + (twozdon)*(I3[154] + AC1*I4[118])
          + (onezdon)*(I3[159] + AC2*I4[117]);
*(vp++) = U0*I0[198]
          - U10*(I1[293] - I2[198])
          - U11*(I1[297] - I2[258])
          - U12*(I1[298] - I2[268])
          + (onezdon)*(I3[155] + AC1*I4[119])
          + (twozdon)*(I3[160] + AC2*I4[118]);
*(vp++) = U0*I0[199]
          - U10*(I1[294] - I2[199])
          - U11*(I1[298] - I2[259])
          - U12*(I1[299] - I2[269])
          + (threezdon)*(I3[161] + AC2*I4[119]);
*(vp++) = U0*I0[200]
          - U10*(I1[300] - I2[200])
          - U11*(I1[301] - I2[260])
          - U12*(I1[302] - I2[270])
          + (threezdon)*(I3[120] + AC0*I4[120]);
*(vp++) = U0*I0[201]
          - U10*(I1[301] - I2[201])
          - U11*(I1[303] - I2[261])
          - U12*(I1[304] - I2[271])
          + (twozdon)*(I3[121] + AC0*I4[121])
          + (onezdon)*(I3[156] + AC1*I4[120]);
*(vp++) = U0*I0[202]
          - U10*(I1[302] - I2[202])
          - U11*(I1[304] - I2[262])
          - U12*(I1[305] - I2[272])
          + (twozdon)*(I3[122] + AC0*I4[122])
          + (onezdon)*(I3[162] + AC2*I4[120]);
*(vp++) = U0*I0[203]
          - U10*(I1[303] - I2[203])
          - U11*(I1[306] - I2[263])
          - U12*(I1[307] - I2[273])
          + (onezdon)*(I3[123] + AC0*I4[123])
          + (twozdon)*(I3[157] + AC1*I4[121]);
*(vp++) = U0*I0[204]
          - U10*(I1[304] - I2[204])
          - U11*(I1[307] - I2[264])
          - U12*(I1[308] - I2[274])
          + (onezdon)*(I3[124] + AC0*I4[124])
          + (onezdon)*(I3[158] + AC1*I4[122])
          + (onezdon)*(I3[163] + AC2*I4[121]);
*(vp++) = U0*I0[205]
          - U10*(I1[305] - I2[205])
          - U11*(I1[308] - I2[265])
          - U12*(I1[309] - I2[275])
          + (onezdon)*(I3[125] + AC0*I4[125])
          + (twozdon)*(I3[164] + AC2*I4[122]);
*(vp++) = U0*I0[206]
          - U10*(I1[306] - I2[206])
          - U11*(I1[310] - I2[266])
          - U12*(I1[311] - I2[276])
          + (threezdon)*(I3[159] + AC1*I4[123]);
*(vp++) = U0*I0[207]
          - U10*(I1[307] - I2[207])
          - U11*(I1[311] - I2[267])
          - U12*(I1[312] - I2[277])
          + (twozdon)*(I3[160] + AC1*I4[124])
          + (onezdon)*(I3[165] + AC2*I4[123]);
*(vp++) = U0*I0[208]
          - U10*(I1[308] - I2[208])
          - U11*(I1[312] - I2[268])
          - U12*(I1[313] - I2[278])
          + (onezdon)*(I3[161] + AC1*I4[125])
          + (twozdon)*(I3[166] + AC2*I4[124]);
*(vp++) = U0*I0[209]
          - U10*(I1[309] - I2[209])
          - U11*(I1[313] - I2[269])
          - U12*(I1[314] - I2[279])
          + (threezdon)*(I3[167] + AC2*I4[125]);

}
