/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_fpgg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (fp|gg) integrals */

void d12hrr_order_fpgg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][8][11] = int_stack + 0;
 Libderiv->deriv_classes[4][8][10] = int_stack + 675;
 Libderiv->deriv_classes[4][8][9] = int_stack + 1350;
 Libderiv->deriv_classes[4][8][8] = int_stack + 2025;
 Libderiv->deriv_classes[4][8][7] = int_stack + 2700;
 Libderiv->dvrr_classes[4][7] = int_stack + 3375;
 Libderiv->deriv_classes[4][8][6] = int_stack + 3915;
 Libderiv->deriv_classes[4][8][2] = int_stack + 4590;
 Libderiv->deriv_classes[4][8][1] = int_stack + 5265;
 Libderiv->dvrr_classes[3][8] = int_stack + 5940;
 Libderiv->deriv_classes[4][8][0] = int_stack + 6390;
 Libderiv->deriv2_classes[3][4][143] = int_stack + 7065;
 Libderiv->deriv2_classes[3][5][143] = int_stack + 7215;
 Libderiv->deriv2_classes[3][6][143] = int_stack + 7425;
 Libderiv->deriv2_classes[3][7][143] = int_stack + 7705;
 Libderiv->deriv2_classes[3][8][143] = int_stack + 8065;
 Libderiv->deriv2_classes[4][4][143] = int_stack + 8515;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 8740;
 Libderiv->deriv2_classes[4][6][143] = int_stack + 9055;
 Libderiv->deriv2_classes[4][7][143] = int_stack + 9475;
 Libderiv->deriv2_classes[4][8][143] = int_stack + 10015;
 Libderiv->deriv2_classes[3][4][131] = int_stack + 10690;
 Libderiv->deriv2_classes[3][5][131] = int_stack + 10840;
 Libderiv->deriv2_classes[3][6][131] = int_stack + 11050;
 Libderiv->deriv2_classes[3][7][131] = int_stack + 11330;
 Libderiv->deriv2_classes[3][8][131] = int_stack + 11690;
 Libderiv->deriv2_classes[4][4][131] = int_stack + 12140;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 12365;
 Libderiv->deriv2_classes[4][6][131] = int_stack + 12680;
 Libderiv->deriv2_classes[4][7][131] = int_stack + 13100;
 Libderiv->deriv2_classes[4][8][131] = int_stack + 13640;
 Libderiv->deriv2_classes[3][4][130] = int_stack + 14315;
 Libderiv->deriv2_classes[3][5][130] = int_stack + 14465;
 Libderiv->deriv2_classes[3][6][130] = int_stack + 14675;
 Libderiv->deriv2_classes[3][7][130] = int_stack + 14955;
 Libderiv->deriv2_classes[3][8][130] = int_stack + 15315;
 Libderiv->deriv2_classes[4][4][130] = int_stack + 15765;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 15990;
 Libderiv->deriv2_classes[4][6][130] = int_stack + 16305;
 Libderiv->deriv2_classes[4][7][130] = int_stack + 16725;
 Libderiv->deriv2_classes[4][8][130] = int_stack + 17265;
 Libderiv->deriv2_classes[3][4][119] = int_stack + 17940;
 Libderiv->deriv2_classes[3][5][119] = int_stack + 18090;
 Libderiv->deriv2_classes[3][6][119] = int_stack + 18300;
 Libderiv->deriv2_classes[3][7][119] = int_stack + 18580;
 Libderiv->deriv2_classes[3][8][119] = int_stack + 18940;
 Libderiv->deriv2_classes[4][4][119] = int_stack + 19390;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 19615;
 Libderiv->deriv2_classes[4][6][119] = int_stack + 19930;
 Libderiv->deriv2_classes[4][7][119] = int_stack + 20350;
 Libderiv->deriv2_classes[4][8][119] = int_stack + 20890;
 Libderiv->deriv2_classes[3][4][118] = int_stack + 21565;
 Libderiv->deriv2_classes[3][5][118] = int_stack + 21715;
 Libderiv->deriv2_classes[3][6][118] = int_stack + 21925;
 Libderiv->deriv2_classes[3][7][118] = int_stack + 22205;
 Libderiv->deriv2_classes[3][8][118] = int_stack + 22565;
 Libderiv->deriv2_classes[4][4][118] = int_stack + 23015;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 23240;
 Libderiv->deriv2_classes[4][6][118] = int_stack + 23555;
 Libderiv->deriv2_classes[4][7][118] = int_stack + 23975;
 Libderiv->deriv2_classes[4][8][118] = int_stack + 24515;
 Libderiv->deriv2_classes[3][4][117] = int_stack + 25190;
 Libderiv->deriv2_classes[3][5][117] = int_stack + 25340;
 Libderiv->deriv2_classes[3][6][117] = int_stack + 25550;
 Libderiv->deriv2_classes[3][7][117] = int_stack + 25830;
 Libderiv->deriv2_classes[3][8][117] = int_stack + 26190;
 Libderiv->deriv2_classes[4][4][117] = int_stack + 26640;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 26865;
 Libderiv->deriv2_classes[4][6][117] = int_stack + 27180;
 Libderiv->deriv2_classes[4][7][117] = int_stack + 27600;
 Libderiv->deriv2_classes[4][8][117] = int_stack + 28140;
 Libderiv->deriv2_classes[3][4][107] = int_stack + 28815;
 Libderiv->deriv2_classes[3][5][107] = int_stack + 28965;
 Libderiv->deriv2_classes[3][6][107] = int_stack + 29175;
 Libderiv->deriv2_classes[3][7][107] = int_stack + 29455;
 Libderiv->deriv2_classes[3][8][107] = int_stack + 29815;
 Libderiv->deriv2_classes[4][4][107] = int_stack + 30265;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 30490;
 Libderiv->deriv2_classes[4][6][107] = int_stack + 30805;
 Libderiv->deriv2_classes[4][7][107] = int_stack + 31225;
 Libderiv->deriv2_classes[4][8][107] = int_stack + 31765;
 Libderiv->deriv2_classes[3][4][106] = int_stack + 32440;
 Libderiv->deriv2_classes[3][5][106] = int_stack + 32590;
 Libderiv->deriv2_classes[3][6][106] = int_stack + 32800;
 Libderiv->deriv2_classes[3][7][106] = int_stack + 33080;
 Libderiv->deriv2_classes[3][8][106] = int_stack + 33440;
 Libderiv->deriv2_classes[4][4][106] = int_stack + 33890;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 34115;
 Libderiv->deriv2_classes[4][6][106] = int_stack + 34430;
 Libderiv->deriv2_classes[4][7][106] = int_stack + 34850;
 Libderiv->deriv2_classes[4][8][106] = int_stack + 35390;
 Libderiv->deriv2_classes[3][4][105] = int_stack + 36065;
 Libderiv->deriv2_classes[3][5][105] = int_stack + 36215;
 Libderiv->deriv2_classes[3][6][105] = int_stack + 36425;
 Libderiv->deriv2_classes[3][7][105] = int_stack + 36705;
 Libderiv->deriv2_classes[3][8][105] = int_stack + 37065;
 Libderiv->deriv2_classes[4][4][105] = int_stack + 37515;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 37740;
 Libderiv->deriv2_classes[4][6][105] = int_stack + 38055;
 Libderiv->deriv2_classes[4][7][105] = int_stack + 38475;
 Libderiv->deriv2_classes[4][8][105] = int_stack + 39015;
 Libderiv->deriv2_classes[3][4][104] = int_stack + 39690;
 Libderiv->deriv2_classes[3][5][104] = int_stack + 39840;
 Libderiv->deriv2_classes[3][6][104] = int_stack + 40050;
 Libderiv->deriv2_classes[3][7][104] = int_stack + 40330;
 Libderiv->deriv2_classes[3][8][104] = int_stack + 40690;
 Libderiv->deriv2_classes[4][4][104] = int_stack + 41140;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 41365;
 Libderiv->deriv2_classes[4][6][104] = int_stack + 41680;
 Libderiv->deriv2_classes[4][7][104] = int_stack + 42100;
 Libderiv->deriv2_classes[4][8][104] = int_stack + 42640;
 Libderiv->deriv2_classes[3][4][95] = int_stack + 43315;
 Libderiv->deriv2_classes[3][5][95] = int_stack + 43465;
 Libderiv->deriv2_classes[3][6][95] = int_stack + 43675;
 Libderiv->deriv2_classes[3][7][95] = int_stack + 43955;
 Libderiv->deriv2_classes[3][8][95] = int_stack + 44315;
 Libderiv->deriv2_classes[4][4][95] = int_stack + 44765;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 44990;
 Libderiv->deriv2_classes[4][6][95] = int_stack + 45305;
 Libderiv->deriv2_classes[4][7][95] = int_stack + 45725;
 Libderiv->deriv2_classes[4][8][95] = int_stack + 46265;
 Libderiv->deriv2_classes[3][4][94] = int_stack + 46940;
 Libderiv->deriv2_classes[3][5][94] = int_stack + 47090;
 Libderiv->deriv2_classes[3][6][94] = int_stack + 47300;
 Libderiv->deriv2_classes[3][7][94] = int_stack + 47580;
 Libderiv->deriv2_classes[3][8][94] = int_stack + 47940;
 Libderiv->deriv2_classes[4][4][94] = int_stack + 48390;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 48615;
 Libderiv->deriv2_classes[4][6][94] = int_stack + 48930;
 Libderiv->deriv2_classes[4][7][94] = int_stack + 49350;
 Libderiv->deriv2_classes[4][8][94] = int_stack + 49890;
 Libderiv->deriv2_classes[3][4][93] = int_stack + 50565;
 Libderiv->deriv2_classes[3][5][93] = int_stack + 50715;
 Libderiv->deriv2_classes[3][6][93] = int_stack + 50925;
 Libderiv->deriv2_classes[3][7][93] = int_stack + 51205;
 Libderiv->deriv2_classes[3][8][93] = int_stack + 51565;
 Libderiv->deriv2_classes[4][4][93] = int_stack + 52015;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 52240;
 Libderiv->deriv2_classes[4][6][93] = int_stack + 52555;
 Libderiv->deriv2_classes[4][7][93] = int_stack + 52975;
 Libderiv->deriv2_classes[4][8][93] = int_stack + 53515;
 Libderiv->deriv2_classes[3][4][92] = int_stack + 54190;
 Libderiv->deriv2_classes[3][5][92] = int_stack + 54340;
 Libderiv->deriv2_classes[3][6][92] = int_stack + 54550;
 Libderiv->deriv2_classes[3][7][92] = int_stack + 54830;
 Libderiv->deriv2_classes[3][8][92] = int_stack + 55190;
 Libderiv->deriv2_classes[4][4][92] = int_stack + 55640;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 55865;
 Libderiv->deriv2_classes[4][6][92] = int_stack + 56180;
 Libderiv->deriv2_classes[4][7][92] = int_stack + 56600;
 Libderiv->deriv2_classes[4][8][92] = int_stack + 57140;
 Libderiv->deriv2_classes[3][4][91] = int_stack + 57815;
 Libderiv->deriv2_classes[3][5][91] = int_stack + 57965;
 Libderiv->deriv2_classes[3][6][91] = int_stack + 58175;
 Libderiv->deriv2_classes[3][7][91] = int_stack + 58455;
 Libderiv->deriv2_classes[3][8][91] = int_stack + 58815;
 Libderiv->deriv2_classes[4][4][91] = int_stack + 59265;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 59490;
 Libderiv->deriv2_classes[4][6][91] = int_stack + 59805;
 Libderiv->deriv2_classes[4][7][91] = int_stack + 60225;
 Libderiv->deriv2_classes[4][8][91] = int_stack + 60765;
 Libderiv->deriv2_classes[3][4][83] = int_stack + 61440;
 Libderiv->deriv2_classes[3][5][83] = int_stack + 61590;
 Libderiv->deriv2_classes[3][6][83] = int_stack + 61800;
 Libderiv->deriv2_classes[3][7][83] = int_stack + 62080;
 Libderiv->deriv2_classes[3][8][83] = int_stack + 62440;
 Libderiv->deriv_classes[4][4][11] = int_stack + 62890;
 Libderiv->deriv2_classes[4][4][83] = int_stack + 63115;
 Libderiv->deriv_classes[4][5][11] = int_stack + 63340;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 63655;
 Libderiv->deriv_classes[4][6][11] = int_stack + 63970;
 Libderiv->deriv2_classes[4][6][83] = int_stack + 64390;
 Libderiv->deriv_classes[4][7][11] = int_stack + 64810;
 Libderiv->deriv2_classes[4][7][83] = int_stack + 65350;
 Libderiv->deriv2_classes[4][8][83] = int_stack + 65890;
 Libderiv->deriv2_classes[3][4][82] = int_stack + 66565;
 Libderiv->deriv2_classes[3][5][82] = int_stack + 66715;
 Libderiv->deriv2_classes[3][6][82] = int_stack + 66925;
 Libderiv->deriv2_classes[3][7][82] = int_stack + 67205;
 Libderiv->deriv2_classes[3][8][82] = int_stack + 67565;
 Libderiv->deriv_classes[4][4][10] = int_stack + 68015;
 Libderiv->deriv2_classes[4][4][82] = int_stack + 68240;
 Libderiv->deriv_classes[4][5][10] = int_stack + 68465;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 68780;
 Libderiv->deriv_classes[4][6][10] = int_stack + 69095;
 Libderiv->deriv2_classes[4][6][82] = int_stack + 69515;
 Libderiv->deriv_classes[4][7][10] = int_stack + 69935;
 Libderiv->deriv2_classes[4][7][82] = int_stack + 70475;
 Libderiv->deriv2_classes[4][8][82] = int_stack + 71015;
 Libderiv->deriv2_classes[3][4][81] = int_stack + 71690;
 Libderiv->deriv2_classes[3][5][81] = int_stack + 71840;
 Libderiv->deriv2_classes[3][6][81] = int_stack + 72050;
 Libderiv->deriv2_classes[3][7][81] = int_stack + 72330;
 Libderiv->deriv2_classes[3][8][81] = int_stack + 72690;
 Libderiv->deriv_classes[4][4][9] = int_stack + 73140;
 Libderiv->deriv2_classes[4][4][81] = int_stack + 73365;
 Libderiv->deriv_classes[4][5][9] = int_stack + 73590;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 73905;
 Libderiv->deriv_classes[4][6][9] = int_stack + 74220;
 Libderiv->deriv2_classes[4][6][81] = int_stack + 74640;
 Libderiv->deriv_classes[4][7][9] = int_stack + 75060;
 Libderiv->deriv2_classes[4][7][81] = int_stack + 75600;
 Libderiv->deriv2_classes[4][8][81] = int_stack + 76140;
 Libderiv->deriv2_classes[3][4][80] = int_stack + 76815;
 Libderiv->deriv2_classes[3][5][80] = int_stack + 76965;
 Libderiv->deriv2_classes[3][6][80] = int_stack + 77175;
 Libderiv->deriv2_classes[3][7][80] = int_stack + 77455;
 Libderiv->deriv2_classes[3][8][80] = int_stack + 77815;
 Libderiv->deriv_classes[4][4][8] = int_stack + 78265;
 Libderiv->deriv2_classes[4][4][80] = int_stack + 78490;
 Libderiv->deriv_classes[4][5][8] = int_stack + 78715;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 79030;
 Libderiv->deriv_classes[4][6][8] = int_stack + 79345;
 Libderiv->deriv2_classes[4][6][80] = int_stack + 79765;
 Libderiv->deriv_classes[4][7][8] = int_stack + 80185;
 Libderiv->deriv2_classes[4][7][80] = int_stack + 80725;
 Libderiv->deriv2_classes[4][8][80] = int_stack + 81265;
 Libderiv->deriv2_classes[3][4][79] = int_stack + 81940;
 Libderiv->deriv2_classes[3][5][79] = int_stack + 82090;
 Libderiv->deriv2_classes[3][6][79] = int_stack + 82300;
 Libderiv->deriv2_classes[3][7][79] = int_stack + 82580;
 Libderiv->deriv2_classes[3][8][79] = int_stack + 82940;
 Libderiv->deriv_classes[4][4][7] = int_stack + 83390;
 Libderiv->deriv2_classes[4][4][79] = int_stack + 83615;
 Libderiv->deriv_classes[4][5][7] = int_stack + 83840;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 84155;
 Libderiv->deriv_classes[4][6][7] = int_stack + 84470;
 Libderiv->deriv2_classes[4][6][79] = int_stack + 84890;
 Libderiv->deriv_classes[4][7][7] = int_stack + 85310;
 Libderiv->deriv2_classes[4][7][79] = int_stack + 85850;
 Libderiv->deriv2_classes[4][8][79] = int_stack + 86390;
 Libderiv->deriv2_classes[3][4][78] = int_stack + 87065;
 Libderiv->deriv2_classes[3][5][78] = int_stack + 87215;
 Libderiv->deriv2_classes[3][6][78] = int_stack + 87425;
 Libderiv->deriv2_classes[3][7][78] = int_stack + 87705;
 Libderiv->deriv2_classes[3][8][78] = int_stack + 88065;
 Libderiv->dvrr_classes[4][4] = int_stack + 88515;
 Libderiv->deriv_classes[4][4][6] = int_stack + 88740;
 Libderiv->deriv2_classes[4][4][78] = int_stack + 88965;
 Libderiv->dvrr_classes[4][5] = int_stack + 89190;
 Libderiv->deriv_classes[4][5][6] = int_stack + 89505;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 89820;
 Libderiv->dvrr_classes[4][6] = int_stack + 90135;
 Libderiv->deriv_classes[4][6][6] = int_stack + 90555;
 Libderiv->deriv2_classes[4][6][78] = int_stack + 90975;
 Libderiv->deriv_classes[4][7][6] = int_stack + 91395;
 Libderiv->deriv2_classes[4][7][78] = int_stack + 91935;
 Libderiv->deriv2_classes[4][8][78] = int_stack + 92475;
 Libderiv->deriv2_classes[3][4][35] = int_stack + 93150;
 Libderiv->deriv2_classes[3][5][35] = int_stack + 93300;
 Libderiv->deriv2_classes[3][6][35] = int_stack + 93510;
 Libderiv->deriv2_classes[3][7][35] = int_stack + 93790;
 Libderiv->deriv2_classes[3][8][35] = int_stack + 94150;
 Libderiv->deriv2_classes[4][4][35] = int_stack + 94600;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 94825;
 Libderiv->deriv2_classes[4][6][35] = int_stack + 95140;
 Libderiv->deriv2_classes[4][7][35] = int_stack + 95560;
 Libderiv->deriv2_classes[4][8][35] = int_stack + 96100;
 Libderiv->deriv2_classes[3][4][34] = int_stack + 96775;
 Libderiv->deriv2_classes[3][5][34] = int_stack + 96925;
 Libderiv->deriv2_classes[3][6][34] = int_stack + 97135;
 Libderiv->deriv2_classes[3][7][34] = int_stack + 97415;
 Libderiv->deriv2_classes[3][8][34] = int_stack + 97775;
 Libderiv->deriv2_classes[4][4][34] = int_stack + 98225;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 98450;
 Libderiv->deriv2_classes[4][6][34] = int_stack + 98765;
 Libderiv->deriv2_classes[4][7][34] = int_stack + 99185;
 Libderiv->deriv2_classes[4][8][34] = int_stack + 99725;
 Libderiv->deriv2_classes[3][4][33] = int_stack + 100400;
 Libderiv->deriv2_classes[3][5][33] = int_stack + 100550;
 Libderiv->deriv2_classes[3][6][33] = int_stack + 100760;
 Libderiv->deriv2_classes[3][7][33] = int_stack + 101040;
 Libderiv->deriv2_classes[3][8][33] = int_stack + 101400;
 Libderiv->deriv2_classes[4][4][33] = int_stack + 101850;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 102075;
 Libderiv->deriv2_classes[4][6][33] = int_stack + 102390;
 Libderiv->deriv2_classes[4][7][33] = int_stack + 102810;
 Libderiv->deriv2_classes[4][8][33] = int_stack + 103350;
 Libderiv->deriv2_classes[3][4][32] = int_stack + 104025;
 Libderiv->deriv2_classes[3][5][32] = int_stack + 104175;
 Libderiv->deriv2_classes[3][6][32] = int_stack + 104385;
 Libderiv->deriv2_classes[3][7][32] = int_stack + 104665;
 Libderiv->deriv2_classes[3][8][32] = int_stack + 105025;
 Libderiv->deriv2_classes[4][4][32] = int_stack + 105475;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 105700;
 Libderiv->deriv2_classes[4][6][32] = int_stack + 106015;
 Libderiv->deriv2_classes[4][7][32] = int_stack + 106435;
 Libderiv->deriv2_classes[4][8][32] = int_stack + 106975;
 Libderiv->deriv2_classes[3][4][31] = int_stack + 107650;
 Libderiv->deriv2_classes[3][5][31] = int_stack + 107800;
 Libderiv->deriv2_classes[3][6][31] = int_stack + 108010;
 Libderiv->deriv2_classes[3][7][31] = int_stack + 108290;
 Libderiv->deriv2_classes[3][8][31] = int_stack + 108650;
 Libderiv->deriv2_classes[4][4][31] = int_stack + 109100;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 109325;
 Libderiv->deriv2_classes[4][6][31] = int_stack + 109640;
 Libderiv->deriv2_classes[4][7][31] = int_stack + 110060;
 Libderiv->deriv2_classes[4][8][31] = int_stack + 110600;
 Libderiv->deriv2_classes[3][4][30] = int_stack + 111275;
 Libderiv->deriv2_classes[3][5][30] = int_stack + 111425;
 Libderiv->deriv2_classes[3][6][30] = int_stack + 111635;
 Libderiv->deriv2_classes[3][7][30] = int_stack + 111915;
 Libderiv->deriv2_classes[3][8][30] = int_stack + 112275;
 Libderiv->deriv_classes[4][4][2] = int_stack + 112725;
 Libderiv->deriv2_classes[4][4][30] = int_stack + 112950;
 Libderiv->deriv_classes[4][5][2] = int_stack + 113175;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 113490;
 Libderiv->deriv_classes[4][6][2] = int_stack + 113805;
 Libderiv->deriv2_classes[4][6][30] = int_stack + 114225;
 Libderiv->deriv_classes[4][7][2] = int_stack + 114645;
 Libderiv->deriv2_classes[4][7][30] = int_stack + 115185;
 Libderiv->deriv2_classes[4][8][30] = int_stack + 115725;
 Libderiv->deriv2_classes[3][4][26] = int_stack + 116400;
 Libderiv->deriv2_classes[3][5][26] = int_stack + 116550;
 Libderiv->deriv2_classes[3][6][26] = int_stack + 116760;
 Libderiv->deriv2_classes[3][7][26] = int_stack + 117040;
 Libderiv->deriv2_classes[3][8][26] = int_stack + 117400;
 Libderiv->deriv2_classes[4][4][26] = int_stack + 117850;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 118075;
 Libderiv->deriv2_classes[4][6][26] = int_stack + 118390;
 Libderiv->deriv2_classes[4][7][26] = int_stack + 118810;
 Libderiv->deriv2_classes[4][8][26] = int_stack + 119350;
 Libderiv->deriv2_classes[3][4][23] = int_stack + 120025;
 Libderiv->deriv2_classes[3][5][23] = int_stack + 120175;
 Libderiv->deriv2_classes[3][6][23] = int_stack + 120385;
 Libderiv->deriv2_classes[3][7][23] = int_stack + 120665;
 Libderiv->deriv2_classes[3][8][23] = int_stack + 121025;
 Libderiv->deriv2_classes[4][4][23] = int_stack + 121475;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 121700;
 Libderiv->deriv2_classes[4][6][23] = int_stack + 122015;
 Libderiv->deriv2_classes[4][7][23] = int_stack + 122435;
 Libderiv->deriv2_classes[4][8][23] = int_stack + 122975;
 Libderiv->deriv2_classes[3][4][22] = int_stack + 123650;
 Libderiv->deriv2_classes[3][5][22] = int_stack + 123800;
 Libderiv->deriv2_classes[3][6][22] = int_stack + 124010;
 Libderiv->deriv2_classes[3][7][22] = int_stack + 124290;
 Libderiv->deriv2_classes[3][8][22] = int_stack + 124650;
 Libderiv->deriv2_classes[4][4][22] = int_stack + 125100;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 125325;
 Libderiv->deriv2_classes[4][6][22] = int_stack + 125640;
 Libderiv->deriv2_classes[4][7][22] = int_stack + 126060;
 Libderiv->deriv2_classes[4][8][22] = int_stack + 126600;
 Libderiv->deriv2_classes[3][4][21] = int_stack + 127275;
 Libderiv->deriv2_classes[3][5][21] = int_stack + 127425;
 Libderiv->deriv2_classes[3][6][21] = int_stack + 127635;
 Libderiv->deriv2_classes[3][7][21] = int_stack + 127915;
 Libderiv->deriv2_classes[3][8][21] = int_stack + 128275;
 Libderiv->deriv2_classes[4][4][21] = int_stack + 128725;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 128950;
 Libderiv->deriv2_classes[4][6][21] = int_stack + 129265;
 Libderiv->deriv2_classes[4][7][21] = int_stack + 129685;
 Libderiv->deriv2_classes[4][8][21] = int_stack + 130225;
 Libderiv->deriv2_classes[3][4][20] = int_stack + 130900;
 Libderiv->deriv2_classes[3][5][20] = int_stack + 131050;
 Libderiv->deriv2_classes[3][6][20] = int_stack + 131260;
 Libderiv->deriv2_classes[3][7][20] = int_stack + 131540;
 Libderiv->deriv2_classes[3][8][20] = int_stack + 131900;
 Libderiv->deriv2_classes[4][4][20] = int_stack + 132350;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 132575;
 Libderiv->deriv2_classes[4][6][20] = int_stack + 132890;
 Libderiv->deriv2_classes[4][7][20] = int_stack + 133310;
 Libderiv->deriv2_classes[4][8][20] = int_stack + 133850;
 Libderiv->deriv2_classes[3][4][19] = int_stack + 134525;
 Libderiv->deriv2_classes[3][5][19] = int_stack + 134675;
 Libderiv->deriv2_classes[3][6][19] = int_stack + 134885;
 Libderiv->deriv2_classes[3][7][19] = int_stack + 135165;
 Libderiv->deriv2_classes[3][8][19] = int_stack + 135525;
 Libderiv->deriv2_classes[4][4][19] = int_stack + 135975;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 136200;
 Libderiv->deriv2_classes[4][6][19] = int_stack + 136515;
 Libderiv->deriv2_classes[4][7][19] = int_stack + 136935;
 Libderiv->deriv2_classes[4][8][19] = int_stack + 137475;
 Libderiv->deriv2_classes[3][4][18] = int_stack + 138150;
 Libderiv->deriv2_classes[3][5][18] = int_stack + 138300;
 Libderiv->deriv2_classes[3][6][18] = int_stack + 138510;
 Libderiv->deriv2_classes[3][7][18] = int_stack + 138790;
 Libderiv->deriv2_classes[3][8][18] = int_stack + 139150;
 Libderiv->deriv_classes[4][4][1] = int_stack + 139600;
 Libderiv->deriv2_classes[4][4][18] = int_stack + 139825;
 Libderiv->deriv_classes[4][5][1] = int_stack + 140050;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 140365;
 Libderiv->deriv_classes[4][6][1] = int_stack + 140680;
 Libderiv->deriv2_classes[4][6][18] = int_stack + 141100;
 Libderiv->deriv_classes[4][7][1] = int_stack + 141520;
 Libderiv->deriv2_classes[4][7][18] = int_stack + 142060;
 Libderiv->deriv2_classes[4][8][18] = int_stack + 142600;
 Libderiv->deriv2_classes[3][4][14] = int_stack + 143275;
 Libderiv->deriv2_classes[3][5][14] = int_stack + 143425;
 Libderiv->deriv2_classes[3][6][14] = int_stack + 143635;
 Libderiv->deriv2_classes[3][7][14] = int_stack + 143915;
 Libderiv->deriv2_classes[3][8][14] = int_stack + 144275;
 Libderiv->deriv2_classes[4][4][14] = int_stack + 144725;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 144950;
 Libderiv->deriv2_classes[4][6][14] = int_stack + 145265;
 Libderiv->deriv2_classes[4][7][14] = int_stack + 145685;
 Libderiv->deriv2_classes[4][8][14] = int_stack + 146225;
 Libderiv->deriv2_classes[3][4][13] = int_stack + 146900;
 Libderiv->deriv2_classes[3][5][13] = int_stack + 147050;
 Libderiv->deriv2_classes[3][6][13] = int_stack + 147260;
 Libderiv->deriv2_classes[3][7][13] = int_stack + 147540;
 Libderiv->deriv2_classes[3][8][13] = int_stack + 147900;
 Libderiv->deriv2_classes[4][4][13] = int_stack + 148350;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 148575;
 Libderiv->deriv2_classes[4][6][13] = int_stack + 148890;
 Libderiv->deriv2_classes[4][7][13] = int_stack + 149310;
 Libderiv->deriv2_classes[4][8][13] = int_stack + 149850;
 Libderiv->deriv_classes[3][4][11] = int_stack + 150525;
 Libderiv->deriv_classes[3][5][11] = int_stack + 150675;
 Libderiv->deriv_classes[3][6][11] = int_stack + 150885;
 Libderiv->deriv_classes[3][7][11] = int_stack + 151165;
 Libderiv->deriv_classes[3][8][11] = int_stack + 151525;
 Libderiv->deriv2_classes[3][4][11] = int_stack + 151975;
 Libderiv->deriv2_classes[3][5][11] = int_stack + 152125;
 Libderiv->deriv2_classes[3][6][11] = int_stack + 152335;
 Libderiv->deriv2_classes[3][7][11] = int_stack + 152615;
 Libderiv->deriv2_classes[3][8][11] = int_stack + 152975;
 Libderiv->deriv2_classes[4][4][11] = int_stack + 153425;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 153650;
 Libderiv->deriv2_classes[4][6][11] = int_stack + 153965;
 Libderiv->deriv2_classes[4][7][11] = int_stack + 154385;
 Libderiv->deriv2_classes[4][8][11] = int_stack + 154925;
 Libderiv->deriv_classes[3][4][10] = int_stack + 155600;
 Libderiv->deriv_classes[3][5][10] = int_stack + 155750;
 Libderiv->deriv_classes[3][6][10] = int_stack + 155960;
 Libderiv->deriv_classes[3][7][10] = int_stack + 156240;
 Libderiv->deriv_classes[3][8][10] = int_stack + 156600;
 Libderiv->deriv2_classes[3][4][10] = int_stack + 157050;
 Libderiv->deriv2_classes[3][5][10] = int_stack + 157200;
 Libderiv->deriv2_classes[3][6][10] = int_stack + 157410;
 Libderiv->deriv2_classes[3][7][10] = int_stack + 157690;
 Libderiv->deriv2_classes[3][8][10] = int_stack + 158050;
 Libderiv->deriv2_classes[4][4][10] = int_stack + 158500;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 158725;
 Libderiv->deriv2_classes[4][6][10] = int_stack + 159040;
 Libderiv->deriv2_classes[4][7][10] = int_stack + 159460;
 Libderiv->deriv2_classes[4][8][10] = int_stack + 160000;
 Libderiv->deriv_classes[3][4][9] = int_stack + 160675;
 Libderiv->deriv_classes[3][5][9] = int_stack + 160825;
 Libderiv->deriv_classes[3][6][9] = int_stack + 161035;
 Libderiv->deriv_classes[3][7][9] = int_stack + 161315;
 Libderiv->deriv_classes[3][8][9] = int_stack + 161675;
 Libderiv->deriv2_classes[3][4][9] = int_stack + 162125;
 Libderiv->deriv2_classes[3][5][9] = int_stack + 162275;
 Libderiv->deriv2_classes[3][6][9] = int_stack + 162485;
 Libderiv->deriv2_classes[3][7][9] = int_stack + 162765;
 Libderiv->deriv2_classes[3][8][9] = int_stack + 163125;
 Libderiv->deriv2_classes[4][4][9] = int_stack + 163575;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 163800;
 Libderiv->deriv2_classes[4][6][9] = int_stack + 164115;
 Libderiv->deriv2_classes[4][7][9] = int_stack + 164535;
 Libderiv->deriv2_classes[4][8][9] = int_stack + 165075;
 Libderiv->deriv_classes[3][4][8] = int_stack + 165750;
 Libderiv->deriv_classes[3][5][8] = int_stack + 165900;
 Libderiv->deriv_classes[3][6][8] = int_stack + 166110;
 Libderiv->deriv_classes[3][7][8] = int_stack + 166390;
 Libderiv->deriv_classes[3][8][8] = int_stack + 166750;
 Libderiv->deriv2_classes[3][4][8] = int_stack + 167200;
 Libderiv->deriv2_classes[3][5][8] = int_stack + 167350;
 Libderiv->deriv2_classes[3][6][8] = int_stack + 167560;
 Libderiv->deriv2_classes[3][7][8] = int_stack + 167840;
 Libderiv->deriv2_classes[3][8][8] = int_stack + 168200;
 Libderiv->deriv2_classes[4][4][8] = int_stack + 168650;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 168875;
 Libderiv->deriv2_classes[4][6][8] = int_stack + 169190;
 Libderiv->deriv2_classes[4][7][8] = int_stack + 169610;
 Libderiv->deriv2_classes[4][8][8] = int_stack + 170150;
 Libderiv->deriv_classes[3][4][7] = int_stack + 170825;
 Libderiv->deriv_classes[3][5][7] = int_stack + 170975;
 Libderiv->deriv_classes[3][6][7] = int_stack + 171185;
 Libderiv->deriv_classes[3][7][7] = int_stack + 171465;
 Libderiv->deriv_classes[3][8][7] = int_stack + 171825;
 Libderiv->deriv2_classes[3][4][7] = int_stack + 172275;
 Libderiv->deriv2_classes[3][5][7] = int_stack + 172425;
 Libderiv->deriv2_classes[3][6][7] = int_stack + 172635;
 Libderiv->deriv2_classes[3][7][7] = int_stack + 172915;
 Libderiv->deriv2_classes[3][8][7] = int_stack + 173275;
 Libderiv->deriv2_classes[4][4][7] = int_stack + 173725;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 173950;
 Libderiv->deriv2_classes[4][6][7] = int_stack + 174265;
 Libderiv->deriv2_classes[4][7][7] = int_stack + 174685;
 Libderiv->deriv2_classes[4][8][7] = int_stack + 175225;
 Libderiv->dvrr_classes[3][4] = int_stack + 175900;
 Libderiv->deriv_classes[3][4][6] = int_stack + 176050;
 Libderiv->dvrr_classes[3][5] = int_stack + 176200;
 Libderiv->deriv_classes[3][5][6] = int_stack + 176410;
 Libderiv->dvrr_classes[3][6] = int_stack + 176620;
 Libderiv->deriv_classes[3][6][6] = int_stack + 176900;
 Libderiv->dvrr_classes[3][7] = int_stack + 177180;
 Libderiv->deriv_classes[3][7][6] = int_stack + 177540;
 Libderiv->deriv_classes[3][8][6] = int_stack + 177900;
 Libderiv->deriv2_classes[3][4][6] = int_stack + 178350;
 Libderiv->deriv2_classes[3][5][6] = int_stack + 178500;
 Libderiv->deriv2_classes[3][6][6] = int_stack + 178710;
 Libderiv->deriv2_classes[3][7][6] = int_stack + 178990;
 Libderiv->deriv2_classes[3][8][6] = int_stack + 179350;
 Libderiv->deriv_classes[4][4][0] = int_stack + 179800;
 Libderiv->deriv2_classes[4][4][6] = int_stack + 180025;
 Libderiv->deriv_classes[4][5][0] = int_stack + 180250;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 180565;
 Libderiv->deriv_classes[4][6][0] = int_stack + 180880;
 Libderiv->deriv2_classes[4][6][6] = int_stack + 181300;
 Libderiv->deriv_classes[4][7][0] = int_stack + 181720;
 Libderiv->deriv2_classes[4][7][6] = int_stack + 182260;
 Libderiv->deriv2_classes[4][8][6] = int_stack + 182800;
 Libderiv->deriv_classes[3][4][2] = int_stack + 183475;
 Libderiv->deriv_classes[3][5][2] = int_stack + 183625;
 Libderiv->deriv_classes[3][6][2] = int_stack + 183835;
 Libderiv->deriv_classes[3][7][2] = int_stack + 184115;
 Libderiv->deriv_classes[3][8][2] = int_stack + 184475;
 Libderiv->deriv2_classes[3][4][2] = int_stack + 184925;
 Libderiv->deriv2_classes[3][5][2] = int_stack + 185075;
 Libderiv->deriv2_classes[3][6][2] = int_stack + 185285;
 Libderiv->deriv2_classes[3][7][2] = int_stack + 185565;
 Libderiv->deriv2_classes[3][8][2] = int_stack + 185925;
 Libderiv->deriv2_classes[4][4][2] = int_stack + 186375;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 186600;
 Libderiv->deriv2_classes[4][6][2] = int_stack + 186915;
 Libderiv->deriv2_classes[4][7][2] = int_stack + 187335;
 Libderiv->deriv2_classes[4][8][2] = int_stack + 187875;
 Libderiv->deriv_classes[3][4][1] = int_stack + 188550;
 Libderiv->deriv_classes[3][5][1] = int_stack + 188700;
 Libderiv->deriv_classes[3][6][1] = int_stack + 188910;
 Libderiv->deriv_classes[3][7][1] = int_stack + 189190;
 Libderiv->deriv_classes[3][8][1] = int_stack + 189550;
 Libderiv->deriv2_classes[3][4][1] = int_stack + 190000;
 Libderiv->deriv2_classes[3][5][1] = int_stack + 190150;
 Libderiv->deriv2_classes[3][6][1] = int_stack + 190360;
 Libderiv->deriv2_classes[3][7][1] = int_stack + 190640;
 Libderiv->deriv2_classes[3][8][1] = int_stack + 191000;
 Libderiv->deriv2_classes[4][4][1] = int_stack + 191450;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 191675;
 Libderiv->deriv2_classes[4][6][1] = int_stack + 191990;
 Libderiv->deriv2_classes[4][7][1] = int_stack + 192410;
 Libderiv->deriv2_classes[4][8][1] = int_stack + 192950;
 Libderiv->deriv_classes[3][4][0] = int_stack + 193625;
 Libderiv->deriv_classes[3][5][0] = int_stack + 193775;
 Libderiv->deriv_classes[3][6][0] = int_stack + 193985;
 Libderiv->deriv_classes[3][7][0] = int_stack + 194265;
 Libderiv->deriv_classes[3][8][0] = int_stack + 194625;
 Libderiv->deriv2_classes[3][4][0] = int_stack + 195075;
 Libderiv->deriv2_classes[3][5][0] = int_stack + 195225;
 Libderiv->deriv2_classes[3][6][0] = int_stack + 195435;
 Libderiv->deriv2_classes[3][7][0] = int_stack + 195715;
 Libderiv->deriv2_classes[3][8][0] = int_stack + 196075;
 Libderiv->deriv2_classes[4][4][0] = int_stack + 196525;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 196750;
 Libderiv->deriv2_classes[4][6][0] = int_stack + 197065;
 Libderiv->deriv2_classes[4][7][0] = int_stack + 197485;
 Libderiv->deriv2_classes[4][8][0] = int_stack + 198025;
 memset(int_stack,0,1589600);

 Libderiv->dvrr_stack = int_stack + 454735;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_fpgg(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+198700,int_stack+176200,int_stack+175900,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+199150,int_stack+176620,int_stack+176200,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+199780,int_stack+199150,int_stack+198700,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+200680,int_stack+177180,int_stack+176620,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+201520,int_stack+200680,int_stack+199150,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+202780,int_stack+201520,int_stack+199780,10);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+204280,int_stack+150675,int_stack+150525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175900,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+204730,int_stack+150885,int_stack+150675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176200,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+205360,int_stack+204730,int_stack+204280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198700,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+206260,int_stack+151165,int_stack+150885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176620,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+207100,int_stack+206260,int_stack+204730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199150,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+208360,int_stack+207100,int_stack+205360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199780,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+209860,int_stack+151525,int_stack+151165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177180,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+210940,int_stack+209860,int_stack+206260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200680,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+212620,int_stack+210940,int_stack+207100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201520,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+209860,int_stack+212620,int_stack+208360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202780,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+212110,int_stack+89190,int_stack+88515,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+212785,int_stack+90135,int_stack+89190,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+213730,int_stack+212785,int_stack+212110,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+215080,int_stack+3375,int_stack+90135,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+216340,int_stack+215080,int_stack+212785,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+218230,int_stack+216340,int_stack+213730,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+220480,int_stack+63340,int_stack+62890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88515,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+221155,int_stack+63970,int_stack+63340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89190,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+222100,int_stack+221155,int_stack+220480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212110,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+223450,int_stack+64810,int_stack+63970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90135,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+224710,int_stack+223450,int_stack+221155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212785,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+226600,int_stack+224710,int_stack+222100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213730,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+228850,int_stack+0,int_stack+64810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3375,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+230470,int_stack+228850,int_stack+223450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215080,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+232990,int_stack+230470,int_stack+224710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216340,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+228850,int_stack+232990,int_stack+226600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218230,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+151525,int_stack+155750,int_stack+155600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175900, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+232225,int_stack+155960,int_stack+155750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176200, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+232855,int_stack+232225,int_stack+151525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198700, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+233755,int_stack+156240,int_stack+155960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176620, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+234595,int_stack+233755,int_stack+232225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199150, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+235855,int_stack+234595,int_stack+232855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199780, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+237355,int_stack+156600,int_stack+156240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177180, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+238435,int_stack+237355,int_stack+233755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200680, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+240115,int_stack+238435,int_stack+234595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201520, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+237355,int_stack+240115,int_stack+235855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202780, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+68465,int_stack+68015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88515, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239605,int_stack+69095,int_stack+68465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89190, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+240550,int_stack+239605,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212110, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+241900,int_stack+69935,int_stack+69095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90135, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+243160,int_stack+241900,int_stack+239605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212785, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+245050,int_stack+243160,int_stack+240550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213730, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+247300,int_stack+675,int_stack+69935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3375, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+248920,int_stack+247300,int_stack+241900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215080, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+251440,int_stack+248920,int_stack+243160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216340, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+247300,int_stack+251440,int_stack+245050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218230, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+156600,int_stack+160825,int_stack+160675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175900, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+250675,int_stack+161035,int_stack+160825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176200, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+251305,int_stack+250675,int_stack+156600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198700, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+252205,int_stack+161315,int_stack+161035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176620, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+253045,int_stack+252205,int_stack+250675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199150, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+254305,int_stack+253045,int_stack+251305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199780, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+255805,int_stack+161675,int_stack+161315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177180, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+256885,int_stack+255805,int_stack+252205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200680, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+258565,int_stack+256885,int_stack+253045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201520, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+255805,int_stack+258565,int_stack+254305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202780, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+675,int_stack+73590,int_stack+73140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88515, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+258055,int_stack+74220,int_stack+73590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89190, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+259000,int_stack+258055,int_stack+675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212110, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+260350,int_stack+75060,int_stack+74220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90135, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+261610,int_stack+260350,int_stack+258055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212785, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+263500,int_stack+261610,int_stack+259000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213730, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+265750,int_stack+1350,int_stack+75060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3375, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+267370,int_stack+265750,int_stack+260350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215080, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+269890,int_stack+267370,int_stack+261610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216340, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+265750,int_stack+269890,int_stack+263500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218230, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+161675,int_stack+165900,int_stack+165750, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+269125,int_stack+166110,int_stack+165900, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+269755,int_stack+269125,int_stack+161675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+270655,int_stack+166390,int_stack+166110, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+271495,int_stack+270655,int_stack+269125, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+272755,int_stack+271495,int_stack+269755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+274255,int_stack+166750,int_stack+166390, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+275335,int_stack+274255,int_stack+270655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+277015,int_stack+275335,int_stack+271495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+274255,int_stack+277015,int_stack+272755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+78715,int_stack+78265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+276505,int_stack+79345,int_stack+78715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+277450,int_stack+276505,int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+278800,int_stack+80185,int_stack+79345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+280060,int_stack+278800,int_stack+276505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+281950,int_stack+280060,int_stack+277450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+284200,int_stack+2025,int_stack+80185, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+285820,int_stack+284200,int_stack+278800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+288340,int_stack+285820,int_stack+280060, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+284200,int_stack+288340,int_stack+281950, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+166750,int_stack+170975,int_stack+170825, 0.0, zero_stack, 1.0, int_stack+175900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+287575,int_stack+171185,int_stack+170975, 0.0, zero_stack, 1.0, int_stack+176200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+288205,int_stack+287575,int_stack+166750, 0.0, zero_stack, 1.0, int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+289105,int_stack+171465,int_stack+171185, 0.0, zero_stack, 1.0, int_stack+176620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+289945,int_stack+289105,int_stack+287575, 0.0, zero_stack, 1.0, int_stack+199150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+291205,int_stack+289945,int_stack+288205, 0.0, zero_stack, 1.0, int_stack+199780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+292705,int_stack+171825,int_stack+171465, 0.0, zero_stack, 1.0, int_stack+177180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293785,int_stack+292705,int_stack+289105, 0.0, zero_stack, 1.0, int_stack+200680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+295465,int_stack+293785,int_stack+289945, 0.0, zero_stack, 1.0, int_stack+201520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+292705,int_stack+295465,int_stack+291205, 0.0, zero_stack, 1.0, int_stack+202780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+83840,int_stack+83390, 0.0, zero_stack, 1.0, int_stack+88515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294955,int_stack+84470,int_stack+83840, 0.0, zero_stack, 1.0, int_stack+89190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+295900,int_stack+294955,int_stack+2025, 0.0, zero_stack, 1.0, int_stack+212110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+297250,int_stack+85310,int_stack+84470, 0.0, zero_stack, 1.0, int_stack+90135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+298510,int_stack+297250,int_stack+294955, 0.0, zero_stack, 1.0, int_stack+212785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+300400,int_stack+298510,int_stack+295900, 0.0, zero_stack, 1.0, int_stack+213730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+302650,int_stack+2700,int_stack+85310, 0.0, zero_stack, 1.0, int_stack+3375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+304270,int_stack+302650,int_stack+297250, 0.0, zero_stack, 1.0, int_stack+215080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+306790,int_stack+304270,int_stack+298510, 0.0, zero_stack, 1.0, int_stack+216340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+302650,int_stack+306790,int_stack+300400, 0.0, zero_stack, 1.0, int_stack+218230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+171825,int_stack+176410,int_stack+176050, 1.0, int_stack+175900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306025,int_stack+176900,int_stack+176410, 1.0, int_stack+176200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+306655,int_stack+306025,int_stack+171825, 1.0, int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+307555,int_stack+177540,int_stack+176900, 1.0, int_stack+176620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+308395,int_stack+307555,int_stack+306025, 1.0, int_stack+199150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+309655,int_stack+308395,int_stack+306655, 1.0, int_stack+199780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+198700,int_stack+177900,int_stack+177540, 1.0, int_stack+177180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+311155,int_stack+198700,int_stack+307555, 1.0, int_stack+200680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+312835,int_stack+311155,int_stack+308395, 1.0, int_stack+201520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+314935,int_stack+312835,int_stack+309655, 1.0, int_stack+202780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2700,int_stack+89505,int_stack+88740, 1.0, int_stack+88515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+311155,int_stack+90555,int_stack+89505, 1.0, int_stack+89190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+312100,int_stack+311155,int_stack+2700, 1.0, int_stack+212110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+313450,int_stack+91395,int_stack+90555, 1.0, int_stack+90135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+313450,int_stack+311155, 1.0, int_stack+212785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+317185,int_stack+198700,int_stack+312100, 1.0, int_stack+213730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+212110,int_stack+3915,int_stack+91395, 1.0, int_stack+3375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+319435,int_stack+212110,int_stack+313450, 1.0, int_stack+215080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+212110,int_stack+319435,int_stack+198700, 1.0, int_stack+216340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+319435,int_stack+212110,int_stack+317185, 1.0, int_stack+218230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+212110,int_stack+5940,int_stack+177180,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+213190,int_stack+212110,int_stack+200680,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+214870,int_stack+213190,int_stack+201520,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+212110,int_stack+214870,int_stack+202780,10);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+5940,int_stack+183625,int_stack+183475,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+214360,int_stack+183835,int_stack+183625,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+214990,int_stack+214360,int_stack+5940,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+215890,int_stack+184115,int_stack+183835,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+216730,int_stack+215890,int_stack+214360,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+217990,int_stack+216730,int_stack+214990,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3375,int_stack+184475,int_stack+184115,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+200590,int_stack+3375,int_stack+215890,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+322810,int_stack+200590,int_stack+216730,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+200590,int_stack+322810,int_stack+217990,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+322810,int_stack+113175,int_stack+112725,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+323485,int_stack+113805,int_stack+113175,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+323485,int_stack+322810,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+324430,int_stack+114645,int_stack+113805,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+325690,int_stack+324430,int_stack+323485,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+327580,int_stack+325690,int_stack+202840,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+329830,int_stack+4590,int_stack+114645,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+331450,int_stack+329830,int_stack+324430,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+333970,int_stack+331450,int_stack+325690,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+329830,int_stack+333970,int_stack+327580,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+184475,int_stack+188700,int_stack+188550,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+333205,int_stack+188910,int_stack+188700,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+333835,int_stack+333205,int_stack+184475,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+334735,int_stack+189190,int_stack+188910,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+335575,int_stack+334735,int_stack+333205,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+3375,int_stack+335575,int_stack+333835,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+336835,int_stack+189550,int_stack+189190,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+337915,int_stack+336835,int_stack+334735,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+339595,int_stack+337915,int_stack+335575,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+336835,int_stack+339595,int_stack+3375,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+339085,int_stack+140050,int_stack+139600,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+339760,int_stack+140680,int_stack+140050,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+340705,int_stack+339760,int_stack+339085,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+342055,int_stack+141520,int_stack+140680,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+343315,int_stack+342055,int_stack+339760,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+345205,int_stack+343315,int_stack+340705,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+347455,int_stack+5265,int_stack+141520,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+349075,int_stack+347455,int_stack+342055,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+351595,int_stack+349075,int_stack+343315,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+347455,int_stack+351595,int_stack+345205,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+189550,int_stack+193775,int_stack+193625,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+350830,int_stack+193985,int_stack+193775,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+351460,int_stack+350830,int_stack+189550,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+352360,int_stack+194265,int_stack+193985,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+353200,int_stack+352360,int_stack+350830,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+354460,int_stack+353200,int_stack+351460,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+355960,int_stack+194625,int_stack+194265,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+357040,int_stack+355960,int_stack+352360,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+358720,int_stack+357040,int_stack+353200,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+355960,int_stack+358720,int_stack+354460,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+358210,int_stack+180250,int_stack+179800,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+358885,int_stack+180880,int_stack+180250,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+359830,int_stack+358885,int_stack+358210,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+361180,int_stack+181720,int_stack+180880,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+362440,int_stack+361180,int_stack+358885,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+364330,int_stack+362440,int_stack+359830,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+366580,int_stack+6390,int_stack+181720,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+368200,int_stack+366580,int_stack+361180,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+370720,int_stack+368200,int_stack+362440,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+366580,int_stack+370720,int_stack+364330,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+7215,int_stack+7065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+150525,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+369955,int_stack+7425,int_stack+7215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+150675,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+370585,int_stack+369955,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+204280,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+371485,int_stack+7705,int_stack+7425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+150885,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+372325,int_stack+371485,int_stack+369955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+204730,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+373585,int_stack+372325,int_stack+370585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+205360,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+369955,int_stack+8065,int_stack+7705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+151165,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6390,int_stack+369955,int_stack+371485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+206260,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+369955,int_stack+6390,int_stack+372325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+207100,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+375085,int_stack+369955,int_stack+373585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+208360,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+369955,int_stack+8740,int_stack+8515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+62890,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+370630,int_stack+9055,int_stack+8740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+63340,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+371575,int_stack+370630,int_stack+369955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+220480,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+372925,int_stack+9475,int_stack+9055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+63970,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6390,int_stack+372925,int_stack+370630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+221155,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+377335,int_stack+6390,int_stack+371575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+222100,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+369955,int_stack+10015,int_stack+9475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+64810,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+379585,int_stack+369955,int_stack+372925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+223450,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+369955,int_stack+379585,int_stack+6390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+224710,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+6390,int_stack+369955,int_stack+377335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+226600,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+10840,int_stack+10690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150525, 1.0, int_stack+155600,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+377335,int_stack+11050,int_stack+10840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150675, 1.0, int_stack+155750,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+377965,int_stack+377335,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204280, 1.0, int_stack+151525,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+378865,int_stack+11330,int_stack+11050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150885, 1.0, int_stack+155960,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+379705,int_stack+378865,int_stack+377335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204730, 1.0, int_stack+232225,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+380965,int_stack+379705,int_stack+377965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+205360, 1.0, int_stack+232855,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+377335,int_stack+11690,int_stack+11330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151165, 1.0, int_stack+156240,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+369955,int_stack+377335,int_stack+378865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206260, 1.0, int_stack+233755,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+377335,int_stack+369955,int_stack+379705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207100, 1.0, int_stack+234595,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+369955,int_stack+377335,int_stack+380965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208360, 1.0, int_stack+235855,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+377335,int_stack+12365,int_stack+12140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62890, 1.0, int_stack+68015,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378010,int_stack+12680,int_stack+12365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63340, 1.0, int_stack+68465,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+378955,int_stack+378010,int_stack+377335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220480, 1.0, int_stack+0,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+380305,int_stack+13100,int_stack+12680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63970, 1.0, int_stack+69095,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+372205,int_stack+380305,int_stack+378010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221155, 1.0, int_stack+239605,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+9765,int_stack+372205,int_stack+378955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222100, 1.0, int_stack+240550,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+377335,int_stack+13640,int_stack+13100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+64810, 1.0, int_stack+69935,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+381565,int_stack+377335,int_stack+380305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223450, 1.0, int_stack+241900,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+377335,int_stack+381565,int_stack+372205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224710, 1.0, int_stack+243160,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+380485,int_stack+377335,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226600, 1.0, int_stack+245050,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+14465,int_stack+14315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+155600, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9765,int_stack+14675,int_stack+14465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+155750, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+10395,int_stack+9765,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+151525, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+11295,int_stack+14955,int_stack+14675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+155960, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12135,int_stack+11295,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+232225, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+13395,int_stack+12135,int_stack+10395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+232855, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9765,int_stack+15315,int_stack+14955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+156240, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+377335,int_stack+9765,int_stack+11295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+233755, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9765,int_stack+377335,int_stack+12135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+234595, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+377335,int_stack+9765,int_stack+13395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+235855, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9765,int_stack+15990,int_stack+15765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+68015, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10440,int_stack+16305,int_stack+15990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+68465, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11385,int_stack+10440,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12735,int_stack+16725,int_stack+16305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+69095, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+13995,int_stack+12735,int_stack+10440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+239605, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+372205,int_stack+13995,int_stack+11385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+240550, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9765,int_stack+17265,int_stack+16725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+69935, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+383860,int_stack+9765,int_stack+12735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+241900, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9765,int_stack+383860,int_stack+13995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+243160, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+12915,int_stack+9765,int_stack+372205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+245050, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+18090,int_stack+17940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150525, 0.0, zero_stack, 1.0, int_stack+160675,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+372205,int_stack+18300,int_stack+18090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150675, 0.0, zero_stack, 1.0, int_stack+160825,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+379585,int_stack+372205,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204280, 0.0, zero_stack, 1.0, int_stack+156600,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+372835,int_stack+18580,int_stack+18300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150885, 0.0, zero_stack, 1.0, int_stack+161035,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+373675,int_stack+372835,int_stack+372205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204730, 0.0, zero_stack, 1.0, int_stack+250675,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+9765,int_stack+373675,int_stack+379585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+205360, 0.0, zero_stack, 1.0, int_stack+251305,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11265,int_stack+18940,int_stack+18580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151165, 0.0, zero_stack, 1.0, int_stack+161315,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+383860,int_stack+11265,int_stack+372835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206260, 0.0, zero_stack, 1.0, int_stack+252205,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16290,int_stack+383860,int_stack+373675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207100, 0.0, zero_stack, 1.0, int_stack+253045,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+383860,int_stack+16290,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208360, 0.0, zero_stack, 1.0, int_stack+254305,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9765,int_stack+19615,int_stack+19390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62890, 0.0, zero_stack, 1.0, int_stack+73140,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10440,int_stack+19930,int_stack+19615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63340, 0.0, zero_stack, 1.0, int_stack+73590,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11385,int_stack+10440,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220480, 0.0, zero_stack, 1.0, int_stack+675,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+16290,int_stack+20350,int_stack+19930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63970, 0.0, zero_stack, 1.0, int_stack+74220,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+17550,int_stack+16290,int_stack+10440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221155, 0.0, zero_stack, 1.0, int_stack+258055,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+372205,int_stack+17550,int_stack+11385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222100, 0.0, zero_stack, 1.0, int_stack+259000,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9765,int_stack+20890,int_stack+20350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+64810, 0.0, zero_stack, 1.0, int_stack+75060,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+386110,int_stack+9765,int_stack+16290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223450, 0.0, zero_stack, 1.0, int_stack+260350,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9765,int_stack+386110,int_stack+17550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224710, 0.0, zero_stack, 1.0, int_stack+261610,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+16290,int_stack+9765,int_stack+372205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226600, 0.0, zero_stack, 1.0, int_stack+263500,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+21715,int_stack+21565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155600, 1.0, int_stack+160675, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+372205,int_stack+21925,int_stack+21715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155750, 1.0, int_stack+160825, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+379585,int_stack+372205,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151525, 1.0, int_stack+156600, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+372835,int_stack+22205,int_stack+21925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155960, 1.0, int_stack+161035, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+373675,int_stack+372835,int_stack+372205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232225, 1.0, int_stack+250675, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+9765,int_stack+373675,int_stack+379585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232855, 1.0, int_stack+251305, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11265,int_stack+22565,int_stack+22205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156240, 1.0, int_stack+161315, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+386110,int_stack+11265,int_stack+372835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233755, 1.0, int_stack+252205, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+19665,int_stack+386110,int_stack+373675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234595, 1.0, int_stack+253045, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+386110,int_stack+19665,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+235855, 1.0, int_stack+254305, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9765,int_stack+23240,int_stack+23015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68015, 1.0, int_stack+73140, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10440,int_stack+23555,int_stack+23240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68465, 1.0, int_stack+73590, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11385,int_stack+10440,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+675, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19665,int_stack+23975,int_stack+23555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69095, 1.0, int_stack+74220, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+20925,int_stack+19665,int_stack+10440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239605, 1.0, int_stack+258055, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+372205,int_stack+20925,int_stack+11385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+240550, 1.0, int_stack+259000, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9765,int_stack+24515,int_stack+23975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69935, 1.0, int_stack+75060, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+388360,int_stack+9765,int_stack+19665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241900, 1.0, int_stack+260350, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9765,int_stack+388360,int_stack+20925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243160, 1.0, int_stack+261610, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+19665,int_stack+9765,int_stack+372205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245050, 1.0, int_stack+263500, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+25340,int_stack+25190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+160675, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+372205,int_stack+25550,int_stack+25340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+160825, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+379585,int_stack+372205,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+156600, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+372835,int_stack+25830,int_stack+25550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+161035, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+373675,int_stack+372835,int_stack+372205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+250675, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+9765,int_stack+373675,int_stack+379585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+251305, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11265,int_stack+26190,int_stack+25830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+161315, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+388360,int_stack+11265,int_stack+372835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+252205, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+23040,int_stack+388360,int_stack+373675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+253045, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+388360,int_stack+23040,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+254305, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9765,int_stack+26865,int_stack+26640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+73140, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10440,int_stack+27180,int_stack+26865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+73590, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11385,int_stack+10440,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+675, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23040,int_stack+27600,int_stack+27180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+74220, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+24300,int_stack+23040,int_stack+10440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+258055, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+372205,int_stack+24300,int_stack+11385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+259000, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9765,int_stack+28140,int_stack+27600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+75060, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+26190,int_stack+9765,int_stack+23040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+260350, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9765,int_stack+26190,int_stack+24300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+261610, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+23040,int_stack+9765,int_stack+372205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+263500, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+28965,int_stack+28815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165750,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+372205,int_stack+29175,int_stack+28965, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165900,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+379585,int_stack+372205,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204280, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161675,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+372835,int_stack+29455,int_stack+29175, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150885, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166110,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+373675,int_stack+372835,int_stack+372205, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269125,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+9765,int_stack+373675,int_stack+379585, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+205360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269755,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11265,int_stack+29815,int_stack+29455, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166390,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+26415,int_stack+11265,int_stack+372835, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270655,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+28095,int_stack+26415,int_stack+373675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207100, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271495,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+372205,int_stack+28095,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272755,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9765,int_stack+30490,int_stack+30265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78265,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10440,int_stack+30805,int_stack+30490, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78715,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11385,int_stack+10440,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26415,int_stack+31225,int_stack+30805, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63970, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79345,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+27675,int_stack+26415,int_stack+10440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221155, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276505,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+390610,int_stack+27675,int_stack+11385, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222100, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277450,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9765,int_stack+31765,int_stack+31225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+64810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80185,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+29565,int_stack+9765,int_stack+26415, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+278800,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9765,int_stack+29565,int_stack+27675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224710, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280060,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+26415,int_stack+9765,int_stack+390610, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226600, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+281950,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+32590,int_stack+32440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155600, 0.0, zero_stack, 1.0, int_stack+165750, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+32800,int_stack+32590, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155750, 0.0, zero_stack, 1.0, int_stack+165900, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+379585,int_stack+374455,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151525, 0.0, zero_stack, 1.0, int_stack+161675, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+390610,int_stack+33080,int_stack+32800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155960, 0.0, zero_stack, 1.0, int_stack+166110, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+391450,int_stack+390610,int_stack+374455, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232225, 0.0, zero_stack, 1.0, int_stack+269125, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+9765,int_stack+391450,int_stack+379585, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232855, 0.0, zero_stack, 1.0, int_stack+269755, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11265,int_stack+33440,int_stack+33080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156240, 0.0, zero_stack, 1.0, int_stack+166390, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+29790,int_stack+11265,int_stack+390610, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233755, 0.0, zero_stack, 1.0, int_stack+270655, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+31470,int_stack+29790,int_stack+391450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234595, 0.0, zero_stack, 1.0, int_stack+271495, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+390610,int_stack+31470,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+235855, 0.0, zero_stack, 1.0, int_stack+272755, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9765,int_stack+34115,int_stack+33890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68015, 0.0, zero_stack, 1.0, int_stack+78265, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10440,int_stack+34430,int_stack+34115, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68465, 0.0, zero_stack, 1.0, int_stack+78715, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11385,int_stack+10440,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+29790,int_stack+34850,int_stack+34430, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69095, 0.0, zero_stack, 1.0, int_stack+79345, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+31050,int_stack+29790,int_stack+10440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239605, 0.0, zero_stack, 1.0, int_stack+276505, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+392860,int_stack+31050,int_stack+11385, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+240550, 0.0, zero_stack, 1.0, int_stack+277450, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9765,int_stack+35390,int_stack+34850, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69935, 0.0, zero_stack, 1.0, int_stack+80185, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+32940,int_stack+9765,int_stack+29790, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241900, 0.0, zero_stack, 1.0, int_stack+278800, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9765,int_stack+32940,int_stack+31050, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243160, 0.0, zero_stack, 1.0, int_stack+280060, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+29790,int_stack+9765,int_stack+392860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245050, 0.0, zero_stack, 1.0, int_stack+281950, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+36215,int_stack+36065, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160675, 1.0, int_stack+165750, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+36425,int_stack+36215, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160825, 1.0, int_stack+165900, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+379585,int_stack+374455,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156600, 1.0, int_stack+161675, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+392860,int_stack+36705,int_stack+36425, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161035, 1.0, int_stack+166110, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+393700,int_stack+392860,int_stack+374455, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250675, 1.0, int_stack+269125, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+9765,int_stack+393700,int_stack+379585, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251305, 1.0, int_stack+269755, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11265,int_stack+37065,int_stack+36705, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161315, 1.0, int_stack+166390, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+33165,int_stack+11265,int_stack+392860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252205, 1.0, int_stack+270655, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+34845,int_stack+33165,int_stack+393700, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253045, 1.0, int_stack+271495, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+392860,int_stack+34845,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254305, 1.0, int_stack+272755, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9765,int_stack+37740,int_stack+37515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73140, 1.0, int_stack+78265, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10440,int_stack+38055,int_stack+37740, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73590, 1.0, int_stack+78715, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11385,int_stack+10440,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+675, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+33165,int_stack+38475,int_stack+38055, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+74220, 1.0, int_stack+79345, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+34425,int_stack+33165,int_stack+10440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258055, 1.0, int_stack+276505, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+395110,int_stack+34425,int_stack+11385, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259000, 1.0, int_stack+277450, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9765,int_stack+39015,int_stack+38475, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75060, 1.0, int_stack+80185, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+36315,int_stack+9765,int_stack+33165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260350, 1.0, int_stack+278800, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9765,int_stack+36315,int_stack+34425, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261610, 1.0, int_stack+280060, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+33165,int_stack+9765,int_stack+395110, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263500, 1.0, int_stack+281950, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+39840,int_stack+39690, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+165750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+40050,int_stack+39840, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+165900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+379585,int_stack+374455,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+161675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+395110,int_stack+40330,int_stack+40050, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+166110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+395950,int_stack+395110,int_stack+374455, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+269125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+9765,int_stack+395950,int_stack+379585, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+269755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11265,int_stack+40690,int_stack+40330, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+166390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+36540,int_stack+11265,int_stack+395110, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+270655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+38220,int_stack+36540,int_stack+395950, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+271495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+395110,int_stack+38220,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+272755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9765,int_stack+41365,int_stack+41140, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+78265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10440,int_stack+41680,int_stack+41365, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+78715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11385,int_stack+10440,int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+36540,int_stack+42100,int_stack+41680, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+79345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+37800,int_stack+36540,int_stack+10440, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+276505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+39690,int_stack+37800,int_stack+11385, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+277450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9765,int_stack+42640,int_stack+42100, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+80185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+397360,int_stack+9765,int_stack+36540, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+278800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9765,int_stack+397360,int_stack+37800, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+280060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+397360,int_stack+9765,int_stack+39690, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+281950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+43465,int_stack+43315, 0.0, zero_stack, 1.0, int_stack+150525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170825,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+43675,int_stack+43465, 0.0, zero_stack, 1.0, int_stack+150675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170975,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+379585,int_stack+374455,int_stack+194625, 0.0, zero_stack, 1.0, int_stack+204280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166750,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9765,int_stack+43955,int_stack+43675, 0.0, zero_stack, 1.0, int_stack+150885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171185,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10605,int_stack+9765,int_stack+374455, 0.0, zero_stack, 1.0, int_stack+204730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+287575,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+36540,int_stack+10605,int_stack+379585, 0.0, zero_stack, 1.0, int_stack+205360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+288205,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+38040,int_stack+44315,int_stack+43955, 0.0, zero_stack, 1.0, int_stack+151165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171465,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+39120,int_stack+38040,int_stack+9765, 0.0, zero_stack, 1.0, int_stack+206260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289105,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+40800,int_stack+39120,int_stack+10605, 0.0, zero_stack, 1.0, int_stack+207100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289945,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+9765,int_stack+40800,int_stack+36540, 0.0, zero_stack, 1.0, int_stack+208360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+291205,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+36540,int_stack+44990,int_stack+44765, 0.0, zero_stack, 1.0, int_stack+62890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83390,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+37215,int_stack+45305,int_stack+44990, 0.0, zero_stack, 1.0, int_stack+63340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83840,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+38160,int_stack+37215,int_stack+36540, 0.0, zero_stack, 1.0, int_stack+220480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2025,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+39510,int_stack+45725,int_stack+45305, 0.0, zero_stack, 1.0, int_stack+63970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84470,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+40770,int_stack+39510,int_stack+37215, 0.0, zero_stack, 1.0, int_stack+221155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294955,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+42660,int_stack+40770,int_stack+38160, 0.0, zero_stack, 1.0, int_stack+222100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295900,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+36540,int_stack+46265,int_stack+45725, 0.0, zero_stack, 1.0, int_stack+64810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85310,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+400735,int_stack+36540,int_stack+39510, 0.0, zero_stack, 1.0, int_stack+223450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297250,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+36540,int_stack+400735,int_stack+40770, 0.0, zero_stack, 1.0, int_stack+224710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+298510,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+400735,int_stack+36540,int_stack+42660, 0.0, zero_stack, 1.0, int_stack+226600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300400,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+47090,int_stack+46940, 0.0, zero_stack, 1.0, int_stack+155600, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170825, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+47300,int_stack+47090, 0.0, zero_stack, 1.0, int_stack+155750, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170975, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12015,int_stack+374455,int_stack+194625, 0.0, zero_stack, 1.0, int_stack+151525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166750, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+36540,int_stack+47580,int_stack+47300, 0.0, zero_stack, 1.0, int_stack+155960, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171185, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+37380,int_stack+36540,int_stack+374455, 0.0, zero_stack, 1.0, int_stack+232225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+287575, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+38640,int_stack+37380,int_stack+12015, 0.0, zero_stack, 1.0, int_stack+232855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+288205, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+40140,int_stack+47940,int_stack+47580, 0.0, zero_stack, 1.0, int_stack+156240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171465, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+41220,int_stack+40140,int_stack+36540, 0.0, zero_stack, 1.0, int_stack+233755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289105, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+42900,int_stack+41220,int_stack+37380, 0.0, zero_stack, 1.0, int_stack+234595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289945, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+40140,int_stack+42900,int_stack+38640, 0.0, zero_stack, 1.0, int_stack+235855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+291205, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+36540,int_stack+48615,int_stack+48390, 0.0, zero_stack, 1.0, int_stack+68015, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83390, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+37215,int_stack+48930,int_stack+48615, 0.0, zero_stack, 1.0, int_stack+68465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83840, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+38160,int_stack+37215,int_stack+36540, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2025, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42390,int_stack+49350,int_stack+48930, 0.0, zero_stack, 1.0, int_stack+69095, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84470, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+43650,int_stack+42390,int_stack+37215, 0.0, zero_stack, 1.0, int_stack+239605, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294955, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+45540,int_stack+43650,int_stack+38160, 0.0, zero_stack, 1.0, int_stack+240550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295900, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+36540,int_stack+49890,int_stack+49350, 0.0, zero_stack, 1.0, int_stack+69935, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85310, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+47790,int_stack+36540,int_stack+42390, 0.0, zero_stack, 1.0, int_stack+241900, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297250, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+36540,int_stack+47790,int_stack+43650, 0.0, zero_stack, 1.0, int_stack+243160, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+298510, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+404110,int_stack+36540,int_stack+45540, 0.0, zero_stack, 1.0, int_stack+245050, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300400, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+50715,int_stack+50565, 0.0, zero_stack, 1.0, int_stack+160675, 0.0, zero_stack, 1.0, int_stack+170825, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+50925,int_stack+50715, 0.0, zero_stack, 1.0, int_stack+160825, 0.0, zero_stack, 1.0, int_stack+170975, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12015,int_stack+374455,int_stack+194625, 0.0, zero_stack, 1.0, int_stack+156600, 0.0, zero_stack, 1.0, int_stack+166750, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+36540,int_stack+51205,int_stack+50925, 0.0, zero_stack, 1.0, int_stack+161035, 0.0, zero_stack, 1.0, int_stack+171185, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+37380,int_stack+36540,int_stack+374455, 0.0, zero_stack, 1.0, int_stack+250675, 0.0, zero_stack, 1.0, int_stack+287575, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+38640,int_stack+37380,int_stack+12015, 0.0, zero_stack, 1.0, int_stack+251305, 0.0, zero_stack, 1.0, int_stack+288205, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+42390,int_stack+51565,int_stack+51205, 0.0, zero_stack, 1.0, int_stack+161315, 0.0, zero_stack, 1.0, int_stack+171465, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+43470,int_stack+42390,int_stack+36540, 0.0, zero_stack, 1.0, int_stack+252205, 0.0, zero_stack, 1.0, int_stack+289105, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+45150,int_stack+43470,int_stack+37380, 0.0, zero_stack, 1.0, int_stack+253045, 0.0, zero_stack, 1.0, int_stack+289945, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+42390,int_stack+45150,int_stack+38640, 0.0, zero_stack, 1.0, int_stack+254305, 0.0, zero_stack, 1.0, int_stack+291205, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+36540,int_stack+52240,int_stack+52015, 0.0, zero_stack, 1.0, int_stack+73140, 0.0, zero_stack, 1.0, int_stack+83390, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+37215,int_stack+52555,int_stack+52240, 0.0, zero_stack, 1.0, int_stack+73590, 0.0, zero_stack, 1.0, int_stack+83840, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+38160,int_stack+37215,int_stack+36540, 0.0, zero_stack, 1.0, int_stack+675, 0.0, zero_stack, 1.0, int_stack+2025, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+44640,int_stack+52975,int_stack+52555, 0.0, zero_stack, 1.0, int_stack+74220, 0.0, zero_stack, 1.0, int_stack+84470, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+45900,int_stack+44640,int_stack+37215, 0.0, zero_stack, 1.0, int_stack+258055, 0.0, zero_stack, 1.0, int_stack+294955, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+47790,int_stack+45900,int_stack+38160, 0.0, zero_stack, 1.0, int_stack+259000, 0.0, zero_stack, 1.0, int_stack+295900, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+36540,int_stack+53515,int_stack+52975, 0.0, zero_stack, 1.0, int_stack+75060, 0.0, zero_stack, 1.0, int_stack+85310, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+50040,int_stack+36540,int_stack+44640, 0.0, zero_stack, 1.0, int_stack+260350, 0.0, zero_stack, 1.0, int_stack+297250, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+36540,int_stack+50040,int_stack+45900, 0.0, zero_stack, 1.0, int_stack+261610, 0.0, zero_stack, 1.0, int_stack+298510, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+50040,int_stack+36540,int_stack+47790, 0.0, zero_stack, 1.0, int_stack+263500, 0.0, zero_stack, 1.0, int_stack+300400, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+54340,int_stack+54190, 0.0, zero_stack, 1.0, int_stack+165750, 1.0, int_stack+170825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+54550,int_stack+54340, 0.0, zero_stack, 1.0, int_stack+165900, 1.0, int_stack+170975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12015,int_stack+374455,int_stack+194625, 0.0, zero_stack, 1.0, int_stack+161675, 1.0, int_stack+166750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+36540,int_stack+54830,int_stack+54550, 0.0, zero_stack, 1.0, int_stack+166110, 1.0, int_stack+171185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+37380,int_stack+36540,int_stack+374455, 0.0, zero_stack, 1.0, int_stack+269125, 1.0, int_stack+287575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+38640,int_stack+37380,int_stack+12015, 0.0, zero_stack, 1.0, int_stack+269755, 1.0, int_stack+288205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+53415,int_stack+55190,int_stack+54830, 0.0, zero_stack, 1.0, int_stack+166390, 1.0, int_stack+171465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+44640,int_stack+53415,int_stack+36540, 0.0, zero_stack, 1.0, int_stack+270655, 1.0, int_stack+289105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+53415,int_stack+44640,int_stack+37380, 0.0, zero_stack, 1.0, int_stack+271495, 1.0, int_stack+289945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+44640,int_stack+53415,int_stack+38640, 0.0, zero_stack, 1.0, int_stack+272755, 1.0, int_stack+291205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+53415,int_stack+55865,int_stack+55640, 0.0, zero_stack, 1.0, int_stack+78265, 1.0, int_stack+83390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+54090,int_stack+56180,int_stack+55865, 0.0, zero_stack, 1.0, int_stack+78715, 1.0, int_stack+83840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+46890,int_stack+54090,int_stack+53415, 0.0, zero_stack, 1.0, int_stack+1350, 1.0, int_stack+2025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+48240,int_stack+56600,int_stack+56180, 0.0, zero_stack, 1.0, int_stack+79345, 1.0, int_stack+84470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+36540,int_stack+48240,int_stack+54090, 0.0, zero_stack, 1.0, int_stack+276505, 1.0, int_stack+294955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+53415,int_stack+36540,int_stack+46890, 0.0, zero_stack, 1.0, int_stack+277450, 1.0, int_stack+295900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+38430,int_stack+57140,int_stack+56600, 0.0, zero_stack, 1.0, int_stack+80185, 1.0, int_stack+85310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+407485,int_stack+38430,int_stack+48240, 0.0, zero_stack, 1.0, int_stack+278800, 1.0, int_stack+297250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+46890,int_stack+407485,int_stack+36540, 0.0, zero_stack, 1.0, int_stack+280060, 1.0, int_stack+298510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+36540,int_stack+46890,int_stack+53415, 0.0, zero_stack, 1.0, int_stack+281950, 1.0, int_stack+300400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+57965,int_stack+57815, 0.0, zero_stack, 2.0, int_stack+170825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+58175,int_stack+57965, 0.0, zero_stack, 2.0, int_stack+170975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12015,int_stack+374455,int_stack+194625, 0.0, zero_stack, 2.0, int_stack+166750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+53415,int_stack+58455,int_stack+58175, 0.0, zero_stack, 2.0, int_stack+171185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+54255,int_stack+53415,int_stack+374455, 0.0, zero_stack, 2.0, int_stack+287575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+55515,int_stack+54255,int_stack+12015, 0.0, zero_stack, 2.0, int_stack+288205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+57015,int_stack+58815,int_stack+58455, 0.0, zero_stack, 2.0, int_stack+171465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+46890,int_stack+57015,int_stack+53415, 0.0, zero_stack, 2.0, int_stack+289105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+57015,int_stack+46890,int_stack+54255, 0.0, zero_stack, 2.0, int_stack+289945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+46890,int_stack+57015,int_stack+55515, 0.0, zero_stack, 2.0, int_stack+291205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+49140,int_stack+59490,int_stack+59265, 0.0, zero_stack, 2.0, int_stack+83390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+53415,int_stack+59805,int_stack+59490, 0.0, zero_stack, 2.0, int_stack+83840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+54360,int_stack+53415,int_stack+49140, 0.0, zero_stack, 2.0, int_stack+2025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+55710,int_stack+60225,int_stack+59805, 0.0, zero_stack, 2.0, int_stack+84470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+56970,int_stack+55710,int_stack+53415, 0.0, zero_stack, 2.0, int_stack+294955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+407485,int_stack+56970,int_stack+54360, 0.0, zero_stack, 2.0, int_stack+295900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+53415,int_stack+60765,int_stack+60225, 0.0, zero_stack, 2.0, int_stack+85310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+58860,int_stack+53415,int_stack+55710, 0.0, zero_stack, 2.0, int_stack+297250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+53415,int_stack+58860,int_stack+56970, 0.0, zero_stack, 2.0, int_stack+298510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+56565,int_stack+53415,int_stack+407485, 0.0, zero_stack, 2.0, int_stack+300400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+61590,int_stack+61440, 1.0, int_stack+150525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176050,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+61800,int_stack+61590, 1.0, int_stack+150675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176410,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+49140,int_stack+374455,int_stack+194625, 1.0, int_stack+204280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171825,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+407485,int_stack+62080,int_stack+61800, 1.0, int_stack+150885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176900,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+408325,int_stack+407485,int_stack+374455, 1.0, int_stack+204730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306025,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+53415,int_stack+408325,int_stack+49140, 1.0, int_stack+205360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306655,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409585,int_stack+62440,int_stack+62080, 1.0, int_stack+151165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177540,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+59940,int_stack+409585,int_stack+407485, 1.0, int_stack+206260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+307555,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+204190,int_stack+59940,int_stack+408325, 1.0, int_stack+207100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308395,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+59940,int_stack+204190,int_stack+53415, 1.0, int_stack+208360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+309655,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+53415,int_stack+63655,int_stack+63115, 1.0, int_stack+62890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88740,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+54090,int_stack+64390,int_stack+63655, 1.0, int_stack+63340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89505,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+55035,int_stack+54090,int_stack+53415, 1.0, int_stack+220480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2700,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+204190,int_stack+65350,int_stack+64390, 1.0, int_stack+63970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90555,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+205450,int_stack+204190,int_stack+54090, 1.0, int_stack+221155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311155,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+207340,int_stack+205450,int_stack+55035, 1.0, int_stack+222100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+312100,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+53415,int_stack+65890,int_stack+65350, 1.0, int_stack+64810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91395,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+62190,int_stack+53415,int_stack+204190, 1.0, int_stack+223450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313450,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+53415,int_stack+62190,int_stack+205450, 1.0, int_stack+224710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198700,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+62190,int_stack+53415,int_stack+207340, 1.0, int_stack+226600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317185,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+66715,int_stack+66565, 1.0, int_stack+155600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176050, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+66925,int_stack+66715, 1.0, int_stack+155750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176410, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+49140,int_stack+374455,int_stack+194625, 1.0, int_stack+151525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171825, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+53415,int_stack+67205,int_stack+66925, 1.0, int_stack+155960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176900, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+54255,int_stack+53415,int_stack+374455, 1.0, int_stack+232225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306025, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+65565,int_stack+54255,int_stack+49140, 1.0, int_stack+232855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306655, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+232225,int_stack+67565,int_stack+67205, 1.0, int_stack+156240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177540, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+204190,int_stack+232225,int_stack+53415, 1.0, int_stack+233755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+307555, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+232225,int_stack+204190,int_stack+54255, 1.0, int_stack+234595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308395, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+204190,int_stack+232225,int_stack+65565, 1.0, int_stack+235855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+309655, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+65565,int_stack+68780,int_stack+68240, 1.0, int_stack+68015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88740, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+66240,int_stack+69515,int_stack+68780, 1.0, int_stack+68465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89505, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+67185,int_stack+66240,int_stack+65565, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2700, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+232225,int_stack+70475,int_stack+69515, 1.0, int_stack+69095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90555, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+233485,int_stack+232225,int_stack+66240, 1.0, int_stack+239605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311155, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+206440,int_stack+233485,int_stack+67185, 1.0, int_stack+240550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+312100, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+239605,int_stack+71015,int_stack+70475, 1.0, int_stack+69935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91395, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+65565,int_stack+239605,int_stack+232225, 1.0, int_stack+241900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313450, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+53415,int_stack+65565,int_stack+233485, 1.0, int_stack+243160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198700, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+65565,int_stack+53415,int_stack+206440, 1.0, int_stack+245050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317185, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+71840,int_stack+71690, 1.0, int_stack+160675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176050, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+72050,int_stack+71840, 1.0, int_stack+160825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176410, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+49140,int_stack+374455,int_stack+194625, 1.0, int_stack+156600, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171825, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+206440,int_stack+72330,int_stack+72050, 1.0, int_stack+161035, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176900, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+207280,int_stack+206440,int_stack+374455, 1.0, int_stack+250675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306025, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+53415,int_stack+207280,int_stack+49140, 1.0, int_stack+251305, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306655, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+250675,int_stack+72690,int_stack+72330, 1.0, int_stack+161315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177540, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+68940,int_stack+250675,int_stack+206440, 1.0, int_stack+252205, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+307555, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+250675,int_stack+68940,int_stack+207280, 1.0, int_stack+253045, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308395, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+68940,int_stack+250675,int_stack+53415, 1.0, int_stack+254305, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+309655, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+73905,int_stack+73365, 1.0, int_stack+73140, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88740, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+53415,int_stack+74640,int_stack+73905, 1.0, int_stack+73590, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89505, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+54360,int_stack+53415,int_stack+0, 1.0, int_stack+675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2700, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+75600,int_stack+74640, 1.0, int_stack+74220, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90555, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+250675,int_stack+0,int_stack+53415, 1.0, int_stack+258055, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311155, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+252565,int_stack+250675,int_stack+54360, 1.0, int_stack+259000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+312100, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+258055,int_stack+76140,int_stack+75600, 1.0, int_stack+75060, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91395, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+53415,int_stack+258055,int_stack+0, 1.0, int_stack+260350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313450, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+258055,int_stack+53415,int_stack+250675, 1.0, int_stack+261610, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198700, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+71190,int_stack+258055,int_stack+252565, 1.0, int_stack+263500, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317185, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+76965,int_stack+76815, 1.0, int_stack+165750, 0.0, zero_stack, 1.0, int_stack+176050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+77175,int_stack+76965, 1.0, int_stack+165900, 0.0, zero_stack, 1.0, int_stack+176410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+49140,int_stack+374455,int_stack+194625, 1.0, int_stack+161675, 0.0, zero_stack, 1.0, int_stack+171825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+258055,int_stack+77455,int_stack+77175, 1.0, int_stack+166110, 0.0, zero_stack, 1.0, int_stack+176900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+258895,int_stack+258055,int_stack+374455, 1.0, int_stack+269125, 0.0, zero_stack, 1.0, int_stack+306025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+260155,int_stack+258895,int_stack+49140, 1.0, int_stack+269755, 0.0, zero_stack, 1.0, int_stack+306655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+269125,int_stack+77815,int_stack+77455, 1.0, int_stack+166390, 0.0, zero_stack, 1.0, int_stack+177540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+261655,int_stack+269125,int_stack+258055, 1.0, int_stack+270655, 0.0, zero_stack, 1.0, int_stack+307555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+269125,int_stack+261655,int_stack+258895, 1.0, int_stack+271495, 0.0, zero_stack, 1.0, int_stack+308395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+261655,int_stack+269125,int_stack+260155, 1.0, int_stack+272755, 0.0, zero_stack, 1.0, int_stack+309655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+269125,int_stack+79030,int_stack+78490, 1.0, int_stack+78265, 0.0, zero_stack, 1.0, int_stack+88740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+269800,int_stack+79765,int_stack+79030, 1.0, int_stack+78715, 0.0, zero_stack, 1.0, int_stack+89505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+269800,int_stack+269125, 1.0, int_stack+1350, 0.0, zero_stack, 1.0, int_stack+2700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+270745,int_stack+80725,int_stack+79765, 1.0, int_stack+79345, 0.0, zero_stack, 1.0, int_stack+90555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+272005,int_stack+270745,int_stack+269800, 1.0, int_stack+276505, 0.0, zero_stack, 1.0, int_stack+311155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+258055,int_stack+272005,int_stack+0, 1.0, int_stack+277450, 0.0, zero_stack, 1.0, int_stack+312100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+269125,int_stack+81265,int_stack+80725, 1.0, int_stack+80185, 0.0, zero_stack, 1.0, int_stack+91395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+250675,int_stack+269125,int_stack+270745, 1.0, int_stack+278800, 0.0, zero_stack, 1.0, int_stack+313450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+53415,int_stack+250675,int_stack+272005, 1.0, int_stack+280060, 0.0, zero_stack, 1.0, int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+250675,int_stack+53415,int_stack+258055, 1.0, int_stack+281950, 0.0, zero_stack, 1.0, int_stack+317185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+82090,int_stack+81940, 1.0, int_stack+170825, 1.0, int_stack+176050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+82300,int_stack+82090, 1.0, int_stack+170975, 1.0, int_stack+176410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+49140,int_stack+374455,int_stack+194625, 1.0, int_stack+166750, 1.0, int_stack+171825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+258055,int_stack+82580,int_stack+82300, 1.0, int_stack+171185, 1.0, int_stack+176900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+258895,int_stack+258055,int_stack+374455, 1.0, int_stack+287575, 1.0, int_stack+306025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+260155,int_stack+258895,int_stack+49140, 1.0, int_stack+288205, 1.0, int_stack+306655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+287575,int_stack+82940,int_stack+82580, 1.0, int_stack+171465, 1.0, int_stack+177540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+53415,int_stack+287575,int_stack+258055, 1.0, int_stack+289105, 1.0, int_stack+307555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+287575,int_stack+53415,int_stack+258895, 1.0, int_stack+289945, 1.0, int_stack+308395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+53415,int_stack+287575,int_stack+260155, 1.0, int_stack+291205, 1.0, int_stack+309655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+287575,int_stack+84155,int_stack+83615, 1.0, int_stack+83390, 1.0, int_stack+88740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+288250,int_stack+84890,int_stack+84155, 1.0, int_stack+83840, 1.0, int_stack+89505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+289195,int_stack+288250,int_stack+287575, 1.0, int_stack+2025, 1.0, int_stack+2700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+290545,int_stack+85850,int_stack+84890, 1.0, int_stack+84470, 1.0, int_stack+90555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+258055,int_stack+290545,int_stack+288250, 1.0, int_stack+294955, 1.0, int_stack+311155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+269125,int_stack+258055,int_stack+289195, 1.0, int_stack+295900, 1.0, int_stack+312100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+294955,int_stack+86390,int_stack+85850, 1.0, int_stack+85310, 1.0, int_stack+91395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+287575,int_stack+294955,int_stack+290545, 1.0, int_stack+297250, 1.0, int_stack+313450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+294955,int_stack+287575,int_stack+258055, 1.0, int_stack+298510, 1.0, int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+258055,int_stack+294955,int_stack+269125, 1.0, int_stack+300400, 1.0, int_stack+317185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+87215,int_stack+87065, 2.0, int_stack+176050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+87425,int_stack+87215, 2.0, int_stack+176410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+55665,int_stack+374455,int_stack+194625, 2.0, int_stack+171825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+269125,int_stack+87705,int_stack+87425, 2.0, int_stack+176900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+269965,int_stack+269125,int_stack+374455, 2.0, int_stack+306025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+271225,int_stack+269965,int_stack+55665, 2.0, int_stack+306655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+306025,int_stack+88065,int_stack+87705, 2.0, int_stack+177540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+294955,int_stack+306025,int_stack+269125, 2.0, int_stack+307555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+306025,int_stack+294955,int_stack+269965, 2.0, int_stack+308395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+294955,int_stack+306025,int_stack+271225, 2.0, int_stack+309655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+306025,int_stack+89820,int_stack+88965, 2.0, int_stack+88740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306700,int_stack+90975,int_stack+89820, 2.0, int_stack+89505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+307645,int_stack+306700,int_stack+306025, 2.0, int_stack+2700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+308995,int_stack+91935,int_stack+90975, 2.0, int_stack+90555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+297205,int_stack+308995,int_stack+306700, 2.0, int_stack+311155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+299095,int_stack+297205,int_stack+307645, 2.0, int_stack+312100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+306025,int_stack+92475,int_stack+91935, 2.0, int_stack+91395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+310255,int_stack+306025,int_stack+308995, 2.0, int_stack+313450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+306025,int_stack+310255,int_stack+297205, 2.0, int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+306025,int_stack+299095, 2.0, int_stack+317185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+93300,int_stack+93150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183475,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+93510,int_stack+93300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183625,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+55665,int_stack+374455,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5940,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+317185,int_stack+93790,int_stack+93510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183835,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+318025,int_stack+317185,int_stack+374455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214360,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+306025,int_stack+318025,int_stack+55665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214990,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+307525,int_stack+94150,int_stack+93790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184115,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+308605,int_stack+307525,int_stack+317185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215890,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+310285,int_stack+308605,int_stack+318025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216730,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+317185,int_stack+310285,int_stack+306025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217990,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+306025,int_stack+94825,int_stack+94600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112725,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306700,int_stack+95140,int_stack+94825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113175,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+307645,int_stack+306700,int_stack+306025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+322810,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+308995,int_stack+95560,int_stack+95140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113805,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+308995,int_stack+306700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+323485,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+310255,int_stack+198700,int_stack+307645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202840,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+306025,int_stack+96100,int_stack+95560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114645,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+297205,int_stack+306025,int_stack+308995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+324430,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+306025,int_stack+297205,int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+325690,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+297205,int_stack+306025,int_stack+310255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327580,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+96925,int_stack+96775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183475, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+97135,int_stack+96925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183625, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+55665,int_stack+374455,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5940, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+306025,int_stack+97415,int_stack+97135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183835, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+306865,int_stack+306025,int_stack+374455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214360, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+308125,int_stack+306865,int_stack+55665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214990, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+309625,int_stack+97775,int_stack+97415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184115, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+310705,int_stack+309625,int_stack+306025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215890, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+312385,int_stack+310705,int_stack+306865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216730, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+309625,int_stack+312385,int_stack+308125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217990, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+306025,int_stack+98450,int_stack+98225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112725, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306700,int_stack+98765,int_stack+98450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113175, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+307645,int_stack+306700,int_stack+306025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+322810, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+311875,int_stack+99185,int_stack+98765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113805, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+311875,int_stack+306700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+323485, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+269125,int_stack+198700,int_stack+307645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202840, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+306025,int_stack+99725,int_stack+99185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114645, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+271375,int_stack+306025,int_stack+311875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+324430, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+306025,int_stack+271375,int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+325690, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+287575,int_stack+306025,int_stack+269125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327580, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+100550,int_stack+100400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183475, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+100760,int_stack+100550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183625, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+55665,int_stack+374455,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5940, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+269125,int_stack+101040,int_stack+100760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183835, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+269965,int_stack+269125,int_stack+374455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214360, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+271225,int_stack+269965,int_stack+55665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214990, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+272725,int_stack+101400,int_stack+101040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184115, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+306025,int_stack+272725,int_stack+269125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215890, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+311875,int_stack+306025,int_stack+269965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216730, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+306025,int_stack+311875,int_stack+271225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217990, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+311875,int_stack+102075,int_stack+101850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112725, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+312550,int_stack+102390,int_stack+102075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113175, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+308275,int_stack+312550,int_stack+311875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+322810, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+313495,int_stack+102810,int_stack+102390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113805, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+313495,int_stack+312550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+323485, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+269125,int_stack+198700,int_stack+308275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202840, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+311875,int_stack+103350,int_stack+102810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114645, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+271375,int_stack+311875,int_stack+313495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+324430, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+276505,int_stack+271375,int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+325690, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+279655,int_stack+276505,int_stack+269125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327580, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+104175,int_stack+104025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+104385,int_stack+104175, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+55665,int_stack+374455,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+269125,int_stack+104665,int_stack+104385, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+269965,int_stack+269125,int_stack+374455, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+271225,int_stack+269965,int_stack+55665, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+272725,int_stack+105025,int_stack+104665, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+276505,int_stack+272725,int_stack+269125, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+311875,int_stack+276505,int_stack+269965, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+276505,int_stack+311875,int_stack+271225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+311875,int_stack+105700,int_stack+105475, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+312550,int_stack+106015,int_stack+105700, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+308275,int_stack+312550,int_stack+311875, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+322810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+313495,int_stack+106435,int_stack+106015, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+313495,int_stack+312550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+323485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+269125,int_stack+198700,int_stack+308275, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+311875,int_stack+106975,int_stack+106435, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+271375,int_stack+311875,int_stack+313495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+324430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+74565,int_stack+271375,int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+325690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+77715,int_stack+74565,int_stack+269125, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+107800,int_stack+107650, 0.0, zero_stack, 1.0, int_stack+183475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+108010,int_stack+107800, 0.0, zero_stack, 1.0, int_stack+183625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+278755,int_stack+374455,int_stack+194625, 0.0, zero_stack, 1.0, int_stack+5940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+269125,int_stack+108290,int_stack+108010, 0.0, zero_stack, 1.0, int_stack+183835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+269965,int_stack+269125,int_stack+374455, 0.0, zero_stack, 1.0, int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+271225,int_stack+269965,int_stack+278755, 0.0, zero_stack, 1.0, int_stack+214990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+272725,int_stack+108650,int_stack+108290, 0.0, zero_stack, 1.0, int_stack+184115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+74565,int_stack+272725,int_stack+269125, 0.0, zero_stack, 1.0, int_stack+215890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+311875,int_stack+74565,int_stack+269965, 0.0, zero_stack, 1.0, int_stack+216730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+74565,int_stack+311875,int_stack+271225, 0.0, zero_stack, 1.0, int_stack+217990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+311875,int_stack+109325,int_stack+109100, 0.0, zero_stack, 1.0, int_stack+112725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+312550,int_stack+109640,int_stack+109325, 0.0, zero_stack, 1.0, int_stack+113175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+308275,int_stack+312550,int_stack+311875, 0.0, zero_stack, 1.0, int_stack+322810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+313495,int_stack+110060,int_stack+109640, 0.0, zero_stack, 1.0, int_stack+113805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+313495,int_stack+312550, 0.0, zero_stack, 1.0, int_stack+323485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+269125,int_stack+198700,int_stack+308275, 0.0, zero_stack, 1.0, int_stack+202840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+311875,int_stack+110600,int_stack+110060, 0.0, zero_stack, 1.0, int_stack+114645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+271375,int_stack+311875,int_stack+313495, 0.0, zero_stack, 1.0, int_stack+324430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+81090,int_stack+271375,int_stack+198700, 0.0, zero_stack, 1.0, int_stack+325690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+84240,int_stack+81090,int_stack+269125, 0.0, zero_stack, 1.0, int_stack+327580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+111425,int_stack+111275, 1.0, int_stack+183475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+111635,int_stack+111425, 1.0, int_stack+183625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+76815,int_stack+374455,int_stack+194625, 1.0, int_stack+5940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+269125,int_stack+111915,int_stack+111635, 1.0, int_stack+183835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+269965,int_stack+269125,int_stack+374455, 1.0, int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+271225,int_stack+269965,int_stack+76815, 1.0, int_stack+214990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+214360,int_stack+112275,int_stack+111915, 1.0, int_stack+184115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+81090,int_stack+214360,int_stack+269125, 1.0, int_stack+215890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+214360,int_stack+81090,int_stack+269965, 1.0, int_stack+216730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+81090,int_stack+214360,int_stack+271225, 1.0, int_stack+217990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+214360,int_stack+113490,int_stack+112950, 1.0, int_stack+112725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+215035,int_stack+114225,int_stack+113490, 1.0, int_stack+113175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+308275,int_stack+215035,int_stack+214360, 1.0, int_stack+322810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+215980,int_stack+115185,int_stack+114225, 1.0, int_stack+113805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+215980,int_stack+215035, 1.0, int_stack+323485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+217240,int_stack+198700,int_stack+308275, 1.0, int_stack+202840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+322810,int_stack+115725,int_stack+115185, 1.0, int_stack+114645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+219490,int_stack+322810,int_stack+215980, 1.0, int_stack+324430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+222010,int_stack+219490,int_stack+198700, 1.0, int_stack+325690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+322810,int_stack+222010,int_stack+217240, 1.0, int_stack+327580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+116550,int_stack+116400,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+116760,int_stack+116550,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+194625,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+198700,int_stack+117040,int_stack+116760,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+326185,int_stack+198700,int_stack+374455,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+327445,int_stack+326185,int_stack+83340,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+202840,int_stack+117400,int_stack+117040,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+214360,int_stack+202840,int_stack+198700,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+216040,int_stack+214360,int_stack+326185,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+218140,int_stack+216040,int_stack+327445,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+326185,int_stack+118075,int_stack+117850,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+326860,int_stack+118390,int_stack+118075,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+326860,int_stack+326185,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+327805,int_stack+118810,int_stack+118390,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+327805,int_stack+326860,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+214360,int_stack+198700,int_stack+202840,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+326185,int_stack+119350,int_stack+118810,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+220390,int_stack+326185,int_stack+327805,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+326185,int_stack+220390,int_stack+198700,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+220390,int_stack+326185,int_stack+214360,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+120175,int_stack+120025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188550,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+120385,int_stack+120175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188700,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184475,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+214360,int_stack+120665,int_stack+120385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188910,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+215200,int_stack+214360,int_stack+374455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333205,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+216460,int_stack+215200,int_stack+83340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333835,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+326185,int_stack+121025,int_stack+120665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189190,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+327265,int_stack+326185,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334735,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+223765,int_stack+327265,int_stack+215200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335575,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+326185,int_stack+223765,int_stack+216460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3375,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+223765,int_stack+121700,int_stack+121475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+139600,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+224440,int_stack+122015,int_stack+121700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140050,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+224440,int_stack+223765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339085,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+225385,int_stack+122435,int_stack+122015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140680,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+225385,int_stack+224440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339760,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+214360,int_stack+198700,int_stack+202840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340705,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+223765,int_stack+122975,int_stack+122435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141520,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+269125,int_stack+223765,int_stack+225385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342055,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+223765,int_stack+269125,int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343315,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+269125,int_stack+223765,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345205,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+123800,int_stack+123650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188550, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+124010,int_stack+123800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188700, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184475, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+214360,int_stack+124290,int_stack+124010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188910, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+215200,int_stack+214360,int_stack+374455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333205, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+216460,int_stack+215200,int_stack+83340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333835, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+223765,int_stack+124650,int_stack+124290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189190, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+224845,int_stack+223765,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334735, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+226525,int_stack+224845,int_stack+215200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335575, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+223765,int_stack+226525,int_stack+216460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3375, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+214360,int_stack+125325,int_stack+125100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+139600, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+215035,int_stack+125640,int_stack+125325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140050, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+215035,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339085, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+215980,int_stack+126060,int_stack+125640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140680, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+215980,int_stack+215035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339760, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+226015,int_stack+198700,int_stack+202840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340705, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+214360,int_stack+126600,int_stack+126060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141520, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+311875,int_stack+214360,int_stack+215980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342055, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+214360,int_stack+311875,int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343315, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+87615,int_stack+214360,int_stack+226015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345205, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+127425,int_stack+127275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188550, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+127635,int_stack+127425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188700, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184475, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+226015,int_stack+127915,int_stack+127635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188910, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+226855,int_stack+226015,int_stack+374455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333205, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+214360,int_stack+226855,int_stack+83340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333835, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+215860,int_stack+128275,int_stack+127915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189190, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+198700,int_stack+215860,int_stack+226015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334735, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+215860,int_stack+198700,int_stack+226855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335575, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+226015,int_stack+215860,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3375, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+214360,int_stack+128950,int_stack+128725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+139600, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+215035,int_stack+129265,int_stack+128950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140050, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+215035,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339085, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+215980,int_stack+129685,int_stack+129265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140680, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+215980,int_stack+215035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339760, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+311875,int_stack+198700,int_stack+202840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340705, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+214360,int_stack+130225,int_stack+129685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141520, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+90990,int_stack+214360,int_stack+215980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342055, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+214360,int_stack+90990,int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343315, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+90990,int_stack+214360,int_stack+311875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345205, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+131050,int_stack+130900, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+131260,int_stack+131050, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+311875,int_stack+131540,int_stack+131260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+312715,int_stack+311875,int_stack+374455, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+214360,int_stack+312715,int_stack+83340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+215860,int_stack+131900,int_stack+131540, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+198700,int_stack+215860,int_stack+311875, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+215860,int_stack+198700,int_stack+312715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+311875,int_stack+215860,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+214360,int_stack+132575,int_stack+132350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+139600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+215035,int_stack+132890,int_stack+132575, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+215035,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+215980,int_stack+133310,int_stack+132890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+215980,int_stack+215035, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+94365,int_stack+198700,int_stack+202840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+214360,int_stack+133850,int_stack+133310, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+96615,int_stack+214360,int_stack+215980, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+214360,int_stack+96615,int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+96615,int_stack+214360,int_stack+94365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+134675,int_stack+134525, 0.0, zero_stack, 1.0, int_stack+188550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+134885,int_stack+134675, 0.0, zero_stack, 1.0, int_stack+188700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+194625, 0.0, zero_stack, 1.0, int_stack+184475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+94365,int_stack+135165,int_stack+134885, 0.0, zero_stack, 1.0, int_stack+188910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+95205,int_stack+94365,int_stack+374455, 0.0, zero_stack, 1.0, int_stack+333205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+214360,int_stack+95205,int_stack+83340, 0.0, zero_stack, 1.0, int_stack+333835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+215860,int_stack+135525,int_stack+135165, 0.0, zero_stack, 1.0, int_stack+189190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+198700,int_stack+215860,int_stack+94365, 0.0, zero_stack, 1.0, int_stack+334735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+215860,int_stack+198700,int_stack+95205, 0.0, zero_stack, 1.0, int_stack+335575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+94365,int_stack+215860,int_stack+214360, 0.0, zero_stack, 1.0, int_stack+3375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+214360,int_stack+136200,int_stack+135975, 0.0, zero_stack, 1.0, int_stack+139600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+215035,int_stack+136515,int_stack+136200, 0.0, zero_stack, 1.0, int_stack+140050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+215035,int_stack+214360, 0.0, zero_stack, 1.0, int_stack+339085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+215980,int_stack+136935,int_stack+136515, 0.0, zero_stack, 1.0, int_stack+140680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+215980,int_stack+215035, 0.0, zero_stack, 1.0, int_stack+339760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+99990,int_stack+198700,int_stack+202840, 0.0, zero_stack, 1.0, int_stack+340705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+214360,int_stack+137475,int_stack+136935, 0.0, zero_stack, 1.0, int_stack+141520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+102240,int_stack+214360,int_stack+215980, 0.0, zero_stack, 1.0, int_stack+342055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+214360,int_stack+102240,int_stack+198700, 0.0, zero_stack, 1.0, int_stack+343315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+102240,int_stack+214360,int_stack+99990, 0.0, zero_stack, 1.0, int_stack+345205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+138300,int_stack+138150, 1.0, int_stack+188550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+138510,int_stack+138300, 1.0, int_stack+188700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+194625, 1.0, int_stack+184475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+99990,int_stack+138790,int_stack+138510, 1.0, int_stack+188910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+100830,int_stack+99990,int_stack+374455, 1.0, int_stack+333205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+214360,int_stack+100830,int_stack+83340, 1.0, int_stack+333835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+333205,int_stack+139150,int_stack+138790, 1.0, int_stack+189190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+215860,int_stack+333205,int_stack+99990, 1.0, int_stack+334735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+333205,int_stack+215860,int_stack+100830, 1.0, int_stack+335575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+99990,int_stack+333205,int_stack+214360, 1.0, int_stack+3375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3375,int_stack+140365,int_stack+139825, 1.0, int_stack+139600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4050,int_stack+141100,int_stack+140365, 1.0, int_stack+140050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+4050,int_stack+3375, 1.0, int_stack+339085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4995,int_stack+142060,int_stack+141100, 1.0, int_stack+140680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+4995,int_stack+4050, 1.0, int_stack+339760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+214360,int_stack+198700,int_stack+202840, 1.0, int_stack+340705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3375,int_stack+142600,int_stack+142060, 1.0, int_stack+141520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+339085,int_stack+3375,int_stack+4995, 1.0, int_stack+342055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+333205,int_stack+339085,int_stack+198700, 1.0, int_stack+343315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+339085,int_stack+333205,int_stack+214360, 1.0, int_stack+345205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+143425,int_stack+143275,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+143635,int_stack+143425,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+194625,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+214360,int_stack+143915,int_stack+143635,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+215200,int_stack+214360,int_stack+374455,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+216460,int_stack+215200,int_stack+83340,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+333205,int_stack+144275,int_stack+143915,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+334285,int_stack+333205,int_stack+214360,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+342460,int_stack+334285,int_stack+215200,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+333205,int_stack+342460,int_stack+216460,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+342460,int_stack+144950,int_stack+144725,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+343135,int_stack+145265,int_stack+144950,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+343135,int_stack+342460,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+344080,int_stack+145685,int_stack+145265,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+344080,int_stack+343135,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+214360,int_stack+198700,int_stack+202840,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+342460,int_stack+146225,int_stack+145685,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3375,int_stack+342460,int_stack+344080,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+342460,int_stack+3375,int_stack+198700,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+105615,int_stack+342460,int_stack+214360,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+147050,int_stack+146900,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+147260,int_stack+147050,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+194625,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+214360,int_stack+147540,int_stack+147260,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+215200,int_stack+214360,int_stack+374455,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+216460,int_stack+215200,int_stack+83340,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+342460,int_stack+147900,int_stack+147540,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+343540,int_stack+342460,int_stack+214360,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+345220,int_stack+343540,int_stack+215200,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+342460,int_stack+345220,int_stack+216460,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+214360,int_stack+148575,int_stack+148350,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+215035,int_stack+148890,int_stack+148575,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+215035,int_stack+214360,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+215980,int_stack+149310,int_stack+148890,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+215980,int_stack+215035,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+344710,int_stack+198700,int_stack+202840,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+214360,int_stack+149850,int_stack+149310,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3375,int_stack+214360,int_stack+215980,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+214360,int_stack+3375,int_stack+198700,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+108990,int_stack+214360,int_stack+344710,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+152125,int_stack+151975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193625,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+152335,int_stack+152125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193775,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189550,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+344710,int_stack+152615,int_stack+152335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193985,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+345550,int_stack+344710,int_stack+374455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+350830,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+214360,int_stack+345550,int_stack+83340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351460,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+215860,int_stack+152975,int_stack+152615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194265,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+198700,int_stack+215860,int_stack+344710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352360,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+215860,int_stack+198700,int_stack+345550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353200,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+344710,int_stack+215860,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354460,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+214360,int_stack+153650,int_stack+153425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179800,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+215035,int_stack+153965,int_stack+153650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180250,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+215035,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358210,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+215980,int_stack+154385,int_stack+153965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180880,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+215980,int_stack+215035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358885,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+3375,int_stack+198700,int_stack+202840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359830,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+214360,int_stack+154925,int_stack+154385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181720,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+112365,int_stack+214360,int_stack+215980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361180,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+214360,int_stack+112365,int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362440,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+112365,int_stack+214360,int_stack+3375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364330,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+157200,int_stack+157050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193625, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+157410,int_stack+157200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193775, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189550, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3375,int_stack+157690,int_stack+157410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193985, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4215,int_stack+3375,int_stack+374455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+350830, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+214360,int_stack+4215,int_stack+83340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351460, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+215860,int_stack+158050,int_stack+157690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194265, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+198700,int_stack+215860,int_stack+3375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352360, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+215860,int_stack+198700,int_stack+4215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353200, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+3375,int_stack+215860,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354460, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+214360,int_stack+158725,int_stack+158500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179800, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+215035,int_stack+159040,int_stack+158725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180250, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+215035,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358210, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+215980,int_stack+159460,int_stack+159040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180880, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+215980,int_stack+215035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358885, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+115740,int_stack+198700,int_stack+202840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359830, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+214360,int_stack+160000,int_stack+159460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181720, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+117990,int_stack+214360,int_stack+215980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361180, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+214360,int_stack+117990,int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362440, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+117990,int_stack+214360,int_stack+115740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364330, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+162275,int_stack+162125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193625, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+162485,int_stack+162275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193775, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189550, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+115740,int_stack+162765,int_stack+162485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193985, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+116580,int_stack+115740,int_stack+374455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+350830, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+214360,int_stack+116580,int_stack+83340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351460, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+215860,int_stack+163125,int_stack+162765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194265, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+198700,int_stack+215860,int_stack+115740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352360, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+215860,int_stack+198700,int_stack+116580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353200, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+115740,int_stack+215860,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354460, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+214360,int_stack+163800,int_stack+163575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179800, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+215035,int_stack+164115,int_stack+163800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180250, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+215035,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358210, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+215980,int_stack+164535,int_stack+164115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180880, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+215980,int_stack+215035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358885, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+121365,int_stack+198700,int_stack+202840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359830, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+214360,int_stack+165075,int_stack+164535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181720, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+123615,int_stack+214360,int_stack+215980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361180, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+214360,int_stack+123615,int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362440, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+123615,int_stack+214360,int_stack+121365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364330, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+167350,int_stack+167200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+167560,int_stack+167350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+194625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+121365,int_stack+167840,int_stack+167560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+122205,int_stack+121365,int_stack+374455, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+350830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+214360,int_stack+122205,int_stack+83340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+215860,int_stack+168200,int_stack+167840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+198700,int_stack+215860,int_stack+121365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+215860,int_stack+198700,int_stack+122205, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+121365,int_stack+215860,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+214360,int_stack+168875,int_stack+168650, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+215035,int_stack+169190,int_stack+168875, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+215035,int_stack+214360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+215980,int_stack+169610,int_stack+169190, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+215980,int_stack+215035, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+126990,int_stack+198700,int_stack+202840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+214360,int_stack+170150,int_stack+169610, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+129240,int_stack+214360,int_stack+215980, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+214360,int_stack+129240,int_stack+198700, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+129240,int_stack+214360,int_stack+126990, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+172425,int_stack+172275, 0.0, zero_stack, 1.0, int_stack+193625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+172635,int_stack+172425, 0.0, zero_stack, 1.0, int_stack+193775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+194625, 0.0, zero_stack, 1.0, int_stack+189550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+126990,int_stack+172915,int_stack+172635, 0.0, zero_stack, 1.0, int_stack+193985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+127830,int_stack+126990,int_stack+374455, 0.0, zero_stack, 1.0, int_stack+350830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+214360,int_stack+127830,int_stack+83340, 0.0, zero_stack, 1.0, int_stack+351460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+215860,int_stack+173275,int_stack+172915, 0.0, zero_stack, 1.0, int_stack+194265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+198700,int_stack+215860,int_stack+126990, 0.0, zero_stack, 1.0, int_stack+352360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+215860,int_stack+198700,int_stack+127830, 0.0, zero_stack, 1.0, int_stack+353200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+126990,int_stack+215860,int_stack+214360, 0.0, zero_stack, 1.0, int_stack+354460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+214360,int_stack+173950,int_stack+173725, 0.0, zero_stack, 1.0, int_stack+179800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+215035,int_stack+174265,int_stack+173950, 0.0, zero_stack, 1.0, int_stack+180250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+215035,int_stack+214360, 0.0, zero_stack, 1.0, int_stack+358210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+215980,int_stack+174685,int_stack+174265, 0.0, zero_stack, 1.0, int_stack+180880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+215980,int_stack+215035, 0.0, zero_stack, 1.0, int_stack+358885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+132615,int_stack+198700,int_stack+202840, 0.0, zero_stack, 1.0, int_stack+359830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+214360,int_stack+175225,int_stack+174685, 0.0, zero_stack, 1.0, int_stack+181720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+134865,int_stack+214360,int_stack+215980, 0.0, zero_stack, 1.0, int_stack+361180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+214360,int_stack+134865,int_stack+198700, 0.0, zero_stack, 1.0, int_stack+362440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+134865,int_stack+214360,int_stack+132615, 0.0, zero_stack, 1.0, int_stack+364330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194625,int_stack+178500,int_stack+178350, 1.0, int_stack+193625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+178710,int_stack+178500, 1.0, int_stack+193775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+194625, 1.0, int_stack+189550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+132615,int_stack+178990,int_stack+178710, 1.0, int_stack+193985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+133455,int_stack+132615,int_stack+374455, 1.0, int_stack+350830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+214360,int_stack+133455,int_stack+83340, 1.0, int_stack+351460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+350830,int_stack+179350,int_stack+178990, 1.0, int_stack+194265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+215860,int_stack+350830,int_stack+132615, 1.0, int_stack+352360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+350830,int_stack+215860,int_stack+133455, 1.0, int_stack+353200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+132615,int_stack+350830,int_stack+214360, 1.0, int_stack+354460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+214360,int_stack+180565,int_stack+180025, 1.0, int_stack+179800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+215035,int_stack+181300,int_stack+180565, 1.0, int_stack+180250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+215035,int_stack+214360, 1.0, int_stack+358210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+215980,int_stack+182260,int_stack+181300, 1.0, int_stack+180880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+215980,int_stack+215035, 1.0, int_stack+358885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+350830,int_stack+198700,int_stack+202840, 1.0, int_stack+359830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+214360,int_stack+182800,int_stack+182260, 1.0, int_stack+181720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+358210,int_stack+214360,int_stack+215980, 1.0, int_stack+361180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+214360,int_stack+358210,int_stack+198700, 1.0, int_stack+362440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+358210,int_stack+214360,int_stack+350830, 1.0, int_stack+364330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+350830,int_stack+185075,int_stack+184925,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+185285,int_stack+185075,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+350830,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+350830,int_stack+185565,int_stack+185285,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+351670,int_stack+350830,int_stack+374455,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+352930,int_stack+351670,int_stack+83340,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+354430,int_stack+185925,int_stack+185565,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+214360,int_stack+354430,int_stack+350830,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+216040,int_stack+214360,int_stack+351670,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+361585,int_stack+216040,int_stack+352930,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+214360,int_stack+186600,int_stack+186375,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+215035,int_stack+186915,int_stack+186600,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+215035,int_stack+214360,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+215980,int_stack+187335,int_stack+186915,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+215980,int_stack+215035,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+350830,int_stack+198700,int_stack+202840,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+214360,int_stack+187875,int_stack+187335,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+353080,int_stack+214360,int_stack+215980,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+214360,int_stack+353080,int_stack+198700,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+138240,int_stack+214360,int_stack+350830,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+350830,int_stack+190150,int_stack+190000,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+190360,int_stack+190150,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+350830,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+350830,int_stack+190640,int_stack+190360,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+351670,int_stack+350830,int_stack+374455,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+352930,int_stack+351670,int_stack+83340,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+354430,int_stack+191000,int_stack+190640,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+214360,int_stack+354430,int_stack+350830,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+216040,int_stack+214360,int_stack+351670,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+363835,int_stack+216040,int_stack+352930,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+214360,int_stack+191675,int_stack+191450,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+215035,int_stack+191990,int_stack+191675,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+215035,int_stack+214360,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+215980,int_stack+192410,int_stack+191990,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+215980,int_stack+215035,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+350830,int_stack+198700,int_stack+202840,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+214360,int_stack+192950,int_stack+192410,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+353080,int_stack+214360,int_stack+215980,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+214360,int_stack+353080,int_stack+198700,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+141615,int_stack+214360,int_stack+350830,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+350830,int_stack+195225,int_stack+195075,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+374455,int_stack+195435,int_stack+195225,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+83340,int_stack+374455,int_stack+350830,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+350830,int_stack+195715,int_stack+195435,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+351670,int_stack+350830,int_stack+374455,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+352930,int_stack+351670,int_stack+83340,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+354430,int_stack+196075,int_stack+195715,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+214360,int_stack+354430,int_stack+350830,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+216040,int_stack+214360,int_stack+351670,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+144990,int_stack+216040,int_stack+352930,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+214360,int_stack+196750,int_stack+196525,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+215035,int_stack+197065,int_stack+196750,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+202840,int_stack+215035,int_stack+214360,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+215980,int_stack+197485,int_stack+197065,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+198700,int_stack+215980,int_stack+215035,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+350830,int_stack+198700,int_stack+202840,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+214360,int_stack+198025,int_stack+197485,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+353080,int_stack+214360,int_stack+215980,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+214360,int_stack+353080,int_stack+198700,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+147240,int_stack+214360,int_stack+350830,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+150615,int_stack+228850,int_stack+209860,225);
     Libderiv->ABCD[11] = int_stack + 150615;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+157365,int_stack+247300,int_stack+237355,225);
     Libderiv->ABCD[10] = int_stack + 157365;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+164115,int_stack+265750,int_stack+255805,225);
     Libderiv->ABCD[9] = int_stack + 164115;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+170865,int_stack+284200,int_stack+274255,225);
     Libderiv->ABCD[8] = int_stack + 170865;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+177615,int_stack+302650,int_stack+292705,225);
     Libderiv->ABCD[7] = int_stack + 177615;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+184365,int_stack+319435,int_stack+314935,225);
     Libderiv->ABCD[6] = int_stack + 184365;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+191115,int_stack+329830,int_stack+200590, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[2] = int_stack + 191115;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+228265,int_stack+347455,int_stack+336835, 0.0, zero_stack, 1.0, int_stack+212110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[1] = int_stack + 228265;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+346960,int_stack+366580,int_stack+355960, 1.0, int_stack+212110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[0] = int_stack + 346960;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+239605,int_stack+6390,int_stack+375085,225);
     Libderiv->ABCD[155] = int_stack + 239605;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+407485,int_stack+380485,int_stack+369955,225);
     Libderiv->ABCD[143] = int_stack + 407485;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+414235,int_stack+12915,int_stack+377335,225);
     Libderiv->ABCD[142] = int_stack + 414235;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+374455,int_stack+16290,int_stack+383860,225);
     Libderiv->ABCD[131] = int_stack + 374455;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+12015,int_stack+19665,int_stack+386110,225);
     Libderiv->ABCD[130] = int_stack + 12015;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+381205,int_stack+23040,int_stack+388360,225);
     Libderiv->ABCD[129] = int_stack + 381205;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+18765,int_stack+26415,int_stack+372205,225);
     Libderiv->ABCD[119] = int_stack + 18765;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+366085,int_stack+29790,int_stack+390610,225);
     Libderiv->ABCD[118] = int_stack + 366085;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+25515,int_stack+33165,int_stack+392860,225);
     Libderiv->ABCD[117] = int_stack + 25515;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+387955,int_stack+397360,int_stack+395110,225);
     Libderiv->ABCD[116] = int_stack + 387955;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+420985,int_stack+400735,int_stack+9765,225);
     Libderiv->ABCD[107] = int_stack + 420985;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+394705,int_stack+404110,int_stack+40140,225);
     Libderiv->ABCD[106] = int_stack + 394705;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+427735,int_stack+50040,int_stack+42390,225);
     Libderiv->ABCD[105] = int_stack + 427735;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+434485,int_stack+36540,int_stack+44640,225);
     Libderiv->ABCD[104] = int_stack + 434485;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+32265,int_stack+56565,int_stack+46890,225);
     Libderiv->ABCD[103] = int_stack + 32265;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+39015,int_stack+62190,int_stack+59940,225);
     Libderiv->ABCD[95] = int_stack + 39015;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+55665,int_stack+65565,int_stack+204190,225);
     Libderiv->ABCD[94] = int_stack + 55665;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+202840,int_stack+71190,int_stack+68940,225);
     Libderiv->ABCD[93] = int_stack + 202840;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+62415,int_stack+250675,int_stack+261655,225);
     Libderiv->ABCD[92] = int_stack + 62415;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+261430,int_stack+258055,int_stack+53415,225);
     Libderiv->ABCD[91] = int_stack + 261430;
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+246355,int_stack+0,int_stack+294955,225);
     Libderiv->ABCD[90] = int_stack + 246355;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+45765,int_stack+297205,int_stack+317185, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[47] = int_stack + 45765;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+294955,int_stack+287575,int_stack+309625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+237355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[46] = int_stack + 294955;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+283030,int_stack+279655,int_stack+306025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[45] = int_stack + 283030;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+301705,int_stack+77715,int_stack+276505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[44] = int_stack + 301705;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+441235,int_stack+84240,int_stack+74565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+292705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[43] = int_stack + 441235;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+69165,int_stack+322810,int_stack+81090, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[42] = int_stack + 69165;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+317185,int_stack+220390,int_stack+218140, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+200590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[38] = int_stack + 317185;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+212110,int_stack+269125,int_stack+326185, 0.0, zero_stack, 1.0, int_stack+209860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[35] = int_stack + 212110;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+323935,int_stack+87615,int_stack+223765, 0.0, zero_stack, 1.0, int_stack+237355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[34] = int_stack + 323935;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+218860,int_stack+90990,int_stack+226015, 0.0, zero_stack, 1.0, int_stack+255805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[33] = int_stack + 218860;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+75915,int_stack+96615,int_stack+311875, 0.0, zero_stack, 1.0, int_stack+274255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[32] = int_stack + 75915;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+82665,int_stack+102240,int_stack+94365, 0.0, zero_stack, 1.0, int_stack+292705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[31] = int_stack + 82665;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+89415,int_stack+339085,int_stack+99990, 0.0, zero_stack, 1.0, int_stack+314935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[30] = int_stack + 89415;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+96165,int_stack+105615,int_stack+333205, 0.0, zero_stack, 1.0, int_stack+200590, 1.0, int_stack+336835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[26] = int_stack + 96165;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+447985,int_stack+108990,int_stack+342460, 0.0, zero_stack, 2.0, int_stack+336835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[25] = int_stack + 447985;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+102915,int_stack+112365,int_stack+344710, 1.0, int_stack+209860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[23] = int_stack + 102915;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+339085,int_stack+117990,int_stack+3375, 1.0, int_stack+237355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[22] = int_stack + 339085;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+0,int_stack+123615,int_stack+115740, 1.0, int_stack+255805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[21] = int_stack + 0;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+109665,int_stack+129240,int_stack+121365, 1.0, int_stack+274255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[20] = int_stack + 109665;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+116415,int_stack+134865,int_stack+126990, 1.0, int_stack+292705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[19] = int_stack + 116415;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+123165,int_stack+358210,int_stack+132615, 1.0, int_stack+314935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[18] = int_stack + 123165;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+308455,int_stack+138240,int_stack+361585, 1.0, int_stack+200590, 0.0, zero_stack, 1.0, int_stack+355960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[14] = int_stack + 308455;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+129915,int_stack+141615,int_stack+363835, 1.0, int_stack+336835, 1.0, int_stack+355960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[13] = int_stack + 129915;
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+358210,int_stack+147240,int_stack+144990, 2.0, int_stack+355960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[12] = int_stack + 358210;

}
